*********************************************************************
* croutons.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: croutons.i,v 2.0 92/05/18 21:20:41 Hartford Exp $
*
* $Log:	croutons.i,v $
*Revision 2.0  92/05/18  21:20:41  Hartford
**** empty log message ***
*
*********************************************************************
	IFND	CROUTONS_I
CROUTONS_I	SET	1

***********************************************************************
* Constants used by effects croutons.
* 
* By SKell, NewTek  Aug 1990
***********************************************************************

DIGOFFSET	SET -3
DIGOFFSETDTW	SET 1

ZERO		SET 0	;will always be 0

QUADSWIDE	SET 184
PIXELSWIDE	SET (QUADSWIDE<<2)

MAXLIMIT 	SET $7fffffff	;used by generation equations
IGNORE		SET -1		;used by overscanColor, etc.

HORSAFETY	SET	0	;3 quads SAFETY margine from TEK ??
VERTSAFETY	SET	0	;2 field lines margine from TEK ??

***** STANDARD TDE ************************************************************

*----- TDE HORIZONTAL SOURCE constants for non-trail TDE rectangle 
* Use these if the rectangle has no border, includes zipper
SXMIN		SET (5+HORSAFETY)
SXMAX		SET (189-HORSAFETY)
SXAXIS		SET ((SXMAX+SXMIN)>>1)
SXSIZE		SET (SXMAX+1-SXMIN)

* Use these if the rectangle has a border
SXMINBORDER	SET SXMIN	;no diff
SXMAXBORDER	SET 182	;borders don't extend all the way across (0-732).
SXAXISBORDER 	SET ((SXMAXBORDER+SXMINBORDER)>>1)
SXSIZEBORDER	SET (SXMAXBORDER+1-SXMINBORDER)

* Use these if the rectangle has a zipper
SXMINZIPPER	SET SXMIN	;no diff
SXMAXZIPPER	SET 185		;186-189.5 = ZIPPER
SXAXISZIPPER 	SET ((SXMAXZIPPER+SXMINZIPPER)>>1)
SXSIZEZIPPER	SET (SXMAXZIPPER+1-SXMINZIPPER)

* Use these if the rectangle is in PAIR units
SXMINPAIR	SET SXMIN
SXMAXPAIR	SET SXMAX
SXAXISPAIR 	SET ((SXMAXPAIR+SXMINPAIR)>>1)
SXSIZEPAIR	SET (SXMAXPAIR+1-SXMINPAIR)

* Use these if the rectangle is in PAIR units, with border
SXMINPAIRBORD	SET SXMINBORDER
SXMAXPAIRBORD	SET SXMAXBORDER
SXAXISPAIRBORD 	SET ((SXMAXPAIRBORD+SXMINPAIRBORD)>>1)
SXSIZEPAIRBORD	SET (SXMAXPAIRBORD+1-SXMINPAIRBORD)

*----- TDE HORIZONTAL DESTINATION constants for non-trail TDE rectangle 
* Use these if the rectangle has no border, includes zipper
DXMIN		SET ZERO
DXMAX		SET (QUADSWIDE-1)
DXAXISMIN	SET (SXMIN+DIGOFFSET)	;left most axis
DXAXIS		SET (SXAXIS+DIGOFFSET)	;axis in center of display
DXAXISMAX	SET (SXMAX+DIGOFFSET)	;right most axis
DXSIZE		SET (DXMAX+1-DXMIN)
DXSHALF		SET (DXSIZE>>1)		;one half the screen size

* Use these if the rectangle has a border
DXMINBORDER	SET DXMIN	;no diff
DXMAXBORDER	SET DXMAX	;no diff
DXAXISMINBORDER	SET (SXMINBORDER+DIGOFFSET)	;left most axis
DXAXISBORDER	SET (SXAXISBORDER+DIGOFFSET)	;axis in center of display
DXAXISMAXBORDER	SET (SXMAXBORDER+DIGOFFSET)	;right most axis
DXSIZEBORDER	SET (DXMAXBORDER+1-DXMINBORDER)
DXSHALFBORDER	SET (DXSIZEBORDER>>1)		;one half the screen size

* Use these if the rectangle has a zipper
DXMINZIPPER	SET DXMIN	;no diff
DXMAXZIPPER	SET DXMAX	;no diff
DXAXISMINZIPPER	SET (SXMINZIPPER+DIGOFFSET)	;left most axis
DXAXISZIPPER	SET (SXAXISZIPPER+DIGOFFSET)	;axis in center of display
DXAXISMAXZIPPER	SET (SXMAXZIPPER+DIGOFFSET)	;right most axis
DXSIZEZIPPER	SET (DXMAXZIPPER+1-DXMINZIPPER)
DXSHALFZIPPER	SET (DXSIZEZIPPER>>1)		;one half the screen size

* Use these if the rectangle is in PAIR units
DXMINPAIR	SET (((DXMIN*2)+3)&~3)	;round up to nearest oct
DXMAXPAIR	SET ((DXMAX*2)&~3)	;round down to nearest oct
DXAXISMINPAIR	SET ((SXMINPAIR+DIGOFFSET)*2)	;left most axis
DXAXISPAIR	SET ((SXAXISPAIR+DIGOFFSET)*2)	;axis in center of display
DXAXISMAXPAIR	SET ((SXMAXPAIR+DIGOFFSET)*2)	;right most axis
DXSIZEPAIR	SET (DXMAXPAIR+1-DXMINPAIR)
DXSHALFPAIR	SET (DXSIZEPAIR>>1)		;one half the screen size

* Use these if the rectangle is in PAIR units, with border
DXMINPAIRBORD		SET (((DXMINBORDER*2)+3)&~3)	;round up to nearest oct
DXMAXPAIRBORD		SET ((DXMAXBORDER*2)&~3)	;round down to nearest oct
DXAXISMINPAIRBORD	SET ((SXMINPAIRBORD+DIGOFFSET)*2)	;left most axis
DXAXISPAIRBORD		SET ((SXAXISPAIRBORD+DIGOFFSET)*2)	;axis in center of display
DXAXISMAXPAIRBORD	SET ((SXMAXPAIRBORD+DIGOFFSET)*2)	;right most axis
DXSIZEPAIRBORD		SET (DXMAXPAIRBORD+1-DXMINPAIRBORD)
DXSHALFPAIRBORD		SET (DXSIZEPAIRBORD>>1)		;one half the screen size

*-----------------------
* Good amounts to move TDE rectangle on/off screen. 12*16 = 6*32 = 3*64 = 192
DXMOVE		SET 192
DXMHALF 	SET (DXMOVE>>1)		;one half the screen size
DXMOVEBORDER	SET DXMOVE		;no diff
DXMHALFBORDER	SET (DXMOVEBORDER>>1)	;one half the screen size
DXMOVEZIPPER	SET DXMOVE		;no diff
DXMHALFZIPPER	SET (DXMOVEZIPPER>>1)	;one half the screen size

DXMOVEPAIR	SET (DXMOVE*2)
DXMHALFPAIR	SET (DXMOVEPAIR>>1)	;one half the screen size
DXMOVEPAIRBORD	SET DXMOVEPAIR		;no diff
DXMHALFPAIRBORD	SET (DXMOVEPAIRBORD>>1)	;one half the screen size

*----------------------------------------------------------------
*----- TDE VERTICAL SOURCE constants for non-trail TDE rectangle
SYMIN		SET (2+VERTSAFETY)	;could useually be 1+
SYMAX		SET (238-VERTSAFETY)	;technically should be 239 !!!
SYAXIS		SET ((SYMAX+SYMIN)>>1)
SYSIZE		SET (SYMAX+1-SYMIN)

*----- TDE VERTICAL DESTINATION constants non-trail TDE rectangle 
DYMIN		SET 1		;avoid 1/2 scan line at top
DYMAX		SET 240		;will only use 240 on field II
DYAXISMIN 	SET SYMIN
DYAXIS		SET SYAXIS
DYAXISMAX	SET SYMAX
DYSIZE		SET (DYMAX+1-DYMIN)
DYSHALF		SET (DYSIZE>>1)

* Good amounts to move TDE rectangle on/off screen. 16*16 = 8*32 = 4*64 = 256
DYMOVE		SET 256
DYMHALF 	SET (DYMOVE>>1)

***** DIGITAL TRAILS ON WRITE TDE ************************************************************
* The source MIN/MAX actually define the limits where the video can be 
* recorded, which is assumed to be the same as the coordinates as for a
* standard TDE source.
* The destination MIN/MAX, as always, are related to the Amiga screen.
* For Trails On Writing, you typically want to use the full screen.
* 
*----- TDE HORIZONTAL SOURCE constants for digital trail TDE rectangle 
SXMINDTW	SET (5+HORSAFETY)
SXMAXDTW	SET (189-HORSAFETY)
SXAXISDTW	SET ((SXMAXDTW+SXMINDTW)>>1)
SXSIZEDTW	SET (SXMAXDTW+1-SXMINDTW)

*----- TDE HORIZONTAL DESTINATION constants for digital trail TDE rectangle 
DXMINDTW	SET ZERO
DXMAXDTW	SET (QUADSWIDE-1)
DXAXISMINDTW	SET (SXMINDTW+DIGOFFSETDTW)	;left most axis
DXAXISDTW	SET (SXAXISDTW+DIGOFFSETDTW)	;axis in center of display
DXAXISMAXDTW	SET (SXMAXDTW+DIGOFFSETDTW)	;right most axis
DXSIZEDTW	SET (DXMAXDTW+1-DXMINDTW)
DXSHALFDTW	SET (DXSIZEDTW>>1)		;one half the screen size

*----- TDE HORIZONTAL SOURCE constants for digital trail TDE rectangle, with zipper 
SXMINDTWZIPPER	SET (5+HORSAFETY)
SXMAXDTWZIPPER	SET (189-HORSAFETY)
SXAXISDTWZIPPER	SET ((SXMAXDTW+SXMINDTW)>>1)
SXSIZEDTWZIPPER	SET (SXMAXDTW+1-SXMINDTW)

*----- TDE HORIZONTAL DESTINATION constants for digital trail TDE rectangle with zipper 
DXMINDTWZIPPER		SET ZERO
DXMAXDTWZIPPER		SET (QUADSWIDE-1)
DXAXISMINDTWZIPPER	SET (SXMINDTWZIPPER+DIGOFFSETDTW)	;left most axis
DXAXISDTWZIPPER		SET (SXAXISDTWZIPPER+DIGOFFSETDTW)	;axis in center of display
DXAXISMAXDTWZIPPER	SET (SXMAXDTWZIPPER+DIGOFFSETDTW)	;right most axis
DXSIZEDTWZIPPER		SET (DXMAXDTWZIPPER+1-DXMINDTW)
DXSHALFDTWZIPPER	SET (DXSIZEDTWZIPPER>>1)		;one half the screen size

* Good amounts to move TDE rectangle on/off screen. 12*16 = 6*32 = 3*64 = 192
DXMOVEDTW	SET 192
DXMHALFDTW	SET (DXMOVEDTW>>1)		;one half the screen size

*----------------------------------------------------------------
*----- TDE VERTICAL SOURCE constants for digital trail TDE rectangle
SYMINDTW	SET (2+VERTSAFETY)	;could usually be 1+
SYMAXDTW	SET (238-VERTSAFETY) ;technically should be 239 !!!
SYAXISDTW	SET ((SYMAXDTW+SYMINDTW)>>1)
SYSIZEDTW	SET (SYMAXDTW+1-SYMINDTW)

*----- TDE VERTICAL DESTINATION constants non-trail TDE rectangle 
DYMINDTW	SET 1		;avoid 1/2 scan line at top
DYMAXDTW	SET 240		;will only use 240 on field II
DYAXISMINDTW 	SET SYMINDTW
DYAXISDTW	SET SYAXISDTW
DYAXISMAXDTW	SET SYMAXDTW
DYSIZEDTW	SET (DYMAXDTW+1-DYMINDTW)
DYSHALFDTW	SET (DYSIZEDTW>>1)

* Good amounts to move TDE rectangle on/off screen. 16*16 = 8*32 = 4*64 = 256
DYMOVEDTW	SET 256
DYMHALFDTW	SET (DYMOVEDTW>>1)

***** WIPES ************************************************************

*----- SOURCE constants for WIPE rectangle
* W1D_srcAxis
WSTART		SET ZERO
WEND		SET ($ffff)
WCENT		SET ($7fff)

*----- HORIZONTAL DESTINATION constants for WIPE rectangle
* W1D_position, W1D_destMin/Max/Axis/effectSize
WXMIN		SET ZERO
WXMAX		SET (PIXELSWIDE-1)
WXAXIS		SET ((WXMAX+WXMIN)>>1)
WXSIZE		SET (WXMAX+1-WXMIN)
WXSHALF		SET (WXSIZE>>1)

* Good amounts to move WIPE rectangle on/off screen. 48*16=24*32=12*64 = 768
WXMOVE		SET 768
WXMHALF 	SET (WXMOVE>>1)

*----- VERTICAL DESTINATION constants for WIPE rectangle
WYMIN		SET ZERO
WYMAX		SET 480
WYAXIS		SET ((WYMAX+WYMIN)>>1)
WYSIZE		SET (WYMAX+1-WYMIN)
WYSHALF		SET (WYSIZE>>1)
	
* Good amounts to move WIPE rectangle on/off screen. 32*16=16*32=8*64 = 512
WYMOVE		SET 512
WYMHALF 	SET (WYMOVE>>1)
	
* W1D_effectColor
KEYLOW		SET 0
KEYHI		SET 1

*****************************************************************
BGKEYQUAF	SET 256		;use Black, White or QUAF
BGCOLORX	SET 255		;QUAF
BGCOLORY 	SET 238 	;Line that contains a QUAF quad

BORDER		SET 252		;border color Y, also use current border X
WHITE		SET 238		;white quad ???

	ENDC  ;CROUTONS_I
