*********************************************************************
* keylogic.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: keylogic.i,v 2.4 93/05/07 22:07:15 Kell Exp $
*
* $Log:	keylogic.i,v $
*Revision 2.4  93/05/07  22:07:15  Kell
**** empty log message ***
*
*Revision 2.3  93/04/07  08:47:36  Kell
*Redesigned the EffectKeysELH structure.
*
*Revision 2.2  92/09/22  20:18:46  Finch
*Added <New Line> at end of file to help HiSoft bug
*
*Revision 2.1  92/09/22  18:08:16  Finch
*Added IFND Labed ENDC to includes
*
*Revision 2.0  92/05/18  21:22:40  Hartford
**** empty log message ***
*
*********************************************************************
	IFND	KEYLOGIC_I
KEYLOGIC_I	SET	1

********************************************************************
* KeyLogic.i  v0.0  rev041190
* Structures & Tables that define switcher Key logic during transitions.
*
* HISTORY          NAME              DESCRIPTION
* ---------    ------------    ----------------------
* 11 Apr 90     Steve Kell	initial v0.0 completed
********************************************************************

	IFND	EXEC_TYPES_I
	include	"exec/types.i"
	ENDC

	IFND	TBarTimeMax
TBarTimeMax	EQU	($ffff)		;Maximum TBar position	
	ENDC

********************************************************************
* This structure is used to point to sets of key or ELH logic depending on
* the state of the switcher as a transition begins.  The structure is also
* to point to key/ELH logic to use during a transition.

	STRUCTURE	KeyFreezeTbl,0
		LONG	KFT_LiveNoKey		;offset from EffectKeysELH start
		LONG	KFT_FrozeNoKey		;offset from EffectKeysELH start
		LONG	KFT_LiveWithKey		;offset from EffectKeysELH start
		LONG	KFT_FrozeWithKey	;offset from EffectKeysELH start
	LABEL KFT_SIZEOF
	
********************************************************************
	STRUCTURE	EffectKeysELH,0
		STRUCT	EKE_KeysTbl,KFT_SIZEOF
		STRUCT	EKE_ELHTbl,KFT_SIZEOF
		LONG	EKE_flags
		WORD	EKE_TBar1	;bottom of stage (if last stage = TValMax)
;;		etc. .......
;;		WORD	EKE_TBarN	;bottom of stage (if last stage = TValMax)
	LABEL	EKE_SIZEOF

;effects logic flags
EKE_LOCKKEY	EQU	(1<<0)	;don't allow key mode to change
EKE_LOCKFREEZE	EQU	(1<<1)	;don't allow freeze/live to change
EKE_NOKEY	EQU	(1<<2)	;force key off
EKE_KEYONBLACK	EQU	(1<<3)	;force key on black
EKE_KEYONWHITE	EQU	(1<<4)	;force key on white
EKE_LIVE	EQU	(1<<5)	;force on live
EKE_FROZE	EQU	(1<<6)	;force on froze
EKE_FROZEFLASH	EQU	(1<<7)	;flash freeze/live button if froze
EKE_LIVEFLASH	EQU	(1<<8)	;flash freeze/live button if live
EKE_LIVEIFANALOGS EQU	(1<<9)  ;force to live DVE if not Digital in use
EKE_LOCKCLIP	EQU	(1<<10) ;don't allow Clip to change

********************************************************************
* This structure defines the routines to use to fix the button logic
* after a transition via a Take (Bottom of TBar), or UnTake (Top of TBar).
* Note: after a Finish the standard Non-transition code will talk to the
* hardware.

	STRUCTURE	FinishTransKeys,0
		BYTE	FTK_OLaySrc	;how to swap rows
		BYTE	FTK_MainSrc
		BYTE	FTK_PrvwSrc
		BYTE	FTK_pad		;pad to long word		

		WORD	FTK_OLayLogic	;logic function (library offset)
		WORD	FTK_MainLogic
		WORD	FTK_PrvwLogic
	LABEL FTK_SIZEOF	

********************************************************************
* This structure defines the routines to use to fix the button logic
* for a given stage of a transition. This stage may be entered by
* down or upward motions of the mouse.

	STRUCTURE	TransStageKeys,0
		BYTE	TSK_OLaySrcDown ;how to swap rows on down transition
		BYTE	TSK_MainSrcDown
		BYTE	TSK_PrvwSrcDown
		BYTE	TSK_OLaySrcUp	;how to swap rows on up transition
		BYTE	TSK_MainSrcUp
		BYTE	TSK_PrvwSrcUp
		
		WORD	TSK_OLayLogic	;logic function for this stage
		WORD	TSK_MainLogic 	;these are library offsets
		WORD	TSK_PrvwLogic
	LABEL TSK_SIZEOF	

********************************************************************
* Standard structure to define the logic for any one stage transition

	STRUCTURE	TransOneStageKeys,0
		STRUCT	TOSK_UnTake,FTK_SIZEOF
		STRUCT	TOSK_Take,FTK_SIZEOF
		STRUCT	TOSK_Stage1,TSK_SIZEOF
	LABEL TOSK_SIZEOF

********************************************************************
* Standard structure to define the logic for any two stage transition
* Use the TTS offsets for a general multistage effect!
	STRUCTURE	TransTwoStageKeys,0
		STRUCT	TTSK_UnTake,FTK_SIZEOF
		STRUCT	TTSK_Take,FTK_SIZEOF
		STRUCT	TTSK_Stage1,TSK_SIZEOF
		STRUCT	TTSK_Stage2,TSK_SIZEOF
	LABEL TTSK_SIZEOF

***************************************************************
		
	STRUCTURE	FinishTransELH,0
;Define what rows the hardware looks at
		BYTE	FTE_AM	
		BYTE	FTE_BM
		BYTE	FTE_PV
		BYTE	FTE_IS
		BYTE	FTE_LK
		BYTE	FTE_CDS	;mask for key type
	LABEL FTE_SIZEOF	

********************************************************************
	STRUCTURE	TransStageELH,0
;Define what rows the hardware looks at
		BYTE	TSE_AM	
		BYTE	TSE_BM
		BYTE	TSE_PV
		BYTE	TSE_IS
		BYTE	TSE_LK
		BYTE	TSE_CDS	;mask for key type
	LABEL TSE_SIZEOF	

********************************************************************
* Standard structure to define the logic for any one stage transition

	STRUCTURE	TransOneStageELH,0
		STRUCT	TOSE_UnTake,FTE_SIZEOF
		STRUCT	TOSE_Take,FTE_SIZEOF
		STRUCT	TOSE_Stage1,TSE_SIZEOF
	LABEL TOSE_SIZEOF

********************************************************************
* Standard structure to define the logic for any two stage transition
* Use the TTS offsets for a general multistage effect!
	STRUCTURE	TransTwoStageELH,0
		STRUCT	TTSE_UnTake,FTE_SIZEOF
		STRUCT	TTSE_Take,FTE_SIZEOF
		STRUCT	TTSE_Stage1,TSE_SIZEOF
		STRUCT	TTSE_Stage2,TSE_SIZEOF
	LABEL TTSE_SIZEOF
		
********************************************************************
; ..Src... 's 
FromOLay 	SET	0
FromMain	SET	1
FromPrvw	SET	2

* (the following equs are only used by ELH stuff, not button ordering)
FromLiveDVE	SET	50  ;use what ever row is live DVE

FromOLayBMainW  SET	51  ;use OLay if keying on black, Main if white
FromOLayWMainB  SET	52  ;use OLay if keying on white, Main if black

	IFD	CRAP
FromDAC0BMainW  SET	53  ;use DAC0 if keying on black, Main if white
FromDAC0WMainB  SET	54  ;use DAC0 if keying on white, Main if black
	ENDC

FromLutHell	SET	60  ;use LutBus if Lut is on, else from Hell
FromLutMonoHell	SET	61  ;LutBus if LUT & color,Mono if Lut & BM, else Hell 

FromDAC0OLay	SET	70  ;use DAC0 if OLay is LutBus, else use OLay
FromDAC0Main	SET	71  ;use DAC0 if Main is LutBus, else use Main
FromDAC0Prvw	SET	72  ;use DAC0 if Prvw is LutBus, else use Prvw

FromVID1	SET	80
FromVID2	SET	81
FromVID3	SET	82
FromVID4	SET	83
FromMAINOUT	SET	84
FromDAC0	SET	85
FromDAC1	SET	86
FromENCODER	SET	87
FromMONO	SET	88
FromEXT		SET	89

FromHell	SET	100	;no row in particular, maybe = blank

CurrentCDS	SET	-1

********************************************************************
********************************************************************
********************************************************************
********************************************************************
*******************************************************************























	ENDC	;	KEYLOGIC_I
