/*
	undelete.c
	UnDelete file recovery utility

	SAS/C V6.58
	November 11, 1998

	PFKP Software
		Bill Evans, Lead Developer
		Robert Wood, Developer
		Lee Stanford, GUI Developer
*/

/***************************************************************************/

#include <ctype.h>
#include <exec/types.h>
#include <exec/memory.h>

#include <graphics/gfxbase.h>
#include <graphics/gfx.h>

#include <intuition/intuitionbase.h>
#include <intuition/intuition.h>

#include <exec/libraries.h>   /* additional for ASL requester */
#include <libraries/asl.h>    /* additional for ASL requester */
#include <clib/exec_protos.h> /* additional for ASL requester */
#include <clib/asl_protos.h>  /* additional for ASL requester */
#include <stdio.h>            /* additional for ASL requester */

/***************************************************************************/

#define WIN_WIDTH	640
#define WIN_HEIGHT	256

#define MIN_WIDTH	175
#define MIN_HEIGHT	52

#define MAX_WIDTH	640
#define MAX_HEIGHT_PAL	256
#define MAX_HEIGHT_NTSC	200

UBYTE *vers = "$VER: filereq 37.0";   /* additional for ASL requester */
#define MYLEFTEDGE 100                /* additional for ASL requester */
#define MYTOPEDGE  25                 /* additional for ASL requester */
#define MYWIDTH    100                /* additional for ASL requester */
#define MYHEIGHT   200                /* additional for ASL requester */

/***************************************************************************/

void adios(char *message);
void about(void);
long asker(void);

/* char SourceDir[31]; */

/***************************************************************************/

struct GfxBase		*GfxBase;
struct IntuitionBase	*IntuitionBase;

struct Window		*window;
struct RastPort		*rastport;
struct IntuiMessage	*intuimessage;

struct Library *AslBase = NULL;       /* additional for ASL requester */

struct TagItem frtags[] =	      /* additional for Source ASL requester */
{
	ASL_Hail,	(ULONG)"Select Source Drive",
	ASL_Height,	MYHEIGHT,
	ASL_Width,	MYWIDTH,
	ASL_LeftEdge,	MYLEFTEDGE,
	ASL_TopEdge,	MYTOPEDGE,
	ASL_OKText,	(ULONG)"Okay",
	ASL_CancelText,	(ULONG)"Cancel",
	ASL_ExtFlags1,	FIL1F_NOFILES,
	ASL_Dir,	(ULONG)"RAM:",    /* No default directory specified */
	TAG_DONE
};				      /* additional for Source ASL requester */

struct TagItem fr1tags[] =	      /* additional for Destination ASL requester */
{
	ASL_Hail,	(ULONG)"Select Destination Drive",
	ASL_Height,	MYHEIGHT,
	ASL_Width,	MYWIDTH,
	ASL_LeftEdge,	MYLEFTEDGE,
	ASL_TopEdge,	MYTOPEDGE,
	ASL_OKText,	(ULONG)"Okay",
	ASL_CancelText,	(ULONG)"Cancel",
	ASL_ExtFlags1,	FIL1F_NOFILES,
	ASL_Dir,	(ULONG)"RAM:",    /* No default directory specified */
	TAG_DONE
};				      /* additional for Destination ASL requester */

struct FileRequester *fr;
struct FileRequester *fr1;

/***************************************************************************/
struct TextAttr T8 = { (UBYTE *)"topaz.font", 8, 0, 0 };

static char winstring[] = "The source directory is: ";
struct IntuiText wintext = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring, 0 };

static char winstring2[] = "The restore directory is: ";
struct IntuiText wintext2 = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring2, 0 };

static char winstring3a[] = "The following files have been";
struct IntuiText wintext3a = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring3a, 0 };

static char winstring3b[] = "identified as deleted: ";
struct IntuiText wintext3b = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring3b, 0 };

static char winstring4[] = "Enter the filename to recover: ";
struct IntuiText wintext4 = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring4, 0 };

char winstring5[] = "";
struct IntuiText wintext5 = { 3, 0, JAM1, 0, 0, &T8, (UBYTE *)&winstring5, 0 }; 


/***************************************************************************/

static char WindowTitle[] = "UnDelete - Flyer file recovery system";
struct NewWindow newwindow = {	0, 0, WIN_WIDTH, WIN_HEIGHT, 0, 1,
				CLOSEWINDOW|MENUPICK,
				WINDOWCLOSE|WINDOWSIZING|WINDOWDRAG
				|WINDOWDEPTH|ACTIVATE|NOCAREREFRESH,
				(struct Gadget *)NULL,
				(struct Image *)NULL,
				(UBYTE *)WindowTitle,
				(struct Screen *)NULL,
				(struct BitMap *)NULL,
				MIN_WIDTH, MIN_HEIGHT, MAX_WIDTH,
				MAX_HEIGHT_PAL, WBENCHSCREEN };

/***************************************************************************/

struct IntuiText intuitext1 = { 0, 1, JAM1, 8, 1, &T8, (UBYTE *)"About", 0 };
struct IntuiText intuitext2 = { 0, 1, JAM1, 0, 1, &T8, (UBYTE *)"-------", 0 };
struct IntuiText intuitext3 = { 0, 1, JAM1, 8, 1, &T8, (UBYTE *)"Quit", 0 };

struct MenuItem menuitem1 = { 	NULL,
				2, 0, 56, 10,
				ITEMTEXT|ITEMENABLED|HIGHCOMP, 0L,
				(APTR)&intuitext1,
				(APTR)0, (BYTE)0, (struct MenuItem *)0,
				(USHORT)0 };

struct MenuItem menuitem2 = { 	(struct MenuItem *)&menuitem1,
				2, 10, 56, 10,
				ITEMTEXT|HIGHCOMP, 0L,
				(APTR)&intuitext2,
				(APTR)0, (BYTE)0, (struct MenuItem *)0,
				(USHORT)0 };

struct MenuItem menuitem3 = { 	(struct MenuItem *)&menuitem2,
				2, 19, 55, 10,
				ITEMTEXT|ITEMENABLED|HIGHBOX, 0L,
				(APTR)&intuitext3,
				(APTR)0, (BYTE)0, (struct MenuItem *)0,
				(USHORT)0 };

struct Menu menu = {		NULL,
				0, 0,
				62, 10,
				MENUENABLED,
				(BYTE *) "Options",
				&menuitem3,
				0, 0, 0, 0 };

/***************************************************************************/

UWORD pointer_data[] ={	0, 0, 256, 256, 256, 256, 896, 0, 3168, 0, 12312, 0,
			256, 49414, 256, 49414, 12312, 0, 3168, 0, 896, 0,
			256, 256, 256, 256, 256, 256, 0, 0 };

UWORD *chip_data;

/***************************************************************************/

ULONG class;
USHORT code;
BOOL quit=FALSE;
short count;

/***************************************************************************/

void main(int argc, char **argv) /* was originally (void) */
{

GfxBase = (struct GfxBase *) OpenLibrary("graphics.library", 0L);
if (!GfxBase) adios("ERROR: Couldn't open graphics.library !");

IntuitionBase = (struct IntuitionBase *) OpenLibrary("intuition.library", 0L);
if (!IntuitionBase) adios("ERROR: Couldn't open intuition.library !");

chip_data = (UWORD *) AllocMem(sizeof(pointer_data), MEMF_CHIP);
if (!chip_data) adios("ERROR: Couldn't allocate memory for chip_data");

for (count = 0; count <32; count++)
	*(chip_data+count) = pointer_data[count];

if (GfxBase -> DisplayFlags == 1)
	newwindow.MaxHeight = newwindow.Height = MAX_HEIGHT_NTSC;

window = (struct Window *) OpenWindow(&newwindow);
if (!window) adios("ERROR: Not enough memory for main-window.");

/* ASL requester to select source directory */
	
	if (AslBase = OpenLibrary("asl.library", 37L))
	{
           if (fr = (struct FileRequester *)
	       AllocAslRequest (ASL_FileRequest, frtags))

	   {
              if (AslRequest (fr, NULL))
	      {
		/* winstring5 = fr->rf_Dir; */
		printf("PATH=%s\n", fr->rf_Dir);
	      }
	      FreeAslRequest (fr);
	   }
	   else
	     printf("User Cancelled\n");

	   CloseLibrary(AslBase);
	}

/* ASL requester ends */
/* ASL requester to select destination directory */
	
	if (AslBase = OpenLibrary("asl.library", 37L))
	{
           if (fr1 = (struct FileRequester *)
	       AllocAslRequest (ASL_FileRequest, fr1tags))

	   {
              if (AslRequest (fr1, NULL))
	      {
		/* winstring5 = fr1->rf_Dir; */
		printf("PATH=%s\n", fr1->rf_Dir);
	      }
	      FreeAslRequest (fr1);
	   }
	   else
	     printf("User Cancelled\n");

	   CloseLibrary(AslBase);
	}

/* ASL requester ends */

rastport=window->RPort;
PrintIText(rastport, &wintext, 25, 25);

/* Lee added the lines below */

PrintIText(rastport, &wintext2, 25, 45);
PrintIText(rastport, &wintext3a, 25, 80);
PrintIText(rastport, &wintext3b, 25, 89);
PrintIText(rastport, &wintext4, 25, 120);
PrintIText(rastport, &wintext5, 25, 180);

/* End of Lee additions */

SetPointer(window, (short *) chip_data, 14, 16, -7, -6);
SetMenuStrip(window, &menu);

while (!quit) {
	intuimessage = (struct IntuiMessage *) GetMsg(window->UserPort);

	if (intuimessage == NULL)
		continue;

	class = intuimessage->Class;
	code = intuimessage->Code;

	switch (class) {
		case CLOSEWINDOW :
			quit = (BOOL) asker();
			break;

		case MENUPICK :
			if (MENUNUM(code)==0)
				switch(ITEMNUM(code)) {
					case 2:	about();
						break;

					case 0:	quit=(BOOL) asker();
				}
		}

	ReplyMsg(intuimessage);
	}

ClearMenuStrip(window, &menu);
ClearPointer(window);

adios(NULL);
}

/***************************************************************************/

void adios(char *message)
{
	if(message)		puts(message);
	if(chip_data)		FreeMem(chip_data, sizeof(pointer_data));
	if(window)		CloseWindow(window);
	if(IntuitionBase)	CloseLibrary(IntuitionBase);
	if(GfxBase)		CloseLibrary(GfxBase);
	if(message)		exit(1);
}

/***************************************************************************/

void about(void)
{

	static char title[] = "About UnDelete";
	static char text1[] = "UnDelete Version 1.0 ";
	static char text2[] = "(c)1998 By PFKP Software";
	static char text3[] = "Tools for the toaster/flyer";

	struct Window		*wd;
	struct RastPort		*rp;
	struct IntuiMessage	*im;

	static struct IntuiText it3 = { 1, 0, JAM1, 5, 24, &T8,
		(UBYTE *)text3, (struct IntuiText *)NULL };

	static struct IntuiText it2 = { 2, 0, JAM1, 5, 12, &T8,
		(UBYTE *)text2, (struct IntuiText *)&it3 };

	static struct IntuiText it1 = { 3, 0, JAM1, 5, 0, &T8,
		(UBYTE *)text1, (struct IntuiText *)&it2 };

	static short coords[] = { 1, 1, 238, 1, 238, 50, 1, 50, 1, 1 };
	static struct Border brdr = { 0, 0, 3, 0, JAM1, 5, &coords[0], NULL };

	struct NewWindow nw = {	15, 15, 251, 65, 0, 1,
				CLOSEWINDOW|MOUSEBUTTONS,
				WINDOWCLOSE|WINDOWDRAG|ACTIVATE|RMBTRAP,
				(struct Gadget *)NULL,
				(struct Image *)NULL,
				(UBYTE *)title,
				(struct Screen *)NULL,
				(struct BitMap *)NULL,
				0, 0, 0, 0, WBENCHSCREEN };


	wd = (struct Window *) OpenWindow (&nw);
	if (wd) {
		rp=wd->RPort;
		PrintIText(rp, &it1, 20, 20);
		DrawBorder(rp, &brdr, 6, 11);

		while (im->Class != CLOSEWINDOW && im->Class != MOUSEBUTTONS)
			im = (struct IntuiMessage *) GetMsg(wd->UserPort);
		ReplyMsg(im);
		CloseWindow(wd);
		}
	else
		adios("ERROR: Not enough memory for about-window");
}

/***************************************************************************/

long asker(void)
{

	static struct IntuiText BodyText = {0, 1, JAM1, 20, 4, &T8,
		(UBYTE *)"Are you sure ?", NULL};

	static struct IntuiText PosText = {0, 1, JAM1, 6, 4, &T8,
		(UBYTE *)"Yes", NULL};

	static struct IntuiText NegText = {0, 1, JAM1, 7, 4, &T8,
		(UBYTE *)"No", NULL};


	return(AutoRequest (window, &BodyText, &PosText, &NegText,
		0, 0, 170, 50));
}
