
#include <exec/types.h>
#include <string.h>
#include <stdio.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

#define	MONOAUDFLDSIZE		3
#define	NUMAUDCHANS			2
#define	SAMPLESPERFIELD	735	// Audio samples per video field

struct Library *FlyerBase;

UBYTE BlkBuff[512];

UWORD	AudioBuff[8][256*MONOAUDFLDSIZE];

UWORD BillStereo;

UWORD Rate;

/* Prototypes */
ULONG WriteTestClip(char *, ULONG, FILE *, FILE *);
ULONG WriteTest2Clip(char *, ULONG, FILE *, FILE *);
ULONG WriteTest3Clip(char *, ULONG, FILE *, FILE *);
ULONG WriteTest4Clip(char *, ULONG, FILE *, FILE *);
ULONG WriteTest5Clip(char *, ULONG, FILE *, FILE *);

ULONG Reprocess(char *, ULONG);

/* Function Prototypes */

int AIFFencode(FILE *);
int AD516encode(FILE *);
int WAVencode(FILE *);
int RAWencode(FILE *);
int IFFencode(FILE *);
int AUencode(FILE *);

void error(char *msg, int code);
int getdata(char *ptr, int nbytes, FILE *IN);
int getdata2(char *ptr, int nbytes, FILE *IN);
UWORD typeit(FILE *);

UWORD size;

/* here for linear interp.  might be useful for other things */
gcd(a, b) 
long a, b;
{
if (b == 0)
   return a;
else
   return gcd(b, a % b);
}

lcm(a, b) 
long a, b;
{
return (a * b) / gcd(a, b);
}

int main(int argc, char *argv[])
{
FILE *IN, *IN2;
ULONG err,frames,frames2;
UWORD temp = 2;
UWORD Type1, Type2;

printf("Black Box Write version 1.2\n");
printf("Copyright Prowave 1996\n");

IN = fopen(argv[1],"rb");

if (IN == NULL)
   error("Error opening input file. Program terminated",1);

rewind(IN);

Type1 = typeit(IN);

printf("This is Type1 %x \n",Type1);

if (Type1 == 1)
   {
   fclose(IN);
   IN = fopen(argv[1],"rb");
   getdata((char *)&err,4,IN);
   printf("Lets go to AIFFencode \n");
   frames = AIFFencode(IN);
   printf("AIFFencode returne\n");
   }

if (Type1 == 2)
   {
   frames = AD516encode(IN);
   }

if (Type1 == 3)
   {
   frames = RAWencode(IN);
   fclose(IN);
   IN = fopen(argv[2],"rb");
   }

if (Type1 == 4)
   {
   fclose(IN);
   IN = fopen(argv[1],"rb");
   getdata((char *)&err,4,IN);
   frames = IFFencode(IN); 
   }

if (Type1 == 5)
   {
   frames = AUencode(IN);
   }

if (Type1 == 50)
   {
   frames = WAVencode(IN);
   }

printf("This is Type1 %x \n",Type1);

IN2 = NULL;

if (argc == 4)
   {
   temp = 3;
   IN2 = fopen(argv[2],"rb");
   if (IN2 == NULL)
      error("Error opening input file. Program terminated",1);

   rewind(IN2);

   Type2 = typeit(IN2);

   if (Type2 == 1)
      {
      fclose(IN2);
      IN2 = fopen(argv[2],"rb");
      getdata((char *)&err,4,IN2);
      frames2 = AIFFencode(IN2);
      }

   if (Type2 == 2)
      frames2 = AD516encode(IN2);

   if (Type2 == 3)
      {
      frames2 = RAWencode(IN2);
      fclose(IN2);
      IN2 = fopen(argv[2],"rb");
      }

   if (Type2 == 4)
      {
      fclose(IN2);
      IN2 = fopen(argv[2],"rb");
      getdata((char *)&err,4,IN2);
      frames2 = IFFencode(IN2);
      }

   if (Type2 == 5)
      {
      frames = AUencode(IN2);
      }

   if (Type2 == 50)
      frames2 = WAVencode(IN2);
   }

if (FlyerBase = OpenLibrary(FLYERLIBNAME,0)) 
   {
   if (size == 1)
      Type1 = 1;

   if (Type1 < 50)
      {
      if (Rate == 44100)
         err = WriteTestClip(argv[temp],frames,IN,IN2);	// Make skeletal version
      else
         err = WriteTest3Clip(argv[temp],frames,IN,IN2);
      } 
   else
      {
      if (size == 1)
         {
         err = WriteTest5Clip(argv[temp],frames,IN,IN2);
         }
      else
         {
         if (Rate == 44100)
            err = WriteTest2Clip(argv[temp],frames,IN,IN2);
         else
            err = WriteTest4Clip(argv[temp],frames,IN,IN2);
         }
      }
 
   if (err == 0) 
      {
      err = Reprocess(argv[temp],frames);		// Let Flyer process into full clip
      }
   CloseLibrary(FlyerBase);
   }
else 
   {
   printf("Open flyer.library failed\n");
   }

fclose(IN);

if (IN2 != NULL)
   fclose(IN2);

return(0);
}

/*******************************************************/

UWORD typeit(FILE *IN)
{
ULONG newest;

getdata((char *)&newest,4,IN);

/* FORM */
if (newest == 0x464F524D)
   {
   getdata((char *)&newest,4,IN);
   getdata((char *)&newest,4,IN);
   if (newest == 0x41494646)
      return(1);
   else
      return(4);
   }

/* AD516 */
if (newest == 0x4B574B33)
   return(2);

if (newest == 0x2E736E64)
   return(5);

/* WAVE */
if (newest == 0x52494646)
   return(50);

return(3);
}

/*******************************************************/

int AIFFencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
int i;                     /* uLaw ADPCM sample */
UWORD temp;
char buf[2];
long dLen;
UWORD nChannels,nBitsPerSample;
 
getdata((char *)&temp,2,IN);
while (temp != 0x434F) 
   getdata((char *)&temp,2,IN);

getdata((char *)&temp,2,IN);
while (temp != 0x4D4D)
   getdata((char *)&temp,2,IN);

getdata((char *)&dLen,4,IN);  

printf("Lets read the data \n");

getdata((char *)&nChannels,2,IN);

getdata((char *)&dLen,4,IN);  

getdata((char *)&nBitsPerSample,2,IN);
getdata((char *)&buf,2,IN);
getdata((char *)&Rate,2,IN);

if (buf[1] == 13)
   Rate = Rate/2; 

printf("Lets read the data \n");

getdata((char *)&buf,2,IN);
getdata((char *)&buf,2,IN);
getdata((char *)&buf,2,IN);

BillStereo = nChannels;

getdata((char *)&temp,2,IN);
while (temp != 0x5353) 
   getdata((char *)&temp,2,IN);

getdata((char *)&temp,2,IN);
while (temp != 0x4E44)
   getdata((char *)&temp,2,IN);

temp = Rate/15;

inlength = (dLen/temp);
if (dLen%temp != 0)
   inlength++;


if (nBitsPerSample > 8)
   size = 2;
else
   size = 1;

printf("dLen(words): %ld\n",dLen);
printf("Number of Frames: %d\n",inlength); 
printf("Rate %d\n",Rate);
printf("Channels %d\n",BillStereo);
printf("Bits %d\n",nBitsPerSample);

return(inlength);
}

/*******************************************************/

int IFFencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
UWORD temp;
long dLen;
ULONG test;

printf("We have reached IFFencode\n");
getdata((char *)&test,4,IN);
while (test != 0x56484452)
   getdata((char *)&test,4,IN);

printf("We have found VHDR\n");

getdata((char *)&test,4,IN);

getdata((char *)&dLen,4,IN);

getdata((char *)&test,4,IN);
getdata((char *)&test,4,IN);

getdata((char *)&Rate,2,IN);

printf("let's set BillStereo value\n");

BillStereo = 1;

getdata((char *)&temp,2,IN);
while (temp != 0x424F) 
   getdata((char *)&temp,2,IN);

getdata((char *)&temp,2,IN);
while (temp != 0x4459)
   getdata((char *)&temp,2,IN);

printf("We found the Body\n");

temp = Rate/15;

inlength = (dLen/temp);
if (dLen%temp != 0)
   inlength++;

size = 1;

printf("dLen(words): %ld\n",dLen);
printf("Number of Frames: %d\n",inlength); 
printf("Rate %d\n",Rate);
printf("Channels %d\n",BillStereo);
return(inlength);
}

/*******************************************************/

int RAWencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
UWORD twist;

inlength = 2;

while (getdata((char *)&twist,2,IN) == 0)
   inlength++;
 
Rate = 44100;
size = 2;

return(inlength);
}


/*******************************************************/

int AUencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
long count;
long widget[4];
UWORD temp;

getdata((char *)&inlength,4,IN);

count = inlength - 24;

getdata((char *)&widget,16,IN);

if (widget[1] == 2)
   size = 1;
else
   size = 2;
 
Rate = widget[2];

BillStereo = widget[3];

inlength = widget[0];

temp = Rate / (15 * BillStereo);

inlength = inlength/temp; 

inlength = inlength;

return(inlength);
}

/*******************************************************/

int AD516encode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
int i;                     /* uLaw ADPCM sample */
UWORD temp;

long dLen;

getdata((char *)&Rate,2,IN);
getdata((char *)&Rate,2,IN);

for (i=0;i<13;i++)
   {
   getdata((char *)&temp,2,IN);
   }

BillStereo = 1;

getdata((char *)&dLen,4,IN);  

for (i=0;i<0x723;i++)
   getdata((char *)&temp,2,IN);

temp = Rate/15;

inlength = (dLen/temp);
if (dLen%temp != 0)
   inlength++;

printf("dLen(words): %ld\n",dLen);
printf("Number of Frames: %d\n",inlength); 
printf("Rate %d\n",Rate);
size = 2;

return(inlength);
}

/*******************************************************/

int WAVencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
int temp;

UWORD ending; 
long rLen,fLen,nSamplesPerSec,nBytesPerSec,dLen;
int wFormatTag,nChannels,nBlockAlign,nBitsPerSample;
char *wID="wwww";
char *fID="ffff";

getdata2((char *)&rLen,4,IN);
getdata2(wID,4,IN);
getdata2(fID,4,IN);

getdata2((char *)&fLen,4,IN);

getdata2((char *)&wFormatTag,2,IN);

getdata2((char *)&nChannels,2,IN);
getdata2((char *)&nSamplesPerSec,4,IN);
getdata2((char *)&nBytesPerSec,4,IN);
getdata2((char *)&nBlockAlign,2,IN);
getdata2((char *)&nBitsPerSample,2,IN);

Rate = (UWORD)nSamplesPerSec;

getdata((char *)&ending,2,IN);
while (ending != 0x6461) 
   getdata((char *)&ending,2,IN);

getdata((char *)&ending,2,IN);
while (ending != 0x7461)
   getdata((char *)&ending,2,IN);

getdata2((char *)&dLen,4,IN);  

/* Print .WAV information to Screen */
wFormatTag = wFormatTag >> 16;
nChannels = nChannels >> 16;
nBlockAlign = nBlockAlign >> 16;
nBitsPerSample = nBitsPerSample >> 16;

BillStereo = nChannels;

printf("This is the numbers %d %d\n",BillStereo,nChannels);

if (BillStereo == 0)
   BillStereo = 1;

if (nBitsPerSample > 8)
   size = 2;
else
   size = 1;

temp = Rate/15*BillStereo*size;

inlength = (dLen/temp);
if (dLen%temp != 0)
   inlength++;

printf("rLen:        %ld\n",rLen);
printf("Channels:    %d (1=MONO)\n",nChannels);
printf("Sample Rate: %d Hz\n",Rate);
printf("Bits/Sample: %d\n",nBitsPerSample);
printf("dLen(words): %ld\n",dLen);
printf("Number of Frames: %d\n",inlength); 
return(inlength);
}

int getdata2(char *ptr, int nbytes, FILE *IN)
{
int count;

for (count = 0; count < nbytes; count++) 
   {
   *(ptr+nbytes-count-1) = getc(IN);
   if (ferror(IN))
      error("error reading from file",0);
   }

return(0);
}

ULONG WriteTest2Clip(char *pathname, ULONG frames, FILE *IN, FILE *IN2)
{
int	i,j,k,l,m;
ULONG	frm;
BPTR	handle2;
struct ClipHeader		*ch;
struct FrameHeader	*fh;
struct Field			*fld;

j = 0;

handle2 = Open(pathname,MODE_NEWFILE);

if (!handle2) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle2,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle2,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            l = j;
            m = l+4;
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               getdata2((char *)&AudioBuff[l][k],size,IN);
               if (BillStereo == 2)
                  getdata2((char *)&AudioBuff[m][k],size,IN);
               else
                  {  
                  if (IN2 != NULL)
                     getdata2((char *)&AudioBuff[m][k],size,IN2);
                  else
                     AudioBuff[m][k] = AudioBuff[l][k]; 
                  }
               }
            }
         }
      }
   if (Write(handle2,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle2);

return(0);		
}

void error(char *msg, int code)
{
printf("\nError code %4i \n",code);
printf("%s",msg);
exit(code);
}

int getdata(char *ptr, int nbytes, FILE *IN)
{
int count;

for (count = 0; count < nbytes; count++) 
   {
   *(ptr+count) = getc(IN);
   if (ferror(IN))
      error("error reading from file",0);
   }

return(0);
}

ULONG WriteTestClip(char *pathname, ULONG frames, FILE *IN, FILE *IN2)
{
int	i,j,k;
ULONG	frm;
BPTR	handle;
struct ClipHeader		*ch;
struct FrameHeader	*fh;
struct Field			*fld;

handle = Open(pathname,MODE_NEWFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               getdata((char *)&AudioBuff[j][k],size,IN);
               if (BillStereo == 2)
                  getdata((char*)&AudioBuff[j+4][k],size,IN);
               else
                  if (IN2 != 0)
                     getdata((char *)&AudioBuff[j+4][k],size,IN2);
                  else
                     AudioBuff[j+4][k] = AudioBuff[j][k];
               }
            }
	 }
      }

   if (Write(handle,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle);

return(0);		// Okay
}

ULONG WriteTest3Clip(char *pathname, ULONG frames, FILE *IN, FILE *IN2)
{
int	i,j,k;
ULONG	frm;
BPTR	handle;
struct ClipHeader		*ch;
struct FrameHeader	*fh;
struct Field			*fld;
UWORD temp, temp2;

ULONG Istep,Ostep,Ipos,Opos,lcmnum;

handle = Open(pathname,MODE_NEWFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

lcmnum = lcm(44100,Rate); 

Istep = lcmnum/Rate;

Ostep = lcmnum/44100;

Opos = Ipos = 0;

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               if ((Ipos + Istep) <= Opos)
                  { 
                  getdata((char *)&temp,size,IN);
                  if (BillStereo == 2)
                     getdata((char*)&temp2,size,IN);
                  if (IN2 != 0)
                     getdata((char*)&temp2,size,IN2);
                  Ipos += Istep;          
                  }
               AudioBuff[j][k] = temp;   
               if (BillStereo == 1)
                  AudioBuff[j+4][k] = AudioBuff[j][k];
               else
                  AudioBuff[j+4][k] = temp2;
               Opos += Ostep;
               if (Opos == Ipos)
                  Opos = Ipos = 0;
               }
            }
	 }
      }
   if (Write(handle,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle);

return(0);		// Okay
}

// Reprocess -- Let Flyer re-process our clip to build all the reserved
//					structures needed.  These are quite technical (as well as
//					being private), so we'll let it do the work for us.  We
//					just provide a clip that has the minimal stuff needed.
//					This, obviously, requires that the clip was written to
//					a Flyer drive.  If not, you should copy the "skeletal"
//					clip file to a Flyer drive first, then do this function.
ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!
if (NUMAUDCHANS == 2)
   actptr->Flags |= CAF_AUDIOL | CAF_AUDIOR;
else
   actptr->Flags |= CAF_AUDIOL;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}


ULONG WriteTest4Clip(char *pathname, ULONG frames, FILE *IN, FILE *IN2)
{
int	i,j,k,l,m;
ULONG	frm;
BPTR	handle2;
struct ClipHeader		*ch;
struct FrameHeader	*fh;
struct Field			*fld;

UWORD temp, temp2;

ULONG Istep,Ostep,Ipos,Opos,lcmnum;

j = 0;

handle2 = Open(pathname,MODE_NEWFILE);

if (!handle2) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle2,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

lcmnum = lcm(44100,Rate); 

Istep = lcmnum/Rate;

Ostep = lcmnum/44100;

Opos = Ipos = 0;

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle2,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            l = j;
            m = l+4;
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               if ((Ipos + Istep) <= Opos)
                  { 
                  getdata2((char *)&temp,2,IN);
                  if (BillStereo == 2)
                     getdata2((char*)&temp2,2,IN);
                  if (IN2 != 0)
                     getdata2((char*)&temp2,2,IN2);
                  Ipos += Istep;          
                  }
               AudioBuff[j][k] = temp;   
               if (BillStereo == 1)
                  AudioBuff[j+4][k] = AudioBuff[j][k];
               else
                  AudioBuff[j+4][k] = temp2;
               Opos += Ostep;
               if (Opos == Ipos)
                  Opos = Ipos = 0;
               }
            }
         }
      }
   if (Write(handle2,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle2);

return(0);		// Okay
}

ULONG WriteTest5Clip(char *pathname, ULONG frames, FILE *IN, FILE *IN2)
{
int	i,j,k,l,m;
ULONG	frm;
BPTR	handle2;
struct ClipHeader  *ch;
struct FrameHeader *fh;
struct Field       *fld;

UWORD temp, temp2, temp3, temp4;

UWORD twist;

ULONG Istep,Ostep,Ipos,Opos,lcmnum;

j = 0;

printf("This is a Type 5 situation\n");

handle2 = Open(pathname,MODE_NEWFILE);

if (!handle2) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle2,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

lcmnum = lcm(44100,Rate); 

Istep = lcmnum/Rate;

Ostep = lcmnum/44100;

Opos = Ipos = 0;

twist = 0;

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle2,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            l = j;
            m = l+4;
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               if ((Ipos + Istep) <= Opos)
                  { 
                  if (twist == 0)
                     {        
                     getdata2((char *)&temp,2,IN);
                     temp3 = temp;
                     temp = temp & 0xFF00;
                     if (BillStereo == 2)
                        temp2 = temp3<<8;
                     else
                        twist = 1;
                     if (IN2 != 0)
                        {
                        getdata2((char *)&temp4,2,IN2);
                        temp2 = temp4;
                        temp2 = temp2 & 0xFF00;
                        }
                     }
                  else
                     {
                     temp = temp3<<8;
                     if (IN2 != 0)
                        temp2 = temp4<<8;
                     twist = 0;
                     }
                  Ipos += Istep;          
                  }
               AudioBuff[j][k] = temp;   
               if ((BillStereo == 1) && (IN2 == 0))
                  AudioBuff[j+4][k] = AudioBuff[j][k];
               else
                  AudioBuff[j+4][k] = temp2;
               Opos += Ostep;
               if (Opos == Ipos)
                  Opos = Ipos = 0;
               }
            }
         }
      }
   if (Write(handle2,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle2);

return(0);		// Okay
}

