
#include "arexx.h"
#include "arexxsyslib.h"

#ifdef RVI
#include "rvi.h"
#endif
 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
#ifdef RVI
   char   error_name[MAX_ERROR_NAME + 1];
#endif
   };

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

struct Library *DosBase;

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

struct Library *FlyerBase;

struct Join
   {
   ULONG   StartFrame;
   } join[512];

ARexxContext rob1;

FILE *bill, *input_file, *jeff_file;

WORD testbuff[256];

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: Video Knife 0.5";

main(int argc,char **argv)
{
LONG result;
ARexxContext rob1;
struct Library *RexxSysLib = NULL;
struct RexxMsg *bill2;
ULONG	res;
ULONG  OUTFILE2;  
ULONG  j;
ULONG Total = 0;
ULONG delta, delta2;
ULONG mydelta;
ULONG oldframe;
ULONG mycount;
ULONG outval;
ULONG mynumber;
ULONG loopcount;
ULONG croutonnum = 0;
ULONG lastframe=0;

char number[100];

struct FlyerVolume FlyVol;

struct ClipInfo	Buffer;
struct ClipAction act;
struct FrameHeader FrameBuffer;

UWORD pathcount;
UWORD *pathpt;

pathpt = &pathcount;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   exit(0);
   }

if ((RexxSysLib = OpenLibrary("rexxsyslib.library",0))==0)
   {
   printf("Open rexxsyslib.library failed\n");
   exit(0);
   }

rob1 = ARexxInit("PROWAVE",NULL,FALSE);
if (!rob1)
   printf("We are confused \n");

delta = atoi(argv[2]);

delta2 = atoi(argv[3]);

Buffer.len = sizeof(struct ClipInfo);

bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"Setting Up Flyer"); 
if (!bill2)
   printf("It didn't work\n");
else
   result = get_reply(rob1);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];
res = GetClipInfo(&FlyVol,&Buffer);

if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,Error2String(res)); 
   if (!bill2)
      printf("It didn't work\n");
   else
      result = get_reply(rob1);
   goto ending;   
   }

OUTFILE2 = Buffer.Fields/4 -1;

jeff_file = fopen("env:cutting","w");

mycount = 0;

oldframe = 0;

for (j=0;j<OUTFILE2 ;j++)
   {

   mynumber = 1000000;

   loopcount = 0;

   while (mynumber > 100000)
      {
      act.VidStartField = j*4;

      act.Volume = &FlyVol;

      res = GetFrameHeader(&act,&FrameBuffer);

      if (res)
         {
         Printf("Super Widget Error on i = %ld \n",j);
         printf("Error %ld - %ls\n",res,Error2String(res));
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,Error2String(res)); 
         if (!bill2)
            printf("It didn't work\n");
         else
            result = get_reply(rob1);
         goto ending;
         }
      
      loopcount++;
      if (loopcount > 10)
         {
         printf("Its broke \n"); 
         goto ending;
         }

      if (FrameBuffer.Length < 0x10000)
         mynumber = 0;
      } 
           
   if (oldframe > FrameBuffer.Length)
      {
      mydelta = oldframe-FrameBuffer.Length; 
      }
   else
      {
      mydelta = FrameBuffer.Length-oldframe;
      }

   if (mydelta+1 > delta)
      {
      if ((j != 0) && (delta2 == 2))  /* First Icon */
         {
         fprintf(jeff_file,"%ld %ld\n",j-1,oldframe);
         Delay(100);
         sprintf(number,"%ld",4);
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"duration",number); 
         outval = (j-1)*4;   
         sprintf(number,"%ld",outval);
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","MAKEICON",0,2,argv[1],number); 
         Delay(100);
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONLOAD",0,1,argv[1]);           
         Delay(100);
         croutonnum++;
         sprintf(number,"%ld",croutonnum);
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number); 
         Delay(100);
         outval = lastframe+4;
         lastframe = outval;
         sprintf(number,"%ld",outval);
         bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"clipstartfield",number); 
         }

      fprintf(jeff_file,"%ld %ld\n",j,FrameBuffer.Length);
      Delay(100);
      outval = j*4 - lastframe;
      sprintf(number,"%ld",outval);
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"duration",number); 
      printf("%ld %ld ",delta,mydelta);
      printf("%ld   %ld  \n",j,FrameBuffer.Length);
      outval = j*4;
      lastframe = outval;
      sprintf(number,"%ld",outval);
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","MAKEICON",0,2,argv[1],number); 
      Delay(100);
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONLOAD",0,1,argv[1]); 
      Delay(100);
      croutonnum++;
      sprintf(number,"%ld",croutonnum);
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number); 
      Delay(100);
      if (delta2 == 1)
         {
         outval = j*4;
         sprintf(number,"%ld",outval);
         }
      else
         {
         outval = j*4;
         sprintf(number,"%ld",outval);
         }
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"clipstartfield",number); 
      }
   oldframe = FrameBuffer.Length; 
   }

if (delta2 == 1)
   outval = j*4 - lastframe + 4;
else
   outval = 4;


sprintf(number,"%ld",outval);
bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"duration",number); 

fprintf(jeff_file,"%d %ld\n",j-1,FrameBuffer.Length);
if (delta2 == 2)
   {
   outval = (j-1)*4;   
   sprintf(number,"%ld",outval);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","MAKEICON",0,2,argv[1],number); 
   Delay(500);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONLOAD",0,1,argv[1]);           
   Delay(100);
   croutonnum++;
   sprintf(number,"%ld",croutonnum);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number); 
   Delay(100);
   sprintf(number,"%ld",lastframe+4);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"clipstartfield",number); 
   outval = j*4 - lastframe;
   sprintf(number,"%ld",outval);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSETTAG",0,2,"duration",number); 
   }

Total = Total + 1;

ending:

ARexxFree(rob1);

if (RexxSysLib)
   CloseLibrary(RexxSysLib);

CloseLibrary(FlyerBase);

fclose(jeff_file);

return(0);
}

LONG get_reply(ARexxContext  context)
{
   struct RexxMsg   *reply;
   unsigned long    i;
   LONG             temp_code;

   /* poll for reply */
   i=0;
      while ( ((reply = GetARexxMsg(context)) == NULL) && (++i < 1000) )
      {
         Delay(5);
      }
 

   if (i == 1000)
   {
      printf("timeout\n");
      /* did not get a response in a long time, just return */
      return(0);
   }
   else
   {
            if (IsARexxReply( reply) )
            { 
         temp_code = reply->rm_Result1;
         FreeARexxMsg(context, reply);
      }
      /* otherwise, don't care */
   }
   return( temp_code);
}

ARexxContext ARexxInit(char *name, char *extension, BOOL multiple)
{
struct Library *RexxSysBase;
struct MsgPort *port;
ARexxContext  context;
unsigned count;
char  *ptr;

context = AllocMem(sizeof(struct ARexxContext), MEMF_PUBLIC | MEMF_CLEAR);

if (!context)
   return(NULL);

RexxSysBase = OpenLibrary((UBYTE *) "rexxsyslib.library",0L);

if (RexxSysBase)
   {
   context->rexx_base = RexxSysBase;
   if (!extension)
      extension = "rexx";
   StrNUpper(context->extension, extension, MAX_EXTENSION);
   ptr = StrNUpper(context->port_name, name, MAX_PORT_NAME);
#ifdef RVI
   strcpy(context->error_name, context->port_name);
   strcat(context->error_name, ".LASTERROR");
#endif

   Forbid();
   if (multiple)
      {
      *ptr++='.';
      for (count = 1; count < 100; ++count)
         {
         UiToStr(count, ptr);
         port = FindPort((UBYTE *) context->port_name);
         if (!port) break;
         }
      }
   else
      {
      port = FindPort((UBYTE *) context->port_name);
      }

   if (!port)
      context->arexx_port = CreatePort ((UBYTE *) context->port_name,0);
   Permit();
   }

if (!context->rexx_base || !context->arexx_port)
   {
   ARexxFree(context);
   context = NULL;
   }

return(context);
}

void ARexxFree (ARexxContext context)
{
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context)
   return;

if (context->rexx_base)
   {
   RexxSysBase = context->rexx_base;
   context->port_name[0] = NULLCHAR;
   while (context->outstanding > 0 && context->arexx_port != NULL)
      {
      WaitPort(context->arexx_port);
      while ((msg = GetARexxMsg(context) ) != NULL)
         {
         if (!FreeARexxMsg(context, msg))
            ReplyARexxMsg(context, msg, 100, NULL, 0);
         }
      }
   if (context->arexx_port)
      {
      Forbid();
      while ((msg = GetARexxMsg(context)) != NULL)
         ReplyARexxMsg(context, msg, 100, NULL, 0);
      DeletePort(context->arexx_port);
      Permit();
      }
   CloseLibrary(RexxSysBase);
   }

FreeMem(context, sizeof(struct ARexxContext));

}

char *ArexxName(ARexxContext context)
{
if (context)
   return(context->port_name);
else
   return(NULL);
}

ULONG ARexxSignal(ARexxContext context)
{
if (context)
   return(1UL << context->arexx_port->mp_SigBit);
else
   return(0);
}

struct Library *ARexxBase(ARexxContext context)
{
if (context)
   return(context->rexx_base);
else
   return(NULL);
}

BOOL IsARexxReply( struct RexxMsg *msg)
{
if (msg)
   return( (BOOL)(msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG ));
else
   return(FALSE);
}

struct RexxMsg *GetARexxMsg(ARexxContext context)
{
struct RexxMsg *msg;

if (!context)
   return(NULL);

msg = (struct RexxMsg *) GetMsg(context->arexx_port);

if (!msg)
   return(NULL);

if (IsARexxReply(msg))
   --context->outstanding;

return(msg);
}

BOOL FreeARexxMsg(ARexxContext context, struct RexxMsg *msg)
{
struct Library *RexxSysBase;

if (!context || !msg)
   return(FALSE);

if (!IsARexxReply(msg))
   return(FALSE);

RexxSysBase = context->rexx_base;

ClearRexxMsg(msg, 16);

if (msg->rm_Result1 == 0 && msg->rm_Result2 != NULL)
   DeleteArgstring((char *) msg->rm_Result2);

DeleteRexxMsg(msg);

return(TRUE);

}

struct RexxMsg *SendARexxMsg(ARexxContext context, char *port_name,
              char *command, ULONG flags)
{
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context || !command)
   return(NULL);

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
              context->port_name);

if (!msg)
   return(NULL);

flags &= ( RXFF_NOIO | RXFF_RESULT | RXFF_STRING | RXFF_TOKEN );

msg->rm_Action = RXCOMM | flags;

msg->rm_Args[0] = (STRPTR) CreateArgstring(command, strlen(command));

msg->rm_Result1 = 0;

msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port = FindPort((UBYTE *) port_name )) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   DeleteArgstring((char *) msg->rm_Args[0]);
   DeleteRexxMsg(msg);
   msg = NULL;
   }

Permit();
return(msg);

}


struct RexxMsg *CallARexxFunc (ARexxContext context, char *port_name,
       char *function, ULONG flags, int num_args, ...)
{
va_list        argptr;
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;
BOOL   quit;
int   i;
char *arg;

if (!context || !function || num_args < 0)
   return(NULL);

if (num_args > 15)
   num_args = 15;

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
            context->port_name);

if (!msg)
   return(NULL);

flags &= (RXFF_NOIO | RXFF_RESULT | RXFF_STRING);

msg->rm_Action = RXFUNC | flags;

msg->rm_Action |= ( num_args & RXARGMASK);

msg->rm_Args[0] = (STRPTR) CreateArgstring(function, strlen(function));

msg->rm_Result1 = 0;
msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

va_start (argptr, num_args);

for (i=1, quit=FALSE; i<= num_args && !quit; ++i)
   {
   arg = (char *) va_arg(argptr, char *);

   if (!arg)
      arg = "";

   msg->rm_Args[i] = (STRPTR) CreateArgstring(arg, strlen(arg));

   if (!msg->rm_Args[i])
      quit = TRUE;

   }

va_end(argptr);

if (quit)
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port=FindPort((UBYTE *) port_name)) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   msg = NULL;
   }


Permit();

return(msg);

}


BOOL  ReplyARexxMsg( ARexxContext context,  struct RexxMsg  *msg,
                     LONG return_code,  char *result_string,
                     LONG error_code)
{

   struct Library  *RexxSysBase;

   if ( !context || !msg )
      return( FALSE );

   if ( IsARexxReply (msg) )
      return( FALSE );

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Set the results */

   msg->rm_Result1 = return_code;
   msg->rm_Result2 = (LONG) NULL;

   /* if no error and result was requested, set the result string */

   if ( result_string != NULL && return_code == RC_OK
        && (msg->rm_Action & RXFF_RESULT) != 0 )
      {
       msg->rm_Result2 = (LONG) CreateArgstring( result_string,
                                 strlen( result_string) );
      }
   else if  (return_code != RC_OK)
      {
         msg->rm_Result2 = error_code;
      }

   ReplyMsg( (struct Message *)msg );

   return(TRUE);
}



BOOL AddFuncHost (ARexxContext context,  LONG priority)
{

   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if( !context )
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Get a new message packet */

   msg = CreateRexxMsg( context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);


   msg->rm_Action = RXADDFH | RXFF_NONRET;
   msg->rm_Args[0] = (STRPTR) context->port_name;
   msg->rm_Args[1] = (STRPTR) priority;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX" ) ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg( msg );
      msg = NULL;
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}


BOOL RemFuncHost( ARexxContext context)
{
   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if (!context)
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* get a new message packet */

   msg = CreateRexxMsg (context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);

   /* tell the resident process to remove the port name to the Library
    * List... we don't expect a reply
    */

   msg->rm_Action   = RXREMLIB | RXFF_NONRET;
   msg->rm_Args[0]  = (STRPTR)  context->port_name;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX") ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg (msg);
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}




BOOL  SetARexxLastError( ARexxContext context, struct RexxMsg *msg,
                        char *error)
{

   #ifndef RVI
      return(FALSE);
   #else
      if (!context || !msg || !error)
         return(FALSE);

      if (!CheckRexxMsg (msg) )
         return(FALSE);

      return( SetRexxVar( msg, context->error_name,
                           error, strlen(error) ) == 0 )
   #endif
}




static char *StrNUpper( char *dest,  char *src,  unsigned int len)
{

   for( ; *src != NULLCHAR && len-- > 0; ++src)
   {
      if (islower (*src))
         *dest++ = toupper( *src );
      else
         *dest++ = *src;
   }

   *dest = NULLCHAR;

   return(dest);
}



static char *UiToStr( unsigned num, char *buf)
{
   num %= 100;

   buf[0] = (num / 10) + '0';
   buf[1] = (num % 10) + '0';
   buf[2] = NULLCHAR;

   return(buf);
}



