
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Capture(char *);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[4][100];
ULONG count[2];

FILE *bill;

main(int argc,char **argv)
{
ULONG	res;

printf("Still2Clip Version 0.95\n");
printf("Copyright Prowave 1996\n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

printf("Lets set the Input \n");
res = FlyerInputSel(0,FI_ToasterMain,FS_ToasterMain);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   CloseLibrary(FlyerBase);
   exit(20);
   }

printf("Recordmode is started \n");
res = SetRecMode(0);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   CloseLibrary(FlyerBase);
   exit(20);
   }

res = RecordMode(0);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   CloseLibrary(FlyerBase);
   exit(20);
   }

printf("We are in Record Mode \n");

Capture(argv[1]);

res = SetPlayMode(0);

CloseLibrary(FlyerBase);

return(0);
}

ULONG Capture(char *pathname)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->VidFieldCount = 4;
actptr->Flags = CAF_VIDEO;
actptr->Channel = 0;

printf("We are here to see video compress modes \n");
res = VideoCompressModes(0,0,4,0);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

printf("We are about to Append Fields \n");

res = AppendFields(actptr);

printf("This is res %ld \n",res);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

return(FERR_OKAY);
}
