
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

BPTR	handle;

main(int argc,char **argv)
{
int	unit,vidchan,drive,audchans,vidflag;
ULONG	res,clock,frame,frames,theclock;
UWORD	Volume;
char	key;

if ((argc!=4)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <vchan> <drive:name> <frame>\n",argv[0]);
   return(20);
   }
	
GetArg(argv[1],&vidchan,0,3,"Video channel");
GetLongArg(argv[3],&frame,0,0x7FFFFFFF,"Start Frame");

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

handle = Input();

ToasterMux(0,1,1,0);

FlyVol.Path = argv[2];
FlyVol.Board = 0;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STARTED;

Action.Channel = vidchan;
Action.Flags = CAF_VIDEO;

Volume = 0xFFFF;

Action.VidStartField = frame * 4;
Action.VidFieldCount = 4;
Action.TotalAudStart = Action.AudStartField = frame * 4;
Action.TotalAudLength = Action.AudFieldCount = 4;
/* Action.GoClock = clock; */
Action.VolSust1 = 0;
Action.VolSust2 = 0;
Action.AudioPan1 = 0;
Action.AudioPan2 = 0;

res = FlyerPlay(&Action);
if (res==FERR_OKAY) 
   {
   res = GetFieldClock(&theclock);
   }

CloseLibrary(FlyerBase);
return(0);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
