
#include "arexx.h"
#include "arexxsyslib.h"

#ifdef RVI
#include "rvi.h"
#endif

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction  Action;

BPTR  handle;

#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
#ifdef RVI
   char   error_name[MAX_ERROR_NAME + 1];
#endif
   };

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

struct Library *DosBase;

void PlayVideo(UWORD, char *,UWORD); 

void AppendVid(char *);

void CheckBar(int);

char pathname[2][100];

struct envtype
   {
   UWORD Frame;
   UWORD Count;
   } Env[100];

FILE *input_file;

ARexxContext rob1;

main(int argc,char **argv)
{
ARexxContext rob1;

struct Library *RexxSysLib = NULL;
struct RexxMsg *bill;
LONG                  result;
UWORD i, Frame1, Frame2;
UWORD looplength, pathcount;
char temp[20];
char outpath[50];
char buff5[256];
char *tokenpt;
UWORD VidQual;
int err;
int TBARVAL, delta;
char number[10];
UWORD key;
UBYTE QualModes[] = {
   0x00,    // Standard
   0x03,    // Extended
   0x00,    // Audio-only (yuck!)
   0x10};      // HQ5
ULONG res;

TBARVAL = 0;

printf("RenderFX version 0.89\n");
printf("Copyright Prowave 1996 \n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

input_file = fopen(argv[1],"r");
if (input_file == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,49);

tokenpt = strtok(NULL,",");
VidQual = atoi(tokenpt);

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(pathname[0],tokenpt,49);
tokenpt = strtok(NULL,",");
Frame1 = atoi(tokenpt)/2;

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(pathname[1],tokenpt,49);

tokenpt = strtok(NULL,",");
Frame2 = atoi(tokenpt)/2;

err = fscanf(input_file,"%s ",temp);
looplength = atoi(temp)/2;

err = fscanf(input_file,"%s ",temp);
pathcount = atoi(temp);

for (i=0;i<pathcount;i++)
   {
   fgets(buff5,255,input_file);
   tokenpt = strtok(buff5,",");
   Env[i].Frame = atoi(tokenpt)/2;
   tokenpt = strtok(NULL,",");
   Env[i].Count = atoi(tokenpt);
   }

RexxSysLib = OpenLibrary("rexxsyslib.library",0);

delta = 50;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

rob1 = ARexxInit("PROWAVE",NULL,FALSE);

if (!rob1)
   printf("We are confused \n");

bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TOSW");
if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }

printf("These are the frames %ld %ld \n",Frame1, Frame2);

printf("This is mode %d \n",VidQual);

if (TBARVAL > 511)
   TBARVAL = 511;
if (TBARVAL < 0)
   TBARVAL = 0;
sprintf(number,"%d",TBARVAL);
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }
CheckBar(TBARVAL);

TBARVAL = TBARVAL + delta;
printf("TBAR %d Delta %d \n",TBARVAL, delta);
   
if (TBARVAL > 511)
   TBARVAL = 511;
if (TBARVAL < 0)
   TBARVAL = 0;
sprintf(number,"%d",TBARVAL);
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }
CheckBar(TBARVAL);


TBARVAL = TBARVAL + delta;
printf("TBAR %d Delta %d \n",TBARVAL, delta);

if (TBARVAL > 511)
   TBARVAL = 511;
if (TBARVAL < 0)
   TBARVAL = 0;
sprintf(number,"%d",TBARVAL);
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }
CheckBar(TBARVAL);


TBARVAL = TBARVAL + delta;
printf("TBAR %d Delta %d \n",TBARVAL, delta);
   
if (TBARVAL > 511)
   TBARVAL = 511;
if (TBARVAL < 0)
   TBARVAL = 0;

sprintf(number,"%d",TBARVAL);
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }

CheckBar(TBARVAL);


bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");

if (!bill)
   {
   printf("It didn't work\n");
   }
else
   {
   result = get_reply( rob1);
   printf("result = %ld\n", result);
   }

ARexxFree(rob1);

if (RexxSysLib)
   CloseLibrary(RexxSysLib);

CloseLibrary(FlyerBase);
}

void CheckBar(int value)
{
struct RexxMsg *bill;
LONG                  result;
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"STAT","TBAR");
result = get_reply( rob1);
printf("This is a response %d  %d\n",result,value);
}

void PlayVideo(UWORD vidchan, char *pathname,UWORD cframe) 
{
ULONG res;
UWORD Volume;

ToasterMux(0,1,1,0);

FlyVol.Path = pathname;
FlyVol.Board = 0;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STOPPED;

Action.Channel = vidchan;
Action.Flags = CAF_VIDEO;

Volume = 0xFFFF;

Action.VidStartField = cframe * 4;
Action.VidFieldCount = 4;
Action.TotalAudStart = Action.AudStartField = cframe * 4;
Action.TotalAudLength = Action.AudFieldCount = 4;

Action.VolSust1 = 0;
Action.VolSust2 = 0;
Action.AudioPan1 = 0;
Action.AudioPan2 = 0;

res = FlyerPlay(&Action);
printf("This is the knowledge we need %d\n",res);
if (res) 
   {
   printf("This is superwidget \n");
   printf("\nError %ld - %ls\n",res,Error2String(res));
   }  
}

void AppendVid(char *outpath)
{

ULONG res;
int fields = 1;

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.SCSIdrive = 0;
FlyVol.Path = outpath;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STOPPED;

Action.Channel = 0;

/* These flags are currently ignored */
Action.Flags = CAF_VIDEO;

Action.VidFieldCount = Action.AudFieldCount = fields;

Action.VolSust1 = 0xFFFF;     // Unimportant
Action.VolSust2 = 0xFFFF;     // "
Action.VidStartField = 0;     // "

res = AppendFields(&Action);
if (res) 
   {
   printf("This is superwidget \n");
   printf("\nError %ld - %ls\n",res,Error2String(res));
   }
}


LONG get_reply(ARexxContext  context)
{
   struct RexxMsg   *reply;
   unsigned long    i;
   LONG             temp_code;

   /* poll for reply */
   i=0;
      while ( ((reply = GetARexxMsg(context)) == NULL) && (++i < 1000) )
      {
         Delay(5);
      }
   
   printf("This is timeout number %d \n",i);

   if (i == 1000)
   {
      printf("timeout\n");
      /* did not get a response in a long time, just return */
      return(0);
   }
   else
   {
            if (IsARexxReply( reply) )
            { 
         temp_code = reply->rm_Result1;
         FreeARexxMsg(context, reply);
      }
      /* otherwise, don't care */
   }
   return( temp_code);
}

ARexxContext ARexxInit(char *name, char *extension, BOOL multiple)
{
struct Library *RexxSysBase;
struct MsgPort *port;
ARexxContext  context;
unsigned count;
char  *ptr;

context = AllocMem(sizeof(struct ARexxContext), MEMF_PUBLIC | MEMF_CLEAR);

if (!context)
   return(NULL);

RexxSysBase = OpenLibrary((UBYTE *) "rexxsyslib.library",0L);

if (RexxSysBase)
   {
   context->rexx_base = RexxSysBase;
   if (!extension)
      extension = "rexx";
   StrNUpper(context->extension, extension, MAX_EXTENSION);
   ptr = StrNUpper(context->port_name, name, MAX_PORT_NAME);
#ifdef RVI
   strcpy(context->error_name, context->port_name);
   strcat(context->error_name, ".LASTERROR");
#endif

   Forbid();
   if (multiple)
      {
      *ptr++='.';
      for (count = 1; count < 100; ++count)
         {
         UiToStr(count, ptr);
         port = FindPort((UBYTE *) context->port_name);
         if (!port) break;
         }
      }
   else
      {
      port = FindPort((UBYTE *) context->port_name);
      }

   if (!port)
      context->arexx_port = CreatePort ((UBYTE *) context->port_name,0);
   Permit();
   }

if (!context->rexx_base || !context->arexx_port)
   {
   ARexxFree(context);
   context = NULL;
   }

return(context);
}

void ARexxFree (ARexxContext context)
{
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context)
   return;

if (context->rexx_base)
   {
   RexxSysBase = context->rexx_base;
   context->port_name[0] = NULLCHAR;
   while (context->outstanding > 0 && context->arexx_port != NULL)
      {
      WaitPort(context->arexx_port);
      while ((msg = GetARexxMsg(context) ) != NULL)
         {
         if (!FreeARexxMsg(context, msg))
            ReplyARexxMsg(context, msg, 100, NULL, 0);
         }
      }
   if (context->arexx_port)
      {
      Forbid();
      while ((msg = GetARexxMsg(context)) != NULL)
         ReplyARexxMsg(context, msg, 100, NULL, 0);
      DeletePort(context->arexx_port);
      Permit();
      }
   CloseLibrary(RexxSysBase);
   }

FreeMem(context, sizeof(struct ARexxContext));

}

char *ArexxName(ARexxContext context)
{
if (context)
   return(context->port_name);
else
   return(NULL);
}

ULONG ARexxSignal(ARexxContext context)
{
if (context)
   return(1UL << context->arexx_port->mp_SigBit);
else
   return(0);
}

struct Library *ARexxBase(ARexxContext context)
{
if (context)
   return(context->rexx_base);
else
   return(NULL);
}

BOOL IsARexxReply( struct RexxMsg *msg)
{
if (msg)
   return( (BOOL)(msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG ));
else
   return(FALSE);
}

struct RexxMsg *GetARexxMsg(ARexxContext context)
{
struct RexxMsg *msg;

if (!context)
   return(NULL);

msg = (struct RexxMsg *) GetMsg(context->arexx_port);

if (!msg)
   return(NULL);

if (IsARexxReply(msg))
   --context->outstanding;

return(msg);
}

BOOL FreeARexxMsg(ARexxContext context, struct RexxMsg *msg)
{
struct Library *RexxSysBase;

if (!context || !msg)
   return(FALSE);

if (!IsARexxReply(msg))
   return(FALSE);

RexxSysBase = context->rexx_base;

ClearRexxMsg(msg, 16);

if (msg->rm_Result1 == 0 && msg->rm_Result2 != NULL)
   DeleteArgstring((char *) msg->rm_Result2);

DeleteRexxMsg(msg);

return(TRUE);

}

struct RexxMsg *SendARexxMsg(ARexxContext context, char *port_name,
              char *command, ULONG flags)
{
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context || !command)
   return(NULL);

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
              context->port_name);

if (!msg)
   return(NULL);

flags &= ( RXFF_NOIO | RXFF_RESULT | RXFF_STRING | RXFF_TOKEN );

msg->rm_Action = RXCOMM | flags;

msg->rm_Args[0] = (STRPTR) CreateArgstring(command, strlen(command));

msg->rm_Result1 = 0;

msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port = FindPort((UBYTE *) port_name )) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   DeleteArgstring((char *) msg->rm_Args[0]);
   DeleteRexxMsg(msg);
   msg = NULL;
   }

Permit();
return(msg);

}


struct RexxMsg *CallARexxFunc (ARexxContext context, char *port_name,
       char *function, ULONG flags, int num_args, ...)
{
va_list        argptr;
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;
BOOL   quit;
int   i;
char *arg;

if (!context || !function || num_args < 0)
   return(NULL);

if (num_args > 15)
   num_args = 15;

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
            context->port_name);

if (!msg)
   return(NULL);

flags &= (RXFF_NOIO | RXFF_RESULT | RXFF_STRING);

msg->rm_Action = RXFUNC | flags;

msg->rm_Action |= ( num_args & RXARGMASK);

msg->rm_Args[0] = (STRPTR) CreateArgstring(function, strlen(function));

msg->rm_Result1 = 0;
msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

va_start (argptr, num_args);

for (i=1, quit=FALSE; i<= num_args && !quit; ++i)
   {
   arg = (char *) va_arg(argptr, char *);

   if (!arg)
      arg = "";

   msg->rm_Args[i] = (STRPTR) CreateArgstring(arg, strlen(arg));

   if (!msg->rm_Args[i])
      quit = TRUE;

   }

va_end(argptr);

if (quit)
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port=FindPort((UBYTE *) port_name)) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   msg = NULL;
   }


Permit();

return(msg);

}


BOOL  ReplyARexxMsg( ARexxContext context,  struct RexxMsg  *msg,
                     LONG return_code,  char *result_string,
                     LONG error_code)
{

   struct Library  *RexxSysBase;

   if ( !context || !msg )
      return( FALSE );

   if ( IsARexxReply (msg) )
      return( FALSE );

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Set the results */

   msg->rm_Result1 = return_code;
   msg->rm_Result2 = (LONG) NULL;

   /* if no error and result was requested, set the result string */

   if ( result_string != NULL && return_code == RC_OK
        && (msg->rm_Action & RXFF_RESULT) != 0 )
      {
       msg->rm_Result2 = (LONG) CreateArgstring( result_string,
                                 strlen( result_string) );
      }
   else if  (return_code != RC_OK)
      {
         msg->rm_Result2 = error_code;
      }

   ReplyMsg( (struct Message *)msg );

   return(TRUE);
}



BOOL AddFuncHost (ARexxContext context,  LONG priority)
{

   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if( !context )
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Get a new message packet */

   msg = CreateRexxMsg( context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);


   msg->rm_Action = RXADDFH | RXFF_NONRET;
   msg->rm_Args[0] = (STRPTR) context->port_name;
   msg->rm_Args[1] = (STRPTR) priority;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX" ) ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg( msg );
      msg = NULL;
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}


BOOL RemFuncHost( ARexxContext context)
{
   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if (!context)
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* get a new message packet */

   msg = CreateRexxMsg (context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);

   /* tell the resident process to remove the port name to the Library
    * List... we don't expect a reply
    */

   msg->rm_Action   = RXREMLIB | RXFF_NONRET;
   msg->rm_Args[0]  = (STRPTR)  context->port_name;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX") ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg (msg);
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}




BOOL  SetARexxLastError( ARexxContext context, struct RexxMsg *msg,
                        char *error)
{

   #ifndef RVI
      return(FALSE);
   #else
      if (!context || !msg || !error)
         return(FALSE);

      if (!CheckRexxMsg (msg) )
         return(FALSE);

      return( SetRexxVar( msg, context->error_name,
                           error, strlen(error) ) == 0 )
   #endif
}




static char *StrNUpper( char *dest,  char *src,  unsigned int len)
{

   for( ; *src != NULLCHAR && len-- > 0; ++src)
   {
      if (islower (*src))
         *dest++ = toupper( *src );
      else
         *dest++ = *src;
   }

   *dest = NULLCHAR;

   return(dest);
}



static char *UiToStr( unsigned num, char *buf)
{
   num %= 100;

   buf[0] = (num / 10) + '0';
   buf[1] = (num % 10) + '0';
   buf[2] = NULLCHAR;

   return(buf);
}



