**********************************************************************
*
* Flyer.i - Flyer include file
*
* $Id: flyer.i,v 1.11 1997/03/26 16:42:24 Holt Exp $
*
* $Log: flyer.i,v $
*Revision 1.11  1997/03/26  16:42:24  Holt
**** empty log message ***
*
*Revision 1.10  1997/02/05  14:04:56  Hayes
*Added DLONG struct for 64-bit file lengths
*
*Revision 1.8  1996/11/13  15:39:05  Holt
**** empty log message ***
*
*Revision 1.6  1996/06/25  17:20:04  Holt
*made many changes to support audio envelopes
*
*Revision 1.5  1995/10/28  16:25:43  Flick
*Added 2 new SCSI errors
*
*Revision 1.4  1995/10/16  17:46:23  Flick
*Added sequence errors
*Added definitions for VideoGrade
*Added ca_Status
*Added FACOx_SENSE8 for FlyerAudioCtrl function
*
*Revision 1.3  1995/08/25  15:29:30  Flick
*Added NOFIR options for field reading/writing
*
*Revision 1.2  1995/08/11  12:39:07  Flick
*Added UserID to ClipAction structure
*
*Revision 1.1  1995/08/07  11:51:22  Flick
*Added FlyerOptions flag defines
*
*Revision 1.0  1995/05/05  15:44:21  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty		Created
**********************************************************************

	IFND	INC_FLYER_I
INC_FLYER_I	SET	1

**
**	Include file for use by Apps calling flyer.library
**
**	(c) Copyright 1994 NewTek, Inc.
**	    All Rights Reserved
**
**	Marty Flickinger
**

	IFND	EXEC_NODES_I
	INCLUDE	"exec/nodes.i"
	ENDC

	IFND	DOS_DOS_I
	INCLUDE	"dos/dos.i"
	ENDC


FLYERLIBNAME:	MACRO
		DC.B	'flyer.library',0
		DS.W	0
		ENDM


*******************************************
*** Public Return Codes for Flyer Calls ***
*******************************************

*** General Flyer Errors ***
FERR_OKAY		EQU $00	;All went well
FERR_CMDFAILED		EQU $01	;Command failed for some reason
FERR_BUSY		EQU $02	;Still in progress
FERR_ABORTED		EQU $03	;User abort
FERR_BADPARAM		EQU $04	;Bad command parameter
FERR_BADCOMMAND		EQU $05	;Command not defined/supported
FERR_BADVIDHDR		EQU $06	;Ran out of video - no header detected
FERR_WRONGMODE		EQU $07	;Wrong play/rec mode for action
FERR_OLDDATA		EQU $08	;Incompatible data
FERR_NOAUDIOCHAN	EQU $09	;No free audio channel(s)
FERR_CHANINUSE		EQU $0A	;Video/SCSI channel not available
FERR_BADFLDHAND		EQU $0B	;Bad or missing field handle
FERR_CLIPLATE		EQU $0C	;A/V clip started late
FERR_DROPPEDFLDS	EQU $0D	;Dropped 1 or more fields

*** Flyer Internal Errors ***
FERR_NOTASKS		EQU $10	;No SCSI tasks available for use
FERR_LISTCORRUPT	EQU $11	;Internal list corrupt
FERR_NOTINRANGE		EQU $12	;Internal list error
FERR_EEFAILURE		EQU $13	;EEPROM failure
FERR_NOFINDERS		EQU $14	;No FrameFinders available for use
FERR_BADMODULE		EQU $1F	;Incompatible module provided

*** FileSystem Errors ***
FERR_OBJNOTFOUND	EQU $20	;Could not find file/dir
FERR_FULL		EQU $21	;Drive full
FERR_DIRFULL		EQU $22	;Directory full
FERR_EXHAUSTED		EQU $23	;Directory list exhausted
FERR_FSFAIL		EQU $24	;FileSystem failure
FERR_WRONGTYPE		EQU $25	;Wrong type of object
FERR_UNFORMATTED	EQU $26	;Drive not high-level formatted
FERR_EXCLUDED		EQU $27	;Exclusive lock prevented action
FERR_OUTOFRANGE		EQU $28	;Seek beyond bounds
FERR_CANTEXTEND		EQU $29	;End of file, and cannot extend file
FERR_PROTECTED		EQU $2A	;Drive write-protected
FERR_DIFFERENT		EQU $2B	;Grips are different objects
FERR_EXISTS		EQU $2C	;File already exists
FERR_NOMEM		EQU $2D	;Out of storage
FERR_DELPROT		EQU $2E	;Delete-protected file
FERR_READPROT		EQU $2F	;Read-protected file
FERR_WRITEPROT		EQU $30	;Write-protected file
FERR_INUSE		EQU $31	;Disk/object in use
FERR_DIRNOTEMPTY	EQU $32	;Directory was not empty

*** SCSI Errors ***
FERR_SELTIMEOUT		EQU $40	;SCSI Time-out -- no drive
FERR_BADSTATUS		EQU $41	;Bad status after executing command
FERR_LOGBLKSIZE		EQU $42	;Cannot handle this size of logical block
FERR_INCOMPLETE		EQU $43	;SCSI transfer not completed fully

*** Sequencing Errors ***
FERR_WRONGDATATYPE	EQU $60	;Asked for improper type of data from clip
FERR_DRIVEINCAPABLE	EQU $61	;Using video clip from a non-video drive
FERR_NO_BROLLDRIVE	EQU $62	;No video B-roll drive found
FERR_HEADFAILED		EQU $63	;A/B head missing/problem

*** Amiga Library Errors ***
FERR_NOCARD		EQU $70	;Flyer card specified does not exist
FERR_LIBFAIL		EQU $71	;Library failed to pass command to Flyer
FERR_ASYNCFAIL		EQU $72	;An asynchronous command failed
FERR_VOLNOTFOUND	EQU $73	;Volume name not found
FERR_NOFREECMD		EQU $74	;Library<->Flyer RAM clogged
FERR_BADID		EQU $75	;Illegal async ID

FERR_LIMIT		EQU $7F


**********************************************
***  Mode - for use with StillMode command ***
**********************************************

MODE_FIELD	EQU	1
MODE_PAIR	EQU	2
MODE_FRAME	EQU	4


*********************************************
***  Used with the FlyerDriveInfo command ***
*********************************************

*** Structure returned from FlyerDriveInfo call ***

    STRUCTURE FlyerVolInfo,0
	UWORD	fvi_len		;Length of this structure
	ULONG	fvi_Ident	;'ROOT' for good volumes
	UBYTE	fvi_Version	;Version of FileSystem that wrote drive
	UBYTE	fvi_LTitle	;Length for L-String
	STRUCT	fvi_Title,80	;String (null-terminated)
	ULONG	fvi_Blocks	;Total user blocks
	ULONG	fvi_BlksFree	;User blocks free
	UBYTE	fvi_Flags	;FVIF_xxx - see below
	UBYTE	fvi_DiskOkay	;FileSys in good shape?
	UWORD	fvi_BlkSize	;Block size
	STRUCT	fvi_DiskDate,ds_SIZEOF
	ULONG	fvi_FragBlks	;Fragmented blocks
	ULONG	fvi_Largest	;Largest free chunk (in blocks)
	ULONG	fvi_Optimized	;Largest free chunk if optimized (in blocks)
	STRUCT	fvi_reserved,4*4
	LABEL	FVI_sizeof

*** FlyerVolInfo Flags ***
	BITDEF	FVI,VIDEOREADY,0	;Drive can handle video
	BITDEF	FVI,AUDIOREADY,1	;Drive can handle audio
	BITDEF	FVI,WRITEPROT,2		;Drive is not writable

*** Flyer Volume node structure ***

    STRUCTURE FlyVolNode,LN_SIZE
	STRUCT	fvn_Name,80		;Name of volume
	UBYTE	fvn_Board		;Flyer board number
	UBYTE	fvn_SCSIdrive		;SCSI channel/unit
	UBYTE	fvn_Flags		;From FlyerVolInfo (FVIF_xxx)
	UBYTE	fvn_pad
	LABEL	FVN_sizeof


******************************************
***  Used with the GetClipInfo command ***
******************************************

*** Structure returned from GetClipInfo call ***

    STRUCTURE ClipInfo,0
	UWORD	ci_len		;Length of this structure
	STRUCT	ci_Name,80
	STRUCT	ci_Comment,80
	UBYTE	ci_Flags	;CIF_xxxx -- see below
	UBYTE	ci_Type		;Unused -- FLYER_TYPE_xxx
	STRUCT	ci_Date,ds_SIZEOF
	ULONG	ci_Bits		;User defined
	ULONG	ci_Fields	;Length in fields
	ULONG	ci_Start	;Start block on drive
	ULONG	ci_Length	;Byte length
	ULONG	ci_IndexBlk	;Location of clip's index
	UBYTE	ci_NumAudChans	;Number of audio channels contained
	UBYTE	ci_VideoGrade	;VG_xxx below
	ULONG	ci_EndBlk	;Last blk used + 1
	ULONG	ci_LengthExt	;Extended Byte length: high 32 bits
	STRUCT	ci_reserved,22
	LABEL	CI_sizeof

*** Flyer object types ***
FLYER_TYPE_FILE		EQU	1
FLYER_TYPE_DIR		EQU	2
FLYER_TYPE_ROOT		EQU	3

*** ClipInfo Flags ***
	BITDEF	CI,HASVIDEO,0	;Clip contains video
	BITDEF	CI,HASAUDIO,1	;Clip contains audio

*** Video grade values ***
VG_STD		EQU	0	;Standard grade video
VG_HQ5		EQU	1	;HQ5 grade video
VG_HQ6		EQU	2	;HQ6 grade video


***************************************
***  Used with the GetSMPTE command ***
***************************************

*** Structure returned from GetSMPTE call ***

    STRUCTURE SMPTEinfo,0
	UBYTE	si_SMPTEvalid		;SMPTE info valid?
	UBYTE	si_SMPTEhours		;Hours
	UBYTE	si_SMPTEminutes		;Minutes
	UBYTE	si_SMPTEseconds		;Seconds
	UBYTE	si_SMPTEframes		;Frames (1/30th)
	UBYTE	si_SMPTEuser1		;BW1 and 2
	UBYTE	si_SMPTEuser2		;BW3 and 4
	UBYTE	si_SMPTEuser3		;BW5 and 6
	UBYTE	si_SMPTEuser4		;BW7 and 8
	UBYTE	si_SMPTEflags		;See SIx_xxxx below
	LABEL	SI_sizeof

*** SMPTE Flags ***
	BITDEF	SI,DROPFRAME,0	;Position is in drop-frame format
	BITDEF	SI,COLORFRAME,1	;Color Frame identification applied
	BITDEF	SI,REVERSE,2	;Time code is reverse-direction

*********************************************
***  Defines for the SetSerDevice command ***
*********************************************

SERDEVTYPE_NONE		equ	0
SERDEVTYPE_SMPTE	equ	1
SERDEVTYPE_CTRL		equ	2
SERDEVTYPE_MIDI		equ	3

SERDEV_GEN_9600		equ	1
SERDEV_HORITA		equ	10
SERDEV_TELCOM		equ	11


*** Structure used with OpenWriteField call ***

    STRUCTURE VidCompInfo,0
	UBYTE	vci_Algo	;Algorithm type
	UBYTE	vci_Tolerance	;Error tolerance
	UBYTE	vci_FIRcomp	;FIR compensation level
	UBYTE	vci_RndFreq	;Noise frequency
	UBYTE	vci_RndSeed	;Noise seed
	UBYTE	vci_Flags	;VCIx_xxx Flags
	UWORD	vci_DataSize	;Max field size in blocks
	ULONG	vci_Private1	;Internal use only
	ULONG	vci_Private2	;Internal use only
	STRUCT	vci_reserved,6
	LABEL	VCI_sizeof

ALGO_D2		EQU	1	;D2
ALGO_SN		EQU	2	;sub-nyquist

*** VidCompInfo Flags ***
	BITDEF	VCI,AUTOMODE,0	;Optimize compression on the fly

SAMPLESPERLINE	EQU	752	;Samples per active video line
TOASTERLINES	EQU	242	;Lines per active video field (Toaster)
LINESPERFIELD	EQU	243	;Lines per active video field (Full NTSC)

**********************************************************
***  Field Modes - for use with OpenWriteField command ***
**********************************************************
	BITDEF	FW,NEW,0	;Create new clip
	BITDEF	FW,APPEND,1	;Append to clip
	BITDEF	FW,REWRITE,2	;Rewrite field
	BITDEF	FW,FRAME,3	;Redo entire frame
	BITDEF	FW,HALFLINES,4	;Support full NTSC fields (+half lines)
	BITDEF	FW,NOFIR,5	;Omit FIR filtering

**********************************************************
***  Field Modes - for use with OpenReadField command ***
**********************************************************
	BITDEF	FR,HALFLINES,4	;Support full NTSC fields (+half lines)


    STRUCTURE FlyerVolume,0
	APTR	fv_Path		;Pointer to Volume:clipname string
	UBYTE	fv_Board	;Board number (0...n)
	UBYTE	fv_SCSIdrive	;SCSI unit on channel
	UBYTE	fv_Flags	;See below
	UBYTE	fv_pad
	STRUCT	fv_reserved,4*4
	LABEL	FV_sizeof


	BITDEF	FV,USENUMS,0	;Ignore volume in string, use numbers


    STRUCTURE ClipAction,0
	APTR	ca_Volume	;Ptr to FlyerVolume structure
	ULONG	ca_ID		;For asynchronous operation
	UBYTE	ca_ReturnTime	;When this call should return
	UBYTE	ca_Channel	;Video channel to use: 0, 1, or FF for choice
	UBYTE	ca_Flags	;CAF_xxxxx -- see below
	UBYTE	ca_PermissFlags	;CAPF_xxxxx -- see below
	ULONG	ca_VidStartField
	ULONG	ca_AudStartField
	ULONG	ca_VidFieldCount
	ULONG	ca_AudFieldCount
	ULONG	ca_GoClock
	UWORD	ca_MatteY	;For use with CAF_USEMATTE
	BYTE	ca_MatteI
	BYTE	ca_MatteQ
	UWORD	ca_VolAttack	;Attack time/ramp time
	UWORD	ca_VolSust1	;Channel 1 sustain volume
	UWORD	ca_VolSust2	;Channel 2 sustain volume
	UWORD	ca_VolDecay	;Decay time
	WORD	ca_AudioPan1	;Channel 1 pan (-left, 0 ctr, +right)
	WORD	ca_AudioPan2	;Channel 2 pan (-left, 0 ctr, +right)
	ULONG	ca_TotalAudStart	;Combined audio start field
	ULONG	ca_TotalAudLength	;Combined audio field count
	STRUCT	ca_reserved0,4*4
	;These block values provide a "raw" access to clip points
	ULONG	ca_StartBlk
	ULONG	ca_EndBlk
	ULONG	ca_UserID		;Caller-private ID used for sequencing errors
	STRUCT	ca_reserved1,3*4
	;These things used by the FileSystem
	ULONG	ca_Grip
	ULONG	ca_FileID
	UBYTE	ca_Access
	UBYTE	ca_pad2
	ULONG	ca_FldHandle	;Handle to open field for direct R/W
	STRUCT	ca_reserved2,3*4
	;Status communication data
	ULONG	ca_Status
	;Special return values -- Valid only when command complete
	ULONG	ca_LastFieldDone
	LABEL	CA_sizeof

*** ReturnTime values ***
RT_FREE		equ	0	;Return immediately, never follow-up
RT_IMMED	equ	1	;Return immediately
RT_STARTED	equ	2	;Return when actually started
RT_STOPPED	equ	3	;Return when action stops

*** ClipAction flags ***
	BITDEF	CA,VIDEO,0		;Include clip video
	BITDEF	CA,AUDIOL,1		;Include left audio channel
	BITDEF	CA,AUDIOR,2		;Include right audio channel
	BITDEF	CA,USEMATTE,3		;Display matte color when clip done
	BITDEF	CA,NOPREROLL,4		;Skip pre-roll
	BITDEF	CA,APPEND,5		;For single-frame appending -- NOT SUPPORTED HERE
	BITDEF	CA,REPROCESS,6		;Force clip re-processing

*** ClipAction permission flags ***
	BITDEF	CAP,STEALOURVIDEO,0	;Can steal requested video channel
	BITDEF	CAP,KILLOTHERVIDEO,1	;Can kill other video channel(s)
	BITDEF	CAP,ERRIFBUSY,2		;Return error rather than wait for it
	BITDEF	CAP,AUTOMUTE,3		;Automatically mute audio when looping
	BITDEF	CAP,USEHEADS,4		;Use A/V heads when present and needed

*** FlyerInputSel values (video source) ***
FI_Camcorder	equ	0	;Needs TBC
FI_SVHS		equ	1	;Needs TBC
FI_Toaster1	equ	2
FI_Toaster2	equ	3
FI_ToasterMain	equ	4
FI_ToasterPV	equ	5

*** FlyerInputSel values (sync source) ***
FS_ToasterMain	equ	0
FS_Toaster1	equ	1

*** Flyer Calibration values ***
CALIB_DACA_PHASE_EDGE	equ 0
CALIB_DACA_PHASE_COURSE	equ 1
CALIB_DACA_PHASE_FINE	equ 2
CALIB_DACB_PHASE_EDGE	equ 3
CALIB_DACB_PHASE_COURSE	equ 4
CALIB_DACB_PHASE_FINE	equ 5
CALIB_ADC_PHASE_EDGE	equ 6
CALIB_ADC_PHASE_COURSE	equ 7
CALIB_ADC_PHASE_FINE	equ 8
CALIB_HPLAYOFFSETA	equ 9
CALIB_HPLAYOFFSETB	equ 10
CALIB_HRECOFFSETA	equ 11
CALIB_HRECOFFSETB	equ 12
CALIB_PEDESTALA		equ 13
CALIB_PEDESTALB		equ 14


*******************************************
***  TBC control structure and defines  ***
*******************************************

    STRUCTURE TBCctrl,0
	UBYTE	tbc_Status	;Status flags
	UBYTE	tbc_Flags	;General flags
	UBYTE	tbc_DecFlags	;Decoder flags
	UBYTE	tbc_EncFlags	;Encoder flags
	UBYTE	tbc_InputSel	;Input mux control
	UBYTE	tbc_Term	;Termination control
	BYTE	tbc_Bright	;Brightness value (-64 to 63)
	UBYTE	tbc_Contrast	;Contrast value (0 to 127)
	UBYTE	tbc_Sat		;Saturation value (0 to 127)
	BYTE	tbc_Hue		;Hue value (-64 to 63)
	UWORD	tbc_Phase	;Phase adjust ($000 to $7FF)
	UWORD	tbc_HorAdj	;Horizontal adjust ($000 to $FFF)
	UBYTE	tbc_Fader	;Fader value (0 to 255)
	UBYTE	tbc_KeyerFlags	;Keyer flags
	STRUCT	tbc_reserved,38
	LABEL	TBC_sizeof

*** TBC Operations ***
	BITDEF	TBCO,STATUS,0		;Fill in status field
	BITDEF	TBCO,MODES,1		;Set modes/flags/muxes
	BITDEF	TBCO,ADJUST,2		;Set adjustment values

*** TBC Status flags ***
	BITDEF	TBCS,MODULE,0		;TBC module present
	BITDEF	TBCS,VIDEO,1		;Video present at input
	BITDEF	TBCS,STABLE,2		;Video input stable

*** TBC General flags ***
	BITDEF	TBCG,BYPASS,0		;Bypass TBC
	BITDEF	TBCG,FREEZE,1		;Freeze video

*** TBC Decoder flags ***
	BITDEF	TBCD,AGC,0		;Enable AGC
	BITDEF	TBCD,CHROMAAGC,1	;Enable chroma AGC
	BITDEF	TBCD,MONOCHROME,2	;Monochrome input

*** TBC Encoder flags ***
	BITDEF	TBCE,BARS,0		;Output 100% sat, 75% ampl bars
	BITDEF	TBCE,KILLCOLOR,1	;Disable color on output

*** TBC InputSel values ***
TBCIN_YC	equ	0	;Flyer SVHS input
TBCIN_COMP	equ	1	;Flyer Composite input
TBCIN_TMAIN	equ	2	;Toaster Main output
TBCIN_FADER	equ	3	;TBC Fader output

*** TBC Termination ***
	BITDEF	TBCT,FADERA,2		;Flyer A channel input
	BITDEF	TBCT,FADERB,3		;Flyer B channel input
	BITDEF	TBCT,OUT,4		;Video output
	BITDEF	TBCT,GENIN,5		;Genlock input
	BITDEF	TBCT,COMPIN,7		;Composite video input

*** TBC Keyer flags ***
	BITDEF	TBCK,KEYONB,0		;Src (A/B)
	BITDEF	TBCK,MODE0,1		;Keyer mode 0 bit
	BITDEF	TBCK,MODE1,2		;Keyer mode 1 bit
	BITDEF	TBCK,FADEROUT,3		;TBC/Fader mux (1 = Fader)


*** StartClipCutList flags ***
	BITDEF	CCL,DESTRUCTIVE,0	;Delete unused portions of original clip


***********************************************
*** Structure used with FlyerAudioCtrl call ***
***********************************************

    STRUCTURE FlyAudCtrl,0
	UBYTE	fac_Flags		;General flags
	UBYTE	fac_pad
	UBYTE	fac_LeftSense		;Left channel overrange detector (0 - 3)
	UBYTE	fac_RightSense		;Right channel overrange detector (0 - 3)
	UBYTE	fac_LeftSrc		;Left input source mux (see below)
	UBYTE	fac_RightSrc		;Right input source mux (see below)
	UBYTE	fac_LeftGain		;Left channel gain (0 or 1 to 16)
	UBYTE	fac_RightGain		;Right channel gain (0 or 1 to 16)
	UBYTE	fac_Aux1Mix		;Aux1 mix-in amount (-16 to 15, -128 to mute)
	UBYTE	fac_reserved1
	UBYTE	fac_Aux2Mix		;Aux2 mix-in amount (-16 to 15, -128 to mute)
	UBYTE	fac_reserved2
	STRUCT	fac_reserved,8
	LABEL	FAC_sizeof

*** Audio Ctrl Operations ***
	BITDEF	FACO,SENSE,0		;Report overrange information
	BITDEF	FACO,SETGAIN,1		;Set input gain as specified
	BITDEF	FACO,SETSRC,2		;Set input sources as specified
	BITDEF	FACO,SETMIX,3		;Set aux mixing as specified
	BITDEF	FACO,SENSE8,4		;Return 8 bit L/R readings in record mode

*** Audio Ctrl Input Sources ***
FACS_LINE1	equ	0	;RCA line-in jacks on rear of card
FACS_AUX1	equ	1	;Aux1 connector (JP19)
FACS_LINE2	equ	2	;Line2 connector (JP1)

*** FlyerOptions Non-Volatile Flags ***
	BITDEF	FLYOPT,DropFramDet,0		;Stop recording on dropped frame
	BITDEF	FLYOPT,NOT_HQ5,1		;=0 to enable HQ5



	STRUCTURE AE_KEY,0
	LONG	 AE_Time
	LONG	 AE_Durr
	WORD	 AE_Flags
	WORD	 AE_Vol1
	WORD	 AE_Vol2
	WORD	 AE_Pan1
	WORD	 AE_Pan2
	LABEL	 AE_KEY_sizeof


	STRUCTURE AEH_HEADER,0
	UWORD	 AEH_Flags
	UWORD	 AEH_KeysUsed
	LABEL	 AEH_HEADER_sizeof

	STRUCTURE DLONG,0
	ULONG	 D_high
	ULONG	 D_low
	LABEL	 DLONG_sizeof


	STRUCTURE FileHSCMD,0
	UWORD	FHSC_opcode			
	UBYTE	FHSC_cont		
	UBYTE	FHSC_error		
	UBYTE	FHSC_WFLAG		
	UBYTE	FHSC_drive		
	ULONG	FHSC_fileid		
	ULONG	FHSC_Start_Blk	
	ULONG	FHSC_Blk_Count	
	ULONG	FHSC_buff		
	LABEL	FHSCMD_sizeof		


	ENDC	; INC_FLYER_I
