	IFND	MACROS_I
MACROS_I	SET	1
********************************************************************
* Macros.i  v1.0  rev102889
* The NewTek general purpose Assembly macros.
*
* Copyright c1988 NewTek, Inc.
* Confidential and Proprietary.  All rights reserved.
* By Steve Kell for NewTek, Inc.
*
* Written for the NewTek Software Source Library, as part
* of a cooperative effort among NewTek programmers.
*
* HISTORY          NAME              DESCRIPTION
* ---------    ------------    ----------------------
* 12 Apr 88     Steve Kell	initial v1.0 completed
* 25 Aug 88	Junior		wrote XLABEL 
* 13 Nov 88	Junior		wrote XCCODE
*  3 Oct 89	Steve Kell	added MACROS_I, reverse structure stuff	
*  6 Oct 89	Steve Kell	rewrote XCCODE to handle mulidefs & CCODE flag
* 14 Oct 89	Steve Kell	fixed XSYS to work with exec/exec_lib.i etc.
* 28 Oct 89 	Steve Kell	added XMEA macro
********************************************************************

*	XREF	_intena ;necessary for ENABLE/DISABLE	
*	XREF	_custom ;necessary for ENABLE/DISABLE

* Use these "N" types when addressing data negatively, as from
*   a link pointer.

* Use standard STRUCTURE MACRO
* Use standard STRUCT MACRO, using a LABEL at the end of a bunch of "N" types.
* Use standard LABEL MACRO, put after the "N" type data it addresses.

NBOOL        MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NBYTE        MACRO
\1          EQU     SOFFSET-1
SOFFSET     SET     SOFFSET-1
     ENDM

NUBYTE       MACRO
\1          EQU     SOFFSET-1
SOFFSET     SET     SOFFSET-1
     ENDM

NWORD        MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NUWORD       MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NSHORT        MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NUSHORT      MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NLONG        MACRO
\1          EQU     SOFFSET-4
SOFFSET     SET     SOFFSET-4
     ENDM

NULONG       MACRO
\1          EQU     SOFFSET-4
SOFFSET     SET     SOFFSET-4
     ENDM

NFLOAT       MACRO
\1          EQU     SOFFSET-4
SOFFSET     SET     SOFFSET-4
     ENDM

NAPTR        MACRO
\1          EQU     SOFFSET-4
SOFFSET     SET     SOFFSET-4
     ENDM

NCPTR        MACRO
\1          EQU     SOFFSET-4
SOFFSET     SET     SOFFSET-4
     ENDM

NRPTR        MACRO
\1          EQU     SOFFSET-2
SOFFSET     SET     SOFFSET-2
     ENDM

NPLANEPTR	MACRO
\1	EQU	SOFFSET-4
SOFFSET	SET	SOFFSET-4
	ENDM
***********************************************************

XLABEL	MACRO		;NOTE it is better to do xdef at top of file! Skell
	xdef	\1
\1
	ENDM

* XCCODE used for routines which are called from C and assembly
*XCCODE	MACRO
*	xdef	\1
*	xdef	_\1
*	ENDM

*********************************************************
* XDEF code, but only xdef 'C' header if CCODE is defined
XCCODE    MACRO            ;label
          IFLE    1-NARG
            XDEF  \1
              IFD CCODE
		XDEF _\1
              ENDC
            IFLE    2-NARG
              XDEF  \2
	        IFD CCODE
		  XDEF _\2
    	        ENDC
              IFLE    3-NARG
                XDEF  \3
      	          IFD CCODE
		    XDEF _\3
          	  ENDC
                IFLE    4-NARG
                  XDEF  \4
                    IFD CCODE
		      XDEF _\4
                    ENDC
                  IFLE    5-NARG
                    XDEF  \5
                      IFD CCODE
			XDEF _\5
                      ENDC
                    IFLE    6-NARG
                      XDEF  \6
                        IFD CCODE
			  XDEF _\6
                        ENDC
                    ENDC
                  ENDC
                ENDC
              ENDC
            ENDC
          ENDC
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XCODE  macro  -  xdef fucntion
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XCODE  label,label....
*
* FUNCTION
*   Used to XDEF functions in the CODE sections.
*
* BUGS
*   Only works for up to 6 labels.
*
* SEE ALSO
*   XDATA macro
*
********************************************************************

XCODE     MACRO            ;label
          IFLE    1-NARG
            XDEF  \1
            IFLE    2-NARG
              XDEF  \2
              IFLE    3-NARG
                XDEF  \3
                IFLE    4-NARG
                  XDEF  \4
                  IFLE    5-NARG
                    XDEF  \5
                    IFLE    6-NARG
                      XDEF  \6
                    ENDC
                  ENDC
                ENDC
              ENDC
            ENDC
          ENDC
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XDATA  macro  -  xdef  data
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XDATA  label,label....
*
* FUNCTION
*   Used to XDEF data in BSS or DATA sections.
*
* BUGS
*   Only works for up to 6 labels.
*
* SEE ALSO
*   XCODE macro
*
********************************************************************

XDATA     MACRO            ;label
          IFLE    1-NARG
            XDEF  \1
            IFLE    2-NARG
              XDEF  \2
              IFLE    3-NARG
                XDEF  \3
                IFLE    4-NARG
                  XDEF  \4
                  IFLE    5-NARG
                    XDEF  \5
                    IFLE    6-NARG
                      XDEF  \6
                    ENDC
                  ENDC
                ENDC
              ENDC
            ENDC
          ENDC
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XSYS  macro   - xref _LVOlabel, jsr _LVOlabel(a6)
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XSYS  SystemFunction
*
* FUNCTION
*   Used to call an external system function.
*   Register a6 must contain a pointer to the appropriate Library.
*   The SystemFunction is an offset into this library, and is
*   defined in alib.
*
* EXAMPLE
*   XSYS  OpenScreen
*
* SEE ALSO
*   XJMP, XJSR macros
*
********************************************************************

XSYS      MACRO            ;SystemFunction
	IFND _LVO\1
          XREF      _LVO\1
	ENDC
          jsr       _LVO\1(a6)
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XJSR & XJMP macros   - xref label, jxx label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   Xxxx  label
*
* FUNCTION
*   Used to jump to or call an external routine.
*
* SEE ALSO
*   XSYS macro
*
********************************************************************

XJSR      MACRO            ;label
          XREF      \1
          jsr       \1
          ENDM

XJMP      MACRO            ;label
          XREF      \1
          jmp       \1
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XSR   macro   - xref label, bsr/jsr label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XSR  label
*
* FUNCTION
*   Used to call an external routine.  Will do a jsr if the DoJSR
*   flag is defined, else it does a bsr.  The bsr accepts a ".s"
*   size specifier.  If you are scatter loading the code, and most
*   calls are to external routines, you should define DoJSR.  If
*   you are linking using SMALLCODE, you should not define DoJSR.
*
* SEE ALSO
*   XJSR, XBSR macros
*
********************************************************************

XSR       MACRO            ;label
          XREF      \1
          IFD       DoJSR
            jsr     \1
            MEXIT
          ENDC
          IFC       '','\0'
            bsr     \1
            MEXIT
          ENDC
            bsr.\0  \1
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XBSR macro   - xref label, bsr label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XBSR  label
*
* FUNCTION
*   Used to call an external routine.  Accepts a ".s" size specifier.
*
* SEE ALSO
*   XJSR macro
*
********************************************************************

XBSR      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bsr     \1
            MEXIT
          ENDC
            bsr.\0  \1
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XBRA macro  -  xref label, bra label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XBRA  label
*
* FUNCTION
*   Used to jump to an external routine.  Accepts a ".s" size specifier.
*
* SEE ALSO
*   XJMP macro
*
********************************************************************

XBRA      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bra     \1
            MEXIT
          ENDC
            bra.\0  \1
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XBcc macros  -  xref label, bcc label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XBcc  label
*
* FUNCTION
*   Used to conditionally branch to an external routine.
*   Accepts ".s" size specifiers.
*
* SEE ALSO
*   XBRA, XBSR, XJSR, XJMP macros
*
********************************************************************

XBCC      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bcc     \1
            MEXIT
          ENDC
            bcc.\0  \1
          ENDM

;XBHS      MACRO            ;label
;          XREF      \1
;          IFC       '','\0'
;            bhs     \1
;            MEXIT
;          ENDC
;            bhs.\0  \1
;          ENDM

XBCS      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bcs     \1
            MEXIT
          ENDC
            bcs.\0  \1
          ENDM

;XBLO      MACRO            ;label
;          XREF      \1
;          IFC       '','\0'
;            blo     \1
;            MEXIT
;          ENDC
;            blo.\0  \1
;          ENDM

XBEQ      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            beq     \1
            MEXIT
          ENDC
            beq.\0  \1
          ENDM

XBGE      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bge     \1
            MEXIT
          ENDC
            bge.\0  \1
          ENDM

XBGT      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bgt     \1
            MEXIT
          ENDC
            bgt.\0  \1
          ENDM

XBHI      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bhi     \1
            MEXIT
          ENDC
            bhi.\0  \1
          ENDM

XBLE      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            ble     \1
            MEXIT
          ENDC
            ble.\0  \1
          ENDM

XBLS      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bls     \1
            MEXIT
          ENDC
            bls.\0  \1
          ENDM

XBLT      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            blt     \1
            MEXIT
          ENDC
            blt.\0  \1
          ENDM

XBMI      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bmi     \1
            MEXIT
          ENDC
            bmi.\0  \1
          ENDM

XBNE      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bne     \1
            MEXIT
          ENDC
            bne.\0  \1
          ENDM

XBPL      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bpl     \1
            MEXIT
          ENDC
            bpl.\0  \1
          ENDM

XBVC      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bvc     \1
            MEXIT
          ENDC
            bvc.\0  \1
          ENDM

XBVS      MACRO            ;label
          XREF      \1
          IFC       '','\0'
            bvs     \1
            MEXIT
          ENDC
            bvs.\0  \1
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XPOKE  macro  -  xref label,  move source,label
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XPOKE  value,label
*
* FUNCTION
*   Used to write to an external address.
*   Works with ".b", ".w", and ".l" size specifiers.
*
* EXAMPLES
*   XPOKE.l  d0,_Foo
*   XPOKE.b  #10,_Foo
*
* SEE ALSO
*   XPEEK, XPEEKA macros
*
********************************************************************

XPOKE      MACRO           ;value,label
          XREF      \2
          IFC       '','\0'
            move    \1,\2
            MEXIT
          ENDC
            move.\0 \1,\2
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XPEEK & XPEEKA macros   -  xref label, move label,dest
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XPEEKx  label,register
*
* FUNCTION
*   Used to read from an external address.  Use XPEEKA if the
*   destination is an address register.  XPEEK works with ".b",
*   ".w", and ".l" size specifiers.  XPEEKA works with ".w", and ".l" .
*
* EXAMPLES
*   XPEEK.l   _Foo,d0
*   XPEEK.w   _Foo,buffer
*   XPEEKA    _Foo,a0
*
* SEE ALSO
*   XPOKE  macro
*
********************************************************************

XPEEK      MACRO           ;label,register
          XREF      \1
          IFC       '','\0'
            move    \1,\2
            MEXIT
          ENDC
            move.\0 \1,\2
          ENDM

XPEEKA      MACRO          ;label,register
          XREF       \1
          IFC        '','\0'
            movea    \1,\2
            MEXIT
          ENDC
            movea.\0 \1,\2
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XLEA  macro - xref label, lea label,An
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XLEA  label,reg
*
* FUNCTION
*   Used to load an address register with the value of an
*   external address.
*
* SEE ALSO
*   XPEEK, XPEEKA, XPOKE macros
*
********************************************************************

XLEA      MACRO            ;label,register
          XREF      \1
            lea     \1,\2
          ENDM

********************************************************************
*                                               Apr 12 12:30 1988
* NAME
*   XMEA  macro - xref label, move.l #label,d0
*
* PATH
*   IFFroutines:inc/macros.i  v1.0
*
* SYNOPSIS
*   XMEA  label,reg
*
* FUNCTION
*   Used to load a data register with the value of an
*   external address.
*
* SEE ALSO
*   XLEA, XPEEK macros
*
********************************************************************

XMEA      MACRO            ;label,register
          XREF      \1
            move.l  #\1,\2
          ENDM

	ENDC	;MACROS_I
