*********************************************************************
* serialdebug.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: serialdebug.i,v 1.0 1995/05/08 09:39:49 Flick Exp $
*
* $Log: serialdebug.i,v $
*Revision 1.0  1995/05/08  09:39:49  Flick
*FirstCheckIn
*
*Revision 2.2  93/03/26  07:58:27  Kell
*Fixed lowercase size extensions on DUMPUDEC DUMPSDEC DUMPHEXI etc
*
*Revision 2.1  93/02/24  03:20:13  Kell
*Added DUMPUDEC, DUMPSDEC, DUMPHEXI, DUMPBITS, & DUMPELH macros.
*
*Revision 2.0  92/05/18  21:24:06  Hartford
**** empty log message ***
*
*********************************************************************
	IFND	SERIAL_DEBUG_I
SERIAL_DEBUG_I	SET	1
********************************************************************
*
* HISTORY	NAME		DESCRIPTION
* -------	-----------	-------------------------------------
* 3-15-90	Ken		Created this file
* 5-02-91	Ken		No longer needs debug.lib
* 5-02-91	Ken		Last update
* 6-20-91	SKell		Edited comments
* 6-20-91	SKell		Added DUMPSTR, DUMPMSG, DUMPTXT
* 6-20-91	SKell		Added DUMPMEM, MDUMP, DUMPHEX, HDUMP
* 6-23-91	SKell		Added DUMPNUM, ALLDUMPS
* 10-25-91	SKell		Added CDUMP & CLIDEBUG stuff
* 2-23-93	SKell		Added DUMPELH,DUMPSDEC,DUMPUDEC
* 2-23-93	SKell		Added DUMPHEXI,DUMPBINARY
*
********************************************************************
*
* ----- Macro Summary ---------
* 
* MACRO	DUMPMSG	<STRING>			;= PRINTSER
* MACRO	DUMPSTR	->STRING			;= PRINTVAR
* MACRO	DUMPTXT	<STRING\STRING\STRING\ etc>
* MACRO DUMPREG <STRING>				;requires RDUMP
* MACRO DUMPMEM <STRING>,->BLOCK,SIZE			;requires MDUMP
* MACRO DUMPHEX <STRING>,->BLOCK,SIZE			;requires HDUMP
* MACRO DUMPNUM <STRING\STRING\STRING etc.>,num		;requires DDUMP, HXDUMP, BIDUMP
* MACRO DUMPELH	<STRING>				;requires ELHDUMP
* MACRO DUMPUDEC <STRING\STRING\etc.>,num,<STRINGS>	;requires DDUMP
* MACRO DUMPSDEC <STRING\STRING\etc.>,num,<STRINGS>	;requires DDUMP
* MACRO DUMPHEXI <STRING\STRING\etc.>,num,<STRINGS>	;requires HXDUMP
* MACRO DUMPBITS <STRING\STRING\etc.>,num,<STRINGS>	;requires BIDUMP
* MACRO ALLDUMPS  ;= RDUMP, MDUMP, HDUMP, NDUMP, CDUMP, DDUMP, HXDUMP, BIDUMP, ELHDUMP

* No Macros will be included if the SERDEBUG & CLIDEBUG flags aren't defined!
* When the SERDEBUG flag is set, output will be sent to the serial port.
* When the CLIDEBUG flag is set, output will be sent to the STDIO stream.
* Both flags may be set.
* If the CLIDEBUG flag is set, you must include CDUMP in your code.
********************************************************************

	IFND _LVOSupervisor
	 INCLUDE "lib/exec_lib.i"
	ENDC

	IFND _LVOOpen
	 INCLUDE "lib/dos_lib.i"
	ENDC

;	XREF	KPutStr
;	XREF	KGetChar

*******************************************************************
* Internal Macro for use in this file only
PRINTDBCHR	MACRO
	IFD	CLIDEBUG
	 jsr	DB_CLICHAR
	ENDC
	IFD	SERDEBUG
	 jsr	-$204(a6)
	ENDC
	ENDM

*******************************************************************
* Internal Macro for use in this file only
EITHERFLAG	MACRO
EITHERDEBUG	SET	0
	IFD	SERDEBUG
EITHERDEBUG	SET	1
	ENDC
	IFD	CLIDEBUG
EITHERDEBUG	SET	1
	ENDC
	ENDM
	
*******************************************************************
* MACRO PRINTSER <STRING>
*
* Summary:
*   Used to print an immediate character sting on a serial terminal.
*   Sends 'string',cr,lf
*
* Note:
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
* Upon Exit:
*	preserved all registers
********************************************************************`
PRINTSER MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	MOVEM.L	D0-D7/A0-A6,-(SP)
	BRA.s	.LAB\@
.LAB2\@	DC.B	'\1',$0D,$0A,0
	CNOP	0,4
.LAB\@
	LEA	.LAB2\@,A0
	move.l	4,a6
.lop\@	move.b	(a0)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@
.loe\@
	MOVEM.L	(SP)+,D0-D7/A0-A6
 ENDC
	ENDM


*******************************************************************
* MACRO PRINTVAR ->STRING
*
* Summary:
*   Used to print a null terminated dc.b character sting on a serial terminal.
*   The ->STRING may be a MemLabel, MemLabel(pc), (An), d16(An), or d8(An,Xn).
*   You must supply $0D,$0A,0 if you want a CR/LF.
*
* Note:
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
* Upon Exit:
*	preserved all registers
********************************************************************`
PRINTVAR MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	MOVEM.L	D0-D7/A0-A6,-(SP)
	LEA	\1,A0

	move.l	4,a6
.lop\@	move.b	(a0)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@
.loe\@
	MOVEM.L	(SP)+,D0-D7/A0-A6
 ENDC
	ENDM

*******************************************************************
* MACRO	DUMPMSG	<STRING>
*
* Summary:
*   Same as PRINTSER.  Just a different macro name.
*******************************************************************
DUMPMSG	MACRO
	PRINTSER <\1>
	ENDM

*******************************************************************
* MACRO	DUMPSTR	->STRING
*
* Summary:
*   Same as PRINTVAR.  Just a different macro name.
*
*   The ->STRING may be a MemLabel, MemLabel(pc), (An), d16(An), or d8(An,Xn).
*******************************************************************
DUMPSTR	MACRO
	PRINTVAR \1
	ENDM

*******************************************************************
* MACRO	DUMPTXT	<STRING\STRING\STRING\ etc>
*
* Summary:
*   Similar to DUMPMSG except multiple lines can be printed.  The
*   "\" character is used to indicate CR+LF.  Remember to include
*   a "\" on the end of the last STRING if you want a final CR+LF.
*
*******************************************************************
DUMPTXT	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	MOVEM.L	D0-D7/A0-A6,-(SP)
	BRA.s	.LAB\@
.LAB2\@	DC.B	'\1',0
	CNOP	0,4

.LAB\@	LEA	.LAB2\@,A0
	move.l	4,a6
.lop\@	move.b	(a0)+,d0
	beq.s	.loe\@
	cmpi.b	#92,d0	;"\"
	bne.s	.lot\@
	move.b	#$0d,d0
	PRINTDBCHR
	move.b	#$0a,d0
.lot\@	PRINTDBCHR
	bra.s	.lop\@

.loe\@	MOVEM.L	(SP)+,D0-D7/A0-A6

 ENDC
	ENDM

*******************************************************************
* MACRO DUMPREG <STRING>
*
* Summary:
*   Used to print a contents of the registers on a serial terminal.
*   Prints the immediate string as a title above the register dump.
*   Sends 'string',cr,lf after each line.
*
* Note:
*   YOU Must also put macro RDUMP at end of code.  This is a sub called
*   by DUMPREG .
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
********************************************************************`
DUMPREG MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	PRINTSER <\1>
	JSR	DB_DUMP_REGS
	ENDC
	ENDM

*-------
RDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPREG_MACRO
DUMPREG_MACRO	SET	1

DB_DUMP_REGS
	MOVEM.L	D0-D7/A0-A6,-(SP)

	MOVEQ.L	#8-1,D0
	LEA	.LAB3\@+3,A0
	MOVE.L	SP,A1			;REGS
	LEA	.HEX\@,A2		;HEXTAB
.LP1\@
	MOVE.L	(A1)+,D1
	BSR.s	.CON\@
	DBF	D0,.LP1\@

	MOVEQ.L	#7-1,D0
	LEA	.LAB4\@+3,A0
.LP2\@
	MOVE.L	(A1)+,D1
	BSR.s	.CON\@
	DBF	D0,.LP2\@

	MOVE.L	SP,D1
	ADD.L	#16*4,D1		;SKIP OVER REGS ON STACK
	BSR.s	.CON\@

	MOVE.L	(A1)+,D1
	LEA	.LAB5\@+3,A0
	BSR.s	.CON\@

	LEA	.LAB2\@,A0
;	JSR	KPutStr

	move.l	4,a6
.lop\@	move.b	(a0)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@
.loe\@



	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS
.CON\@
	LEA	8(A0),A0

	MOVEQ.L	#8-1,D4
.CL\@	MOVE.L	D1,D2
	LSR.L	#4,D1
	AND.W	#%1111,D2
	MOVE.B	0(A2,D2.W),-(A0)
	DBF	D4,.CL\@

	LEA	9(A0),A0

	RTS
.HEX\@	DC.B	'0123456789ABCDEF'
.LAB2\@	DC.B	'      0        1        2        3        4        5        6        7',$0D,$0A
.LAB3\@	DC.B	'D: 00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000',$0D,$0A
.LAB4\@	DC.B	'A: 00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000',$0D,$0A
.LAB5\@	DC.B	'P: 00000000 ',$0D,$0A,$0D,$0A,0
	CNOP	0,4

	ENDC
	ENDC
	ENDM 				;RDUMP

*******************************************************************
* MACRO DUMPMEM <STRING>,->BLOCK,SIZE
*
*
* Summary:
*   Used to print a contents of a memory block on a serial terminal.
*   The Memory Offset, Absolute Address, memory in HEX and memory in
*   ASCII are display.  It prints info on 16 bytes per output row.
*   Prints the immediate string as a title above the memory dump.
*   The ->BLOCK may be a MemLabel, MemLabel(pc), (An), d16(An), or d8(An,Xn).
*   The SIZE may be #Immediate, or Dn .
*
*   Sends cr,lf after each line.
*
* Note:
*   YOU Must also put macro MDUMP at end of code.  This is a sub called
*   by DUMPMEM .
*
*   On immediate sizes, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
********************************************************************`
DUMPMEM MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	PRINTSER <\1>

	movem.l	d0/a0,-(sp)
	lea	\2,a0
	move.l	\3,d0
	JSR	DB_DUMP_MEMB
	movem.l	(sp)+,d0/a0

	ENDC
	ENDM

*-------
MDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPMEM_MACRO
DUMPMEM_MACRO	SET	1

* a0->block, d0=size
DB_DUMP_MEMB
	MOVEM.L	D0-D7/A0-A6,-(SP)

	addi.l	#15,d0	;round up
	lsr.l	#4,d0	;16 bytes per row

	moveq	#0,d2	;offset counter

	LEA	.HEX\@,A2		;HEXLUT

	bra.s	.b100\@

* d0 = # of rows
.b10\@	lea	.LAB1\@,a1
	move.l	d2,d1
	BSR.s	.CON\@	;offset
	
	addq.w	#1,a1
	move.l	a0,d1
	BSR.s	.CON\@	;address
	
	addq.w	#2,a1
	moveq	#4-1,d3
	
.b20\@	move.b	(a0)+,d1	;might not be word aligned
	lsl.w	#8,d1
	move.b	(a0)+,d1
	swap	d1
	move.b	(a0)+,d1
	lsl.w	#8,d1
	move.b	(a0)+,d1

	BSR.s	.CON\@	;print hex

	dbra	d3,.b20\@

;----
	lea	-16(a0),a0

	addq.w	#1,a1
	moveq	#16-1,d3

.b30\@	move.b	(a0)+,d1
	cmpi.b  #' ',d1
	bcc.s	.b50\@	;jump if >= 32
.b40\@	move.b	#'.',d1	;non-displayable ASCII = 0-31, 127-255
	bra.s	.b60\@
.b50\@	cmpi.b	#127,d1
	bcc.s	.b40\@	;jump if >= 127

.b60\@	move.b	d1,(a1)+
	dbra	d3,.b30\@


	movem.l	d0/a0,-(sp)	;I think a0 is ok though
	LEA	.LAB1\@,A1		;buff
	move.l	4,a6
.lop\@	move.b	(a1)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@
.loe\@ 	movem.l	(sp)+,d0/a0

	add.l	#16,d2

.b100\@	dbra	d0,.b10\@

	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

*-----------
* d1 = LONG that is to be put into the print buffer, at a1
* a2->Hex LUT
.CON\@
	LEA	8(a1),a1	;LONG = 4 bytes = 8 nibbles = 8 Ascii Chars

	MOVEQ.L	#8-1,D4
.CL\@	MOVE.L	D1,D5
	LSR.L	#4,D1
	AND.W	#%1111,D5
	MOVE.B	0(A2,D5.W),-(a1)
	DBF	D4,.CL\@

	LEA	9(a1),a1

	RTS
*-----------

.HEX\@	DC.B	'0123456789ABCDEF'
.LAB1\@	DC.B	'00000000: 00000000:  00000000 00000000 00000000 00000000  ................',$0D,$0A,0
	CNOP	0,4

	ENDC
	ENDC
	ENDM 				;MDUMP

*******************************************************************
* MACRO DUMPHEX <STRING>,->BLOCK,SIZE
*
*
* Summary:
*   Used to print a contents of a memory block on a serial terminal.
*   Prints the immediate string as a title above the memory dump.
*   The ->BLOCK may be a MemLabel, MemLabel(pc), (An), d16(An), or d8(An,Xn).
*   The SIZE may be #Immediate, or Dn .
*   This is similar to DUMPMEM except absolute addresses and ASCII are omited.
*   This prints info at 32 bytes per output row.
*   Sends cr,lf after each line.
*
* Note:
*   YOU Must also put macro HDUMP at end of code.  This is a sub called
*   by DUMPHEX .
*
*   On immediate sizes, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
* NOTE: This could have used the DUMPUDEC & DUMPHEXI macros the make this
* one shorter.  Oh well.
*
* Upon Exit:
*	preserved all registers
********************************************************************`
DUMPHEX MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	PRINTSER <\1>

	movem.l	d0/a0,-(sp)
	lea	\2,a0
	move.l	\3,d0
	JSR	DB_DUMP_MEMH
	movem.l	(sp)+,d0/a0

	ENDC
	ENDM

*-------
HDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPHEX_MACRO
DUMPHEX_MACRO	SET	1

* a0->block, d0=size
DB_DUMP_MEMH
	MOVEM.L	D0-D7/A0-A6,-(SP)

	addi.l	#31,d0	;round up
	lsr.l	#5,d0	;32 bytes per row

	moveq	#0,d2	;offset counter

	LEA	.HEX\@,A2		;HEXLUT

	bra.s	.b100\@

* d0 = # of rows
.b10\@	lea	.LAB1\@,a1
	move.l	d2,d1
	moveq	#5,d6
	BSR.s	.CON\@	;offset
	
	moveq	#8,d6
	moveq	#1,d7
.b15\a	addq.w	#1,a1
	moveq	#4-1,d3
	
.b20\@	move.b	(a0)+,d1	;might not be word aligned
	lsl.w	#8,d1
	move.b	(a0)+,d1
	swap	d1
	move.b	(a0)+,d1
	lsl.w	#8,d1
	move.b	(a0)+,d1

	BSR.s	.CON\@	;print hex

	dbra	d3,.b20\@

	dbra	d7,.b15\a
;----

	movem.l	d0/a0,-(sp)	;I think a0 is ok though
	LEA	.LAB1\@,A1		;buff
	move.l	4,a6
.lop\@	move.b	(a1)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@
.loe\@	movem.l	(sp)+,d0/a0

	add.l	#32,d2

.b100\@	dbra	d0,.b10\@

	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

*-----------
* d1 = LONG that is to be put into the print buffer, at a1
* a2->Hex LUT, d6=# of ASCII bytes
.CON\@
	LEA	0(a1,d6.w),a1	;LONG = 4 bytes = 8 nibbles = 8 Ascii Chars
	
	move.w	d6,d4
	subq.w	#1,d4
.CL\@	MOVE.L	D1,D5
	LSR.L	#4,D1
	AND.W	#%1111,D5
	MOVE.B	0(A2,D5.W),-(a1)
	DBF	D4,.CL\@

	LEA	1(a1,d6.w),a1

	RTS
*-----------

.HEX\@	DC.B	'0123456789ABCDEF'
.LAB1\@	DC.B	'00000: 01234567 01234567 01234567 01234567  01234567 01234567 01234567 01234567',$0D,$0A,0    
	CNOP	0,4

	ENDC
	ENDC
	ENDM 				;MDUMP

*******************************************************************
* MACRO DUMPNUM <STRING\STRING\STRING etc.>,num
*
*
* Summary:
*   Used to print LONG in DECIMAL, HEX, and BINARY on a serial terminal.
*   Prints the immediate string as a title(s).  The title will be on the
*   same line as the numeric results, unless you include the CR/LF
*   characture "\" in the STRING.
*   The num maybe addressed by a MemLabel, MemLabel(pc), (An), d16(An), or
*   d8(An,Xn).  Or a register Dn, or #Immediate.
*   Sends cr,lf after the numbers.
*
* Note:
*   You must also put macros DDUMP, HXDUMP, & BIDUMP at end of code.
*  These are subs called by DUMPNUM .
*
*   On immediate nums, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
*
********************************************************************

DUMPNUM MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG
	
	DUMPTXT <\1>
	DUMPSDEC.L <= >,\2,<>
	DUMPHEXI.L < >,\2,<>
	DUMPBITS.L < >,\2,<\\>

	ENDC
	ENDM

*******************************************************************
* MACRO ASKWAK
*
* Summary:
*	prompts user to press "d" to enter ROMWAK, or any key to continue
*	program execution
*
* Note:
*   You must also link with the debug.lib and define a flag SERDEBUG or CLIDEBUG
*   for this to work?????
*
* Bugs:
*	If aux: or ser: is using serial port, those devices will not
*	be able to read data properly from the keyboard after this macro
*	is executed
*
* Upon Exit:
*	preserved all registers
********************************************************************`
ASKWAK	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	

	MOVEM.L	D0-D7/A0-A6,-(sp)

	PRINTSER <PUSH D TO DEBUG SPACE TO CONTINUE.>
	move.l	4,a6
.wdk\@	JSR	-510(a6)		;rawmaygetchar
	tst.l	d0
	bmi	.wdk\@

	cmp.b	#'d',d0
	bne.s	.nd\@

	JSR	-$72(a6)
.nd\@	MOVEM.L	(SP)+,D0-D7/A0-A6
	ENDC
	ENDM

**********************************************************************
* Put a character from D0 into the STDIO stream
CDUMP	MACRO
	IFD	CLIDEBUG
	IFND	DUMPCLI_MACRO
DUMPCLI_MACRO	SET	1

DB_CLICHAR:
	movem.l	d0-d3/a0-a1/a6,-(sp)
	move.w	d0,d3
.dbcc0	move.l	DB_STDOUT(pc),d1
	bne.s	.dbcc1

* Open DOS, and get STDOUT
	lea	DB_DOS(pc),a0
	tst.l	(a0)
	bne.s	.dbcc2		;jmp if already failed once
	move.w	#-1,(a0)	;assume failure
	lea	.libname(pc),a1
	moveq	#0,d0	
	movea.l	4,a6	;(4).w,a6
	jsr	_LVOOpenLibrary(a6)
	tst.l	d0
	beq.s	.dbcc2	;jump if fail
	lea	DB_DOS(pc),a0
	move.l	d0,(a0)
	move.l	d0,a6	
	jsr	_LVOOutput(a6)
	lea	DB_STDOUT(pc),a0
	move.l	d0,(a0)
	move.l	a6,a1
	movea.l	4,a6	;(4).w,a6
	jsr	_LVOCloseLibrary(a6)
	bra.s	.dbcc0

.dbcc1	movea.l	DB_DOS(pc),a6
	move.w	d3,-(sp)
	move.l	sp,d2
	addq.l	#1,d2
	moveq	#1,d3
	jsr	_LVOWrite(a6)
	addq.w	#2,sp
.dbcc2	movem.l	(sp)+,d0-d3/a0-a1/a6
	rts

.libname	dc.b	'dos.library',0
		CNOP	0,4
DB_STDOUT	dc.l	0
DB_DOS		dc.l	0	;must follow DB_STDIN

	ENDC
	ENDC
	ENDM 				;CDUMP

*******************************************************************
* MACRO DUMPUDEC <STRING\STRING etc.>,num,<STRING\STRING etc>
*
*
* Summary:
*   Used to print a UBYTE, UWORDS or ULONG in DECIMAL on a serial terminal.
*   Prints the first immediate string as a title(s)1.  The title will be on the
*   same line as the numeric results, unless you include the CR/LF
*   characture "\" in the STRINGS.
*   The num maybe addressed by a MemLabel, MemLabel(pc), (An), d16(An), or
*   d8(An,Xn).  Or a register Dn, or #Immediate.
*   The second immediate string is optional. If you want a cr,lf after the
*   number, you must include a "\" characture in the second set of strings.
*
* Note:
*   YOU Must also put macro DDUMP at end of code.  This is a sub called
*   by DUMPUDEC .
*
*   On immediate nums, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
*
********************************************************************
DUMPUDEC MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	DUMPTXT <\1>

	movem.l	d0/d5/d6,-(sp)

        IFC	'','\0'
        move.l	\2,d0
	moveq	#0,d5
        ENDC
	IFC      'B','\0'        
    	move.b	\2,d0
	andi.l	#$ff,d0
	moveq	#28,d5
	ENDC
	IFC      'W','\0'
    	move.w	\2,d0
	andi.l	#$ffff,d0
	moveq	#20,d5
	ENDC
	IFC      'L','\0'        
    	move.l	\2,d0
	moveq	#0,d5
	ENDC
	IFC      'b','\0'        
    	move.b	\2,d0
	andi.l	#$ff,d0
	moveq	#28,d5
	ENDC
	IFC      'w','\0'
    	move.w	\2,d0
	andi.l	#$ffff,d0
	moveq	#20,d5
	ENDC
	IFC      'l','\0'        
    	move.l	\2,d0
	moveq	#0,d5
	ENDC
	
	moveq	#-1,d6		;no sign
	JSR	DB_DUMP_DEC
	movem.l	(sp)+,d0/d5/d6

	DUMPTXT	<\3>

	ENDC
	ENDM

*******************************************************************
* MACRO DUMPSDEC <STRING\STRING etc.>,num,<STRING\STRING etc>
*
*
* Summary:
*   Used to print a SIGNED BYTE, WORD or LONG in DECIMAL on a serial terminal.
*   Prints the first immediate string as a title(s)1.  The title will be on the
*   same line as the numeric results, unless you include the CR/LF
*   characture "\" in the STRINGS.
*   The num maybe addressed by a MemLabel, MemLabel(pc), (An), d16(An), or
*   d8(An,Xn).  Or a register Dn, or #Immediate.
*   The second immediate string is optional. If you want a cr,lf after the
*   number, you must include a "\" characture in the second set of strings.
*
* Note:
*   YOU Must also put macro DDUMP at end of code.  This is a sub called
*   by DUMPSDEC .
*
*   On immediate nums, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
*
********************************************************************
DUMPSDEC MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	DUMPTXT <\1>

	movem.l	d0/d5/d6,-(sp)
	moveq	#0,d6

        IFC	'','\0'
        move.l	\2,d0
	moveq	#0,d5
	tst.l	d0
        ENDC
	IFC      'B','\0'        
    	move.b	  \2,d0
	moveq	#28,d5
	ext.w	d0
	ext.l	d0
	ENDC
	IFC      'W','\0'        
    	move.w	  \2,d0
	moveq	#20,d5
	ext.l	d0
	ENDC
	IFC      'L','\0'        
    	move.l	  \2,d0
	moveq	#0,d5
	tst.l	d0
	ENDC
	IFC      'b','\0'        
    	move.b	  \2,d0
	moveq	#28,d5
	ext.w	d0
	ext.l	d0
	ENDC
	IFC      'w','\0'        
    	move.w	  \2,d0
	moveq	#20,d5
	ext.l	d0
	ENDC
	IFC      'l','\0'        
    	move.l	  \2,d0
	moveq	#0,d5
	tst.l	d0
	ENDC
		
	bpl.s	.pos\@
	neg.l	d0
	moveq	#1,d6		;sign flag
.pos\@	JSR	DB_DUMP_DEC
	movem.l	(sp)+,d0/d5/d6

	DUMPTXT	<\3>

	ENDC
	ENDM

*--------------------------------------
DDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPDEC_MACRO
DUMPDEC_MACRO	SET	1

* d0=num
DB_DUMP_DEC
	MOVEM.L	D0-D7/A0-A6,-(SP)

	lea	.LAB1\@,a0
	tst.w	d6
	bmi.s	.b10\@

	move.b	#'+',(a0)+
	tst.w	d6
	beq.s	.b10\@
	move.b	#'-',-1(a0)

.b10\@	lea	.div\@,a1
	adda.w	d5,a1
.b12\@	move.l	(a1)+,d2
	beq.s	.b20\@
	move.b	#'0'-1,d3
.b15\@	addq.w	#1,d3
	sub.l	d2,d0
	bpl.s	.b15\@
	add.l	d2,d0
	move.b	d3,(a0)+
	bra.s	.b12\@

.b20\@	move.b	#0,(a0)

	LEA	.LAB1\@,A1		;buff
	move.l	4,a6
.lop\@	move.b	(a1)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@

.loe\@	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

*-----------

.div\@	dc.l	1000000000	;ULONG	= 0
	dc.l	100000000
	dc.l	10000000
	dc.l	1000000
	dc.l	100000
	dc.l	10000		;UWORD = 5*4 = 20
	dc.l	1000
	dc.l	100		;UBYTE = 7*4 = 28
	dc.l	10
	dc.l	1
	dc.l	0

.LAB1\@	DC.B	'-1234567890',0
	CNOP	0,4

	ENDC
	ENDC
	ENDM	;DDUMP


*******************************************************************
* MACRO DUMPHEXI <STRING\STRING etc.>,num,<STRING\STRING etc>
*
*
* Summary:
*   Used to print a BYTE, WORD or LONG in HEXIDECIMAL on a serial terminal.
*   Prints the first immediate string as a title(s)1.  The title will be on the
*   same line as the numeric results, unless you include the CR/LF
*   characture "\" in the STRINGS.
*   The num maybe addressed by a MemLabel, MemLabel(pc), (An), d16(An), or
*   d8(An,Xn).  Or a register Dn, or #Immediate.
*   The second immediate string is optional. If you want a cr,lf after the
*   number, you must include a "\" characture in the second set of strings.
*
* Note:
*   YOU Must also put macro HXDUMP at end of code.  This is a sub called
*   by DUMPHEXI .
*
*   On immediate nums, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
*
********************************************************************
DUMPHEXI MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	DUMPTXT <\1>

	movem.l	d0/d2,-(sp)

        IFC	'','\0'
        move.l	\2,d0
	moveq	#7,d2
        ENDC
	IFC      'B','\0'        
    	move.b	\2,d0
	moveq	#1,d2
	ENDC
	IFC      'W','\0'        
    	move.w	\2,d0
	moveq	#3,d2
	ENDC
	IFC      'L','\0'        
    	move.l	\2,d0
	moveq	#7,d2
	ENDC
	IFC      'b','\0'        
    	move.b	\2,d0
	moveq	#1,d2
	ENDC
	IFC      'w','\0'        
    	move.w	\2,d0
	moveq	#3,d2
	ENDC
	IFC      'l','\0'        
    	move.l	\2,d0
	moveq	#7,d2
	ENDC
	
	JSR	DB_DUMP_HEXI
	movem.l	(sp)+,d0/d2

	DUMPTXT	<\3>

	ENDC
	ENDM

*--------------------------------------
HXDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPHEXI_MACRO
DUMPHEXI_MACRO	SET	1

* d0=num
DB_DUMP_HEXI
	MOVEM.L	D0-D7/A0-A6,-(SP)

	LEA	.LAB1\@+2,a0
	adda.w	d2,a0
	move.b	#0,(a0)
	LEA	.HEX\@,A1		;HEXLUT
.CL\@	MOVE.L	d0,D3
	LSR.L	#4,d0
	AND.W	#%1111,D3
	MOVE.B	0(A1,D3.W),-(a0)
	DBF	D2,.CL\@
	
	LEA	.LAB1\@,A1		;buff
	move.l	4,a6
.lop\@	move.b	(a1)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@

.loe\@	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

.HEX\@	DC.B	'0123456789ABCDEF'
.LAB1\@	DC.B	'$0123FEDC',0
	CNOP	0,4

	ENDC
	ENDC
	ENDM 				;HXDUMP


*******************************************************************
* MACRO DUMPBITS <STRING\STRING etc.>,num,<STRING\STRING etc>
*
*
* Summary:
*   Used to print a BYTE, WORD or LONG in BINARY on a serial terminal.
*   Prints the first immediate string as a title(s)1.  The title will be
*   on the same line as the numeric results, unless you include the CR/LF
*   characture "\" in the STRINGS.
*   The num maybe addressed by a MemLabel, MemLabel(pc), (An), d16(An), or
*   d8(An,Xn).  Or a register Dn, or #Immediate.
*   The second immediate string is optional. If you want a cr,lf after the
*   number, you must include a "\" characture in the second set of strings.
*
* Note:
*   YOU Must also put macro BIDUMP at end of code.  This is a sub called
*   by DUMPBITS .
*
*   On immediate nums, don't forget the # symbol!!!
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
*
* Upon Exit:
*	preserved all registers
*
********************************************************************
DUMPBITS MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	DUMPTXT <\1>

	movem.l	d0-d2/d5,-(sp)

        IFC	'','\0'
        move.l	\2,d0
	moveq	#41,d1
	moveq	#2-1,d2
	moveq	#4-1,d5
        ENDC
	IFC      'B','\0'        
    	move.b	\2,d0
	ror.l	#8,d0
	moveq	#10,d1
	moveq	#1-1,d2
	moveq	#2-1,d5
	ENDC
	IFC      'W','\0'        
    	move.w	\2,d0
	swap	d0
	moveq	#20,d1
	moveq	#1-1,d2
	moveq	#4-1,d5
	ENDC
	IFC      'L','\0'        
    	move.l	\2,d0
	moveq	#41,d1
	moveq	#2-1,d2
	moveq	#4-1,d5
	ENDC
	IFC      'b','\0'        
    	move.b	\2,d0
	ror.l	#8,d0
	moveq	#10,d1
	moveq	#1-1,d2
	moveq	#2-1,d5
	ENDC
	IFC      'w','\0'        
    	move.w	\2,d0
	swap	d0
	moveq	#20,d1
	moveq	#1-1,d2
	moveq	#4-1,d5
	ENDC
	IFC      'l','\0'        
    	move.l	\2,d0
	moveq	#41,d1
	moveq	#2-1,d2
	moveq	#4-1,d5
	ENDC
	
	JSR	DB_DUMP_BITS
	movem.l	(sp)+,d0-d2/d5

	DUMPTXT	<\3>

	ENDC
	ENDM

*--------------------------------------
BIDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPBITS_MACRO
DUMPBITS_MACRO	SET	1

* d0=num
DB_DUMP_BITS
	MOVEM.L	D0-D7/A0-A6,-(SP)

	lea	.LAB1\@+1,a0
	
.a2\@	move.w	d5,d4	;4 nibbles/word
.a3\@	moveq	#4-1,d3	;4 bits/nibble
.a5\@	add.l	d0,d0
	bcc.s	.a10\@
	move.b	#'1',(a0)+
	bra.s	.a20\@
.a10\@	move.b	#'0',(a0)+
.a20\@	dbra	d3,.a5\@
	move.b	#' ',(a0)+
	dbra	d4,.a3\@
	move.b	#' ',(a0)+
	dbra	d2,.a2\@ ;number of words

	LEA	.LAB1\@,A1		;buff
	move.b	#0,0(a1,d1.w)
	move.l	4,a6
.lop\@	move.b	(a1)+,d0
	beq.s	.loe\@
	PRINTDBCHR
	bra.s	.lop\@

.loe\@	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

.LAB1\@	DC.B	'%1111 0000 1100 0011  1010 0101 1001 0110',0
	CNOP	0,4

	ENDC
	ENDC
	ENDM 				;BIDUMP

**********************************************************************
DUMPELH	MACRO		;a5->ToastBase
	EITHERFLAG
 IFNE	EITHERDEBUG	
	DUMPMSG <\1>
	JSR	DB_DUMP_ELH
	ENDC
	ENDM

*--------------
ELHDUMP	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	
	IFND	DUMPELH_MACRO
DUMPELH_MACRO	SET	1

DB_DUMP_ELH
	MOVEM.L	D0-D7/A0-A6,-(SP)

	lea	TB_VTSetUp(a5),a0

	moveq	#0,d0
	ELHTEST_NOPAIRS	a0
	beq.s	.elh1\@
	moveq	#1,d0
.elh1\@ DUMPUDEC.B <NOPAIRS=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LUST	a0
	beq.s	.elh2\@
	moveq	#1,d0
.elh2\@ DUMPUDEC.B <LUST=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LKNOT	a0
	beq.s	.elh3\@
	moveq	#1,d0
.elh3\@ DUMPUDEC.B <LKNOT=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_BRIDGE	a0
	beq.s	.elh4\@
	moveq	#1,d0
.elh4\@ DUMPUDEC.B <BRIDGE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LUT	a0
	beq.s	.elh5\@
	moveq	#1,d0
.elh5\@ DUMPUDEC.B <LUT=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_SA	a0
	beq.s	.elh6\@
	moveq	#1,d0
.elh6\@ DUMPUDEC.B <SA=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LKEC	a0
	beq.s	.elh7\@
	moveq	#1,d0
.elh7\@ DUMPUDEC.B <LKEC=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LINP	a0
	beq.s	.elh8\@
	moveq	#1,d0
.elh8\@ DUMPUDEC.B <LINP=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_ABSE	a0
	beq.s	.elh9\@
	moveq	#1,d0
.elh9\@ DUMPUDEC.B <ABSE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_WERB	a0
	beq.s	.elh10\@
	moveq	#1,d0
.elh10\@ DUMPUDEC.B <WERB=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_LINR	a0
	beq.s	.elh11\@
	moveq	#1,d0
.elh11\@ DUMPUDEC.B <LINR=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_AFR	a0
	beq.s	.elh12\@
	moveq	#1,d0
.elh12\@ DUMPUDEC.B <AFR=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_AFP	a0
	beq.s	.elh13\@
	moveq	#1,d0
.elh13\@ DUMPUDEC.B <AFP=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_OBR	a0
	beq.s	.elh14\@
	moveq	#1,d0
.elh14\@ DUMPUDEC.B <OBR=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_TERM1	a0
	beq.s	.elh15\@
	moveq	#1,d0
.elh15\@ DUMPUDEC.B <TERM1=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_TERM2	a0
	beq.s	.elh16\@
	moveq	#1,d0
.elh16\@ DUMPUDEC.B <TERM2=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_TERM3	a0
	beq.s	.elh17\@
	moveq	#1,d0
.elh17\@ DUMPUDEC.B <TERM3=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_TERM4	a0
	beq.s	.elh18\@
	moveq	#1,d0
.elh18\@ DUMPUDEC.B <TERM4=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_USERON	a0
	beq.s	.elh19\@
	moveq	#1,d0
.elh19\@ DUMPUDEC.B <USERON=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_MATTE	a0
	beq.s	.elh20\@
	moveq	#1,d0
.elh20\@ DUMPUDEC.B <MATTE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_BMWIPE	a0
	beq.s	.elh21\@
	moveq	#1,d0
.elh21\@ DUMPUDEC.B <BMWIPE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_ISWIPE	a0
	beq.s	.elh22\@
	moveq	#1,d0
.elh22\@ DUMPUDEC.B <ISWIPE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_AMWIPE	a0
	beq.s	.elh23\@
	moveq	#1,d0
.elh23\@ DUMPUDEC.B <AMWIPE=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_NOSNOW	a0
	beq.s	.elh24\@
	moveq	#1,d0
.elh24\@ DUMPUDEC.B <NOSNOW=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_NOLOCK	a0
	beq.s	.elh25\@
	moveq	#1,d0
.elh25\@ DUMPUDEC.B <NOLOCK=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_NOKEYSHIFT	a0
	beq.s	.elh26\@
	moveq	#1,d0
.elh26\@ DUMPUDEC.B <NOKEYSHIFT=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_NOKEYINVERT	a0
	beq.s	.elh27\@
	moveq	#1,d0
.elh27\@ DUMPUDEC.B <NOKEYINVERT=>,d0,<\\>

	moveq	#0,d0
	ELHTEST_PVMUTE	a0
	beq.s	.elh28\@
	moveq	#1,d0
.elh28\@ DUMPUDEC.B <PVMUTE=>,d0,<\\>

	ELHGET_TERM	a0,d0
	andi.l	#$ff,d0
	DUMPBITS.B <TERM=>,d0,<\\>

	ELHGET_PV	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <PV=>,d0,<\\>

	ELHGET_LK	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <LK=>,d0,<\\>

	ELHGET_BM	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <BM=>,d0,<\\>

	ELHGET_IS	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <IS=>,d0,<\\>

	ELHGET_AM	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <AM=>,d0,<\\>

	ELHGET_MB	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <MB=>,d0,<\\>

	ELHGET_MA	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <MA=>,d0,<\\>

	ELHGET_MP	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <MP=>,d0,<\\>

	ELHGET_CDS	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <CDS=>,d0,<\\>

	ELHGET_CD	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <CD=>,d0,<\\>

	ELHGET_DP	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <DP=>,d0,<\\>

	ELHGET_EP	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <EP=>,d0,<\\>

	ELHGET_LKA	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <LKA=>,d0,<\\>

	ELHGET_LKB	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <LKB=>,d0,<\\>

	ELHGET_PED	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <PED=>,d0,<\\>

	ELHGET_GAIN	a0,d0
	andi.l	#$ff,d0
	DUMPUDEC.B <GAIN=>,d0,<\\>

	MOVEM.L	(SP)+,D0-D7/A0-A6
	RTS

	ENDC	;IFND DUMPELH_MACRO
	ENDC	;IFNE EITHERDEBUG
	ENDM 	;ELHDUMP

*******************************************************************
* MACRO ALLDUMPS
*
* Summary:
*	Place this macro at the end of your program if you are using
*	most of the DUMPing macros.  If this MACRO is included, you
*	don't need to, and shouldn't include either of RDUMP, MDUMP,
*	HDUMP, etc.
*
*   SERDEBUG or CLIDEBUG must be defined in order for this macro to be included.
*
* Upon Exit:
*	preserved all registers
********************************************************************`
ALLDUMPS	MACRO
	EITHERFLAG
 IFNE	EITHERDEBUG	

	RDUMP
	MDUMP
	HDUMP
	CDUMP
	DDUMP
	HXDUMP
	BIDUMP
	ELHDUMP
	
	ENDC	;EITHERDEBUG
	ENDM

**********************************************************************
* end of SerialDebug.i
	ENDC	;SERIAL_DEBUG_I


