/********************************************************************
* $AccessWindow.c$
* $Id: AccessWindow.c,v 2.29 1995/10/09 16:40:00 Flick Exp $
* $Log: AccessWindow.c,v $
*Revision 2.29  1995/10/09  16:40:00  Flick
*Removed unnecessary usage of popup.h
*
*Revision 2.28  1995/10/03  14:31:22  Flick
*Current & Project times now use non-prop font, moved a bit to make room
*Now reads --:--:--:-- when project fails to play (was ??:??:??:??)
*
*Revision 2.27  1995/09/28  10:01:52  Flick
*Now uses RawKeyCodes.h
*
*Revision 2.26  1995/08/31  16:13:17  Flick
*Reworded access window items to Current & Project (& moved slightly)
*
*Revision 2.25  1995/08/18  16:54:54  Flick
*Reworked rendering routines to share window better, be more adjustable
*New functions for setting/displaying current time & running time length
*Now honors EditingLive flag which locks accesswindow from others during
*
*Revision 2.24  1994/11/09  19:21:25  pfrench
*Now better behaved when using new grid object
*
*Revision 2.23  1994/11/04  03:43:23  pfrench
*Changed mask to 3 bitplanes deep, where before it was eight
*This should speed up rendering quite a bit.
*
*Revision 2.22  1994/10/20  10:25:13  CACHELIN4000
*Fix AccessWindowGetsMessage() for keystrokes from HandleKey()
*
*Revision 2.21  94/10/12  20:40:32  CACHELIN4000
*Add clever hidden path-finder to access window
*
*Revision 2.20  94/09/27  18:57:20  pfrench
*Fixed clearing problem if the filename became much shorter
*
*Revision 2.19  1994/09/27  16:22:10  pfrench
*AccessWindow being re-used for crouton name display
*
*Revision 2.18  1994/09/23  20:07:35  pfrench
*Moved loadslice to main event loop
*
*Revision 2.17  1994/09/22  14:08:30  pfrench
*Now mark slices that are loaded with an asterisk
*
*Revision 2.16  1994/09/21  21:33:15  pfrench
*Using new FlushWindowPort call
*
*Revision 2.15  1994/09/14  19:36:24  pfrench
*Now uses proportional fonts for gadgets.
*
*Revision 2.14  1994/09/14  01:24:33  pfrench
*Repeated latest sends to switcher
*
*Revision 2.13  1994/09/14  00:48:45  pfrench
*Sending load and select commands on app popup.
*
*Revision 2.12  1994/09/13  18:51:40  pfrench
*Added application popup menu
*
*Revision 2.11  1994/09/12  18:43:11  pfrench
*Now smarter about navigating around
*
*Revision 2.10  1994/09/11  22:58:00  pfrench
*Now highlights crouton in old column/new row when scroll
*to new row
*
*Revision 2.9  1994/09/11  22:17:30  pfrench
*Now scrolls grid after typing last char of row.
*
*Revision 2.8  1994/09/11  15:48:03  pfrench
*Got auto-scrolling working for selected node
*
*Revision 2.7  1994/09/09  16:45:01  pfrench
*Another small fix for typing "." then a number when in Reset mode
*
*Revision 2.6  1994/09/09  16:41:30  pfrench
*Got crouton select logic working.
*
*Revision 2.5  1994/09/08  15:45:12  pfrench
*More code massaging.
*
*Revision 2.4  1994/09/07  16:33:03  pfrench
*Now has its own event loop
*
*Revision 2.3  1994/09/07  01:54:37  pfrench
*Still chugging along
*
*Revision 2.2  1994/09/07  00:10:44  pfrench
*Fixed initialization problem
*
*Revision 2.1  1994/09/06  23:54:02  pfrench
*Another simple version, still not completely working
*
*Revision 2.0  1994/09/06  23:28:10  pfrench
*FirstCheckIn
*
*/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/sghooks.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>

#include <crouton_all.h>

#include <proto/exec.h>
#include <proto/graphics.h>
#include <proto/intuition.h>

#include <request.h>
#include <gadgets.h>

#include <editwindow.h>
#include <editswit.h>
#include <panel.h>
#include <project.h>
#include <grazer.h>
#include <filelist.h>
#include <grazerrequest.h>
#include <RawKeyCodes.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

//#define SERDEBUG	1
#include <serialdebug.h>

VOID KPutStr(char *String);
VOID KPutChar(char C);

extern LONG ew_QuickSelect( struct EditWindow *Edit, LONG nodenum );

extern struct Window *access_win;
extern struct TextFont *EditFont,*DarkFont,*TCDarkFont;
extern struct Screen *EditScreen;
extern struct EditWindow *EditTop,*EditBottom;
extern struct FastGadget *CurFG,*SKellFG;
extern struct FastGadget **PtrProject;
extern struct ESParams1 ESparams1;
extern struct TextExtent LastExtent;
extern struct Gadget Gadget1;
extern struct MsgPort *EditPort,*SwitPort;
extern BOOL	EditingLive;						// Editing to video/music

struct Window *OpenAccessWindow(void);
LONG aw_Redraw( struct AccessWindow *aw );
LONG ResetAccessWindow(void);
LONG UpdateAccessWindowRows( LONG newrows );
LONG CloseAccessWindow(void);
LONG AccessPanelGetsMessage( struct IntuiMessage *im );
LONG aw_NewKey( struct AccessWindow *aw, char ch );
BOOL HandleAccessWindowPort( struct Window *win );
struct EditWindow *HandlePrograms( struct EditWindow *Edit,struct IntuiMessage *im );

static void aw_RedrawRowCol( struct AccessWindow *aw );
static void DisplayRowCol(struct AccessWindow *aw);


#define TCLEN	88			/* Space to reserve for xx:xx:xx:xx */

#define	ROWCOL_x		4									/* Start of row/col field */
#define	ROWCOL_xe	56									/* end */
#define	CRTN_x		56									/* Start of crouton name field */
#define	CRTN_xe		305								/* end */
#define	CT_x			313								/* Current Time field */
#define	CT_xe			460								/* end */
#define	PT_x			492								/* Program Length field */
#define	PT_xe			636								/* end */

struct AccessWindow
{
	struct Window		*aw_win;

	// Numeric pad selection stuff
	char					 aw_numbuf[10];
	UBYTE					 aw_state;
	UBYTE					 aw_rowdigits;

	char					 *aw_croutonpath;	// Full Path + Name, string ptr to MAX_PATH bytes
	char					 *aw_croutonname;	// Start of Name in CroutonPath buffer
};

#define AWSTATE_RESET		0
#define AWSTATE_ROWSELECT	1
#define AWSTATE_COLSELECT	2

static struct AccessWindow		 sglobal_aw;
struct AccessWindow				*global_aw = &sglobal_aw;

extern struct TagItem nw_ti[2];

static char CroutonName[MAX_PATH+1]="";

#define ID_LOADCROUTON	ID_CONTROLS

struct ExtNewWindow access_nw = {
	32 + GRID_LEFT,28,	/* window XY origin relative to TopLeft of screen */
	640,16,					/* window width and height */
	1,0,						/* detail and block pens */

	/* IDCMP flags */
	IDCMP_RAWKEY | IDCMP_REFRESHWINDOW | IDCMP_MOUSEBUTTONS,

	/* other window flags */
	WFLG_BACKDROP | WFLG_SIMPLE_REFRESH | WFLG_BORDERLESS |
	WFLG_RMBTRAP | WFLG_NW_EXTENDED,

	NULL,	/* first gadget in gadget list */
	NULL,	/* custom CHECKMARK imagery */
	NULL,	/* window title */
	NULL,	/* custom screen pointer */
	NULL,	/* custom bitmap */
	5,5,	/* minimum width and height */
	656,400,	/* maximum width and height */
	CUSTOMSCREEN,	/* destination screen type */
	&nw_ti[0]
};

struct Window *OpenAccessWindow(void)
{
	struct Window *win;

	access_nw.Screen = EditScreen;

	if ( win = OpenWindow((struct NewWindow *)&access_nw) )
	{
		struct RastPort	*rp = win->RPort;

		global_aw->aw_win = win;

		// Number is of the form "XXX-X"
		global_aw->aw_numbuf[0] = ' ';
		global_aw->aw_numbuf[1] = ' ';
		global_aw->aw_numbuf[2] = '0';
		global_aw->aw_numbuf[3] = '.';
		global_aw->aw_numbuf[4] = '0';

		global_aw->aw_numbuf[5] = ' ';
		global_aw->aw_numbuf[6] = '-';
		global_aw->aw_numbuf[7] = ' ';
		global_aw->aw_numbuf[8] = '\0';
		global_aw->aw_croutonpath = CroutonName;
		global_aw->aw_croutonname = CroutonName;
		SetDrMd(rp,JAM2);
		SetFont(rp,DarkFont);
		rp->Mask = 0x07;

		/* aw_Redraw(global_aw); */
	}

	return(win);
}

LONG ResetAccessWindow(void)
{
	LONG					 retval = 0;

	global_aw->aw_numbuf[0] = ' ';
	global_aw->aw_numbuf[1] = ' ';
	global_aw->aw_numbuf[2] = '0';
	global_aw->aw_numbuf[4] = '0';
	global_aw->aw_state = AWSTATE_RESET;
	
	aw_RedrawRowCol(global_aw);

	return(retval);
}

LONG UpdateAccessWindowRows( LONG newrows )
{
	if ( newrows >= 100 )
	{
		global_aw->aw_rowdigits = 3;
	}
	else if ( newrows >= 10 )
	{
		global_aw->aw_rowdigits = 2;
	}
	else
	{
		global_aw->aw_rowdigits = 1;
	}

	return((LONG)global_aw->aw_rowdigits);
}

LONG SelectNodeInAccessWindow( struct EditWindow *Edit, struct FastGadget *fg )
{
	LONG					 nodepos;

	// If node is actually _in_ the project
	// returns 0...(n-1) or -1 if node is not in list.
	if ( (nodepos = GetProjNodeOrder(Edit,fg)) >= 0 )
	{
		UWORD		row,col;

		row = (nodepos / 8) + 1;
		col = (nodepos % 8) + 1;

		global_aw->aw_numbuf[2] = '0' + (char) (row % 10); row /= 10;
		global_aw->aw_numbuf[1] = '0' + (char) (row % 10); row /= 10;
		global_aw->aw_numbuf[0] = '0' + (char) (row % 10);

		if ( global_aw->aw_numbuf[0] == '0' )
			global_aw->aw_numbuf[0] = ' ';

		if ( global_aw->aw_numbuf[1] == '0' )
			global_aw->aw_numbuf[1] = ' ';

		global_aw->aw_numbuf[4] = '0' + (char) col;

		global_aw->aw_state = AWSTATE_RESET;

		aw_RedrawRowCol(global_aw);
	}
	else
	{
		ResetAccessWindow();
	}

	return(nodepos);
}


/*
 *  aw_Redraw -- used to refresh AccessWindow stuff
 */
LONG aw_Redraw( struct AccessWindow *aw )
{
	LONG					 retval = 0;

	DisplayCroutonName(NULL);
	aw_RedrawRowCol(aw);
	DisplayCurrentTime();
	DisplayRunningTime();

	return(retval);
}

static void aw_RedrawRowCol( struct AccessWindow *aw )
{
	DisplayRowCol(aw);
}

LONG CloseAccessWindow(void)
{
	LONG					retval = 0;

	if ( global_aw->aw_win )
	{
		CloseWindow(global_aw->aw_win);
		global_aw->aw_win = NULL;
	}

	return(retval);
}

BOOL HandleAccessWindowPort( struct Window *win )
{
	struct IntuiMessage	*im;
	BOOL						 Done=FALSE;

	while ( im = (struct IntuiMessage *)GetMsg(win->UserPort) )
	{
		switch (im->Class)
		{
			case IDCMP_REFRESHWINDOW:
				BeginRefresh(win);
				aw_Redraw(global_aw);
				EndRefresh(win,TRUE);
			break;

			case IDCMP_RAWKEY:
				/* if (im->Code == RAWKEY_F8) Done = TRUE;
				else */ AccessPanelGetsMessage(im);
			break;
			case IDCMP_MOUSEBUTTONS:
				AccessPanelGetsMessage(im);
			break;
		}

		ReplyMsg((struct Message *)im);
	}

	return(Done);
}

#define IQ_BUTTONS		IEQUALIFIER_LEFTBUTTON|IEQUALIFIER_RBUTTON|IEQUALIFIER_MIDBUTTON

// We are expecting char to be '0' <= ch <= '9' or '.'
LONG AccessPanelGetsMessage( struct IntuiMessage *im )
{
	LONG			retval = 0;

	if ( im->Qualifier & IEQUALIFIER_NUMERICPAD )
	{
		// No repeating characters
		if ( !(im->Qualifier & IEQUALIFIER_REPEAT) )
		{
			char		ch = 0;

			switch ( im->Code )
			{
				case 0x0F:			ch = '0';	break;
				case 0x1D:			ch = '1';	break;
				case 0x1E:			ch = '2';	break;
				case 0x1F:			ch = '3';	break;
				case 0x2D:			ch = '4';	break;
				case 0x2E:			ch = '5';	break;
				case 0x2F:			ch = '6';	break;
				case 0x3C:			ch = '.';	break;
				case 0x3D:			ch = '7';	break;
				case 0x3E:			ch = '8';	break;
				case 0x3F:			ch = '9';	break;
				//case RAWKEY_PAD_ENTER:	ch = '\n";	break;
			}
			if ( ch )
			{
				retval = TRUE;
				aw_NewKey( global_aw, ch );
			}
		}
	}
	else if ( im->Class == IDCMP_MOUSEBUTTONS )
	{
		if( im->Code==SELECTDOWN )
		{
			DisplayMessage(global_aw->aw_croutonpath);
		}
		else {
			aw_Redraw(global_aw);
		}
	}
	else global_aw->aw_state = AWSTATE_RESET;

	return(retval);
}

LONG aw_NewKey(	struct AccessWindow *aw,
						char ch )
{
	LONG			retval = 0;
	UWORD			scroll_to_row = FALSE;

	if ( ch == '.' )
	{
		retval = TRUE;

		if ( aw->aw_state == AWSTATE_RESET )
		{
			// De-select any selected croutons
			if(SKellFG)
				SendSwitcherReply(ES_SelectDefault,(SKellFG=NULL));

			if( EditTop->Node.Type==EW_PROJECT )
			{
				// CurFG = NULL;
				// ChangeStatusList(EditTop,EN_SELECTED,EN_NORMAL);
			}
		}
		aw->aw_state = AWSTATE_COLSELECT;
		scroll_to_row = TRUE;
	}
	else if ( (ch >= '0') && (ch <= '9') )
	{
		retval = TRUE;

		if ( aw->aw_state == AWSTATE_COLSELECT )
		{
			struct FastGadget	*fg;
			UWORD					 gadnum = 0,rowgad = 0;

			aw->aw_state = AWSTATE_RESET;
			aw->aw_numbuf[4] = ch;

			if ( aw->aw_numbuf[0] != ' ' )
				gadnum += (aw->aw_numbuf[0] - '0') * 100;

			if ( aw->aw_numbuf[1] != ' ' )
				gadnum += (aw->aw_numbuf[1] - '0') * 10;

			if ( aw->aw_numbuf[2] != ' ' )
				gadnum += (aw->aw_numbuf[2] - '0');

			// Row numbers begin with one (in text)
			if ( gadnum > 0 )	gadnum -= 1;

			// cols per row
			gadnum *= 8;

			if ( aw->aw_numbuf[4] != ' ' )
				rowgad += (aw->aw_numbuf[4] - '0');

			// Column numbers begin with one (in text)
			if ( rowgad > 0 )	rowgad -= 1;
			if ( rowgad > 7 )	rowgad = 7;

			// Send off a command to the switcher or
			// editor to select the crouton just specified
			if ( fg = GetProjNode( *PtrProject, gadnum + rowgad ) )
			{
				CurFG = fg;

				if( EditTop->Node.Type==EW_PROJECT )
				{
					ew_QuickSelect(EditTop,gadnum + rowgad);
				}
			}

			scroll_to_row = TRUE;
		}
		else
		{
			if ( aw->aw_state == AWSTATE_RESET )
			{
				// Clear out significant digits
				aw->aw_state = AWSTATE_ROWSELECT;
				aw->aw_numbuf[0] = ' ';
				aw->aw_numbuf[1] = ' ';
				aw->aw_numbuf[2] = ch;

				// De-select any selected croutons
				if(SKellFG)
					SendSwitcherReply(ES_SelectDefault,(SKellFG=NULL));
				if( EditTop->Node.Type==EW_PROJECT )
				{
					// CurFG = NULL;
					// ChangeStatusList(EditTop,EN_SELECTED,EN_NORMAL);
				}
			}
			else /* aw->aw_state == AWSTATE_ROWSELECT */
			{
				// Multiply char sequence by 10
				// Since this is an ASCII representation,
				// we just move the values up one
				if ( aw->aw_rowdigits > 2 )
					aw->aw_numbuf[0] = aw->aw_numbuf[1];

				if ( aw->aw_rowdigits > 1 )
					aw->aw_numbuf[1] = aw->aw_numbuf[2];

				aw->aw_numbuf[2] = ch;
			}

			// Check if rows are full. if so, go into
			// colselect state.
			if ( aw->aw_numbuf[3-aw->aw_rowdigits] != ' ' )
			{
				aw->aw_state = AWSTATE_COLSELECT;
				scroll_to_row = TRUE;
			}
		}

		// Re-draw the row/column with the new digits
		aw_RedrawRowCol(aw);
	}

	// Compute row and scroll to it
	if ( scroll_to_row && (EditTop->Node.Type == EW_PROJECT) )
	{
		scroll_to_row = 0;

		if ( aw->aw_numbuf[0] != ' ' )
			scroll_to_row += (aw->aw_numbuf[0] - '0') * 100;

		if ( aw->aw_numbuf[1] != ' ' )
			scroll_to_row += (aw->aw_numbuf[1] - '0') * 10;

		if ( aw->aw_numbuf[2] != ' ' )
			scroll_to_row += (aw->aw_numbuf[2] - '0');

		// Row numbers begin with one (in text)
		if ( scroll_to_row > 0 )	scroll_to_row -= 1;

		ew_ScrollToRow(EditTop,scroll_to_row);

		{
			struct FastGadget	*fg;
			UWORD					 gadnum = 0;

			if ( aw->aw_numbuf[4] != ' ' )
				gadnum += (aw->aw_numbuf[4] - '0');

			// Column numbers begin with one (in text)
			if ( gadnum > 0 )	gadnum -= 1;
			if ( gadnum > 7 )	gadnum = 7;

			if ( fg = GetProjNode( *PtrProject, (scroll_to_row * 8) + gadnum) )
			{
				if( EditTop->Node.Type==EW_PROJECT )
				{
					CurFG = fg;
					ew_QuickSelect(EditTop,(scroll_to_row * 8) + gadnum);
				}
			}
		}
	}

	return(retval);
}

static BOOL MsgUp=FALSE;
static char	time[12]="00:00:00:00";
static LONG TotalFields=0,CurTime=0;

void CalcCurrentTime(struct FastGadget *fg)
{
	LONG	time;

	time = GetStartTimeInSequence(fg);
	SetCurrentTime(time);					// Set (and display, if possible)
}

void __asm SetCurrentTime(register __d0 LONG Fields)
{
	CurTime=Fields;

	if (!MsgUp)
		DisplayCurrentTime();		// Redraw it if not occluded by message
}

void DisplayCurrentTime(void)
{
	const LONG			TCX = CT_xe - TCLEN;		// Start of time code part of field

	struct Window		*win;
	LONG					frms;

	DUMPMSG("CT");

	frms = CurTime>>1;		  // convert to frames

	if (MsgUp)
		DisplayMessage(NULL);		// Try to get accesswindow back

	if (!MsgUp)										// But we may not be able to!
	{
		if ( win=global_aw->aw_win )
		{
			struct RastPort		*rp = global_aw->aw_win->RPort;

			SetAPen(rp,PAL_DGRAY);
			Move(rp,CT_x,rp->Font->tf_Baseline + 2 );

			if( CurTime != -1 )
			{
				SafeColorText(rp,"Current",7);

				Move(rp,TCX,rp->Font->tf_Baseline + 2 );

				LongToTime((ULONG *)&frms,time);

				SetFont(rp,TCDarkFont);
				SafeColorText(rp,time,11);		// Render (optional) time string
				SetFont(rp,DarkFont);
			}

			if (rp->cp_x <= CT_xe)				// Clear out unused part of CurTime field
			{
				SetAPen(rp,PAL_DGRAY);
				RectFill(rp,rp->cp_x,0,CT_xe,win->Height);
			}
		}
	}
}


void CalcRunningTime(void)
{
	LONG	time;

	time = GetTotalSequenceTime();
	SetRunningTime(time);					// Set (and display, if possible)
}

void __asm SetRunningTime(register __d0 LONG Fields)
{
	TotalFields=Fields;

	if (!MsgUp)
		DisplayRunningTime();		// Redraw it if not occluded by message
}

LONG DisplayRunningTime(void)
{
	const LONG			TCX = PT_xe - TCLEN;		// Start of time code part of field

	struct Window		*win;
	LONG					frms;

	DUMPMSG("RT");

	frms = TotalFields>>1;  // convert to frames

	if (MsgUp)
		DisplayMessage(NULL);					// Try to get accesswindow back

	if (!MsgUp)										// But we may not be able to!
	{
		if( TotalFields != -1 )
			LongToTime((ULONG *)&frms,time);
		else
			strcpy(time,"--:--:--:--");

		// RectFill(&srp,PT_x + 54+2,y+2,PT_x + 54+TCLEN+6,y+(LINE_HEIGHT-3));
		// NewBorderBox(&srp,PT_x + 54,y,PT_x + 54+TCLEN+11,y+LINE_HEIGHT+2,BOX_CP_BORDER);
		if ( time )
		{
			if ( win=global_aw->aw_win )
			{
				struct RastPort		*rp = global_aw->aw_win->RPort;

				SetAPen(rp,PAL_DGRAY);

				Move(rp,PT_x,rp->Font->tf_Baseline + 2 );
//				SafeColorText(rp,"Program Time",12);
				SafeColorText(rp,"Project",7);

				Move(rp,TCX,rp->Font->tf_Baseline + 2 );

				SetFont(rp,TCDarkFont);
				SafeColorText(rp,time,11);
				SetFont(rp,DarkFont);

				if (rp->cp_x <= PT_xe)			// Clear out rest of ProgTime field
				{
					SetAPen(rp,PAL_DGRAY);
					RectFill(rp,rp->cp_x,0,PT_xe,win->Height);
				}
			}
		}
	}
	return(0);
}


LONG DisplayCroutonName( STRPTR filename )
{
	struct Window		*win;
	int	len;

	if(MsgUp)
		DisplayMessage(NULL);					// Try to get accesswindow back

	if (!MsgUp)										// But we may not be able to!
	{
		if ( win = global_aw->aw_win )
		{
			struct RastPort		*rp = global_aw->aw_win->RPort;
			if ( filename )
			{
				strncpy(global_aw->aw_croutonpath,filename,MAX_PATH);
				global_aw->aw_croutonname = FilePart(global_aw->aw_croutonpath);
			}
			SetAPen(rp,PAL_DGRAY);
//			RectFill(rp,CRTN_x,0,CRTN_xe,win->Height);
			Move( rp, CRTN_x, rp->Font->tf_Baseline + 2 );

			len = strlen(global_aw->aw_croutonname);
			if (len)
				SafeFitText(rp,global_aw->aw_croutonname,len,CRTN_xe-CRTN_x,TRUE);

			if (rp->cp_x <= CRTN_xe)			// Clear out unused part of name field
			{
				SetAPen(rp,PAL_DGRAY);
				RectFill(rp,rp->cp_x,0,CRTN_xe,win->Height);
			}
		}
	}
	return(0);
}

static void DisplayRowCol(struct AccessWindow *aw)
{
	struct RastPort	*rp = aw->aw_win->RPort;

	if (MsgUp)
		DisplayMessage(NULL);					// Try to get accesswindow back

	if (!MsgUp)										// But we may not be able to!
	{
		Move(rp,ROWCOL_x,rp->Font->tf_Baseline + 2);
		SafeColorText(rp,aw->aw_numbuf,8);
	}
}


// Put message atop screen, or clear message if mes=NULL
LONG DisplayMessage( STRPTR mes )
{
	struct Window	*win;

	if ( win = global_aw->aw_win )
	{
		struct RastPort		*rp = win->RPort;

		if ( mes )
		{
			MsgUp = TRUE;

			SetAPen(rp,PAL_LGRAY);
			SetRast(rp,PAL_DGRAY);
			SaveBorder(rp,0,0,win->Width-1,win->Height);
			NewBorderBox(rp,0,0,win->Width-1,win->Height,BOX_STD_BORDER);

			SetFont(rp,EditFont);

			Move(rp,6,rp->Font->tf_Baseline + 3 );
			SafeColorText(rp,mes,strlen(mes));

			SetFont(rp,DarkFont);
		}
		else
		{
			if (!EditingLive)		// Don't allow this bar to go away until STOP!
			{
				MsgUp = FALSE;
				SetRast(rp,1);

				aw_Redraw(global_aw);		// Put crouton name/times back up
			}
		}
	}
	return(0);
}
