/*********************************************************************\
*
* RecLevel - Test record level control
*
* $Id: CODEC.c,v 1.0 1995/05/05 15:48:21 Flick Exp $
*
* $Log: CODEC.c,v $
*Revision 1.0  1995/05/05  15:48:21  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	01/31/95		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <intuition/intuition.h>

#include "FlyerLib.h"
#include "Flyer.h"

#define	GAINDFLT	8

#define	GAINSPAN	17
#define	GAINBASE	0
#define	AUXSPAN	33
#define	AUXBASE	-17

#define	GRAPHX		300
#define	GRAPHY		70
#define	CHUNK			10
#define	BARHEIGHT	3*CHUNK
#define	BARWIDTH		30
#define	BETWEEN		50

struct FileInfoBlock fib;

struct Library *FlyerBase;

struct	Window			*Window;
struct	IntuitionBase	*IntuitionBase;
struct	GfxBase			*GfxBase;
struct	RastPort			*RP;
int		InputSrc,LastBar[2];
struct	FlyAudCtrl		CODEC;

LONG		oldaux1pos,oldaux2pos,Loldgainpos,Roldgainpos;

#define	GID_AUX1SLIDER		1
#define	GID_AUX2SLIDER		2
#define	GID_LGAINSLIDER	3
#define	GID_RGAINSLIDER	4
#define	GID_SRC				5

void SetupSlider(struct Gadget *gad,UWORD span, UWORD pos);
void SendCODEC(UBYTE oper);
void ShowVal(int which,int val);
ULONG	ScrollBar2Pos(ULONG max,struct Gadget *gad);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void Message(int x,int y,int num);
void UpdateBar(int which,int new);
void PresetSliders(void);

USHORT	BoxVectors[] = {104,14, 0,14, 0,0, 104,0, 104,14};
struct	Border BoxBorder = {-2,-2,1,0,JAM1,5,BoxVectors,NULL};

USHORT	GraphVectors[] =
				{0xFFFF,0xFFFF, BARWIDTH+1,0xFFFF, BARWIDTH+1,BARHEIGHT+1,
				0xFFFF,BARHEIGHT+1, 0xFFFF,0xFFFF};
struct	Border GraphBorder = {0,0,1,0,JAM1,5,GraphVectors,NULL};

struct TextAttr MyFont = {(STRPTR)"topaz.font",TOPAZ_EIGHTY,0,0};

struct Gadget SrcGadget = {    /* Input source */
   NULL,500,40,104,14,GADGHNONE,RELVERIFY,BOOLGADGET,
   (APTR)&BoxBorder,NULL,NULL,0,NULL,
	GID_SRC,NULL};

struct PropInfo LGainSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image LGainSliderImage;
struct Gadget LGainSliderGadget = {
	&SrcGadget,
	20,20,200,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&LGainSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&LGainSliderInfo,
	GID_LGAINSLIDER,
	NULL
};

struct PropInfo RGainSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image RGainSliderImage;
struct Gadget RGainSliderGadget = {
	&LGainSliderGadget,
	20,42,200,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&RGainSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&RGainSliderInfo,
	GID_RGAINSLIDER,
	NULL
};

struct PropInfo Aux1SliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image Aux1SliderImage;
struct Gadget Aux1SliderGadget = {
	&RGainSliderGadget,
	20,64,200,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&Aux1SliderImage,
	NULL,
	NULL,
	0,
	(APTR)&Aux1SliderInfo,
	GID_AUX1SLIDER,
	NULL
};


struct PropInfo Aux2SliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image Aux2SliderImage;
struct Gadget Aux2SliderGadget = {
	&Aux1SliderGadget,
	20,86,200,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&Aux2SliderImage,
	NULL,
	NULL,
	0,
	(APTR)&Aux2SliderInfo,
	GID_AUX2SLIDER,
	NULL
};

struct NewWindow NewWindow =
	{
	0,0,640,100,
	0,1,
	GADGETUP | MOUSEMOVE | CLOSEWINDOW | INTUITICKS,
	WINDOWCLOSE | WINDOWDRAG | WINDOWDEPTH | ACTIVATE | NOCAREREFRESH,
	&Aux2SliderGadget,		/* Gadget 1st */
	NULL,
	"Flyer CODEC Control Test",
	NULL,
	NULL,
	100,25,
	640,400,
	WBENCHSCREEN
};


char PosBuffer[20] = " ";
struct	IntuiText ValueText =
	{1,0,JAM2,18,12,&MyFont,(unsigned char *)&PosBuffer,NULL};

struct	IntuiText Info6Text =
	{1,0,JAM2,GRAPHX+BETWEEN,GRAPHY+3,&MyFont,"Right",NULL};
struct	IntuiText Info5Text =
	{1,0,JAM2,GRAPHX,GRAPHY+3,&MyFont,"Left",&Info6Text};
struct	IntuiText Info4Text =
	{1,0,JAM2,18,78,&MyFont,"Aux 2 mix",&Info5Text};
struct	IntuiText Info3Text =
	{1,0,JAM2,18,56,&MyFont,"Aux 1 mix",&Info4Text};
struct	IntuiText Info2Text =
	{1,0,JAM2,18,34,&MyFont,"Right Gain",&Info3Text};
struct	IntuiText Info1Text =
	{1,0,JAM2,18,12,&MyFont,"Left Gain",&Info2Text};


main(int argc,char **argv)
{
	int		stop;
	struct	IntuiMessage  *IntMsg;
	ULONG		MIClass;
	ULONG		newaux1pos,newaux2pos,Lnewgainpos,Rnewgainpos;
	USHORT	theID;
	struct	Gadget	*MIAddress;

	if (argc!=1) {
		printf("Usage: %ls\n",argv[0]);
		return(20);
	}

	FlyerBase = OpenLibrary("flyer.library",0);
	if (FlyerBase==0) {
		printf("Could not open Flyer\n");
		exit(10);
	}

	IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library",0);
	if (IntuitionBase) {
		GfxBase = (struct GfxBase *)OpenLibrary("graphics.library",0);
		if (GfxBase) {
			Window = (struct Window *)OpenWindow(&NewWindow);
			if (Window) {
				RP = Window->RPort;

				PrintIText(RP,&Info1Text,0,0);
			   DrawBorder(RP,&GraphBorder,GRAPHX,GRAPHY-BARHEIGHT);
			   DrawBorder(RP,&GraphBorder,GRAPHX+BETWEEN,GRAPHY-BARHEIGHT);

				Message(500+10,40-10,InputSrc);

				stop = 0;

				PresetSliders();
				SendCODEC(FACOF_SETGAIN | FACOF_SETSRC | FACOF_SETMIX);

				do {
					Wait(1<<Window->UserPort->mp_SigBit);
					while (IntMsg=(struct IntuiMessage *)GetMsg(Window->UserPort)) {
						MIClass		= IntMsg->Class;  /* Get pertinent info */
						MIAddress	= (struct Gadget *)IntMsg->IAddress;
						if (MIClass == GADGETUP)
/*						if (MIAddress)  THIS WOULD HIT, SOMETIMES WAS FFFF0000! */
							theID = MIAddress->GadgetID;
						else
							theID = 0;
						ReplyMsg((struct Message *)IntMsg);			/* Reply to message quickly */

						SendCODEC(FACOF_SENSE);			/* Get overrange values */
						UpdateBar(0,CODEC.LeftSense);
						UpdateBar(1,CODEC.RightSense);

						Lnewgainpos = ScrollBar2Pos(GAINSPAN,&LGainSliderGadget);
						if (Lnewgainpos != Loldgainpos) {				/* Slider changed since last? */
							ShowVal(0,GAINBASE+Lnewgainpos);
							Loldgainpos = Lnewgainpos;
							SendCODEC(FACOF_SETGAIN);
						}
						Rnewgainpos = ScrollBar2Pos(GAINSPAN,&RGainSliderGadget);
						if (Rnewgainpos != Roldgainpos) {				/* Slider changed since last? */
							ShowVal(1,GAINBASE+Rnewgainpos);
							Roldgainpos = Rnewgainpos;
							SendCODEC(FACOF_SETGAIN);
						}
						newaux1pos = ScrollBar2Pos(AUXSPAN,&Aux1SliderGadget);
						if (newaux1pos != oldaux1pos) {				/* Slider changed since last? */
							ShowVal(2,AUXBASE+newaux1pos);
							oldaux1pos = newaux1pos;
							SendCODEC(FACOF_SETMIX);
						}
						newaux2pos = ScrollBar2Pos(AUXSPAN,&Aux2SliderGadget);
						if (newaux2pos != oldaux2pos) {				/* Slider changed since last? */
							ShowVal(3,AUXBASE+newaux2pos);
							oldaux2pos = newaux2pos;
							SendCODEC(FACOF_SETMIX);
						}

						if (MIClass == GADGETUP) {
							if (theID == GID_SRC) {
								if ((++InputSrc) == 3)
									InputSrc = 0;
								SendCODEC(FACOF_SETSRC);
								Message(500+10,40-10,InputSrc);
							}
						}
						else if (MIClass == CLOSEWINDOW)
							stop = 1;
					}
				} while (stop==0);

				CloseWindow(Window);
			}
			CloseLibrary((struct Library *)GfxBase);
		}
		CloseLibrary((struct Library *)IntuitionBase);
	}

	CloseLibrary(FlyerBase);
}


void PresetSliders(void)
{
	Loldgainpos = GAINDFLT-GAINBASE;
	SetupSlider(&LGainSliderGadget,GAINSPAN,Loldgainpos);
	ShowVal(0,GAINBASE+Loldgainpos);

	Roldgainpos = GAINDFLT-GAINBASE;
	SetupSlider(&RGainSliderGadget,GAINSPAN,Roldgainpos);
	ShowVal(1,GAINBASE+Roldgainpos);

	oldaux1pos = (-17)-AUXBASE;
	SetupSlider(&Aux1SliderGadget,AUXSPAN,oldaux1pos);
	ShowVal(2,AUXBASE+oldaux1pos);

	oldaux2pos = (-17)-AUXBASE;
	SetupSlider(&Aux2SliderGadget,AUXSPAN,oldaux2pos);
	ShowVal(3,AUXBASE+oldaux2pos);
}

void SetupSlider(struct Gadget *gad,UWORD span, UWORD pos)
{
	ULONG	p,body;

	/* Set appropriate size(s) */
	body = (0x10000/(ULONG)span) & 0xFFFF;
/*	info->HorizBody  = body; */

	p = (ULONG)pos;
	p = (p<<16)/(ULONG)(span-1);

	if (p>0xFFFF)
		p = 0xFFFF;

/*	info->HorizPot = p; */

	NewModifyProp(gad,Window,0,AUTOKNOB|FREEHORIZ,p,0,body,MAXBODY,1);
}


void SendCODEC(UBYTE oper)
{
	ULONG	res;
	BYTE	temp;

	CODEC.LeftSrc	= CODEC.RightSrc	= InputSrc;
	CODEC.LeftGain		= GAINBASE+Loldgainpos;
	CODEC.RightGain	= GAINBASE+Roldgainpos;

	temp = AUXBASE+oldaux1pos;
	if (temp<-16)
		temp = -128;
	CODEC.Aux1Mix	= temp;

	temp = AUXBASE+oldaux2pos;
	if (temp<-16)
		temp = -128;
	CODEC.Aux2Mix	= temp;

	if (oper & FACOF_SETMIX) {
		printf("Src = %ld, gain = %ld, aux1 = %ld, aux2 = %ld\n",
			CODEC.LeftSrc,CODEC.LeftGain,CODEC.Aux1Mix,CODEC.Aux2Mix);
	}

	res = FlyerAudioCtrl(0,&CODEC,oper);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

#if 0
	if (oper & FACOF_SENSE) {
		printf("OvL = %ld, OvR = %ld\n",
			CODEC.LeftSense,CODEC.RightSense);
	}
#endif
}


void ShowVal(int which,int val)
{
	sprintf(PosBuffer,"%ld      ",val);
	PrintIText(RP,&ValueText,100,22*which);
}


ULONG	ScrollBar2Pos(ULONG max,struct Gadget *gad)
{
	ULONG	new;

	new = ((struct PropInfo *)gad->SpecialInfo)->HorizPot+1;
	new = ((max-1) * new)>>15;
	if (new & 1) new++;
	new>>=1;

	if (new >= max)
		new = max-1;

	return(new);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

char *Msgs[] = {
   "Line 1",
   "Aux 1 ",
   "Line 2",
};

void Message(int x,int y,int num)
{
	strcpy(PosBuffer,Msgs[num]);
	PrintIText(RP,&ValueText,x,y);
}

void UpdateBar(int which,int new)
{
	int	x1,x2,y,y1,y2,cur;

	x1 = GRAPHX + (which * BETWEEN);
	x2 = x1 + BARWIDTH;

	y = GRAPHY;
	cur = LastBar[which];

	SetDrMd(RP,JAM2);

	SetAPen(RP,0);
	while (cur > new) {		/* Draw less til up to date */
		y2 = y-(cur-1)*CHUNK;
		y1 = y-cur*CHUNK;
#if 0
		printf("-%ld,%ld,%ld,%ld\n",x1,y1,x2,y2);
#endif
		RectFill(RP,x1,y1,x2,y2);
		cur--;
	}

	while (cur < new) {		/* Draw more til up to date */
		if ((cur+1) >= 3)
			SetAPen(RP,2);		/* Warning! */
		else
			SetAPen(RP,3);		/* Okay */
		y2 = y-cur*CHUNK;
		y1 = y-(cur+1)*CHUNK;
#if 0
		printf("+%ld,%ld,%ld,%ld\n",x1,y1,x2,y2);
#endif
		RectFill(RP,x1,y1,x2,y2);
		cur++;
	}
	LastBar[which] = new;
}
