/*********************************************************************\
*
* CalibTest - Test calibration commands
*
* $Id: CalibTest.c,v 1.0 1995/05/05 15:48:18 Flick Exp $
*
* $Log: CalibTest.c,v $
*Revision 1.0  1995/05/05  15:48:18  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	10/05/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <intuition/intuition.h>

#include "FlyerLib.h"
#include "Flyer.h"

#define	POSSPAN	752*2
#define	POSBASE	-752

struct FileInfoBlock fib;

struct Library *FlyerBase;

struct	Window			*Window;
struct	IntuitionBase  *IntuitionBase;
struct	RastPort			*RP;
int		AdjType;
ULONG		oldclkpos,oldcrspos,oldfinepos,oldpospos;

#define	GID_CLKSLIDER		1
#define	GID_COURSESLIDER	2
#define	GID_FINESLIDER		3
#define	GID_POSSLIDER		4
#define	GID_SAVE				5
#define	GID_TYPE				6

void SetupSlider(struct Gadget *gad,UWORD span, UWORD pos);
void Doit(int value,int saveit);
void Doit3(int which,int value,int saveit);
void ShowVal(int which,int val);
ULONG	ScrollBar2Pos(ULONG max,struct Gadget *gad);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void Message(int x,int y,int num);
void PresetSliders(void);

USHORT	BoxVectors[] = {104,14, 0,14, 0,0, 104,0, 104,14};
struct	Border BoxBorder = {-2,-2,1,0,JAM1,5,BoxVectors,NULL};

struct TextAttr MyFont = {(STRPTR)"topaz.font",TOPAZ_EIGHTY,0,0};

struct Gadget TypeGadget = {    /* None/Light/Heavy */
   NULL,500,40,104,14,GADGHNONE,RELVERIFY,BOOLGADGET,
   (APTR)&BoxBorder,NULL,NULL,0,NULL,
	GID_TYPE,NULL};

struct IntuiText SaveText = {
   1,0,JAM1,27,2,&MyFont,"Save",NULL};
struct Gadget SaveGadget = {		/* Save! button */
	&TypeGadget,500,70,101,11,GADGHCOMP,RELVERIFY,BOOLGADGET,
   (APTR)&BoxBorder,NULL,&SaveText,0,NULL,
	GID_SAVE,
	NULL};

struct PropInfo PosSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image PosSliderImage;
struct Gadget PosSliderGadget = {
	&SaveGadget,
	20,20,600,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&PosSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&PosSliderInfo,
	GID_POSSLIDER,
	NULL
};

struct PropInfo ClkSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image ClkSliderImage;
struct Gadget ClkSliderGadget = {
	&PosSliderGadget,
	20,42,400,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&ClkSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&ClkSliderInfo,
	GID_CLKSLIDER,
	NULL
};


struct PropInfo CrsSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image CrsSliderImage;
struct Gadget CrsSliderGadget = {
	&ClkSliderGadget,
	20,64,400,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&CrsSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&CrsSliderInfo,
	GID_COURSESLIDER,
	NULL
};

struct PropInfo FineSliderInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image FineSliderImage;
struct Gadget FineSliderGadget = {
	&CrsSliderGadget,
	20,86,400,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&FineSliderImage,
	NULL,
	NULL,
	0,
	(APTR)&FineSliderInfo,
	GID_FINESLIDER,
	NULL
};

struct NewWindow NewWindow =
	{
	0,0,640,100,
	0,1,
	GADGETUP | MOUSEMOVE | CLOSEWINDOW | INTUITICKS,
	WINDOWCLOSE | WINDOWDRAG | WINDOWDEPTH | ACTIVATE | NOCAREREFRESH,
	&FineSliderGadget,		/* Gadget 1st */
	NULL,
	"Flyer Calibration Test",
	NULL,
	NULL,
	100,25,
	640,400,
	WBENCHSCREEN
};


char PosBuffer[20] = " ";
struct	IntuiText ValueText =
	{1,0,JAM2,18,12,&MyFont,(unsigned char *)&PosBuffer,NULL};

struct	IntuiText Info4Text =
	{1,0,JAM2,18,78,&MyFont,"Fine",NULL};
struct	IntuiText Info3Text =
	{1,0,JAM2,18,56,&MyFont,"Course",&Info4Text};
struct	IntuiText Info2Text =
	{1,0,JAM2,18,34,&MyFont,"Clk",&Info3Text};
struct	IntuiText Info1Text =
	{1,0,JAM2,18,12,&MyFont,"Position",&Info2Text};



main(int argc,char **argv)
{
	int	stop;
	struct	IntuiMessage  *IntMsg;
	ULONG		MIClass;
	ULONG		newclkpos,newcrspos,newfinepos,newpospos;
	USHORT	theID;
	struct	Gadget	*MIAddress;

	if (argc!=1) {
		printf("Usage: %ls\n",argv[0]);
		return(20);
	}

	AdjType = 0;

	FlyerBase = OpenLibrary("flyer.library",0);
	if (FlyerBase==0) {
		printf("Could not open Flyer\n");
		exit(10);
	}

	IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library",0);
	if (IntuitionBase) {
		Window = (struct Window *)OpenWindow(&NewWindow);
		if (Window) {
			RP = Window->RPort;

			PrintIText(RP,&Info1Text,0,0);

			Message(500+10,40-10,AdjType);

			stop = 0;

			PresetSliders();

			do {
				Wait(1<<Window->UserPort->mp_SigBit);
				while (IntMsg=(struct IntuiMessage *)GetMsg(Window->UserPort)) {
					MIClass		= IntMsg->Class;  /* Get pertinent info */
					MIAddress	= (struct Gadget *)IntMsg->IAddress;
					if (MIAddress)
						theID = MIAddress->GadgetID;
					else
						theID = 0;
					ReplyMsg((struct Message *)IntMsg);			/* Reply to message quickly */

					newclkpos = ScrollBar2Pos(4,&ClkSliderGadget);
					if (newclkpos != oldclkpos) {				/* Slider changed since last? */
						Doit3(0,newclkpos,0);
						oldclkpos = newclkpos;
					}
					newcrspos = ScrollBar2Pos(10,&CrsSliderGadget);
					if (newcrspos != oldcrspos) {				/* Slider changed since last? */
						Doit3(1,newcrspos,0);
						oldcrspos = newcrspos;
					}
					newfinepos = ScrollBar2Pos(8,&FineSliderGadget);
					if (newfinepos != oldfinepos) {				/* Slider changed since last? */
						Doit3(2,newfinepos,0);
						oldfinepos = newfinepos;
					}
					newpospos = ScrollBar2Pos(POSSPAN,&PosSliderGadget);
					if (newpospos != oldpospos) {				/* Slider changed since last? */
						Doit(POSBASE+newpospos,0);
						oldpospos = newpospos;
					}


					if (MIClass == GADGETUP) {
						if (theID == GID_SAVE) {
							Doit3(0,oldclkpos,1);
							Doit3(1,oldcrspos,1);
							Doit3(2,oldfinepos,1);
							Doit(POSBASE+oldpospos,1);
							printf("Saved!\n");
						}
						else if (theID == GID_TYPE) {
							if ((++AdjType) == 3)
								AdjType = 0;
							PresetSliders();			/* Get current values for type */
							Message(500+10,40-10,AdjType);
						}
#if 0
						else if (theID == GID_CLKSLIDER) {
							newclkpos = ScrollBar2Pos(Scale,&SliderGadget);
							Doit(newclkpos);
							oldclkpos = newclkpos;
						}
#endif
					}
					else if (MIClass == CLOSEWINDOW)
						stop = 1;
				}
			} while (stop==0);

			CloseWindow(Window);
		}
		CloseLibrary((struct Library *)IntuitionBase);
	}

	CloseLibrary(FlyerBase);
}


void PresetSliders(void)
{
	ULONG	res;
	WORD 	value;

	res = FlyerReadCalib(0,AdjType+CALIB_HPLAYOFFSETA,&value);
	oldpospos = value-POSBASE;
	SetupSlider(&PosSliderGadget,POSSPAN,oldpospos);
	ShowVal(0,POSBASE+oldpospos);

	res = FlyerReadCalib(0,AdjType*3+CALIB_DACA_PHASE_EDGE,&value);
	oldclkpos = value;
	SetupSlider(&ClkSliderGadget,4,oldclkpos);
	ShowVal(1,oldclkpos);

	res = FlyerReadCalib(0,AdjType*3+CALIB_DACA_PHASE_COURSE,&value);
	oldcrspos = value;
	SetupSlider(&CrsSliderGadget,10,oldcrspos);
	ShowVal(2,oldcrspos);

	res = FlyerReadCalib(0,AdjType*3+CALIB_DACA_PHASE_FINE,&value);
	oldfinepos = value;
	SetupSlider(&FineSliderGadget,8,oldfinepos);
	ShowVal(3,oldfinepos);
}

void SetupSlider(struct Gadget *gad,UWORD span, UWORD pos)
{
	ULONG	p,body;

	/* Set appropriate size(s) */
	body = (0x10000/(ULONG)span) & 0xFFFF;
/*	info->HorizBody  = body; */

	p = (ULONG)pos;
	p = (p<<16)/(ULONG)(span-1);

	if (p>0xFFFF)
		p = 0xFFFF;

/*	info->HorizPot = p; */

	NewModifyProp(gad,Window,0,AUTOKNOB|FREEHORIZ,p,0,body,MAXBODY,1);
}

void Doit(int val,int saveit)
{
	ULONG	res;

	ShowVal(0,val);

	res = FlyerWriteCalib(0,AdjType+CALIB_HPLAYOFFSETA,val,saveit);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
}


void Doit3(int which,int val,int saveit)
{
	ULONG	res;

	ShowVal(1+which,val);

	res = FlyerWriteCalib(0,AdjType*3+which,val,saveit);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
}


void ShowVal(int which,int val)
{
	sprintf(PosBuffer,"%ld      ",val);
	PrintIText(RP,&ValueText,100,22*which);
}


ULONG	ScrollBar2Pos(ULONG max,struct Gadget *gad)
{
	ULONG	new;

	new = ((struct PropInfo *)gad->SpecialInfo)->HorizPot+1;
	new = ((max-1) * new)>>15;
	if (new & 1) new++;
	new>>=1;

	if (new >= max)
		new = max-1;

	return(new);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

char *Msgs[] = {
   "PlayA",
   "PlayB",
   " Rec ",
};

void Message(int x,int y,int num)
{
	strcpy(PosBuffer,Msgs[num]);
	PrintIText(RP,&ValueText,x,y);
}
