/*********************************************************************\
*
* CopyClip - Copy clip from drive to drive
*
* $Id: CopyClip.c,v 1.0 1995/05/05 15:48:25 Flick Exp $
*
* $Log: CopyClip.c,v $
*Revision 1.0  1995/05/05  15:48:25  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/11/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume SrcVol,DestVol;

main(int argc,char **argv)
{
	int	unit;
	ULONG	res;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <vol:name> <destvol:>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	SrcVol.Board = unit;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

/*	SrcVol.Flags = FVF_USENUMS; */
	SrcVol.Path = argv[2];
	SrcVol.SCSIdrive = 0;

	DestVol.Path = argv[3];
	DestVol.SCSIdrive = 0;
/*	DestVol.SCSIdrive = todrive; */

	res = FlyerCopyClip(&SrcVol,&DestVol);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Created file\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
