/*********************************************************************\
*
* CopyData2File - Turn raw data into a file
*
* $Id: CopyData2File.c,v 1.0 1995/05/05 15:48:31 Flick Exp $
*
* $Log: CopyData2File.c,v $
*Revision 1.0  1995/05/05  15:48:31  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	03/03/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

struct FlyerVolInfo	Buffer;

main(int argc,char **argv)
{
	int	unit,drive,todrive;
	ULONG	res,start,frames;

	if ((argc!=7)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <start> <frames> <name> <todrive>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"Drive");
	GetLongArg(argv[3],&start,0,0x7FFFFFFF,"Start block");
	GetLongArg(argv[4],&frames,0,0x7FFFFFFF,"Frames");
	GetArg(argv[6],&todrive,0,23,"To Drive");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Path = argv[5];
	FlyVol.SCSIdrive = drive;
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.StartBlk = start;
	Action.VidFieldCount = frames*4;

	/* Magic - Instruct to copy to another drive, then add to FileSys */
	Action.MatteY = 0x1234;
	Action.MatteI = todrive;

	res = Data2File(&Action);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Created file\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
