/*********************************************************************\
*
* DMAwrite - DMA from CPU memory --> DMA
*
* $Id: DMAwrite.c,v 1.0 1995/05/05 15:48:58 Flick Exp $
*
* $Log: DMAwrite.c,v $
*Revision 1.0  1995/05/05  15:48:58  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	03/14/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit;
	ULONG	blklen,cpu,dma;
	ULONG	res;

	if ((argc!=5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <blklen> <dma addr> <cpu addr>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetLongArg(argv[2],&blklen,0,0xFFFFFFFF,"Block Length");
	GetLongArg(argv[3],&dma,0,0xFFFFFFFF,"DMA Addr");
	GetLongArg(argv[4],&cpu,0,0xFFFFFFFF,"CPU Addr");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = CPUDMA(unit,cpu,dma,blklen,1);		/* Read CPU to DMA */
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
