/*********************************************************************\
*
* DeFrag - Cleans up a Flyer drive
*
* $Id: DeFrag.c,v 1.0 1995/05/05 15:48:49 Flick Exp $
*
* $Log: DeFrag.c,v $
*Revision 1.0  1995/05/05  15:48:49  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	05/17/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	res;

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"Drive");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.SCSIdrive = drive;

	res = FlyerDeFrag(&FlyVol);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("DeFrag complete\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
