/*********************************************************************\
*
* DoTest - Hardware checkout -- access misc tests
*
* $Id: DoTest.c,v 1.0 1995/11/06 14:52:02 Flick Exp $
*
* $Log: DoTest.c,v $
*Revision 1.0  1995/11/06  14:52:02  Flick
*FirstCheckIn
*
*
* Copyright (c) 1995 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"
//#include "flyerprivate.h"

void	GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library		*FlyerBase;

BPTR	handle;

#if 0
main(int argc,char **argv)
{
	ULONG	res,result;
	int	arg1,arg2,arg3,arg4,arg5,test;

//	handle = Input();

	if ((argc<2)||(argv[1][0]=='?'))
	{
		printf("Usage: %ls <test> [<arg1> [<arg2>]]\n",argv[0]);
		exit(10);
	}

	GetArg(argv[1],&test,0,0xFF,"Test");
	arg1=arg2=arg3=arg4=arg5 = 0;

	if (argc==3)
		GetArg(argv[2],&arg1,0,0xFFFF,"Arg 1");
	if (argc==4)
		GetArg(argv[3],&arg2,0,0xFFFF,"Arg 2");
	if (argc==5)
		GetArg(argv[4],&arg3,0,0xFFFF,"Arg 3");
	if (argc==6)
		GetArg(argv[5],&arg3,0,0xFFFF,"Arg 4");
	if (argc==7)
		GetArg(argv[6],&arg3,0,0xFFFF,"Arg 5");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		exit(10);
	}

	res = FlyerSelfTest(0,test,arg1,arg2,&result);

//	PromptWait("\nHit a key to boot test Flyer code");

	printf("Error=%ld, Result=%ld\n",res,result);

	if (FlyerBase)
		CloseLibrary(FlyerBase);

	return(0);
}
#endif


ULONG Args[6];

main(int argc,char **argv)
{
	int	i,test;
	ULONG	res,ID;

	if ((argc<2)||(argv[1][0]=='?'))
	{
		printf("Usage: %ls <test> <args...>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&test,0,0xFF,"Test");

	for (i=2;i<argc;i++)
	{
		if ((i-2)<6)
			GetLongArg(argv[i],&Args[i-2],0,0xFFFFFFFF,"Argument");
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	handle = Input();

	printf("Starting test (press RETURN to abort)\n");
	res = RunModule(0,test,NULL,&ID,argc-2,Args);

	for (;;)
	{
		if (WaitForChar(handle,30))
		{
			getchar();
			printf("Trying to abort...\n");
			res = AbortCmd(ID);
			break;
		}
		res = CheckCmd(ID);
		if (res != FERR_BUSY)
		{
			printf("Complete\n");
			break;
		}
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

#if 0
int YesOrNo(char *prompt)
{
	char	c;

#if 0
	while (WaitForChar(handle,1000)) {			/* Flush any that are queued */
		getchar();
	}
#endif

#if 0
	do {
		c = getch();
		printf("(%ld) ",c);
		if (c == 0)
			break;
	} while (c == EOF);
#endif

	printf("%ls?\n",prompt);

#if 0
	while (!WaitForChar(handle,1000)) {}		/* Wait for new */
#endif

	c = getch();

	if ((c=='Y')||(c=='y'))
		return(1);
	else
		return(0);
}


void PromptWait(char *prompt)
{
#if 0
	while (WaitForChar(handle,30)) {			/* Flush any that are queued */
		getchar();
	}
#endif

	printf("%ls\n",prompt);

#if 0
	while (!WaitForChar(handle,30)) {}		/* Wait for new */
#endif
	getch();
}
#endif
