/********************************************************************
* $doshelp.c$ - useful AmigaDOS-related routines
* $Id: DosHelp.c,v 2.14 1995/11/21 15:55:53 Flick Exp $
* $Log: DosHelp.c,v $
*Revision 2.14  1995/11/21  15:55:53  Flick
*Flyer DOS copy, if stops short due to lack of space, now deletes fragment
*created (and will no longer try to copy .i file anyway).
*
*Revision 2.13  1995/10/03  17:29:47  Flick
*Now sets up defaults for more robust prefs file if it doesn't exist
*
*Revision 2.12  1995/10/03  14:03:20  Flick
*No longer writes default UserPrefs file on startup (waits until an option is changed)
*
*Revision 2.11  1995/10/02  15:12:44  Flick
*FCopy now supports new abortable Flyer high-speed copy
*Added Load/SavePrefsData fn's
*
*Revision 2.10  1995/08/09  17:50:04  Flick
*Added arg to NiceCopy, whether to also copy files' .i/.info files -- fixes bug
*with copying subdirs and their contents (.i already exists warnings)
*
*Revision 2.9  1995/06/13  18:03:50  pfrench
*Fixed couple of bugs w/regards to file moving
*
*Revision 2.8  1995/06/01  10:03:44  pfrench
*Now translates disk-full message from flyer-speak to dos-speak
*
*Revision 2.7  1994/12/30  20:28:48  pfrench
*Added waitsprite code while copying.
*
*Revision 2.6  1994/12/20  16:12:06  pfrench
*Added support for file moving vs. copying vs. flyercopy
*
*Revision 2.5  1994/12/17  17:48:07  pfrench
*Added flyer/flyer copy.  still some bugs in the flyer.library
*copyclip() function, copies all files to board0/scsi0/drive0
*
*Revision 2.4  1994/12/07  19:45:50  pfrench
*Now checks for cancel in large file transfers.
*
*Revision 2.3  1994/07/04  18:38:42  CACHELIN4000
**** empty log message ***
*
*Revision 2.2  94/06/07  15:18:58  CACHELIN4000
**** empty log message ***
*
*Revision 2.1  94/03/02  21:05:20  CACHELIN4000
**** empty log message ***
*
*Revision 2.0  94/02/17  16:23:42  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  15:56:41  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  14:43:59  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*	12-17-92	Steve H		Convert to use SmartStrings
*	12-17-92	Steve H		Last Update
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <dos/dos.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <crouton_all.h>

#include <edit.h>
#include <doshelp.h>
#include <request.h>

#include <proto/exec.h>
#include <proto/dos.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

#include <flyer.h>
#include <flyerlib.h>

//#define SERDEBUG	1
#include <serialdebug.h>

#define VERSION_2_0	37L

extern struct Library *FlyerBase;
extern UWORD DOSVersion;
extern LONG GrazerCopyMode;
extern char filepathbuf[300];
extern struct Library *ToasterBase;
extern BPTR BootLock;

VOID DisplayWaitSprite(VOID);
VOID DisplayNormalSprite(VOID);
BPTR __asm GetBootLock(register __a0 struct Library *);

char destfilepathbuf[300];
BOOL Overwrite;
struct Window *LocalWind;

/****** DosHelp/DirectoryChar ***************************************
*
*   NAME
*	DirectoryChar
*
*   SYNOPSIS
*	BOOL DirectoryChar(char c)
*
*   FUNCTION
*	returns TRUE if ':' or '/', else returns FALSE
*
*********************************************************************
*/
BOOL __regargs DirectoryChar(char c)
{
	if (c == ':' || c == '/') return(TRUE);
	else return(FALSE);
}

/****** DosHelp/AppendToPath ****************************************
*
*   NAME
*	AppendToPath
*
*   SYNOPSIS
*	BOOL AppendToPath(struct SmartString *Appendage,struct SmartString *Path)
*
*   FUNCTION
*	Appends a file or directory to the end of a given path
*
*********************************************************************
*/
BOOL __regargs AppendToPath(struct SmartString *Appendage,struct SmartString *Path)
{
	BOOL Success = FALSE;

	if (Appendage && Path) {
		if ((SmartStringLength(Path)) &&
			(!(DirectoryChar(SmartStringRight(Path))))) // if not dir char,
			if (!(AppendCSmartString("/",Path))) return(FALSE); // add one
		Success = AppendSmartString(Appendage,Path);
	}
	return(Success);
}

BOOL __regargs AppendCToPath(char *Appendage,struct SmartString *Path)
{
	BOOL Success = FALSE;

	if (Appendage && Path) {
		if ((SmartStringLength(Path)) &&
			(!(DirectoryChar(SmartStringRight(Path))))) // if not dir char,
			if (!(AppendCSmartString("/",Path))) return(FALSE); // add one
		Success = AppendCSmartString(Appendage,Path);
	}
	return(Success);
}

// Delete file, and whatever icons I can find
LONG  CrDeleteFile(char *fil)
{
  struct SmartString *icon;
  if( (icon=AllocSmartString(fil,NULL)) )
  {
    if(AppendCSmartString(".i",icon) )
    {
      DeleteFile(GetCString(icon));
      if( AppendCSmartString("nfo",icon) )
        DeleteFile(GetCString(icon));
    }
		FreeSmartString(icon);
  }
  return(DeleteFile(fil));
}

/****** DosHelp/DeleteDirectory *************************************
*
*   NAME
*	DeleteDirectory
*
*   SYNOPSIS
*	BOOL DeleteDirectory(struct SmartString *DirName)
*
*   FUNCTION
*	delete everything it can in this directory,
*	calls itself recursively for other dirs,
*	does not delete the directory itself
*
*********************************************************************
*/
BOOL __regargs DeleteDirectory(struct SmartString *DirName)
{
	struct FileInfoBlock *fib = NULL;
	BPTR DirLock = NULL,OldDirLock;
	BOOL Success = FALSE, More;
	struct SmartString *Temp;

	if (DirName && (SmartStringLength(DirName))
		&& (fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR))) {
		DirLock = Lock(GetCString(DirName),ACCESS_READ);
		if (DirLock) {
			OldDirLock = CurrentDir(DirLock);
			if (Examine(DirLock, fib)) {
				More = ExNext(DirLock,fib);
				while (More) {
					if (!(Temp=AllocSmartString(fib->fib_FileName,NULL)))
						goto Exit;
					if (fib->fib_DirEntryType >= 0)
						if (!DeleteDirectory(Temp)) goto Exit;
					More = ExNext(DirLock,fib); // do before DeleteFile()
					if (!DeleteFile(GetCString(Temp))) goto Exit;
					FreeSmartString(Temp);
				}
				Success = TRUE; // deleted everything in directory
			}
Exit:
			CurrentDir(OldDirLock);
			UnLock(DirLock);
		}
		if (fib) FreeMem(fib,sizeof(struct FileInfoBlock));
	}
	return(Success);
}

/****** DosHelp/FileOrDirectory *************************************
*
*   NAME
*	FileOrDirectory
*
*   SYNOPSIS
*	UWORD FileOrDirectory(struct SmartString *Path)
*
*   FUNCTION
*	returns A_FILE,A_DIRECTORY,or A_NON_EXISTANT
*
*********************************************************************
*/
UWORD __regargs FileOrDirectory(struct SmartString *Path)
{
	UWORD Result = A_NON_EXISTANT;
	BPTR ALock = NULL;
	struct FileInfoBlock *fib;
	LONG Type;

	if (fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR|MEMF_PUBLIC)) {
		if (Path && (SmartStringLength(Path)) &&
			(ALock = Lock(GetCString(Path),ACCESS_READ))) {
			if (Examine(ALock,fib)) {
				Type = fib->fib_DirEntryType;
				if ( Type < 0) Result = A_FILE;
				else if (Type >= 0) Result = A_DIRECTORY;
			}
			UnLock(ALock);
		}
		FreeMem(fib,sizeof(struct FileInfoBlock));
	}
	return(Result);
}

/****** DosHelp/CopyDir ********************************************
*
*   NAME
*	CopyDir
*
*   SYNOPSIS
*	LONG CopyDir(char *Source,char *Dest)
*
*   FUNCTION
*	Returns 0 for success, or IoErr() return code on error
*
*********************************************************************
*/
LONG __regargs CopyDir(char *Source,char *Dest)
{
	LONG Error = NULL;
	struct FileInfoBlock *fib;
	BPTR SrcLock=NULL,DestLock = NULL;
	BOOL More;
	struct SmartString *NewSrc=NULL,*NewDst=NULL;

	if (fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR)) {
		if (SrcLock = Lock(Source,ACCESS_READ)) {
		if (Examine(SrcLock,fib)) {

// create dir if doesn't exist
		if (!(DestLock = Lock(Dest,ACCESS_READ)))
			DestLock = CreateDir(Dest);

		if (DestLock) {
			UnLock(DestLock); // free exclusive lock for recursive calls

// copy anything in dir
			More = ExNext(SrcLock,fib);
			while (More) {
				if ((!(NewSrc=AllocSmartString(Source,NULL))) ||
					(!(AppendCToPath(fib->fib_FileName,NewSrc))) ||
					(!(NewDst=AllocSmartString(Dest,NULL))) ||
					(!(AppendCToPath(fib->fib_FileName,NewDst)))) {
					More = FALSE;
					Error = ERROR_NO_FREE_STORE;
				} else {
					if (fib->fib_DirEntryType > 0)
					 Error = CopyDir(GetCString(NewSrc),GetCString(NewDst));
					else
// call NiceCopy() to follow Overwrite preference (DO NOT COPY extras!)
					 Error = NiceCopy(GetCString(NewSrc),GetCString(NewDst),
						fib->fib_FileName,FALSE);

					if (Error) More = FALSE;
					else More = ExNext(SrcLock,fib);
				}
				if (NewSrc) {
					FreeSmartString(NewSrc);
					NewSrc = NULL;
				}
				if (NewDst) {
					FreeSmartString(NewDst);
					NewDst = NULL;
				}
			} // while more

		} else Error = IoErr(); // CreateDir()
		} else Error = IoErr(); // Examine()
		UnLock(SrcLock);
		} else Error = IoErr(); // lock source
		FreeMem(fib,sizeof(struct FileInfoBlock));
	} else Error = ERROR_NO_FREE_STORE;
	return(Error);
}

#define MIN_COPY_BUFFER 50000
LONG FCopy( char *Source, char *Dest, struct FileInfoBlock *fib )
{
	LONG Error = NULL;

	if ( GrazerCopyMode == 1 )
	{
		BPTR		lock;

		/* Don't Delete dest if it's the same file */
		if ( stricmp(Source,Dest) )
		{
			if ( lock = Lock(Dest,ACCESS_READ) )
			{
				UnLock(lock);

				DeleteFile(Dest);
			}
		}

		/* Moving files about on the same drive!! */
		if ( !Rename(Source,Dest) )
		{
			Error = IoErr();
		}
	}
	else if ( GrazerCopyMode == 2 )
	{
		BPTR		lock;
		char		*ch;
		struct FlyerVolume	src_fv,dest_fv;
		struct ClipAction		src_act;

		/* MUST Be initialized to zeroes */
		memset(&src_act,0,sizeof(src_act));
		memset(&src_fv,0,sizeof(src_fv));
		memset(&dest_fv,0,sizeof(dest_fv));

		/* resolve source filepathbuf to volume name */
		lock = Lock(Source,ACCESS_READ);
		NameFromLock(lock,filepathbuf,sizeof(filepathbuf));
		UnLock(lock);

		src_fv.Path = filepathbuf;

		/* Delete file if it's there */
		if ( lock = Lock(Dest,ACCESS_READ) )
		{
			UnLock(lock);
			DeleteFile(Dest);
		}

		/* Prepare destfilepathbuf */
		if ( ch = strchr(Dest,':') )
		{
			char		c;

			/* resolve dest path's volume name */
			ch++;	c = *ch;	*ch = '\0';

			lock = Lock(Dest,ACCESS_READ);
			NameFromLock(lock,destfilepathbuf,sizeof(destfilepathbuf));
			UnLock(lock);
			*ch = c;

			/* Append rest of path */
			strcat(destfilepathbuf,ch);
			// ch = FilePart(destfilepathbuf);
			// *ch = '\0';

			dest_fv.Path = destfilepathbuf;

//			Error = FlyerCopyClip(&src_fv,&dest_fv);		// Old synchronous way (yuck)

			src_act.Volume = &src_fv;
			src_act.ReturnTime = RT_IMMED;

			DUMPSTR("FlyerCopying...");

			Error = FlyerCopyClipNew(&src_act,&dest_fv);		// START clip copying...
			DUMPUDECL ("(start=",Error,") ");
			if (Error == FERR_OKAY)
			{
				DUMPSTR("Waiting...");
				do
				{
					if (CheckNoticeCancel())				// If CANCEL button pressed...
					{
						DUMPSTR("Aborting...");
						AbortAction(&src_act);				// ...abort copy ASAP
						DUMPMSG("Aborted");
						Error = FERR_ABORTED;
						break;
					}
					else
						Error = CheckAction(&src_act);	// Still copying?
				} while (Error == FERR_BUSY);				// Loop until copy is done
				DUMPMSG("Done");
			}

			if (Error == FERR_FULL)
				Error = ERROR_DISK_FULL;
			else if (Error == FERR_ABORTED)
				Error = ERROR_USER_ABORT;
		}
	}
	else
	{
		BPTR SrcHandle = NULL,DestHandle = NULL;
		LONG FileSize,BufferSize,ReadSize;
		UBYTE *Buffer;

		if (SrcHandle = Open(Source,MODE_OLDFILE))
		{
			if (DestHandle = Open(Dest,MODE_NEWFILE))
			{
				FileSize = fib->fib_Size;   // allocate up to file size, if available
				if ((Buffer = SafeAllocMem(BufferSize=FileSize,MEMF_PUBLIC)) ||
					(Buffer = SafeAllocMem(BufferSize=MIN_COPY_BUFFER,MEMF_PUBLIC)))
				{ // read/write loop until done
					while (FileSize && (!Error))
					{
		    			ReadSize = min(FileSize,BufferSize);
						if (ReadSize == Read(SrcHandle,Buffer,ReadSize))
						{
							if (ReadSize == Write(DestHandle,Buffer,ReadSize))
								FileSize -= ReadSize;
							else
								Error = IoErr();
						}
						else
							Error = IoErr();

						if ( !Error && CheckNoticeCancel() )
							Error = ERROR_USER_ABORT;
					}

					FreeMem(Buffer,BufferSize);
				}
				else Error = ERROR_NO_FREE_STORE;

	  			Close(DestHandle);

				if (Error == ERROR_DISK_FULL)
				{
					DeleteFile(Dest);			// Remove partial file that was created
				}
			}
			else
				Error = IoErr();
			Close(SrcHandle);
		}
		else Error = IoErr();
	}

	if (!Error && (DOSVersion >= VERSION_2_0))
	{ // if no error, and DOS 2.0 or later, copy date, protection bits, comment
		SetFileDate(Dest,&fib->fib_Date);
		SetProtection(Dest,fib->fib_Protection);
		SetComment(Dest,fib->fib_Comment);
	}

	return(Error);
}

/****** DosHelp/CopyFile ********************************************
*
*   NAME
*	CopyFile
*
*   SYNOPSIS
*	LONG CopyFile(char *Source,char *Dest,BOOL extras)
*
*   FUNCTION
*	Copies files, and directories recursively
*	Returns 0 for success, or IoErr() return code on error
*	always continues if finds dest directory already exists,
*	but checks Overwrite flag for files
* "Extras" flag determines whether to do .i & .info as well
*
*********************************************************************
*/
LONG __regargs CopyFile(char *Source,char *Dest,BOOL extras)
{
	LONG Error = NULL;
	struct FileInfoBlock *fib;
	BPTR SrcLock = NULL;
	struct SmartString *NewSrc=NULL,*NewDst=NULL;

	// source must exist, and dest must be valid
	if (Source && Dest)
	{
		if (fib = SafeAllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR|MEMF_PUBLIC))
		{    // check source file size
			if (SrcLock = Lock(Source,ACCESS_READ))
			{
				if (Examine(SrcLock,fib))
					UnLock(SrcLock);
				else
				{
					Error = IoErr();
					UnLock(SrcLock);
					goto Exit;
				}
			}
			else
			{
				Error = IoErr();
				goto Exit;
			}

			if (fib->fib_DirEntryType > 0)
			{     // check for dir
				Error = CopyDir(Source,Dest);
			} // copy file
			else
			{
				Error=FCopy(Source,Dest,fib);				// Copy the file

				if (extras && (!Error))	// Copy extra files with it?
				{
					if ( (NewSrc=AllocSmartString(Source,NULL)) && AppendCSmartString(".i",NewSrc) &&
						 (NewDst=AllocSmartString(Dest,NULL)) && AppendCSmartString(".i",NewDst) )
					{
						if (SrcLock = Lock(GetCString(NewSrc),ACCESS_READ))
						{
							if (Examine(SrcLock,fib))
								FCopy(GetCString(NewSrc),GetCString(NewDst),fib);		// Copy .i file
							UnLock(SrcLock);
						}

						if ( AppendCSmartString("nfo",NewSrc) && AppendCSmartString("nfo",NewDst) )
						{
							if (SrcLock = Lock(GetCString(NewSrc),ACCESS_READ))
							{
								if (Examine(SrcLock,fib))
									FCopy(GetCString(NewSrc),GetCString(NewDst),fib);	// Copy .info file
								UnLock(SrcLock);
							}
						}
					}
					if (NewSrc)	FreeSmartString(NewSrc);
					if (NewDst)	FreeSmartString(NewDst);
				}
			} // file copy
Exit:
			FreeMem(fib,sizeof(struct FileInfoBlock));
			return(Error);
		} // if SafeAllocMem()
		else Error = ERROR_NO_FREE_STORE;
	} // if SourcePath && DestPath
	else
		Error = ERROR_OBJECT_NOT_FOUND;

	return(Error);
}

/****** DosHelp/StartNiceCopy ****************************************
*
*   NAME
*	StartNiceCopy
*
*   SYNOPSIS
*	LONG StartNiceCopy(struct Window *Window)
*
*   FUNCTION
*	Returns 0 for success, or IoErr() return code on error
*
*********************************************************************
*/
LONG __regargs StartNiceCopy(
	struct Window *Window,
	BOOL Status,
	BOOL Option)
{
	char *MPtr[2];

	LocalWind = Window;
	if (Status) {
		if ( GrazerCopyMode == 1 )
			MPtr[0] = "Now Moving:";
		else
			MPtr[0] = "Now Copying:";
		MPtr[1] = " ";
		OpenNoticeWindow(Window,MPtr,2,Option);
		DisplayWaitSprite();
	}
	return(0);
}

/****** DosHelp/EndNiceCopy ****************************************
*
*   NAME
*	EndNiceCopy
*
*   SYNOPSIS
*	VOID EndNiceCopy(VOID)
*
*   FUNCTION
*
*********************************************************************
*/
VOID __regargs EndNiceCopy(VOID)
{
	DisplayNormalSprite();
	CloseNoticeWindow();
	Overwrite = FALSE;
}

/****** DosHelp/NiceCopy ********************************************
*
*   NAME
*	NiceCopy
*
*   SYNOPSIS
*	LONG NiceCopy(char *Source,char *Dest,char *JustName,BOOL extras)
*
*   FUNCTION
*	Returns 0 for success, or IoErr() return code on error
*  "Extras" specifies whether to copy the .i/.info file as well
*
*********************************************************************
*/
LONG __regargs NiceCopy(char *Source,char *Dest,char *JustName,BOOL extras)
{
	BPTR DestL;
	char *MPtr[3];

	if (CheckNoticeCancel()) return(ERROR_USER_ABORT);
	if (!Overwrite) {
		if (DestL = Lock(Dest,ACCESS_READ)) {
			UnLock(DestL);
			if (!LocalWind) return(ERROR_OBJECT_EXISTS);
			MPtr[0] = Dest;
			MPtr[1] = "already exists. Do you want to replace";
			MPtr[2] = "all existing files during this copy?";
			if (SimpleRequest(LocalWind,MPtr,3,
				REQ_CENTER|REQ_H_CENTER|REQ_OK_CANCEL,NULL)) {
				Overwrite = TRUE;
			} else {
				return(ERROR_OBJECT_EXISTS);
			}
		}
	}
	UpdateNotice(JustName,1);
	return(CopyFile(Source,Dest,extras));
}

/****** DosHelp/FindParent ******************************************
*
*   NAME
*	FindParent
*
*   SYNOPSIS
*	BOOL FindParent(struct SmartString *Path,UWORD InitialState)
*
*   FUNCTION
*	returns TRUE if able to find and change Path to a parent directory
*	if InitialState 0, goes up a dir, else just removes file at end
*
*********************************************************************
*/
BOOL __regargs FindParent(struct SmartString *Path,UWORD InitialState)
{
	UWORD State = 0,Char;
	BOOL Success = FALSE;
	char c;

	if (Path) {
		Char = SmartStringLength(Path);
		if (Char) {
			if (InitialState) State = 1;
			else
			if ((FileOrDirectory(Path) == A_DIRECTORY)
				&& (!DirectoryChar(SmartStringRight(Path)))) {
				State = 1; // found dir, now parenting
			}
			while ((Char > 0) && (State < 2)) {
				Char--;
				c = SmartStringChar(Path,Char);
				if (DirectoryChar(c)) {
					State++;
				}
			}
			if (State == 2) {
				if (SmartStringChar(Path,Char) == ':') Char += 1;
				Success=PartialEraseSmartString(Path,Char); // just leave parent
			}
		}
	}
	return(Success);
}

/****** DosHelp/FileSize *************************************
*
*   NAME
*	FileSize
*
*   SYNOPSIS
*	LONG FileSize(char *Path)
*
*   FUNCTION
*	returns fib_Size
*
*********************************************************************
*/
LONG __regargs FileSize(char *Path)
{
	BPTR ALock = NULL;
	struct FileInfoBlock *fib;
	LONG L=0;

	if (fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR|MEMF_PUBLIC)) {
		if (Path &&
			(ALock = Lock(Path,ACCESS_READ))) {
			if (Examine(ALock,fib)) {
				L = fib->fib_Size;
			}
			UnLock(ALock);
		}
		FreeMem(fib,sizeof(struct FileInfoBlock));
	}
	return(L);
}

// Replace device name in smart path with volume name
struct SmartString *PathDevToVol(struct SmartString *Path)
{
	BPTR ALock = NULL;
	char	dev[20]="",*c, *FilePart;
	struct FileInfoBlock *fib;
	LONG L=0;
	struct SmartString *NewPath;

	c=GetCString(Path);
	DUMPSTR(c);
	while( *c && (*c!=':') && (L<20) )
		dev[L++] = *c++;
	FilePart=c++; // ':' plus whatever remaining path
	DUMPSTR("    Device Name : ");
	DUMPMSG(dev);
	if (fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR|MEMF_PUBLIC)) {
		if (dev && (ALock = Lock(dev,ACCESS_READ))) {
			if (Examine(ALock,fib))
			{
				if( (NewPath=AllocSmartString(fib->fib_FileName,NULL)) )
				{
					if(*c) AppendCSmartString(FilePart,NewPath);
					FreeSmartString(Path);
				}
				else NewPath=Path;
			}
			UnLock(ALock);
		}
		FreeMem(fib,sizeof(struct FileInfoBlock));
	}
	DUMPSTR("New Path: ");
	c=GetCString(NewPath);
	if(*c) DUMPMSG(FilePart);
	return(NewPath);
}


char PrefsName[] = "Edit_Support/prefs";

int LoadPrefsData(struct EditPrefs *prefs)
{
	BPTR	handle,oldCD;
	int	actual=0;

	if (ToasterBase)
	{
		BootLock = GetBootLock(ToasterBase);
		oldCD = CurrentDir(BootLock);

		if (handle = Open(PrefsName,MODE_OLDFILE))
		{
			actual == Read(handle,prefs,sizeof(struct EditPrefs));			// Read data
			Close(handle);
		}
		else
		{
			memset(prefs,0,sizeof(struct EditPrefs));		// Defaults, in case error
			prefs->UserLevel = USRLVL_IDIOT;
			prefs->SeqFlags = SFF_STOPONERR;
			prefs->WarnFlags = WARNFLAGS_IDIOT;		// All warnings
			prefs->EditFlags = EDITFLAGS_IDIOT;

//DONT DO THIS, IN CASE SWITCHER CRASHES AND THIS INVALIDATES HARD DRIVE!
//			SavePrefsData(prefs);							// Make a prefs file with defaults
		}

		CurrentDir(oldCD);		// Restore CD at entry
	}

	return(actual);
}

int SavePrefsData(struct EditPrefs *prefs)
{
	BPTR	handle,oldCD;
	int	actual=0;

	if (ToasterBase)
	{
		BootLock = GetBootLock(ToasterBase);
		oldCD = CurrentDir(BootLock);

		if (handle = Open(PrefsName,MODE_NEWFILE))
		{
			actual == Write(handle,prefs,sizeof(struct EditPrefs));			// Write data
			Close(handle);
		}

		CurrentDir(oldCD);		// Restore CD at entry
	}

	return(actual);
}


// end of doshelp.c
