/********************************************************************
* Drag.c - implementation specific dragging routines
* $Id: Drag.c,v 2.62 1995/09/25 12:13:52 Flick Exp $
* $Log: Drag.c,v $
*Revision 2.62  1995/09/25  12:13:52  Flick
*Some fn's pass qualifiers around for extra functionality
*Added CTRL-overwrite coerce in CalculateDrop
*
*Revision 2.61  1995/08/18  16:59:03  Flick
*Added support all over for maintaining project current time & running time
*
*Revision 2.60  1995/08/02  15:08:09  Flick
*SELECT ALL then SELECT: CurFG would be stale -- now set to selected crouton
*
*Revision 2.59  1995/06/28  18:05:40  Flick
*Added ew_ForceRedraw f'n
*
*Revision 2.58  1995/06/14  14:54:43  pfrench
*Moved endgrazrequest call out to outermost event loop
*using "global_GrazReqDoubleClicked" flag byte
*
*Revision 2.57  1995/06/14  14:24:57  Flick
*Added ew_MultiSelect function for hiliting multiple FG's
*
*Revision 2.56  1995/06/01  09:21:13  pfrench
*Fixed enforcer hit on ALT double of files crouton
*
*Revision 2.55  1995/02/24  16:46:29  CACHELIN4000
*Change double-click to open panel with alt-qualifier, do auto without
*
*Revision 2.54  1995/02/24  12:04:24  pfrench
*Now preventing enforcer hits on double click causing
*window open/close (like save project)
*
*Revision 2.53  1995/02/20  16:53:48  pfrench
*Fixed potential problem if viewing in files/files mode
*
*Revision 2.52  1995/02/20  16:47:19  pfrench
*Now will bring up controls if double-click crouton in
*the project and not in switcher mode.
*
*Revision 2.51  1994/12/19  22:38:45  pfrench
*Modified for now shared-code proof.library.
*
*Revision 2.50  1994/11/21  13:08:06  pfrench
*Fixed enforcer hits after ending grazer request.
*
*Revision 2.49  1994/11/18  13:38:13  pfrench
*Made deselectotheredit a little quicker
*
*Revision 2.48  1994/11/15  13:37:51  pfrench
*Needed to force error select
*
*Revision 2.47  1994/11/11  11:01:19  pfrench
*Sped up dragging startup with new object method
*
*Revision 2.46  1994/11/09  19:20:51  pfrench
*Fixed more routines for rendering/selecting crouton
*for accesswindow.c
*
*Revision 2.45  1994/11/09  13:49:04  pfrench
*More massaging
*
*Revision 2.44  1994/11/09  12:48:27  pfrench
*Added initial support for croutongrid object
*
*Revision 2.43  1994/10/12  20:15:13  CACHELIN4000
*Fix Display() call, remove prototypes
*
*Revision 2.42  94/09/28  16:07:49  pfrench
*Fixed enforcer hit
*
*Revision 2.41  1994/09/27  18:04:54  pfrench
*Added name printing when navigating with keyboar
*
*Revision 2.40  1994/09/23  10:05:09  CACHELIN4000
*Fix call to DisplayRunningTime()
*
*Revision 2.39  94/09/21  21:33:34  pfrench
*Using new FlushWindowPort call
*
*Revision 2.38  1994/09/20  22:47:14  pfrench
*Modified to work with dircache (Editwindow has ptr to list now)
*
*Revision 2.37  1994/09/12  18:40:54  pfrench
*Navigation now much more efficient and flexible
*
*Revision 2.36  1994/09/08  15:44:00  pfrench
*Added support for AccessWindow update as click-navigate
*
*Revision 2.35  1994/09/02  00:29:12  pfrench
*Fixed selectdown in switcher mode
*
*Revision 2.34  1994/08/31  17:37:51  pfrench
*Got drag working so single-click on a selected crouton will
*deselect all other croutons.
*
*Revision 2.33  1994/08/30  18:30:19  pfrench
*Now save requester works a little smarter than before
*
*Revision 2.32  1994/08/30  18:02:16  pfrench
*Navigation commands now send SelectDefaults.
*
*Revision 2.31  1994/08/30  17:22:32  pfrench
*Multiple-selecting fg's sends a SelectDefault to switcher.
*
*Revision 2.30  1994/08/30  10:33:35  Kell
*Changed SendSwitcherReply calls to work with new ESParams structures.
*
*Revision 2.29  1994/08/29  20:36:13  pfrench
*Enabled double-click of currently (SELECTED) crouton
*
*Revision 2.28  1994/08/29  18:37:41  pfrench
*Now ignores SHIFT-Select in switcher mode
*Non-shift select clears all selected croutons.
*Removes extra MOUSEMOVES after dragging finishes
*
*Revision 2.27  1994/08/27  19:23:14  pfrench
*Fixed ES_Select stuff in editor mode.
*
*Revision 2.26  1994/08/27  00:18:19  CACHELIN4000
**** empty log message ***
*
*Revision 2.25  94/08/26  15:53:12  CACHELIN4000
*add DisplayRunningTime() after DisplayCroutonName()
*
*Revision 2.24  94/08/26  14:55:22  pfrench
*Added Bad crouton flag set
*
*Revision 2.23  1994/08/18  19:46:19  pfrench
*Hit that sweet spot that keeps current switcher FG highlighted
*if its a drag (plug that sweet spot)
*
*Revision 2.22  1994/08/10  15:05:09  pfrench
*Removed multi-select in switcher mode.
*
*Revision 2.21  1994/08/09  12:03:19  pfrench
*Fixed (I think) probjem with de-selecting gads in project
*
*Revision 2.20  1994/08/06  11:49:41  pfrench
*Node code changes.
*
*Revision 2.19  1994/08/01  15:53:59  pfrench
*Removed calls to req file type as those files are being
*filtered out of the grazer again.
*
*Revision 2.18  1994/07/31  14:40:14  pfrench
*Mainly changes to grazer request
*
*Revision 2.17  1994/07/28  18:20:23  pfrench
*Added filename display in upper corner of screen.
*
*Revision 2.16  1994/07/25  10:44:12  pfrench
*Added double-click support for file requester mode.
*
*Revision 2.15  1994/07/21  12:28:08  pfrench
*Added preliminary project/project support
*
*Revision 2.14  1994/07/08  10:09:26  CACHELIN4000
*replace SendSwitcher() calls with SendSwitcherReply()
*
*Revision 2.13  94/06/07  15:20:10  CACHELIN4000
**** empty log message ***
*
*Revision 2.10  94/05/25  16:17:54  CACHELIN4000
*Add select on already selected FGs
*
*Revision 2.5  94/04/22  15:18:24  CACHELIN4000
**** empty log message ***
*
*Revision 2.3  94/04/20  17:44:57  CACHELIN4000
*Navigate commands
*
*Revision 2.2  94/03/29  18:56:53  Kell
*Some error messages added.
*
*Revision 2.1  94/03/18  17:11:21  CACHELIN4000
*Make AUTO_SCROLL eaasier
*
*Revision 2.0  94/02/17  14:44:43  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
* Note: although Projects no longer use EditNodes (they use FastGadgets),
* ptrs to project nodes are still stored as ptrs to EditNodes (be careful!)
*
*	12-17-92	Steve H		Convert to use SmartStrings
*	10-14-93	Steve H		Last Update
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <crouton_all.h>

#include <editwindow.h>
#include <editswit.h>
#include <gadgets.h>
#include <draghelp.h>
#include <project.h>

#include <grazer.h>
#include <doshelp.h>
#include <filelist.h>
#include <grazerrequest.h>

#ifndef PROOF_LIB_H
#include <proof_lib.h>
#endif

#include <croutongrid.h>

#include <proto/exec.h>
#include <proto/graphics.h>
#include <proto/intuition.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

//#define SERDEBUG	1
#include <serialdebug.h>

// drag safety distance
#define X_DISTANCE 12
#define Y_DISTANCE 12

// DropMode (if crouton dropped in current location)
#define DROP_INVALID 0
#define DROP_VALID 1	// if DragDestination FALSE, just VALID
#define DROP_INSERT 2	// if DragDestination TRUE, either INSERT/OVERWRITE
#define DROP_OVERWRITE 3

// AutoScrollMode
#define AUTO_SCROLL_OFF 0
#define AUTO_SCROLL_UP 1
#define AUTO_SCROLL_DOWN 2

#define AUTO_HEIGHT 42

LONG ew_QuickSelect( struct EditWindow *Edit, LONG nodenum );
LONG ew_MultiSelect( struct EditWindow *Edit, LONG nodenum );
LONG ew_ForceRedraw( struct EditWindow *Edit, LONG nodenum );
extern VOID SoftSpriteOn(VOID);
extern VOID SoftSpriteOff(VOID);

extern struct Library *ProofBase;
extern struct List WindowList;
extern struct EditWindow *TimingEdit;
extern struct EditWindow *EditTop,*EditBottom;
extern struct FastGadget *CurFG,*SKellFG;
extern int	CurGrid,CurRow,CurCol;
extern struct SmartString *FileRequestPath;
extern struct Screen *EditScreen;
extern long global_GrazReqDoubleClicked;

extern struct ESParams1 ESparams1;

static struct EditWindow *SelectEdit=NULL;
static struct EditNode *SelectNode=NULL;
static BOOL SelectNodeIsNew;

static struct EditNode *LastDropNode = NULL;
static UWORD LastDropMode = 0;

static BOOL SpriteOff = FALSE;
static struct Float *DragCrouton=NULL,*DropArea=NULL,*DropArea2=NULL;
static struct EditWindow *DragTesting = NULL,
	*DragOn = NULL, // window dragging from
	*DropEdit=NULL; // window if dropped now
static WORD DragTestX,DragTestY; // window coords
static struct EditNode *DragNode; // node used as dragging image
static WORD NewDragX,NewDragY,NewDragW,NewDragH; // screen coords
static struct RastPort *DragRP=NULL; // for RenderNode()
static BOOL DisplayDrag = FALSE;

static UWORD DropMode;
static struct EditNode *DropNode; // node over if dropped now
static struct Box DropBox,DropBox2; // in screen coords
static UWORD AutoScrollMode; // when dragging and at top/bottom of grid

static ULONG StartSecs,StartMicros; // double click test start value
static struct EditNode *DoubleNode; // double click test node

static VOID EndCleanDrag_im( struct IntuiMessage *im );

#define SWITCHER_MODE	( (!EditBottom) && (EditTop->Height != TOP_LARGE) )
#define EDITOR_MODE		(!SWITCHER_MODE)

/****** Drag/InitDrag **********************************************
*
*   NAME
*	InitDrag
*
*   SYNOPSIS
*	BOOL InitDrag(WORD MaxWidth,WORD MaxHeight,UWORD Depth,
*		struct RastPort *RastPort,struct TextFont *Font)
*
*   FUNCTION
*	Called once at program startup
*
*********************************************************************
*/
BOOL __regargs InitDrag(WORD MaxWidth,WORD MaxHeight,UWORD Depth,
	struct RastPort *RastPort,struct TextFont *Font)
{
	BOOL Success = FALSE;

	if (MaxWidth && MaxHeight && Depth && RastPort &&
		(DragCrouton = AllocFloat(MaxWidth,MaxHeight,Depth,RastPort)) &&
		(DropArea = AllocFloat(MaxWidth,MaxHeight,Depth,RastPort)) &&
		(DropArea2 = AllocFloat(MaxWidth,MaxHeight,Depth,RastPort)) &&
		(DragRP = HelpAllocRastPort(MaxWidth,MaxHeight,Depth,MEMF_CHIP))) {
		SetFont(DragRP,Font);
		Success = TRUE;
	}

	if (!Success) FreeDrag();
	return(Success);
}

/****** Drag/FreeDrag ***********************************************
*
*   NAME
*	FreeDrag
*
*   SYNOPSIS
*	VOID FreeDrag(VOID)
*
*   FUNCTION
*	Called once at program termination
*
*********************************************************************
*/
VOID FreeDrag(VOID)
{
	if (DragRP) {
		HelpFreeRastPort(DragRP);
		DragRP = NULL;
	}
	if (DropArea2) {
		FreeFloat(DropArea2);
		DropArea2 = NULL;
	}
	if (DropArea) {
		FreeFloat(DropArea);
		DropArea = NULL;
	}
	if (DragCrouton) {
		FreeFloat(DragCrouton);
		DragCrouton = NULL;
	}
}

/****** Drag/HandleMove ****************************************
*
*   NAME
*	HandleMove
*
*   SYNOPSIS
*	struct EditWindow *HandleMove(struct EditWindow *Edit,
*		struct IntuiMessage *IntuiMsg)
*
*   FUNCTION
*
*
*********************************************************************
*/
struct EditWindow *HandleMove(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg)
{
	WORD X,Y;

	// if dragged far enough, turn it on
	if (DragTesting)
	{
		if ((abs(DragTestX-IntuiMsg->MouseX) > X_DISTANCE)
			|| (abs(DragTestY-IntuiMsg->MouseY) > Y_DISTANCE))
		{

		// clear imagery and begin drag mode
			if ( Edit->ew_cg )
			{
				ob_DoMethod(Edit->ew_cg,CRGRIDM_BeginDrag);
				Edit->RedrawSelect = TRUE;
				Edit->DisplayGrid = TRUE;
				Edit->ew_OptRender = TRUE;
			}
			else
			{
				ChangeStatusList(Edit,EN_SELECTED,EN_DRAGGING);
			}
			DragTesting = NULL;
			DragOn = Edit;
			SpriteOff = TRUE;
			SoftSpriteOff();

		// render image to use during drag
			NewDragW = Edit->ImageWidth;
			NewDragH = Edit->ImageHeight;
			Edit->RenderNode(Edit,DragNode,DragRP,0,0);
			BltBitMap(	DragRP->BitMap,1,1,
							DragRP->BitMap,0,0,NewDragW,NewDragH,
							0xc0,0xff,NULL);
			WaitBlit();
		}
	}

	if (DragOn)
	{
		X = IntuiMsg->MouseX + Edit->Window->LeftEdge;
		Y = IntuiMsg->MouseY + Edit->Window->TopEdge;
		NewDragX = X - (Edit->ImageWidth >> 1);
		NewDragY = Y - (Edit->ImageHeight >> 1);
		DisplayDrag = TRUE;
		CalculateDrop(Edit,X,Y,IntuiMsg->Qualifier);
		CheckAutoMode(X,Y);
	}
	return(Edit);
}

/****** Drag/CalculateDrop ******************************************
*
*   NAME
*	CalculateDrop
*
*   SYNOPSIS
*	VOID CalculateDrop(struct EditWindow *Edit,WORD X, WORD Y)
*
*   FUNCTION
*	X,Y are screen coords
*
*********************************************************************
*/
VOID __regargs CalculateDrop(struct EditWindow *Edit,WORD X, WORD Y, UWORD qualifiers)
{
	WORD TestX,A,Fourth,Half;
	struct Gadget *Grid;
	struct Window *Window;

	DropMode = DROP_INVALID;

	if (DropEdit = OverWhichWindow(X,Y))
	{
		Grid = FindGadget(DropEdit->Gadgets,ID_GRID);
		Window = DropEdit->Window;
		X -= Window->LeftEdge; // to drop window coords
		Y -= Window->TopEdge;

		// if on grid
		if ((X >= Grid->LeftEdge) &&
			(X <= Grid->LeftEdge+Grid->Width-1) &&
			(Y >= Grid->TopEdge) &&
			(Y <= Grid->TopEdge+Grid->Height-1))
		{

			if ( DropEdit->DragDestination )
			{ // does window want this info?

				Half = DropEdit->ColumnSize >> 1;
				Fourth = Half >> 1;
				Y = (Y - Grid->TopEdge + DropEdit->ScrollOffset) / DropEdit->RowSize;
				X -= Grid->LeftEdge;

				TestX = (X + Fourth) / DropEdit->ColumnSize;
				A = TestX + ((Y + DropEdit->RowOffset) * DropEdit->ColumnCount)+1;
				if (A < 0) A = 0;

				DropNode = GetEditNode(DropEdit,A);

				TestX = (X + Fourth) / (DropEdit->ColumnSize >> 1);

				if (qualifiers & IEQUALIFIER_CONTROL)	// User prefers an overwrite?
					DropMode = DROP_OVERWRITE;
				else
					DropMode = (TestX % 2) + 2; // INSERT(2) or OVERWRITE(3)

				if (!DropNode) DropMode = DROP_INSERT; // can't OVERWRITE nothing

				// now calculate drop guide coords
				DropBox.Width = 0; // flag that no box (if insert after btm right)
				DropBox2.Width = 0; // flag that no second box

				if (GetBox(DropEdit,A,&DropBox) && (DropMode == DROP_INSERT))
				{
					DropBox.LeftEdge -= Half;

					// need a second box
					if (DropBox.LeftEdge < Grid->LeftEdge)
					{ // left edge of grid
						DropBox.LeftEdge = Grid->LeftEdge;
						DropBox.Width = Half;

						if (DropBox.TopEdge > Grid->TopEdge)
						{ // not on top row
							DropBox2.TopEdge = DropBox.TopEdge - DropEdit->RowSize;
							DropBox2.LeftEdge = Grid->LeftEdge + (DropEdit->ColumnSize *
								(DropEdit->ColumnCount-1)) + Half;
							DropBox2.Width = Half;
							DropBox2.Height = DropEdit->RowSize;
							ClipToGadget(&DropBox2,Grid);
						}
					}
				}

				DropBox.LeftEdge += Window->LeftEdge; // convert to screen coord
				DropBox.TopEdge += Window->TopEdge;
				if (DropBox2.Width)
				{
					DropBox2.LeftEdge += Window->LeftEdge;
					DropBox2.TopEdge += Window->TopEdge;
				}
			}
			else	/* (!DragDestination) window does not want this info */
			{
				DropMode = DROP_VALID;
				DropNode = NULL;
				DropBox.Width = 0;
				DropBox2.Width = 0;
			}
		}
	}
}

/****** Drag/OverWhichWindow ****************************************
*
*   NAME
*	OverWhichWindow
*
*   SYNOPSIS
*	struct EditWindow *OverWhichWindow(WORD X,WORD Y)
*
*   FUNCTION
*	X,Y are SCREEN coords
*
*********************************************************************
*/
struct EditWindow *__regargs OverWhichWindow(WORD X,WORD Y)
{
	struct EditWindow *Edit,*Next;
	struct Window *Window;

	Edit = (struct EditWindow *)WindowList.lh_Head;
	while (Next=(struct EditWindow *)Edit->Node.MinNode.mln_Succ) {
		Window = Edit->Window;
		if ((X >= Window->LeftEdge) &&
			(X <= Window->LeftEdge+Window->Width-1) &&
			(Y >= Window->TopEdge) &&
			(Y <= Window->TopEdge+Window->Height-1)) return(Edit);
		Edit = Next;
	}
	return(NULL);
}

/****** Drag/GetBox *************************************************
*
*   NAME
*	GetBox
*
*   SYNOPSIS
*	BOOL GetBox(struct EditWindow *Edit,UWORD Offset,struct Box *Box)
*
*   FUNCTION
*	Fills in Box structure, window coords
*
*********************************************************************
*/
BOOL __regargs GetBox(struct EditWindow *Edit,UWORD Offset,struct Box *Box)
{
	BOOL Success = FALSE;
	WORD X1,Y1,X2,Y2,A,B;
	struct Gadget *Grid;

	if (Offset) {
		Grid = FindGadget(Edit->Gadgets,ID_GRID);
		A = Offset - 1 - (Edit->RowOffset * Edit->ColumnCount);
		X1 = A % Edit->ColumnCount;
		Y1 = A / Edit->ColumnCount;
		X1 = Grid->LeftEdge + (X1 * Edit->ColumnSize);
		Y1 = Grid->TopEdge + (Y1 * Edit->RowSize) - Edit->ScrollOffset;
		X2 = X1 + Edit->ColumnSize - 1;
		Y2 = Y1 + Edit->RowSize - 1;

		A = Grid->TopEdge;
		B = Grid->TopEdge + Grid->Height - 1;
		if (Y1 < A) Y1 = A;
		if (Y2 > B) Y2 = B;

		Box->LeftEdge = X1;
		Box->TopEdge = Y1;
		Box->Width = X2 - X1 + 1;
		Box->Height = Y2 - Y1 + 1;
		Success = TRUE;
	}
	return(Success);
}

LONG ew_ScrollToRow( struct EditWindow *Edit, UWORD row )
{
	LONG			retval = 0;
	UWORD			proj_botrow;

	// Get the bottom row of the project
	if ( Edit->Height == TOP_LARGE )
		proj_botrow = Edit->RowOffset + 7;
	else
		proj_botrow = Edit->RowOffset + 3;

	if (	(row < Edit->CurrentRows) &&
				((row < Edit->RowOffset) ||
				 (row > proj_botrow)) )
	{
		if ( row < Edit->RowOffset )
		{
			Edit->RowOffset = row;
		}
		else
		{
			Edit->RowOffset += (row - proj_botrow);
		}

		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = FALSE;

		RowOffsetToPot(Edit);
	}

	return(retval);
}

LONG ew_NavigateNodeNum( struct EditWindow *Edit, LONG nodenum )
{
	LONG				retval = 0;

	if(SKellFG)
	{
		SKellFG=NULL;
		SendSwitcherReply(ES_SelectDefault,NULL);
	}

	if( Edit->Node.Type==EW_PROJECT )
	{
		struct FastGadget		*fg = *(((struct Project *)Edit->Special)->PtrPtr);

		if ( nodenum > 0 )
		{
			if ( !(fg = GetProjNode(fg,nodenum)) )
			{
				fg = (struct FastGadget *)GetLastEditNode(Edit);
			}
		}	/* zero or negative nodenums select first gad */

		if ( fg )
		{
			// SelectNodeInAccessWindow returns a node number
			nodenum = SelectNodeInAccessWindow(Edit,fg);

			if( Edit->ew_cg )
			{
				ULONG		croutonmode = CROUTONSELECT_SELECTED;

				if ( SWITCHER_MODE )
					croutonmode |= CROUTONSELECT_NAVIGATE;

				ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
					nodenum,GRIDSELECT_NORMAL,croutonmode);

				Edit->RedrawSelect = TRUE;
				Edit->DisplayGrid = TRUE;
				Edit->ew_OptRender = TRUE;
			}
			else
			{
				ChangeStatusList(Edit,EN_SELECTED,EN_NORMAL);

				fg->FGDiff.FGNode.Status = EN_SELECTED;
				fg->FGDiff.FGNode.Redraw = TRUE;
			}

			CurFG=fg;

			// Scroll the Edit to the new nodepos
			ew_ScrollToRow(Edit,(nodenum >> 3));
			DisplayCroutonName(((struct ExtFastGadget *)fg)->FileName);
		}
	}

//	SetCurrentTime(-1);			// Navigation clears current time display

	return(retval);
}

LONG ew_QuickSelect( struct EditWindow *Edit, LONG nodenum )
{
	if( Edit->ew_cg )
	{
		ULONG		croutonmode = CROUTONSELECT_SELECTED;

		if ( SWITCHER_MODE )
			croutonmode |= CROUTONSELECT_NAVIGATE;

		ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
			nodenum,GRIDSELECT_NORMAL,croutonmode);

		Edit->RedrawSelect = TRUE;
		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = TRUE;
	}
	else
	{
		struct EditNode	*en = NULL;

		if ( nodenum >= 0 )
		{
			if ( !(en = GetEditNode(Edit,nodenum+1)) )
			{
				en = GetLastEditNode(Edit);
			}
		}

		ChangeStatusList(Edit,EN_SELECTED,EN_NORMAL);

		if ( en )
		{
			ChangeStatusNode(Edit,en,EN_SELECTED);
		}
	}

	return(0);
}


LONG ew_MultiSelect( struct EditWindow *Edit, LONG nodenum )
{
	if( Edit->ew_cg )
	{
		ULONG		croutonmode = CROUTONSELECT_SELECTED;

		if ( SWITCHER_MODE )
			croutonmode |= CROUTONSELECT_NAVIGATE;

		ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
			nodenum,GRIDSELECT_MULTIPLE,croutonmode);

		Edit->RedrawSelect = TRUE;
		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = TRUE;
	}

	return(0);
}


LONG ew_ForceRedraw( struct EditWindow *Edit, LONG nodenum )
{
	if( Edit->ew_cg )
	{
		ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
			nodenum,GRIDSELECT_REDRAW,NULL);

		Edit->RedrawSelect = TRUE;
		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = TRUE;
	}

	return(0);
}


BOOL NavigateFirst(struct EditWindow *Edit)
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		ew_NavigateNodeNum(Edit,0);

		CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}

	return(FALSE);
}

BOOL NavigateLast(struct EditWindow *Edit)
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		ew_NavigateNodeNum(Edit,LONG_MAX);

		CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}

	return(FALSE);
}

BOOL NavigateRight(struct EditWindow *Edit, UWORD Qualifier )
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		LONG		nodenum = 0;

		if ( CurFG )
		{
			nodenum = GetProjNodeOrder(Edit,CurFG);

			if ( Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
				nodenum |= 0x07;
			else if ( Qualifier & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
				nodenum = LONG_MAX;
			else
				nodenum += 1;
		}

		ew_NavigateNodeNum(Edit,nodenum);

		if (Qualifier & IEQUALIFIER_CONTROL)		// Zip mode?
			SetCurrentTime(-1);			// Navigation clears current time display
		else
			CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}
	return(FALSE);
}

BOOL NavigateLeft(struct EditWindow *Edit, UWORD Qualifier )
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		LONG		nodenum = 0;

		if ( CurFG )
		{
			nodenum = GetProjNodeOrder(Edit,CurFG);

			if ( Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
				nodenum &= ~0x07;
			else if ( Qualifier & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
				nodenum = 0;
			else
				nodenum -= 1;
		}

		ew_NavigateNodeNum(Edit,nodenum);

		if (Qualifier & IEQUALIFIER_CONTROL)		// Zip mode?
			SetCurrentTime(-1);			// Navigation clears current time display
		else
			CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}
	return(FALSE);
}


BOOL NavigateDown(struct EditWindow *Edit, UWORD Qualifier )
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		LONG		nodenum = 0;

		if ( CurFG )
		{
			nodenum = GetProjNodeOrder(Edit,CurFG);

			if ( Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
				nodenum += 8 * 4;
			else if ( Qualifier & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
				nodenum = ((Edit->CurrentRows-1) * 8) + (nodenum & 0x07);
			else
				nodenum += 8;
		}

		ew_NavigateNodeNum(Edit,nodenum);

		if (Qualifier & IEQUALIFIER_CONTROL)		// Zip mode?
			SetCurrentTime(-1);			// Navigation clears current time display
		else
			CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}
	return(FALSE);
}


BOOL NavigateUp(struct EditWindow *Edit, UWORD Qualifier )
{
	if ( Edit->Node.Type == EW_PROJECT )
	{
		LONG		nodenum = 0;

		if ( CurFG )
		{
			nodenum = GetProjNodeOrder(Edit,CurFG);

			if ( Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
				nodenum -= 8 * 4;
			else if ( Qualifier & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
				nodenum &= 0x07;
			else
				nodenum -= 8;
		}

		ew_NavigateNodeNum(Edit,nodenum);

		if (Qualifier & IEQUALIFIER_CONTROL)		// Zip mode?
			SetCurrentTime(-1);			// Navigation clears current time display
		else
			CalcCurrentTime(CurFG);		// Calc/display CurFG's time
	}
	return(FALSE);
}

//*******************************************************************
VOID __regargs DeselectOtherEdit(struct EditWindow *Edit)
{
	struct EditWindow		*OtherEdit = NULL;

	if ( Edit == EditTop )
	{
		OtherEdit = EditBottom;
	}
	else if ( Edit == EditBottom )
	{
		OtherEdit = EditTop;
	}

	if ( OtherEdit )
	{
		if ( OtherEdit->ew_cg )
		{
			ob_DoMethod( OtherEdit->ew_cg,CRGRIDM_SelectCrouton,
				-1,GRIDSELECT_NORMAL,CROUTONSELECT_NORMAL);

			OtherEdit->DisplayGrid = TRUE;
			OtherEdit->ew_OptRender = TRUE;
		}
		else
		{
			ChangeStatusList(OtherEdit,EN_SELECTED,EN_NORMAL);
		}
	}
}

/****** Drag/HandleGrid ****************************************
*
*   NAME
*	HandleGrid
*
*   SYNOPSIS
*	struct EditWindow *HandleGrid(struct EditWindow *Edit,
*		struct IntuiMessage *IntuiMsg)
*
*   FUNCTION
*
*
*********************************************************************
*/
struct EditWindow *HandleGrid(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg)
{
	struct EditNode *Node;
	BOOL ShiftDown;

	Node = OverWhichNode(Edit,IntuiMsg->MouseX+Edit->Window->LeftEdge,
		IntuiMsg->MouseY+Edit->Window->TopEdge);

	if (IntuiMsg->Class == GADGETDOWN)
	{
		ShiftDown = IntuiMsg->Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT);

		DeselectOtherEdit(Edit); // clear anything selected in other window on screen

		if (!Node) 		// if not over valid crouton, clear any selected ones
		{
			if( Edit->ew_cg )
			{
				ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
					-1,GRIDSELECT_NORMAL,CROUTONSELECT_NORMAL);

				Edit->RedrawSelect = TRUE;
				Edit->DisplayGrid = TRUE;
				Edit->ew_OptRender = TRUE;
			}
			else
			{
				Node = NULL;
				if(SKellFG) {
					SKellFG=NULL;
					SendSwitcherReply(ES_SelectDefault,NULL);
				}

				ChangeStatusList(Edit,EN_SELECTED,EN_NORMAL);
			}

			if( Edit->Node.Type==EW_PROJECT )  // Never let NO FG be selected
			{
				CurFG = NULL;
			}

			SetCurrentTime(-1);				// Remove
		}
		else if ( !(SWITCHER_MODE && ShiftDown) )
		{ 	// if shift key not down, clear any selected ones
			// (unless hit crouton already selected, then leave others selected)
			LONG nodenum = -1;

			if ( SKellFG && (Node != (struct EditNode *)SKellFG) )
			{
				SKellFG=NULL;
				SendSwitcherReply(ES_SelectDefault,NULL);
			}

			if( (GetEditNodeBehavior(Edit,Node)&EN_SELECT_ACTION) &&
					Edit->NodeSelect && (!ShiftDown))
			{
				SelectEdit = Edit; // possibly going to send a select msg
				SelectNode = Node; // (if not dragged)
			}

			if ( Edit->Node.Type==EW_PROJECT )
			{
				if ( ShiftDown )
				{
					SelectNodeInAccessWindow(Edit,NULL);
					nodenum = GetProjNodeOrder(Edit,(struct FastGadget *)Node);
				}
				else
				{
					nodenum = SelectNodeInAccessWindow(Edit,(struct FastGadget *)Node);
				}
			}
			else if ( Edit->Node.Type==EW_GRAZER )
			{
				nodenum = GetGrazerNodeOrder(Edit,Node);
			}

			if ( GetEditNodeStatus(Edit,Node) == EN_NORMAL )	// if unselected, select
			{
				STRPTR	nodename;

				SelectNodeIsNew = TRUE;

				if(Edit->Node.Type==EW_PROJECT)
					nodename = ((struct ExtFastGadget *)Node)->FileName;
				else
					nodename = GetCString(Node->Node.Name);

				DisplayCroutonName( nodename );
//				if (IntuiMsg->Qualifier & IEQUALIFIER_CONTROL)

				if ( Edit->Node.Type==EW_PROJECT )
				{
					// Calculate and update crouton's current time
					CalcCurrentTime((struct FastGadget *)Node);
				}
				else
					SetCurrentTime(-1);		// Remove for grazer gadgets

//				DisplayRunningTime();

				if( Edit->ew_cg )
				{
					ULONG		selectmode = GRIDSELECT_NORMAL;
					ULONG		croutonmode = CROUTONSELECT_SELECTED;

					if ( ShiftDown )
						selectmode = GRIDSELECT_MULTIPLE;

					if ( SWITCHER_MODE )
						croutonmode |= CROUTONSELECT_NAVIGATE;

					ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
						nodenum,selectmode,croutonmode);

					Edit->RedrawSelect = TRUE;
					Edit->DisplayGrid = TRUE;
					Edit->ew_OptRender = TRUE;
				}
				else
				{
					if (!ShiftDown)
						ChangeStatusList(Edit,EN_SELECTED,EN_NORMAL);

					ChangeStatusNode(Edit,Node,EN_SELECTED);
				}

				if( Edit->Node.Type==EW_PROJECT )
				{
					// set CurGrid in render routine;
					CurFG=(struct FastGadget *)Node;
				}
				else if (global_gr)
				{
					struct GrazerRequest	*gr = global_gr;
					struct GrazerNode		*GNode = (struct GrazerNode *)Node;

					// No valid pathname set as of yet.
					gr->gr_Flags &= ~(GRAZREQ_VALIDFILENAME);

					if ( GNode->DOSClass == EN_FILE )
					{
						struct Grazer *Grazer = (struct Grazer *)Edit->Special;

						if ( gr->gr_FilePath) FreeSmartString(gr->gr_FilePath);

						if ( gr->gr_FilePath = DuplicateSmartString(Grazer->Path) )
						{
							BOOL			ok = TRUE;

							if (!DirectoryChar(SmartStringRight(gr->gr_FilePath)))
								if (!AppendCSmartString("/",gr->gr_FilePath))
									ok = FALSE;

							if ( ok && AppendSmartString(Node->Node.Name,gr->gr_FilePath) )
							{
								gr->gr_Flags |= GRAZREQ_VALIDFILENAME;

								if ( gr->gr_Flags & GRAZREQ_ALLOWCREATE )
								{
									struct Gadget *Gadget;

									if ( Gadget = FindGadget(EditTop->Gadgets,ID_PATH) )
									{
										UpdateStringGadgetText(EditTop->Window,Gadget,nodename);
										RefreshGList(Gadget,EditTop->Window,NULL,1);
									}
								}
							}
						}
					}
				}

				if ((Edit->AllowDrag) && (GetEditNodeBehavior(Edit,Node)&EN_DRAGGABLE))
					BeginDragTest(Edit,IntuiMsg,Node);

				SetStartTime(Node,IntuiMsg);

			}	// else if already select, deselect if shift down
			else if (GetEditNodeStatus(Edit,Node) == EN_SELECTED)
			{
				SelectNodeIsNew = FALSE;

				if (ShiftDown)
				{
					if( Edit->ew_cg )
					{
						ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
							nodenum,GRIDSELECT_MULTIPLE,CROUTONSELECT_NORMAL);

						Edit->RedrawSelect = TRUE;
						Edit->DisplayGrid = TRUE;
						Edit->ew_OptRender = TRUE;
					}
					else
					{
						ChangeStatusNode(Edit,Node,EN_NORMAL);
					}

					if( SKellFG )
					{
						SKellFG=NULL;
						SendSwitcherReply(ES_SelectDefault,NULL);
					}
				}
				else
				{
					if ((Edit->AllowDrag) && (GetEditNodeBehavior(Edit,Node) & EN_DRAGGABLE))
						BeginDragTest(Edit,IntuiMsg,Node);

					if ((Edit->NodeDouble) && (DoubleNode == Node)
						&& (GetEditNodeBehavior(Edit,Node)&EN_DOUBLE_ACTION)
						&& (DoubleClick(StartSecs,StartMicros,IntuiMsg->Seconds,IntuiMsg->Micros)))
					{	// if double-click valid, call client

						DragTesting = DragOn = NULL;
						EndDrag();

						if (	global_gr && (((struct GrazerNode *)Node)->DOSClass == EN_FILE) )
						{
							global_GrazReqDoubleClicked = TRUE;
						}
						else
						{
/*
							if (	(EDITOR_MODE) &&
									(Edit->Node.Type==EW_PROJECT) &&
									(Edit == EditTop) )
*/

							if( (Edit->Node.Type==EW_PROJECT) &&
								 (IntuiMsg->Qualifier&(IEQUALIFIER_LALT|IEQUALIFIER_RALT)) )
							{
								HandlePanel(Edit,IntuiMsg);			// Bring up control panel
							}
							else
							{
								Edit->NodeDouble(Edit,Node);
							}
						}
					}
					else if (SWITCHER_MODE)
					{  // how do I tell 1st of double-click/drag on selected from click on selected
						SetStartTime(Node,IntuiMsg);
						if(Node==(struct EditNode *)SKellFG)
						{
							// If error occurs

							ESparams1.Data1=(LONG)Node;
							if ( SendSwitcherReply(ES_Select,&ESparams1) )
							{
								struct FastGadget	*fg = (struct FastGadget *)Node;

								fg->FGDiff.FGNode.Behavior |= EN_BADCROUTON;
								fg->FGDiff.FGNode.Redraw = TRUE;

								if( Edit->ew_cg )
								{
									ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
										nodenum,GRIDSELECT_MULTIPLE,
										CROUTONSELECT_SELECTED|CROUTONSELECT_ERROR);
								}
							}
						}
					}
					else
					{		/*** Clicked on an already-selected crouton w/o SHIFT ***/

						if ( Edit->Node.Type==EW_PROJECT )
						{
							// Calculate and update crouton's current time
							CalcCurrentTime((struct FastGadget *)Node);
						}
						else
							SetCurrentTime(-1);		// Remove for grazer gadgets
					}
				}

				SetStartTime(Node,IntuiMsg);
			}
		}
	}
	else if (IntuiMsg->Class == GADGETUP)
	{	// Send too many ES_SelectDefault messages in multi-select events
		// if(ShiftDown) SendSwitcherReply(ES_SelectDefault,NULL);

		EndCleanDrag_im(IntuiMsg);  // if dragging, check drop location
	}
	return(Edit);
}

//*********************************************************************
VOID EndCleanDrag(struct IntuiMessage *im)
{
	EndCleanDrag_im(im);
}

static VOID EndCleanDrag_im( struct IntuiMessage *im )
{
	if (DragOn)
	{
		RestoreFloat(DragCrouton); // restore no matter what
		if (SpriteOff)
		{
			SpriteOff = FALSE;
			SoftSpriteOn();
		}

		if ( SWITCHER_MODE )
		{
#ifdef OLDWAY
			if( EditTop->ew_cg )
			{
				LONG		nodenum;

				nodenum = GetProjNodeOrder(EditTop,SKellFG);

				ob_DoMethod( EditTop->ew_cg,CRGRIDM_SelectCrouton,
					nodenum,GRIDSELECT_NORMAL,
					CROUTONSELECT_SELECTED|CROUTONSELECT_NAVIGATE);

				EditTop->RedrawSelect = TRUE;
				EditTop->DisplayGrid = TRUE;
				EditTop->ew_OptRender = TRUE;
			}
			else
#endif
			{
				ChangeStatusList(EditTop,EN_SELECTED,EN_NORMAL);
				if(SKellFG)
					ChangeStatusNode(EditTop,(struct EditNode *)SKellFG,EN_SELECTED);
			}
		}

	} else if ( SelectNode )
	{
		if ( im && !(im->Qualifier & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT)) )
		{
			if( SelectEdit->ew_cg )
			{
				LONG		nodenum = -1;

				if ( SelectEdit->Node.Type == EW_PROJECT )
					nodenum = GetProjNodeOrder(SelectEdit,(struct FastGadget *)SelectNode);
				else if ( SelectEdit->Node.Type==EW_GRAZER )
					nodenum = GetGrazerNodeOrder(SelectEdit,SelectNode);

				ob_DoMethod( SelectEdit->ew_cg,CRGRIDM_SelectCrouton,
					nodenum,GRIDSELECT_NORMAL,CROUTONSELECT_SELECTED);

				SelectEdit->RedrawSelect = TRUE;
				SelectEdit->DisplayGrid = TRUE;
				SelectEdit->ew_OptRender = TRUE;
				CurFG=(struct FastGadget *)SelectNode;		// Just 1 selected again
			}
			else
			{
				ChangeStatusList(SelectEdit,EN_SELECTED,EN_NORMAL);
				ChangeStatusNode(SelectEdit,SelectNode,EN_SELECTED);
			}

			if ( !SelectNodeIsNew )
			{
				if ( SelectEdit->Node.Type == EW_PROJECT )
					((struct FastGadget *)SelectNode)->FGDiff.FGNode.Redraw = FALSE;
				else
					SelectNode->Redraw = FALSE;
			}
		}

		if ( im && SelectNodeIsNew )
			SelectEdit->NodeSelect(SelectEdit,SelectNode);
	}
	SelectNode = NULL;
	DragDrop(im ? im->Qualifier : 0);
	EndDrag();
}

//*********************************************************************
VOID __regargs SetStartTime(struct EditNode *Node,struct IntuiMessage *IntuiMsg)
{
	DoubleNode = Node;
	StartSecs = IntuiMsg->Seconds;
	StartMicros = IntuiMsg->Micros;
}

/****** Drag/OverWhichNode ******************************************
*
*   NAME
*	OverWhichNode
*
*   SYNOPSIS
*	struct EditNode *OverWhichNode(struct EditWindow *Edit,WORD X,WORD Y)
*
*   FUNCTION
*	X,Y are SCREEN coords
*	Call if you know the hit was over this EditWindow
*
*********************************************************************
*/
struct EditNode *__regargs OverWhichNode(struct EditWindow *Edit,WORD X,WORD Y)
{
	struct Gadget *Grid;
	struct EditNode *Node=NULL;
	WORD A;

	Grid = FindGadget(Edit->Gadgets,ID_GRID);
	X -= Edit->Window->LeftEdge; // convert to window coords
	Y -= Edit->Window->TopEdge;

	if (	(X >= Grid->LeftEdge) && (X <= Grid->LeftEdge+Grid->Width) &&
			(Y >= Grid->TopEdge) && (Y <= Grid->TopEdge+Grid->Height) )
	{
		X -= Grid->LeftEdge;
		Y = Y - Grid->TopEdge + Edit->ScrollOffset;
		X /= Edit->ColumnSize;
		Y /= Edit->RowSize;
		A = X + ((Y + Edit->RowOffset) * Edit->ColumnCount) + 1;
		Node = GetEditNode(Edit,A);
	}
	return(Node);
}

/****** Drag/ChangeStatusList ***************************************
*
*   NAME
*	ChangeStatusList
*
*   SYNOPSIS
*	BOOL ChangeStatusList(struct EditWindow *Edit,UWORD From,UWORD To)
*
*   FUNCTION
*
*
*********************************************************************
*/
BOOL __regargs ChangeStatusList(struct EditWindow *Edit,UWORD From,UWORD To)
{
	struct EditNode *Node,*Next;
	struct FastGadget *FG;
	BOOL Success = FALSE;

	if (Edit)
	{
		switch(Edit->Node.Type)
		{
		case EW_GRAZER:
			Node = (struct EditNode *)Edit->Special->pEditList->lh_Head;
			while (Next=(struct EditNode *)Node->Node.MinNode.mln_Succ)
			{
				if ((From == EN_NOT_STATUS) || (Node->Status == From))
				{
					Node->Status = To;
					Node->Redraw = TRUE;
					Edit->RedrawSelect = TRUE;
					Edit->DisplayGrid = TRUE;
				}
				Node = Next;
			}
			Success = TRUE;
		break;

		case EW_PROJECT:
			FG = *(((struct Project *)Edit->Special)->PtrPtr);
			while (FG)
			{
				if ((From == EN_NOT_STATUS) || (FG->FGDiff.FGNode.Status == From))
				{
					FG->FGDiff.FGNode.Status = To;
					FG->FGDiff.FGNode.Redraw = TRUE;
					Edit->RedrawSelect = TRUE;
					Edit->DisplayGrid = TRUE;
				}
				FG = FG->NextGadget;
			}    // if curFG was just deselected, reset to first FG
			Success = TRUE;
		}

		if ( Edit->ew_cg )
		{
			/* De-selecting status of all nodes no matter what */
			if (	((From == EN_NOT_STATUS) && (To == EN_NORMAL)) /* ||
					((From == EN_SELECTED) && (To == EN_NORMAL)) */ )
			{
				ob_DoMethod( Edit->ew_cg,CRGRIDM_SelectCrouton,
					-1,GRIDSELECT_NORMAL,CROUTONSELECT_NORMAL);

				Edit->RedrawSelect = TRUE;
				Edit->DisplayGrid = TRUE;
				Edit->ew_OptRender = TRUE;
			}
		}
	}
	return(Success);
}

/****** Drag/ChangeStatusNode ***************************************
*
*   NAME
*	ChangeStatusNode
*
*   SYNOPSIS
*	BOOL ChangeStatusNode(struct EditWindow *Edit,struct EditNode *Node,
*		UWORD To)
*
*   FUNCTION
*
*
*********************************************************************
*/
BOOL __regargs ChangeStatusNode(struct EditWindow *Edit,struct EditNode *Node,
	UWORD To)
{
	BOOL Success = FALSE;
	struct FastGadget *FG;

	if ( Node )
	{
		Edit->RedrawSelect = TRUE;
		Edit->DisplayGrid = TRUE;
		Success = TRUE;

		if (Edit->Node.Type == EW_GRAZER)
		{
			Node->Status = To;
			Node->Redraw = TRUE;
		}
		else
		{  // don't deselect current FG
			FG = (struct FastGadget *)Node;
			FG->FGDiff.FGNode.Status = To;
			FG->FGDiff.FGNode.Redraw = TRUE;
		}
	}
	return(Success);
}

/****** Drag/BeginDragTest ******************************************
*
*   NAME
*	BeginDragTest
*
*   SYNOPSIS
*	VOID BeginDragTest(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg,
*		struct EditNode *Node)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID __regargs BeginDragTest(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg,
	struct EditNode *Node)
{
	DragTestX = IntuiMsg->MouseX;
	DragTestY = IntuiMsg->MouseY;
	DragTesting = Edit;
	DragNode = Node;
	ReportMouse(TRUE,Edit->Window);
}

/****** Drag/EndDrag ************************************************
*
*   NAME
*	EndDrag
*
*   SYNOPSIS
*	VOID EndDrag(VOID)
*
*   FUNCTION
*	Ends AutoDrag modes and Drag mode
*
*********************************************************************
*/
VOID EndDrag(VOID)
{
	struct EditWindow *Edit = NULL;

	EndAutoScroll();

	if (SpriteOff)
	{
		SpriteOff = FALSE;
		SoftSpriteOn();
	}

	if (DragOn)
		Edit = DragOn;

	if (DragTesting)
		Edit = DragTesting;

	if ( Edit )
	{
		struct Window	*win;

		if ( win = Edit->Window )
		{
			win->Flags &= ~(WFLG_REPORTMOUSE);

			// Remove all MouseMoves as they were causing the editor to crash
			FlushWindowPort(win,IDCMP_MOUSEMOVE);
		}

		DisplayDrag = TRUE; // need to restore saved data
	}
	DragTesting = DragOn = NULL;
}

/****** Drag/DisplayGrid ********************************************
*
*   NAME
*	DisplayGrid
*
*   SYNOPSIS
*	VOID DisplayGrid(UWORD RowOffset,UWORD ScrollOffset,
*		struct EditWindow *Edit)
*
*   FUNCTION
*	Displays grid, string gadgets, drag and drop areas
*
*********************************************************************
*/
VOID __regargs DisplayGrid(UWORD RowOffset,UWORD ScrollOffset,struct EditWindow *Edit)
{
	ULONG Drawn,Top,Height;
	struct RastPort *RP;
	struct Gadget *Grid;
	UWORD WaitY,Y1,Y2;
	BOOL SpecialRedraw;

	if (	(Edit->DisplayGrid || DisplayDrag) &&
				(Grid = FindGadget(Edit->Gadgets,ID_GRID)) )
	{ // anything to draw?
		RP = Edit->Window->RPort;
		SetAPen(RP,SCREEN_PEN);
		Top = Edit->Window->TopEdge+Grid->TopEdge;
		Height = Grid->Height - 1;

	// wait until last scanline before begin rendering
		if (DropMode > DROP_VALID) {
			if (DropBox.Width) Y1 = DropBox.TopEdge+DropBox.Height;
			else Y1 = 0;
			if (DropBox2.Width) Y2 = DropBox2.TopEdge+DropBox2.Height;
			else Y2 = 0;
			Y1 = max(Y1,Y2);
		} else Y1 = 0;

		WaitY = max(Y1,(NewDragY+Edit->ImageHeight));
		WaitY = (WaitY + 88 + Edit->Screen->TopEdge) >> 1;
		WaitForVPos(WaitY);

		RestoreFloat(DragCrouton); // restore no matter what

		if ((DropMode > DROP_VALID) &&
			(LastDropNode == DropNode) && (LastDropMode == DropMode)
			&& (!Edit->DisplayGrid))
		{
			SpecialRedraw = TRUE; // to avoid some flicker
		}
		else
		{
			SpecialRedraw = FALSE; // must redraw DropArea
			RestoreFloat(DropArea);
			RestoreFloat(DropArea2);
		}
		WaitBlit();

		if ( Edit->DisplayGrid )
		{
			if ( Edit->ew_cg )
			{
				LONG		new_top,old_top = 0;
				ULONG		rendermode = RENDERGRID_NORMAL;

				if ( Edit->ew_OptRender )
					rendermode = RENDERGRID_DAMAGE;

				new_top = (RowOffset * Edit->RowSize) + ScrollOffset;

				ob_GetAttrs( Edit->ew_cg,
						CRGRIDA_TopLine,	&old_top,
						TAG_DONE );

				SoftSpriteOff();

				if ( new_top != old_top )
				{
					ob_DoMethod(Edit->ew_cg,CRGRIDM_ScrollGrid,(new_top - old_top));
				}
				else
				{
					ob_DoMethod(Edit->ew_cg,CRGRIDM_RedrawGrid,rendermode);
				}

				SoftSpriteOn();
			}
			else
			{
				Drawn = DrawScrollGrid(Edit->ScrollGrid,
					GetRow(Edit->ScrollGrid,(RowOffset*Edit->ColumnCount)+1),
					ScrollOffset,Height,Edit->Window->RPort->BitMap,
					Edit->Window->LeftEdge+Grid->LeftEdge,Top);
				if (Drawn < Height) RectFill(RP,Grid->LeftEdge,Grid->TopEdge+Drawn,
					Grid->LeftEdge+Grid->Width-1,Grid->TopEdge+Height-1);
			}
			Edit->ew_OptRender = FALSE;
			Edit->RowOffset = RowOffset;
			Edit->ScrollOffset = ScrollOffset;
			Edit->DisplayGrid = FALSE;
		}

		if (DragOn)
		{
			if ((DropMode > DROP_VALID) && (!SpecialRedraw))
			{
				if (!AutoScrollMode)
				{
					if (DropBox.Width) RenderFloat(DropArea,DropBox.LeftEdge,
						DropBox.TopEdge,DropBox.Width,DropBox.Height,NULL);
					if (DropBox2.Width) RenderFloat(DropArea2,DropBox2.LeftEdge,
						DropBox2.TopEdge,DropBox2.Width,DropBox2.Height,NULL);
				}
			}
			RenderFloat(DragCrouton,NewDragX,NewDragY,NewDragW,NewDragH,
				DragRP->BitMap);
		}

		if (DragOn) {
			LastDropNode = DropNode;
			LastDropMode = DropMode;
		} else {
			LastDropNode = NULL;
			LastDropMode = 0;
		}

		DisplayDrag = FALSE;
	}
	WaitBlit();
}

/****** Drag/CheckAutoMode ******************************************
*
*   NAME
*	CheckAutoMode
*
*   SYNOPSIS
*	VOID CheckAutoMode(WORD X,WORD Y)
*
*   FUNCTION
*	X,Y screen coords
*
*********************************************************************
*/
VOID __regargs CheckAutoMode(WORD X,WORD Y)
{
	struct EditWindow *Edit;
	struct Gadget *Grid;

	Edit = OverWhichWindow(X,Y);

	// if over a different project, or not over any project, stop
	// previous scrolling
	if (TimingEdit && (TimingEdit != Edit)
		&& (AutoScrollMode != AUTO_SCROLL_OFF)) {
		EndAutoScroll();
	}

	if (Edit)
	{
		X -= Edit->Window->LeftEdge;
		Y -= Edit->Window->TopEdge;
		Grid = FindGadget(Edit->Gadgets,ID_GRID);
		switch(AutoScrollMode) {

	// check to see if should turn on
			case AUTO_SCROLL_OFF:
				if (Y < Grid->TopEdge + AUTO_HEIGHT) {
					AutoScrollMode = AUTO_SCROLL_UP;
					StartRepeat(Edit,ID_UP);
				} else if ((Y > Grid->TopEdge+Grid->Height-AUTO_HEIGHT)
					&& (Y < Grid->TopEdge+Grid->Height)) {
					AutoScrollMode = AUTO_SCROLL_DOWN;
					StartRepeat(Edit,ID_DOWN);
				}
			break;

	// check to see if should stop
			case AUTO_SCROLL_UP:
				if (Y > Grid->TopEdge + AUTO_HEIGHT) {
					EndAutoScroll();
				}
			break;

	// check to see if should stop
			case AUTO_SCROLL_DOWN:
				if ((Y < Grid->TopEdge+Grid->Height-AUTO_HEIGHT)
					|| (Y > Grid->TopEdge+Grid->Height)) {
					EndAutoScroll();
				}
			break;
		}
	}
}

/****** Drag/EndAutoScroll ******************************************
*
*   NAME
*	EndAutoScroll
*
*   SYNOPSIS
*	VOID EndAutoScroll(VOID)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID EndAutoScroll(VOID)
{
	if (TimingEdit) {
		EndRepeat(TimingEdit);
		TimingEdit = NULL;
	}
	AutoScrollMode = AUTO_SCROLL_OFF;
}

/****** Drag/DragDrop ***********************************************
*
*   NAME
*	DragDrop
*
*   SYNOPSIS
*	VOID DragDrop(VOID)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID DragDrop(UWORD qualifiers)
{
	if (DragOn)
	{
		if (DropEdit && (DropMode != DROP_INVALID) &&
			(DropEdit->NodeDropped))
		{
			DropEdit->NodeDropped(DragOn,DropEdit,DropMode,DropNode,qualifiers);
		}
		else
		{
			ChangeStatusList(DragOn,EN_DRAGGING,EN_SELECTED);
		}
	}
}

// end of drag.c
