/*********************************************************************\
*
* EEPROM - Access Flyer EEPROM
*
* $Id: EEPROM.c,v 1.0 1995/05/05 15:49:07 Flick Exp $
*
* $Log: EEPROM.c,v $
*Revision 1.0  1995/05/05  15:49:07  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	10/06/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,addr,readflag,data;
	UWORD	dataword;
	ULONG	res;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <addr> <READ|data>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&addr,0,0x3F,"Address");

	if (!stricmp(argv[3],"READ"))
		readflag = 1;
	else {
		readflag = 0;
		GetArg(argv[3],&data,0,0xFFFF,"Data");
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	if (readflag) {
		res = ReadEEreg(unit,addr,&dataword);
		printf("EEPROM address %lx = %04lx\n",addr,dataword);
	}
	else {
		res = WriteEEreg(unit,addr,data);
	}
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
