/*********************************************************************\
*
* FIRinit - Initialize FIR filter
*
* $Id: FIRinit.c,v 1.0 1995/05/05 15:49:16 Flick Exp $
*
* $Log: FIRinit.c,v $
*Revision 1.0  1995/05/05  15:49:16  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

BPTR	handle;

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

main(int argc,char **argv)
{
	int	unit,bank;
	ULONG	res,reg0,reg1;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <reg0> <reg1>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetLongArg(argv[2],&reg0,0,0xFFFF,"Register 0 value");
	GetLongArg(argv[3],&reg1,0,0xFFFF,"Register 1 value");

	handle = Input();

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = FIRinit(unit,(UWORD)reg0,(UWORD)reg1);
	if (res)
		printf("Init Error %ld - %ls\n",res,Error2String(res));

	for (;;) {
		if (WaitForChar(handle,30)) {
			getchar();
			break;
		}

		for (bank=0;bank<8;bank++) {
			res = FIRmapRAM(unit,bank,2,0);
			if (res)
				printf("MapRam Error %ld - %ls\n",res,Error2String(res));
		}
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
