/*********************************************************************\
*
* FIRload - Downloads FIR coefficients
*
* $Id: FIRload.c,v 1.0 1995/05/05 15:49:19 Flick Exp $
*
* $Log: FIRload.c,v $
*Revision 1.0  1995/05/05  15:49:19  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

int ReadFIRFile(char *,UWORD *);

struct Library *FlyerBase;

void GetArg(char *arg,int *var,int lo,int hi,char *label);

main(int argc,char **argv)
{
	int	unit,prepost;
	ULONG	res;
	UWORD	FirBuff[8];

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <pre(0)/post(1)> <coef file>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&prepost,0,1,"Pre/Post");

	if (!ReadFIRFile(argv[3],FirBuff))
		exit(20);

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = FIRcustom(unit,prepost,2,FirBuff);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("FIR Load Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


int ReadFIRFile(char *name,UWORD *buff)
{
	char	filename[30];
	FILE	*fp;
	ULONG	value;
	int	i;

	strcpy(filename,name);
#if 0
	if (stricmp(".FIR",&filename[strlen(filename)-4]))
		strcat(filename,".FIR");
#endif

	fp = fopen(filename,"r");
	if (fp) {
		for (i=0;i<8;i++) {
			fscanf(fp,"%lx\n",&value);
			buff[i] = (UWORD)value;
		}
		fclose(fp);
		return(1);
	}
	printf("Could not find file %s\n",filename);
	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
