/*********************************************************************\
*
* FIRmapscale - Initializes FIR filter with given scale,shape
*
* $Id: FIRmapscale.c,v 1.0 1995/05/05 15:49:22 Flick Exp $
*
* $Log: FIRmapscale.c,v $
*Revision 1.0  1995/05/05  15:49:22  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	12/21/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

BPTR	handle;

void GetArg(char *arg,int *var,int lo,int hi,char *label);

main(int argc,char **argv)
{
	int	unit,bank,scale,shape;
	ULONG	res;

	if ((argc!=5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <bank> <scale> <shape>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&bank,0,7,"Bank");
	GetArg(argv[3],&scale,1,4,"Scale Factor");
	GetArg(argv[4],&shape,0,3,"Response shape");

	handle = Input();

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = FIRmapRAM(unit,bank,scale,shape);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
