/********************************************************************
* $filelist.c$
* $Id: FileList.c,v 2.26 1995/02/22 10:13:36 CACHELIN4000 Exp $
* $Log: FileList.c,v $
*Revision 2.26  1995/02/22  10:13:36  CACHELIN4000
*Check flyerbase before building list, etc.
*
*Revision 2.25  1995/01/31  18:48:44  pfrench
*Hacked to create fly_tape device, will cause grazer.c to
*do a tape-restore.
*
*Revision 2.24  1994/12/06  19:47:10  CACHELIN4000
*Add call to sort in Controls, unused compare and swap..
*
*Revision 2.23  1994/11/29  13:10:05  pfrench
*Added CDROM directory optimizations
*                 
*Revision 2.22  1994/11/12  17:31:39  CACHELIN4000
*put LoadNodeImage() in BuildDeviceList()
*
*Revision 2.21  1994/11/09  15:43:00  CACHELIN4000
**** empty log message ***
*
*Revision 2.20  94/10/27  23:44:03  CACHELIN4000
*Add more device name recognition kiudges, PC_DOS ID..
*
*Revision 2.19  94/10/20  22:01:29  CACHELIN4000
*Attempt to determine unformatted devices... i.e. add a bunch of serial messages..
*
*Revision 2.18  94/10/14  13:37:54  CACHELIN4000
*Add CheckFlyerDrives() call to BuildFlyerList()
*
*Revision 2.17  94/09/28  11:29:31  CACHELIN4000
*Remove FlyerDrive Listing from BuildDeviceList, create BuildFlyerList()
*
*Revision 2.16  94/09/27  17:24:13  CACHELIN4000
*change Flyer recognition for DiskType='FLY0'
*
*Revision 2.15  94/09/24  10:57:26  CACHELIN4000
*Flyer Drive detection
*
*Revision 2.14  94/09/20  22:50:35  pfrench
*Many modifications to work with directory cacheing
*
*Revision 2.13  1994/08/11  16:54:13  pfrench
*Disabled (temporarily, at least). Projects saving from
*withing the grazer's path string gadget.
*
*Revision 2.12  1994/08/02  21:47:38  pfrench
*Cleaned up getdevtask() as it wasn't properly doing
*a forbid/permit for its operations.
*
*Revision 2.11  1994/08/01  15:55:35  pfrench
*Now filters out some file if in requester mode.
*
*Revision 2.10  1994/07/31  14:40:52  pfrench
*Now helps out grazer for file-save requester.
*
*Revision 2.9  1994/07/04  18:40:03  CACHELIN4000
**** empty log message ***
*
*Revision 2.8  94/06/22  10:46:38  CACHELIN4000
**** empty log message ***
*
*Revision 2.7  94/06/07  15:20:21  CACHELIN4000
**** empty log message ***
*
*Revision 2.6  94/03/13  07:53:28  Kell
*Change the way debug statements are handled.
*
*Revision 2.5  94/03/12  20:00:17  CACHELIN4000
**** empty log message ***
*
*Revision 2.4  94/03/11  09:32:11  Kell
**** empty log message ***
*
*Revision 2.3  94/03/07  20:55:43  CACHELIN4000
**** empty log message ***
*
*Revision 2.0  94/02/17  14:44:40  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <stdio.h>
#include <string.h>
#include <crouton_all.h>

#include <filelist.h>
#include <grazer.h>
#include <flyer.h>

#include <proto/exec.h>
#include <proto/dos.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

/****************************************/
//#define SERDEBUG	1
#include <serialdebug.h>

#define LIST_DB  NA("BuildFileList")
#define LIST_DB2 NA("IsFileValid")
/****************************************/

#define ADD_TAPEDRIVE	TRUE

// #define DEV_DEBUG 1
#define MAX_DOS_LENGTH 30
#define FLOPPY_DOS		0x444F5300 // OFS
#define DRIVE1_DOS		0x444F5301 // FFS (also FFS floppies ... duh)
#define DRIVE2_DOS		0x444F5302
#define DRIVE3_DOS		0x444F5303
#define DRIVE4_DOS		0x444F5304
#define DRIVE5_DOS		0x444F5305
#define FLYER_DOS			0x464C5900
#define PC_DOS				0x4D534400 // MSD0

char TrackName[] = "trackdisk.device",TempDev[32];
extern struct Library *FlyerBase;

//*******************************************************************
VOID __regargs RemoveFreeNode(struct SmartNode *Node,
		VOID (*FreeNode)(struct SmartNode *Node))
{
	Remove((struct Node *)Node);
	FreeNode(Node);
}


/****** FileList/BuildFileList **************************************
*
*   NAME
*	BuildFileList
*
*   SYNOPSIS
*	BOOL BuildFileList(struct SmartString *Path,ULONG ValidAttributes,struct List *List,
*		struct SmartNode *(*CreateNode)(struct SmartString *Name),
*		VOID (*FreeNode)(struct SmartNode *Node),
*		VOID (*NodeFIB)(struct SmartNode *,struct FileInfoBlock *,
*		UWORD DOSClass),
*		UWORD GetClass(struct SmartNode *))
*
*   FUNCTION
*	Assumes all nodes are SmartNodes,
*	Frees any existing List as well,
*	Calls CreateNode when needs a new node,
*	Calls NodeFIB when wants client to fill in FIB info
*
*   INPUTS
*	if Dir NULL, or points to NULL string, build list of devices instead
*
*********************************************************************
*/
BOOL BuildFileList(struct SmartString *Path,ULONG ValidAttributes,struct List *List,
	struct SmartNode *(*CreateNode)(struct SmartString *Name),
	VOID (*FreeNode)(struct SmartNode *Node),
	VOID (*NodeFIB)(struct SmartNode *,struct FileInfoBlock *,UWORD DOSClass),
	UWORD GetClass(struct SmartNode *))
{
	struct SmartNode *SmartNode = NULL;
	BPTR DirLock = NULL,OldCD;
	struct FileInfoBlock *Fib = NULL;
	BOOL Success = FALSE,OldCDValid=FALSE;
	struct SmartString *TempString = NULL;

	if (!Path || (!SmartStringLength(Path)))
		return(BuildDeviceList(ValidAttributes,List,CreateNode,FreeNode,
			NodeFIB,GetClass));

	if (DirLock = Lock(GetCString(Path),ACCESS_READ))
	{
		if (Fib = AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR))
		{
			if (Examine(DirLock, Fib))
			{
				if (Fib->fib_DirEntryType < 0)
				{
					goto ErrorExit; // make sure not file
				}
				OldCD = CurrentDir(DirLock);
				OldCDValid = TRUE;

				if ( IsCDROMDirectory(DirLock,Fib) )
				{
 					/* Directory has ".allicons" file, and is CD-ROM */
 					Success = BuildFileListFromCDROM(List,DirLock,Fib);
 				}
				else
				{
					while (ExNext(DirLock,Fib))
					{
						if (IsFileValid(Fib,ValidAttributes))
						{
							if (TempString = AllocSmartString(Fib->fib_FileName,NULL))
							{
								SmartNode = CreateNode(TempString);
								FreeSmartString(TempString);
								if (!SmartNode) goto ErrorExit;

								NodeFIB(SmartNode,Fib,0);

								if ( LoadNodeImage((struct GrazerNode *)SmartNode) )
								{
									AddTail(List,(struct Node *)SmartNode);
								}
								else
								{
									if( ((struct GrazerNode *)SmartNode)->BitMap )
										FreeIconBM(((struct GrazerNode *)SmartNode)->BitMap);
									FreeSmartNode(SmartNode);
								}
							} else goto ErrorExit;
						}
					}

					Success = TRUE; // assume ERROR_NO_MORE_ENTRIES
				}
			} // examine
		} // alloc mem
	}

ErrorExit:
//  DisplayNormalSprite();
	if (OldCDValid) CurrentDir(OldCD);
	if (DirLock) UnLock(DirLock);
	if (Fib) FreeMem(Fib,sizeof(struct FileInfoBlock));
// if any kind of error, keep partially complete list
	return(Success);
}

WORD __regargs NameType(char *C)
{
	if ((C[0] == 'D') && (C[1] == 'F') && (C[2] >= '0') && (C[2] <= '9') &&
		(C[3] == ':'))
		return(CR_FLOPPY);

	if ((C[0] == 'R') && (C[1] == 'A') && (C[2] == 'M') && (C[3] == ':'))
		return(CR_FLOPPY);

	if ((C[0] == 'F') && (C[1] == 'L') && (C[2] == 'Y') && (C[3] == ':'))
		return(CR_FLYER);

	if ((C[0] == 'C') && (C[1] == 'D') && (C[2] >= '0') && (C[2] <= '9') &&
		(C[3] == ':'))
		return(CR_CDROM);

	return(CR_DRIVE);
}

//*******************************************************************
WORD __inline VolType(ULONG	DiskType, LONG handler)
{
	switch(DiskType)
	{
		case PC_DOS:
			DUMPMSG("PC Floppy!");
			return(CR_FLOPPY);
			break;
		case FLOPPY_DOS:
			DUMPMSG("Floppy!");
			return(CR_FLOPPY);
			break;
		case DRIVE1_DOS:
		case DRIVE2_DOS:
		case DRIVE3_DOS:
		case DRIVE4_DOS:
		case DRIVE5_DOS:
			DUMPMSG("Drive!");
			if(handler) return(CR_CDROM); // handler is really BSTR, NULL for Amiga FS
			return(CR_DRIVE);
			break;
		case FLYER_DOS:
			DUMPMSG("Flyer!");
			return(CR_FLYER);
			break;
	}
	DUMPMSG("Unknown!");
	return(CR_UNKNOWN);
}

//*******************************************************************
char *__regargs FindDevTask(struct MsgPort *T)
{
	struct DosInfo *DosInfo;
	struct DosList *DosList;
	unsigned char blen;
	unsigned char *bstr,*cstr = NULL;

	Forbid();

	DosInfo = (struct DosInfo *)BADDR(DOSBase->dl_Root->rn_Info);
	DosList = (struct DosList *)BADDR(DosInfo->di_DevInfo);
	while (DosList)
	{
		if (	(DosList->dol_Type == DLT_DEVICE) &&
				(DosList->dol_Task == T))
		{
			bstr = (char *)(BADDR(DosList->dol_Name));
			cstr = &TempDev[0];

			blen = *bstr++;
			cstr[blen] = ':';
			cstr[blen+1] = 0;

			while (blen--)
				*cstr++ = *bstr++;

			cstr = &TempDev[0];
			break;
		}
		DosList = (struct DosList *)BADDR(DosList->dol_Next);
	}

	Permit();

	return(cstr);
}

/****** FileList/BuildDeviceList ************************************
*
*   NAME
*	BuildDeviceList
*
*   SYNOPSIS
*	BOOL BuildDeviceList(ULONG ValidAttributes,struct List *List,
*		struct SmartNode *(*CreateNode)(struct SmartString *Name),
*		VOID (*FreeNode)(struct SmartNode *Node),
*		VOID (*NodeFIB)(struct SmartNode *,struct FileInfoBlock *,
*		UWORD DOSClass),
*		UWORD GetClass(struct SmartNode *))
*
*   FUNCTION
*
*********************************************************************
*/
//*******************************************************************
BOOL BuildDeviceList(ULONG ValidAttributes,struct List *List,
	struct SmartNode *(*CreateNode)(struct SmartString *Name),
	VOID (*FreeNode)(struct SmartNode *Node),
	VOID (*NodeFIB)(struct SmartNode *,struct FileInfoBlock *,
	UWORD DOSClass),
	UWORD GetClass(struct SmartNode *))
{
	struct SmartNode *SmartNode = NULL, *OldSmartNode;
	struct DosInfo *DosInfo;
	struct DosList *DosList;
	UBYTE *Src,Temp[MAX_DOS_LENGTH+1];
	ULONG L,Valid;
	struct InfoData *InfoData = NULL;
	BPTR MyLock;
	BOOL Success = FALSE;
	struct SmartString *TempStr=NULL;
	struct GrazerNode *GNode;
	char *Name;

	if (InfoData = AllocMem(sizeof(struct InfoData),MEMF_CLEAR))
	{
		Forbid();
		DosInfo = (struct DosInfo *)BADDR(DOSBase->dl_Root->rn_Info);
		DosList = (struct DosList *)BADDR(DosInfo->di_DevInfo);
		Valid = ValidAttributes;

/****************/
// First pass (during Forbid()), just get info
		while (DosList)
		{

	// get device name
			Src = (char *)BADDR(DosList->dol_Name);
			L = Src[0];
			strncpy(&Temp[0],&Src[1],L);
			Temp[L] = 0;
			strcat(&Temp[0],":");
			if ((!(TempStr=AllocSmartString(Temp,NULL)))
				|| (!(SmartNode = CreateNode(TempStr))))
			{
				Permit();
				goto Exit;
			}

			FreeSmartString(TempStr);
			TempStr = NULL;

			GNode = (struct GrazerNode *)SmartNode;

			switch (DosList->dol_Type)
			{
				case DLT_DEVICE:
					DUMPHEXIL("Node: ",(LONG)SmartNode," ");
					DUMPSTR(Temp);
					DUMPHEXIL(" Device DiskType: ",DosList->dol_misc.dol_volume.dol_DiskType,"\\");
					if (Valid & VALID_DEVICES) {
						NodeFIB(SmartNode,NULL,EN_DEVICE);
//						GNode->Type = NameType(Temp);
//						DUMPHEXIL("D Node->Type: ",GNode->Type,"\\");
					}
					break;
				case DLT_DIRECTORY:
					if (Valid & VALID_ASSIGNS)
						NodeFIB(SmartNode,NULL,EN_ASSIGN);
					break;
				case DLT_VOLUME:
					DUMPHEXIL("Node: ",(LONG)SmartNode," ");
					DUMPSTR(Temp);
					DUMPHEXIL("Volume DiskType: ",DosList->dol_misc.dol_volume.dol_DiskType,"\\");
					if (Valid & VALID_VOLUMES)
					{
						NodeFIB(SmartNode,NULL,EN_VOLUME);
/*
						if (Name = FindDevTask(DosList->dol_Task))
						{
							GNode->Type = VolType(DosList->dol_misc.dol_volume.dol_DiskType,DosList->dol_misc.dol_handler.dol_Handler);
							DUMPHEXIL("V Node->Type: ",GNode->Type,"\\");
						}
*/
					}
					break;
			}
			AddTail(List,(struct Node *)SmartNode);
			DosList = (struct DosList *)BADDR(DosList->dol_Next);
		}
		Permit();
/****************/
// Second pass, try to Lock() it

		SmartNode = (struct SmartNode *)List->lh_Head;
		while (SmartNode->MinNode.mln_Succ) 
		{
			OldSmartNode = SmartNode;
			GNode = (struct GrazerNode *)OldSmartNode;
			SmartNode = (struct SmartNode *)SmartNode->MinNode.mln_Succ;
			switch (GetClass(OldSmartNode)) {
				case EN_UNDEFINED:
					RemoveFreeNode(OldSmartNode,FreeNode);
					break;

				case EN_DEVICE:
				case EN_ASSIGN:
				case EN_VOLUME:
					MyLock = NULL;
					if (SmartStringLength(OldSmartNode->Name))
					{
						Name=GetCString(OldSmartNode->Name);
						MyLock = Lock( Name ,ACCESS_READ);
					}
					if (!MyLock)
					{
						DUMPSTR(Name);
						DUMPSTR(" cannot be Locked...");
						DUMPHEXIL("Node: ",(LONG)OldSmartNode,"\\");
						RemoveFreeNode(OldSmartNode,FreeNode);
					}
					else
					{
						if(Info(MyLock,InfoData))
						{
							if( ((InfoData->id_DiskState != ID_VALIDATED)
							&& (InfoData->id_DiskState != ID_WRITE_PROTECTED))
							||( (GNode->Type=VolType(InfoData->id_DiskType,NULL)) == CR_UNKNOWN)  )
							{
								DUMPSTR(Name);
								DUMPMSG("  Not a valid DOS disk\n");
								RemoveFreeNode(OldSmartNode,FreeNode);
							} else
							{
								DUMPSTR(Name);
								DUMPHEXIL(" id_DiskType: ",InfoData->id_DiskType,"	");
								DUMPHEXIL("Node->Type: ",GNode->Type,"\\");
								NodeFIB(OldSmartNode,NULL,GetClass(OldSmartNode));
								LoadNodeImage(GNode);
							}
						} else
						{
							RemoveFreeNode(OldSmartNode,FreeNode);
							DUMPMSG("  Unable to do Info().");
						}
						UnLock(MyLock);
					}
					break;
			}
		}

		Success = TRUE;
	}
Exit:
	if (TempStr) FreeSmartString(TempStr);
	if (InfoData) FreeMem(InfoData,sizeof(struct InfoData));

#if ADD_TAPEDRIVE
	if ( Valid & (VALID_VOLUMES|VALID_DEVICES) )
	{
		strcpy(Temp,"FLY_TAPE:");

		if ( TempStr = AllocSmartString(Temp,NULL) )
		{
			if ( SmartNode = CreateNode(TempStr) )
			{
				NodeFIB(SmartNode,NULL,EN_DEVICE);
				((struct GrazerNode *)SmartNode)->Type = CR_FLYER;
				LoadNodeImage((struct GrazerNode *)SmartNode);
				AddTail(List,(struct Node *)SmartNode);
			}

			FreeSmartString(TempStr);
		}
	}
#endif
	return(Success);
}

/****** FileList/IsFileValid ****************************************
*
*   NAME
*	IsFileValid
*
*   SYNOPSIS
*	BOOL IsFileValid(struct FileInfoBlock *fib, ULONG Valid)
*
*   FUNCTION
*
*********************************************************************
*/
BOOL IsFileValid(struct FileInfoBlock *fib, ULONG Valid)
{
	BOOL Result = FALSE;
	UWORD Length;

	if ((Valid & VALID_FILES) && (fib->fib_DirEntryType < 0))
	{
		Length = strlen(fib->fib_FileName);
		if (Length)
		{
#ifndef SHOW_DOT_I
	      if (stricmp(".i",&fib->fib_FileName[Length-2]))
#endif
			if (Valid & VALID_INFO_FILES) // if user wants ".info" files, OK
				Result = TRUE;
			else if (stricmp(".info",&fib->fib_FileName[Length-5]))
				Result = TRUE;
		}
	}
	else
	{
		if ((Valid & VALID_DIRECTORIES) && (fib->fib_DirEntryType >= 0))
			Result = TRUE;
	}

	if( Result )
	{
		DEBUGSTR(LIST_DB2,"Valid File: ");
		DEBUGMSG(LIST_DB2,fib->fib_FileName);
	}
	return(Result);
}

void BuildFlyerList()
{
	struct DosInfo *DosInfo;
	struct DosList *DosList;
	UBYTE *Src,Temp[MAX_DOS_LENGTH+1];
	ULONG L;

	if(!FlyerBase) return;
	Forbid();
		DosInfo = (struct DosInfo *)BADDR(DOSBase->dl_Root->rn_Info);
		DosList = (struct DosList *)BADDR(DosInfo->di_DevInfo);
		while (DosList)
		{
			Src = (char *)BADDR(DosList->dol_Name);
			L = Src[0];
			strncpy(&Temp[0],&Src[1],L);
			Temp[L] = 0;
			strcat(&Temp[0],":");
			switch (DosList->dol_Type)
			{
				case DLT_DEVICE:
					break;
				case DLT_DIRECTORY:
					break;
				case DLT_VOLUME:
					DUMPHEXIL("Volume DiskType: ",DosList->dol_misc.dol_volume.dol_DiskType,"\\");
					if(DosList->dol_misc.dol_volume.dol_DiskType == FLYER_DOS)
						AddFlyerDrive(Temp);
					break;
			}
			DosList = (struct DosList *)BADDR(DosList->dol_Next);
		}
	Permit();
	CheckFlyerDrives();
	SortFlyerDrives();
	return;
}

#define IS_AUDIO_DRIVE(FVI)		((FVI->Flags&FVIF_AUDIOREADY) && !(FVI->Flags&FVIF_VIDEOREADY))
// CompareElements() returns: if <0, A<B; if =0, A=B; if >0, A>B
int CompareFlyerDrives(void *Drives, LONG IndexA, LONG IndexB)
{
	UBYTE **fds = Drives;
	struct FlyerVolInfo *fviA=NULL,*fviB=NULL;
	DUMPUDECL("Comparing Drive ",IndexA," and ");
	DUMPUDECL("Drive ",IndexB," \\");
	DUMPSTR(fds[IndexA]);
	DUMPMSG(fds[IndexB]);

	fviA = GetFlyerInfo(fds[IndexA]);
	fviB = GetFlyerInfo(fds[IndexB]);
	if(!fviA)
	{
		if(fviB) return(-1);
		else return(0);
	}
	else if(!fviB)
	{
		if(fviA) return(1);
		else return(0);
	}
	else if(IS_AUDIO_DRIVE(fviA))
	{
		if(!IS_AUDIO_DRIVE(fviB)) return(-1);
	}
	else if(IS_AUDIO_DRIVE(fviB)) return(1);

// Now either both are audio or neither is
	if(fviA->Largest > fviB->Largest) return(1);
	if(fviA->Largest < fviB->Largest) return(-1);
	return(0);
}

void SwapFlyerDrives(void *Drives, LONG IndexA, LONG IndexB)
{
	UBYTE **fds = Drives, *t;
	DUMPSTR("Swapping ");
	DUMPSTR(fds[IndexA]);
	DUMPSTR(" And ");
	DUMPMSG(fds[IndexB]);
	t=fds[IndexA];
	fds[IndexA] = fds[IndexB];
	fds[IndexB]=t;
}

// end of filelist.c
