/*********************************************************************\
*
* FindHeader - Locate a nearby clip header
*
* $Id: FindHeader.c,v 1.0 1995/05/05 15:49:13 Flick Exp $
*
* $Log: FindHeader.c,v $
*Revision 1.0  1995/05/05  15:49:13  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	07/11/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	res,lba,addr,end;
	UWORD	data,frmhi,frmlo;

	if ((argc!=5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <addr> <endaddr>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"SCSI Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[3],&lba,0,0xFFFFFFFF,"Start address");
	GetLongArg(argv[4],&end,0,0xFFFFFFFF,"End address");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	Action.Flags = 0;
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	for (addr=lba;addr<end;addr++) {
		res = Read10(&Action,1,addr,0x1FFF);
		if (res) {
			printf("Read10 Error %ld - %ls\n",res,Error2String(res));
			printf("(code = %ld)\n",res);
			break;
		}

		res = CPUDMA(unit,0x40,0x1FFF,1,0);		/* Write DMA to CPU */
		if (res) {
			printf("CPUDMA Error %ld - %ls\n",res,Error2String(res));
			printf("(code = %ld)\n",res);
			break;
		}

		res = CPUread(unit,0xC08000,&data);
		if (res) {
			printf("Error %ld - %ls\n",res,Error2String(res));
			break;
		}
		if (data == 0x4346) {
			res = CPUread(unit,0xC08002,&data);
			if (res) {
				printf("Error %ld - %ls\n",res,Error2String(res));
				break;
			}
			if (data == 0x524D) {
				res = CPUread(unit,0xC08014,&frmhi);
				res = CPUread(unit,0xC08016,&frmlo);
				printf("Header found at %lx (frame $%lx)\n",addr,(frmhi<<16) + frmlo);
				addr += 0x100;		/* Can't be this short! */
			}
		}
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
