/*********************************************************************\
*
* FlyerInit - Initializes Flyer 0 board
*
* $Id: FlyerInit.c,v 1.1 1995/08/30 18:10:30 Flick Exp $
*
* $Log: FlyerInit.c,v $
*Revision 1.1  1995/08/30  18:10:30  Flick
*Added REBOOT command line option
*
*Revision 1.0  1995/05/05  15:49:48  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	10/25/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

char DefaultPath1[] = "SYS:NewTek/Programs/Flyer_Support";
char DefaultPath2[] = "WORK:NewTek/Programs/Flyer_Support";

main(int argc,char **argv)
{
	int	retcode;
	ULONG	res;
	BPTR	lock;
	BOOL	reboot = FALSE;

	if ((argc>2) && (stricmp(argv[argc-1],"REBOOT")==0))
	{
		reboot = TRUE;
		argc--;
	}

	if ((argc>2) || ((argc==2) && (argv[1][0]=='?'))) {
		printf("Usage: %ls [FlyerPath]\n",argv[0]);
		return(10);
	}

	retcode = 10;

	if (FlyerBase = OpenLibrary(FLYERLIBNAME,0)) {
		if (argc==2) {
			lock = Lock(argv[1],SHARED_LOCK);
		}
		else {
			lock = Lock(DefaultPath1,SHARED_LOCK);
			if (!lock)
				lock = Lock(DefaultPath2,SHARED_LOCK);
		}

		if (lock) {
			if (reboot)
			{
				res = FlyerQuit(0);					// Gives error if not running
//				printf("Quit Error %ld\n",res);
				if (res == FERR_OKAY)
					Delay(50);							// Need this to be safe! (Let ROM boot)
			}

			res = InitFlyers(lock);				/* Do it! */
			if (res)
				printf("Flyer Init Error %ld\n",res);
			else {
				printf("Okay\n");
				retcode = 0;
			}
			UnLock(lock);
		}
		else
			printf("Couldn't find Flyer directory\n");

		CloseLibrary(FlyerBase);
	}
	else
		printf("Open flyer.library failed\n");

	return(retcode);
}
