/*********************************************************************\
*
* FlyerInitForce - Initializes Flyer 0 board with the given chipset files
*
* $Id: FlyerInitForce.c,v 2.0 96/11/13 19:09:48 Hayes Exp $
*
* $Log:	FlyerInitForce.c,v $
*Revision 2.0  96/11/13  19:09:48  Hayes
*FirstCheckIn
*
*Revision 2.0  96/11/11  11:46:47  Hayes
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	11/4/96		Todd created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	retcode, i, j;
	ULONG	res;
	BPTR	lock;
	ULONG chipID = 0;

	if ((argc<2) || (argc>3))
	{
		printf("Usage: %ls <FlyerPath> [ChipID]\n",argv[0]);
		return(10);
	}

	retcode = 10;

	if (FlyerBase = OpenLibrary(FLYERLIBNAME,0)) 
	{
		lock = Lock(argv[1],SHARED_LOCK);

		if (lock)
		{
			if ( argc == 3 )
			{
				for( i = 0, j = 0;i < 4; i++ )
				{
					chipID = chipID << 8;
					chipID += argv[2][j];
					if ( argv[2][j] != 0 )
					{
						j++;
					}
				}
			}
			res = InitFlyerForce( lock, chipID );	/* Do it! */
			if (res)
				printf("Flyer Init Error %ld\n",res);
			else {
				printf("Okay\n");
				retcode = 0;
			}
			UnLock(lock);
		}
		else
			printf("Couldn't find Flyer directory\n");

		CloseLibrary(FlyerBase);
	}
	else
		printf("Open flyer.library failed\n");

	return(retcode);
}
