/*********************************************************************\
*
* FrameSearch - Display spec'd frame in clip
*
* $Id: FrameSearch.c,v 1.0 1995/05/05 15:50:31 Flick Exp $
*
* $Log: FrameSearch.c,v $
*Revision 1.0  1995/05/05  15:50:31  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	03/16/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;
struct FlyerVolume	FlyVol;
struct ClipAction		Action;
struct SMPTEinfo		SmpteInfo;

main(int argc,char **argv)
{
	int	unit,vchan,drive,viewit,hearit;
	ULONG	frame,res;

	if ((argc!=8)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <vidchan> <drive> <name> <frame> <view> <hear>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&vchan,0,1,"Video Channel");
	GetArg(argv[3],&drive,0,23,"SCSI Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[5],&frame,0,0xFFFFFFFF,"Frame number");
	GetArg(argv[6],&viewit,0,1,"View Flag");
	GetArg(argv[7],&hearit,0,1,"Hear Flag");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	Action.Flags = 0;
	if (viewit)
		Action.Flags |= CAF_VIDEO;
	if (hearit)
		Action.Flags |= CAF_AUDIOL | CAF_AUDIOR;

	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Path = argv[4];
	Action.Channel = vchan;
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	res = BeginFindField(&Action);
	if (res==FERR_OKAY) {
		printf("Searching...\n");
		Action.VidStartField = frame*4;
		res = DoFindField(&Action);
		EndFindField(&Action);
		if (res==FERR_OKAY) {
			res = GetSMPTE(unit,&SmpteInfo);
			if (res)
				printf("SMPTE Error %ld - %ls\n",res,Error2String(res));
			else {
				if (SmpteInfo.SMPTEvalid==0)
					printf("No SMPTE info\n");
				else {
					printf("SMPTE time = %02ld:%02ld:%02ld:%02ld\n",
						SmpteInfo.SMPTEhours,
						SmpteInfo.SMPTEminutes,
						SmpteInfo.SMPTEseconds,
						SmpteInfo.SMPTEframes);
				}
			}
		}
	}

	if (res==FERR_OBJNOTFOUND)
		printf("Could not find frame\n");
	else if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Block = %lx\n",Action.StartBlk);

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
