/*********************************************************************\
*
* FreqSweep - Sweep frequency of a given clock and find peak performance
*
* $Id: FreqSweep.c,v 1.0 1995/11/30 10:51:35 Flick Exp $
*
* $Log: FreqSweep.c,v $
*Revision 1.0  1995/11/30  10:51:35  Flick
*FirstCheckIn
*
*
* Copyright (c) 1995 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	11/28/95		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

#define	LINEADDR				0xEEEDB9
#define	DEBUGLINEADDR		0xEF4601

#define	SAMPLES		4

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	clk,i,line;
	ULONG	res;
	long	lo,hi,inc,val;
	UBYTE	*lineptr = (UBYTE *)LINEADDR;

	if ((argc > 5) && (!stricmp(argv[argc-1],"debug")))
	{
		lineptr = (UBYTE *)DEBUGLINEADDR;
		argc--;
	}

	if ((argc != 5)||(argv[1][0]=='?'))
	{
		printf("Usage: %ls <clock> <lo> <hi> <inc>\n",argv[0]);
		printf("\nClocks:\n");
		printf("  0 = DMA\n");
		printf("  1 = Audio\n");
		printf("  2 = Mcoder\n");
		printf("  3 = Pcoder\n");
		return(20);
	}

	GetArg(argv[1],&clk,0,3,"Clock");
	stcd_l(argv[2],&lo);
	stcd_l(argv[3],&hi);
	stcd_l(argv[4],&inc);

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
	{
		printf("Open flyer.library failed\n");
		return;
	}

	for (val=lo; val<hi; val+=inc)
	{
		res = SetFlooby(0,clk,7,val);
		if (res)
		{
			printf("Error %ld - %ls\n",res,Error2String(res));
			break;
		}

		if (clk == 0)
			Delay(40);			// DMA needs more time to settle
		else
			Delay(20);

		line=0;
		for (i=0; i<SAMPLES; i++)
		{
			line += *lineptr;
			Delay(2);			// Guarantee we're on a different field
		}

		line /= SAMPLES;

		printf("%ld: ",val);
		for (i=100; i<=line; i++)
			printf("*");
		printf(" (%ld)\n",line);
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
