/********************************************************************
* $Grid.c$
* $Id: Grid.c,v 2.25 1995/09/18 15:35:02 pfrench Exp $
* $Log: Grid.c,v $
*Revision 2.25  1995/09/18  15:35:02  pfrench
*Fixed bad-scroll after delete bug
*
*Revision 2.24  1995/06/01  14:21:37  pfrench
*Added capability to scroll past end of full project grid
*
*Revision 2.23  1995/01/20  11:18:41  Kell
*Using Dark Yellow as a Select border color so Preview Overlay will show up as white.
*
*Revision 2.22  1994/12/19  22:39:30  pfrench
*Modified for now shared-code proof.library.
*
*Revision 2.21  1994/12/02  16:08:56  pfrench
*Removed call to allocscrollgrid, and also modified the
*no-window case to fudge the coordinates so it doesn't cause
*screen-draw bugs when running under v37
*
*Revision 2.20  1994/11/15  17:49:52  pfrench
*changed red palette color to 10
*
*Revision 2.19  1994/11/14  16:01:13  pfrench
*Now configures pens/depth correctly for AA/ECS machines
*
*Revision 2.18  1994/11/09  21:00:01  pfrench
*Added more parameters to allocgrid
*
*Revision 2.17  1994/11/09  19:22:26  pfrench
*Only enabled proof grid object
*
*Revision 2.16  1994/11/09  12:49:27  pfrench
*Added initial support for croutongrid object
*
*Revision 2.15  1994/09/02  15:30:06  pfrench
*Now correctly does error stuff.
*
*Revision 2.14  1994/09/01  00:44:00  pfrench
*Removed gunsight highlighting from editor modes.
*
*Revision 2.13  1994/08/27  16:15:47  CACHELIN4000
*Implement "Corner hiliting" for navigation
*
*Revision 2.12  94/08/27  14:30:19  pfrench
**** empty log message ***
*
*Revision 2.11  1994/08/26  16:30:08  pfrench
*Added ECS rendering calls for bad croutons
*
*Revision 2.10  1994/08/26  15:17:52  pfrench
*Added red-highlighting to croutons that failed to load
*
*Revision 2.9  1994/08/26  14:50:50  CACHELIN4000
*Fix hiliting for A2000, add stripes, PAL_RED
*
*Revision 2.8  94/04/23  17:44:00  CACHELIN4000
**** empty log message ***
*
*Revision 2.7  94/04/22  14:54:09  CACHELIN4000
**** empty log message ***
*
*Revision 2.6  94/04/22  14:32:02  CACHELIN4000
**** empty log message ***
*
*Revision 2.5  94/04/20  17:32:28  CACHELIN4000
**** empty log message ***
*
*Revision 2.4  94/03/13  07:51:11  Kell
**** empty log message ***
*
*Revision 2.3  94/03/12  19:59:26  CACHELIN4000
**** empty log message ***
*
*Revision 2.2  94/03/11  09:32:20  Kell
**** empty log message ***
*
*Revision 2.1  94/02/19  09:34:24  Kell
**** empty log message ***
*
*Revision 2.0  94/02/17  16:24:12  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  15:57:17  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  14:44:14  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*	12-17-92	Steve H		Convert to use SmartStrings
*	11-17-93	Steve H		Last Update
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <intuition/intuition.h>
#include <crouton_all.h>

#include <editwindow.h>
#include <gadgets.h>
#include <project.h>

#ifndef PROOF_LIB_H
#include <proof_lib.h>
#endif

#include <croutongrid.h>

#include <proto/exec.h>
#include <proto/graphics.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

//#define SERDEBUG	1
#include <serialdebug.h>

extern struct TextFont *EditFont;
extern struct Gadget Gadget1;
extern UBYTE AAMachine;
extern struct FastGadget *CurFG;
extern struct FastGadget *SKellFG;
extern int	CurGrid,CurRow,CurCol;
extern UWORD CandyStripe[],BCandyStripe[];
enum {	PAL_BLACK, PAL_DGRAY, PAL_LGRAY, PAL_WHITE,  // Palette colors
				PAL_LBLACK, PAL_DDGRAY, PAL_DYELLOW, PAL_LYELLOW };
#define PAL_RED	10

extern struct EditWindow *EditTop,*EditBottom;
extern struct Library *ProofBase;

#define SWITCHER_MODE	( (!EditBottom) && (EditTop->Height != TOP_LARGE) )
#define EDITOR_MODE		(!SWITCHER_MODE)


LONG RebuildGrazerGrid( struct EditWindow *Edit );

/****** Grid/AllocGrid **********************************************
*
*   NAME
*	AllocGrid
*
*   SYNOPSIS
*	BOOL AllocGrid(struct EditWindow *Edit)
*
*   FUNCTION
*	Sets up for grid scrolling/rendering
*
*********************************************************************
*/
BOOL AllocGrid(struct EditWindow *Edit)
{
	BOOL Success = FALSE;

	DUMPHEXIL("Edit=",(LONG)Edit,"\\");
	DUMPHEXIL("Edit->Screen=",(LONG)(Edit->Screen),"\\");
	DUMPHEXIL("Edit->Screen->RastPort.BitMap=",(LONG)Edit->Screen->RastPort.BitMap,"\\");

	if (Edit)
	{
		if (Edit->ScrollGrid)
			FreeGrid(Edit); // if already allocated

		if ( Edit->ew_cg )
		{
			ob_Dispose(Edit->ew_cg);
			Edit->ew_cg = NULL;
		}

		if ( TRUE /* Edit->Node.Type == EW_PROJECT */ )
		{
			struct Gadget *Grid;
			LONG				top,left;

			if ( Edit->Window )
			{
				left = Edit->Window->LeftEdge;
				top = Edit->Window->TopEdge;
			}
			else
			{
				left = Edit->LeftEdge + 32;
				top = Edit->TopEdge + 44;
			}

			Grid = FindGadget(Edit->Gadgets,ID_GRID);

			if ( Edit->ew_cg = ob_NewObject(NULL,CROUTONGRIDCLASS,
					CRGRIDA_DestScreen,	Edit->Screen,
					CRGRIDA_DestBitMap,	Edit->Screen->RastPort.BitMap,
					CRGRIDA_DestLeft,		left + Grid->LeftEdge,
					CRGRIDA_DestTop,		top + Grid->TopEdge,
					CRGRIDA_DestWidth,	Grid->Width,
					CRGRIDA_DestHeight,	Grid->Height,

					CRGRIDA_CroutonColumns,	Edit->ColumnCount,
					CRGRIDA_CroutonWidth,	Edit->ColumnSize,
					CRGRIDA_CroutonHeight,	Edit->RowSize,

					CRGRIDA_DestDepth,	((AAMachine) ? 6:2),
					CRGRIDA_BackPen,		PAL_DGRAY,
					CRGRIDA_HighlightPen,((AAMachine) ? PAL_DYELLOW:PAL_WHITE),
					CRGRIDA_ErrorPen,		((AAMachine) ? PAL_RED:PAL_WHITE),

					CRGRIDA_TextFont,		EditFont,
					TAG_DONE	) )
			{
				if ( Edit->Node.Type == EW_PROJECT )
				{
					ob_DoMethod( Edit->ew_cg,CRGRIDM_BuildGridFromFGList,
						((struct Project *)Edit->Special)->PtrPtr );
				}
				else
				{
					RebuildGrazerGrid(Edit);
				}
				Success = TRUE;
			}
		}

		if (!Success)
			FreeGrid(Edit);
	}
	return(Success);
}

LONG RebuildGrazerGrid( struct EditWindow *Edit )
{
	LONG	retval = TRUE;

	if ( Edit->ew_cg && Edit->Special->pEditList )
	{
		ob_DoMethod( Edit->ew_cg,CRGRIDM_BuildGridFromGrazerList,
			Edit->Special->pEditList );
	}

	return(retval);
}

/****** Grid/FreeGrid ***********************************************
*
*   NAME
*	FreeGrid
*
*   SYNOPSIS
*	VOID FreeGrid(struct EditWindow *Edit)
*
*   FUNCTION
*	Frees everything after done rendering/scrolling this grid
*
*********************************************************************
*/
VOID FreeGrid(struct EditWindow *Edit)
{
	if (Edit->ScrollGrid)
	{
		FreeScrollGrid(Edit->ScrollGrid);
		Edit->ScrollGrid = NULL;
		Edit->RenderRastPort = NULL;
	}

	if ( Edit->ew_cg )
	{
		ob_Dispose(Edit->ew_cg);
		Edit->ew_cg = NULL;
	}
}

/****** Grid/CalcGridDimensions *************************************
*
*   NAME
*	CalcGridDimensions
*
*   SYNOPSIS
*	VOID CalcGridDimensions(struct EditWindow *Edit)
*
*   FUNCTION
*	Called when GridContents change
*	Note that clients are responsible for Edit->Column/RowSize before
*	calling this function
*
*********************************************************************
*/
VOID CalcGridDimensions(struct EditWindow *Edit)
{
	struct Gadget *Gadget;

	Gadget = FindGadget(Edit->Gadgets,ID_GRID);
	Edit->ColumnCount = Gadget->Width / Edit->ColumnSize;
	Edit->RowCount = Gadget->Height / Edit->RowSize;
}

/****** Grid/RenderRow **********************************************
*
*   NAME
*	RenderRow
*
*   SYNOPSIS
*	struct EditNode *RenderRow(struct EditWindow *Edit,struct EditNode *Node)
*
*   FUNCTION
*	returns first Node after this row
*
*********************************************************************
*/
struct EditNode *RenderRow(struct EditWindow *Edit,struct EditNode *Node)
{
	UWORD Column,X,X2;
	struct RastPort *RP;
	struct EditNode *Next;

	RP = Edit->RenderRastPort;
	SetDrMd(RP,JAM2);
	SetAPen(RP,SCREEN_PEN);
	X = 0;
	for (Column = 0; Column < Edit->ColumnCount; Column++) {
		Next = GetNextEditNode(Edit,Node);
		if (Node) {
      if(Node ==(struct EditNode *) CurFG) CurCol=Column;
			switch(GetEditNodeStatus(Edit,Node)) {
				case EN_NORMAL:
					if ( Node != (struct EditNode *) SKellFG )
					{
						Edit->RenderNode(Edit,Node,RP,X,0);
						break;
					}
				case EN_SELECTED:
					Edit->RenderNode(Edit,Node,RP,X,0);
					if(CurFG == NULL) CurFG=(struct FastGadget *)Node;
					if (AAMachine)
					{
						SetABPenDrMd(RP,PAL_DYELLOW,PAL_BLACK,JAM2);
//						SetAfPt(RP,CandyStripe,3);  // Nice stripes
						if (	(Node == (struct EditNode *) SKellFG) ||
								(EDITOR_MODE) )
						{
							RectFill(RP,X+1,1+Edit->ImageHeight-1,X+1+Edit->ImageWidth-1,1+Edit->ImageHeight+1);
							RectFill(RP,X+1,1,X+1+Edit->ImageWidth-1,2);
							RectFill(RP,X+1,1,X+2,1+Edit->ImageHeight+1);
							RectFill(RP,X+1+Edit->ImageWidth-1,1,X+1+Edit->ImageWidth+1,1+Edit->ImageHeight+1);
						}
						else {                 // bottom
							RectFill(RP,X+1,1+Edit->ImageHeight-1,X+(Edit->ImageWidth>>2),1+Edit->ImageHeight+1);
							RectFill(RP,X+1+3*(Edit->ImageWidth>>2),1+Edit->ImageHeight-1,X+1+Edit->ImageWidth-1,1+Edit->ImageHeight+1);
                                   // top
							RectFill(RP,X+1,1,X+(Edit->ImageWidth>>2),2);
							RectFill(RP,X+1+3*(Edit->ImageWidth>>2),1,X+1+Edit->ImageWidth-1,2);
                                  // left
							RectFill(RP,X+1,1,X+2,1+(Edit->ImageHeight>>2));
							RectFill(RP,X+1,1+3*(Edit->ImageHeight>>2),X+2,1+Edit->ImageHeight+1);
                                  // right
							RectFill(RP,X+1+Edit->ImageWidth-1,1,X+1+Edit->ImageWidth+1,1+(Edit->ImageHeight>>2));
							RectFill(RP,X+1+Edit->ImageWidth-1,1+3*(Edit->ImageHeight>>2),X+1+Edit->ImageWidth+1,1+Edit->ImageHeight+1);
						}


						SetAfPt(RP,NULL,3);  // No stripes
					} else
					{
						SetAPen(RP,PAL_WHITE);
//						SetBPen(RP,PAL_BLACK);
						SetDrMd(RP,JAM2);
//						SetABPenDrMd(RP,PAL_WHITE,PAL_BLACK,JAM2); 2000 doesn't like this...
//						SetAfPt(RP,CandyStripe,3);  // Nice stripes
						if (	(Node == (struct EditNode *) SKellFG) ||
								(EDITOR_MODE) )
						{
							RectFill(RP,X+1,1,X+1+Edit->ImageWidth-1,3);
							RectFill(RP,X+1,1+Edit->ImageHeight-2,X+1+Edit->ImageWidth-1,1+Edit->ImageHeight+1);
							RectFill(RP,X+1,1,X+3,1+Edit->ImageHeight+1);
							RectFill(RP,X+1+Edit->ImageWidth-2,1,X+1+Edit->ImageWidth+1,1+Edit->ImageHeight+1);
						}
						else {                 // bottom
							RectFill(RP,X+1,1+Edit->ImageHeight-1,X+(Edit->ImageWidth>>2),1+Edit->ImageHeight+1);
							RectFill(RP,X+1+3*(Edit->ImageWidth>>2),1+Edit->ImageHeight-1,X+1+Edit->ImageWidth-1,1+Edit->ImageHeight+1);
                                   // top
							RectFill(RP,X+1,1,X+(Edit->ImageWidth>>2),2);
							RectFill(RP,X+1+3*(Edit->ImageWidth>>2),1,X+1+Edit->ImageWidth-1,2);
                                  // left
							RectFill(RP,X+1,1,X+2,1+(Edit->ImageHeight>>2));
							RectFill(RP,X+1,1+3*(Edit->ImageHeight>>2),X+2,1+Edit->ImageHeight+1);
                                  // right
							RectFill(RP,X+1+Edit->ImageWidth-1,1,X+1+Edit->ImageWidth+1,1+(Edit->ImageHeight>>2));
							RectFill(RP,X+1+Edit->ImageWidth-1,1+3*(Edit->ImageHeight>>2),X+1+Edit->ImageWidth+1,1+Edit->ImageHeight+1);
						}
//						SetAfPt(RP,NULL,3);  // No stripes
					}
					break;

				case EN_DRAGGING:
					SetAPen(RP,1);
					SetDrMd(RP,JAM2);
					RectFill(RP,X,0,X+Edit->ColumnSize-1,Edit->RowSize-1);
			}

			Node->Redraw = FALSE;

			if ( GetEditNodeBehavior(Edit,Node) & EN_BADCROUTON )
			{
				struct FastGadget *fg = (struct FastGadget *)Node;

				SetDrMd(RP,JAM2);
				if (AAMachine) SetAPen(RP,PAL_RED);
				else SetAPen(RP,PAL_WHITE);
				SetBPen(RP,PAL_BLACK);
				SetAfPt(RP,CandyStripe,3);  // Nice stripes
				RectFill(RP,X+1,1,X+1+Edit->ImageWidth-1,2);
				RectFill(RP,X+1,1+Edit->ImageHeight-1,X+1+Edit->ImageWidth-1,1+Edit->ImageHeight+1);
				RectFill(RP,X+1,1,X+2,1+Edit->ImageHeight+1);
				RectFill(RP,X+1+Edit->ImageWidth-1,1,X+1+Edit->ImageWidth+1,1+Edit->ImageHeight+1);
				SetAfPt(RP,NULL,3);  // No stripes

				fg->FGDiff.FGNode.Behavior &= ~(EN_BADCROUTON);
				fg->FGDiff.FGNode.Redraw = TRUE;
			}

			WaitBlit();

			Node = Next;
			X += Edit->ColumnSize;
		}

		// else clear rest of row
		else {
			SetAPen(RP,SCREEN_PEN);
//			SetAPen(RP,5);
			X2 = (RP->BitMap->BytesPerRow*8)-1;
			if (X < X2) // if ColumnCount==1, don't RectFill
				RectFill(RP,X,0,X2,RP->BitMap->Rows-1);
			Column = Edit->ColumnCount; // end loop
		}
	}
	WaitBlit();
	return(Node);
}

/****** Grid/RenderList *********************************************
*
*   NAME
*	RenderList
*
*   SYNOPSIS
*	BOOL RenderList(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/
BOOL RenderList(struct EditWindow *Edit)
{
	BOOL Success = FALSE;

	if ( !Edit->ew_cg )
	{
		struct EditNode *Node,*Next;
		UWORD Length,RowCount,Row,A,ColumnCount;

		Node = GetEditNode(Edit,1);
		Length = GetEditListLen(Edit);
		ColumnCount = Edit->ColumnCount;
		RowCount = ((Length+ColumnCount-1)/ColumnCount);
		CurCol=-1; CurRow=-1;
		for (Row = 1; Row <= RowCount; Row++) {
			if (Edit->RedrawList || RedrawRow(Edit,Node,ColumnCount)) {
				Node = RenderRow(Edit,Node);
				if( (CurCol!=-1) && (CurRow==-1) ) // We've reached curFG, haven't set currow
				{
					CurRow=Row-1;
					CurGrid=(CurRow*ColumnCount) + CurCol;
				}
				GridChipToFast(Edit->ScrollGrid,Row);
			}

			// if not rendering this row, skip to next one
			else for (A = 0; A < Edit->ColumnCount; A++) {
				Next = GetNextEditNode(Edit,Node);
				if (Next) Node = Next;
			}
		}
	}
	Edit->RedrawList = Edit->RedrawSelect = FALSE;
	Success = TRUE;
Exit:
	return(Success);
}

//*******************************************************************
BOOL RedrawRow(struct EditWindow *Edit,struct EditNode *Node,UWORD ColumnCount)
{
	UWORD A;
	struct EditNode *Next;

	if (Node) {
	for (A=0; A < ColumnCount; A++) {
		if (GetEditNodeRedraw(Edit,Node)) return(TRUE);
		Next = GetNextEditNode(Edit,Node);
		if (!Next) return(FALSE); // end of list
		Node = Next;
	}
	}
	return(FALSE);
}

/****** Grid/NewGridLength ******************************************
*
*   NAME
*	NewGridLength
*
*   SYNOPSIS
*	VOID NewGridLength(struct EditWindow *Edit)
*
*   FUNCTION
*	Called anytime the grid length changes, or the window height changes
*
*********************************************************************
*/
VOID NewGridLength(struct EditWindow *Edit)
{
	ULONG Length;
	UWORD MaxRowOffset;
	struct Gadget *Prop,*Grid;

	if (Edit && Edit->ColumnCount)
	{
		BOOL			extend_for_full_project = 0;

		Edit->ListLength = Length = GetEditListLen(Edit);
		Edit->CurrentRows = (Length + Edit->ColumnCount-1) / Edit->ColumnCount;

		if (	(Edit->Node.Type == EW_PROJECT) &&						/* Project && */
				!(Length % Edit->ColumnCount) &&							/* Full Row  && */
				(Length >= (Edit->RowCount * Edit->ColumnCount)) )	/* Bigger than display */
		{
			extend_for_full_project = TRUE;
		}

		if ( extend_for_full_project )
			Edit->CurrentRows++;

		if (Length >= (Edit->RowCount * Edit->ColumnCount))
		{
			Edit->ScrollPositions = Edit->CurrentRows - Edit->RowCount + 1;
		}
		else
		{
			Edit->ScrollPositions = 1; // not scrollable
			Edit->RowOffset = 0;
			Edit->ScrollOffset = 0;
		}

		// make sure RowOffset still valid for grid
		MaxRowOffset = Edit->CurrentRows - Edit->RowCount;
		if (Edit->ScrollOffset) MaxRowOffset--;
		if (Edit->RowOffset > MaxRowOffset) {
			Edit->RowOffset = MaxRowOffset;
			Edit->ScrollOffset = 0;
		}


		// redisplay prop gadget with new body
		Prop = FindGadget(Edit->Gadgets,ID_KNOB);
		Grid = FindGadget(Edit->Gadgets,ID_GRID);

		SetPropVertBody(Prop,Edit->Window,
			Grid->Height,Edit->CurrentRows*Edit->RowSize,FALSE);

		if ( Edit->ew_cg )
		{
			Edit->ew_OptRender = FALSE;

			if ( Edit->Node.Type == EW_PROJECT )
			{
				ob_DoMethod( Edit->ew_cg,CRGRIDM_BuildGridFromFGList,
					((struct Project *)Edit->Special)->PtrPtr );
			}
			else
			{
				RebuildGrazerGrid(Edit);
			}
		}
	}
}

/****** Grid/RowOffsetToPot *****************************************
*
*   NAME
*	RowOffsetToPot
*
*   SYNOPSIS
*	VOID RowOffsetToPot(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID RowOffsetToPot(struct EditWindow *Edit)
{
	struct Gadget *Prop;
	struct PropInfo *PropInfo;
	ULONG Total,Offset;

	Prop = FindGadget(Edit->Gadgets,ID_KNOB);
	PropInfo = Prop->SpecialInfo;
	if (Edit->ScrollPositions > 1) {
		Total = (Edit->ScrollPositions-1) * Edit->RowSize; // total #pos
		Offset = Edit->RowOffset * Edit->RowSize;
		Offset += Edit->ScrollOffset; // offset into total
		SetPropVertPot(Prop,Edit->Window,Offset,NULL,Total);
	} else SetPropVertPot(Prop,Edit->Window,0,NULL,1);
	Edit->RenderRail = TRUE;
}

/****** Grid/PotToRowOffset *****************************************
*
*   NAME
*	PotToRowOffset
*
*   SYNOPSIS
*	VOID PotToRowOffset(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID PotToRowOffset(struct EditWindow *Edit)
{
	struct Gadget *Prop;
	struct PropInfo *PropInfo;
	ULONG A;

	Prop = FindGadget(Edit->Gadgets,ID_KNOB);
	PropInfo = Prop->SpecialInfo;

	A = (Edit->ScrollPositions-1) * Edit->RowSize;
	A = (PropInfo->VertPot * A) / MAXPOT;
	Edit->RowOffset = A / Edit->RowSize;
	Edit->ScrollOffset = A % Edit->RowSize;
}

// end of grid.c
