/********************************************************************
* $HandleScroll.c$
* $Id: HandleScroll.c,v 2.3 1994/12/08 15:36:38 CACHELIN4000 Exp $
* $Log: HandleScroll.c,v $
*Revision 2.3  1994/12/08  15:36:38  CACHELIN4000
*Make sldier wider in InitKnob, dummy out DrawKnob f'n which is now unnecessary!!
*
*Revision 2.2  1994/11/10  18:46:58  pfrench
*Now turning redraw optimization on for scrolling.
*
*Revision 2.1  1994/11/09  12:48:11  pfrench
*Added initial support for croutongrid object
*
*Revision 2.0  1994/02/17  16:24:01  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  15:57:03  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  14:44:17  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	12-17-92	Steve H		Convert to use SmartStrings
*	12-17-92	Steve H		Last Update
*
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <stdio.h>
#include <string.h>
#include <crouton_all.h>

#include <editwindow.h>
#include <gadgets.h>
#include <panel.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

extern struct PropHelp *PropHelp;

BOOL PropDown = FALSE;
struct EditWindow *TimingEdit = NULL;

/****** HandleScroll/HandleUp ************************************
*
*   NAME   
*	HandleUp
*
*   SYNOPSIS
*	struct EditWindow *HandleUp(struct EditWindow *Edit,
*		struct IntuiMessage *IntuiMsg)
*
*   FUNCTION
*	
*
*********************************************************************
*/
struct EditWindow *HandleUp(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg)
{
	if (IntuiMsg->Class == GADGETDOWN) {
		DoUpArrow(Edit);
		StartRepeat(Edit,((struct Gadget *)IntuiMsg->IAddress)->GadgetID);
	}
	else
		EndRepeat(Edit);
	return(Edit);
}


/****** HandleScroll/DoUpArrow **************************************
*
*   NAME   
*	DoUpArrow
*
*   SYNOPSIS
*	VOID DoUpArrow(struct EditWindow *Edit)
*
*   FUNCTION
*	
*
*********************************************************************
*/
VOID DoUpArrow(struct EditWindow *Edit)
{
	LONG Y,NewRowOffset,StartOffset,Step;

	if (((Edit->ScrollPositions > 1) && (Edit->RowOffset > 0))
		|| Edit->ScrollOffset) {

		Step = 10;
		if (Edit->ScrollOffset) {
			StartOffset = Edit->ScrollOffset-(Edit->ScrollOffset % Step);
			NewRowOffset = Edit->RowOffset;
		} else {
			StartOffset = Edit->RowSize - (Edit->RowSize % Step);
			NewRowOffset = Edit->RowOffset-1;
		}
		if (StartOffset == Edit->RowSize) StartOffset -= Step;

		for (Y=StartOffset; Y >= 0; Y -= Step) {
			Edit->DisplayGrid = TRUE;
			Edit->ew_OptRender = TRUE;
			DisplayGrid(NewRowOffset,Y,Edit);
		}
		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = TRUE;
		DisplayGrid(NewRowOffset,0,Edit);
		RowOffsetToPot(Edit);
	}
}

/****** HandleScroll/HandleDown ****************************************
*
*   NAME   
*	HandleDown
*
*   SYNOPSIS
*	struct EditWindow *HandleDown(struct EditWindow *Edit,
*		struct IntuiMessage *IntuiMsg)
*
*   FUNCTION
*
*
*********************************************************************
*/
struct EditWindow *HandleDown(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg)
{
	if (IntuiMsg->Class == GADGETDOWN) {
		DoDownArrow(Edit);
		StartRepeat(Edit,((struct Gadget *)IntuiMsg->IAddress)->GadgetID);
	}
	else
		EndRepeat(Edit);
	return(Edit);
}

/****** HandleScroll/DoDownArrow ************************************
*
*   NAME   
*	DoDownArrow
*
*   SYNOPSIS
*	VOID DoDownArrow(struct EditWindow *Edit)
*
*   FUNCTION
*	
*
*********************************************************************
*/
VOID DoDownArrow(struct EditWindow *Edit)
{
	LONG A,Y,Step,NewRowOffset,StartOffset,EndOffset;

	A = Edit->RowOffset+1;
	if ((Edit->ScrollPositions > 1) && ((Edit->RowOffset+Edit->RowCount) 
		< Edit->CurrentRows)) {

		Step = 10;
		NewRowOffset = A;
		if (Edit->ScrollOffset) {
			A = Edit->ScrollOffset + Step - 1;
			StartOffset = A - (A % Step);
		} else {
			StartOffset = 0;
		}
		EndOffset = Edit->RowSize-(Edit->RowSize % Step);
		for (Y = StartOffset; Y < EndOffset; Y += Step) {
			Edit->DisplayGrid = TRUE;
			Edit->ew_OptRender = TRUE;
			DisplayGrid(Edit->RowOffset,Y,Edit);
		}
		Edit->DisplayGrid = TRUE;
		Edit->ew_OptRender = TRUE;
		DisplayGrid(NewRowOffset,0,Edit);
		RowOffsetToPot(Edit);
	}
}

/****** HandleScroll/StartRepeat ************************************
*
*   NAME   
*	StartRepeat
*
*   SYNOPSIS
*	VOID StartRepeat(struct EditWindow *Edit,UWORD GadgetID)
*
*   FUNCTION
*	
*
*********************************************************************
*/
VOID StartRepeat(struct EditWindow *Edit,UWORD GadgetID)
{
	if (Edit) {
		Edit->RepeatGadgetID = GadgetID;
		TimingEdit = Edit;
		PropStartRepeat(PropHelp);
	}
}

/****** HandleScroll/EndRepeat **************************************
*
*   NAME   
*	EndRepeat
*
*   SYNOPSIS
*	VOID EndRepeat(struct EditWindow *Edit)
*
*   FUNCTION
*	
*
*********************************************************************
*/
VOID EndRepeat(struct EditWindow *Edit)
{
	if (Edit && Edit->RepeatGadgetID) {
		Edit->RepeatGadgetID = 0;
		TimingEdit = NULL;
		PropEndRepeat(PropHelp);
	}
}

/****** HandleScroll/HandleTimer ****************************************
*
*   NAME   
*	HandleTimer
*
*   SYNOPSIS
*	struct EditWindow *HandleTimer(struct EditWindow *Edit)
*
*   FUNCTION
*	
*
*********************************************************************
*/
struct EditWindow *HandleTimer(struct EditWindow *Edit)
{
	if (Edit->RepeatGadgetID) {
		PropHandleRepeat(PropHelp);
		switch (Edit->RepeatGadgetID) {
			case ID_UP:
				DoUpArrow(Edit);
				break;
			case ID_DOWN:
				DoDownArrow(Edit);
		}
	}
	return(Edit);
}

/****** Handlers/HandleProp ****************************************
*
*   NAME   
*	HandleProp
*
*   SYNOPSIS
*	struct EditWindow *HandleProp(struct EditWindow *Edit,
*		struct IntuiMessage *IntuiMsg)
*
*   FUNCTION
*	
*
*********************************************************************
*/
struct EditWindow *HandleProp(struct EditWindow *Edit,struct IntuiMessage *IntuiMsg)
{
	UWORD OldRow,OldScroll;

	if (IntuiMsg->Class == IDCMP_GADGETUP) PropDown = FALSE;
	else PropDown = TRUE;

	OldRow = Edit->RowOffset;
	OldScroll = Edit->ScrollOffset;
	if (Edit->ScrollPositions > 1) {
		PotToRowOffset(Edit);
		if ((Edit->RowOffset != OldRow) || 
			(Edit->ScrollOffset != OldScroll))
			Edit->DisplayGrid = TRUE;
	}
	Edit->RenderRail = TRUE;
	return(Edit);
}

#define RAIL_W 7
LONG RailColor[] = { 4,4,5,5,5,2,2 };
//*******************************************************************
VOID InitKnobRail(struct EditWindow *Edit)
{ // DUH  What's a border ...
	struct Gadget *Prop;
	LONG X,Y,X2,Y2;
	struct RastPort *RP;

	if (Prop = FindGadget(Edit->Gadgets,ID_KNOB)) {
		RP = Edit->Window->RPort;
//		X = Prop->LeftEdge + ((Prop->Width - RAIL_W)>>1);
//		X2 = X + RAIL_W - 1;
		X = Prop->LeftEdge - 1;
		X2 = X + Prop->Width+1;
		Y = Prop->TopEdge-1;
		Y2 = Prop->TopEdge+Prop->Height+1;
		SetAPen(RP,PAL_LBLACK);
		Move(RP,X2,Y);
		Draw(RP,X+1,Y);
		Draw(RP,X,Y+1);
		Draw(RP,X,Y2);
		Move(RP,X-1,Y2-1);
		Draw(RP,X-1,Y+1);
		Draw(RP,X+1,Y-1);
		Draw(RP,X2,Y-1);

		SetAPen(RP,PAL_LGRAY);
		Move(RP,X2+1,Y+1);
		Draw(RP,X2+1,Y2-1);
		Draw(RP,X2-1,Y2+1);
		Draw(RP,X,Y2+1);
		Move(RP,X+1,Y2);
		Draw(RP,X2,Y2);
		Draw(RP,X2,Y+1);

#ifdef NOBEVEL
		SetAPen(RP,PAL_LBLACK);
		Move(RP,X2,Y);
		Draw(RP,X,Y);
		Draw(RP,X,Y2);
		Move(RP,X-1,Y2+1);
		Draw(RP,X-1,Y-1);
		Draw(RP,X2+1,Y-1);
		SetAPen(RP,PAL_LGRAY);
		Move(RP,X2+1,Y);
		Draw(RP,X2+1,Y2+1);
		Draw(RP,X,Y2+1);
		Move(RP,X+1,Y2);
		Draw(RP,X2,Y2);
		Draw(RP,X2,Y+1);
#endif

/*
		SetAPen(RP,PAL_LBLACK);
		Move(RP,X+1,Y-2);
		Draw(RP,X+5,Y-2);
		Move(RP,X,Y-1);
		Draw(RP,X+4,Y-1);
		Move(RP,X+1,Y2+1);
		Draw(RP,X+2,Y2+1);
		SetAPen(RP,PAL_LGRAY);
		Move(RP,X+5,Y-1);
		Draw(RP,X+6,Y-1);
		Move(RP,X+2,Y2+1);
		Draw(RP,X+6,Y2+1);
		Move(RP,X+1,Y2+2);
		Draw(RP,X+5,Y2+2);
 */
	}
}

//*******************************************************************
VOID DrawKnobRail(struct EditWindow *Edit)
{
	return;
/*
	struct Gadget *Prop;
	LONG X,Y,X2,Y2,KnobY,KnobY2,*L;
	struct RastPort *RP;

	if (Prop = FindGadget(Edit->Gadgets,ID_KNOB)) {
		RP = Edit->Window->RPort;
		X = Prop->LeftEdge + ((Prop->Width - RAIL_W)>>1);
		X2 = X + RAIL_W - 1;
		Y = Prop->TopEdge;
		Y2 = ((struct Image *)Prop->GadgetRender)->Height; // Y2 temp
		KnobY = Prop->Height - Y2;
		KnobY = ((((struct PropInfo *)Prop->SpecialInfo)->VertPot * KnobY)
			 / MAXPOT) + Y;
		KnobY2 = KnobY + Y2 ;
		Y2 = Prop->TopEdge+Prop->Height-1;
		L = RailColor;
		Forbid();
		for (; X <= X2; X++) {
			SetAPen(RP,*L++);
			if (Y != KnobY) {
				Move(RP,X,Y);
				Draw(RP,X,KnobY);
			}
			if (Y2 != KnobY) {
				Move(RP,X,KnobY2);
				Draw(RP,X,Y2);
			}
		}
		Permit();
		WaitBlit();
	}
*/
}

// end of handlescroll.c
