/*********************************************************************\
*
* HorizAdj - Tweak playback pixel offsets
*
* $Id: HorizAdj.c,v 1.0 1995/05/05 15:50:37 Flick Exp $
*
* $Log: HorizAdj.c,v $
*Revision 1.0  1995/05/05  15:50:37  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	11/16/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	chan,value,item;
	ULONG	res;
	WORD	thevalue;

	if ((argc<2)||(argc>3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <vidchan (3,4)> [<value>]\n",argv[0]);
		printf("Beta test software, not for general distribution\n");
		printf("Copyright  1994, Newtek, inc.\n");
		return(20);
	}

	GetArg(argv[1],&chan,3,4,"Video Channel");
	if (chan==3)
		item = CALIB_HPLAYOFFSETA;
	else
		item = CALIB_HPLAYOFFSETB;

	if (argc==3)
		GetArg(argv[2],&value,0,200,"Value");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	if (argc==3) {
		res = FlyerWriteCalib(0,item,-value,1);
		if (res)
			printf("Error %ld - %ls\n",res,Error2String(res));
		else
			printf("Okay\n");
	}
	else {
		res = FlyerReadCalib(0,item,&thevalue);
		if (res)
			printf("Error %ld - %ls\n",res,Error2String(res));
		else
			printf("Current value is %ld\n",-thevalue);
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stcd_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

