/********************************************************************
* $ImageInfo.c$ -- List of gadget positions, IDs in Gadget64.pic and Gadget4.pic
* $Log: ImageInfo.c,v $
*Revision 2.30  1995/11/03  15:53:59  Flick
*Now uses better choices of small icons for books/scrolls/crawls/keys & ASCII
*
*Revision 2.29  1995/11/03  14:01:11  Flick
*Compensation for new art for "All" & "Clone" button sizes
*
*Revision 2.28  1995/10/02  15:21:26  Flick
*Adjusted for new sizes of All & Duplicate buttons
*
*Revision 2.27  1995/09/19  12:39:32  Flick
*Removed use of some extra junk in the .pic -- added 4 sizes of buttons, both relief and highlight type
*
*Revision 2.26  1995/07/06  18:21:10  Flick
*Added ID_CROUTONSTAMP_AUDIO
*
*Revision 2.25  1995/06/28  17:46:42  pfrench
*Added new imagery for crouton stamp images
*
*Revision 2.24  1995/02/27  22:13:05  pfrench
*coords of bottom-row gads were off by one.
*
*Revision 2.23  1995/02/27  13:01:17  pfrench
*Added new gadgets for backup/restore buttons
*
*Revision 2.22  1995/02/01  17:57:19  CACHELIN4000
*Add ID_BUTTON
*
*Revision 2.21  1995/01/12  13:43:56  CACHELIN4000
*Fix ID_GHOST_SAVE width too... duoooh!
*
*Revision 2.20  1995/01/12  12:04:48  CACHELIN4000
*add PLAY_PART button, shrink Save width
*
*Revision 2.19  1994/12/21  20:05:03  pfrench
*Added Directory tabs images
*
*Revision 2.18  1994/12/08  13:26:08  CACHELIN4000
*Trim vertical slider ( ID_KNOB )
*
*Revision 2.17  1994/12/03  14:50:40  CACHELIN4000
*Add ID_QUICK_TUNE gadget
*
*Revision 2.16  1994/10/04  16:03:26  CACHELIN4000
*Continue/Cancel same size, other tweaks by Todd
*
*Revision 2.15  1994/09/27  19:43:34  pfrench
*Un-commented id_popup_disp
*
*Revision 2.14  1994/09/27  16:24:35  pfrench
*Removed image coords for the View Popup gadget
*
*Revision 2.13  1994/08/31  17:57:14  CACHELIN4000
*trim LRKnob image
*
*Revision 2.12  94/08/25  18:15:10  pfrench
*Added coords of ID_VCR_STOP
*
*Revision 2.11  1994/08/16  15:06:32  pfrench
*Fixed small problem
*
*Revision 2.10  1994/08/16  11:25:07  pfrench
*Added ID_GHOST_ALL gadget coords
*
*Revision 2.9  1994/07/04  18:40:51  CACHELIN4000
**** empty log message ***
*
*Revision 2.8  94/06/24  17:20:07  CACHELIN4000
*Add ID_MARK_PANEL, etc.
*
*Revision 2.7  94/06/22  10:46:48  CACHELIN4000
**** empty log message ***
*
*Revision 2.6  94/06/03  09:21:18  CACHELIN4000
*add ID_FINE_TUNE
*
*Revision 2.5  94/05/24  08:47:10  CACHELIN4000
**** empty log message ***
*
*Revision 2.4  94/03/16  19:00:34  CACHELIN4000
**** empty log message ***
*
*Revision 2.3  94/03/16  16:12:00  CACHELIN4000
**** empty log message ***
*
*Revision 2.2  94/03/16  12:22:04  CACHELIN4000
**** empty log message ***
*
*Revision 2.1  94/03/02  21:05:10  CACHELIN4000
**** empty log message ***
*
*Revision 2.0  94/02/24  17:25:23  CACHELIN4000
*FirstCheckIn
*
* $Id: ImageInfo.c,v 2.30 1995/11/03 15:53:59 Flick Exp $
*
* Copyright (c)1993 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*
*	10-8-93	Steve H		Created this file
*	1-6-94	Daniel K	Last Modified
* Feb 16 1994 Arnie
*******************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <editwindow.h>
#include <gadgets.h>


// LeftEdge,TopEdge,Width,Height
struct IBox ImageBox[] = {
{ 18,432,13,14 },			//	ID_CROUTONSTAMP_LOCKED,
{ 18,432,13,14 },			//	ID_CROUTONSTAMP_LOCKED alt,

{ 43,432,13,14 },			//	ID_CROUTONSTAMP_MASTERCUT,
{ 43,432,13,14 },			//	ID_CROUTONSTAMP_MASTERCUT alt,

{ 68,432,13,14 },			//	ID_CROUTONSTAMP_CUTAWAY,
{ 68,432,13,14 },			//	ID_CROUTONSTAMP_CUTAWAY alt,

{ 93,432,13,14 },			//	ID_CROUTONSTAMP_AUDIO,
{ 93,432,13,14 },			//	ID_CROUTONSTAMP_AUDIO alt,

{ 1,0,39,20 },				// ID_PLAY
{ 1,22,39,20 },			// ID_PLAY alt
{ 188,0,35,20 },			// ID_ALL
{ 188,22,35,20 },			// ID_ALL alt
{ 260,0,56,20 },			// ID_DELETE
{ 260,22,56,20 },			// ID_DELETE alt
//{ 317,0,72,20 },			// ID_DUPLICATE
//{ 317,22,72,20 },			// ID_DUPLICATE alt
{ 317,0,59,20 },			// ID_DUPLICATE
{ 317,22,59,20 },			// ID_DUPLICATE alt

{ 91,292,65,20 },			// ID_ROOT_VOL
{ 91,314,65,20 },			// ID_ROOT_VOL alt
{ 175,292,65,20 },		// ID_ROOT_DEV
{ 175,314,65,20 },		// ID_ROOT_DEV alt
{ 258,292,65,20 },		// ID_ROOT_ASS
{ 258,314,65,20 },		// ID_ROOT_ASS alt
{ 156,292,15,20 },		// ID_CHOOSE_ROOT
{ 156,314,15,20 },		// ID_CHOOSE_ROOT alt

{ 54,95,96,20 },			// ID_NEW_PROJECT
{ 54,117,96,20 },			// ID_NEW_PROJECT alt
{ 151,95,89,20 },			// ID_NEW_FOLDER
{ 151,117,89,20 },		// ID_NEW_FOLDER alt
{ 241,95,64,20 },			// ID_REQ_RENAME
{ 241,117,64,20 },		// ID_REQ_RENAME alt
{ 0,228,20,13 },			// ID_UP
{ 25,179,20,13 },			// ID_UP alt
{ 0,241,20,12 },			// ID_DOWN
{ 25,192,20,12 },			// ID_DOWN alt
{ 25,135,20,19 },			// ID_CLOSE
{ 25,155,20,19 },			// ID_CLOSE alt
{ 28,96,16,31 },			// ID_KNOB
{ 28,96,16,31 },			// ID_KNOB alt
//{ 0,119,20,33 },		// ID_KNOB (Fat vertical knob)
//{ 0,119,20,33 },		// ID_KNOB alt
// { 508,74,54,18 },		// ID_REQ_OK
// { 508,113,54,18 },	// ID_REQ_OK alt
// { 450,74,54,18 },		// ID_REQ_CANCEL
// { 450,113,54,18 },	// ID_REQ_CANCEL alt
{ 523,74,69,18 },			// ID_REQ_OK
{ 523,113,69,18 },		// ID_REQ_OK alt
{ 450,74,69,18 },			// ID_REQ_CANCEL
{ 450,113,69,18 },		// ID_REQ_CANCEL alt
{ 377,74,69,18 },			// ID_REQ_CONTINUE
{ 377,113,69,18 },		// ID_REQ_CONTINUE alt

{ 90,189,80,50 },			// ID_NAMES_ASSIGN
{ 90,189,80,50 },			// ID_NAMES_ASSIGN alt (don't make alt imagery for these)
{ 170,189,80,50 },		// ID_NAMES_DEVICE
{ 170,189,80,50 },		// ID_NAMES_DEVICE alt
{ 250,189,80,50 },		// ID_NAMES_FILE
{ 250,189,80,50 },		// ID_NAMES_FILE alt
{ 330,189,80,50 },		// ID_NAMES_FOLDER
{ 330,189,80,50 },		// ID_NAMES_FOLDER alt
{ 490,189,80,50 },		// ID_NAMES_REMOVABLE
{ 490,189,80,50 },		// ID_NAMES_REMOVABLE alt

{ 363,161,19,15 },		// ID_SMALL_ASSIGN		(arrows)
{ 363,161,19,15 },		// ID_SMALL_ASSIGN alt (don't make alt imagery for these)
{ 394,161,19,15 },		// ID_SMALL_DEVICE		(drive)
{ 394,161,19,15 },		// ID_SMALL_DEVICE alt
{ 424,161,19,15 },		// ID_SMALL_FILE			(paper)
{ 424,161,19,15 },		// ID_SMALL_FILE alt
{ 454,161,19,15 },		// ID_SMALL_FOLDER		(folder)
{ 454,161,19,15 },		// ID_SMALL_FOLDER alt
{ 482,161,19,15 },		// ID_SMALL_PROJECT		(4 small boxes)
{ 482,161,19,15 },		// ID_SMALL_PROJECT alt
{ 511,161,19,15 },		// ID_SMALL_REMOVABLE	(CD image)
{ 511,161,19,15 },		// ID_SMALL_REMOVABLE alt
{ 580,161,19,15 },		// ID_SMALL_FRAME			(film strip)
{ 580,161,19,15 },		// ID_SMALL_FRAME alt
{ 482,144,19,15 },		// ID_SMALL_IMAGE			(paint brush)
{ 482,144,19,15 },		// ID_SMALL_IMAGE alt
{ 363,144,19,15 },		// ID_SMALL_3DOBJ			(LW logo)
{ 363,144,19,15 },		// ID_SMALL_3DOBJ alt
{ 363,144,19,15 },		// ID_SMALL_3DSCN			(LW logo)
{ 363,144,19,15 },		// ID_SMALL_3DSCN alt
{ 363,144,19,15 },		// ID_SMALL_3DSRF			(LW logo)
{ 363,144,19,15 },		// ID_SMALL_3DSRF alt
{ 363,144,19,15 },		// ID_SMALL_3DENV			(LW logo)
{ 363,144,19,15 },		// ID_SMALL_3DENV alt
{ 363,144,19,15 },		// ID_SMALL_3DMOT			(LW logo)
{ 363,144,19,15 },		// ID_SMALL_3DMOT alt
{ 394,144,19,15 },		// ID_SMALL_EFFECT		("FX")
{ 394,144,19,15 },		// ID_SMALL_EFFECT alt
{ 424,144,19,15 },		// ID_SMALL_FONT			("F")
{ 424,144,19,15 },		// ID_SMALL_FONT alt
{ 424,144,19,15 },		// ID_SMALL_EPS			("F")
{ 424,144,19,15 },		// ID_SMALL_EPS alt
{ 557,143,19,15 },		// ID_SMALL_CGPAGE		("CG")
{ 557,143,19,15 },		// ID_SMALL_CGPAGE alt
{ 557,143,19,15 },		// ID_SMALL_CGBOOK		("CG")
{ 557,143,19,15 },		// ID_SMALL_CGBOOK alt
{ 454,144,19,15 },		// ID_SMALL_REXX			("RX")
{ 454,144,19,15 },		// ID_SMALL_REXX alt
{ 424,161,19,15 },		// ID_SMALL_ASCII			(Paper)
{ 424,161,19,15 },		// ID_SMALL_ASCII alt
// { 604,121,19,15 },	// ID_SMALL_CLIP
// { 604,121,19,15 },	// ID_SMALL_CLIP alt
// { 580,144,19,15 },	// ID_SMALL_AUDIO
// { 580,144,19,15 },	// ID_SMALL_AUDIO alt
{ 604,94,19,15 },			// ID_SMALL_CLIP			(Double film strip)
{ 604,94,19,15 },			// ID_SMALL_CLIP alt
{ 604,144,19,15 },		// ID_SMALL_AUDIO			(Speaker+waves)
{ 604,144,19,15 },		// ID_SMALL_AUDIO alt

{ 176,382,160,25 },		// ID_CROUTON_SMALL
{ 176,414,160,25 },		// ID_CROUTON_SMALL alt
{ 499,0,140,20 },			// ID_POPUP_DISP
{ 499,0,140,20 },			// ID_POPUP_DISP alt
{ 541,162,8,4 },			// ID_POPUP_UP
{ 541,162,8,4 },			// ID_POPUP_UP alt
{ 541,168,8,4 },			// ID_POPUP_DOWN
{ 541,168,8,4 },			// ID_POPUP_DOWN alt
{ 90,239,80,50 },			// ID_NAMES_FLOPPY
{ 90,239,80,50 },			// ID_NAMES_FLOPPY alt
{ 557,161,19,15 },		// ID_SMALL_FLOPPY
{ 557,161,19,15 },		// ID_SMALL_FLOPPY alt

{ 115,0,68,20 },			// ID_CONTROLS
{ 115,22,68,20 },			// ID_CONTROLS alt
{ 45,0,65,20 },			// ID_NEW_CLIP
{ 45,22,65,20 },			// ID_NEW_CLIP alt
{ 229,447,78,20 },		// ID_REQ_DARK_CANCEL
{ 229,470,78,20 },		// ID_REQ_DARK_CANCEL alt
{ 201,165,40,20 },		// ID_REQ_RECORD
{ 281,165,40,20 },		// ID_REQ_RECORD alt
{ 241,165,39,20 },		// ID_REQ_STOP
{ 321,165,39,20 },		// ID_REQ_STOP alt

{ 260,44,129,20 },		// ID_GHOST_DEL_DUPE
{ 260,44,129,20 },		// ID_GHOST_DEL_DUPE (no alt)
{ 54,139,186,20 },		// ID_GHOST_PROJ_FOLD
{ 54,139,186,20 },		// ID_GHOST_PROJ_FOLD (no alt)
{ 188,44,35,20 },			// ID_GHOST_ALL
{ 188,44,35,20 },			// ID_GHOST_ALL (no alt)
{ 115,44,68,20 },			// ID_GHOST_CONTROLS
{ 115,44,68,20 },			// ID_GHOST_CONTROLS (no alt)
{ 45,44,65,20 },			// ID_GHOST_NEW_CLIP
{ 45,44,65,20 },			// ID_GHOST_NEW_CLIP (no alt)
//{ 394,0,100,20 },		// ID_SAVE_PROJECT
//{ 394,22,100,20 },		// ID_SAVE_PROJECT alt
{ 394,0,47,20 },			// ID_SAVE_PROJECT
{ 394,22,47,20 },			// ID_SAVE_PROJECT alt
{ 394,44,47,20 },			// ID_GHOST_SAVE_PROJ
{ 394,44,47,20 },			// ID_GHOST_SAVE_PROJ (no alt)
{ 1,44,39,20 },			// ID_GHOST_PLAY
{ 1,44,39,20 },			// ID_GHOST_PLAY (no alt)

{ 143,447,78,20 },		// ID_DARK_CONTINUE
{ 143,470,78,20 },		// ID_DARK_CONTINUE alt
// { 415,259,33,20 },	// ID_LR_KNOB      // Fat Style !!
// { 415,259,33,20 },	// ID_LR_KNOB alt
//{ 375,261,33,16 },		// ID_LR_KNOB
//{ 375,261,33,16 },		// ID_LR_KNOB alt
{ 376,261,31,16 },		// ID_LR_KNOB
{ 376,261,31,16 },		// ID_LR_KNOB alt
{ 539,259,16,19 },		// ID_LEFT
{ 575,259,16,19 },		// ID_LEFT alt
{ 555,259,17,19 },		// ID_RIGHT
{ 591,259,17,19 },		// ID_RIGHT alt
{ 74,336,40,20 },			// ID_1
{ 74,360,40,20 },			// ID_1 alt
{ 114,336,40,20 },		// ID_2
{ 114,360,40,20 },		// ID_2 alt
{ 154,336,40,20 },		// ID_3
{ 154,360,40,20 },		// ID_3 alt
{ 194,336,40,20 },		// ID_4
{ 194,360,40,20 },		// ID_4 alt
{ 398,336,41,20 },		// ID_4_END
{ 398,360,41,20 },		// ID_4_END alt
{ 234,336,41,20 },		// ID_5_END
{ 234,360,41,20 },		// ID_5_END alt
{ 348,314,143,20 },		// ID_IN_TYPE
{ 348,292,143,20 },		// ID_IN_TYPE alt
{ 495,314,143,20 },		// ID_OUT_TYPE
{ 495,292,143,20 },		// ID_OUT_TYPE alt
//{ 26,336,21,19 },		// ID_BOOL     // Round style!
//{ 26,356,21,19 },		// ID_BOOL alt
{ 51,336,20,19 },			// ID_BOOL
{ 51,356,20,19 },			// ID_BOOL alt
//{ 42,203,43,37 },			// ID_SMILEY
//{ 42,242,43,37 },			// ID_SMILEY alt
{ 324,450,40,20 },		// ID_S
{ 324,474,40,20 },		// ID_S alt
{ 364,450,40,20 },		// ID_M
{ 364,474,40,20 },		// ID_M alt
{ 404,450,40,20 },		// ID_F
{ 404,474,40,20 },		// ID_F alt
{ 444,450,40,20 },		// ID_V
{ 444,474,40,20 },		// ID_V alt
{ 511,416,42,20 },		// ID_VCR_REC
{ 511,436,42,20 },		// ID_VCR_REC alt
{ 552,416,42,20 },		// ID_VCR_PAUSE
{ 552,436,42,20 },		// ID_VCR_PAUSE alt
{ 593,416,42,20 },		// ID_VCR_PLAY
{ 593,436,42,20 },		// ID_VCR_PLAY alt
{ 531,457,42,20 },		// ID_VCR_REW
{ 531,477,42,20 },		// ID_VCR_REW alt
{ 572,457,42,20 },		// ID_VCR_FFWD
{ 572,477,42,20 },		// ID_VCR_FFWD alt
{ 240,165,42,20 },		// ID_VCR_STOP
{ 320,165,42,20 },		// ID_VCR_STOP alt
{ 457,242,17,19 },		// ID_EZ_SLIDE_L
{ 491,242,17,19 },		// ID_EZ_SLIDE_L alt
{ 474,242,16,19 },		// ID_EZ_SLIDE_R
{ 508,242,16,19 },		// ID_EZ_SLIDE_R alt
//{ 1,67,92,22 },			// ID_FINE_TUNE
//{ 273,67,92,22 },		// ID_FINE_TUNE alt
//{ 104,450,96,20 },		// ID_MARK_CLIP
//{ 104,472,96,20 },		// ID_MARK_CLIP alt
//{ 104,494,96,20 },		// ID_MARK_PANEL
//{ 104,516,96,20 },		// ID_MARK_PANEL alt
// { 104,538,96,20 },	// ID_REORG		(shorter)
// { 104,560,96,20 },	// ID_REORG alt
//{ 206,538,151,20 },	// ID_REORG
//{ 206,560,151,20 },	// ID_REORG alt
//{ 360,538,117,20 },	// ID_REC_PANEL
//{ 360,560,117,20 },	// ID_REC_PANEL alt
//{ 2,450,96,20 },		// ID_QUICK_TUNE
//{ 2,472,96,20 },		// ID_QUICK_TUNE alt
{ 550,339,80,16 },		// ID_DIRTAB_TAB
{ 550,357,80,16 },		// ID_DIRTAB_TAB alt
{ 458,339,22,16 },		// ID_DIRTAB_CYCLE
{ 458,358,22,16 },		// ID_DIRTAB_CYCLE alt
{ 480,339,59,16 },		// ID_DIRTAB_SET
{ 480,358,59,16 },		// ID_DIRTAB_SET alt
{ 490,457,42,20 },		// ID_PLAY_PART
{ 490,477,42,20 },		// ID_PLAY_PART alt
//{ 60,495,96,20 },			// ID_BUTTON
//{ 60,517,96,20 },			// ID_BUTTON alt
{ 4,654,89,20 },			// ID_BU_BACKUP
{ 278,654,89,20 },		// ID_BU_BACKUP alt
{ 4,676,89,20 },			// ID_BU_RESTORE
{ 278,676,89,20 },		// ID_BU_RESTORE alt
{ 95,632,89,20 },			// ID_BU_QUIT
{ 369,632,89,20 },		// ID_BU_QUIT alt
{ 95,654,89,20 },			// ID_BU_CONTINUE
{ 369,654,89,20 },		// ID_BU_CONTINUE alt
{ 95,676,89,20 },			// ID_BU_CANCEL
{ 369,676,89,20 },		// ID_BU_CANCEL alt
{ 186,654,89,20 },		// ID_BU_PAUSE
{ 460,654,89,20 },		// ID_BU_PAUSE alt
{ 186,676,89,20 },		// ID_BU_SAVELOG
{ 460,676,89,20 },		// ID_BU_SAVELOG alt
{  2,495, 56,20 },		// ID_BUTTON1
{  2,517, 56,20 },		// ID_BUTTON1 alt
{ 60,495, 96,20 },		// ID_BUTTON2
{ 60,517, 96,20 },		// ID_BUTTON2 alt
{158,495,120,20 },		// ID_BUTTON3
{158,517,120,20 },		// ID_BUTTON3 alt
{280,495,160,20 },		// ID_BUTTON4
{280,517,160,20 },		// ID_BUTTON4 alt

{  2,539, 56,20 },		// ID_HOTBUTTON1
{  2,561, 56,20 },		// ID_HOTBUTTON1 alt
{ 60,539, 96,20 },		// ID_HOTBUTTON2
{ 60,561, 96,20 },		// ID_HOTBUTTON2 alt
{158,539,120,20 },		// ID_HOTBUTTON3
{158,561,120,20 },		// ID_HOTBUTTON3 alt
{280,539,160,20 },		// ID_HOTBUTTON4
{280,561,160,20 },		// ID_HOTBUTTON4 alt

{ 0,0,0,0 }
};


WORD CutImage[] = {
	ID_CROUTONSTAMP_LOCKED,
	ID_CROUTONSTAMP_MASTERCUT,
	ID_CROUTONSTAMP_CUTAWAY,
	ID_CROUTONSTAMP_AUDIO,
	ID_PLAY,
	ID_ALL,
	ID_DELETE,
	ID_DUPLICATE,
	ID_ROOT_VOL,
	ID_ROOT_DEV,
	ID_ROOT_ASS,
	ID_CHOOSE_ROOT,
	ID_NEW_PROJECT,
	ID_NEW_FOLDER,
	ID_REQ_RENAME,
	ID_UP,
	ID_DOWN,
	ID_CLOSE,
	ID_KNOB,
	ID_REQ_OK,
	ID_REQ_CANCEL,
	ID_REQ_CONTINUE,

	ID_NAMES_ASSIGN,
	ID_NAMES_DEVICE,
	ID_NAMES_FILE,
	ID_NAMES_FOLDER,
	ID_NAMES_REMOVABLE,

	ID_SMALL_ASSIGN,
	ID_SMALL_DEVICE,
	ID_SMALL_FILE,
	ID_SMALL_FOLDER,
	ID_SMALL_PROJECT,
	ID_SMALL_REMOVABLE,
	ID_SMALL_FRAME,
	ID_SMALL_IMAGE,
	ID_SMALL_3DOBJ,
	ID_SMALL_3DSCN,
	ID_SMALL_3DSRF,
	ID_SMALL_3DENV,
	ID_SMALL_3DMOT,
	ID_SMALL_EFFECT,
	ID_SMALL_FONT,
	ID_SMALL_EPS,
	ID_SMALL_CGPAGE,
	ID_SMALL_CGBOOK,
	ID_SMALL_REXX,
	ID_SMALL_ASCII,
	ID_SMALL_CLIP,
	ID_SMALL_AUDIO,

	ID_CROUTON_SMALL,
	ID_POPUP_DISP,
	ID_POPUP_UP,
	ID_POPUP_DOWN,
	ID_NAMES_FLOPPY,
	ID_SMALL_FLOPPY,
	ID_CONTROLS,
	ID_NEW_CLIP,
	ID_REQ_DARK_CANCEL,
	ID_REQ_RECORD,
	ID_REQ_STOP,
	ID_GHOST_DEL_DUPE,
	ID_GHOST_PROJ_FOLD,
	ID_GHOST_ALL,
	ID_GHOST_CONTROLS,
	ID_GHOST_NEW_CLIP,
	ID_SAVE_PROJECT,
	ID_GHOST_SAVE_PROJ,
	ID_GHOST_PLAY,
	ID_DARK_CONTINUE,
	ID_LR_KNOB,
	ID_LEFT,
	ID_RIGHT,
	ID_1, ID_2, ID_3, ID_4, ID_4_END, ID_5_END,
	ID_IN_TYPE,
	ID_OUT_TYPE,
	ID_BOOL,
//	ID_SMILEY,
	ID_S, ID_M, ID_F, ID_V,
	ID_VCR_REC,
	ID_VCR_PAUSE,
	ID_VCR_PLAY,
	ID_VCR_REW,
	ID_VCR_FFWD,
	ID_VCR_STOP,
	ID_EZ_SLIDE_L,
	ID_EZ_SLIDE_R,
//	ID_FINE_TUNE,
//	ID_MARK_CLIP,
//	ID_MARK_PANEL,
//	ID_REORG,
//	ID_REC_PANEL,
//	ID_QUICK_TUNE,
	ID_DIRTAB_TAB,
	ID_DIRTAB_CYCLE,
	ID_DIRTAB_SET,
	ID_PLAY_PART,
//	ID_BUTTON,
	ID_BU_BACKUP,
	ID_BU_RESTORE,
	ID_BU_QUIT,
	ID_BU_CONTINUE,
	ID_BU_CANCEL,
	ID_BU_PAUSE,
	ID_BU_SAVELOG,

	ID_BUTTON1,		/* Four lengths of relief-type buttons */
	ID_BUTTON2,
	ID_BUTTON3,
	ID_BUTTON4,

	ID_HOTBUTTON1,	/* Four lengths of highlite-type buttons */
	ID_HOTBUTTON2,
	ID_HOTBUTTON3,
	ID_HOTBUTTON4,

	ID_END_OF_LIST
};


/* System for auto-sized buttons, based on label text */
WORD ButtonSizes[] = {	56,96,120,160,0 };

WORD	ReliefButtons[] = {
	ID_BUTTON1,
	ID_BUTTON2,
	ID_BUTTON3,
	ID_BUTTON4
};
WORD	HotButtons[] = {
	ID_HOTBUTTON1,
	ID_HOTBUTTON2,
	ID_HOTBUTTON3,
	ID_HOTBUTTON4
};

#if 0
These gadgets were eliminated, and so their CHIP image(s) are no longer kept in memory

We should really remove these from the PowerWindows data.  I would, if only I could get
PowerWindows 2.5 to run without crashing!!!

ID_FINE_TUNE
ID_QUICK_TUNE
ID_MARK_CLIP
ID_MARK_PANEL
ID_REORG
ID_REC_PANEL

These gadgets have only a few callers -- it may be able to eliminate these too someday
ID_REQ_DARK_CANCEL	(1)
ID_DARK_CONTINUE		(1)

#endif

// end of imageinfo.c
