/*********************************************************************\
*
* IntFormat - Format Flyer drives (internal version)
*
* $Id: IntFormat.c,v 1.0 1995/05/05 15:50:57 Flick Exp $
*
* $Log: IntFormat.c,v $
*Revision 1.0  1995/05/05  15:50:57  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,long *var,long lo,long hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

main(int argc,char **argv)
{
	int	unit,drive,flags;
	ULONG	res;
	LONG	blocks;
	struct DateStamp now;

	if (argc!=6) {
		printf("Usage: %ls <board> <drive> <volume name> <blocks> <flags>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"SCSI drive");
	GetLongArg(argv[4],&blocks,0,0x7FFFFFFF,"Blocks");
	GetArg(argv[5],&flags,0,3,"Flags");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	/* Get date/time (pass to Flyer as volume creation date) */
	DateStamp(&now);

	FlyVol.SCSIdrive = drive;
	res = FlyerFormat(&FlyVol,argv[3],&now,blocks,flags);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,long *var,long lo,long hi,char *label)
{
	stch_l(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
