/*********************************************************************\
*
* LoopFile - Copies file to video buffer
*
* $Id: LoopFile.c,v 1.0 1995/05/05 15:51:40 Flick Exp $
*
* $Log: LoopFile.c,v $
*Revision 1.0  1995/05/05  15:51:40  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/23/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "Flyer.h"

ULONG ReadBinFile(char *,ULONG,char *);
void FreeFile(void);
void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

UBYTE	*Buffer;
ULONG	Length;

ULONG	Args[6];

main(int argc,char **argv)
{
	ULONG	res;
	LONG	size;
	int	unit;

#if 0
	int	i;
	LONG	datasize;
	ULONG	ID;
	register UBYTE *ptr,*src;
#endif

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <file>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	size = ReadBinFile(argv[2],0,".enc");
	if (size) {
#if 0
		printf("Copying data to SRAM\n");

		ptr = (UBYTE *)0xEC2000;
		src = Buffer;

		for (i=0;i<size;i++)
			*ptr++ = *src++;

		datasize = size;
		FreeFile();

		size = ReadBinFile("m2:GetVid",0x0700,".bin");
		if (size) {
			Args[0] = 0x002000;
			Args[1] = datasize;
			res = RunModule(unit,size,Buffer,&ID,2,Args);

			for (;;) {
				res = CheckCmd(ID);
				if (res != FERR_BUSY) {
					printf("Complete\n");
					break;
				}
			}
		}
#endif
		res = FlyerLoadVideo(unit,Buffer,size);
	}
	CloseLibrary(FlyerBase);
	FreeFile();

	return(0);
}


ULONG ReadBinFile(char *name,ULONG offset,char *suffix)
{
	char	filename[80];
	FILE	*fp;
	int	read;

	strcpy(filename,name);
	if (stricmp(suffix,&filename[strlen(filename)-4]))
		strcat(filename,suffix);

	read = 0;
	fp = fopen(filename,"r");
	if (fp) {
		fseek(fp,0,SEEK_END);
		Length = ftell(fp)-offset;
		fseek(fp,offset,SEEK_SET);

		Buffer = AllocMem(Length,MEMF_PUBLIC);
		if (Buffer) {
			read = fread(Buffer,Length,1,fp);
			if (read != 1)
				printf("Warning: entire file not read!\n");
		}
		else
			printf("Could not allocate memory\n");
		fclose(fp);
	}
	else
		printf("Could not find file %s\n",filename);

	if (read==1)
		return(Length);
	else
		return(0);
}


void FreeFile(void)
{
	if (Length)
		FreeMem(Buffer,Length);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
