/*********************************************************************\
*
* MakeHead - Make A/B head
*
* $Id: MakeHead.c,v 1.0 1995/05/05 15:51:50 Flick Exp $
*
* $Log: MakeHead.c,v $
*Revision 1.0  1995/05/05  15:51:50  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	07/01/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	res,frame,frames;

	if ((argc!=6)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <name> <frame> <frames>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&drive,0,23,"SCSI drive");
	GetLongArg(argv[4],&frame,0,0x7FFFFFFF,"Start Frame");
	GetLongArg(argv[5],&frames,0,0x7FFFFFFF,"Frame Count");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.Path = argv[3];
	FlyVol.Board = unit;
	FlyVol.SCSIdrive = drive;

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	Action.Flags = 0;
	Action.VidStartField = frame * 4;
	Action.VidFieldCount = frames * 4;

	res = MakeClipHead(&Action);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
