/*********************************************************************\
*
* Module - Loads/calls software module
*
* $Id: Module.c,v 1.0 1995/05/05 15:52:00 Flick Exp $
*
* $Log: Module.c,v $
*Revision 1.0  1995/05/05  15:52:00  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/05/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "Flyer.h"

ULONG ReadBinFile(char *,ULONG);
void FreeFile(void);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;

UBYTE	*Buffer;
ULONG	Length;

BPTR	handle;

ULONG Args[6];

main(int argc,char **argv)
{
	int	i,unit;
	LONG	size;
	ULONG	res,ID;

	if ((argc<3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <file> <args...>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");

	for (i=3;i<argc;i++) {
		if ((i-3)<6)
			GetLongArg(argv[i],&Args[i-3],0,0xFFFFFFFF,"Argument");
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	handle = Input();

	/* Load code into SRAM */
	size = ReadBinFile(argv[2],0x0700);
	if (size) {
		printf("Starting module (press RETURN to abort)\n");
		res = RunModule(unit,size,Buffer,&ID,argc-3,Args);

		for (;;) {
			if (WaitForChar(handle,30)) {
				getchar();
				printf("Trying to abort...\n");
				res = AbortCmd(ID);
				break;
			}
			res = CheckCmd(ID);
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}

		if (res)
			printf("Error %ld - %ls\n",res,Error2String(res));
		else {
			printf("Okay\n");
		}
	}
	CloseLibrary(FlyerBase);
	FreeFile();

	return(0);
}


ULONG ReadBinFile(char *name,ULONG offset)
{
	char	filename[80];
	FILE	*fp;
	int	read;

	strcpy(filename,name);
	if (stricmp(".BIN",&filename[strlen(filename)-4]))
		strcat(filename,".BIN");

	read = 0;
	fp = fopen(filename,"r");
	if (fp) {
		fseek(fp,0,SEEK_END);
		Length = ftell(fp)-offset;
		fseek(fp,offset,SEEK_SET);

		Buffer = AllocMem(Length,MEMF_PUBLIC);
		if (Buffer) {
			read = fread(Buffer,Length,1,fp);
			if (read != 1)
				printf("Warning: entire file not read!\n");
		}
		else
			printf("Could not allocate memory\n");
		fclose(fp);
	}
	else
		printf("Could not find file %s\n",filename);

	if (read==1)
		return(Length);
	else
		return(0);
}


void FreeFile(void)
{
	if (Length)
		FreeMem(Buffer,Length);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
