/*********************************************************************\
*
* Play - Play raw video data
*
* $Id: Play.c,v 1.0 1995/05/05 15:52:09 Flick Exp $
*
* $Log: Play.c,v $
*Revision 1.0  1995/05/05  15:52:09  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

BPTR	handle;

main(int argc,char **argv)
{
	int	unit,vidchan,drive,vidflag,audchans,volume;
	ULONG	res,start,end,clock,frmcount;

	if (((argc!=10)&&(argc!=11))||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <vidchan> <drive> <startaddr> <endaddr> <frames> <frameclock> <vidflag> <audchans> [volume]\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&vidchan,0,1,"Video channel");
	GetArg(argv[3],&drive,0,23,"SCSI drive");
	GetLongArg(argv[4],&start,0,0x7FFFFFFF,"Start Address");
	GetLongArg(argv[5],&end,0,0x7FFFFFFF,"End Address");
	GetLongArg(argv[6],&frmcount,0,0x7FFFFFFF,"Frame Count");
	GetLongArg(argv[7],&clock,0,0x7FFFFFFF,"Frame Clock");
	GetArg(argv[8],&vidflag,0,1,"Video Flag");
	GetArg(argv[9],&audchans,0,2,"Audio Channels");
	if (argc==11)
		GetArg(argv[10],&volume,0,0xFFFF,"Volume");
	else
		volume = 0x8000;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Press RETURN to abort\n");

	handle = Input();

	FlyVol.Path = 0;
	FlyVol.Board = unit;
	FlyVol.SCSIdrive = drive;
	FlyVol.Flags = FVF_USENUMS;

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_IMMED;

	Action.Channel = vidchan;
	Action.Flags = 0;
	if (vidflag)
		Action.Flags |= CAF_VIDEO;
	if (audchans==2)
		Action.Flags |= (CAF_AUDIOL | CAF_AUDIOR);
	else if (audchans==1)
		Action.Flags |= CAF_AUDIOL;
	Action.VidFieldCount = frmcount * 4;
	Action.GoClock = clock;
	Action.VolSust1 = volume;
	Action.VolSust2 = volume;
	Action.StartBlk = start;
	Action.EndBlk = end;

	res = FlyerPlay(&Action);
	if (res==FERR_OKAY) {
		for (;;) {
			if (WaitForChar(handle,30)) {
				getchar();
				printf("trying to abort\n");
				res = AbortAction(&Action);
				break;
			}
			res = CheckAction(&Action);
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	printf("Played %ld frames\n",(Action.LastFieldDone+1)>>2);

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
