/*********************************************************************\
*
* PlayClip3 - Play video clip
*
* $Id: PlayClip3.c,v 1.0 1995/05/05 15:52:19 Flick Exp $
*
* $Log: PlayClip3.c,v $
*Revision 1.0  1995/05/05  15:52:19  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
*	05/04/94		Marty		Added fast frame-indexing
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

BPTR	handle;

main(int argc,char **argv)
{
	int	drive,audchans,vol,pan1,pan2,attack,decay;
	ULONG	res,frame,frames,baseclock;

	if ((argc!=11)||(argv[1][0]=='?')) {
		printf("Usage: %ls <drive> <name> <frame> <frames> <audchans> <vol> <pan1> <pan2> <attack> <decay>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&drive,0,23,"SCSI drive");
	GetLongArg(argv[3],&frame,0,0x7FFFFFFF,"Start Frame");
	GetLongArg(argv[4],&frames,0,0x7FFFFFFF,"Frame Count");
	GetArg(argv[5],&audchans,0,2,"Audio Channels");
	GetArg(argv[6],&vol,0,0xFFFF,"Volume");
	GetArg(argv[7],&pan1,0,0xFFFF,"Pan1");
	GetArg(argv[8],&pan2,0,0xFFFF,"Pan2");
	GetArg(argv[9],&attack,0,0xFFFF,"Attack");
	GetArg(argv[10],&decay,0,0xFFFF,"Decay");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Press RETURN to abort\n");

	handle = Input();

	FlyVol.Path = argv[2];
	FlyVol.Board = 0;
	FlyVol.SCSIdrive = drive;

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STARTED;

	Action.Channel = 0;
	Action.Flags = 0;
	if (audchans==1)
		Action.Flags |= CAF_AUDIOL;
	else if (audchans==2)
		Action.Flags |= CAF_AUDIOL | CAF_AUDIOR;

	Action.PermissFlags = CAPF_USEHEADS;

	Action.VidStartField = 0;
	Action.VidFieldCount = 0;
	Action.TotalAudStart = Action.AudStartField = frame * 4;
	Action.TotalAudLength = Action.AudFieldCount = frames * 4;

	res = GetFieldClock(&baseclock);
	Action.GoClock = (baseclock + 200) & ~3;
	printf("(@ %lx)\n",Action.GoClock);


	Action.VolSust1 = vol;
	Action.VolSust2 = vol;
	Action.AudioPan1 = pan1;
	Action.AudioPan2 = pan2;
	Action.VolAttack = attack;
	Action.VolDecay = decay;

	res = FlyerPlay(&Action);
	if (res==FERR_OKAY) {
		for (;;) {
			if (WaitForChar(handle,30)) {
				if (getchar()=='a') {
					Action.Flags ^= (CAF_AUDIOL | CAF_AUDIOR);		/* Toggle audio */
					printf("Audio turned %ls\n",(Action.Flags & (CAF_AUDIOL | CAF_AUDIOR))?"on":"off");
					res = ChangeAudio(&Action);
					getchar();
				}
				else {
					res = AbortAction(&Action);
					printf("Aborted\n");
					break;
				}
			}
			res = CheckAction(&Action);
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}
	}

	printf("Last frame played = %ld\n",Action.LastFieldDone>>2);

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
