/*********************************************************************\
*
* RecClip - Record video clip
*
* $Id: RecClip.c,v 1.0 1995/05/05 15:52:26 Flick Exp $
*
* $Log: RecClip.c,v $
*Revision 1.0  1995/05/05  15:52:26  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

BPTR	handle;
UBYTE	PauseFlag;


main(int argc,char **argv)
{
	int	unit,vidchan,drive,vidflag,audchans;
	ULONG	res,clock,frmcount;

	if ((argc!=9)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <vchan> <drive> <name> <frames> <frameclock> <vidflag> <audchans>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&vidchan,0,3,"Video channel");
	GetArg(argv[3],&drive,0,23,"SCSI drive");
	GetLongArg(argv[5],&frmcount,0,0x7FFFFFFF,"Frame Count");
	GetLongArg(argv[6],&clock,0,0x7FFFFFFF,"Frame Clock");
	GetArg(argv[7],&vidflag,0,1,"Video Flag");
	GetArg(argv[8],&audchans,0,2,"Audio Channels");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Press RETURN to abort\n");

	handle = Input();

	FlyVol.Path = argv[4];
	FlyVol.Board = unit;
	FlyVol.SCSIdrive = drive;
	FlyVol.Flags = FVF_USENUMS;

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_IMMED;

	Action.Channel = vidchan;
	Action.Flags = 0;
	if (vidflag)
		Action.Flags |= CAF_VIDEO;
	if (audchans==2)
		Action.Flags |= (CAF_AUDIOL | CAF_AUDIOR);
	else if (audchans==1)
		Action.Flags |= CAF_AUDIOL;
	Action.VidFieldCount = frmcount * 4;
	Action.AudFieldCount = frmcount * 4;
	Action.GoClock = clock;
	Action.VolSust1 = 0xFFFF;
	Action.VolSust2 = 0xFFFF;
	Action.VidStartField = 0;

	res = FlyerRecord(&Action);
	if (res==FERR_OKAY) {
		for (;;) {
			if (WaitForChar(handle,30)) {
				if (getchar()=='p') {
					PauseFlag = 1-PauseFlag;
					printf("(%ls)\n",PauseFlag?"paused":"resumed");
					res = PauseAction(&Action,PauseFlag);
					getchar();
				}
				else {
					res = AbortAction(&Action);
					printf("Aborted\n");
					break;
				}
			}
			res = CheckAction(&Action);
/*			printf("[%lx]\n",res); */
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}
	}

	printf("Frames recorded = %ld\n",(Action.LastFieldDone+1)>>2);

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
