/*********************************************************************\
*
* SCSIread - Read from SCSI
*
* $Id: SCSIread.c,v 1.0 1995/05/05 15:50:14 Flick Exp $
*
* $Log: SCSIread.c,v $
*Revision 1.0  1995/05/05  15:50:14  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	lba,blklen,dest,dma,res;

	if ((argc!=7)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <lba> <blklen> <dmaaddr> <CPU destaddr>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[3],&lba,0,0xFFFFFFFF,"LBA");
	GetLongArg(argv[4],&blklen,0,0xFFFFFFFF,"Block Length");
	GetLongArg(argv[5],&dma,0,0xFFFFFFFF,"DMA Addr");
	GetLongArg(argv[6],&dest,0,0xFFFFFFFF,"CPU Dest Addr");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return(20);
	}

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	printf("Reading from drive (lba %lx)\n",lba);

	res = Read10(&Action,blklen,lba,dma);
	if (res) {
		printf("Read10 Error %ld - %ls\n",res,Error2String(res));
	}

	if (dest != 0) {	/* Skip CPU DMA? */
		res = CPUDMA(unit,dest,dma,blklen,0);		/* Write to CPU */
		if (res) {
			printf("CPUDMA Error %ld - %ls\n",res,Error2String(res));
		}
	}

	CloseLibrary(FlyerBase);

	if (res)
		return(10);
	else
		return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
