/*********************************************************************\
*
* SCSIwrite - Write to SCSI
*
* $Id: SCSIwrite.c,v 1.0 1995/05/05 15:50:21 Flick Exp $
*
* $Log: SCSIwrite.c,v $
*Revision 1.0  1995/05/05  15:50:21  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	lba,blklen,src,dma,res;

	if ((argc!=7)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <CPU srcaddr> <dmaaddr> <lba> <blklen>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[3],&src,0,0xFFFFFFFF,"CPU Src Addr");
	GetLongArg(argv[4],&dma,0,0xFFFFFFFF,"DMA Addr");
	GetLongArg(argv[5],&lba,0,0xFFFFFFFF,"LBA");
	GetLongArg(argv[6],&blklen,0,0xFFFFFFFF,"Block Length");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Writing to drive\n");

	if (src != 0) {	/* Skip CPU DMA? */
		res = CPUDMA(unit,src,dma,blklen,1);		/* Read */
		if (res)
			printf("CPUDMA Error %ld - %ls\n",res,Error2String(res));
	}

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	res = Write10(&Action,blklen,dma,lba);
	if (res)
		printf("Write10 Error %ld - %ls\n",res,Error2String(res));

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
