/*********************************************************************\
*
* SReadTest - Time SCSI dbl-buf reads
*
* $Id: SReadTest.c,v 1.0 1995/05/05 15:53:07 Flick Exp $
*
* $Log: SReadTest.c,v $
*Revision 1.0  1995/05/05  15:53:07  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

UBYTE	*Buffer;
ULONG	BufLen;

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action[2];

main(int argc,char **argv)
{
	int	unit,drive;
	ULONG	lba,blklen,repeat,ticks;
	ULONG	res;
	struct	DateStamp	start,end;
	double	meg,speed,seconds;

	if ((argc!=6)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <channel> <lba> <blklen> <repeat>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVol.Board = unit;
	GetArg(argv[2],&drive,0,23,"Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[3],&lba,0,0xFFFFFFFF,"LBA");
	GetLongArg(argv[4],&blklen,0,0xFFFFFFFF,"Block Length");
	GetLongArg(argv[5],&repeat,0,0xFFFFFFFF,"Repeat");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

#if 0
	Action[0].Volume = &FlyVol;
	Action[1].Volume = &FlyVol;

	BufLen = 512 * blklen;
	Buffer = (UBYTE *)AllocMem(BufLen*2,MEMF_PUBLIC);
	if (Buffer) {
		res = SCSIseek(&FlyVol,lba);
		if (res)
			printf("Seek Error %ld - %ls\n",res,Error2String(res));

		printf("Reading from drive\n");

		ID[0] = ID[1] = 0;
		state = 0;
		Buff[0] = Buffer;
		Buff[1] = Buffer+BufLen;

		DateStamp(&start);			/* Log time now */

		for (count=0;count<repeat;count++) {
			if (ID[state])
				WaitAction(&Action[state]);		/* Wait here until my last xfer done */

			Action[state].ReturnTime = RT_IMMED;

			res = Read10(&Action[state],blklen,lba,(ULONG)Buff[state]);
			ID[state] = Action[state].ID;
			if (res) {
				printf("Read Error %ld - %ls\n",res,Error2String(res));
				break;
			}
			lba += blklen;					/* Advance block addr */
			state = (state)?0:1;			/* Now dbl-buffer next command in */
		}

		if ((ID[state])&&(ID[state]>FERR_LIMIT))
			WaitAction(&Action[state]);		/* Wait here until xfer done */
		state = (state)?0:1;			/* next command */
		if ((ID[state])&&(ID[state]>FERR_LIMIT))
			WaitAction(&Action[state]);		/* Wait here until xfer done */

		DateStamp(&end);				/* Log time now */

		/* Compute stats */
		meg = ((double)(blklen * repeat))/2048.0;
		printf("Transferred %.1f MB\n",meg);
		ticks = end.ds_Minute * 60 *50 + end.ds_Tick;
		ticks -= start.ds_Minute * 60*50 + start.ds_Tick;
		seconds = ((double)ticks)/50;

		printf("Elapsed time was %.2f seconds\n",seconds);
		speed = meg/((double)seconds);
		printf("Transfer rate was %.2f MB/sec\n",speed);

		FreeMem(Buffer,BufLen*2);
	}
	else
		printf("Could not allocate fast RAM\n");
#endif

	printf("Reading from drive\n");

	DateStamp(&start);			/* Log time now */

	res = ReadTest(&FlyVol,blklen,repeat,lba,1);
	if (res)
		printf("Read Error %ld - %ls\n",res,Error2String(res));
	else {
		DateStamp(&end);				/* Log time now */

		/* Compute stats */
		meg = ((double)(blklen * repeat))/2048.0;
		printf("Transferred %.1f MB\n",meg);
		ticks = end.ds_Minute * 60 *50 + end.ds_Tick;
		ticks -= start.ds_Minute * 60*50 + start.ds_Tick;
		seconds = ((double)ticks)/50;

		printf("Elapsed time was %.2f seconds\n",seconds);
		speed = meg/((double)seconds);
		printf("Transfer rate was %.2f MB/sec\n",speed);
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
