/*********************************************************************\
*
* SReadTest2 - Time SCSI dbl-buf reads
*
* $Id: SReadTest2.c,v 1.0 1995/05/05 15:53:10 Flick Exp $
*
* $Log: SReadTest2.c,v $
*Revision 1.0  1995/05/05  15:53:10  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

int DoTest(ULONG lba,ULONG blklen,ULONG repeat,int dblbuf);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

UBYTE	*Buffer;
ULONG	BufLen;

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action[2];

main(int argc,char **argv)
{
	int	unit,drive,last,dblbuf,steps,i;
	ULONG	lba,blklen,repeat,max,interval,res,startsize,stepsize;

	if ((argc!=5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <drive> <interval> <steps> <dblbuf>\n",argv[0]);
		return(20);
	}

	repeat = 0x40;

	unit = 0;
	FlyVol.Board = unit;
	GetArg(argv[1],&drive,0,23,"Drive");
	FlyVol.SCSIdrive = drive;
	GetLongArg(argv[2],&interval,0,0x7FFFFFFF,"Interval");
	GetArg(argv[3],&steps,0,4,"Steps");
	GetArg(argv[4],&dblbuf,0,1,"Double Buffer Flag");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = ReadSize(&FlyVol,&max,&blklen);
	if (res) {
		printf("ReadSize Error %ld - %ls\n",res,Error2String(res));
		exit(20);
	}
	printf("Drive max blk is %lx\n",max);

#if 0
	max = 0x3ff000;
#endif

	if (steps==1) {
		startsize = 0x200;
		stepsize = 0x80;
	}
	else {
		startsize = 0x100;
		stepsize = 0x80;
	}

	printf("Doing drive read test...\n");
	printf("			");
	for (i=1,blklen=startsize;i<=steps;i++,blklen+=stepsize)
		printf("%03lx   ",blklen);
	printf("\n");

	for (last=0,lba=0;!last;lba+=interval) {
		printf("(%lx)",blklen*repeat);
		if ((lba+(blklen*repeat)) >= max) {
			lba = max-(blklen*repeat);
			last = 1;
		}
		printf("At LBA %06lx ---> ",lba);
		for (i=1,blklen=startsize;i<=steps;i++,blklen+=stepsize) {
			if (!DoTest(lba,blklen,repeat,dblbuf))
				break;
		}
		printf("\n");
	}

	CloseLibrary(FlyerBase);

	return(0);
}


int DoTest(ULONG lba,ULONG blklen,ULONG repeat,int dblbuf)
{
	struct	DateStamp	start,end;
	double	meg,speed,seconds;
	ULONG		ticks,res;

	DateStamp(&start);			/* Log time now */

	res = ReadTest(&FlyVol,blklen,repeat,lba,dblbuf);
	if (res) {
		printf("Read Error %ld - %ls\n",res,Error2String(res));
		return(0);
	}
	else {
		DateStamp(&end);				/* Log time now */

		/* Compute stats */
		meg = ((double)(blklen * repeat))/2048.0;
		ticks = end.ds_Minute * 60 *50 + end.ds_Tick;
		ticks -= start.ds_Minute * 60*50 + start.ds_Tick;
		seconds = ((double)ticks)/50;

		speed = meg/((double)seconds);
		printf("	%.2f",speed);

		return(1);
	}
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
