/*********************************************************************\
*
* SReadTest3 - Time SCSI dbl-buf reads/writes
*
* $Id: SReadTest3.c,v 1.0 1995/05/05 15:53:13 Flick Exp $
*
* $Log: SReadTest3.c,v $
*Revision 1.0  1995/05/05  15:53:13  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

double DoTest(ULONG lba,ULONG blklen,ULONG repeat,int dblbuf);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

int	WriteFlag;

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action[2];

main(int argc,char **argv)
{
	int	unit,drive,last,samples,i,tests,WriteFlag;
	ULONG	lba,blklen,repeat,totalsize,max,res;
	double spd,lowest,totalspd;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <drive> <tests> <READ|WRITE>\n",argv[0]);
		return(20);
	}

	unit = 0;
	FlyVol.Board = unit;
	GetArg(argv[1],&drive,0,23,"Drive");
	FlyVol.SCSIdrive = drive;
	GetArg(argv[2],&tests,0,99,"Tests");

	if (stricmp("write",argv[3])==0)
		WriteFlag = 1;
	else
		WriteFlag = 0;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = ReadSize(&FlyVol,&max,&blklen);
	if (res) {
		printf("ReadSize Error %ld - %ls\n",res,Error2String(res));
		exit(20);
	}

	printf("Max block = %lx\n",max);

#if 0
	max = 0x12345;
#endif

	blklen = 0x200;
	repeat = 0x40;

	printf("Doing drive %ls test...\n",(WriteFlag?"write":"read"));

	samples = 0;
	lowest = 9999.0;
	totalspd = 0.0;

	for (i=0;i<tests;i++) {
		for (last=0,lba=0;!last;lba+=totalsize) {
			totalsize = blklen * repeat;
			if ((lba+totalsize) >= max) {
				lba = max-totalsize;
	/*			blklen = (max-lba)/repeat;
				totalsize = blklen * repeat; */
				last = 1;
			}
			spd = DoTest(lba,blklen,repeat,1);
			if (spd < .1)
				break;

			if (spd < lowest)
				lowest = spd;
			totalspd += spd;
			samples++;
		}
	}

	printf("Out of %ld samples...\n",samples);
	printf("   Slowest speed was %.2f\n",lowest);
	printf("   Average speed was %.2f\n",totalspd/(double)samples);

	CloseLibrary(FlyerBase);

	return(0);
}


double DoTest(ULONG lba,ULONG blklen,ULONG repeat,int dblbuf)
{
	struct	DateStamp	start,end;
	double	meg,speed,seconds;
	ULONG		ticks,res;

	DateStamp(&start);			/* Log time now */

	if (WriteFlag)
		res = WriteTest(&FlyVol,blklen,repeat,lba,dblbuf);
	else
		res = ReadTest(&FlyVol,blklen,repeat,lba,dblbuf);

	if (res) {
		printf("R/W Error %ld - %ls\n",res,Error2String(res));
		return(0);
	}
	else {
		DateStamp(&end);				/* Log time now */

		/* Compute stats */
		meg = ((double)(blklen * repeat))/2048.0;
		ticks = end.ds_Minute * 60 *50 + end.ds_Tick;
		ticks -= start.ds_Minute * 60*50 + start.ds_Tick;
		seconds = ((double)ticks)/50;

		speed = meg/((double)seconds);

		printf("%06lx --> %.2f\n",lba,speed);

		return(speed);
	}
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
