/*********************************************************************\
*
* SerDevice - Specify Flyer serial devices
*
* $Id: SerDevice.c,v 1.0 1995/05/05 15:51:13 Flick Exp $
*
* $Log: SerDevice.c,v $
*Revision 1.0  1995/05/05  15:51:13  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	11/11/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,port,type,make;
	ULONG	res;

	if ((argc!=5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <port> <type> <make>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&port,0,1,"Port");
	GetArg(argv[3],&type,0,0xFF,"Type");
	GetArg(argv[4],&make,0,0xFF,"Make");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = SetSerDevice(unit,port,type,make);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
