/*********************************************************************\
*
* SerLoad - Downloads file to Flyer SBus
*				(This version accepts Menghua's ASCII files)
*
* $Id: SerLoad.c,v 1.0 1995/05/05 15:51:19 Flick Exp $
*
* $Log: SerLoad.c,v $
*Revision 1.0  1995/05/05  15:51:19  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	09/23/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

int ReadWangFile(char *);
int ASCIItoBinary(char input);
void FreeFiles(void);
void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

#define	OUTLENGTH	8192

UBYTE	*FileBuffer,*OutBuffer;
ULONG	FileLength;

main(int argc,char **argv)
{
	int	unit,cmtmode,adcntr,nybcntr;
#if 0
	int	i,j;
#endif
	ULONG	res;
	ULONG	size;
	UBYTE	*from,build,addr;
	char	ch;

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <file>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	if (ReadWangFile(argv[2])) {
		size = FileLength;
#if 0
		for (i=0;i<size;i+=16) {
			printf("%04lx: ",i);
			for (j=0;j<16;j++) {
				if ((i+j)<size)
					printf("%02lx ",FileBuffer[i+j]);
			}
			printf("\n");
		}
#endif
		from = FileBuffer;
		cmtmode = 0;
		adcntr = nybcntr = 0;
		while (size>0) {
			ch = *from++;
			size--;
			if (cmtmode) {				/* Doing comment */
				if (ch<32) {
					cmtmode = 0;
					adcntr = nybcntr = 0;
					printf("\n");
				}
				else
					printf("%c",ch);
			}
			else if (ch == ':') {			/* Start comment? */
				cmtmode = 1;
			}
			else if (isxdigit(ch)) {
				if (nybcntr==0) {
					build = ASCIItoBinary(ch) << 4;
					nybcntr++;
				}
				else {
					build += ASCIItoBinary(ch);
					nybcntr = 0;
					if (adcntr == 0) {
						addr = build;
						adcntr++;
					}
					else {
						printf("%02lx <-- %02lx\n",addr,build);

						res = SBusWrite(unit,addr,build);
						if (res)
							printf("Error writing %02lx to %02lx\n",build,addr);

						adcntr = 0;
					}
				}

			}
			else
				nybcntr = 0;
		}
		printf("Done\n");
	}
	CloseLibrary(FlyerBase);
	FreeFiles();

	return(0);
}


int ReadWangFile(char *name)
{
	char	filename[80];
	FILE	*fp;
	int	read;

	strcpy(filename,name);
	if (stricmp(".dat",&filename[strlen(filename)-4]))
		strcat(filename,".dat");

	read = 0;
	fp = fopen(filename,"r");
	if (fp) {
		fseek(fp,0,SEEK_END);
		FileLength = ftell(fp);
		fseek(fp,0,SEEK_SET);

		FileBuffer = AllocMem(FileLength,MEMF_PUBLIC);
		if (FileBuffer) {
			read = fread(FileBuffer,FileLength,1,fp);
			if (read != 1)
				printf("Warning: entire file not read!\n");
		}
		else
			printf("Could not allocate memory\n");
		fclose(fp);
	}
	else
		printf("Could not find file %s\n",filename);

	return(read);
}


int ASCIItoBinary(char input)
{
	char		c1;
	int		v;

	c1 = toupper(input);
	if (c1>'9')
		v = ((UBYTE)c1)-'A'+10;
	else
		v = ((UBYTE)c1)-'0';

	return(v);
}


void FreeFiles(void)
{
	if (FileBuffer)
		FreeMem(FileBuffer,FileLength);
	if (OutBuffer)
		FreeMem(OutBuffer,OUTLENGTH);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
