/*********************************************************************\
*
* SerLoop - Test serial bus
*
* $Id: SerLoop.c,v 1.0 1995/05/05 15:51:23 Flick Exp $
*
* $Log: SerLoop.c,v $
*Revision 1.0  1995/05/05  15:51:23  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	07/29/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

BPTR	handle;

main(int argc,char **argv)
{
	int	unit,vidchan,scsichan,vidflag,audchans,volume;
	ULONG	res,start,end,clock,frmcount;

	if (((argc!=2)&&(argc!=11))||(argv[1][0]=='?')) {
		printf("Usage: %ls <READ|WRITE>\n",argv[0]);
		return(20);
	}

	if (stricmp("WRITE",argv[1])==0)
		writeflag = 1;
	else if (stricmp("READ",argv[1])==0)
		writeflag = 0;
	else {
		printf("Must specifiy READ or WRITE\n");
		exit(10);
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Press RETURN to abort\n");

	handle = Input();

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_IMMED;

	Action.Channel = vidchan;
	Action.Flags = 0;
	if (vidflag)
		Action.Flags |= CAF_VIDEO;
	if (audchans==2)
		Action.Flags |= CAF_STEREOAUDIO;
	else if (audchans==1)
		Action.Flags |= CAF_MONOAUDIO;
	Action.FieldCount = frmcount * 4;
	Action.GoClock = clock;
	Action.VolSust1 = volume;
	Action.VolSust2 = volume;
	Action.StartBlk = start;
	Action.EndBlk = end;

	res = FlyerPlay(&Action);
	if (res==FERR_OKAY) {
		for (;;) {
			if (WaitForChar(handle,30)) {
				getchar();
				printf("trying to abort\n");
				res = AbortAction(&Action);
				break;
			}
			res = CheckAction(&Action);
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
