/*********************************************************************\
*
* SerRead2 - Reads data from Flyer SBus
*
* $Id: SerRead2.c,v 1.0 1995/05/05 15:51:30 Flick Exp $
*
* $Log: SerRead2.c,v $
*Revision 1.0  1995/05/05  15:51:30  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,addr;
	ULONG	res;
	UBYTE	data;

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <address>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&addr,0,255,"Address");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("(Clear 01 in command to abort)\n");

	res = SBusRead(unit,addr,&data,1);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("%02lx: %02x\n",addr,data);

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
