/*********************************************************************\
*
* SerWrite - Writes data to Flyer SBus
*
* $Id: SerWrite.c,v 1.0 1995/05/05 15:52:41 Flick Exp $
*
* $Log: SerWrite.c,v $
*Revision 1.0  1995/05/05  15:52:41  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,addr,data;
	ULONG	res;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <address> <data>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&addr,0,255,"Address");
	GetArg(argv[3],&data,0,255,"Data");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = SBusWrite(unit,addr,data);
	if (res)
		printf("Error - %ls\n",res,Error2String(res));
	else
		printf("SerWrite Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
