/*********************************************************************\
*
* SerialNum - Access Flyer serial number
*
* $Id: SerialNum.c,v 1.0 1995/05/05 15:51:16 Flick Exp $
*
* $Log: SerialNum.c,v $
*Revision 1.0  1995/05/05  15:51:16  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	10/31/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,readflag;
	LONG	number;
	UWORD	numword;
	ULONG	res;

	if ((argc!=2)||(argv[1][0]=='?')) {
		printf("Usage: %ls <number | READ>\n",argv[0]);
		return(20);
	}

	if (!stricmp(argv[1],"READ"))
		readflag = 1;
	else {
		readflag = 0;
		stcd_l(argv[1],&number);
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	unit = 0;

	if (readflag) {
		res = ReadEEreg(unit,4,&numword);
		number = numword << 16;
		res = ReadEEreg(unit,3,&numword);
		number += numword;
		printf("Serial number is = %ld\n",number);
	}
	else {
		res = WriteEEreg(unit,4,number >> 16);
		res = WriteEEreg(unit,3,number & 0xFFFF);
	}
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}
