/*********************************************************************\
*
* SetFloobyCal - Sets play offset/phase
*
* $Id: SetFloobyCal.c,v 1.0 1995/05/05 15:52:53 Flick Exp $
*
* $Log: SetFloobyCal.c,v $
*Revision 1.0  1995/05/05  15:52:53  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	12/19/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,chan,item,value,value2,value3,saveit;
	ULONG	res;

	if ((argc<5)||(argc>7)) {
		printf("Usage: %ls <chan> <item> <save> <value> [value2] [value3]\n",argv[0]);
		return(20);
	}

	unit = 0;
	GetArg(argv[1],&chan,0,3,"Channel");
	GetArg(argv[2],&item,1,69,"Item");
	GetArg(argv[3],&saveit,0,1,"Save");
	GetArg(argv[4],&value,0x80000000,0x7FFFFFFF,"Value 1");

	if (argc>=6)
		GetArg(argv[5],&value2,0,255,"Value 2");
	else
		value2 = 0;

	if (argc==7)
		GetArg(argv[6],&value3,0,255,"Value 3");
	else
		value3 = 0;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = 0;

	switch (item) {
	case 2:
		if (chan==0) {
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_EDGE,value,saveit);
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_COURSE,value2,saveit);
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_FINE,value3,saveit);
/* 		Delay(4); */
		}
		else {
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_EDGE,value,saveit);
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_COURSE,value2,saveit);
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_FINE,value3,saveit);
/*			Delay(4); */
		}
		break;
	case 5:
		if (chan==0)
			res = FlyerWriteCalib(0,CALIB_HPLAYOFFSETA,value,saveit);
		else
			res = FlyerWriteCalib(0,CALIB_HPLAYOFFSETB,value,saveit);
		break;
	case 16:
		res = SetFlooby(unit,chan,item,value);
		break;
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
