/*********************************************************************\
*
* StillMode - Set video still mode
*
* $Id: StillMode.c,v 1.1 1995/11/06 13:47:10 Flick Exp $
*
* $Log: StillMode.c,v $
*Revision 1.1  1995/11/06  13:47:10  Flick
*Relaxed input restrictions for "channel" (0-3)
*
*Revision 1.0  1995/05/05  15:53:17  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	03/14/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,chan,mode;
	ULONG	res;

	if ((argc!=4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <channel> <mode>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&chan,0,3,"Channel");
	GetArg(argv[3],&mode,1,4,"Mode");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = StillMode(unit,chan,mode);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
