/*********************************************************************\
*
* TestMisc - Test routing commands
*
* $Id: TestMisc.c,v 1.0 1995/05/05 15:50:05 Flick Exp $
*
* $Log: TestMisc.c,v $
*Revision 1.0  1995/05/05  15:50:05  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/30/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,coefset,prepost,i;
	UWORD	scale,CoefBuf[8];
	ULONG	res;

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <set> <pre/post>\n",argv[0]);
		return(20);
	}

	unit = 0;

	GetArg(argv[1],&coefset,0,31,"Set");
	GetArg(argv[2],&prepost,0,1,"Pre/post");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = FIRquery(unit,coefset,prepost,&scale,CoefBuf);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	printf("Scale = %ld\n",scale);
	for (i=0;i<8;i++)
		printf("Coef %ld = %lx\n",i,CoefBuf[i]);

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
