/*********************************************************************\
*
* TestPlay1 - Play video clip
*
* $Id: TestPlay1.c,v 1.0 1995/05/05 15:50:08 Flick Exp $
*
* $Log: TestPlay1.c,v $
*Revision 1.0  1995/05/05  15:50:08  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
*	05/04/94		Marty		Added fast frame-indexing
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

ULONG StartIt(int start,int vchan,char *name,int drive,ULONG frame,
	ULONG clock,ULONG frames,UBYTE flags,UBYTE permissions);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;

main(int argc,char **argv)
{
	int	test;
	ULONG	clock,theclock;

	if ((argc<4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <test> <name 1> <name2> [goclock]\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&test,1,9,"Test type");
	if (argc==5)
		GetLongArg(argv[4],&clock,0,0x7fffffff,"Go Clock");
	else
		clock = 0;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	Defaults(&Action);

	switch (test) {
	case 1:
		StartIt(RT_STARTED,0xFF,argv[2],0,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,1,argv[3],16,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,0,argv[2],0,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,1,argv[3],16,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,0,argv[2],0,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,1,argv[3],16,0,clock,0,
			CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
		break;
	case 2:
		theclock = StartIt(RT_STARTED,0,argv[2],0,0,0,0,
			CAF_VIDEO | CAF_NOPREROLL | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		StartIt(RT_IMMED,0,argv[3],0,0,theclock+clock,0,
			CAF_VIDEO | CAF_NOPREROLL | CAF_USEMATTE,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);

		break;
	case 3:
		theclock = StartIt(RT_STARTED,0,argv[2],0,0,0,1,
			CAF_VIDEO | CAF_NOPREROLL,
			CAPF_STEALOURVIDEO | CAPF_KILLOTHERVIDEO);
	
		break;
	}

	CloseLibrary(FlyerBase);

	return(0);
}


ULONG StartIt(int start,int vchan,char *name,int drive,ULONG frame,
	ULONG clock,ULONG frames,UBYTE flags,UBYTE permissions)
{
	ULONG res,i,j,theclock;

	FlyVol.Path = name;
	FlyVol.Board = 0;
	FlyVol.SCSIdrive = drive;

	Action.Volume = &FlyVol;
	Action.ReturnTime = start;

	Action.Channel = vchan;
	Action.Flags = flags;
	Action.PermissFlags = permissions;

	Action.VidStartField = frame * 4;
	Action.GoClock = clock;
	Action.VidFieldCount = frames * 4;
/*	Action.VidFieldCount = 0;
	Action.VolSust1 = 0xFFFF;
	Action.VolSust2 = 0xFFFF;
*/
	res = FlyerPlay(&Action);
	if (res==FERR_OKAY) {
		res = GetFieldClock(&theclock);
		printf("Started at clock %lx (asked for %lx)\n",theclock,clock);
		printf("Used channel %lx\n",Action.Channel);
	}
	else
		printf("Error %ld - %ls\n",res,Error2String(res));

	for (j=234,i=0;i<200000;i++) {
		j *= 35;
		j /= 12;
	}
	return(theclock);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
