/*********************************************************************\
*
* TestRouting - Test routing commands
*
* $Id: TestRouting.c,v 1.0 1995/05/05 15:53:40 Flick Exp $
*
* $Log: TestRouting.c,v $
*Revision 1.0  1995/05/05  15:53:40  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/30/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,item,val1,val2,val3;
	ULONG	res;

	if ((argc!=6)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <item> <val1> <val2> <val3>\n",argv[0]);
		printf("\nItems...\n");
		printf("  1) Toaster Mux Value (1,2,3) \n");
		printf("  2) Input Select Value (1,2)\n");
		printf("  3) Termination Value (1)\n");
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&item,1,69,"Item");
	GetArg(argv[3],&val1,0,0xFF,"Value 1");
	GetArg(argv[4],&val2,0,0xFF,"Value 2");
	GetArg(argv[5],&val3,0,0xFF,"Value 3");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	switch (item) {
	case (1):
		res = ToasterMux(unit,val1,val2,val3);
		break;
	case (2):
		res = FlyerInputSel(unit,val1,val2);
		break;
	case (3):
		res = FlyerTermination(unit,val1);
		break;
	default:
		printf("Illegal item\n");
		res = 0;
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
