/*********************************************************************\
*
* TestTBC - Test TBC commands
*
* $Id: TestTBC.c,v 1.0 1995/05/05 15:53:44 Flick Exp $
*
* $Log: TestTBC.c,v $
*Revision 1.0  1995/05/05  15:53:44  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	01/20/95		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetHexArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;
struct TBCctrl	TBC;

main(int argc,char **argv)
{
	int	oper,flags,dflags,eflags,input,term,bright,cont,sat,hue,phase,horiz;
	ULONG	res;

	if ((argc!=13)||(argv[1][0]=='?')) {
		printf("Usage: %ls <oper> <flags> <Dflags> <Eflags> <input> <term>\n",argv[0]);
		printf("<bright> <contr> <sat> <hue> <phase> <horiz>\n");
		return(20);
	}

	GetArg(argv[1],&oper,0,15,"Operation");
	GetHexArg(argv[2],&flags,0,255,"Flags");
	GetHexArg(argv[3],&dflags,0,255,"Dflags");
	GetHexArg(argv[4],&eflags,0,255,"Eflags");
	GetArg(argv[5],&input,0,3,"InputSel");
	GetHexArg(argv[6],&term,0,255,"Termination");
	GetArg(argv[7],&bright,-64,63,"Brightness");
	GetArg(argv[8],&cont,0,127,"Contrast");
	GetArg(argv[9],&sat,0,127,"Saturation");
	GetArg(argv[10],&hue,-64,63,"Hue");
	GetArg(argv[11],&phase,0,2047,"Phase adjust");
	GetArg(argv[12],&horiz,0,4095,"Horizontal adjust");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	TBC.Flags = flags;
	TBC.DecFlags = dflags;
	TBC.EncFlags = eflags;
	TBC.InputSel = input;
	TBC.Term = term;
	TBC.Bright = bright;
	TBC.Contrast = cont;
	TBC.Sat = sat;
	TBC.Hue = hue;
	TBC.Phase = phase;
	TBC.HorAdj = horiz;

	res = TBCcontrol(0,&TBC,oper);
	if (res==FERR_CMDFAILED)
		printf("Error - no TBC present\n");
	else if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));

	if (oper & TBCOF_STATUS) {
		if (TBC.Status & TBCSF_MODULE) {
			printf("Video signal %ls present\n",(TBC.Status & TBCSF_VIDEO)?"is":"is not");
			if (TBC.Status & TBCSF_VIDEO) {
				printf("Signal %ls stable\n",(TBC.Status & TBCSF_STABLE)?"is":"is not");
			}
		}
		else {
			printf("No TBC present\n");
		}
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stcd_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetHexArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
