/*********************************************************************\
*
* Volumes - Dump mounted Flyer volume names
*
* $Id: Volumes.c,v 1.0 1995/05/05 15:53:57 Flick Exp $
*
* $Log: Volumes.c,v $
*Revision 1.0  1995/05/05  15:53:57  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	11/13/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"
/* #include "flyerprivate.h" */

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void Cleanup(int code);

struct Library		*FlyerBase;

#if 0
struct FlyerLib	*FlyLib;
#endif


main(int argc,char **argv)
{
	struct FlyerVolNode	*vptr;
	struct MinList			*vollist;

	if (argc!=1) {
		printf("Usage: %ls\n",argv[0]);
		Cleanup(10);
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		Cleanup(10);
	}

#if 0
	FlyLib = (struct FlyerLib *)FlyerBase;
#endif

	printf("Flyer volumes in list...\n");

	vollist = (struct MinList *)LockFlyVolList();
	if (vollist==0) {
		printf("Couldn't lock Flyer volume list\n");
	}
	else {
		vptr = (struct FlyerVolNode *)vollist->mlh_Head;

#if 0
		vptr = (struct FlyerVolNode *)FlyLib->fl_Volumes.mlh_Head;
#endif

		while (vptr->Node.ln_Succ) {
			printf("\"%ls\"  brd=%ld, drive=%ld, flags=%ld\n",vptr->Name,vptr->Board,
				vptr->SCSIdrive,vptr->Flags);
/*			printf("(at address %lx)\n",vptr); */

			vptr = (struct FlyerVolNode *)vptr->Node.ln_Succ;
		}
		UnLockFlyVolList(vollist);
	}

	Cleanup(0);

	return(0);
}


void Cleanup(int code)
{
	if (FlyerBase)
		CloseLibrary(FlyerBase);

	if (code)
		exit(code);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
