/*********************************************************************\
*
* Vparam - Set video parameters
*
* $Id: Vparam.c,v 1.0 1995/05/05 15:54:00 Flick Exp $
*
* $Log: Vparam.c,v $
*Revision 1.0  1995/05/05  15:54:00  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,mintol,maxtol,rndfreq,vidlen,special,firset;
	ULONG	res;

	if (argc!=7) {
		printf("Usage: %ls <mintol> <maxtol> <rndfreq> <vidlen> <firset> <special>\n",argv[0]);
		return(20);
	}

	unit = 0;
	GetArg(argv[1],&mintol,0,7,"Minimum Tolerance");
	GetArg(argv[2],&maxtol,0,7,"Maximum Tolerance");
	GetArg(argv[3],&rndfreq,0,255,"Rnd Freq");
	GetArg(argv[4],&vidlen,0,0x7FFF,"Video Length");
	GetArg(argv[5],&firset,0,4,"FIR set");
	GetArg(argv[6],&special,0,0xFF,"Special Stuff");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = VideoParams(unit,0,mintol,maxtol,rndfreq,vidlen,firset,special);
#if 0
	if (res==0)
		res = VideoParams(unit,1,mintol,maxtol,rndfreq,vidlen,firset,special);
#endif
	if (res)
		printf("Error - %ls\n",Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
