/*********************************************************************\
*
* WriteField - Creates video fields in a clip
*
* $Id: WriteField.c,v 1.1 1995/07/12 11:15:58 Flick Exp $
*
* $Log: WriteField.c,v $
*Revision 1.1  1995/07/12  11:15:58  Flick
*Fixed bug -- specified field 0 on every field written!
*
*Revision 1.0  1995/05/05  15:54:03  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	09/16/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "FlyerPrivate.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;

struct FlyerVolume	FlyVol;
struct ClipAction		Action;
struct VidCompInfo	compinfo;
struct ClipInfo		Cinfo;

UBYTE Buffer[SAMPLESPERLINE],AltBuf[SAMPLESPERLINE];
UBYTE WhiteBuffer[SAMPLESPERLINE];

main(int argc,char **argv)
{
	int	unit,drive,i,value,line,modes,fieldnum;
	ULONG	res;
	UBYTE	*buff;

	if ((argc!=6)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <name> <modes> <D2 value>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&drive,0,23,"SCSI Drive");
	GetArg(argv[4],&modes,0,0xFF,"Mode flags");
	GetArg(argv[5],&value,0,0xFF,"D2 value");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.Board = unit;
	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Path = argv[3];
	FlyVol.SCSIdrive = drive;

	if (modes) {
		fieldnum = 0;
	}
	else {
		Cinfo.len = sizeof(struct ClipInfo);
		res = GetClipInfo(&FlyVol,&Cinfo);
		if (res)
			printf("ClipInfo Error %ld - %ls\n",res,Error2String(res));
		else {
			fieldnum = Cinfo.Fields;
			printf("Field = %ld\n",fieldnum);
			fieldnum &= 3;		// Modulo 4
		}
	}

	Action.Volume = &FlyVol;

	Action.ReturnTime = RT_STOPPED;
	compinfo.Algo = ALGO_D2;
	compinfo.Tolerance = 0;
	compinfo.RndFreq = 122;
//	compinfo.RndFreq = 13;
/*	compinfo.RndSeed = 6;  HANDLED IN S/W */
	compinfo.FIRcomp = 2;
	compinfo.DataSize = 0x70;

	res = OpenWriteField(&Action,fieldnum,modes | FWF_APPEND,&compinfo);
//	res = EasyOpenWriteField(&Action,fieldnum,modes | FWF_APPEND,0);
	if (res) {
		printf("\nOpen Error %ld - %ls\n",res,Error2String(res));
	}
	else {
		printf("Buffer @ %lx\n",Buffer);


		/* Tests fill color and line skipping on read */
		Action.ReturnTime = RT_STOPPED;
		Action.MatteY = 127;		/* Grn */
		Action.MatteI = -27;
		Action.MatteQ = -51;
		SetFillColor(&Action);

		for (i=0;i<SAMPLESPERLINE;i++) {
			switch (value) {
			case 0:
				Buffer[i] = 71;
				break;
			case 1:
				Buffer[i] = 71+i/6;
				break;
			case 2:
				Buffer[i] = 71 + (i % 130);
				break;
			case 3:
				Buffer[i] = 200-i/6;
				break;
			case 4:
				Buffer[i] = 200-(i % 130);
				break;
			case 5:
				if ((i & 3)==0) {
					Buffer[i+0] = 0x33;
					Buffer[i+1] = 0x4e;
					Buffer[i+2] = 0x93;
					Buffer[i+3] = 0x78;
					AltBuf[i+0] = 0x93;
					AltBuf[i+1] = 0x78;
					AltBuf[i+2] = 0x33;
					AltBuf[i+3] = 0x4e;
				}
				break;
			default:
				Buffer[i] = value;
			}
		}

		for (i=0;i<SAMPLESPERLINE;i++) {
			WhiteBuffer[i] = 200;
		}

#if 0
		printf("Before values...");
		for (i=0;i<12;i++)
			printf("%02lx ",Buffer[i]);
		printf("\n");
#endif

		SkipLines(&Action,60);

//		res = FlyerWriteLine(&Action,WhiteBuffer);

//		for (line=21;line<=260;line++) {
//		for (line=21;line<=241;line++) {
		for (line=82;line<=200;line++) {
			Action.ReturnTime = RT_STOPPED;

			buff = Buffer;

//			if ((line==21)&&(modes))
//				buff = WhiteBuffer;

			if (line==82)
				buff = WhiteBuffer;
			else if (value == 5) {
				if ((fieldnum == 0) || (fieldnum == 3)) {
					if (line & 1)
						buff = AltBuf;
					else
						buff = Buffer;
				}
				else {
					if (line & 1)
						buff = Buffer;
					else
						buff = AltBuf;
				}
			}

			res = FlyerWriteLine(&Action,buff);
			if (res) {
				printf("\nError %ld on line %ld - %ls\n",res,line,Error2String(res));
				break;
			}
		}

#if 0
		printf("After values...");
		for (i=0;i<12;i++)
			printf("%02lx ",Buffer[i]);
		printf("\n");
#endif

		Action.ReturnTime = RT_STOPPED;
		res = CloseField(&Action);
		if (res)
			printf("\nClose Error %ld - %ls\n",res,Error2String(res));
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
