/*
 * $Id: allicons.c,v 5.5 1995/01/03 21:25:58 pfrench Exp $
 *
 * $Source: rsrc:allicons.c,v $
 *
 * $Log: allicons.c,v $
*Revision 5.5  1995/01/03  21:25:58  pfrench
*Added error message if iconfile build failed
*
*Revision 5.4  1994/12/19  22:37:58  pfrench
*Modified for now shared-code proof.library.
*
*Revision 5.3  1994/12/02  14:08:22  pfrench
*New iconfile name is ".allicons.i" and I am now using readargs
*
*Revision 5.2  1994/11/30  23:42:55  pfrench
*Added streambuffer class
*
*Revision 5.1  1994/11/29  13:48:43  pfrench
*Now allows CTRL_C break to quit doing directorys.
*
*Revision 5.0  1994/11/29  13:04:52  pfrench
*FirstCheckIn
*
 */

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef CLASSES_H
#include "classes.h"
#endif

#ifndef CLASSUSR_H
#include "classusr.h"
#endif

#ifndef CLASSBASE_H
#include "classbase.h"
#endif

#ifndef PROOF_STREAM_H
#include "stream.h"
#endif

#ifndef PROOF_LIB_H
#include <proof_lib.h>
#endif

#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>

#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>

#include <clib/dos_protos.h>
#include <pragmas/dos_pragmas.h>

#include <clib/alib_stdio_protos.h>
#include <string.h>

extern LONG BuildIconFile( STRPTR dirname );
extern struct Library *DOSBase;

#define ICONFILE_NAME ".allicons.i"

struct Library		*ProofBase;
struct Library		*CroutonBase;

ULONG stdout;
struct ClassBase	*ClassBase;

LONG InitProofLib(void);
LONG CloseProofLib(void);
LONG build_dir( STRPTR dirname );

static char filepath[320];

LONG InitProofLib(void)
{
	LONG	retval = 0;

	if ( ProofBase = OpenLibrary("proof.library",0) )
	{
		ClassBase = pb_GetClassBase();

		retval = TRUE;
	}

	return(retval);
}

LONG CloseProofLib(void)
{
	LONG	retval = 0;

	if ( ProofBase )
		CloseLibrary(ProofBase);

	return(retval);
}

#define TEMPLATE "DIR/M,ALL/S,DELETE=DEL/S,INAME=IN/K"

#define DIR_OPT	0
#define ALL_OPT	1
#define DEL_OPT	2
#define NAM_OPT	3

LONG opt_array[4];

static BOOL delete_icons = FALSE;
static BOOL recurse_dirs = FALSE;
static char *iconfile_name = ICONFILE_NAME;

LONG main( void )
{
	LONG				 retval = 1;
	struct RDArgs	*ra;

	stdout = Output();

	if ( ra = ReadArgs(TEMPLATE,opt_array,NULL) )
	{
		if ( InitProofLib() )
		{
			if ( CroutonBase = OpenLibrary("crouton.library",0) )
			{
				if ( opt_array[ALL_OPT] )
					recurse_dirs = TRUE;

				if ( opt_array[DEL_OPT] )
					delete_icons = TRUE;

				if ( opt_array[NAM_OPT] )
					iconfile_name = (char *)opt_array[NAM_OPT];

				if ( opt_array[DIR_OPT] )
				{
					STRPTR		 dirname;
					STRPTR		*dn = (STRPTR *)opt_array[DIR_OPT];

					while ( dirname = *dn++ )
					{
						retval = build_dir(dirname);

						if ( SetSignal(0L,0L) & SIGBREAKF_CTRL_C )
							break;
					}
				}
				else
				{
					retval = build_dir("");
				}
				
				if ( SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C )
					printf("***Break***\n");

				CloseLibrary(CroutonBase);
			}
		}

		FreeArgs(ra);
	}

	CloseProofLib();

	return(retval);
}

LONG build_dir( STRPTR dirname )
{
	LONG	retval = 0;
	BPTR	dirlock;

	if ( dirlock = Lock(dirname,ACCESS_READ) )
	{
		struct FileInfoBlock		*fib;

		if ( fib = (struct FileInfoBlock *) AllocMem(sizeof(*fib),MEMF_PUBLIC|MEMF_CLEAR) )
		{
			if ( Examine(dirlock, fib) )
			{
				if ( fib->fib_DirEntryType > 0 )
				{
					BPTR				olddir;
					BOOL				gotname = FALSE;

					gotname = NameFromLock(dirlock,filepath,sizeof(filepath));

					if ( delete_icons )
					{
						olddir = CurrentDir(dirlock);

						if ( DeleteFile(iconfile_name) )
						{
							printf( "Deleting \"%s%s%s\"\n",
								filepath,
								((filepath[strlen(filepath)-1]==':') ? "" : "/"),
								iconfile_name );
						}

						CurrentDir(olddir);

					}
					else
					{
						printf( "Building \"%s%s%s\"",
							filepath,
							((filepath[strlen(filepath)-1]==':') ? "" : "/"),
							ICONFILE_NAME );

						retval = BuildIconFile(dirname);

						printf( "%s\n", ((retval) ? "" : "..ERR" ) );
					}

					olddir = CurrentDir(dirlock);

					if ( recurse_dirs )
					{
						while (ExNext(dirlock,fib))
						{
							if ( SetSignal(0L,0L) & SIGBREAKF_CTRL_C )
								break;

							/* If this is a directory? */
							if ( fib->fib_DirEntryType > 0 )
							{
								retval = build_dir(fib->fib_FileName);
							}
						}
					}

					CurrentDir(olddir);
				}
			}

			FreeMem(fib,sizeof(*fib));
		}

		UnLock(dirlock);
	}

	return(retval);
}
