/*********************************************************************\
*
* CopyData - Copies data from drive to drive
*
* $Id: copydata.c,v 1.0 1995/05/05 15:48:28 Flick Exp $
*
* $Log: copydata.c,v $
*Revision 1.0  1995/05/05  15:48:28  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/24/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);
void GetSpecialLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;
struct FlyerVolume FlyVolSrc,FlyVolDest;

main(int argc,char **argv)
{
	int	unit,srcdrive,destdrive;
	ULONG	res,blkadr,blklen,destadr;

	if ((argc!=7)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <src drive> <src addr> <blocks> <dest drive> <dest addr>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	FlyVolSrc.Board = FlyVolDest.Board = unit;
	GetArg(argv[2],&srcdrive,0,23,"Source Drive");
	GetSpecialLongArg(argv[3],&blkadr,0,0x7FFFFFFF,"Src Block address");
	GetLongArg(argv[4],&blklen,0,0x7FFFFFFF,"Blocks Count");
	GetArg(argv[5],&destdrive,0,23,"Destination Drive");
	GetSpecialLongArg(argv[6],&destadr,0,0x7FFFFFFF,"Dest Block address");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	printf("Copying data\n");
	FlyVolSrc.SCSIdrive = srcdrive;
	FlyVolDest.SCSIdrive = destdrive;

	res = CopyData(&FlyVolSrc,&FlyVolDest,blkadr,blklen,destadr);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Copied okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetSpecialLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	if (!stricmp(arg,"tape")) {
		*var = -1;
	}
	else {
		stch_l(arg,(long *)var);
		if ((*var < lo)||(*var > hi)) {
			printf("Error: %ls is out of range\n",label);
			exit(20);
		}
	}
}
