/********************************************************************
* $edit.c$ - main entry, event loop
* $Id: edit.c,v 2.76 1995/10/03 14:01:58 Flick Exp $
* $Log: edit.c,v $
*Revision 2.76  1995/10/03  14:01:58  Flick
*Now uses DarkFont if TCDarkFont not found (TCFont was right spacing but wrong color)
*
*Revision 2.75  1995/10/02  15:14:01  Flick
*Tries to open new TCDarkFont.  Does a LoadPrefsData on startup to get Editor-only presf
*
*Revision 2.74  1995/09/28  10:06:42  Flick
*Now uses RawKeyCodes.h
*
*Revision 2.73  1995/09/26  16:45:53  Flick
*Ooops! Removed debugging
*
*Revision 2.72  1995/09/26  16:43:20  Flick
*Added IntuiMsg arg to EndCleanDrop() on SELECTUP msg!?!
*
*Revision 2.71  1995/08/31  16:13:58  Flick
*Now clears all flyer A/V heads on program exit
*
*Revision 2.70  1995/08/28  10:36:28  Flick
*Added RebootFlyer code (still manual at this point)
*
*Revision 2.69  1995/07/13  13:02:37  Flick
*HandleWindow & HandleReqWindow now test gadget->UserData for NULL before
*dispatching as handling code!
*
*Revision 2.68  1995/06/14  14:56:01  pfrench
*Moved endgrazrequest call out to outermost event loop
*using "global_GrazReqDoubleClicked" flag byte
*
*Revision 2.67  1995/03/02  12:34:29  pfrench
*Added switcher un-used rawkey handling code
*
*Revision 2.66  1995/02/20  16:11:12  pfrench
*Now properly responds to locate file.
*
*Revision 2.65  1995/02/17  17:07:40  pfrench
*Added check for global edit depth
*
*Revision 2.64  1995/02/03  13:23:40  pfrench
*Now, savedirtabs is being done when one is changed/added
*
*Revision 2.63  1994/12/30  02:33:07  Kell
*Removed ES_FlyerVolumes send.
*
*Revision 2.62  1994/12/29  16:14:33  CACHELIN4000
*Move f8 editor quit to HandleCommon/HandleKey(), let Key NULL return trigger exit
*
*Revision 2.61  1994/12/28  18:59:21  CACHELIN4000
**** empty log message ***
*
*Revision 2.60  1994/12/28  17:40:10  CACHELIN4000
*Undo previous change again, alter HandleSwitcher w/ SWQuit
*
*Revision 2.59  1994/12/28  15:44:57  CACHELIN4000
*Remove DONE=TRUE from NULL return in HandleWindow()
*
*Revision 2.58  1994/12/24  13:46:53  CACHELIN4000
*Set Done=TRUE on NULL returns from HandleWindow ==> popup QUIT closes ports ==> VT can be run again w/out crashing
*
*Revision 2.57  1994/12/22  23:07:06  CACHELIN4000
*Check-in so I can do an updateme, get new proof stuff, and link successfully
*
*Revision 2.55  1994/12/22  15:39:29  pfrench
*Added savedirtabs call before exiting
*
*Revision 2.54  1994/12/21  20:04:39  pfrench
*Added Directory tabs support.
*
*Revision 2.53  1994/12/17  04:49:13  Kell
*Now it gets the flyer volumes sometime after the 1st switcher message.
*
*Revision 2.52  1994/12/09  16:35:57  pfrench
*Removed softsprite calls as they were causing too much flashing
*
*Revision 2.51  1994/12/09  16:22:02  pfrench
*Now disable softsprite while rendering display
*
*Revision 2.50  1994/11/16  15:11:37  CACHELIN4000
*Fix Gadget image plane pick
*
*Revision 2.49  1994/11/16  01:07:55  CACHELIN4000
*Enable ARexx stuff
*
*Revision 2.48  1994/11/15  18:05:43  CACHELIN4000
*Eliminate extra 3 planes from gadget images on AA machine (still load deeper pic though).
*
*Revision 2.47  1994/11/09  12:46:08  pfrench
*Now adding support for proof.lib
*
*Revision 2.46  1994/10/13  14:01:32  CACHELIN4000
*add Edit_Support dir instead of system
*
*Revision 2.45  94/09/27  22:10:04  CACHELIN4000
*Remove RAM: startup directory, so flyer drive list would be initialized always
*
*Revision 2.44  94/09/27  17:51:58  pfrench
*Put small check in event loop
*
*Revision 2.43  1994/09/27  16:22:46  pfrench
*Changed LoadSlice prototype
*
*Revision 2.42  1994/09/23  20:08:03  pfrench
*Moved loadslice to main event loop
*
*Revision 2.41  1994/09/17  21:32:23  pfrench
*Added init/close for dir cache
*
*Revision 2.40  1994/09/14  15:11:58  Kell
*Changed dhd.library open to flyer.library.
*
*Revision 2.39  1994/09/13  16:09:15  pfrench
*Fixed enforcer hit on startup waitmask
*
*Revision 2.38  1994/09/13  15:52:01  pfrench
*Added accesswindow signal bit to waitmask
*
*Revision 2.37  1994/09/07  16:32:17  pfrench
*Accesswindow a little further along
*
*Revision 2.36  1994/09/07  01:13:51  pfrench
*Getting a little closer
*
*Revision 2.35  1994/09/06  23:56:28  pfrench
*Added basic accesswindow calls
*
*Revision 2.34  1994/09/02  01:31:53  pfrench
*Got delayed error timer working reliably.
*
*Revision 2.33  1994/09/02  00:37:43  pfrench
*Was opening wrong timer.device
*
*Revision 2.32  1994/09/01  23:49:24  pfrench
*Added delayed msg port to waitmask
*
*Revision 2.31  1994/09/01  22:26:27  pfrench
*Added DelayedError timer.device message port
*
*Revision 2.30  1994/08/30  10:34:13  Kell
*Changed SendSwitcherReply calls to work with new ESParams structures.
*Removed a global ESMessage called OurESMessage
*
*Revision 2.29  1994/08/25  16:42:43  CACHELIN4000
*Add AGA check to Setup() for 2000/3000 compatibility
*
*Revision 2.27  94/07/25  21:03:00  pfrench
*Now doesn't specify version 4.0 when opening crouton.library
*
*Revision 2.26  1994/07/25  20:55:38  pfrench
*Now correctly free's gad imagery if partial fail.
*
*Revision 2.25  1994/07/18  16:41:19  pfrench
*Added initial hack for doing async requesters.
*
*Revision 2.24  1994/07/15  12:01:18  pfrench
*Changed CopyMsg to a ExtIntuiMessage, so we don't break
*input via Tablets.
*
*Revision 2.23  1994/07/11  13:27:07  CACHELIN4000
*Add TimeCodeLG.font support
*
*Revision 2.22  94/07/08  10:07:49  CACHELIN4000
*replace SendSwitcher() calls with SendSwitcherReply()
*
*Revision 2.21  94/06/24  17:19:08  CACHELIN4000
*Default Gadget handling to eliminate some PowerWindows crap
*
*Revision 2.20  94/03/18  17:29:07  CACHELIN4000
*Change GrazerLayout back to 0 for picture croutons.
*
*Revision 2.19  94/03/18  04:44:19  Kell
*Renamed Flier to Flyer
*
*Revision 2.18  94/03/17  09:52:20  Kell
**** empty log message ***
*
*Revision 2.17  94/03/16  16:36:16  Kell
*Added FlyerBase opening/closing
*
*Revision 2.16  94/03/15  14:57:50  Kell
**** empty log message ***
*
*Revision 2.15  94/03/14  23:22:34  CACHELIN4000
*Attempt to fix mem leak on ES_QUIT
*
*Revision 2.14  94/03/14  21:56:38  CACHELIN4000
**** empty log message ***
*
*Revision 2.13  94/03/13  07:55:26  Kell
*Moved ProjectEditor dump key to F8 (instead of F9)
*
*Revision 2.12  94/03/12  20:01:45  CACHELIN4000
*change effects to RAM: for startup dir
*
*Revision 2.11  94/03/12  13:38:16  CACHELIN4000
**** empty log message ***
*
*Revision 2.10  94/03/11  12:17:09  CACHELIN4000
*Added ES_STARTUP message to startup routines
*
*Revision 2.9  94/03/11  09:32:05  Kell
**** empty log message ***
*
*Revision 2.8  94/03/09  01:51:47  CACHELIN4000
*Startup Message almost in...
*
*Revision 2.7  94/03/05  21:05:07  CACHELIN4000
**** empty log message ***
*
*Revision 2.6  94/03/02  21:05:34  CACHELIN4000
**** empty log message ***
*
*Revision 2.5  94/02/27  15:05:05  CACHELIN4000
**** empty log message ***
*
*
*Revision 2.3  94/02/24  15:58:37  CACHELIN4000
*Change GrazerLayout to 1 for name croutons.
*
*Revision 2.2  94/02/19  09:34:12  Kell
**** empty log message ***
*
*Revision 2.1  94/02/18  22:57:50  Kell
**** empty log message ***
*
*Revision 2.0  94/02/17  16:24:06  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  15:57:09  Kell
*FirstCheckIn
*
*Revision 2.0  94/02/17  14:44:22  Kell
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*	12-17-92	Steve H		Convert to use SmartStrings
*	10-16-93	Steve H		Last Update
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <graphics/gfxbase.h>
#include <intuition/intuition.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <edit.h>
#include <editwindow.h>
#include <grazer.h>
#include <gadgets.h>
#include <prophelp.h>
#include <project.h>
#include <filelist.h>
#include <editswit.h>
#include <crouton_all.h>
#include <flyerlib.h>
#include <RawKeyCodes.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>
#include <proto/layers.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

/*********************************************/
//#define SERDEBUG	1
#include <serialdebug.h>
/*****8***************************************/

extern LONG InitProofLib(void);
extern LONG CloseProofLib(void);

VOID __asm LoadBM(
	register __d0 char Name[],
	register __d1 LONG Flags,
	register __a0 struct BitMap *BM);

extern BOOL __regargs HandleErrPort( struct MsgPort *Port );
extern LONG InitGrazerDirCache(void);
extern LONG CloseGrazerDirCache(void);
extern LONG LocateFileRequest( void );

extern far APTR AsmGfxBase,AsmIntuitionBase,AsmCroutonBase,AsmToasterBase;

extern struct ESParams1 ESparams1;
extern UBYTE *FlyerDrives[];
extern LONG FlyerDriveCount;
extern LONG global_EditScreenDepth;
extern LONG global_do_locatefile;

#define ECS_DEPTH 2
#define AA_DEPTH 6
UBYTE IntDepth,IntPlanePick,AAMachine;

// #define STARTUP_DEBUG

#define OPEN_AREXX
#define VERSION_1_3	34L
#define VERSION_2_0	36L
#define VERSION_3_0 39L
#define REQUIRE_VERSION VERSION_2_0

//****************************************
extern LONG global_LoadSliceCommand;
extern struct Gadget Gadget1,Gadget38;
struct Gadget *FT_Gadget1,*GRZ_Gadget1; // For faster list searches, grazer and file starts
extern BOOL PropDown;
extern struct EditWindow *TimingEdit;
extern struct IBox ImageBox[];
extern WORD CutImage[];

extern far UWORD BMWidth,BMHeight;
extern far UBYTE BMColor[],BMDepth;
BPTR __asm GetBootLock(register __a0 struct Library *);
extern BOOL HandleAccessWindowPort( struct Window *win );
extern LONG LoadSlice( LONG slicecommand );

extern ULONG ReadDirectoryTabs( STRPTR filename );
extern ULONG FreeDirectoryTabs( void );
extern LONG global_setting_dirtab;

//****************************************
long global_GrazReqDoubleClicked;
struct IntuiMessage global_sw_im;
struct IntuitionBase *IntuitionBase = NULL;
struct GfxBase *GfxBase = NULL;
struct Library *DiskfontBase = NULL;
// struct LayersBase *LayersBase = NULL;
struct Library *CroutonBase = NULL;
struct Library *ToasterBase = NULL;
struct Library *FlyerBase = NULL;

struct TextFont *EditFont = NULL,*DarkFont = NULL,*YellowFont = NULL,
	*TCFont = NULL, *TCDarkFont = NULL;
struct Process *Me = NULL;
struct Screen *EditScreen = NULL;
struct Window *access_win = NULL;
struct PropHelp *PropHelp = NULL;

struct MsgPort *DelayedErrMsgPort = NULL;
struct DelayedErrorRequest	*global_der = NULL;
BOOL DelayedErrorPending = FALSE;

UWORD DOSVersion;	// lib_Version of DOSLibrary
BOOL OurScreen = FALSE;
struct EditPrefs UserPrefs;		// User preferences live here

// save path strings here when grazers closed
struct SmartString *TopPath=NULL,*BottomPath=NULL;

struct TextAttr TextAttr = {
	"InterfaceLG.font",TEXT_HEIGHT,FSF_COLORFONT,FPF_DISKFONT
},
YellowAttr = {
	"InterfaceTABS.font",TEXT_HEIGHT,FSF_COLORFONT,FPF_DISKFONT
},
TCAttr = {
	"TimeCodeLG.font",TEXT_HEIGHT,FSF_COLORFONT,FPF_DISKFONT
},
TCDarkAttr = {
	"TimeCodeDG.font",TEXT_HEIGHT,FSF_COLORFONT,FPF_DISKFONT
},
DarkAttr = {
	"InterfaceDG.font",TEXT_HEIGHT,FSF_COLORFONT,FPF_DISKFONT
};

static char ToastSys[] = "Edit_Support/",ECSImage[] = "gadget4.pic",
	AAImage[] = "gadget64.pic";
#ifndef SWIT_ONLY
static char NoToastSys[] = "edit:art/";
#endif

struct List WindowList; // !!! needs work to maintain
struct EditWindow *EditTop=NULL,*EditBottom=NULL;

static struct NewScreen NewScreenStructure = {
	0,0,	/* screen XY origin relative to View */
//	-32,0,	/* screen XY origin relative to View */

	SCREEN_WIDTH,SCREEN_HEIGHT,
	ECS_DEPTH,
	1,1,	/* detail and block pens */
	LACE+HIRES,	/* display modes for this screen */
	CUSTOMSCREEN,	/* screen type */
	NULL,	/* pointer to default screen font */
	NULL,	/* screen title */
	NULL,	/* first in list of custom screen gadgets */
	NULL	/* pointer to custom BitMap structure */
};

struct Gadget DefaultGadget = {
	NULL,10,10,16,16,
	NULL,RELVERIFY,BOOLGADGET,
	NULL,NULL,NULL,NULL,NULL,
	ID_END_OF_LIST+1,NULL
};

UBYTE *TempMem,*TempMem2;

struct BitMap FileBitMap;
static struct ExtIntuiMessage CopyMsg;

#ifdef OPEN_AREXX
static struct MsgPort *CopyARexxPort = NULL; // copy of ptr to arexx port
#endif
struct MsgPort *EditPort = NULL,*SwitPort = NULL;

static ULONG WaitMask = NULL;
WORD GrazerLayout = 0; // 0 is 80x50, 1 is 160x25

//struct ESMessage OurESMessage;

BOOL HandleReqWindow(struct EditWindow *Edit);

struct Hook DummyHook;
ULONG __saveds __asm HookFunc(register __a0 struct Hook *hook,
				   register __a2 APTR	      object,
				   register __a1 APTR	      message)
{
	return(0);
}

BPTR BootLock;
struct Window *SwitWind;

/****** Edit/InitEditing *************************************
*
*   NAME
*	InitEditing
*
*   SYNOPSIS
*	BOOL InitEditing(void)
*
*   FUNCTION
*	Opens screen and gets ready to edit projects/display grazers
*
*********************************************************************
*/
BOOL InitScreenStuff(VOID)
{
	BOOL result = FALSE;

	if (InitDrag(
			max((FileBitMap.BytesPerRow << 3),MAX_GRAZ_COL_SIZE),
			max(FileBitMap.Rows,MAX_GRAZ_ROW_SIZE),
			IntDepth,&EditScreen->RastPort,
			EditFont))
	{
		result = TRUE;
	}

	//InstallLayerInfoHook(&EditScreen->LayerInfo,LAYERS_NOBACKFILL); //&hook);

#ifdef STARTUP_DEBUG
	if (result==TRUE) DUMPMSG("InitScreenStuff success.\n");
	else DUMPMSG("InitScreenStuff failed.\n");
#endif

	return(result);
}

//*********************************************************************
BOOL InitEditing(void)
{
	BOOL result = TRUE;
	int A,B;

	NewScreenStructure.Depth = IntDepth;
	NewScreenStructure.Font = &TextAttr;
	NewScreenStructure.Height = SCREEN_HEIGHT;

#ifndef SWIT_ONLY
	if (!SwitPort){
		EditScreen = OpenScreen(&NewScreenStructure);
		if (!EditScreen)
		{
			DUMPMSG("Can't OpenScreen EditScreen");
			 return(FALSE);
		}
		SetRast(&EditScreen->RastPort,SCREEN_PEN);
		B = 1 << IntDepth;
		for (A = 0; A < B; A++)
			SetRGB32(&EditScreen->ViewPort,A,
				BMColor[A*3]<<24,
				BMColor[(A*3)+1]<<24,
				BMColor[(A*3)+2]<<24);

		OurScreen = TRUE;
		result = InitScreenStuff();
	}
#endif

#ifdef STARTUP_DEBUG
	if (result==TRUE) DUMPMSG("InitEditing success.\n");
	else DUMPMSG("InitEditing failed.\n");
#endif

	return(result);
}

/****** Edit/EndEditing *************************************
*
*   NAME
*	EndEditing
*
*   SYNOPSIS
*	VOID EndEditing(void)
*
*   FUNCTION
*	Closes all grazers/projects which may be open, closes screen
*
*********************************************************************
*/
VOID EndEditing(VOID)
{
	if (EditTop) {
		EditTop->Close(EditTop);
		EditTop->Free(EditTop);
		EditTop = NULL;
	}
	if (EditBottom) {
		EditBottom->Close(EditBottom);
		EditBottom->Free(EditBottom);
		EditBottom = NULL;
	}

	FreeDrag();
	if (OurScreen && EditScreen) {
		CloseScreen(EditScreen);
	}
	EditScreen = NULL;
	OurScreen = FALSE;
}

//*******************************************************************
VOID FreeImagery(struct BitMap *BM)
{
	LONG Size,A;

	if (BM) {
		Size = BM->BytesPerRow * BM->Rows;
		for (A = 0; A < BM->Depth; A++)
			if (BM->Planes[A]) FreeMem(BM->Planes[A],Size);
		FreeMem(BM,sizeof(struct BitMap));
	}
}

//*******************************************************************
// All the gadget imagery in one IFF picture
struct BitMap *LoadImagery(char FileName[])
{
	struct BitMap *BM;
	LONG A,Size;

	if (BM = SafeAllocMem(sizeof(struct BitMap),MEMF_CLEAR)) {
		BMWidth = 0;
		LoadBM(FileName,-1,BM);
		if (BMWidth && BMHeight && BMDepth) {
			BM->BytesPerRow = ((BMWidth + 15) >> 3) & 0xfffe;
			BM->Rows = BMHeight;
			BM->Depth = BMDepth;
			Size = BM->BytesPerRow * BM->Rows;
			for (A = 0; A < BM->Depth; A++)
			if (!(BM->Planes[A] = SafeAllocMem(Size,MEMF_CHIP)))
			{
				DUMPMSG((UBYTE *)FileName);
				DUMPMSG("Can't SafeAllocMem BM->Planes[A]");
				goto Fail;
			}
			LoadBM(FileName,0,BM);
		} else {
			DUMPMSG((UBYTE *)FileName);
			DUMPMSG("No BMWidth || BMHeight || BMDepth");
Fail:
			FreeImagery(BM);
			BM = NULL;
		}
	}
	else
	{
		DUMPMSG((UBYTE *)FileName);
		DUMPMSG("Can't SafeAllocMem BitMap");
	}

	return(BM);
}

//*******************************************************************
VOID FreeImage(struct Image *Image)
{
	LONG L;

	if (Image->ImageData) {
		L = ((Image->Width + 15) >> 3) & 0xfffe;
		L = L * Image->Height * IntDepth;
		FreeMem(Image->ImageData,L); // all planes continuous
	}
	FreeMem(Image,sizeof(struct Image));
}

//*******************************************************************
VOID FreeGadgetImagery(VOID)
{
	WORD *Cut;
	struct Image *Image;
	struct Gadget *Gadget;

	Cut = &CutImage[0];
	while (*Cut != ID_END_OF_LIST)
	{
		if ( Gadget = FindGadget(&Gadget1,*Cut++) )
		{
			if (Gadget->Flags & GADGIMAGE)
			{
				if (Image = Gadget->GadgetRender) FreeImage(Image);
				if (Image = Gadget->SelectRender) FreeImage(Image);
			}
		}
	}
}

//*******************************************************************
BOOL InitGadgetImagery(VOID)
{
	struct BitMap *BM,TempBM;
	BOOL Success = FALSE,AltImage;
	struct Gadget *Gadget,*LastGad=NULL;
	struct Image *RImage,*SImage;
	LONG L,W,PSize;
	struct IBox *Box;
	char *C;
	WORD *Cut;
	struct SmartString *Sm=NULL;

	C = AAImage;
	if (IntDepth == ECS_DEPTH) C = ECSImage;

#ifndef SWIT_ONLY
	if (!ToasterBase) {
		DUMPMSG("Don't have ToasterBase");

		if (!(Sm = AllocSmartString(NoToastSys,NULL)))
		{
			DUMPMSG("Can't AllocSmartString NoToastSys");
			 goto RealExit;
		}
	} else {
#endif
//		DUMPMSG("Have ToasterBase");

		if (!(Sm = AllocSmartString(ToastSys,NULL)))
		{
			DUMPMSG("Can't AllocSmartString ToastSys");
			 goto RealExit;
		}
		BootLock = GetBootLock(ToasterBase);
		CurrentDir(BootLock);

#ifndef SWIT_ONLY
	}
#endif

//	DUMPMSG("Have AllocSmartString NoToastSys or ToastSys");

	if (!AppendCSmartString(C,Sm))
	{
  		DUMPMSG("Can't AppendCSmartString C");
	 goto RealExit;
	}
//	DUMPMSG("Have AppendCSmartString");

	if (BM = LoadImagery(GetCString(Sm))) {
	Box = &ImageBox[0];
	Cut = &CutImage[0];
//		Gadget = FindGadget(&Gadget1,*Cut++);
//	while( (*Cut!=ID_END_OF_LIST) && (Gadget=FindGadget(&Gadget1,*Cut++)) )
	while (*Cut != ID_END_OF_LIST)
	{
		if(!(Gadget=FindGadget(&Gadget1,*Cut)))
		{
			if(!(Gadget = AllocOneGadget(&DefaultGadget)))
				goto Err;
			Gadget->GadgetID = *Cut;
			if(LastGad)
			{
				LastGad->NextGadget=Gadget;
				LastGad = Gadget;
			}
			else
			{
				for(LastGad=&Gadget1; LastGad->NextGadget;LastGad=LastGad->NextGadget)
					;
				LastGad->NextGadget=Gadget;
				LastGad = Gadget;
				LastGad->NextGadget=NULL;
			}
		}
		Cut++;
		if ((Box->Left == (Box+1)->Left) && (Box->Top == (Box+1)->Top)) {
			AltImage = FALSE;
			Gadget->Flags = GADGHNONE+GADGIMAGE;
		} else {
			AltImage = TRUE;
			Gadget->Flags = GADGHIMAGE+GADGIMAGE;
		}

		if (Gadget->GadgetType == PROPGADGET)
			((struct PropInfo *)Gadget->SpecialInfo)->Flags &= (~AUTOKNOB);

		Gadget->GadgetRender = SafeAllocMem(sizeof(struct Image),MEMF_CLEAR);
		if (!Gadget->GadgetRender)
		{
			DUMPMSG("Can't SafeAllocMem Gadget->GadgetRender");
		  goto Err;
		}
//		DUMPMSG("Have SafeAllocMem Gadget->GadgetRender");

		if (AltImage) {
			Gadget->SelectRender = SafeAllocMem(sizeof(struct Image),MEMF_CLEAR);
			if (!Gadget->SelectRender)
			{
				DUMPMSG("Can't SafeAllocMem Gadget->SelectRender");
 				goto Err;
 			}
//			DUMPMSG("Have SafeAllocMem Gadget->SelectRender");
		}

		RImage = Gadget->GadgetRender;
		Gadget->Width = RImage->Width = Box->Width;
		Gadget->Height = RImage->Height = Box->Height;
		RImage->Depth = (IntDepth==AA_DEPTH ? 3:IntDepth); // Only need 3 planes for AA Image
		RImage->PlanePick = (IntDepth==AA_DEPTH ? 0x07:IntPlanePick); // Only need 3 planes for AA Image
		RImage->PlaneOnOff = 0;

		if (AltImage) {
			SImage = Gadget->SelectRender;
			SImage->Width = Gadget->Width;
			SImage->Height = Gadget->Height;
			SImage->Depth = RImage->Depth;
			SImage->PlanePick = RImage->PlanePick;
			SImage->PlaneOnOff = 0;
		}

		W = ((Box->Width + 15) >> 3) & 0xfffe;
		PSize = W * Box->Height;
		L = PSize * IntDepth;
		if (!(RImage->ImageData = SafeAllocMem(L,MEMF_CHIP|MEMF_CLEAR)))
		{
			DUMPMSG("Can't SafeAllocMem RImage->ImageData");
			goto Err;
		}
//		DUMPMSG("Have SafeAllocMem RImage->ImageData");

		if (AltImage) {
			if (!(SImage->ImageData = SafeAllocMem(L,MEMF_CHIP|MEMF_CLEAR)))
			{
				DUMPMSG("Can't SafeAllocMem SImage->ImageData");
				goto Err;
			}
//			DUMPMSG("Have SafeAllocMem SImage->ImageData");
		}
		TempBM.BytesPerRow = W;
		TempBM.Rows = RImage->Height;
		TempBM.Depth = RImage->Depth;

		C = (char *)RImage->ImageData;
		for (L = 0; L < TempBM.Depth; L++) {
			TempBM.Planes[L] = C;
			C += PSize;
		}
		BltBitMap(BM,Box->Left,Box->Top,&TempBM,0,0,
			Box->Width,Box->Height,0xc0,0xff,NULL);
		WaitBlit();
		Box++;

		if (AltImage) {
		C = (char *)SImage->ImageData;
		for (L = 0; L < TempBM.Depth; L++) {
			TempBM.Planes[L] = C;
			C += PSize;
		}
		BltBitMap(BM,Box->Left,Box->Top,&TempBM,0,0,
			Box->Width,Box->Height,0xc0,0xff,NULL);
		WaitBlit();
		}
		Box++;
	}
	Success = TRUE;
Err:
Exit:
	FreeImagery(BM);
	}
	else DUMPMSG("Can't LoadImagery()");

RealExit:
	if (Sm) FreeSmartString(Sm);

#ifdef STARTUP_DEBUG
	if (Success==TRUE) DUMPMSG("InitG success.\n");
	else DUMPMSG("InitG failed.\n");
#endif
  FT_Gadget1=&Gadget1;
  GRZ_Gadget1=FindGadget(&Gadget1,ID_CROUTON_SMALL);
	return(Success);
}

/*******************************************************************/
VOID InitDumbFont(struct TextFont *Font)
{
	struct ColorTextFont *CFont;

	if (IntDepth == AA_DEPTH) {
//		CFont = (struct ColorTextFont *)EditFont;
		CFont = (struct ColorTextFont *)Font;
		CFont->ctf_Depth = FONT_DEPTH;
		CFont->ctf_PlanePick = FONT_MASK;
		CFont->ctf_PlaneOnOff = 0;
	}
}

/*******************************************************************/
BOOL Setup()
{
	struct Gadget *Gadget;
#ifdef CUSTOM_BODY
	struct PropInfo *SInfo;
	struct Image *Image;
#endif
	struct Library *Lib;


#ifdef STARTUP_DEBUG
	DUMPMSG("Startup debug enabled.\n");
#endif
	if (!(IntuitionBase = (struct IntuitionBase *)
		OpenLibrary("intuition.library",REQUIRE_VERSION)))
	{
			DUMPMSG("Can't open intuition.library");
			return(FALSE);
	}
	AsmIntuitionBase = IntuitionBase;

	if (!(GfxBase = (struct GfxBase *)
		OpenLibrary("graphics.library",REQUIRE_VERSION)))
	{
			DUMPMSG("Can't open graphics.library");
			return(FALSE);
	}
	AsmGfxBase = GfxBase;

  if( ((struct GfxBase *)GfxBase)->ChipRevBits0&GFXF_AA_LISA )
	{
		IntDepth = AA_DEPTH;
		IntPlanePick = 0x3f;
		AAMachine = TRUE;
	}
	else  // OK, don't allow ECS mode on 4000
	{  // verify that we are in AGA machine, allow ECS mode on 4000 though
		IntDepth = ECS_DEPTH;
		IntPlanePick = 0x03;
		AAMachine = FALSE;
	}

	if (!(DiskfontBase = OpenLibrary("diskfont.library",REQUIRE_VERSION)))
	{
		DUMPMSG("Can't open diskfont.library");
		return(FALSE);
	}

	if (!(LayersBase =
		OpenLibrary("layers.library",REQUIRE_VERSION)))
	{
			DUMPMSG("Can't open layers.library");
			return(FALSE);
	}

	if (!(CroutonBase = OpenLibrary("crouton.library",0)))
	{
			DUMPMSG("Can't open crouton.library");
			return(FALSE);
	}
	AsmCroutonBase = CroutonBase;

	Lib = (struct Library *)DOSBase;
	DOSVersion = Lib->lib_Version;

	ToasterBase = OpenLibrary("ToasterBase",0);
#ifdef SWIT_ONLY		//was ifdef pre 2-29-94
	if (!ToasterBase)
	{
		DUMPMSG("Can't open ToasterBase");
		 return(FALSE);
	}
#endif
	AsmToasterBase = ToasterBase;

	FlyerBase = OpenLibrary("flyer.library",0);
#ifdef SWIT_ONLY
	if (!FlyerBase)		DUMPMSG("Can't open Flyer.library");
#endif

#ifdef STARTUP_DEBUG
	DUMPMSG("Libraries opened.\n");
#endif

	if ( !InitProofLib() )
	{
		return(FALSE);
	}

	ReadDirectoryTabs("edit_support/DirTabs");

	if (!(EditFont = OpenDiskFont(&TextAttr))) {
		DUMPMSG("Can't open DiskFont InterfaceLG.font");
		return(FALSE);
	}
	if (!(YellowFont = OpenDiskFont(&YellowAttr))) {
		DUMPMSG("Can't open DiskFont InterfaceLG.font");
		return(FALSE);
	}
	if (!(DarkFont = OpenDiskFont(&DarkAttr))) {
		DUMPMSG("Can't open DiskFont InterfaceDG.font");
		return(FALSE);
	}
	if (!(TCFont = OpenDiskFont(&TCAttr)))
		TCFont = EditFont;
	if (!(TCDarkFont = OpenDiskFont(&TCDarkAttr)))
		TCDarkFont = DarkFont;

#ifdef STARTUP_DEBUG
	DUMPMSG("Font opened.\n");
#endif
	InitDumbFont(EditFont);
	InitDumbFont(YellowFont);
	InitDumbFont(DarkFont);
	if(TCFont!=EditFont)InitDumbFont(TCFont);
	if(TCDarkFont!=DarkFont)InitDumbFont(TCDarkFont);
	InitStringExtend(EditFont,0,2);

	Me = (struct Process *)FindTask(NULL);
	Me->pr_WindowPtr = (APTR)-1;
	if (!(PropHelp = InitPropHelp()))
	{
		DUMPMSG("Can't InitPropHelp");
		 return(FALSE);
	}

	if ( !(DelayedErrMsgPort = CreatePort(NULL,0)) )
	{
		 return(FALSE);
	}

	/* Build timer request for delayed error */
	if ( !(global_der = (struct DelayedErrorRequest *)
			CreateExtIO(DelayedErrMsgPort,sizeof(*global_der))) )
	{
		return(FALSE);
	}

	// OpenDevice() returns error
	if ( OpenDevice(TIMERNAME,UNIT_MICROHZ,(struct IORequest *)global_der,0L) )
	{
		return(FALSE);
	}

	// Initialize TimerIO defaults to wait 1.5 seconds
	global_der->der_timerequest.tr_node.io_Command = TR_ADDREQUEST;
	global_der->der_timerequest.tr_time.tv_secs = 1;
	global_der->der_timerequest.tr_time.tv_micro = 500000;

	InitGrazerDirCache();

	NewList(&WindowList); // list of all EditWindows

	EditPort = CreatePort("edit.port",0);
	if (!EditPort)
	{
		 DUMPMSG("Can't CreatePort edit.port");
		 return(FALSE);
	}
	SwitPort = FindPort("ToasterARexx.port");
#ifdef SWIT_ONLY		//was ifdef pre 2-29-94
	if (!SwitPort)
	{
		DUMPMSG("Can't FindPort ToasterARexx.port");
		 return(FALSE);
	}
#endif

	if (!(InitGadgetImagery()))
	{
		DUMPMSG("Can't InitGadgetImagery()");
	  return(FALSE);
	}
	Gadget = FindGadget(&Gadget1,ID_NAMES_FILE);
	ImageToBitMap(Gadget->GadgetRender,&FileBitMap);

#ifdef OPEN_AREXX
	if (!(CopyARexxPort=OpenARexxPort()))
	{
		DUMPMSG("Can't OpenARexxPort()");
	 return(FALSE);
	}
#endif

	if (!(TempMem = SafeAllocMem(TEMP_SIZE,0)))
	{
		DUMPMSG("Can't SafeAllocMem TempMem");
		 return(FALSE);
	}
	if (!(TempMem2 = SafeAllocMem(TEMP_SIZE,0)))
	{
		DUMPMSG("Can't SafeAllocMem TempMem2");
		 return(FALSE);
	}

	if (!(TopPath = AllocSmartString(NULL,NULL)))
	{
		DUMPMSG("Can't AllocSmartString TopPath");
		 return(FALSE);
	}

//	if (!(BottomPath = AllocSmartString("RAM:",NULL)))
	if (!(BottomPath = AllocSmartString(NULL,NULL)))
	{
		DUMPMSG("Can't AllocSmartString BottomPath = RAM:");
		 return(FALSE);
	}

	DummyHook.h_MinNode.mln_Succ = 0;
	DummyHook.h_MinNode.mln_Pred = 0;
	DummyHook.h_Entry = (ULONGFUNCT)HookFunc;
	DummyHook.h_SubEntry = (ULONGFUNCT)HookFunc;
//	DummyHook.h_Entry = HookFunc;
//	DummyHook.h_SubEntry = HookFunc;
	DummyHook.h_Data = NULL;

	LoadPrefsData(&UserPrefs);			// Load user-preferences file (Editor-specific)

#ifdef STARTUP_DEBUG
	DUMPMSG("Startup success.\n");
#endif
	return(TRUE);
}

//*******************************************************************
VOID Cleanup(VOID)
{
	struct ColorTextFont *CFont;
DUMPMSG("Edit:Cleanup()");

	CloseAccessWindow();

DUMPMSG("  AccessWindow Closed");

	if (TopPath) FreeSmartString(TopPath);
	DUMPMSG("Freed string1\n");

	if (BottomPath) FreeSmartString(BottomPath);
	DUMPMSG("Freed string2\n");

	if (EditPort) DeletePort(EditPort);
	DUMPMSG("Freed port\n");

	if (FlyerBase)
	{
		DUMPMSG("Flyer stuff\n");
		StartHeadList(0);			// Do nice, graceful cleanup of heads
		EndHeadList(0,1);			// So drive changes will be legal
		CloseLibrary(FlyerBase);
		DUMPMSG("Flyer stuff done\n");
	}
	if (ToasterBase) CloseLibrary(ToasterBase);
	DUMPMSG("Close TB\n");

	if (TempMem2) FreeMem(TempMem2,TEMP_SIZE);
	DUMPMSG("Freed TM2\n");

	if (TempMem) FreeMem(TempMem,TEMP_SIZE);
	DUMPMSG("Close TM\n");

#ifdef OPEN_AREXX
	CloseARexxPort();
	DUMPMSG("Close ARexx\n");
#endif

	FreeGadgetImagery();
	DUMPMSG("Freed Imagery\n");

	CloseGrazerDirCache();
	DUMPMSG("Close DirCache\n");

DUMPMSG("  GrazerDirCache Closed");

	if ( global_der )
	{
		if ( DelayedErrorPending & 0x01 )
		{
			AbortIO( (struct IORequest *)global_der );
			WaitIO( (struct IORequest *)global_der );
			GetMsg( DelayedErrMsgPort );
		}

		if ( ((struct IORequest *)global_der)->io_Device )
			CloseDevice((struct IORequest *)global_der);

		DeleteExtIO((struct IORequest *)global_der);
	}

	if ( DelayedErrMsgPort )
		DeletePort(DelayedErrMsgPort);

DUMPMSG("  DelayedErrMsgPort Closed");

	if (PropHelp)
		FreePropHelp(PropHelp);
	DUMPMSG("Freed PropHelp\n");

	if (EditFont) {
		if (IntDepth == AA_DEPTH) {
			CFont = (struct ColorTextFont *)EditFont;
			CFont->ctf_Depth = 4;
		}
		CloseFont(EditFont);
		DUMPMSG("Close EditFont\n");
	}
	if (YellowFont) {
		if (IntDepth == AA_DEPTH) {
			CFont = (struct ColorTextFont *)YellowFont;
			CFont->ctf_Depth = 4;
		}
		CloseFont(YellowFont);
		DUMPMSG("Close YellowFont\n");
	}
	if (DarkFont) {
		if (IntDepth == AA_DEPTH) {
			CFont = (struct ColorTextFont *)DarkFont;
			CFont->ctf_Depth = 4;
		}
		CloseFont(DarkFont);
		DUMPMSG("Close DarkFont\n");
	}
	if (TCFont && (TCFont!=EditFont)) {
		if (IntDepth == AA_DEPTH) {
			CFont = (struct ColorTextFont *)TCFont;
			CFont->ctf_Depth = 4;
		}
		CloseFont(TCFont);
		DUMPMSG("Close TCFont\n");
	}
	if (TCDarkFont && (TCDarkFont!=DarkFont)) {
		if (IntDepth == AA_DEPTH) {
			CFont = (struct ColorTextFont *)TCDarkFont;
			CFont->ctf_Depth = 4;
		}
		CloseFont(TCDarkFont);
		DUMPMSG("Close TCDarkFont\n");
	}

DUMPMSG("  Fonts Closed");

	FreeDirectoryTabs();

DUMPMSG("  Tabs Saved & Closed");

	CloseProofLib();

DUMPMSG("  ProofLib Closed");

	if (CroutonBase) CloseLibrary(CroutonBase);
	if (LayersBase) CloseLibrary((struct Library *)LayersBase);
	if (DiskfontBase) CloseLibrary(DiskfontBase);
	if (GfxBase) CloseLibrary((struct Library *)GfxBase);
	if (IntuitionBase) CloseLibrary((struct Library *)IntuitionBase);

DUMPMSG("ALL Closed");

}

/****** Edit/BuildWaitMask ******************************************
*
*   NAME
*	BuildWaitMask
*
*   SYNOPSIS
*	BOOL BuildWaitMask
*
*   FUNCTION
*	Gets SigBit from all EditWindows,TimerPort,and MsgPort
*
*********************************************************************
*/
#define MAX_SIGNALS 32
static struct EditWindow *EditSigBit[MAX_SIGNALS];

ULONG BuildWaitMask()
{
	struct EditWindow *Edit;
	UWORD a;

	WaitMask = NULL;
	for (a = 0; a < MAX_SIGNALS; a++) EditSigBit[a] = NULL;

	Edit = (struct EditWindow *)WindowList.lh_Head;
	while (Edit->Node.MinNode.mln_Succ) {
		if (Edit->Window) {
			a = Edit->Window->UserPort->mp_SigBit;
			WaitMask |= (1 << a);
			EditSigBit[a] = Edit;
		}
		Edit = (struct EditWindow *)Edit->Node.MinNode.mln_Succ;
	}
	WaitMask |= (1 << PropHelp->TimerReplyPort->mp_SigBit);
	WaitMask |= (1 << EditPort->mp_SigBit);
	WaitMask |= (1 << DelayedErrMsgPort->mp_SigBit);

	if ( access_win )
		WaitMask |= (1 << access_win->UserPort->mp_SigBit);

#ifdef OPEN_AREXX
	if(CopyARexxPort)
		WaitMask |= (1 << CopyARexxPort->mp_SigBit);
#endif
	return(TRUE);
}

/****** Edit/UpdateDisplay ******************************************
*
*   NAME
*	UpdateDisplay
*
*   SYNOPSIS
*	VOID UpdateDisplay(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID UpdateDisplay(struct EditWindow *Edit)
{
	struct Gadget *Gadget;

	if (Edit) {
	if (Edit->RenderRail) {
		DrawKnobRail(Edit);
		Edit->RenderRail = FALSE;
	}
	if (Edit->RedrawString) {
		if (Gadget = FindGadget(Edit->Gadgets,ID_PATH)) {
			RefreshGList(Gadget,Edit->Window,NULL,1);
		}
		Edit->RedrawString = FALSE;
	}
	if (Edit->RedrawList || Edit->RedrawSelect) {
		RenderList(Edit);
		Edit->DisplayGrid = TRUE;
	}
	DisplayGrid(Edit->RowOffset,Edit->ScrollOffset,Edit);
	}
}

//*******************************************************************
VOID UpdateAllDisplay(VOID)
{
	if ( global_EditScreenDepth )
	{
		struct EditWindow *Draw,*Next;

		Draw = (struct EditWindow *)WindowList.lh_Head;
		while (Next = (struct EditWindow *)Draw->Node.MinNode.mln_Succ)
		{
			UpdateDisplay(Draw);
			Draw = Next;
		}
	}
}

/****** Edit/HandleWindow *******************************************
*
*   NAME
*	HandleWindow
*
*   SYNOPSIS
*	BOOL HandleWindow(struct EditWindow *Edit)
*
*   FUNCTION
*	Handles all window messages
*
*********************************************************************
*/
BOOL HandleWindow(struct EditWindow *Edit)
{
	struct IntuiMessage *IntuiMsg;
	BOOL Done = FALSE;
	UWORD Code;
	struct Gadget *Gadget;

// pointer to a function that returns a pointer to an EditWindow structure
	struct EditWindow *(*Handler)(struct EditWindow *,struct IntuiMessage *);

	while (Edit && (IntuiMsg = (struct IntuiMessage *)
		GetMsg(Edit->Window->UserPort))) {
		CopyMem(IntuiMsg,&CopyMsg,sizeof(struct ExtIntuiMessage));
			 // must reply now because window might close
		ReplyMsg((struct Message *)IntuiMsg);
		IntuiMsg = (struct IntuiMessage *)&CopyMsg;

		Code = IntuiMsg->Code;
		switch (IntuiMsg->Class)
		{
			case IDCMP_MOUSEMOVE:
				if (PropDown) HandleProp(Edit,IntuiMsg);
				else HandleMove(Edit,IntuiMsg);
				break;

			case IDCMP_RAWKEY:
//				if (IntuiMsg->Code == RAWKEY_F8) Done = TRUE;
//				else
				DUMPHEXIW("HandleWindow( KEY= ",IntuiMsg->Code,") \\");
					Edit = HandleKey(Edit,IntuiMsg);
				if(Edit==NULL) Done=TRUE;
				break;

			case IDCMP_GADGETUP:
			case IDCMP_GADGETDOWN:
				Gadget = IntuiMsg->IAddress;
				Handler = (EDITWINDOWFUNCT)Gadget->UserData; // ignore warning
				if (Handler)				// Must not be NULL
				{
					Edit = Handler(Edit,IntuiMsg); // Edit might Free during this call
					if(Edit==NULL) Done=TRUE;
				}
				break;

			case IDCMP_MOUSEBUTTONS: // buttons not over gadgets
									 // including not over our window
				if (Code == SELECTUP) {
					EndCleanDrag(IntuiMsg);
				}
				if (Code & IECODE_RBUTTON) // up or down
					SendIntuiSwitcher(IntuiMsg);
				break;

			case IDCMP_DISKINSERTED:
			case IDCMP_DISKREMOVED:
				CheckShowList(&WindowList);
		}
	// actions may affect redraws on other windows as well
//		DUMPSTR("Updating Display...");
		UpdateAllDisplay();
//		DUMPMSG("	... Completed");
	}
//	DUMPMSG("Window Handled");
	return(Done);
}

/****** Edit/EventLoop **********************************************
*
*   NAME
*	EventLoop
*
*   SYNOPSIS
*	EventLoop
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID EventLoop()
{
	ULONG Signals;
	BOOL Done = FALSE,SWQuit=FALSE;
	int a;

	while (!Done)
	{
		/* "Class" is set by HandleSwitcherReply() if it
		 * recieved an ES_SwitcherRAWKEY from the switcher.
		 * (see EditWindow.c)
		 */
		if ( global_sw_im.Class )
		{
			/* "Class" now = 0 so we dont send key back to
			 * switcher inside HandleKey()
			 */
			global_sw_im.Class = 0;

			if ( EditTop )
			{
				HandleKey(EditTop,&global_sw_im);
				UpdateAllDisplay();
			}
		}

		Signals = Wait(WaitMask);
		for (a = 0; a < MAX_SIGNALS; a++)
		{
			if (Signals & (1<<a))
			{
				if (EditSigBit[a])
				{
					if ( EditSigBit[a]->Node.Type == EW_ASYNCREQ )
					{
						Done |= HandleReqWindow(EditSigBit[a]);
					} else {
						Done |= HandleWindow(EditSigBit[a]);
					}
				}
			}
		}
		if (Signals & (1<<PropHelp->TimerReplyPort->mp_SigBit))
		{
			GetMsg(PropHelp->TimerReplyPort);
			if (TimingEdit) HandleTimer(TimingEdit);
		}
		if (Signals & (1<<EditPort->mp_SigBit))
		{
			if( !(SWQuit=HandleSwitcher(EditPort)) ) // Update when quitting may strand mem.
			{
				UpdateAllDisplay(); // might need grid redraw

/**********************
//The following has to be done somewhere outside of any Switcher->Editor
//message processing, otherwise the Switcher could be in a busy loop
//waiting on a reply, and not be able to handle the following
//ES_FlyerDriveInfo requests.
//
//				if(FlyerDriveCount==0) {
//						BuildFlyerList();	// Want to make sure this has been built
//
//						ESparams1.Data1=(LONG)FlyerDrives;
//						SendSwitcherReply(ES_FlyerVolumes,&ESparams1);
//				}
**********************/
			}
			else
			{
				DUMPMSG("Switcher said QUIT!");
				Done |=SWQuit; // Silly to have SWQuit at all... fix hit on quitting?
			}
		}
		if ( Signals & (1<<DelayedErrMsgPort->mp_SigBit) )
		{
			HandleErrPort(DelayedErrMsgPort);
		}
		if ( access_win && (Signals & (1<<access_win->UserPort->mp_SigBit)) )
		{
			Done |= HandleAccessWindowPort(access_win);
		}

#ifdef OPEN_AREXX
		if (Signals & (1<<CopyARexxPort->mp_SigBit))
		{
			Done |= HandleARexxPort();
		}
#endif
		// Application Slice to load (set in GraphicHelp.c)
		if ( global_LoadSliceCommand )
		{
			LoadSlice( global_LoadSliceCommand );
			global_LoadSliceCommand = 0;
		}

		if ( global_do_locatefile )
		{
			LocateFileRequest();
		}

		if ( global_GrazReqDoubleClicked )
		{
			global_GrazReqDoubleClicked = FALSE;
			EndGrazerRequest(TRUE);
		}
	}
}

//*******************************************************************
int main(argc, argv)
	int argc;
	char *argv[];
{

//	printf("la la la\n");
//	printf("la la la\n");

/*
	if ((argc == 2) && (argv[1][0] == '2')) {
		IntDepth = ECS_DEPTH;
		IntPlanePick = 0x03;
		AAMachine = FALSE;
	} else {
		IntDepth = AA_DEPTH;
		IntPlanePick = 0x3f;
		AAMachine = TRUE;
	}
*/

	if (Setup() && InitEditing()) {
#ifndef SWIT_ONLY
		if (!SwitPort)
			if (!MakeLayout(EW_PROJECT,TOP_SMALL,EW_GRAZER))
			{
				DUMPMSG("Can't MakeLayout()");
				 goto Exit;
			}
#endif
		BuildWaitMask();
		if (SwitPort)
		{
			DUMPMSG("Edit About to Send ES_STARTUP");
			SendSwitcherReply(ES_STARTUP,NULL);
			DUMPMSG("Edit Sent ES_STARTUP");
		}
		EventLoop();
		DUMPMSG("Exited EventLoop()");
	}
Exit:
	EndEditing();
	Cleanup();
DUMPMSG("Edit:Main() ALL DONE!");
}

// end of edit.c

BOOL HandleReqWindow(struct EditWindow *Edit)
{
	struct IntuiMessage *IntuiMsg;
	BOOL Done = FALSE;
	UWORD Code;
	struct Gadget *Gadget;

// pointer to a function that returns a pointer to an EditWindow structure
	struct EditWindow *(*Handler)(struct EditWindow *,struct IntuiMessage *);

	while (Edit && (IntuiMsg = (struct IntuiMessage *)
		GetMsg(Edit->Window->UserPort))) {
		CopyMem(IntuiMsg,&CopyMsg,sizeof(struct ExtIntuiMessage));
			 // must reply now because window might close
		ReplyMsg((struct Message *)IntuiMsg);
		IntuiMsg = (struct IntuiMessage *)&CopyMsg;

		Code = IntuiMsg->Code;
		switch (IntuiMsg->Class) {
			case IDCMP_RAWKEY:
				if (IntuiMsg->Code == RAWKEY_F8) Done = TRUE;
				else Edit = HandleKey(Edit,IntuiMsg);
			break;

			case IDCMP_GADGETUP:
			case IDCMP_GADGETDOWN:
				Gadget = IntuiMsg->IAddress;
				Handler = (EDITWINDOWFUNCT)Gadget->UserData; // ignore warning
				if (Handler)		// Must not be NULL
					Edit = Handler(Edit,IntuiMsg); // Edit might Free during this call
				break;

			case IDCMP_MOUSEBUTTONS: // buttons not over gadgets
															 // including not over our window
				if (Code & IECODE_RBUTTON) // up or down
					SendIntuiSwitcher(IntuiMsg);
				break;

			case IDCMP_DISKINSERTED:
			case IDCMP_DISKREMOVED:
				CheckShowList(&WindowList);
		}
	// actions may affect redraws on other windows as well
	UpdateAllDisplay();
	}
	return(Done);
}



void RebootFlyer(void)
{
	struct DateStamp	now;
	BPTR	lock,oldCD;

	if ((ToasterBase) && (FlyerBase))
	{
		BootLock = GetBootLock(ToasterBase);
		oldCD = CurrentDir(BootLock);

		FlyerQuit(0);
		Delay(50);

		lock = Lock("Flyer_Support",SHARED_LOCK);
		if (lock)
		{
			InitFlyers(lock);
			UnLock(lock);
		}

		// Should set Flyer's software real-time-clock to Amiga's again
		DateStamp(&now);
		SetFlyerTime(&now);

		CurrentDir(oldCD);		// Restore CD at entry
	}
}
