/********************************************************************
* FileTypes.c - Routines and data for determining types of files
* $Id: filetypes.c,v 2.19 1996/07/29 10:39:41 Holt Exp $
* $Log: filetypes.c,v $
*Revision 2.19  1996/07/29  10:39:41  Holt
*added the QTNames array for putting Qmode on the file info panel.
*
*Revision 2.18  1995/08/09  17:51:27  Flick
*"Unfixed" DTNames array entries back to "Effect" for ANIM/ILBM's
*
*Revision 2.17  1995/07/24  15:13:08  Holt
*made changes relating to ham anims
*
*Revision 2.16  1995/03/09  13:27:40  CACHELIN4000
*Fix text for CRFX
*
*Revision 2.15  1995/02/20  13:47:04  CACHELIN4000
*Add file description strings for new Crouton.library types
*
*Revision 2.14  1995/02/19  00:57:16  CACHELIN4000
*add Flyer Still, Main, Keyed/video Anims
*
*Revision 2.13  1994/11/16  01:07:12  CACHELIN4000
*Add CR_ERR! type to DTNames array.
*
*Revision 2.12  1994/11/12  17:32:14  CACHELIN4000
*add CR_ERROR to CrUDTypes array..
*
*Revision 2.11  1994/11/04  16:00:13  CACHELIN4000
*Remove old dead f'ns now in crouton.library
*
*Revision 2.10  94/06/22  10:46:31  CACHELIN4000
**** empty log message ***
*
*Revision 2.9  94/03/19  12:14:53  CACHELIN4000
**** empty log message ***
*
*Revision 2.8  94/03/16  16:11:43  CACHELIN4000
**** empty log message ***
*
*Revision 2.0  94/02/28  10:03:37  CACHELIN4000
*FirstCheckIn
*
* By Arnie Cachelin Feb 25 1994
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*********************************************************************/


#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <iffp/ilbm.h>
#include <stdio.h>
#include <string.h>
#include <crouton_all.h>
#include <dos.h>
#include <time.h>

#include <editwindow.h>
#include <grazer.h>
#include <gadgets.h>
#include <filelist.h>
#include <doshelp.h>
#include <prophelp.h>
#include <request.h>
#include <project.h>
#include <editswit.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>

#ifndef PROTO_PASS
#include <proto.h>
#endif

ULONG CRuDTypes[] = {     // Values #defined in croutons.h...
  CT_FXANIM,        // ANIM
  CT_FXILBM,        // ILBM
  CT_FXALGO,        // ALGO
  CT_FXCR,          // CRFX
  CT_VIDEO,         // CLIP
  CT_AUDIO,         //  AUD
  CT_CONTROL,       // CTRL
  CT_PROJECT,       // PROJ
  CT_FRAMESTORE,    // FRAM
  CT_KEY,           // KEYF
  CT_SCROLL,        // SCRO
  CT_CRAWL,         // CRAW

	CT_VIDEOANIM,		// VIDA
	CT_KEYEDANIM,		// KEYA
	CT_MAIN,				// MAIN
	CT_STILL,			// STIL

	CT_ERROR,			// ERR! Last of the control-panel types
  CT_CGBOOK,        // BOOK
  CT_IMAGE,         // RGBA
  CT_LWSCENE,       // LWSC
  CT_LWOBJ,         // LWOB
  CT_LWSURF,        // SURF
  CT_LWMOT,         // LWMO
  CT_LWENV,         // LWEN
  CT_FONT,          // FONT
  CT_EPS,           // EPSF
  CT_REXX,          // REXX
  CT_TEXT ,         // TEXT
  CT_UNKNOWN,       // WHAT This one should remain last of the project-loadable types

  CT_FLOPPY,        // FLOP
  CT_DRIVE,         // DRIV
  CT_CDROM,         // CDRM
  CT_FLYER,         // FLYR
  CT_DIR            //  DIR
  };

// An array of names could be real handy sometime.
char *DTNames[] = {
  "Effect",
  "Effect",
  "Effect",
  "ChromaFX",
  "Video Clip",
  "Audio Clip",
  "Control",
  "Project",
  "Framestore",
  "Key Page",
  "Scroll Page",
  "Crawl Page",
  "Video Anim",
  "Keyed Anim",
  "Source Out",
  "Flyer Still",
  "Lost Crouton",
  "CG Book",
  "Image",
  "3D Scene",
  "3D Object",
  "3D Surface",
  "3D Motion",
  "3D Envelope",
  "Font",
  "EPS File",
  "ARexx",
  "Text",
  "Mystery File",
	"Floppy",
	"Hard Disk",
	"CD-ROM",
	"VT Flyer",
	"Folder",
  "Gubba-Doop",
  "Gubba-Loop" };  // Force of habit and superstition make me NULL terminate this bad boy


char *QTNames[] = {
	"           ",
	"STD Quality",
	"HQ5 Quality",
	"HQ6 Quality"};





UWORD __asm CRuDToCR(REG(d0) ULONG ctype)
{
	UWORD i;
	for(i=CR_FXANIM; i<= CR_DIR; i++)
		if(CRuDTypes[i]==ctype) return(i);
	return(CR_UNKNOWN);
}

UWORD __asm CRuDToDT(REG(d0) ULONG ctype)
{
  switch(ctype)
  {
    case    CT_VIDEOANIM:				// added 071195
    case    CT_KEYEDANIM:				// added 071195
    case    CT_FXANIM:
    case    CT_FXILBM:
    case    CT_FXALGO:
    case    CT_FXCR:
      return(DT_EFFECT);
    case    CT_VIDEO:
      return(DT_PROJECT);
    case    CT_AUDIO:
      return(DT_PROJECT);
    case    CT_CONTROL:
      return(DT_PROJECT);
    case    CT_PROJECT:
      return(DT_PROJECT);
    case    CT_FRAMESTORE:
    case    CT_KEY:
      return(DT_FRAMESTORE);
    case    CT_SCROLL:
    case    CT_CRAWL:
      return(DT_CGPAGE);
    case    CT_CGBOOK:
      return(DT_CGBOOK);
    case    CT_IMAGE:
      return(DT_IMAGE);
    case    CT_LWSCENE:
      return(DT_3DSCN);
    case    CT_LWOBJ:
      return(DT_3DOBJ);
    case    CT_LWSURF:
      return(DT_3DSRF);
    case    CT_LWMOT:
      return(DT_3DMOT);
    case    CT_LWENV:
      return(DT_3DENV);
    case    CT_FONT:
      return(DT_FONT);
    case    CT_EPS:
      return(DT_EPS);
    case    CT_REXX:
      return(DT_REXX);
    case    CT_TEXT:
      return(DT_ASCII);
    case    CT_UNKNOWN:
    default: ;
  }
  return(DT_DEFAULT);
}
