/*********************************************************************\
*
* FlyerFormat - Format Flyer drives
*
* $Id: flyerformat.c,v 1.9 1995/08/23 11:33:46 Hayes Exp $
*
* $Log: flyerformat.c,v $
*Revision 1.9  1995/08/23  11:33:46  Hayes
*Made changes to big tables.
*
*Revision 1.8  95/08/17  16:46:14  pfrench
*Small tweak.
*
*Revision 1.7  1995/08/16  16:39:01  pfrench
*Added Karl's big tables
*
*Revision 1.6  1995/08/14  17:41:19  pfrench
*No code changes, added un-used routine that resets some
*mode pages to their default values
*
*Revision 1.5  1995/07/18  12:53:01  pfrench
*Bumped version to 4.05, also no longer prints out
*supported drive list.
*
*Revision 1.4  1995/07/18  12:51:13  pfrench
*Modified Seagate Elite 9 options
*
*Revision 1.3  1995/06/07  09:23:42  pfrench
*Added new tweak for IBM drives
*
*Revision 1.2  1995/06/01  16:27:25  pfrench
*Updated version info and IBM options
*
*Revision 1.1  1995/06/01  10:25:30  pfrench
*Now computes block percentage by dividing by 1000 first.
*Decreases accuracy, but doesn't overflow on multi-gig drives
*
*Revision 1.0  1995/05/05  15:49:28  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
* 12-05-94      pfrench         Created this file
* 12-12-94      marty           Added Seagate Elite 9
* 02-08-95      pfrench         Now prints firm vers
* 02-17-95      pfrench         Only displays sequent
*                               tial access devices
* 02-17-95      pfrench         Added wait pointer
* 03-07-95      pfrench         Fixed volname bug
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#ifndef INTUITION_GADGETCLASS_H
#include <intuition/gadgetclass.h>
#endif

#ifndef LIBRARIES_GADTOOLS_H
#include <libraries/gadtools.h>
#endif

#include <ctype.h>
#include <string.h>

#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>

#include <clib/dos_protos.h>
#include <pragmas/dos_pragmas.h>

#include <clib/intuition_protos.h>
#include <pragmas/intuition_pragmas.h>

#include <clib/gadtools_protos.h>
#include <pragmas/gadtools_pragmas.h>

#include <clib/alib_stdio_protos.h>


/* GLOBAL VARIABLES */

ULONG stdout;
struct Library *FlyerBase;
struct Library *IntuitionBase;
struct Library *GadToolsBase;
struct TextAttr Topaz80 = { "topaz.font",8,0,0, };

#define APP_VERSION	"V4.05"
#define APP_TITLE		"FlyerFormat " APP_VERSION

/* ------------------------------------------------------------------ */

struct Options {
	char	*optname;
	UBYTE	page;
	UBYTE	pos;
	UBYTE	flag;
	LONG	value;
};

struct Manuf {
	char	*manufname;
	char	*modelname;
	char	*revision;
	ULONG	blocks;
	struct Options *options;
};

/* ------------------------------- */
unsigned char SafeDefaultPages[] =
{
	0x00,
	0x01,
	0x08,
	0x0a,

	0xFF	/* Terminator */
};

/* ------------------------------- */

/* SEAGATE ST15150N 0017 */
struct Options Opts_ST15150N_0017[] = {
	{" ", 0x00, 0x02, 0, 0x00},
	{" ", 0x00, 0x03, 0, 0x00},
	{" ", 0x01, 0x02, 0, 0x08},
	{" ", 0x01, 0x03, 0, 0x00},
	{" ", 0x01, 0x04, 0, 0x30},
	{" ", 0x01, 0x05, 0, 0x00},
	{" ", 0x01, 0x06, 0, 0x00},
	{" ", 0x01, 0x07, 0, 0x00},
	{" ", 0x01, 0x08, 0, 0x00},
	{" ", 0x01, 0x09, 0, 0x00},
	{" ", 0x01, 0x0A, 0, 0xFF},
	{" ", 0x01, 0x0B, 0, 0xFF},
	{" ", 0x02, 0x02, 0, 0x00},
	{" ", 0x02, 0x03, 0, 0x00},
	{" ", 0x02, 0x04, 0, 0x00},
	{" ", 0x02, 0x05, 0, 0x0A},
	{" ", 0x02, 0x06, 0, 0x00},
	{" ", 0x02, 0x07, 0, 0x00},
	{" ", 0x02, 0x08, 0, 0x00},
	{" ", 0x02, 0x09, 0, 0x00},
	{" ", 0x02, 0x0A, 0, 0x00},
	{" ", 0x02, 0x0B, 0, 0x00},
	{" ", 0x02, 0x0C, 0, 0x00},
	{" ", 0x02, 0x0D, 0, 0x00},
	{" ", 0x02, 0x0E, 0, 0x00},
	{" ", 0x02, 0x0F, 0, 0x00},
	{" ", 0x03, 0x02, 0, 0x00},
	{" ", 0x03, 0x03, 0, 0x15},
	{" ", 0x03, 0x04, 0, 0x00},
	{" ", 0x03, 0x05, 0, 0x09},
	{" ", 0x03, 0x06, 0, 0x00},
	{" ", 0x03, 0x07, 0, 0x00},
	{" ", 0x03, 0x08, 0, 0x00},
	{" ", 0x03, 0x09, 0, 0x15},
	{" ", 0x03, 0x0A, 0, 0x00},
	{" ", 0x03, 0x0B, 0, 0x6C},
	{" ", 0x03, 0x0C, 0, 0x02},
	{" ", 0x03, 0x0D, 0, 0x00},
	{" ", 0x03, 0x0E, 0, 0x00},
	{" ", 0x03, 0x0F, 0, 0x01},
	{" ", 0x03, 0x10, 0, 0x00},
	{" ", 0x03, 0x11, 0, 0x09},
	{" ", 0x03, 0x12, 0, 0x00},
	{" ", 0x03, 0x13, 0, 0x10},
	{" ", 0x03, 0x14, 0, 0x40},
	{" ", 0x03, 0x15, 0, 0x00},
	{" ", 0x03, 0x16, 0, 0x00},
	{" ", 0x03, 0x17, 0, 0x00},
	{" ", 0x04, 0x02, 0, 0x00},
	{" ", 0x04, 0x03, 0, 0x0E},
	{" ", 0x04, 0x04, 0, 0x80},
	{" ", 0x04, 0x05, 0, 0x15},
	{" ", 0x04, 0x06, 0, 0x00},
	{" ", 0x04, 0x07, 0, 0x00},
	{" ", 0x04, 0x08, 0, 0x00},
	{" ", 0x04, 0x09, 0, 0x00},
	{" ", 0x04, 0x0A, 0, 0x00},
	{" ", 0x04, 0x0B, 0, 0x00},
	{" ", 0x04, 0x0C, 0, 0x00},
	{" ", 0x04, 0x0D, 0, 0x00},
	{" ", 0x04, 0x0E, 0, 0x00},
	{" ", 0x04, 0x0F, 0, 0x00},
	{" ", 0x04, 0x10, 0, 0x00},
	{" ", 0x04, 0x11, 0, 0x00},
	{" ", 0x04, 0x12, 0, 0x00},
	{" ", 0x04, 0x13, 0, 0x00},
	{" ", 0x04, 0x14, 0, 0x1C},
	{" ", 0x04, 0x15, 0, 0x20},
	{" ", 0x04, 0x16, 0, 0x00},
	{" ", 0x04, 0x17, 0, 0x00},
	{" ", 0x07, 0x02, 0, 0x00},
	{" ", 0x07, 0x03, 0, 0x00},
	{" ", 0x07, 0x04, 0, 0x30},
	{" ", 0x07, 0x05, 0, 0x00},
	{" ", 0x07, 0x06, 0, 0x00},
	{" ", 0x07, 0x07, 0, 0x00},
	{" ", 0x07, 0x08, 0, 0x00},
	{" ", 0x07, 0x09, 0, 0x00},
	{" ", 0x07, 0x0A, 0, 0xFF},
	{" ", 0x07, 0x0B, 0, 0xFF},
	{" ", 0x08, 0x02, 0, 0x14},
	{" ", 0x08, 0x03, 0, 0x00},
	{" ", 0x08, 0x04, 0, 0xFF},
	{" ", 0x08, 0x05, 0, 0xFF},
	{" ", 0x08, 0x06, 0, 0x00},
	{" ", 0x08, 0x07, 0, 0x00},
	{" ", 0x08, 0x08, 0, 0x03},
	{" ", 0x08, 0x09, 0, 0x5B},
	{" ", 0x08, 0x0A, 0, 0x02},
	{" ", 0x08, 0x0B, 0, 0x64},
	{" ", 0x08, 0x0C, 0, 0x80},
	{" ", 0x08, 0x0D, 0, 0x02},
	{" ", 0x08, 0x0E, 0, 0x00},
	{" ", 0x08, 0x0F, 0, 0x00},
	{" ", 0x08, 0x10, 0, 0x00},
	{" ", 0x08, 0x11, 0, 0x00},
	{" ", 0x08, 0x12, 0, 0x00},
	{" ", 0x08, 0x13, 0, 0x00},
	{" ", 0x0A, 0x02, 0, 0x02},
	{" ", 0x0A, 0x03, 0, 0x00},
	{" ", 0x0A, 0x04, 0, 0x00},
	{" ", 0x0A, 0x05, 0, 0x00},
	{" ", 0x0A, 0x06, 0, 0x00},
	{" ", 0x0A, 0x07, 0, 0x00},
	{" ", 0x0A, 0x08, 0, 0x00},
	{" ", 0x0A, 0x09, 0, 0x00},
	{" ", 0x0A, 0x0A, 0, 0x00},
	{" ", 0x0A, 0x0B, 0, 0x00},
	{" ", 0x0C, 0x02, 0, 0x80},
	{" ", 0x0C, 0x03, 0, 0x00},
	{" ", 0x0C, 0x04, 0, 0x00},
	{" ", 0x0C, 0x05, 0, 0x1D},
	{" ", 0x0C, 0x06, 0, 0x00},
	{" ", 0x0C, 0x07, 0, 0x00},
	{" ", 0x0C, 0x08, 0, 0x00},
	{" ", 0x0C, 0x09, 0, 0x00},
	{" ", 0x0C, 0x0A, 0, 0x00},
	{" ", 0x0C, 0x0B, 0, 0x00},
	{" ", 0x0C, 0x0C, 0, 0x00},
	{" ", 0x0C, 0x0D, 0, 0x0E},
	{" ", 0x0C, 0x0E, 0, 0x7F},
	{" ", 0x0C, 0x0F, 0, 0x14},
	{" ", 0x0C, 0x10, 0, 0x00},
	{" ", 0x0C, 0x11, 0, 0x00},
	{" ", 0x0C, 0x12, 0, 0x00},
	{" ", 0x0C, 0x13, 0, 0x00},
	{" ", 0x0C, 0x14, 0, 0x00},
	{" ", 0x0C, 0x15, 0, 0x00},
	{" ", 0x0C, 0x16, 0, 0x10},
	{" ", 0x0C, 0x17, 0, 0x00},
	{" ", 0x0D, 0x02, 0, 0x00},
	{" ", 0x0D, 0x03, 0, 0x00},
	{" ", 0x0D, 0x04, 0, 0x00},
	{" ", 0x0D, 0x05, 0, 0x00},
	{" ", 0x0D, 0x06, 0, 0x00},
	{" ", 0x0D, 0x07, 0, 0x00},
	{" ", 0x0D, 0x08, 0, 0x00},
	{" ", 0x0D, 0x09, 0, 0x00},
	{" ", 0x0D, 0x0A, 0, 0x00},
	{" ", 0x0D, 0x0B, 0, 0x00},

	{0,0,0,0,0},
};

/* SEAGATE ST32550N 0016 */
struct Options Opts_ST32550N_0016[] = {
	{" ", 0x00, 0x02, 0, 0x00},
	{" ", 0x00, 0x03, 0, 0x00},
	{" ", 0x01, 0x02, 0, 0x08},
	{" ", 0x01, 0x03, 0, 0x00},
	{" ", 0x01, 0x04, 0, 0x30},
	{" ", 0x01, 0x05, 0, 0x00},
	{" ", 0x01, 0x06, 0, 0x00},
	{" ", 0x01, 0x07, 0, 0x00},
	{" ", 0x01, 0x08, 0, 0x00},
	{" ", 0x01, 0x09, 0, 0x00},
	{" ", 0x01, 0x0A, 0, 0xFF},
	{" ", 0x01, 0x0B, 0, 0xFF},
	{" ", 0x02, 0x02, 0, 0x00},
	{" ", 0x02, 0x03, 0, 0x00},
	{" ", 0x02, 0x04, 0, 0x00},
	{" ", 0x02, 0x05, 0, 0x0A},
	{" ", 0x02, 0x06, 0, 0x00},
	{" ", 0x02, 0x07, 0, 0x00},
	{" ", 0x02, 0x08, 0, 0x00},
	{" ", 0x02, 0x09, 0, 0x00},
	{" ", 0x02, 0x0A, 0, 0x00},
	{" ", 0x02, 0x0B, 0, 0x00},
	{" ", 0x02, 0x0C, 0, 0x00},
	{" ", 0x02, 0x0D, 0, 0x00},
	{" ", 0x02, 0x0E, 0, 0x00},
	{" ", 0x02, 0x0F, 0, 0x00},
	{" ", 0x03, 0x02, 0, 0x00},
	{" ", 0x03, 0x03, 0, 0x0B},
	{" ", 0x03, 0x04, 0, 0x00},
	{" ", 0x03, 0x05, 0, 0x09},
	{" ", 0x03, 0x06, 0, 0x00},
	{" ", 0x03, 0x07, 0, 0x00},
	{" ", 0x03, 0x08, 0, 0x00},
	{" ", 0x03, 0x09, 0, 0x16},
	{" ", 0x03, 0x0A, 0, 0x00},
	{" ", 0x03, 0x0B, 0, 0x6D},
	{" ", 0x03, 0x0C, 0, 0x02},
	{" ", 0x03, 0x0D, 0, 0x00},
	{" ", 0x03, 0x0E, 0, 0x00},
	{" ", 0x03, 0x0F, 0, 0x01},
	{" ", 0x03, 0x10, 0, 0x00},
	{" ", 0x03, 0x11, 0, 0x08},
	{" ", 0x03, 0x12, 0, 0x00},
	{" ", 0x03, 0x13, 0, 0x10},
	{" ", 0x03, 0x14, 0, 0x40},
	{" ", 0x03, 0x15, 0, 0x00},
	{" ", 0x03, 0x16, 0, 0x00},
	{" ", 0x03, 0x17, 0, 0x00},
	{" ", 0x04, 0x02, 0, 0x00},
	{" ", 0x04, 0x03, 0, 0x0D},
	{" ", 0x04, 0x04, 0, 0xB7},
	{" ", 0x04, 0x05, 0, 0x0B},
	{" ", 0x04, 0x06, 0, 0x00},
	{" ", 0x04, 0x07, 0, 0x00},
	{" ", 0x04, 0x08, 0, 0x00},
	{" ", 0x04, 0x09, 0, 0x00},
	{" ", 0x04, 0x0A, 0, 0x00},
	{" ", 0x04, 0x0B, 0, 0x00},
	{" ", 0x04, 0x0C, 0, 0x00},
	{" ", 0x04, 0x0D, 0, 0x00},
	{" ", 0x04, 0x0E, 0, 0x00},
	{" ", 0x04, 0x0F, 0, 0x00},
	{" ", 0x04, 0x10, 0, 0x00},
	{" ", 0x04, 0x11, 0, 0x00},
	{" ", 0x04, 0x12, 0, 0x00},
	{" ", 0x04, 0x13, 0, 0x00},
	{" ", 0x04, 0x14, 0, 0x1C},
	{" ", 0x04, 0x15, 0, 0x20},
	{" ", 0x04, 0x16, 0, 0x00},
	{" ", 0x04, 0x17, 0, 0x00},
	{" ", 0x07, 0x02, 0, 0x00},
	{" ", 0x07, 0x03, 0, 0x00},
	{" ", 0x07, 0x04, 0, 0x30},
	{" ", 0x07, 0x05, 0, 0x00},
	{" ", 0x07, 0x06, 0, 0x00},
	{" ", 0x07, 0x07, 0, 0x00},
	{" ", 0x07, 0x08, 0, 0x00},
	{" ", 0x07, 0x09, 0, 0x00},
	{" ", 0x07, 0x0A, 0, 0xFF},
	{" ", 0x07, 0x0B, 0, 0xFF},
	{" ", 0x08, 0x02, 0, 0x14},
	{" ", 0x08, 0x03, 0, 0x00},
	{" ", 0x08, 0x04, 0, 0xFF},
	{" ", 0x08, 0x05, 0, 0xFF},
	{" ", 0x08, 0x06, 0, 0x00},
	{" ", 0x08, 0x07, 0, 0x00},
	{" ", 0x08, 0x08, 0, 0x01},
	{" ", 0x08, 0x09, 0, 0x99},
	{" ", 0x08, 0x0A, 0, 0x01},
	{" ", 0x08, 0x0B, 0, 0xC7},
	{" ", 0x08, 0x0C, 0, 0x80},
	{" ", 0x08, 0x0D, 0, 0x02},
	{" ", 0x08, 0x0E, 0, 0x00},
	{" ", 0x08, 0x0F, 0, 0x00},
	{" ", 0x08, 0x10, 0, 0x00},
	{" ", 0x08, 0x11, 0, 0x00},
	{" ", 0x08, 0x12, 0, 0x00},
	{" ", 0x08, 0x13, 0, 0x00},
	{" ", 0x0A, 0x02, 0, 0x02},
	{" ", 0x0A, 0x03, 0, 0x00},
	{" ", 0x0A, 0x04, 0, 0x00},
	{" ", 0x0A, 0x05, 0, 0x00},
	{" ", 0x0A, 0x06, 0, 0x00},
	{" ", 0x0A, 0x07, 0, 0x00},
	{" ", 0x0A, 0x08, 0, 0x00},
	{" ", 0x0A, 0x09, 0, 0x00},
	{" ", 0x0A, 0x0A, 0, 0x00},
	{" ", 0x0A, 0x0B, 0, 0x00},
	{" ", 0x0C, 0x02, 0, 0x80},
	{" ", 0x0C, 0x03, 0, 0x00},
	{" ", 0x0C, 0x04, 0, 0x00},
	{" ", 0x0C, 0x05, 0, 0x1A},
	{" ", 0x0C, 0x06, 0, 0x00},
	{" ", 0x0C, 0x07, 0, 0x00},
	{" ", 0x0C, 0x08, 0, 0x00},
	{" ", 0x0C, 0x09, 0, 0x00},
	{" ", 0x0C, 0x0A, 0, 0x00},
	{" ", 0x0C, 0x0B, 0, 0x00},
	{" ", 0x0C, 0x0C, 0, 0x00},
	{" ", 0x0C, 0x0D, 0, 0x0D},
	{" ", 0x0C, 0x0E, 0, 0xB6},
	{" ", 0x0C, 0x0F, 0, 0x0A},
	{" ", 0x0C, 0x10, 0, 0x00},
	{" ", 0x0C, 0x11, 0, 0x00},
	{" ", 0x0C, 0x12, 0, 0x00},
	{" ", 0x0C, 0x13, 0, 0x00},
	{" ", 0x0C, 0x14, 0, 0x00},
	{" ", 0x0C, 0x15, 0, 0x00},
	{" ", 0x0C, 0x16, 0, 0x10},
	{" ", 0x0C, 0x17, 0, 0x00},
	{" ", 0x0D, 0x02, 0, 0x00},
	{" ", 0x0D, 0x03, 0, 0x00},
	{" ", 0x0D, 0x04, 0, 0x00},
	{" ", 0x0D, 0x05, 0, 0x00},
	{" ", 0x0D, 0x06, 0, 0x00},
	{" ", 0x0D, 0x07, 0, 0x00},
	{" ", 0x0D, 0x08, 0, 0x00},
	{" ", 0x0D, 0x09, 0, 0x00},
	{" ", 0x0D, 0x0A, 0, 0x00},
	{" ", 0x0D, 0x0B, 0, 0x00},
	{0,0,0,0,0},
};

struct Options IBMOptions[] = {
	{"WCE",8,2,0x04,1},
	{"Pri",8,3,0,0x11},
	{"Segs",8,13,0,2},
	{"TCHD",0,5,0x80,0},
	{"TCC",0,5,0x40,1},
	{"LITF",0,5,0x01,1},
	{0,0,0,0,0},
};

struct Options SeaCuda4Options[] = {
	{"RCD",8,2,0x01,0},
	{"WCE",8,2,0x04,1},
	{"Segs",8,13,0,2},
	{0,0,0,0,0},
};

struct Options SeaElite9Options[] = {
//	{"RCD",8,2,0x01,0},
//	{"WCE",8,2,0x04,1},
//	{"IC",8,2,0x80,0},
//	{"Segs",8,13,0,2},

	{"",1,2,0,0x08},
	{"",1,3,0,0x00},
	{"",1,8,0,0x00},

	{"",8,2,0,0x14},
	{"PrefHi",8,8,0,0x02},
	{"PrefLo",8,9,0,0xca},
	{"Segs",8,13,0,2},

	{"",0x0a,2,0,2},

	{0,0,0,0,0},
};

struct Options Micropolis3243Options[] = {
	{"RCD",8,2,0x01,0},
	{"WCE",8,2,0x04,1},
	{0,0,0,0,0},
};

struct Options Micropolis1991Options[] = {
	{"RCD",8,2,0x01,0},
	{"WCE",8,2,0x04,1},
	{0,0,0,0,0},
};

struct Options Quantum32150Options[] = {
	{"AWRE",1,2,0x80,1},
	{"RC"  ,1,2,0x10,0},
	{"DCR" ,1,2,0x01,0},
	{"CorSpan",1,4,0,0},
	{"HeadOff",1,5,0,0},
	{"WCE" ,8,2,0x04,1},
	{0,0,0,0,0},
};


#define CHECK_FIRMWARE_REVISIONS

struct Manuf Manufs[] = {
	{"SEAGATE ","ST15150N",		"0017",	0,				Opts_ST15150N_0017},
	{"SEAGATE ","ST32550N",		"0016",	0,				Opts_ST32550N_0016},

#ifdef CHECK_FIRMWARE_REVISIONS
	{"IBM     ","0664M1H",		"",		0,				IBMOptions},
	{"SEAGATE ","ST15150N",		"",		0,				SeaCuda4Options},
	{"SEAGATE ","ST410800N",	"",		0,				SeaElite9Options},
	{"MICROP  ","3243-19MZ", 	"",		0x794000,	Micropolis3243Options},
	{"MICROP  ","1991-27MZ",	"",		0,				Micropolis1991Options},
	{"Quantum ","XP32150", 		"",		0,				Quantum32150Options},
#else
	{"IBM     ","0664M1H",		"7 70",	0,				IBMOptions},
	{"SEAGATE ","ST15150N",		"",		0,				SeaCuda4Options},
	{"SEAGATE ","ST410800N",	"",		0,				SeaElite9Options},
	{"MICROP  ","3243-19MZ", 	"HT01",	0x794000,	Micropolis3243Options},
	{"MICROP  ","1991-27MZ",	"HT01",	0,				Micropolis1991Options},
	{"Quantum ","XP32150", 		"555B",	0,				Quantum32150Options},
#endif
	{0,0,0,0,0},
};

/* The Wait pointer Mike Sinz uses... (ripped from DiskSpeed4.c) */
USHORT __chip WaitPointer[36] =
{
	0x0000, 0x0000, 0x0400, 0x07C0, 0x0000, 0x07C0, 0x0100, 0x0380, 0x0000,
	0x07E0, 0x07C0, 0x1FF8, 0x1FF0, 0x3FEC, 0x3FF8, 0x7FDE, 0x3FF8, 0x7FBE,
	0x7FFC, 0xFF7F, 0x7EFC, 0xFFFF, 0x7FFC, 0xFFFF, 0x3FF8, 0x7FFE, 0x3FF8,
	0x7FFE, 0x1FF0, 0x3FFC, 0x07C0, 0x1FF8, 0x0000, 0x07E0, 0x0000, 0x0000
};

/*
 * These two defines set up and clear the WaitPointer...
 */
#define	SetWait(x)	SetPointer(x,WaitPointer,16L,16L,-6L,0L)
#define	ClearWait(x)	ClearPointer(x)

/* ------------------------------------------------------------------ */

struct _FlyDevice
{
	struct Node		fd_Node;					/* Contains nameptr */

	UWORD				fd_driveID;				/* (channel * 8) + drive */

	UBYTE				fd_inqlen;				/* Inquiry() len */
	UBYTE				fd_scsiver;				/* scsi version */

	UBYTE				fd_flags;				/* flag bits (see below) */
	UBYTE				fd_pad;

	struct Manuf	*fd_manuf;				/* Manufacturer info for drive (if any) */

	/* Long aligned */

	char				fd_namebuf[100];		/* Name as appears in list */

	/* Information from Inquiry() function */

	char				fd_vendor[8];
	char				fd_productID[16];
	char				fd_revision[4];

	/* Information from FlyerDriveInfo() */

	struct FlyerVolInfo	fd_fvi;			/* Information from flyer */

	/* Information from ReadSize() function */

	ULONG				fd_blocks;
	ULONG				fd_blocksize;

};

#define FDF_FLYERFS				0x01
#define FDF_CAN_CHANGE_CACHE	0x02

#define APP_FAST_VIDEO_KEY		231

struct AppData
{
	struct FlyerVolume	ad_fv;			/* temporary flyer volume for scanning */

	struct MinList			ad_devlist;		/* device list of flyer drives */

	/* Handshake for key */
	LONG						ad_percent;
	LONG						ad_key;

	/* Interface related stuff */

	struct Screen			*ad_scr;
	void						*ad_vi;

	struct Window			*ad_win;			/* Window Pointer */
	struct Gadget			*ad_glist;		/* Gadtools gadget list pointer */

	struct Gadget			*ad_drivegad;	/* Gadget containing devices */
	struct Gadget			*ad_formatgad;	/* Format drive gadget  */
	struct Gadget			*ad_cachegad;	/* Set cache gadget */

	struct _FlyDevice 	*ad_last_fd;	/* Last FlyDevice selected from list */

	/* general purpose buffer */

	char						ad_buf[256];		/* buffer for reading/writing */

	char						ad_volname[32];	/* new volume name (for format) */
};

/* ------------------------------------------------------------------ */

#define MY_WINFLAGS	(WFLG_DRAGBAR | WFLG_DEPTHGADGET | WFLG_CLOSEGADGET | WFLG_ACTIVATE)
#define MY_IDCMP		(LISTVIEWIDCMP | BUTTONIDCMP | IDCMP_CLOSEWINDOW)

/*
 *		General Window Layout
 *		 ____________________________________________
 *		|x|													 |B|
 *		|--------------------------------------------|
 *		|															|
 *		|	+--------------------------------------+	|
 *		|	|												 |x|	|
 *		|	|												 |x|	|
 *		|	|												 |x|	|
 *		|	|												 |x|	|
 *		|	|												 |	|	|
 *		|	|												 |_|	|
 *		|	|												 |^|	|
 *		|	|												 |v|	|
 *		|	+--------------------------------------+	|
 *		|															|
 *		|	[Re-Scan]	[Format Drive]	 [Set Cache]	|
 *		|															|
 *		+--------------------------------------------+
 *
 */

#define	APPGAD_DRIVELIST		1
#define	APPGAD_RESCAN			2
#define	APPGAD_FORMAT			3
#define	APPGAD_SETCACHE		4

#define	APPWIN_INNERWIDTH		620
#define	APPWIN_INNERHEIGHT	120

#define	DRIVELIST_LEFT			10
#define	DRIVELIST_WIDTH		APPWIN_INNERWIDTH - 14
#define	DRIVELIST_TOP			10
#define	DRIVELIST_HEIGHT		APPWIN_INNERHEIGHT - DRIVELIST_TOP - 24

#define	BUTTON_WIDTH			((DRIVELIST_WIDTH - 32) / 3)

/* ------------------------------------------------------------------ */

int main(int argc,char **argv);
static LONG ad_EventLoop( struct AppData *ad );
static LONG scan_flyerdrives( struct AppData *ad );
static LONG ad_FormatFlyerDrive( struct AppData *ad, struct _FlyDevice *fd );
static LONG ad_SetModePageDefaults( struct AppData *ad, struct _FlyDevice *fd );
static LONG ad_SetCacheParams( struct AppData *ad, struct _FlyDevice *fd );
static ULONG ChangeItem( struct AppData *ad, struct Options *optptr );
static LONG ad_OpenInterface( struct AppData *ad );
static void ad_CloseInterface( struct AppData *ad );
static void ad_SelectDeviceNode( struct AppData *ad, LONG nodenum );
static LONG ad_CreateGadgetList( struct AppData *ad );
static struct AppData *ad_Create(void);
static void ad_Delete( struct AppData *ad );
static struct _FlyDevice *fd_Create(void);
static void fd_Delete( struct _FlyDevice *fd );
static struct Node *GetNodeNum( struct MinList *l, LONG nodenum );

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

#define TEMPLATE "PERCENT=PCT/N,KEY/N"
#define PERCENT_OPT	0
#define KEY_OPT		1
LONG opt_array[2];

int main(int argc,char **argv)
{
	struct RDArgs	*ra;

	stdout = Output();

	if ( ra = ReadArgs(TEMPLATE,opt_array,NULL) )
	{
		if ( !(FlyerBase = OpenLibrary(FLYERLIBNAME,0)) )
			printf("Open flyer.library failed\n");

		/* if ( FlyerBase = OpenLibrary(FLYERLIBNAME,0) ) */
		{
			if ( IntuitionBase = OpenLibrary("intuition.library",37L) )
			{
				if ( GadToolsBase = OpenLibrary("gadtools.library",37L) )
				{
					struct AppData		*ad;

					if ( ad = ad_Create() )
					{
						if ( opt_array[PERCENT_OPT] )
							ad->ad_percent = *(LONG *)opt_array[PERCENT_OPT];

						if ( opt_array[KEY_OPT] )
							ad->ad_key = *(LONG *)opt_array[KEY_OPT];

						if ( ad_OpenInterface(ad) )
						{
							scan_flyerdrives(ad);

							/* refresh flyer device list */
							GT_SetGadgetAttrs(ad->ad_drivegad,ad->ad_win,NULL,
								GTLV_Labels,		&ad->ad_devlist,
								TAG_DONE );

							ad_EventLoop(ad);

							ad_CloseInterface(ad);
						}

						ad_Delete(ad);
					}

					CloseLibrary(GadToolsBase);
				}

				CloseLibrary(IntuitionBase);
			}

			if (FlyerBase) CloseLibrary(FlyerBase);
		}
		/* else printf("Open flyer.library failed\n"); */


		FreeArgs(ra);
	}

	return(0);
}

static LONG ad_EventLoop( struct AppData *ad )
{
	LONG		retval = 0;
	BOOL		done = FALSE;

	while ( !done )
	{
		struct IntuiMessage		*im;

		Wait( (1L << ad->ad_win->UserPort->mp_SigBit) );

		while ( !done && (im = GT_GetIMsg(ad->ad_win->UserPort)) )
		{
			ULONG				 im_class;
			UWORD				 im_code;
			struct Gadget	*gad;

			/* No harm in referencing gad yet */
			gad = (struct Gadget *)im->IAddress;
			im_class = im->Class;
			im_code = im->Code;

			GT_ReplyIMsg(im);

			switch (im_class)
			{
				case IDCMP_GADGETUP:
					switch ( gad->GadgetID )
					{
						case APPGAD_DRIVELIST:
						{
							ad_SelectDeviceNode(ad,im_code);
						}
						break;

						case APPGAD_RESCAN:
						{
							GT_SetGadgetAttrs(ad->ad_drivegad,ad->ad_win,NULL,
								GTLV_Labels,		NULL,
								TAG_DONE );

							ad_SelectDeviceNode(ad,-1);

							scan_flyerdrives(ad);

							GT_SetGadgetAttrs(ad->ad_drivegad,ad->ad_win,NULL,
								GTLV_Labels,		&ad->ad_devlist,
								TAG_DONE );
						}
						break;

						case APPGAD_FORMAT:
						{
							if ( ad->ad_last_fd )
							{
								ad_FormatFlyerDrive(ad,ad->ad_last_fd);
							}
						}
						break;

						case APPGAD_SETCACHE:
						{
							if ( ad->ad_last_fd )
							{
								/* DONT DO THIS */
								// ad_SetModePageDefaults(ad,ad->ad_last_fd);

								ad_SetCacheParams(ad,ad->ad_last_fd);
							}
						}
						break;
					}
				break;

				case IDCMP_REFRESHWINDOW:
					GT_BeginRefresh(ad->ad_win);
					GT_EndRefresh(ad->ad_win,TRUE);
				break;

				case IDCMP_CLOSEWINDOW:
					done = TRUE;
				break;
			}
		}
	}

	return(retval);
}

static LONG scan_flyerdrives( struct AppData *ad )
{
	LONG					 err = 0;
	struct _FlyDevice	*fd;

	/* Free in reverse order */
	while ( fd = (struct _FlyDevice *)RemTail((struct List *)&ad->ad_devlist) )
	{
		fd_Delete(fd);
	}

	if ( FlyerBase )
	{

	WORD		chan;

	printf("Scanning Flyer drives");

	ad->ad_fv.Board = 0;

	SetWait(ad->ad_win);

	for ( chan = 0; chan < 3; chan++ )
	{
		WORD		drive;

		ad->ad_fv.SCSIdrive = (chan << 3) + 0;

		ad->ad_buf[0] = '\0';

		printf("..%lc",(long)('A'+chan));

		if ( !(err = FindDrives(&ad->ad_fv,ad->ad_buf)) )
		{
			for ( drive = 0; drive < 7; drive++ )
			{

				printf(".%lc",(long)('0'+drive));

				/* There is a drive here */
				if ( ad->ad_buf[0] & (1 << drive) )
				{
					if ( fd = fd_Create() )
					{
						/* Drive identification */
						fd->fd_driveID = (chan << 3) + drive;

						/* General information */
						fd->fd_scsiver = ad->ad_buf[2+drive];
						fd->fd_inqlen = ad->ad_buf[10+drive]+5;

						/* Add This item to the list */
						AddTail( (struct List *)&ad->ad_devlist,(struct Node *)fd);
					}
					else
					{
						/* Running very low on memory */
					}
				}
			}
		}
	}

	printf("\n");

	}
#ifdef TEST_CODE
	else
	{
		if ( fd = fd_Create() )
		{
			/* Drive identification */
			fd->fd_driveID = (0 << 3) + 0;

			strcpy(fd->fd_vendor,"AJAX");
			strcpy(fd->fd_productID,"SmegmaDrive 1");

			/* Add This item to the list */
			AddTail( (struct List *)&ad->ad_devlist,(struct Node *)fd);
		}

		if ( fd = fd_Create() )
		{
			/* Drive identification */
			fd->fd_driveID = (0 << 3) + 1;

			strcpy(fd->fd_vendor,"BERTHOLD");
			strcpy(fd->fd_productID,"Fahrvergnugen");

			/* Add This item to the list */
			AddTail( (struct List *)&ad->ad_devlist,(struct Node *)fd);
		}

		if ( fd = fd_Create() )
		{
			/* Drive identification */
			fd->fd_driveID = (1 << 3) + 0;

			strcpy(fd->fd_vendor,"ACME");
			strcpy(fd->fd_productID,"Rattlepoop 26");

			fd->fd_flags |= FDF_FLYERFS | FDF_CAN_CHANGE_CACHE;

			/* Add This item to the list */
			AddTail( (struct List *)&ad->ad_devlist,(struct Node *)fd);
		}

		if ( fd = fd_Create() )
		{
			/* Drive identification */
			fd->fd_driveID = (2 << 3) + 2;

			strcpy(fd->fd_vendor,"SeaCrate");
			strcpy(fd->fd_productID,"Cannon Fodder");

			/* Add This item to the list */
			AddTail( (struct List *)&ad->ad_devlist,(struct Node *)fd);
		}
	}
#endif /* TEST_CODE */

	if ( !err )
	{
		struct _FlyDevice	*next_fd;

		for(	fd = (struct _FlyDevice *)ad->ad_devlist.mlh_Head;
				next_fd = (struct _FlyDevice *)fd->fd_Node.ln_Succ;
				fd = next_fd )
		{
			char		*volumename;
			char		*driveattrs;

			/* Now ask for some info on the drives */
			ad->ad_fv.SCSIdrive = fd->fd_driveID;

			if ( FlyerBase )
			{
				if ( !(err = Inquiry(&ad->ad_fv,fd->fd_inqlen,ad->ad_buf)) )
				{
					/* Is the device type == 0x00 (random access device) */
					if ( (ad->ad_buf[0] & 0x1F) == 0x00 )
					{
						CopyMem(&ad->ad_buf[8],fd->fd_vendor,sizeof(fd->fd_vendor));
						CopyMem(&ad->ad_buf[16],fd->fd_productID,sizeof(fd->fd_productID));
						CopyMem(&ad->ad_buf[32],fd->fd_revision,sizeof(fd->fd_revision));
					}
					else
					{
						/* Don't want users trying to format scanners and the like */
						/* WARNING: doing continue instead of progressing to end of loop */
						Remove((struct Node *)fd);
						fd_Delete(fd);
						continue;
					}
				}
				else
				{
					/* Error condition on Inquiry() */
				}


				if ( !(err = FlyerDriveInfo(&ad->ad_fv,&fd->fd_fvi)) )
				{
				}

				if ( TRUE )
				{
					UBYTE				old_flags = ad->ad_fv.Flags;

					ad->ad_fv.Flags |= FVF_USENUMS;

					/* Error condition on FlyerDriveInfo() */

					err = ReadSize(&ad->ad_fv,&fd->fd_blocks,&fd->fd_blocksize);

					ad->ad_fv.Flags = old_flags;
				}
			}

			/* This is a flyer filesystem drive */
			if ( (fd->fd_fvi.Ident == 0x524f4f54) && (fd->fd_fvi.Version == 1) )
			{
				volumename = fd->fd_fvi.Title;

				fd->fd_flags |= FDF_FLYERFS;

				if (fd->fd_fvi.Flags & FVIF_VIDEOREADY)
				{
					if (fd->fd_fvi.Flags & FVIF_AUDIOREADY)
						driveattrs = "Video/Audio";
					else
						driveattrs = "Video Only";
				}
				else if (fd->fd_fvi.Flags & FVIF_AUDIOREADY)
				{
					driveattrs = "Audio Only";
				}
				else
				{
					if (fd->fd_fvi.Flags & FVIF_WRITEPROT)
						driveattrs = "Read Only";
					else
						driveattrs = "";
				}
			}
			else
			{
				volumename = "";
				driveattrs = "Not Flyer-FS";
			}

			/* Print drive information to node's name buffer in listview */

			sprintf( fd->fd_namebuf,

				"SCSI: %1lc ID: %1ld - %-8.8s%-16.16s%-4.4s %-12.12s \"%s\"",

					(long)('A' + (fd->fd_driveID >> 3)),
					(long)(fd->fd_driveID & 0x07),
					fd->fd_vendor, fd->fd_productID, fd->fd_revision,
					driveattrs, volumename );

			/* Can we modify the cache params? */
			/* if ( fd->fd_flags & FDF_FLYERFS ) */
			{
				struct Manuf	*man;

				for ( man=&Manufs[0];man->manufname;man++ )
				{
					/* Match of Manufacturer name? */
					if ( !strnicmp(man->manufname,fd->fd_vendor,strlen(man->manufname)) )
					{
						/* Match of Model name? */
						if ( !strnicmp(man->modelname,fd->fd_productID,strlen(man->modelname)) )
						{

#ifdef CHECK_FIRMWARE_REVISIONS
							if ( strlen(man->revision) )
							{
								/* If a revision string specified, and they
								 * are identical, otherwise skip it.
								 */

								if ( !strnicmp(man->revision,fd->fd_revision,strlen(man->revision)) )
								{
									break;
								}
							}
							else
#endif
							{
								/* No revision string specified, model number
								 * is good enough for the cache params.
								 */
								break;
							}
						}
					}
				}

				/* This drive may have its cache params set */
				if ( man->manufname )
				{
					fd->fd_manuf = man;
					fd->fd_flags |= FDF_CAN_CHANGE_CACHE;
				}
			}
		}
	}

	ClearWait(ad->ad_win);

	return(err);
}

static LONG ad_FormatFlyerDrive( struct AppData *ad, struct _FlyDevice *fd )
{
	LONG					err = 0;
	char					*volname;
	BOOL					ok = FALSE;
	UBYTE					fvi_flags;

	/* Default format flags */
	fvi_flags = FVIF_VIDEOREADY | FVIF_AUDIOREADY;

	if ( fd->fd_flags & FDF_FLYERFS )
	{
		/* Drive Already formatted with Flyer-FS */
		/* Ask user if it's OK to trash it */

		ULONG	iflags = NULL;

		struct EasyStruct	es = {
			sizeof (struct EasyStruct),
			0,

			"Format Flyer Drive",

			"Volume \"%s\" is already a Flyer formatted\n"
			"partition.  Reformatting will cause all data\n"
			"on this drive to be lost!",

			"O.K., I understand|Cancel",
			};

		volname = fd->fd_fvi.Title;

		if ( EasyRequest(ad->ad_win,&es,&iflags,volname) )
		{
			ok = TRUE;
		}
	}
	else
	{
		/* Drive Already formatted with Flyer-FS */
		/* Ask user if it's OK to trash it */

		ULONG	iflags = NULL;
		char	ch[2];

		struct EasyStruct	es = {
			sizeof (struct EasyStruct),
			0,

			"Format Flyer Drive",

			"This will format the drive on Channel %ld, ID %ld to\n"
			"the volume name \"%s\". Reformatting will cause\n"
			"all data on this drive to be lost!",

			"O.K., I understand|Cancel",
			};

		ch[1] = '\0';
		volname = ad->ad_volname;

		strcpy(volname,"Flyer");
		ch[0] = 'A' + (fd->fd_driveID >> 3);
		strcat(volname,ch);
		ch[0] = '0' + (fd->fd_driveID & 0x07);
		strcat(volname,ch);

		if ( EasyRequest(ad->ad_win,&es,&iflags,
					(long)(fd->fd_driveID >> 3),
					(long)(fd->fd_driveID & 0x07),
					volname) )
		{
			ok = TRUE;
		}
	}

	if ( ok )
	{
		/* Ask if we want to format the drive as an Audio only drive */

		ULONG	iflags = NULL;

		struct EasyStruct	es = {
			sizeof (struct EasyStruct),
			0,

			"Format Flyer Drive",

			"Choose how you would like Volume\n"
			"\"%s\" to be formatted.  At least\n"
			"one drive on a flyer system must\n"
			"be formatted as Audio Only.\n",

			"Audio Only|Audio/Video",
			};

		if ( EasyRequest(ad->ad_win,&es,&iflags,volname) )
		{
			fvi_flags &= ~FVIF_VIDEOREADY;
		}
		else
		{
			if ( ad->ad_key == APP_FAST_VIDEO_KEY && ad->ad_percent )
			{
				struct EasyStruct	ees = {
					sizeof (struct EasyStruct),
					0,

					"Format a percentage of the drive",

					"You have chosen to format %ld.%01ld percent\n"
					"of Volume \"%s\". Is this correct?\n",

					"Format Percent of Drive|Format Entire Drive",
					};

				iflags = NULL;

				if ( EasyRequest(ad->ad_win,&ees,&iflags,
						ad->ad_percent / 10,
						ad->ad_percent % 10,
						volname) )
				{
				}
				else
				{
					ad->ad_percent = 0;
				}
			}
		}
	}

	if ( ok )
	{
		struct DateStamp	now;

		/* Talking to the drive for this flydevice */
		ad->ad_fv.SCSIdrive = fd->fd_driveID;

		/* Get date/time (pass to Flyer as volume creation date) */
		DateStamp(&now);

		printf("Re-Setting Drive Cache Parameters\n");
		err = ad_SetCacheParams(ad,fd);

		if (err)
		{
			printf("Error %ld - %ls\n",err,Error2String(err));
		}

		SetWait(ad->ad_win);

		if ( FlyerBase )
		{
			ULONG				blocks = 0;

			if ( fd->fd_manuf )
				blocks = fd->fd_manuf->blocks;

			if ( ad->ad_key == APP_FAST_VIDEO_KEY && ad->ad_percent )
			{
				// Compute percentage of drive to format with fast video rates

#ifdef ROUNDING_ERRORS
				blocks = (fd->fd_blocks * ad->ad_percent) / 1000;
#else
				/* Divide by 1000 first, this means the drive will
				 *	be formatted in 1000-block increments.
				 */
				blocks = (fd->fd_blocks / 1000) * ad->ad_percent;
#endif

				if ( blocks > fd->fd_blocks )
					blocks = fd->fd_blocks;

				// fvi_flags |= FVIF_FAST_VIDEO;
			}

			err = FlyerFormat(&ad->ad_fv,volname,&now,blocks,fvi_flags);

			/*
				printf("Would've called FlyerFormat(%ld,\"%s\",%ld,%02lx)\n",
					fd->fd_driveID,volname,blocks,fvi_flags );
			*/
		}

		GT_SetGadgetAttrs(ad->ad_drivegad,ad->ad_win,NULL,
			GTLV_Labels,		NULL,
			TAG_DONE );

		ad_SelectDeviceNode(ad,-1);

		scan_flyerdrives(ad);

		GT_SetGadgetAttrs(ad->ad_drivegad,ad->ad_win,NULL,
			GTLV_Labels,		&ad->ad_devlist,
			TAG_DONE );

		ClearWait(ad->ad_win);

	}

	return(err);
}

#ifdef LATER
static LONG ad_SetModePageDefaults( struct AppData *ad, struct _FlyDevice *fd )
{
	unsigned char	*pp = SafeDefaultPages;
	LONG				 err = 0;

	SetWait(ad->ad_win);

	/* Talking to the drive for this flydevice */
	ad->ad_fv.SCSIdrive = fd->fd_driveID;

	while ( *pp != 0xFF )
	{
		UBYTE	pagelen;
		UBYTE	*pagebuffer;

		/* Get length of Default Mode Page */
		err = ModeSense(&ad->ad_fv,1,*pp | 0x80,&pagelen);

		if (err)
			printf("ModeSense1 Error %ld - %ls\n",err,Error2String(err));

		pagelen++;			/* Total length of data phase */

		if (pagelen > 255)
		{
			printf("Error - page length too long\n");
			return(err);
		}

		/* Read Page's Default settings */
		err = ModeSense(&ad->ad_fv,pagelen,*pp | 0x80,ad->ad_buf);

		if (err)
			printf("ModeSense2 Error %ld - %ls\n",err,Error2String(err));
		else
		{
			ad->ad_buf[0] = 0;

			pagebuffer = &ad->ad_buf[4];

			/* Drive returned block descriptor? */
			if ( ad->ad_buf[3] )
			{
				int	i;

				/* Strip it out if so */
				ad->ad_buf[3] = 0;
				for (i=12;i<pagelen;i++)
					ad->ad_buf[i-8] = ad->ad_buf[i];
				pagelen -= 8;
			}

			pagebuffer[0] &= 0x7F;		/* Strip off PS bit before sending back */
			pagebuffer[2] &= 0x3F;		/* Setting Current values */

			/* Send updated page back to drive */
			err = ModeSelect(&ad->ad_fv,pagelen,ad->ad_buf,0x11);			//PF=1, SP=1

			if (err) {
				err = ModeSelect(&ad->ad_fv,pagelen,ad->ad_buf,0x01);		//PF=0, SP=1
				if (err)
					printf("ModeSelect Error %ld - %ls\n",err,Error2String(err));
			}
			else
			{
				printf("Set Page %02lx to default values\n",(long) *pp);
			}
		}

		pp++;
	}

	ClearWait(ad->ad_win);

	return(err);
}
#endif

static LONG ad_SetCacheParams( struct AppData *ad, struct _FlyDevice *fd )
{
	LONG				 err = 0;
	struct Manuf	*man;

	SetWait(ad->ad_win);

	/* Talking to the drive for this flydevice */
	ad->ad_fv.SCSIdrive = fd->fd_driveID;

	if ( man = fd->fd_manuf )
	{
		struct Options	*opt;

		for ( opt = man->options; opt->optname; opt++ )
		{
			printf("ChangeItem(%ld): \"%s\" Pg:%ld, Pos:%ld, Flg: %01ld, Val:%lx\n",
				ad->ad_fv.SCSIdrive,
				opt->optname, opt->page, opt->pos, opt->flag, opt->value );
			ChangeItem(ad,opt);
		}
	}
	else
	{
		printf("Error, unsupported drive/model [%-8.8s] [%-16.16s]\n",fd->fd_vendor,fd->fd_productID);
//		printf("Supported drives:\n");
//		for (man=&Manufs[0];man->manufname;man++)
//			printf("   [%ls] [%ls] [%ls]\n",
//				man->manufname,man->modelname,man->revision);
	}

	ClearWait(ad->ad_win);

	return(err);
}

static ULONG ChangeItem( struct AppData *ad, struct Options *optptr )
{
	UBYTE	*pagebuffer;
	ULONG	err;
	UBYTE	pagelen;

	/* Get length of Mode Page */
	err = ModeSense(&ad->ad_fv,1,optptr->page,&pagelen);

	if (err)
		printf("ModeSense1 Error %ld - %ls\n",err,Error2String(err));

	pagelen++;			/* Total length of data phase */

	if (pagelen > 255)
	{
		printf("Error - page length too long\n");
		return(err);
	}

	/* Read Page's current settings */
	err = ModeSense(&ad->ad_fv,pagelen,optptr->page,ad->ad_buf);

	if (err)
		printf("ModeSense2 Error %ld - %ls\n",err,Error2String(err));
	else
	{
		ad->ad_buf[0] = 0;

		pagebuffer = &ad->ad_buf[4];

		/* Drive returned block descriptor? */
		if ( ad->ad_buf[3] )
		{
			int	i;

			/* Strip it out if so */
			ad->ad_buf[3] = 0;
			for (i=12;i<pagelen;i++)
				ad->ad_buf[i-8] = ad->ad_buf[i];
			pagelen -= 8;
		}

		/* Is the item to change a single bit? */
		if ( optptr->flag )
		{
			if ( optptr->value == 1 )
				pagebuffer[optptr->pos] |= optptr->flag;		/* Set it */
			else if ( optptr->value == 0 )
				pagebuffer[optptr->pos] &= (~optptr->flag);	/* Clr it */
		}
		else /* Item to change is a byte */
		{
			if ( optptr->value >=0 )
				pagebuffer[optptr->pos] = optptr->value;
			else
			{
				printf("%ls is currently %lx",
					optptr->optname,pagebuffer[optptr->pos]);
			}
		}

		pagebuffer[0] &= 0x7F;		/* Strip off PS bit before sending back */

		/* Send updated page back to drive */
		err = ModeSelect(&ad->ad_fv,pagelen,ad->ad_buf,0x11);			//PF=1, SP=1
		if (err) {
			err = ModeSelect(&ad->ad_fv,pagelen,ad->ad_buf,0x01);		//PF=0, SP=1
			if (err)
				printf("ModeSelect Error %ld - %ls\n",err,Error2String(err));
		}
		else
			printf("Done\n");
	}

	return(err);
}

static LONG ad_OpenInterface( struct AppData *ad )
{
	LONG			result = 0;

	if ( ad->ad_scr = LockPubScreen(NULL) )
	{
		if ( ad->ad_vi = GetVisualInfo(ad->ad_scr,TAG_END) )
		{
			if ( ad_CreateGadgetList(ad) )
			{
				if ( ad->ad_win = OpenWindowTags(NULL,
						WA_Title,			APP_TITLE,
						WA_Left,				0,
						WA_Top,				0,
						WA_InnerWidth,		APPWIN_INNERWIDTH,
						WA_InnerHeight,	APPWIN_INNERHEIGHT,

						WA_Gadgets,			ad->ad_glist,

						WA_Flags,			MY_WINFLAGS,
						WA_SmartRefresh,	TRUE,
						WA_IDCMP,			MY_IDCMP,

						TAG_DONE) )
				{
					/* We've got it open!! */
					result = TRUE;
				}
			}
		}
	}

	if ( !result )
		ad_CloseInterface(ad);

	return(result);
}

static void ad_CloseInterface( struct AppData *ad )
{
	if ( ad->ad_win )
	{
		CloseWindow(ad->ad_win);
		ad->ad_win = NULL;
	}

	if ( ad->ad_glist )
	{
		FreeGadgets(ad->ad_glist);
		ad->ad_glist = NULL;
	}

	if ( ad->ad_vi )
	{
		FreeVisualInfo(ad->ad_vi);
		ad->ad_vi = NULL;
	}

	if ( ad->ad_scr )
	{
		UnlockPubScreen(NULL,ad->ad_scr);
		ad->ad_scr = NULL;
	}
}

static void ad_SelectDeviceNode( struct AppData *ad, LONG nodenum )
{
	LONG			format_disable = TRUE;
	LONG			cache_disable = TRUE;

	if ( ad->ad_last_fd = (struct _FlyDevice *)
			GetNodeNum(&ad->ad_devlist,nodenum) )
	{
		format_disable = FALSE;

		if ( ad->ad_last_fd->fd_flags & FDF_CAN_CHANGE_CACHE )
		{
			cache_disable = FALSE;
		}
	}

	GT_SetGadgetAttrs(ad->ad_formatgad,ad->ad_win,NULL,
		GA_Disabled,		format_disable,
		TAG_DONE );

	GT_SetGadgetAttrs(ad->ad_cachegad,ad->ad_win,NULL,
		GA_Disabled,		cache_disable,
		TAG_DONE );

}

static LONG ad_CreateGadgetList( struct AppData *ad )
{
	LONG						 retval = FALSE;
	struct Gadget			*gad;
	struct NewGadget		 ng;

	gad = CreateContext(&ad->ad_glist);

	ng.ng_VisualInfo	= ad->ad_vi;
	ng.ng_TextAttr		= &Topaz80;

	ng.ng_LeftEdge	= DRIVELIST_LEFT;
	ng.ng_TopEdge	= DRIVELIST_TOP + ad->ad_scr->WBorTop + 14;
	ng.ng_Width		= DRIVELIST_WIDTH;
	ng.ng_Height	= DRIVELIST_HEIGHT;

	ng.ng_GadgetText	= "Drives on Flyer SCSI Bus";
	ng.ng_GadgetID		= APPGAD_DRIVELIST;
	ng.ng_Flags			= PLACETEXT_ABOVE;

	/* Allocate listview gadget (for drives) */
	gad = CreateGadget(LISTVIEW_KIND,gad,&ng,
				/* GTLV_Labels,		&ad->ad_devlist, */
				GTLV_ShowSelected,	NULL,
				TAG_DONE);

	ad->ad_drivegad = gad;

	/* Re-scan gadget */

	ng.ng_TopEdge		+= (ng.ng_Height + 2);
	ng.ng_Width			= BUTTON_WIDTH;
	ng.ng_Height		= 12;

	ng.ng_GadgetText	= "Re-scan Drives";
	ng.ng_GadgetID		= APPGAD_RESCAN;
	ng.ng_Flags			= PLACETEXT_IN;

	gad = CreateGadget(BUTTON_KIND,gad,&ng,
				TAG_DONE);

	/* Format drive gadget */

	ng.ng_LeftEdge		+= (ng.ng_Width + 9);
	ng.ng_GadgetText	= "Format Drive";
	ng.ng_GadgetID		= APPGAD_FORMAT;

	gad = CreateGadget(BUTTON_KIND,gad,&ng,
				GA_Disabled,			TRUE,
				TAG_DONE);

	ad->ad_formatgad = gad;

	/* Set Cache params gadget */

	ng.ng_LeftEdge		+= (ng.ng_Width + 9);
	ng.ng_GadgetText	= "Set Drive Cache";
	ng.ng_GadgetID		= APPGAD_SETCACHE;

	gad = CreateGadget(BUTTON_KIND,gad,&ng,
				GA_Disabled,			TRUE,
				TAG_DONE);

	ad->ad_cachegad = gad;

	if ( gad )
		retval = TRUE;

	return(retval);
}

static struct AppData *ad_Create()
{
	struct AppData *ad;

	if ( ad = (struct AppData *)AllocMem(sizeof(*ad),MEMF_PUBLIC|MEMF_CLEAR) )
	{
		NewList((struct List *)&ad->ad_devlist);
	}

	return(ad);
}

static void ad_Delete( struct AppData *ad )
{
	struct _FlyDevice *fd;

	while ( fd = (struct _FlyDevice *)RemTail((struct List *)&ad->ad_devlist) )
	{
		fd_Delete(fd);
	}

	FreeMem(ad,sizeof(*ad));
}

static struct _FlyDevice *fd_Create()
{
	struct _FlyDevice *fd;

	if ( fd = (struct _FlyDevice *)AllocMem(sizeof(*fd),MEMF_PUBLIC|MEMF_CLEAR) )
	{
		/* Have node name point into the structure */
		fd->fd_Node.ln_Name = fd->fd_namebuf;
		fd->fd_fvi.len = sizeof(fd->fd_fvi);
	}

	return(fd);
}

static void fd_Delete( struct _FlyDevice *fd )
{
	FreeMem(fd,sizeof(*fd));
}

static struct Node *GetNodeNum( struct MinList *l, LONG nodenum )
{
	struct Node *node = (struct Node *)l->mlh_Head;

	while ( node->ln_Succ )
	{
		if ( !nodenum-- )
			break;

		node = node->ln_Succ;
	}

	if ( !node->ln_Succ )
		node = NULL;

	return(node);
}
