**********************************************************************
*
* flyer.library - Toaster support functions
*
* $Id: flyerlibToast.asm,v 1.0 1995/05/05 15:47:59 Flick Exp $
*
* $Log: flyerlibToast.asm,v $
*Revision 1.0  1995/05/05  15:47:59  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* 01/12/95	Marty	created
**********************************************************************
* Toaster control routines
**********************************************************************

	include "exec/types.i"
	include "exec/nodes.i"
	include "exec/lists.i"
	include "exec/libraries.i"
	include "macros.i"
	include "Flyer.i"
	include "FlyerPrivate.i"
	include "tsrc:switcher/inc/instinct.i"
	include "serialdebug.i"

******* Exported *******************************************************

	XDEF	HideFlyer,RestoreFlyer


******* Imported *******************************************************

	IFNE	SERDEBUG
	XREF	DB_DUMP_HEXI
	ENDC

*********************************************************************
* OpenToastBase -- Open ToasterBase library
*
* Entry:
*	a6:Flyerbase (library)
*
* Exit:
*	d0: Base or NULL
*********************************************************************
ToastBaseName:	dc.b	'ToasterBase',0

OpenToastBase
	move.l	a6,-(sp)
	move.l	4.w,a6				;Get execbase
	moveq.l	#0,d0
	lea.l		ToastBaseName(pc),a1
	XSYS		OpenLibrary
	move.l	(sp)+,a6
	rts


*********************************************************************
* CloseToastBase -- Close ToasterBase library
*
* Entry:
*	a0:ToasterBase (library)
*
* Exit:
*********************************************************************
CloseToastBase
	cmp.w		#0,a0
	beq.s		.nolib
	movem.l	a1/a6,-(sp)
	move.l	4.w,a6				;Get execbase
	move.l	a0,a1
	XSYS		CloseLibrary
	movem.l	(sp)+,a1/a6
.nolib
	rts


*********************************************************************
* HideFlyer -- Hide Flyer outputs from outside world
*
* Entry:
*	a6:Flyerbase (library)
*
* Exit:
*********************************************************************
HideFlyer
	IFD	DEBUGTOAST
	DUMPMSG <Hide!>
	ENDC
	movem.l	a0/a5/d0,-(sp)
	bsr	OpenToastBase
	IFD	DEBUGTOAST
	DUMPHEXI.L <ToastBase:>,d0,<\>
	ENDC

	tst.l	d0
	beq	.exit
	move.l	d0,a5			;-> ToasterBase

****** Here begins Toaster access

	clr.b	FlyerShowing

	DEA.l	TB_VTSetUp,a0
;	lea.l	TB_VTSetUp(a5),a0

	ELHGET_AM	a0,d0			;Get AM
	move.w	d0,StashAM

	IFD	DEBUGTOAST
	DUMPHEXI.W <AM:>,d0,<\>
	ENDC

	cmpi.w		#VTI_AM_VID3,d0
	beq.s		.on_AM
	cmpi.w		#VTI_AM_VID4,d0
	beq.s		.on_AM
	tst.w		TB_VideoFlagSec(a5)
	bne.s		.none_on_AM		;jump if Frozen
	cmpi.w		#VTI_AM_DAC0,d0
	bne.s		.none_on_AM		;not showing live DVE
	ELHGET_IS	a0,d0
	cmpi.w		#VTI_IS_VID3,d0
	beq.s		.on_AM
	cmpi.w		#VTI_IS_VID4,d0
	bne.s		.none_on_AM

.on_AM
	move.b	#1,FlyerShowing
	ELHPUT_AM_I	a0,VTI_AM_ENCODER	;Display encoder

.none_on_AM
	ELHGET_BM	a0,d0			;Get BM
	move.w	d0,StashBM

	IFD	DEBUGTOAST
	DUMPHEXI.W <BM:>,d0,<\>
	ENDC

	cmpi.w		#VTI_BM_VID3,d0
	beq.s		.on_BM
	cmpi.w		#VTI_BM_VID4,d0
	beq.s		.on_BM
	tst.w		TB_VideoFlagSec(a5)
	bne.s		.none_on_BM		;jump if Frozen
	cmpi.w		#VTI_BM_DAC0,d0
	bne.s		.none_on_BM		;not showing live DVE
	ELHGET_IS	a0,d0
	cmpi.w		#VTI_IS_VID3,d0
	beq.s		.on_BM
	cmpi.w		#VTI_IS_VID4,d0
	bne.s		.none_on_BM

.on_BM
	move.b	#1,FlyerShowing
	ELHPUT_BM_I	a0,VTI_BM_ENCODER	;Display encoder

.none_on_BM
	tst.b	FlyerShowing
	beq	.need_no_matte

	clr.w	StashMatte

* Don't change encoder to black if it's currently shown
	GET.w	TB_MainSec,d0
;	move.w	TB_MainSec(a5),d0
	IFD	DEBUGTOAST
	DUMPHEXI.W <MainSec:>,d0,<\>
	ENDC
	btst	#B_ENCODER,d0
	bne	.gotmatte

	GET.w	TB_OLaySec,d0
;	move.w	TB_OLaySec(a5),d0
	IFD	DEBUGTOAST
	DUMPHEXI.W <OLaySec:>,d0,<\>
	ENDC
	btst	#B_ENCODER,d0
	bne	.gotmatte

	GET.w	TB_ToastBGC,d0
;	move.w	TB_ToastBGC(a5),d0
	move.w	d0,StashMatte

	IFD	DEBUGTOAST
	DUMPHEXI.W <Matte:>,d0,<\>
	ENDC

	tst.w	d0
	beq.s	.gotmatte			;jump if already black
	moveq	#0,d0				;black
	CALLTL	SetMatteColor

.gotmatte
	IFD	DEBUGTOAST
	DUMPMSG <SendELH2>
	ENDC
	CALLTL	SendELH2Toaster

	bsr	BigDelay

.need_no_matte

***** End of Toaster functions

	move.l	a5,a0
	bsr	CloseToastBase
.exit
	movem.l	(sp)+,a0/a5/d0
	rts



*********************************************************************
* RestoreFlyer -- Restore Toaster outputs
*
* Entry:
*	a6:Flyerbase (library)
*
* Exit:
*********************************************************************
RestoreFlyer
	movem.l	a0/a5/d0,-(sp)

	tst.b	FlyerShowing		;Need to restore?
	beq.s	.exit

	bsr	BigDelay

	bsr	OpenToastBase
	tst.l	d0
	beq	.exit
	move.l	d0,a5			;-> ToasterBase

****** Here begins Toaster access

	move.w		StashMatte,d0
	beq.s		.wasblack		;jump if originally it was black
	CALLTL		SetMatteColor

.wasblack
	lea.l		TB_VTSetUp(a5),a0
	move.w		StashAM,d0
	ELHPUT_AM_R	a0,d0
	move.w		StashBM,d0
	ELHPUT_BM_R	a0,d0

	CALLTL		SendELH2Toaster

***** End of Toaster functions

	move.l	a5,a0
	bsr	CloseToastBase
.exit
	movem.l	(sp)+,a0/a5/d0
	rts



***************************************
BigDelay
	IFD	DEBUGTOAST
	DUMPMSG <D1>
	ENDC
	move.l	#200000,d0
.delay
	nop
	subq.l	#1,d0
	bne.s	.delay

	IFD	DEBUGTOAST
	DUMPMSG <D2>
	ENDC
	rts

*--------------------------------------------
StashAM		dc.w	0
StashBM		dc.w	0	
StashMatte 	dc.w	0
FlyerShowing	dc.b	0
