/********************************************************************
* $Grazer.c - EditWindow for looking at AmigaDOS hierarchy$
* $Id: grazer.c,v 2.77 1996/02/15 11:38:39 Holt Exp $
* $Log: grazer.c,v $
*Revision 2.77  1996/02/15  11:38:39  Holt
*added es_take support
*
*Revision 2.76  1995/10/14  10:14:44  Flick
*Removed DTM_RefreshTabs which was crashing when transitioning from project
*view to files/files view
*
*Revision 2.75  1995/10/02  15:17:08  Flick
*Added POPUP_TOOLS to button row
*
*Revision 2.74  1995/09/25  12:16:41  Flick
*Added (but don't use) "qualifiers" to GrazerDropped()
*
*Revision 2.73  1995/08/18  16:42:57  Flick
*Slight changes for maintaining running time
*
*Revision 2.72  1995/08/09  17:52:56  Flick
*Had to add arg for new NiceCopy()
*
*Revision 2.71  1995/07/27  18:14:29  Flick
*Added support for Drive Info panel
*
*Revision 2.70  1995/06/01  09:37:19  pfrench
*Fixed Drive Move code
*
*Revision 2.69  1995/02/24  16:50:19  CACHELIN4000
*Process ARexx script double clicks instead of passing to switcher
*
*Revision 2.68  1995/01/31  18:48:07  pfrench
*Hacked to call a restore if fly_tape device is double-clicked
*
*Revision 2.67  1995/01/13  12:23:23  CACHELIN4000
*Comment out type check before allowing nodes to get double clicks
*
*Revision 2.66  1995/01/12  14:04:57  CACHELIN4000
*add PLAY_PART button
*
*Revision 2.65  1994/12/31  07:05:37  pfrench
*Now voiding project length on handle panel
*
*Revision 2.64  1994/12/31  00:36:26  pfrench
*Corrected potential problem with copying files from nearly
*equal flyer volume names.
*
*Revision 2.63  1994/12/30  20:45:43  pfrench
*Possibly fixed "New folder" redraw bug
*
*Revision 2.62  1994/12/21  21:31:16  pfrench
*Hopefully final tweaking of grid position
*
*Revision 2.61  1994/12/21  20:05:27  pfrench
*Added Directory tabs support.
*
*Revision 2.60  1994/12/20  16:11:24  pfrench
*Now files are moved if copied to same drive
*
*Revision 2.59  1994/12/17  17:48:59  pfrench
*Added flyer/flyer copy.  still some bugs in the flyer.library
*copyclip() function, copies all files to board0/scsi0/drive0
*
*Revision 2.58  1994/12/07  15:55:08  pfrench
*Removed grazerrequest dependencies. functionality is now
*more centralized in graphichelp
*
*Revision 2.57  1994/12/05  14:00:22  pfrench
*Added support for moving to project save directory
*
*Revision 2.56  1994/11/29  14:45:29  CACHELIN4000
**** empty log message ***
*
*Revision 2.55  1994/11/16  01:06:29  CACHELIN4000
*Enable double-click on arexx macros, don't try for default icon on dirs!!!
*
*Revision 2.54  1994/11/12  17:33:54  CACHELIN4000
*LoadNodeImage() now gets default croutons for devices/volumes
*
*Revision 2.53  1994/11/09  12:47:10  pfrench
*Added initial support for proof.lib
*
*Revision 2.52  1994/11/04  16:28:35  CACHELIN4000
*Move DoAllNewDir outside of DoInfoPanel to fix hit on Rename
*
*Revision 2.51  94/10/28  11:58:03  CACHELIN4000
*SHow dir, volume icons...
*
*Revision 2.50  94/10/18  18:03:05  CACHELIN4000
*Add Icon Image for dir.s, text
*
*Revision 2.49  94/10/11  16:57:41  CACHELIN4000
*Add Flags to ES_LoadCrouton fro Project vs. Grazer loading
*
*Revision 2.48  94/10/01  13:15:22  Kell
**** empty log message ***
*
*Revision 2.47  1994/09/27  20:00:15  pfrench
*Needed to add POP_VIEWS ID
*
*Revision 2.46  1994/09/27  16:24:05  pfrench
*Removed all calls to FreeDirCache as it is being
*handled automatically now.
*
*Revision 2.45  1994/09/20  22:48:23  pfrench
*Many modifications to work with directory cacheing
*
*Revision 2.44  1994/08/30  10:40:31  Kell
*Changed SendSwitcherReply calls to work with new ESParams structures.
*
*Revision 2.43  1994/08/27  17:54:15  CACHELIN4000
*Add NewClip, Play,Stop in Arrange f'n
*
*Revision 2.42  94/08/25  18:37:53  pfrench
*Now sends volume-resolved fastgadget path on double-click
*
*Revision 2.41  1994/08/24  12:07:53  CACHELIN4000
*Add clip recognition to GrazerDouble
*
*Revision 2.40  94/08/01  15:59:23  pfrench
*Moved proto to where it could be seen.
*
*Revision 2.39  1994/08/01  15:56:25  pfrench
*Now filters out un-requested file types so they don't get
*added to the grazer's list.
*
*Revision 2.38  1994/07/31  14:42:58  pfrench
*Removed one un-used function proto.
*
*Revision 2.37  1994/07/28  18:20:47  pfrench
*Added ifdef'd out code that right-aligned the pathname in
*it's gadget.
*
*Revision 2.36  1994/07/27  16:49:32  pfrench
*Removed "New Project" button from grazer.  Stretched out
*pathname to use the new space.
*
*Revision 2.35  1994/07/25  10:45:40  pfrench
*Moved GrazerDouble functionality into drag.c
*
*Revision 2.34  1994/07/21  18:55:40  pfrench
*Enabled double click of requested file types.
*
*Revision 2.33  1994/07/04  18:33:34  CACHELIN4000
**** empty log message ***
*
*Revision 2.32  94/06/21  16:15:34  CACHELIN4000
**** empty log message ***
*
*Revision 2.31  94/06/07  15:18:09  CACHELIN4000
**** empty log message ***
*
*Revision 2.30  94/04/23  17:45:08  CACHELIN4000
**** empty log message ***
*
*Revision 2.29  94/04/20  17:33:25  CACHELIN4000
*Move DoInfoPanel stuff to Panel.c
*
*Revision 2.28  94/03/18  21:12:33  CACHELIN4000
*DoAllNewDir() only does EW_GRAZER types (Project save enforcer hit(??)}
*
*Revision 2.27  94/03/17  09:53:25  Kell
**** empty log message ***
*
*Revision 2.26  94/03/16  18:13:02  CACHELIN4000
**** empty log message ***
*
*Revision 2.25  94/03/16  16:12:21  CACHELIN4000
**** empty log message ***
*
*Revision 2.24  94/03/15  14:57:56  Kell
**** empty log message ***
*
*Revision 2.23  94/03/15  12:18:41  CACHELIN4000
**** empty log message ***
*
*Revision 2.22  94/03/14  21:56:24  CACHELIN4000
**** empty log message ***
*
*Revision 2.21  94/03/14  11:54:25  CACHELIN4000
*Enable EN_DOUBLE_ACTION on Types in LoadNodeImage()
*
*Revision 2.20  94/03/14  00:30:39  CACHELIN4000
**** empty log message ***
*
*Revision 2.16  94/03/11  09:32:13  Kell
*
*Revision 2.12  94/03/07  22:49:13  Kell
*Preventing the ExamineCrouton functions from fill in needless fields.
*
*Revision 2.11  94/03/07  22:36:23  Kell
*Re-enabled the ExamineCrouton.... calls.
*
*Revision 2.10  94/03/07  20:55:19  CACHELIN4000
**** empty log message ***
*
*Revision 2.9  94/03/07  17:50:22  Kell
*Fixed ExamineCrouton calls to look at the returned results
*
*Revision 2.8  94/03/07  11:06:44  Kell
**** empty log message ***
*
*Revision 2.4  94/02/27  18:35:35  CACHELIN4000
*Added FileType() checking to LoadNodeImage()
*
*Revision 2.0  94/02/17  16:23:57  Kell
*FirstCheckIn
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*	12-1-92		Steve H		Last Update
*	12-17-92	Steve H		Convert to use SmartStrings
*	10-15-93	Steve H		Last Update
*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <dos/dos.h>
#include <iffp/ilbm.h>

#include <stdio.h>
#include <string.h>
#include <crouton_all.h>
#include <dos.h>
#include <time.h>

#ifndef PROOF_LIB_H
#include <proof_lib.h>
#endif

#include "dirtabs.h"
#include "croutongrid.h"

#include <editwindow.h>
#include <grazer.h>
#include <gadgets.h>
#include <filelist.h>
#include <doshelp.h>
#include <prophelp.h>
#include <request.h>
#include <project.h>
#include <editswit.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>

#include <filetypes.p>

#ifndef PROTO_PASS
#include <proto.h>
#else

extern APTR GrazerParent,GrazerDouble,GrazerRoot,GrazerChooseRoot,
	GrazerNewFolder,
	GrazerDelete,GrazerAll,GrazerDuplicate;
BOOL OpenEditWindow(struct EditWindow * );
BOOL RenderEditWindow(struct EditWindow * , BOOL );
void CloseEditWindow(struct EditWindow * );
#endif

extern LONG IsRequestedFileType( struct EditNode *Node );
extern LONG RebuildGrazerGrid( struct EditWindow *Edit );

/****************************************/
#define SERDEBUG	1
#include <serialdebug.h>

#define TYPE_DB YA("DoInfoPanel")
/****************************************/

VOID __asm LoadBM(register __d0 char Name[],
    register __d1 LONG Flags,register __a0 struct BitMap *BM);
extern far UWORD BMWidth,BMHeight;  // Kludgey side-effects of LoadBM
extern far UBYTE BMColor[],BMDepth;

extern struct Library *ProofBase;
extern char filepathbuf[300];
extern char destfilepathbuf[300];
extern struct SmartString *TopPath,*BottomPath;
extern struct Gadget Gadget1,*FT_Gadget1,*GRZ_Gadget1;
extern WORD GrazerLayout;
extern struct EditWindow *EditTop,*EditBottom;
extern struct TextExtent LastExtent;
extern UBYTE *TempMem,*TempMem2,IntDepth,*ProjectName;
extern char TempCh[],TempC2[],*DTNames[];
extern struct List WindowList;
extern struct MsgPort *SwitPort;
extern ULONG CRuDTypes[];

extern struct ESParams1 ESparams1;
extern struct ESParams2 ESparams2;

VOID DisplayWaitSprite(VOID);
VOID DisplayNormalSprite(VOID);

VOID __asm CopyCrut(
	register __a0 struct BitMap *SrcBM,
	register __a1 struct BitMap *DstBM,
	register __d0 WORD DestX,
	register __d1 WORD DestY,
	register __d2 WORD Height);

#define	LAST_ID_IN_LISTS		ID_NEW_FOLDER

static UWORD TopIDS[] = {
	ID_UP,ID_DOWN,ID_CLOSE,ID_KNOB,ID_GRID,
	ID_VCR_PLAY,ID_PLAY_PART,ID_REQ_STOP,ID_CONTROLS,ID_NEW_CLIP,
	ID_ALL,ID_DELETE,ID_DUPLICATE,ID_GHOST_SAVE_PROJ,ID_POPUP_PROGRAMS,ID_POPUP_VIEWS,
	ID_POPUP_TOOLS,ID_PATH,ID_CHOOSE_ROOT,ID_NEW_FOLDER,
	ID_END_OF_LIST
};

static UWORD BottomIDS[] = {
	ID_UP,ID_DOWN,ID_CLOSE,ID_KNOB,ID_GRID,ID_NEW_CLIP,
	ID_PATH,ID_CHOOSE_ROOT,ID_NEW_PROJECT,ID_NEW_FOLDER,
	ID_END_OF_LIST
};

LONG GrazerCopyMode = 0;

#define GRAZ_COL_SIZE 80
#define GRAZ_ROW_SIZE 50
#define GRAZ_IMAGE_WIDTH (GRAZ_COL_SIZE-2)
#define GRAZ_IMAGE_HEIGHT (GRAZ_ROW_SIZE-2)

#define GRAZ_COL_SIZE2 160
#define GRAZ_ROW_SIZE2 25
#define GRAZ_IMAGE_WIDTH2 (GRAZ_COL_SIZE2-2)
#define GRAZ_IMAGE_HEIGHT2 (GRAZ_ROW_SIZE2-2)

#define TEXT_BASELINE 9
#define TEXT_X_SPACE 4
#define TEXT_Y_SPACE 2

static UBYTE	TypeStr[5]="";
WORD RootLeft,RootTop;
ULONG IFF_FORM = MAKE_ID('F','O','R','M'),T=0;
//*******************************************************************
BOOL OpenGrazerWindow(struct EditWindow *Edit)
{
	if (!OpenEditWindow(Edit)) return(FALSE);
	UpdatePath(Edit);
	return(TRUE);
}

/****** Grazer/UpdatePath *******************************************
*
*   NAME
*	UpdatePath
*
*   SYNOPSIS
*	VOID UpdatePath(struct EditWindow *Edit)
*
*   FUNCTION
*	Goes from Grazer->Path to string gadget's SI->Buffer
*
*********************************************************************
*/
VOID UpdatePath(struct EditWindow *Edit)
{
	struct Gadget *Gadget;

	Gadget = FindGadget(Edit->Gadgets,ID_PATH);
	UpdateStringGadgetText(Edit->Window,Gadget,
		GetCString(((struct Grazer *)Edit->Special)->Path));
	Edit->RedrawString = TRUE;
}

/****** Grazer/GetGrazerClass ***************************************
*
*   NAME
*	GetGrazerClass
*
*   SYNOPSIS
*	UWORD GetGrazerClass(struct SmartNode *Node)
*
*   FUNCTION
* 	Node is really GrazerNode
*
*********************************************************************
*/
UWORD GetGrazerClass(struct SmartNode *Node)
{
	return(((struct GrazerNode *)Node)->DOSClass);
}

/****** Grazer/GrazerCompare ***************************************
*
*   NAME
*	GrazerCompare
*
*   SYNOPSIS
*	int GrazerCompare(struct MinNode *NodeA,struct MinNode *NodeB)
*
*   FUNCTION
* 	Returns: if <0, A<B; if =0, A=B; if >0, A>B
*
*********************************************************************
*/
int __asm __saveds GrazerCompare(
	register __a0 struct MinNode *NodeA,
	register __a1 struct MinNode *NodeB)
{
	UWORD AType,BType;
	struct GrazerNode *AG,*BG;

	AG = (struct GrazerNode *)NodeA;
	BG = (struct GrazerNode *)NodeB;
	AType = AG->DOSClass;
	BType = BG->DOSClass;

// if same Type, compare names
	if ((AType == BType) || (AType >= EN_START_ROOT && BType >= EN_START_ROOT))
		return(SmartStringCmpI(AG->EditNode.Node.Name,BG->EditNode.Node.Name));

// if different, devices first, then dirs, then files
	if (AType < BType) return(1);
	return(-1);
}

/****** Grazer/GrazerFIBNode ****************************************
*
*   NAME
*	GrazerFIBNode
*
*   SYNOPSIS
*	VOID GrazerFIBNode(struct SmartNode *SmartNode,struct FileInfoBlock *Fib,
*		UWORD DOSClass)
*
*   FUNCTION
*	Either Fib or DOSClass must be NULL
*
*********************************************************************
*/
VOID GrazerFIBNode(struct SmartNode *SmartNode,struct FileInfoBlock *Fib,
	UWORD DOSClass)
{
	struct GrazerNode *Node;

	Node = (struct GrazerNode *)SmartNode;
	if (DOSClass) Node->DOSClass = DOSClass;
	else if (Fib) {
		Node->DOSClass = EN_FILE;
		if (Fib->fib_DirEntryType >= 0)
			Node->DOSClass = EN_DIRECTORY;
		Node->FileSize = Fib->fib_Size;
		Node->DateStamp.ds_Days = Fib->fib_Date.ds_Days;
		Node->DateStamp.ds_Minute = Fib->fib_Date.ds_Minute;
		Node->DateStamp.ds_Tick = Fib->fib_Date.ds_Tick;
		Node->Protection = Fib->fib_Protection;
	}

// files: draggable, double->info panel
// dirs:  draggable, double->open dir
	Node->EditNode.Behavior = 0;
	switch (Node->DOSClass) {
		case EN_DIRECTORY:
			Node->EditNode.Behavior = EN_DOUBLE_ACTION;
		case EN_FILE:
			Node->EditNode.Behavior |= EN_DRAGGABLE;
			break;
		case EN_DEVICE:
		case EN_VOLUME:
		case EN_ASSIGN:
			Node->EditNode.Behavior = EN_DOUBLE_ACTION;
	}
}

//*******************************************************************

// THIS WAS CONNECTED TO THE F8 KEY.  IT IS THE SAME AS SELECTING "CONTROLS".

struct EditWindow *GrazerHandleInfo(
	struct EditWindow *RetEdit,struct IntuiMessage *IntuiMsg)
{
	struct Grazer *Grazer;
	UWORD Going = 1;
	struct EditNode *Node,*Next;
	struct GrazerNode *GNode;
	struct SmartString *Temp = NULL;
	struct EditWindow *Edit,*ENext;

	Edit = (struct EditWindow *)WindowList.lh_Head;
	while (ENext = (struct EditWindow *)Edit->Node.MinNode.mln_Succ)
	{
		if (Edit->Node.Type == EW_GRAZER)
		{
		 	Grazer = (struct Grazer *)Edit->Special;
			Node = (struct EditNode *)Edit->Special->pEditList->lh_Head;
			while (Next = (struct EditNode *)Node->Node.MinNode.mln_Succ)
			{
				if (Node->Status == EN_SELECTED)
				{
					GNode = (struct GrazerNode *)Node;

					if ((GNode->DOSClass == EN_FILE) || (GNode->DOSClass == EN_DIRECTORY))
					{
						if (!SmartStringLength(Grazer->Path)) goto Exit;
						if (!(Temp = DuplicateSmartString(Grazer->Path))) goto Exit;
						if (!DirectoryChar(SmartStringRight(Temp)))
							if (!AppendCSmartString("/",Temp)) goto FExit;
						if (!AppendSmartString(Node->Node.Name,Temp)) goto FExit;
						Going = DoInfoPanel(GetCString(Temp),GetCString(Node->Node.Name),
							Edit,GNode->Type);
				FExit:
						if (Temp) FreeSmartString(Temp);
						if (!Going) goto Exit;
					}
					else if (GNode->DOSClass == EN_VOLUME)
					{
						Going = DoDriveInfoPanel(GetCString(Node->Node.Name),Edit);
						if (!Going) goto Exit;
					}
				}
				Node = Next;
			}
		}
		else
		{
			HandlePanel(Edit,IntuiMsg);
//			SetRunningTime(0);			// Sets and displays
			DisplayRunningTime();		// Forces display
		}
		if(Going==2) DoAllNewDir(Edit); // renamed file in DoInfoPanel()
		Edit = ENext;
	}
Exit:
	return(RetEdit);
}

//*******************************************************************
BOOL GrazerDouble(struct EditWindow *Edit,struct EditNode *Node)
{
	UWORD a,L;
	struct Grazer *Grazer;
	BOOL Success = FALSE;
	struct GrazerNode *GNode = (struct GrazerNode *)Node;
	struct FastGadget	*FG;
	struct SmartString *Item;
	
	DUMPMSG("Grazer DoubleClick");
 	Grazer = (struct Grazer *)Edit->Special;
	if (GNode->DOSClass == EN_FILE)
	{
		DUMPSDECW("Double On Node Type: ",GNode->Type," ");
		if ((Item = DuplicateSmartString(Grazer->Path)) &&
				(AppendToPath(GNode->EditNode.Node.Name,Item)))
		switch(GNode->Type)
		{				// check for project - open it
			case CR_PROJECT:
				if( ((EditTop->Node.Type==EW_GRAZER) && MorphWindow(EW_TOP,EW_PROJECT) )
					|| (EditTop->Node.Type==EW_PROJECT) )  // Get Project on Top
				{
					strcpy(ProjectName,GetCString(Item));
					DUMPSTR("Before GrazerDouble() sends ES_LoadProject with ");
					DUMPMSG(ProjectName);
					ESparams2.Data1=0;
					ESparams2.Data2=(LONG)ProjectName;
					SendSwitcherReply(ES_LoadProject,&ESparams2);  // Proj. #, name
					DUMPMSG("  After GrazerDouble() sent ES_LoadProject");
					if (EditTop->Node.Type == EW_PROJECT) InitSetupProject(EditTop);
				}
				break;
			case CR_REXX:
				DUMPSTR("Launch ARexx Macro  ");
				DUMPMSG(GetCString(Item));
				Success=ARexxMacro(GetCString(Item));
				break;
			default:
				DUMPSTR("Before GrazerDouble() sends ES_LoadCrouton on ");
				DUMPMSG(GetCString(Item));
				{
					BPTR		lock;

					if ( lock = Lock(GetCString(Item),ACCESS_READ) )
					{
						BOOL			gotvolpath;

						gotvolpath = NameFromLock(lock,filepathbuf,sizeof(filepathbuf));

						UnLock(lock);

						if ( gotvolpath )
						{
							ESparams2.Data1=(LONG)filepathbuf;
							ESparams2.Data2=(LONG)1;

// THIS HACK WILL CAUSE CLIP ICONS TO BE RE-WRITTEN WHEN DOUBLE CLICK IN GRAZER
//							DHD_MakeClipIcon((char *)filepathbuf);

							if( FG=(struct FastGadget *)SendSwitcherReply(ES_LoadCrouton,&ESparams2))
							{
								ESparams1.Data1=(LONG)FG;
								DUMPMSG("  B4 GrazerDouble() sends ES_Select");
								SendSwitcherReply(ES_Select,&ESparams1);
								DUMPMSG("  B4 GrazerDouble() sends ES_Auto");
								SendSwitcherReply(ES_Auto,&ESparams1);
								DUMPMSG("  B4 GrazerDouble() sends ES_FreeCrouton");
								SendSwitcherReply(ES_FreeCrouton,&ESparams1);
							}
						}
					}
				}
				break;
		}
		if (Item) FreeSmartString(Item);
	}
	else
	{
		if (	(GNode->Type == CR_FLYER) &&
				!strcmp(GetCString(Node->Node.Name),"FLY_TAPE:") )
		{
			extern LONG DoProjectRestore( STRPTR projname, STRPTR device, LONG unit, struct Window *win );

			/* We'll want to do a restore */

			if ( DoProjectRestore(NULL,"flyerscsi.device",-1,Edit->Window) )
			{
				Success = TRUE;
			}
		}
		else
		{
			// if device or folder, open it
			a = FileOrDirectory(Grazer->Path);
			switch (a)
			{
				case A_FILE:
					if (FindParent(Grazer->Path,0)) break;
				case A_NON_EXISTANT:
					EraseSmartString(Grazer->Path);
			}
			L = SmartStringLength(Grazer->Path);

			// if Grazer->Path, and no dir char at end, append one
			if (L && (!DirectoryChar(SmartStringRight(Grazer->Path))))
				if (!(AppendCSmartString("/",Grazer->Path)))
					return(FALSE);

			// append directory name
			if ((L && (Node->Node.Name)) || 			// or device name
			((!L) && (((struct GrazerNode *)Node)->DOSClass >= EN_START_ROOT)))
			{
				if (!(AppendSmartString(Node->Node.Name,Grazer->Path))) return(FALSE);
				Success = DoAllNewDir(Edit);
			}
		}
	}
	return(Success);
}

/****** Grazer/DoAllNewDir ******************************************
*
*   NAME
*	DoAllNewDir
*
*   SYNOPSIS
*	BOOL DoAllNewDir(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/

BOOL DoAllNewDir(struct EditWindow *Edit)
{
	if (Edit->Node.Type == EW_GRAZER)
	{
		DisplayWaitSprite();
		Edit->RowOffset = Edit->ScrollOffset = 0;
		RowOffsetToPot(Edit);
		DUMPHEXIL("Into DoAllNewDir() ... *Edit = ",(LONG)Edit,"\\");
		BuildNewPath(Edit); // may modify Grazer->Path
		UpdatePath(Edit);
		DisplayNormalSprite();
		DUMPSTR("Done! \\");
		return(TRUE);
	}
}

//*******************************************************************
// Check to see if two grazers looking at same directory
VOID CheckOtherSame(struct EditWindow *Edit)
{
	struct EditWindow *Other;

	if (Edit == EditTop) Other = EditBottom;
	else if (Edit == EditBottom) Other = EditTop;
	else return;
	if (!Other) return;
	if ((Edit->Node.Type == EW_GRAZER) && (Other->Node.Type == EW_GRAZER) &&
		(stricmp(GetCString(((struct Grazer *)Edit->Special)->Path),
				GetCString(((struct Grazer *)Other->Special)->Path)) == 0))
	{
		DoAllNewDir(Other);
	}
	return;
}

/****** Grazer/AllocGrazerNode **************************************
*
*   NAME
*	AllocGrazerNode
*
*   SYNOPSIS
*	struct SmartNode *AllocGrazerNode(struct SmartString *Name)
*
*   FUNCTION
*
*
*********************************************************************
*/
struct SmartNode *AllocGrazerNode(struct SmartString *Name)
{
	struct GrazerNode *Node;

	if (Node = (struct GrazerNode *)AllocSmartNode(Name,
		sizeof(struct GrazerNode),MEMF_CLEAR))
	{
		Node->EditNode.Node.Type = EN_STANDARD;
		Node->EditNode.Redraw = TRUE;
	}
	return(&Node->EditNode.Node);
}


/****** Grazer/FreeGrazerNode ***************************************
*
*   NAME
*	FreeGrazerNode
*
*   SYNOPSIS
*	void FreeGrazerNode(struct SmartNode *sn )
*
*   FUNCTION
*
*
*********************************************************************
*/
void FreeGrazerNode(struct SmartNode *sn )
{
	if( ((struct GrazerNode *)sn)->BitMap)
		FreeIconBM(((struct GrazerNode *)sn)->BitMap);
	FreeSmartNode(sn);
}

/****** EditWindow/CloseGrazerWindow **********************************
*
*   NAME
*	CloseGrazerWindow
*
*   SYNOPSIS
*	VOID CloseGrazerWindow(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/

//*******************************************************************
// note: not called on MorphWindow()
VOID CloseGrazerWindow(struct EditWindow *Edit)
{
	if (Edit)
	{
		if ( Edit->Special->dircache )
		{
			UngetDirCache(Edit->Special->dircache);
			Edit->Special->dircache = NULL;
		}

		CloseEditWindow(Edit);
	}
}

struct BitMap *GetDefaultBitmap(int type)
{
	struct CroutonInfo  CI = {0,0,0,0,0,0};
	CI.CroutonType=CRuDTypes[type];
	GetCroutonInfo("",&CI);
	return(CI.IconBM);
}

struct Gadget *GetSmallImage(int type)
{
	UWORD	ID;
	switch(type)
	{
		case	CR_FXANIM:
		case	CR_FXILBM:
		case	CR_FXALGO:
		case	CR_FXCR:
		case	CR_CONTROL:
			ID = ID_SMALL_EFFECT;
			break;
		case	CR_VIDEO:
			ID = ID_SMALL_CLIP;
			break;
		case	CR_AUDIO:
			ID = ID_SMALL_AUDIO;
			break;
		case	CR_PROJECT:
			ID = ID_SMALL_PROJECT;
			break;
		case	CR_FRAMESTORE:
			ID = ID_SMALL_FRAME;
			break;
		case	CR_KEY:
		case	CR_SCROLL:
		case	CR_CRAWL:
			ID = ID_SMALL_CGPAGE;
			break;
		case	CR_CGBOOK:
			ID = ID_SMALL_CGBOOK;
			break;
		case	CR_IMAGE:
			ID = ID_SMALL_IMAGE;
			break;
		case	CR_LWSCENE:
			ID = ID_SMALL_3DSCN;
			break;
		case	CR_LWOBJ:
			ID = ID_SMALL_3DOBJ;
			break;
		case	CR_LWSURF:
			ID = ID_SMALL_3DSRF;
			break;
		case	CR_LWMOT:
			ID = ID_SMALL_3DMOT;
			break;
		case	CR_LWENV:
			ID = ID_SMALL_3DENV;
			break;
		case	CR_FONT:
			ID = ID_SMALL_FONT;
			break;
		case	CR_EPS:
			ID = ID_SMALL_EPS;
			break;
		case	CR_TEXT:
			ID = ID_SMALL_ASCII;
			break;
		case	CR_REXX:
			ID = ID_SMALL_REXX;
			break;
		case	CR_FLOPPY:
			ID = ID_SMALL_FLOPPY;
			break;
		case	CR_DRIVE:
		case	CR_FLYER:
			ID = ID_SMALL_DEVICE;
			break;
		case	CR_CDROM:
			ID = ID_SMALL_REMOVABLE;
			break;
		case	CR_DIR:
			ID = ID_SMALL_FOLDER;
			break;
		case	CR_UNKNOWN:
		default:
			ID = ID_SMALL_FILE;
			break;
	}
	return(FindGadget(&Gadget1,ID));
}

/****** Grazer/GrazerRenderNode *************************************
*
*   NAME
*	GrazerRenderNode
*
*   SYNOPSIS
*	VOID GrazerRenderNode(struct EditWindow *Edit,struct EditNode *Node,
*		struct RastPort *RP,UWORD LeftEdge,UWORD TopEdge);
*
*   FUNCTION
*
*
*********************************************************************
*/
VOID GrazerRenderNode(struct EditWindow *Edit,struct EditNode *Node,
		struct RastPort *RP,UWORD LeftEdge,UWORD TopEdge)
{
	UWORD X1,Y1,X2,Y2,Max;
	struct Gadget *Gadget;
	struct SmartString *S;
	struct BitMap *BM;
	struct GrazerNode *GNode;

//	char num[8]="    ";

	X1 = LeftEdge;
	Y1 = TopEdge;
	GNode = (struct GrazerNode *)Node;

// 160x25
	if (GrazerLayout)
	{
		Gadget = FindGadget(&Gadget1,ID_CROUTON_SMALL);
		DrawImage(RP,(struct Image *)Gadget->GadgetRender,X1,Y1);
		switch(((struct GrazerNode *)Node)->DOSClass) {
		case EN_VOLUME:
		case EN_DEVICE:
			Gadget = FindGadget(&Gadget1,ID_SMALL_DEVICE);
			switch(GNode->Type) {
				case CR_FLOPPY:
					Gadget = FindGadget(&Gadget1,ID_SMALL_FLOPPY);
				break;
				case CR_CDROM:
					Gadget = FindGadget(&Gadget1,ID_SMALL_REMOVABLE);
				break;
			}
			break;
		case EN_ASSIGN:
			Gadget = FindGadget(&Gadget1,ID_SMALL_ASSIGN);
			break;
		case EN_FILE:
//		DUMPSDECW("GNode->Type: ",GNode->Type,"\\");
//			Gadget = FindGadget(FT_Gadget1,ID_SMALL_EFFECT + GNode->Type - GT_EFFECT);
			Gadget = GetSmallImage(GNode->Type);
			break;
		case EN_DIRECTORY:
			Gadget = FindGadget(&Gadget1,ID_SMALL_FOLDER);
			break;
		default:
			Gadget = FindGadget(FT_Gadget1,ID_SMALL_FILE);
		}
		DrawImage(RP,(struct Image *)Gadget->GadgetRender,X1+5,Y1+5);
		if (S = Node->Node.Name) {
			X2 = 5 + Gadget->Width;
			Move(RP,X1+X2,TopEdge+7+TEXT_BASELINE);
			SafeFitText(RP,GetCString(S),SmartStringLength(S),
				Edit->ImageWidth - X2 - 3,TRUE);
		}

// 80x50
	}
	else
	{
		Y2 = TopEdge + Edit->ImageHeight - 7;
		if(BM = (GNode)->BitMap)
		{
			SetAPen(RP,SCREEN_PEN);
			SetDrMd(RP,JAM2);
			RectFill(RP,X1,Y1,X1+Edit->ColumnSize-1,Y1+Edit->RowSize-1);
			Y2 += 1;
			WaitBlit();
//	DUMPMEM("BM=",(APTR)BM,(LONG)sizeof(struct BitMap));
//	DUMPMEM("RPBM=",(APTR)(RP->BitMap),(LONG)sizeof(struct BitMap));
//	DUMPUDECL("X1=",(LONG)X1," ");
//	DUMPUDECL("Y1=",(LONG)X1," ");
//	DUMPUDECL("Rows=",(LONG)(Edit->RowSize),"\\");
			CopyCrut(BM,RP->BitMap,X1,Y1+1,Edit->RowSize-2);
/*
			SetAPen(RP,SOLID_PEN);
			RectFill(RP,X1+4,Y2-9,X1+Edit->ColumnSize-5,Y1+Edit->RowSize-6);
*/
		}
		else
		{
			switch(GNode->DOSClass)
			{
			case EN_VOLUME:
			case EN_DEVICE:
				Gadget = FindGadget(&Gadget1,ID_NAMES_DEVICE);
				switch(GNode->Type) {
					case CR_FLOPPY:
						Gadget = FindGadget(&Gadget1,ID_NAMES_FLOPPY);
					break;
					case CR_CDROM:
						Gadget = FindGadget(&Gadget1,ID_NAMES_REMOVABLE);
					break;
				}
				break;
			case EN_ASSIGN:
				Gadget = FindGadget(&Gadget1,ID_NAMES_ASSIGN);
				break;
			case EN_FILE:
    		Gadget = NULL;
				BM=GetDefaultBitmap(GNode->Type); // - GT_EFFECT);
				SetAPen(RP,SCREEN_PEN);
				SetDrMd(RP,JAM2);
				RectFill(RP,X1,Y1,X1+Edit->ColumnSize-1,Y1+Edit->RowSize-1);
				Y2 += 1;
				DUMPSTR(GetCString(Node->Node.Name));
				DUMPUDECL("		GType: ",(LONG)GNode->Type,"		");
				DUMPMSG(DTNames[GNode->Type]);
				WaitBlit();
				CopyCrut(BM,RP->BitMap,X1,Y1+1,Edit->RowSize-2);
//				T++;
//				Move(RP,X1+10,Y1+16);
//				SafeColorText(RP,num,Max);
//				num[1]=' ';
//				Max=stcl_d(num,GNode->Type);
//				Move(RP,X1+50,Y1+16);
//				SafeColorText(RP,num,Max);
		  	break;
			case EN_DIRECTORY:
				Gadget = FindGadget(&Gadget1,ID_NAMES_FOLDER);
				break;
			default:
				Gadget = FindGadget(&Gadget1,ID_NAMES_FILE);
			}
			if(Gadget) DrawImage(RP,(struct Image *)Gadget->GadgetRender,X1,Y1);
		}

		if(S = Node->Node.Name)
			if( !(GNode->BitMap) || ( (GNode->BitMap) &&
				((GNode->DOSClass==EN_DIRECTORY) || (GNode->DOSClass==EN_VOLUME)
					|| !((GNode->BitMap->pad)&0x0001)) )  ) // This bit set means IconBM loaded
			{
				Max = SafeFitText(RP,GetCString(S),SmartStringLength(S),
					Edit->ImageWidth - 6,FALSE);
				X1 = (Edit->ImageWidth - 6) - LastExtent.te_Width;
				X1 = LeftEdge + 4 + (X1 >> 1);
				Move(RP,X1,Y2);
				SafeColorText(RP,GetCString(S),Max);
			}
	}
	WaitBlit();
}

/****** Grazer/GrazerDropped ****************************************
*
*   NAME
*	GrazerDropped
*
*   SYNOPSIS
*	BOOL GrazerDropped(struct EditWindow *Source,struct EditWindow *Dest,
*		UWORD DropMode, struct EditNode *DestNode)
*
*   FUNCTION
*	Called when Dest is EW_GRAZER, Source is GRAZER/PROJECT
*
*********************************************************************
*/
BOOL GrazerDropped(struct EditWindow *Source,struct EditWindow *Dest,
	UWORD DropMode, struct EditNode *DestNode, UWORD qualifiers)
{
	struct EditNode *Node,*Next;
	struct SmartString *Src,*Dst;
	struct Grazer *SrcGrazer;
	BOOL AtLeastOne = FALSE,Started = FALSE;
	LONG Err = NULL,Count=0;
	char *MPtr[3];

// only supports GRAZER->GRAZER
	if (Source->Node.Type != EW_GRAZER) {
		ChangeStatusList(Source,EN_DRAGGING,EN_SELECTED);
		return(FALSE);
	}

	SrcGrazer = (struct Grazer *)Source->Special;

	/* Initialize copymode to default */
	GrazerCopyMode = 0;

	/* Determine Flyer/Flyer copy */
	if ( Source != Dest )
	{
		BPTR		src_lock;

		if ( src_lock = Lock( GetCString(((struct Grazer *)Source->Special)->Path),ACCESS_READ) )
		{
			BPTR		dest_lock;

			if ( dest_lock = Lock( GetCString(((struct Grazer *)Dest->Special)->Path),ACCESS_READ) )
			{
				char	*vol1end;

				/* resolve volume/path names */
				NameFromLock(src_lock,filepathbuf,sizeof(filepathbuf));
				NameFromLock(dest_lock,destfilepathbuf,sizeof(destfilepathbuf));

				if ( vol1end = strchr(filepathbuf,':') )
				{
					char		*vol2end;

					*vol1end = '\0';

					if ( vol2end = strchr(destfilepathbuf,':') )
					{
						*vol2end = '\0';

						/* Same volume names?? */
						if ( !strcmp(filepathbuf,destfilepathbuf) )
						{
							/* Moving files on same drive!!! */
							GrazerCopyMode = 1;
						}

						*vol2end = ':';
					}

					*vol1end = ':';
				}

				/* If We're not copying on the same volume */
				if ( !GrazerCopyMode )
				{
					struct InfoData	*id;

					if ( id = AllocMem( sizeof(struct InfoData),MEMF_PUBLIC|MEMF_CLEAR) )
					{
						if ( Info(src_lock,id) )
						{
							if ( !(strncmp( (char *)&id->id_DiskType,"FLY",3)) )
							{
								if ( Info(dest_lock,id) )
								{
									if ( !(strncmp( (char *)&id->id_DiskType,"FLY",3)) )
									{
										/* Both are flyer file system drives */
										GrazerCopyMode = 2;
									}
								}
							}
						}

						FreeMem(id,sizeof(*id));
					}
				}

				UnLock(dest_lock);
			}

			UnLock(src_lock);
		}
	}

// count # of items
	Node = (struct EditNode *)Source->Special->pEditList->lh_Head;
	while (Next = (struct EditNode *)Node->Node.MinNode.mln_Succ) {
		if (Node->Status == EN_DRAGGING) Count++;
		Node = Next;
	}

	Node = (struct EditNode *)Source->Special->pEditList->lh_Head;
	while (Next=(struct EditNode *)Node->Node.MinNode.mln_Succ)
	{
		if (Node->Status == EN_DRAGGING)
		{
			if (!Err)
			{ // if Err condition, just resetting nodes

				// Grazer to Grazer: DOS copy/replace
				if (Source != Dest)
				{
					if (SmartStringLength((((struct Grazer *)Dest->Special)->Path)) == 0)
					{
						ContinueRequest(Source->Window,"Open a device before copying.");
						Err = ERROR_USER_ABORT;
					}
					else
					{
						Src = Dst = NULL;
						if (	(Src=DuplicateSmartString(SrcGrazer->Path)) &&
								(Dst=DuplicateSmartString(((struct Grazer *)Dest->Special)->Path)) &&
								(AppendToPath(Node->Node.Name,Src)) &&
								(AppendToPath(Node->Node.Name,Dst))	)
						{

							if (!Started)
							{
								Started = TRUE;
								if ((Count > 1) || (FileOrDirectory(Src)!=A_FILE)
									|| (FileSize(GetCString(Src))) > 50000)
									StartNiceCopy(Source->Window,TRUE,TRUE);
								else
									StartNiceCopy(Source->Window,FALSE,TRUE);
							}
							AtLeastOne = TRUE;

							if ( Err = NiceCopy(GetCString(Src),GetCString(Dst),
									GetCString(Node->Node.Name),TRUE) )
							{
								if (Err < ERROR_USER_ABORT)
								{
									MPtr[0] = "Unable to create";
									MPtr[1] = GetCString(Dst);
									MPtr[2] = IoErrToText(Err);
									SimpleRequest(Dest->Window,MPtr,3,
										REQ_CENTER|REQ_H_CENTER,NULL);
								}
							}

						}

						if (Dst)
						{
							FreeSmartString(Dst);
							Dst = NULL;
						}

						if (Src)
						{
							FreeSmartString(Src);
							Src = NULL;
						}
					}
				}
			}
			Node->Status = EN_SELECTED;
			Node->Redraw = TRUE;
			Source->RedrawSelect = TRUE;
			Source->DisplayGrid = TRUE;
		}
		Node=Next;
	}

// make dest EditWindow update
	if (Started)	EndNiceCopy();

	if (AtLeastOne)
	{
		DoAllNewDir(Dest);

		// Grazer Move on same volume
		if ( GrazerCopyMode == 1 )
			DoAllNewDir(Source);

		// CheckOtherSame(Dest); not possible
		// UpdateDisplay(Dest); not necessary here
	}

	/* Clear copymode to default (just in case) */
	GrazerCopyMode = 0;

Exit:
	return(FALSE);
}

/****** Grazer/BuildNewPath *****************************************
*
*   NAME
*	BuildNewPath
*
*   SYNOPSIS
*	BOOL BuildNewPath(struct EditWindow *Edit)
*
*   FUNCTION
*
*
*********************************************************************
*/
BOOL BuildNewPath(struct EditWindow *Edit)
{
	BOOL Success = FALSE;
	struct Grazer *Grazer;
	LONG Err = 0;

	EraseGadget(Edit->Window,ID_GRID); // for user feedback
	Grazer = (struct Grazer *)Edit->Special;
	DUMPHEXIL("Into BuildNewPath() ... *Grazer = ",(LONG)Grazer,"\\");
	DUMPMSG(GetCString(Grazer->Path));
//	Grazer->Path = PathDevToVol(Grazer->Path);

TryAgain:

	if ( Edit->Special->dircache )
		UngetDirCache(Edit->Special->dircache);

	if ( Edit->Special->dircache = GetDirCache(GetCString(Grazer->Path),&Edit->Special->pEditList,Grazer) )
	{
		struct List			*filter_list;
		struct EditNode	*node,*nextnode;

		Success = TRUE;

		filter_list = GetDirCacheFilterList(Edit->Special->dircache);

		for ( node = (struct EditNode *)Edit->Special->pEditList->lh_Head;
				nextnode = (struct EditNode *)node->Node.MinNode.mln_Succ;
				node = nextnode )
		{
			if ( !(IsRequestedFileType(node)) )
			{
				Remove((struct Node *)node);
				AddTail(filter_list,(struct Node *)node);
			}
		}

		RebuildGrazerGrid(Edit);
	}

	if (!Success)
	{
		Err = IoErr();
		if ((Err == ERROR_OBJECT_NOT_FOUND) ||
			(Err == ERROR_DIR_NOT_FOUND))
		{
			if (FindParent(Grazer->Path,1)) goto TryAgain;
			EraseSmartString(Grazer->Path);
			goto TryAgain;
		}
		if (!Err) Err = ERROR_NO_FREE_STORE;
		ContinueRequest(Edit->Window,IoErrToText(Err));
	}
	QuicksortList(Grazer->Special.pEditList,GrazerCompare);
	SafeFixRowCount(Edit);
	NewGridLength(Edit);
	Edit->RedrawList = TRUE;
	Edit->ew_OptRender = FALSE;

	return(Success);
}

/****** Grazer/ArrangeGrazerGadgets *********************************
*
*   NAME
*	ArrangeGrazerGadgets
*
*   SYNOPSIS
*	VOID ArrangeGrazerGadgets(struct EditWindow *Edit,UWORD WindowHeight)
*
*   FUNCTION
*	Arranges gadgets given grazer
*
*********************************************************************
*/
#define GRID_H 175
#define BAR_H 20
#define X_GAP1 1
#define XX 5
VOID ArrangeGrazerGadgets(struct EditWindow *Edit,UWORD WindowHeight)
{
	struct Gadget *Close,*Grid,*Play,*Stop,*Control,
		*All,*Delete,*Duplicate,*Save,*ProgPop,*ViewPop,*ToolsPop,*Clip,
		*Path,*Root,*Choose,*NewFold,*DirTab,*PlayPart;

// please note the Window may not be open
	Grid = FindGadget(Edit->Gadgets,ID_GRID);
	Path = FindGadget(Edit->Gadgets,ID_PATH);
	Choose = FindGadget(Edit->Gadgets,ID_CHOOSE_ROOT);
	NewFold = FindGadget(Edit->Gadgets,ID_NEW_FOLDER);
	Root = FindGadget(GRZ_Gadget1,ID_ROOT_DEV);
	Clip = FindGadget(Edit->Gadgets,ID_NEW_CLIP);
	DirTab = FindGadget(Edit->Gadgets,ID_DIRTAB_CYCLE);

	Grid->TopEdge = GRID_TOP;
	Grid->Height = GRID_H;
	Path->LeftEdge = GRID_LEFT + 4;
	Path->TopEdge = Grid->TopEdge + GRID_H + 3 + 5;
	Path->Height = TEXT_HEIGHT;

	// setup ID_GRID's Height
	if (Edit->Location == EW_TOP)
	{
		Close = FindGadget(Edit->Gadgets,ID_CLOSE);
		Play = FindGadget(Edit->Gadgets,ID_VCR_PLAY);
		PlayPart = FindGadget(Edit->Gadgets,ID_PLAY_PART);
		Stop = FindGadget(Edit->Gadgets,ID_REQ_STOP);
		Control = FindGadget(Edit->Gadgets,ID_CONTROLS);
		All = FindGadget(Edit->Gadgets,ID_ALL);
		Delete = FindGadget(Edit->Gadgets,ID_DELETE);
		Duplicate = FindGadget(Edit->Gadgets,ID_DUPLICATE);
		Save = FindGadget(Edit->Gadgets,ID_GHOST_SAVE_PROJ);
		ToolsPop = FindGadget(Edit->Gadgets,ID_POPUP_TOOLS);
		ProgPop = FindGadget(Edit->Gadgets,ID_POPUP_PROGRAMS);
		ViewPop = FindGadget(Edit->Gadgets,ID_POPUP_VIEWS);
	}

	if (ArrangeEditGadgets(Edit))
	{
		if (Edit->Location == EW_TOP)
		{
			Stop->TopEdge = Control->TopEdge = PlayPart->TopEdge =
			All->TopEdge = Delete->TopEdge = Duplicate->TopEdge =
			Save->TopEdge = ToolsPop->TopEdge = ProgPop->TopEdge =
			ViewPop->TopEdge = Play->TopEdge = 205;

			ToolsPop->Width = 59;

			Delete->LeftEdge = GRID_LEFT;

			All->LeftEdge = Delete->LeftEdge + Delete->Width + 2*XX-1;
			Duplicate->LeftEdge = All->LeftEdge + All->Width;
			ToolsPop->LeftEdge = Duplicate->LeftEdge + Duplicate->Width;
			Control->LeftEdge = ToolsPop->LeftEdge + ToolsPop->Width + 1;

			Play->LeftEdge =  Control->LeftEdge + Control->Width + 2*XX-1;
			PlayPart->LeftEdge = Play->LeftEdge + Play->Width-1;
			Stop->LeftEdge = PlayPart->LeftEdge + PlayPart->Width;
			Save->LeftEdge = Stop->LeftEdge + Stop->Width + 2*XX-1;

			ProgPop->LeftEdge = Save->LeftEdge + Save->Width + 2*XX-1;
			ProgPop->Width = 92;
			ViewPop->Width = 65;
			ToolsPop->Height = ProgPop->Height = ViewPop->Height = 19;
			ViewPop->LeftEdge = ProgPop->LeftEdge + ProgPop->Width+1;
		}

		RootTop = NewFold->TopEdge = Choose->TopEdge = Clip->TopEdge =
			Grid->TopEdge + GRID_H + 3;

		NewFold->LeftEdge = GRID_LEFT + Grid->Width - NewFold->Width;
		Clip->LeftEdge = NewFold->LeftEdge - Clip->Width - XX;
		Choose->LeftEdge = Clip->LeftEdge - Choose->Width - XX;
		RootLeft = Choose->LeftEdge - Root->Width;
		Path->Width = RootLeft - X_GAP1 - Path->LeftEdge - 3;

		Grid->Height -= 16;

		ob_SetAttrs( DirTab,
			GA_Left,	Grid->LeftEdge,
			GA_Top,	(Grid->TopEdge  + Grid->Height),
			TAG_DONE );

		/* Trim expose 1/3 crouton off bottom of grid */
		Grid->Height -= 8;

		if ( Edit->ew_cg )
		{
			ob_SetAttrs( Edit->ew_cg,
				CRGRIDA_DestHeight,	Grid->Height,
				TAG_DONE );
		}

		RedrawRootMode(Edit);
	}
}

/****** Grazer/ResizeGrazer ***************************************
*
*   NAME
*	ResizeGrazer
*
*   SYNOPSIS
*	BOOL ResizeGrazer(struct EditWindow *Edit,UWORD NewHeight)
*
*   FUNCTION
*	Called by ResizeEditWindow(), does Grazer-specific changes
*
*********************************************************************
*/
BOOL ResizeGrazer(struct EditWindow *Edit,UWORD NewHeight)
{
	BOOL Success;
	struct Grazer *Grazer;

	Grazer = (struct Grazer *)Edit->Special;
	ArrangeGrazerGadgets(Edit,NewHeight);
	CalcGridDimensions(Edit); // re-calc as soon as grid re-sized

	Edit->RowOffset = Edit->ScrollOffset = 0;
	RowOffsetToPot(Edit);
	NewGridLength(Edit);

// if only one large grazer, no dragging, else allow it
	if ((Edit->Location == EW_TOP) &&
		(Edit->Height == TOP_LARGE))
		Edit->AllowDrag = FALSE;
	else Edit->AllowDrag = TRUE;

	Success = TRUE;

	return(Success);
}

/****** Grazer/FreeGrazer ******************************************
*
*   NAME
*	FreeGrazer
*
*   SYNOPSIS
*	VOID FreeGrazer(struct EditWindow *Edit)
*
*   FUNCTION
*	Frees it all
*
*********************************************************************
*/
VOID FreeGrazer(struct EditWindow *Edit)
{
	struct Grazer *Grazer;
	struct SmartString *SS;

	if (Edit)
	{
		Grazer = (struct Grazer *)Edit->Special;
		SS = BottomPath;
		if (Edit->Location == EW_TOP) SS = TopPath;
		EraseSmartString(SS);
		AppendSmartString(Grazer->Path,SS); // save path for next time

		{
			struct Gadget	*prev_gad;
			APTR				 dirtab_gad;

			/* remove the dirtab gadget from the list */
			dirtab_gad = FindGadget(Edit->Gadgets,ID_DIRTAB_CYCLE);
			ob_Dispose(dirtab_gad);

			// WARNING - WE ARE ASSUMING THAT ID_NEW_FOLDER IS
			// THE LAST GADGET IN THE GADGET LIST.

			prev_gad = FindGadget(Edit->Gadgets,LAST_ID_IN_LISTS);
			prev_gad->NextGadget = NULL;
		}

		FreeEditWindow(Edit);

		if (Edit->Special)
		{
			Grazer = (struct Grazer *)Edit->Special;
			FreeSmartString(Grazer->Path);

			if ( Edit->Special->dircache )
				UngetDirCache(Edit->Special->dircache);

			FreeMem(Edit->Special,sizeof(struct Grazer));
		}
		FreeSmartNode(&Edit->Node);
	}
}

//*******************************************************************
BOOL GrazGrid(struct EditWindow *Edit)
{
	FreeGrid(Edit);
	if (GrazerLayout) {
		Edit->ColumnSize = GRAZ_COL_SIZE2;
		Edit->RowSize = GRAZ_ROW_SIZE2;
		Edit->ImageWidth = GRAZ_IMAGE_WIDTH2;
		Edit->ImageHeight = GRAZ_IMAGE_HEIGHT2;
	} else {
		Edit->ColumnSize = GRAZ_COL_SIZE;
		Edit->RowSize = GRAZ_ROW_SIZE;
		Edit->ImageWidth = GRAZ_IMAGE_WIDTH;
		Edit->ImageHeight = GRAZ_IMAGE_HEIGHT;
	}
	CalcGridDimensions(Edit);
	return(AllocGrid(Edit));
}

/****** Grazer/AllocInitGrazer ******************************************
*
*   NAME
*	AllocInitGrazer
*
*   SYNOPSIS
*	struct EditWindow *AllocInitGrazer(struct NewGrazer *NewGrazer)
*
*   FUNCTION
*	Allocates a grazer window, but does not open it
*
*********************************************************************
*/
struct EditWindow *AllocInitGrazer(struct NewGrazer *NewGrazer)
{
	struct Grazer *Grazer;
	struct EditWindow *Edit;
	UWORD *IDS;
	BOOL Success = FALSE;
	struct Gadget *Gadget;
	struct SmartString *SS;

	if (NewGrazer->NewEdit.Location == EW_TOP) IDS = TopIDS;
	else if (NewGrazer->NewEdit.Location == EW_BOTTOM) IDS = BottomIDS;
	else return(NULL);

// if only one full-screen grazer, no dragging
	if ((NewGrazer->NewEdit.Location == EW_TOP) &&
		(NewGrazer->NewEdit.Height == TOP_LARGE))
		NewGrazer->NewEdit.Options &= (~OPTION_ALLOW_DRAG);
	else NewGrazer->NewEdit.Options |= (OPTION_ALLOW_DRAG);

	if ((Edit=(struct EditWindow *)AllocSmartNode(NULL,sizeof(struct EditWindow),
		MEMF_CLEAR)) &&
		(Edit->Special = (struct EditSpecial *)AllocSmartNode(NULL,
		sizeof(struct Grazer),MEMF_CLEAR))) {

		Grazer = (struct Grazer *)Edit->Special;

		if (NewGrazer->ValidAttributes & VALID_VOLUMES) Grazer->RootMode = 0;
		if (NewGrazer->ValidAttributes & VALID_DEVICES) Grazer->RootMode = 1;
		if (NewGrazer->ValidAttributes & VALID_ASSIGNS) Grazer->RootMode = 2;

		SS = BottomPath;
		if ( NewGrazer->NewEdit.Location == EW_TOP )
			SS = TopPath;

		if (Grazer->Path = DuplicateSmartString(SS)) {

		Edit->Node.Type = EW_GRAZER;
		Edit->NodeDropped = GrazerDropped;
		Edit->RenderNode = GrazerRenderNode;
		Edit->NodeDouble = GrazerDouble;
		Edit->NodeDeleted = GrazerDelete;
		Edit->NodeDuplicate = GrazerDuplicate;
		Edit->SelectAll = GrazerAll;
		// Edit->NodeSelect = ???GrazerDuplicate;

		Edit->Resize = ResizeGrazer;
		Edit->Open = OpenGrazerWindow;
		Edit->Close = CloseGrazerWindow; // no special requirements
		Edit->Free = FreeGrazer;

		if ((InitEditWindow(Edit,&NewGrazer->NewEdit))
			&& (Edit->Gadgets = AllocGadgetIDS(IDS,&Gadget1)))
		{
			struct Gadget	*dirtab_gad;

			if ( dirtab_gad = (struct Gadget *)
					ob_NewObject( NULL,DIRTABCLASS,
						TAG_DONE) )
			{
				// CANNOT do this now, as it uses EditTop, which is NULL when top project
				// window is closed and top Grazer is trying to open.  Moved this into
				// SetupWindow(), which occurs AFTER EditTop is once again valid.
//				ob_DoMethod(dirtab_gad,DTM_RefreshTabs);

				// Need to add this to the end of the gadget list

				// WARNING - WE ARE ASSUMING THAT ID_NEW_FOLDER IS
				// THE LAST GADGET IN THE GADGET LIST.

				Gadget = FindGadget(Edit->Gadgets,LAST_ID_IN_LISTS);
				Gadget->NextGadget = dirtab_gad;


				Grazer->ValidAttributes = NewGrazer->ValidAttributes;
				ArrangeGrazerGadgets(Edit,NewGrazer->NewEdit.Height);

				Gadget = FindGadget(Edit->Gadgets,ID_KNOB);

				if ( GrazGrid(Edit) && AllocGrid(Edit) )
				{
					// Specify handlers for shared icons
					Gadget = FindGadget(Edit->Gadgets,ID_CLOSE);
					Gadget->UserData = (APTR)GrazerParent;

					Success = TRUE;
				}
			}
		}

		if (!Success) {
			if (Edit) {
				FreeGrazer(Edit);
				Edit = NULL;
			}
		}
	} // if AllocSmartString Path
	} // if AllocMem() EditWindow & Grazer
	return(Edit);
}

struct FastGadget TempFG;

// Assumes we're CD to its directory

BOOL __asm XLoadNodeIcon( register __a0 struct GrazerNode *Node)
{
	struct BufferLock *L;
  BPTR	lock=NULL;

// Load BM from .I file, get type from file itself

 DUMPMSG("Entering \7 XLoadNodeIcon()");
  strcpy(TempMem,GetCString(Node->EditNode.Node.Name));
  strcat(TempMem,".I");
  if( !(lock=Lock(TempMem,SHARED_LOCK)) ) return(FALSE);
  UnLock(lock);
  LoadBM(TempMem,-1,(struct BitMap *)TempMem2);
  Node->BitMap = (struct BitMap *)TempMem2;
  if( !(BMWidth && BMHeight && BMDepth) )
  {
    Node->BitMap = NULL;
    return(FALSE);
  }
  if( (Node->BitMap=HelpAllocBitMap(80,50,BMDepth,0)) ) // Should alloc depth<intdepth for FX?
    LoadBM(TempMem,0,Node->BitMap);
  else return(FALSE);
  if (L = BufferOpen(GetCString(Node->EditNode.Node.Name),MODE_OLDFILE,2048,TempMem2))
  {
//    Node->Type = DataFileType(L) + GT_EFFECT;
    Node->Type = CroutonType(L);
    BufferClose(L);
    return(TRUE);
  }
  else
  {
//    Node->Type = GT_DEFAULT;
    Node->Type = CR_UNKNOWN;
    return(TRUE);
  }
}


BOOL __asm LoadNodeIcon( register __a0 struct GrazerNode *Node)
{
	struct CroutonInfo CI={0,0,(char *)1, 1, (APTR)1,0}; // non-zero members won't be filled

	if(SwitPort)
	{
		DUMPMSG("Into LoadNodeIcon()");

		if((ExamineCroutonIconFile(GetCString(Node->EditNode.Node.Name),&CI)!=CrI_OK)
			|| (CI.CroutonType == CT_UNSEEN)
			|| (CI.IconBM == NULL))
		{
			if((ExamineCroutonDataFile(GetCString(Node->EditNode.Node.Name),&CI)!=CrI_OK)
				|| (CI.CroutonType == CT_UNSEEN)
				||  (CI.IconBM == NULL))
			{
				if((ExamineCroutonDefaults(GetCString(Node->EditNode.Node.Name),&CI)!=CrI_OK)
					|| (CI.CroutonType == CT_UNSEEN)
					||  (CI.IconBM == NULL))
	  			{
					return(FALSE); // ASSUME!!! no bmaps were allocated above
			  	}
			}
		}

		DUMPSTR(GetCString(Node->EditNode.Node.Name));

		((ULONG *)TypeStr)[0] = CI.CroutonType;

		DUMPSTR(" CroutonType= ");
		DUMPSTR(TypeStr);
//	DUMPHEXIL("  CroutonIconBM=",(LONG)CI.IconBM,"\\");

		if(CI.CroutonType != CT_UNSEEN) Node->Type=CRuDToCR(CI.CroutonType);
		else Node->Type=CR_UNKNOWN;  // DT_DEFAULT+ GT_EFFECT;

		DUMPHEXIL("  Node->Type=",Node->Type," = ");
		DUMPMSG(DTNames[Node->Type]);
		DUMPHEXIL("CRuDTypes[Node->Type] ",(LONG)CRuDTypes[Node->Type]," \\");

		Node->BitMap=CI.IconBM;
		return(TRUE);
	}
  else return(XLoadNodeIcon(Node));
}

//*******************************************************************
// Assumes we're CD to its directory
BOOL __asm LoadNodeImage( register __a0 struct GrazerNode *Node)
{
	WORD *WP,A,*P1,*P2;
	struct BufferLock *L;
	LONG S;
	BOOL	result = FALSE;

	if( (Node->DOSClass==EN_DIRECTORY) )
	{
		struct CroutonInfo CI={0,0,(char *)1, 1, (APTR)1,0}; // non-zero members won't be filled
		CI.CroutonType = CRuDTypes[Node->Type];
		if( (ExamineCroutonIconFile(GetCString(Node->EditNode.Node.Name),&CI)==CrI_OK) )
			Node->BitMap=CI.IconBM;
		return(TRUE);
	}
	else if( (Node->DOSClass==EN_VOLUME) || (Node->DOSClass==EN_DEVICE) )
	{
		struct CroutonInfo CI={0,0,(char *)1, 1, (APTR)1,0}; // non-zero members won't be filled
		CI.CroutonType = CRuDTypes[Node->Type];
		if( (ExamineCroutonIconFile(GetCString(Node->EditNode.Node.Name),&CI)==CrI_OK) )
			Node->BitMap=CI.IconBM;
		else if( ExamineCroutonDefaults(GetCString(Node->EditNode.Node.Name),&CI)==CrI_OK )
			Node->BitMap=CI.IconBM;

		DUMPSTR("Node Name: ");
		DUMPSTR(GetCString(Node->EditNode.Node.Name));
		DUMPHEXIL(" Type: ",CRuDTypes[Node->Type],"	");
		DUMPHEXIL(" Bitmap: ",(LONG)Node->BitMap,"\\");

		return(TRUE);
	}
	else if(Node->DOSClass != EN_FILE) return(TRUE);

// SKell sez double on any file!!!
	Node->EditNode.Behavior |= EN_DOUBLE_ACTION;
// ... so i comment out the check below!
	if( LoadNodeIcon(Node) )
	{
/*
		switch(Node->Type)
		{
			case CR_VIDEO:
			case CR_CONTROL:
			case CR_AUDIO:
			case CR_FXANIM:
			case CR_FXILBM:
			case CR_FXALGO:
			case CR_FXCR:
			case CR_PROJECT:
			case CR_REXX:
			case CR_FRAMESTORE:
			case CR_KEY:
				Node->EditNode.Behavior |= EN_DOUBLE_ACTION;
		}
*/
		return(TRUE);
	}

	if (L = BufferOpen(GetCString(Node->EditNode.Node.Name),MODE_OLDFILE,2048,TempMem2))
	{
//		Node->Type = DataFileType(L) + GT_EFFECT;
		Node->Type = CroutonType(L);
		result = TRUE;
		switch(Node->Type)
		{
//			case GT_EFFECT:
			case CR_FXANIM:
			case CR_FXILBM:
			case CR_FXALGO:
			case CR_FXCR:
			BufferSeek(L,0,OFFSET_BEGINNING);

			if (BufferRead(L,(UBYTE *)&TempFG,sizeof(struct FastGadget)) !=
				CR_ERR_NONE) goto Exit;

			if ((TempFG.Width == 80) && (TempFG.Height == 50))
				{
				if (!(S = (LONG)TempFG.Data)) goto Exit;

				if (BufferSeek(L,(S-sizeof(struct FastGadget)),
					OFFSET_CURRENT) != CR_ERR_NONE)	goto Exit;

				if (BufferRead(L,TempMem,1500) != CR_ERR_NONE) goto Exit;

				// make fast, make depth,size of FG
				if (!(Node->BitMap=HelpAllocBitMap(80,50,2,0)))	goto Exit;

				A = 250;
				WP = (WORD *)TempMem;
				P1 = (WORD *)Node->BitMap->Planes[0];
				P2 = (WORD *)Node->BitMap->Planes[1];
				while (A)
				{
					WP++;
					*P1++ = *WP++;
					*P2++ = *WP++;
					A--;
				}
			} //else printf("W %d H %d\n",TempFG.Width,TempFG.Height);
        break;

//		case GT_PROJECT:
      case CR_PROJECT:
  			Node->EditNode.Behavior |= EN_DOUBLE_ACTION;
        break;
		}
Exit:
    BufferClose(L);
	}

	return(result);
}

//*******************************************************************
// check to see if any windows grazers showing device lists
VOID __regargs CheckShowList(struct List *List)
{
	struct EditWindow *Edit,*Next;
	struct Grazer *G;

	Edit = (struct EditWindow *)List->lh_Head;
	while ( Next = (struct EditWindow *)Edit->Node.MinNode.mln_Succ )
	{
		if (Edit->Node.Type == EW_GRAZER)
		{
			G = (struct Grazer *)Edit->Special;
			if ( SmartStringLength(G->Path) == 0 )
				DoAllNewDir(Edit);
		}
		Edit = Next;
	}
}

// end of grazer.c
