/*********************************************************************\
*
* Info - Replacement for AmigaDOS "info" which can't handle big clips
*
* $Id: info.c,v 1.0 1995/05/05 15:54:10 Flick Exp $
*
* $Log: info.c,v $
*Revision 1.0  1995/05/05  15:54:10  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	09/16/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/execbase.h>

#include <dos/dosasl.h>
#include <dos/dosextens.h>
#include <dos/rdargs.h>

#include <string.h>
#include <dos.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/utility.h>

#define	ID_FLYER_DISK		(0x464C5900L)	/* 'FLY\0' */


void ShowInfo(	struct DosLibrary *DOSBase,
					struct Library		*UtilityBase,
					int type,
					struct InfoData *id,
					struct DosList *dl);

struct combo {
	struct combo *next;
	struct InfoData	id;
	struct DosList		dl;
};


int main(void)
{
	struct	DosLibrary	*DOSBase = 0;
	struct	Library		*UtilityBase = 0;
	struct	ExecBase		*SysBase = *(struct ExecBase **)4;

	LONG		TheArgs[1];
	struct	DosList	*dl,*ldl;
	struct	DosList	*voldl;
	struct	DosList	*devdl;
	struct	combo		*firstguy;
	struct	combo		*thisguy;

	struct	combo		*com,*next;
	struct	RDArgs	*rdArgs;
	struct	InfoData	*id;

	int		found;
	int		abort,retcode;
	int		i,len;
	char		*ptr;

	char		*DisksMsg,*VolumesMsg;

	DisksMsg = "$VER: NewTek info 1.0 (6.1.95)\n\r";
	DisksMsg = "Copyright  1995, NewTek, inc.  Written by Marty Flickinger\n";

	DisksMsg = "\nMounted disks:\nUnit\x09  Size\x09   Used\x09    Free Full Errs   Status   Name\n";
	VolumesMsg = "\nVolumes available:\n";

	abort = 0;
	found = 0;

	retcode = 20;		/* Default return code */

	firstguy = 0;

	if (DOSBase = (struct DosLibrary *)OpenLibrary("dos.library",36L)) {
		if (UtilityBase = OpenLibrary("utility.library",36L)) {
			TheArgs[0] = 0;

			rdArgs = ReadArgs("DEVICE",&TheArgs[0],NULL);
			if (rdArgs == NULL) {
				PrintFault(IoErr(),NULL);
			}
			else {
				id = AllocVec(sizeof(struct InfoData),MEMF_CLEAR|MEMF_PUBLIC);
				if (id == 0) {
					PrintFault(IoErr(),NULL);
				}
				else {
					if (TheArgs[0] == 0) {
						dl = LockDosList(LDF_READ|LDF_DEVICES);
						while (dl = NextDosEntry(dl,LDF_READ|LDF_DEVICES)) {
							if (CheckSignal(SIGBREAKF_CTRL_C)) {
								abort = 1;
								PrintFault(ERROR_BREAK,NULL);
								break;
							}
							if (dl->dol_Task) {
								if (DoPkt(dl->dol_Task,ACTION_DISK_INFO,((ULONG) id)>>2,0,0,0,0)) {
									com = (struct combo *)AllocVec(sizeof(struct combo),MEMF_CLEAR|MEMF_PUBLIC);
									if (com==NULL) {
										PrintFault(IoErr(),NULL);
										break;
									}

									com->dl = *dl;		/* Copy DosList structure */
									com->id = *id;		/* Copy InfoData structure */

									if (firstguy == 0) {
										thisguy = com;
										firstguy = com;
									}
									else {
										thisguy->next = com;
										thisguy = com;
									}
								}
							}
						}
						UnLockDosList(LDF_READ|LDF_DEVICES);

						PutStr(DisksMsg);

						for (com=firstguy;com;) {
							ShowInfo(DOSBase,UtilityBase,0,&com->id,&com->dl);
							next = com->next;
							FreeVec(com);
							com = firstguy = next;
						}

						if (abort==0) {
							dl = LockDosList(LDF_READ|LDF_VOLUMES);
							while (dl = NextDosEntry(dl,LDF_READ|LDF_VOLUMES)) {
								com = AllocVec(sizeof(struct combo),MEMF_CLEAR|MEMF_PUBLIC);
								if (com==NULL) {
									PrintFault(IoErr(),0);
									break;
								}

								com->dl = *dl;		/* Copy DosList structure */
								com->id = *id;		/* Copy InfoData structure */

								if (firstguy == 0) {
									thisguy = com;
									firstguy = com;
								}
								else {
									thisguy->next = com;
									thisguy = com;
								}
							}
							UnLockDosList(LDF_READ|LDF_VOLUMES);

							PutStr(VolumesMsg);

							for (com=firstguy;com;) {
								ShowInfo(DOSBase,UtilityBase,1,&com->id,&com->dl);
								next = com->next;
								FreeVec(com);
								com = firstguy = next;
							}
						}
					}
					else {
						ldl = LockDosList(LDF_READ|LDF_DEVICES|LDF_VOLUMES);

						len = strlen((char *)TheArgs[0]);
						for (i=0,ptr=(char *)TheArgs[0];i<len;i++,ptr++) {
							if (*ptr == ':') {
								*ptr = 0;
								break;
							}
						}

						dl = FindDosEntry(ldl,(STRPTR)TheArgs[0],LDF_READ|LDF_DEVICES|LDF_VOLUMES);
						if ((dl) && (dl->dol_Task)) {
							if (DoPkt(dl->dol_Task,ACTION_DISK_INFO,((ULONG)id)>>2,0,0,0,0)) {
								voldl = dl;
								devdl = dl;
								for (dl=ldl;dl=NextDosEntry(dl,LDF_DEVICES|LDF_VOLUMES);) {
									if (dl->dol_Task == devdl->dol_Task) {
										if (devdl->dol_Type != dl->dol_Type) {
											if (devdl->dol_Type == DLT_DEVICE)
												voldl = dl;
											else
												devdl = dl;
											break;
										}
									}
								}
								found = 1;
							}
						}

						UnLockDosList(LDF_READ|LDF_DEVICES|LDF_VOLUMES);

						if (found) {
							PutStr(DisksMsg);
							ShowInfo(DOSBase,UtilityBase,0,id,devdl);

							PutStr(VolumesMsg);
							ShowInfo(DOSBase,UtilityBase,1,id,voldl);
						}
					}
					FreeVec(id);
					retcode = 0;
				}
				FreeArgs(rdArgs);
			}
			CloseLibrary(UtilityBase);
			CloseLibrary((struct Library *)DOSBase);
			return(retcode);
		}
	}
	if (DOSBase)
		CloseLibrary((struct Library *)DOSBase);

	((struct Process *)SysBase->ThisTask)->pr_Result2 = ERROR_INVALID_RESIDENT_LIBRARY;

	return(retcode);
}


/* Type: 0=devices/1=volumes */
void ShowInfo(	struct DosLibrary *DOSBase,
					struct Library		*UtilityBase,
					int type,
					struct InfoData *id,
					struct DosList *dl)
{
	LONG	ArgList[10];
	char	namebuf[256];
	char	scratch[256];
	char	*ptr;
	int	i,len,scale;
	struct DeviceList *vol;
	ULONG	bytes,temp,pct,used,total;


	ptr = (char *) (dl->dol_Name << 2);
	len = *ptr;
	memcpy(&namebuf[0],ptr+1,len);

	namebuf[len] = 0;

	ArgList[0] = (LONG)&namebuf[0];

	if (type) {
		if (dl->dol_Task)
			ArgList[1] = (LONG)"[Mounted]";
		else
			ArgList[1] = (LONG)NULL;

		VPrintf("%s %s\n",ArgList);
	}
	else {
		strcat((char *)ArgList[0],":");

		if ((id->id_DiskType == ID_DOS_DISK)
		||  (id->id_DiskType == ID_FFS_DISK)
		||  (id->id_DiskType == ID_INTER_DOS_DISK)
		||  (id->id_DiskType == ID_INTER_FFS_DISK)
		||  (id->id_DiskType == ID_FASTDIR_DOS_DISK)
		||  (id->id_DiskType == ID_FASTDIR_FFS_DISK)
		||  (id->id_DiskType == ID_MSDOS_DISK)
		||  (id->id_DiskType == ID_FLYER_DISK)) {

			for (i=0;i<256;i++)
				scratch[i] = 0;			/* Clear all */

			vol = (struct DeviceList *)(id->id_VolumeNode<<2);
			ptr = (char *)(vol->dl_Name<<2);
			memcpy(scratch,ptr+1,*ptr);

			ArgList[8] = (LONG)&scratch[0];				/* Volume name */
			ArgList[6] = id->id_NumSoftErrors;
			ArgList[3] = id->id_NumBlocksUsed;
			ArgList[4] = id->id_NumBlocks - id->id_NumBlocksUsed;

			scale = 0;
			temp = id->id_NumBlocks;
			if (temp > 0x3FFFFF) {		/* Scale to prevent overflow if needed */
				scale = 8;
				temp >>= scale;
			}
			bytes = UMult32(temp,id->id_BytesPerBlock);

			temp = bytes >> (30-scale);
			ArgList[1] = temp;
			ArgList[2] = (LONG)"G";
			if (temp < 10) {
				temp = bytes >> (20-scale);
				ArgList[1] = temp;
				ArgList[2] = (LONG)"M";
				if (temp < 10) {
					temp = bytes >> (10-scale);
					ArgList[1] = temp;
					ArgList[2] = (LONG)"K";
				}
			}

#if 0
			ArgList[1] = bytes>>10;
			ArgList[2] = (LONG)"K";

			if (ArgList[1] > 9999) {
				ArgList[1] = bytes>>20;
				ArgList[2] = (LONG)"M";
			}
#endif

/*** Calculate percentage used ***/

			used = id->id_NumBlocksUsed;
			total = id->id_NumBlocks;
			if (used > 21000000) {		/* Scale if needed to prevent overflow */
				used >>= 16;
				total >>= 16;
			}

			temp = used * 100;
			pct = UDivMod32(temp,total);
			if (getreg(REG_D1) >= (total>>1))
				pct++;

			ArgList[5] = pct;			/* % used */

			switch (id->id_DiskState) {
				case ID_WRITE_PROTECTED:
					ArgList[7] = (LONG)"Read Only";
					break;

				case ID_VALIDATING:
					ArgList[7] = (LONG)"Validating";
					break;

				default:
					ArgList[7] = (LONG)"Read/Write";
			}
			VPrintf("%-8s%5ld%s%9ld%9ld %3ld%% %3ld  %-10s %-s\n",ArgList);
		}
		else {
			switch(id->id_DiskType) {
				case ID_NO_DISK_PRESENT:
					ArgList[1] = (LONG)"No disk present";
					break;
				case ID_KICKSTART_DISK:
					ArgList[1] = (LONG)"Kickstart disk";
					break;
				case ID_NOT_REALLY_DOS:
					ArgList[1] = (LONG)"Not a DOS disk";
					break;
				default:
					ArgList[1] = (LONG)"Unreadable disk";
			}

			VPrintf("%-10s%s\n",ArgList);
		}
	}
}
