/*********************************************************************\
*
* JogTest - test jog/shuttle commands
*
* $Id: jogtest.c,v 1.5 1995/08/21 12:05:48 Flick Exp Holt $
*
* $Log: jogtest.c,v $
*Revision 1.5  1995/08/21  12:05:48  Flick
*Added button to test shuttle fwd at 1x
*
*Revision 1.4  1995/07/25  17:47:06  Flick
*Added 'x' option to go to black on close or not
*
*Revision 1.3  1995/07/17  12:09:11  Flick
*Removed extraneous DoFindField when changing audio volume
*
*Revision 1.2  1995/07/17  09:35:03  Flick
*Fixed occasional enforcer hit when exiting
*
*Revision 1.1  1995/06/02  09:32:20  Flick
*Added 'L' option to specify looping audio or not
*
*Revision 1.0  1995/05/05  15:51:00  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/19/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <intuition/intuition.h>

#include "FlyerLib.h"
#include "Flyer.h"

struct FileInfoBlock fib;

struct Library *FlyerBase;
struct FlyerVolume	FlyVol;
struct ClipAction		Action;
struct SMPTEinfo		SmpteInfo;

struct ClipInfo	ClipInfo;

struct	Window			*Window;
struct	IntuitionBase  *IntuitionBase;
struct	RastPort			*RP;

UBYTE	permissions;
BOOL toblack = FALSE;

#define	GID_VOLUME	1
#define	GID_JOG		2
#define	GID_JOGBEGIN		3

void Doit(ULONG field);
ULONG	ScrollBar2Pos(ULONG max);
ULONG	GetVolume(void);
void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct TextAttr MyFont = {(STRPTR)"topaz.font",TOPAZ_EIGHTY,0,0};

USHORT	BoxVectors[] = {104,14, 0,14, 0,0, 104,0, 104,14};
struct	Border BoxBorder = {-2,-2,1,0,JAM1,5,BoxVectors,NULL};

struct IntuiText JogBeginText = {
   1,0,JAM1,32,2,&MyFont,"Jog",NULL};
struct Gadget JogBeginGadget = {		/* Jog start */
	NULL,400,50,101,11,GADGHCOMP,RELVERIFY,BOOLGADGET,
   (APTR)&BoxBorder,NULL,&JogBeginText,0,NULL,
	GID_JOGBEGIN,
	NULL};


struct PropInfo VolumeInfo = {
	AUTOKNOB|FREEHORIZ,0xFFFF,0,
	0x0100,MAXBODY,
};

struct Image VolumeImage;
struct Gadget VolumeGadget = {
	&JogBeginGadget,
	20,50,300,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&VolumeImage,
	NULL,
	NULL,
	0,
	(APTR)&VolumeInfo,
	GID_VOLUME,
	NULL
};

struct PropInfo ShuttleInfo = {
	AUTOKNOB|FREEHORIZ,0,0,
	0x0100,MAXBODY,
};

struct Image ShuttleImage;
struct Gadget ShuttleGadget = {
	&VolumeGadget,
	20,20,600,10,
	GADGHCOMP,
	RELVERIFY,
	PROPGADGET,
	(APTR)&ShuttleImage,
	NULL,
	NULL,
	0,
	(APTR)&ShuttleInfo,
	GID_JOG,
	NULL
};

struct NewWindow NewWindow =
	{
	0,50,
	640,80,
	0,1,
	GADGETUP | MOUSEMOVE | CLOSEWINDOW | INTUITICKS,
	WINDOWCLOSE | WINDOWDRAG | WINDOWDEPTH | ACTIVATE | NOCAREREFRESH,
	&ShuttleGadget,		/* Gadget 1st */
	NULL,
	"Flyer Jog Test",
	NULL,
	NULL,
	100,25,
	640,400,
	WBENCHSCREEN
};

char SmpteBuffer[] = "SMPTE: xx:xx:xx:xx     ";
struct	IntuiText SmpteText =
	{1,0,JAM2,200,41,&MyFont,(unsigned char *)&SmpteBuffer,NULL};

char BlkBuffer[20] = "Block 0";
struct	IntuiText BlkText =
	{1,0,JAM2,200,31,&MyFont,(unsigned char *)&BlkBuffer,NULL};

char PosBuffer[20] = "Field 0";
struct	IntuiText PosText =
	{1,0,JAM2,18,31,&MyFont,(unsigned char *)&PosBuffer,NULL};

char VolBuffer[20] = "(100%)";
struct	IntuiText VolumeText =
	{1,0,JAM2,330,51,&MyFont,(unsigned char *)&VolBuffer,NULL};

struct	IntuiText Info2Text =
	{1,0,JAM2,18,42,&MyFont,"Volume",NULL};
struct	IntuiText Info1Text =
	{1,0,JAM2,18,12,&MyFont,"Jog",&Info2Text};


int	vidflag,audchans;

main(int argc,char **argv)
{
	int	drive,unit,vchan,stop,oldvol=0,newvol;
	ULONG	res,TotalFields;
	struct	IntuiMessage  *IntMsg;
	ULONG		MIClass,newfield,oldfield,field;
	USHORT	theID;
	struct	Gadget	*MIAddress;
	char	*ptr;

	if ((argc!=6)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <drive> <vidchan> <name> <V/M/S/L/X>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&drive,0,23,"Drive");
	GetArg(argv[3],&vchan,0,1,"Video Channel");

	permissions = CAPF_AUTOMUTE;

	for (ptr=argv[5];*ptr;ptr++) {
		switch (toupper(*ptr)) {
			case 'V': vidflag = 1; break;
			case 'M': audchans = 1; break;
			case 'S': audchans = 2; break;
			case 'L': permissions &= ~CAPF_AUTOMUTE; break;		// To loop, remove auto-mute
			case 'X': toblack = TRUE;
		}
	}

	FlyVol.Board = unit;
	FlyVol.Path = argv[4];
	FlyVol.SCSIdrive = drive;
	FlyVol.Flags = FVF_USENUMS;

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Channel = vchan;

	FlyerBase = OpenLibrary("flyer.library",0);
	if (FlyerBase==0) {
		printf("Could not open Flyer\n");
		exit(10);
	}

#if 0
	AbortAction(0);			/* Kill everything else */
#endif

	ClipInfo.len = sizeof(struct ClipInfo);
	res = GetClipInfo(&FlyVol,&ClipInfo);
	if (res) {
		printf("ClipInfo Error %ld - %ls\n",res,Error2String(res));
		TotalFields = 100;
	}
	else {
		TotalFields = ClipInfo.Fields;
	}

	/* Set appropriate size */
	ShuttleInfo.HorizBody = (0x10000/((TotalFields+3)/4)) & 0xFFFF;

	Action.Flags = 0;
	if (vidflag)
		Action.Flags |= CAF_VIDEO;
	if (audchans==1)
		Action.Flags |= CAF_AUDIOL;
	else if (audchans==2)
		Action.Flags |= CAF_AUDIOL | CAF_AUDIOR;

	Action.VolSust1 = GetVolume();
	Action.VolSust2 = GetVolume();

	Action.PermissFlags = permissions;

	res = BeginFindField(&Action);
	if (res==FERR_OKAY) {
		IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library",0);
		if (IntuitionBase) {
			Window = (struct Window *)OpenWindow(&NewWindow);
			if (Window) {
				RP = Window->RPort;

				PrintIText(RP,&Info1Text,0,0);
				PrintIText(RP,&VolumeText,0,0);

				stop = 0;
				oldfield = 0;

				do {
					Wait(1<<Window->UserPort->mp_SigBit);
					while (IntMsg=(struct IntuiMessage *)GetMsg(Window->UserPort)) {
						MIClass		= IntMsg->Class;  /* Get pertinent info */
						MIAddress	= (struct Gadget *)IntMsg->IAddress;
						if (MIClass == GADGETUP)
//						if (MIAddress)	// THIS WOULD ENFORCER HIT, SOMETIMES HAS FFFF0000!!!
							theID = MIAddress->GadgetID;
						else
							theID = 0;
						ReplyMsg((struct Message *)IntMsg);			/* Reply to message quickly */

						newfield = ScrollBar2Pos(TotalFields);
						if (newfield != oldfield) {				/* Slider changed since last? */
							Doit(newfield);
							oldfield = newfield;
						}

						newvol = GetVolume();
						if (newvol != oldvol) {				/* Slider changed since last? */
//							Doit(newfield);
							Action.VolSust1 = newvol;
							Action.VolSust2 = newvol;
							sprintf(VolBuffer,"(%ld%%)    ",Action.VolSust1/655);
							PrintIText(RP,&VolumeText,0,0);
							Doit(newfield);
							oldvol = newvol;
						}


						if (MIClass == GADGETUP) {
							if (theID == GID_VOLUME) {
#if 0
								Action.VolSust1 = GetVolume();
								Action.VolSust2 = GetVolume();
								sprintf(VolBuffer,"(%ld%%)    ",Action.VolSust1/655);
								PrintIText(RP,&VolumeText,0,0);
								Doit(newfield);
#endif
							}
							else if (theID == GID_JOG) {
#if 0
								Doit(newfield);
								oldfield = newfield;
#endif
							}
							else if (theID == GID_JOGBEGIN)
							{
								for (field = 0; field<920; field+=4)
								{
									Doit(field);
//									Action.PermissFlags = permissions;
//									if (vidflag)
//										Action.VidStartField = field;
//									else
//										Action.AudStartField = field;
//									DoFindField(&Action);
								}
							}
						}
						else if (MIClass == CLOSEWINDOW)
							stop = 1;
					}
				} while (stop==0);

				CloseWindow(Window);
			}
			CloseLibrary((struct Library *)IntuitionBase);
		}
		if (toblack)
			Action.Flags |= CAF_USEMATTE;
		EndFindField(&Action);
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);
}


void Doit(ULONG field)
{
	ULONG	res;

	sprintf(PosBuffer,"Field %ld      ",field);
	PrintIText(RP,&PosText,0,0);

	Action.PermissFlags = permissions;

	if (vidflag)
		Action.VidStartField = field;
	else
		Action.AudStartField = field;

	res = DoFindField(&Action);
	if (res)
		printf("Could not locate field %ld\n",field);
	else {
		sprintf(BlkBuffer,"Block $%lx      ",Action.StartBlk);
		PrintIText(RP,&BlkText,0,0);

		/* See if field had SMPTE info */
		res = GetSMPTE(FlyVol.Board,&SmpteInfo);
		if ((res==FERR_OKAY)&&(SmpteInfo.SMPTEvalid)) {
			sprintf(SmpteBuffer,"SMPTE: %02ld:%02ld:%02ld:%02ld %ls",
				SmpteInfo.SMPTEhours,SmpteInfo.SMPTEminutes,
				SmpteInfo.SMPTEseconds,SmpteInfo.SMPTEframes,
				(SmpteInfo.SMPTEflags & SIF_DropFrame)?"(DF)":"    ");
		}
		else {
			sprintf(SmpteBuffer,"SMPTE: --:--:--:--     ");
		}
		PrintIText(RP,&SmpteText,0,0);
	}
}


ULONG	ScrollBar2Pos(ULONG max)
{
	ULONG	new;

	new = ((struct PropInfo *)ShuttleGadget.SpecialInfo)->HorizPot+1;
	new = (max * (new>>4))>>11;
	if (new & 1) new++;
	new>>=1;

	if (new >= max)
		new = max-1;

	return(new);
}


ULONG	GetVolume(void)
{
	ULONG	vol;

	vol = ((struct PropInfo *)VolumeGadget.SpecialInfo)->HorizPot;

	return(vol);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
