/*********************************************************************\
*
* MakeFile - Create a file
*
* $Id: makefile.c,v 1.1 1995/06/20 09:13:34 Flick Exp $
*
* $Log: makefile.c,v $
*Revision 1.1  1995/06/20  09:13:34  Flick
*Supports option to make a non-block-aligned file
*
*Revision 1.0  1995/05/05  15:51:43  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	01/13/95		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume SrcVol;

main(int argc,char **argv)
{
	int	unit;
	ULONG	res,blks,start,bytes;

	if (((argc!=4)&&(argc!=5))||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <vol:name> <blocks> [BYTES]\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetLongArg(argv[3],&blks,0,0xFFFFFFFF,"Blocks");
	SrcVol.Board = unit;

	// Specified bytes instead of blocks?
	if ((argc==5)&&(stricmp(argv[4],"BYTES")==0))
	{
		bytes = blks;
		blks = 0;
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

/*	SrcVol.Flags = FVF_USENUMS; */
	SrcVol.Path = argv[2];
	SrcVol.SCSIdrive = 0;

	start = bytes;						// Kludge: if user specified bytes, pass in here

	printf("Blks:%ld Bytes:%ld\n",blks,bytes);

	res = MakeFlyerFile(&SrcVol,blks,&start);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Created file (start is %lx)\n",start);

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
