/*********************************************************************\
*
* MemTest - Test Flyer shared RAM (from Amiga side)
*
* $Id: memtest.c,v 1.0 1995/05/05 15:51:56 Flick Exp $
*
* $Log: memtest.c,v $
*Revision 1.0  1995/05/05  15:51:56  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/03/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

#define	VERBOSE	0

void Error(int err,UWORD *dadr,UWORD *tadr,UWORD wdata,UWORD rdata);
void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


main(int argc,char **argv)
{
	ULONG	loaddr,hiaddr,mask,i;
	UWORD	*loptr,*hiptr,*ptr,*testptr,rd,wr;

	if ((argc!=3)||(argv[1][0]=='?')) {
		printf("Usage: %ls <loaddr> <hiaddr>\n",argv[0]);
		return(20);
	}

	GetLongArg(argv[1],&loaddr,0,0xFFFFFF,"Lo Address");
	GetLongArg(argv[2],&hiaddr,0,0xFFFFFF,"Lo Address");

	hiptr = (UWORD *)hiaddr;
	loptr = (UWORD *)loaddr;

	for (ptr=loptr;ptr<=hiptr;ptr++)
		*ptr = 0xAAAA;

	for (ptr=loptr;ptr<=hiptr;ptr++) {
#if VERBOSE
		if (((ULONG)ptr & 0xFFF)==0)
			printf("Test Adr: %lx\n",(ULONG)ptr);
#endif
		wr = 0xFFFF;
		*ptr = wr;
		rd = *ptr;
		if (rd != wr)
			Error(1,ptr,ptr,wr,rd);

		mask = 2;
		for (i=1;i<=17;i++) {
			testptr = (UWORD *)((ULONG)ptr ^ mask);
			if ((testptr>=loptr)&&(testptr<=hiptr)) {
				rd = *testptr;
				if (testptr < ptr)
					wr = 0x5555;
				else
					wr = 0xAAAA;

				if (rd != wr)
					Error(2,ptr,testptr,wr,rd);
				mask <<= 1;
			}
		}

		/* Single bit test */
		wr = 1;
		for (i=0;i<16;i++) {
			*ptr = wr;
			rd = *ptr;
			if (rd != wr)
				Error(3,ptr,ptr,wr,rd);
			wr <<= 1;
		}

		*ptr = 0x5555;
	}

	return(0);
}


void Error(int err,UWORD *dadr,UWORD *tadr,UWORD wdata,UWORD rdata)
{
	switch (err) {
	case (1):
		printf("Readback error - ");
		break;
	case (2):
		printf("Crosstalk error - ");
		break;
	case (3):
		printf("Bit error - ");
		break;
	}

	printf("Data Addr: %lx  Test Addr: %lx  Expected: %lx  Read: %lx\n",
		(ULONG)dadr,(ULONG)tadr,wdata,rdata);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
