/* $PanData.c$  Control panel data
* $Id: pandata.c,v 2.31 1997/02/03 23:50:19 Holt Exp $
* $Log: pandata.c,v $
*Revision 2.31  1997/02/03  23:50:19  Holt
*fixed audio and panel defs so when envlope button on skip panel would
*still look ok.
*
*Revision 2.30  1996/11/18  18:40:03  Holt
*added move envelope panel support.
*
*Revision 2.29  1996/10/29  18:17:29  Holt
*added more audio envelope things includeing
*use envelope
*
*Revision 2.28  1996/07/29  10:28:36  Holt
*added part of the autioenv panel.
*
*Revision 2.27  1996/07/19  14:52:35  Holt
*finished up cfx
*
*Revision 2.26  1996/07/15  18:29:40  Holt
*made many changes to add a env button to the audio and clip panels.
*
*Revision 2.25  1995/10/09  16:43:27  Flick
*Removed unnecessary usage of popup.h
*Changes for new Lost Crouton panel
*
*Revision 2.24  1995/10/06  16:12:43  Flick
*Added ReqFlyJog_IPL
*
*Revision 2.23  1995/10/03  17:32:46  Flick
*Added "Prefer fine tune panels" to option panel
*Removed Main expert panel (unused)
*
*Revision 2.22  1995/10/03  14:25:17  Flick
*Changed to "User Experience"
*
*Revision 2.21  1995/10/02  15:22:21  Flick
*Deleted obsolete initializer structures, moved Flyer options from Setup to Options panel
*Many other minor adjustments
*
*Revision 2.20  1995/09/28  09:55:39  Flick
*Rename changed back to Continue
*
*Revision 2.19  1995/09/25  12:21:08  Flick
*Worked on FX and Key panels, added Quick panel
*
*Revision 2.18  1995/09/19  12:37:32  Flick
*Changed all panel initializers to InitPanelLine structures which are MUCH smaller, rest of structure is init'd by standard data for each PNL_xxxx type.
*
*Revision 2.17  1995/09/13  12:21:25  Flick
*All panels modified to support new fine adjust system (x offset) plus new
*definitions for placement PPOS_xxx.  Lotsa panels juggled around and scrunched.
*New buttons include reorg from driveinfo, cut/process next/prev, cut/process
*entry buttons in A/V panels.
*
*Revision 2.16  1995/08/18  16:46:48  Flick
*Changed drive info panel (largest free/upon reorg)
*
*Revision 2.15  1995/08/16  10:59:48  Flick
*Added clip time to InfoPanel, rewording on DriveInfoPanel
*
*Revision 2.14  1995/08/09  17:56:06  Flick
*Added HQ5 button in setup panel, Added Fade in/out buttons for keys
*Reworked all FX panels + added a new one
*
*Revision 2.13  1995/07/27  18:12:08  Flick
*Added DriveInfo_PL
*
*Revision 2.12  1995/06/27  13:46:09  Flick
*Added Drop Frame Stop button on setup panel
*
*Revision 2.11  1995/06/20  23:29:28  Flick
*Added new "Height" member to all structures
*Added Lock button and time to Frame and Clip panels
*
*Revision 2.10  1995/04/27  14:24:17  Flick
*Re-added speed buttons to scrolls/crawls, re-aligned things
*
*Revision 2.9  1995/04/24  10:39:29  pfrench
*Changed Process button to read Cutting Rm.
*
*Revision 2.8  1995/03/16  14:27:49  CACHELIN4000
*Fix CRFX panel
*
*Revision 2.7  1995/03/05  17:06:37  CACHELIN4000
*Remove scroll/crawl speed controls
*
*Revision 2.6  1995/03/03  11:44:00  CACHELIN4000
*make labels more consistent, bag Start Key off fx panels
*
*Revision 2.5  1995/02/28  19:21:24  CACHELIN4000
*Occam off scroll controls
*
*Revision 2.4  1995/02/25  16:03:57  CACHELIN4000
*Change justification of Setup/FlyerOut controls
*
*Revision 2.3  1995/02/24  11:12:45  CACHELIN4000
*Change Start time text, order...
*
*Revision 2.2  1995/02/21  12:19:34  CACHELIN4000
*Add TimeMode popup to Audio panel
*
*Revision 2.1  1995/02/20  12:27:45  CACHELIN4000
*Just do stuff with bytes below
*
*Revision 2.0  1995/02/19  16:41:21  CACHELIN4000
*FirstCheckIn
*
*
* Copyright (c)1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/sghooks.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <editwindow.h>
#include <project.h>
#include <gadgets.h>
#include <prophelp.h>
#include <grazer.h>
#include <editswit.h>
#include <crouton_all.h>
#include <request.h>
#include <tags.h>
#include <panel.h>
#include <flyer.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>

#ifndef PROTO_PASS
#include <proto.h>
#else
DrawBGFunc *DrawBG();
#include "edit:proto/Pline.p"
#endif

#define SERDEBUG	1
#include <serialdebug.h>

#define	TESTING_ONLY	0

#undef CFAR
#define CFAR __far

#define CSTATIC
#define STATIC static

#define LAST_LINE						{ 0,0,0,0,0 }


CFAR  struct PanelLine EasyPanel_PL[23];
CFAR  struct PanelLine ExpertPanel_PL[28];
CFAR  struct PanelLine OtherPanel_PL[18];


CFAR  struct InitPanelLine ReqString_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STRING,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine ReqNum_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZNUM,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine ReqTime_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine ReqTell_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine ReqButtons_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_CHECK,PPOS_RIGHT,"",0,-1},
	{PNL_CHECK,PPOS_RIGHT,"",0,-1},
	{PNL_CHECK,PPOS_RIGHT,"",0,-1},
	{PNL_CHECK,PPOS_RIGHT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Setup_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"Toaster Setup",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_OUT_TYPE,PPOS_CENTER,"Control Monitor",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TOGGLE,PPOS_LEFT,"Video Input Termination",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_CENTER,"GPI Remote Trigger ",0,-1},
	{PNL_TOGGLE,PPOS_CENTER,"Flyer Out",0,-1},
	{PNL_CHECK,PPOS_CENTER,"Enable High Quality 6 Mode ",0,-1},
	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Options_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"Editor Options",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Experience Level ",0,-1},
	{PNL_CHECK,PPOS_CENTER,"Stop Recording on Dropped Frame ",0,-1},
	{PNL_CHECK,PPOS_CENTER,"Stop Sequence on Timing Error ",0,-1},
	{PNL_CHECK,PPOS_CENTER,"Prefer fine tune panels ",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Key On Default",0,30},
	{PNL_POPUP,PPOS_CENTER,"Key Off Default",0,30},
	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,0},		// Makes panel go wide
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Tweak_IPL[] = {
	{PNL_TEXT,PPOS_CENTER," Flyer Tweaks ",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_RIGHT,"Mode  ",0,-1},
	{PNL_EZNUM,PPOS_CENTER, "Position",0,-1},
	{PNL_EZNUM,PPOS_CENTER, "Clock",0,-1},
	{PNL_EZNUM,PPOS_CENTER, "Coarse",0,-1},
	{PNL_EZNUM,PPOS_CENTER, "Fine",0,-1},
//	{PNL_EZNUM,PPOS_CENTER, "Pedestal",0,-1},
//	{PNL_TOGGLE,PPOS_CENTER, "",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine TBC_IPL[] = {
	{PNL_TEXT,PPOS_CENTER," Flyer TBC Control ",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STEPSLIDE,PPOS_WIDER+PPOS_CENTER, "Horizontal",0,-1}, // Centered slider 0-0x7ff
	{PNL_STEPSLIDE,  PPOS_CENTER, "Phase",0,-1}, // Centered slider 0-0x7ff
	{PNL_STEPSLIDE,PPOS_WIDER+PPOS_LEFT, "Hue",0,-1},  // Centered slider -64 - 63
	{PNL_STEPSLIDE,  PPOS_LEFT, "Brightness",0,-1}, // 0 - 127
	{PNL_STEPSLIDE,PPOS_WIDER+PPOS_LEFT, "Saturation",0,-1},  // 0 - 127
	{PNL_STEPSLIDE,  PPOS_LEFT, "Contrast",0,-1},  // 0 - 127
//	{PNL_STEPSLIDE,PPOS_WIDER+PPOS_LEFT, "Fader",0,-1},  // 0 - 255
	{PNL_TEXT,PPOS_CENTER,"",0,-1},					// (Dead fader}
	{PNL_POPUP,  PPOS_CENTER, "Input",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine XPTBC_IPL[] = {
	{PNL_TEXT,PPOS_CENTER," Flyer TBC Control ",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_LEFT, "Input",0,-1},
	{PNL_POPUP,  PPOS_LEFT, "Key Mode",0,-1},
	{PNL_STEPSLIDE,  PPOS_CENTER, "Fader",0,-1},  // 0 - 255
	{PNL_DIVIDE,PPOS_LEFT," Termination  ",0,-1},
	{PNL_TOGGLE,  PPOS_CENTER, "",0,-1},
	{PNL_DIVIDE,PPOS_LEFT," Keyer  ",0,-1},
	{PNL_TOGGLE,  PPOS_CENTER, "",0,-1},
	{PNL_DIVIDE,PPOS_LEFT," Encoder  ",0,-1},
	{PNL_TOGGLE,  PPOS_CENTER, "",0,-1},
	{PNL_DIVIDE,PPOS_LEFT," Decoder  ",0,-1},
	{PNL_TOGGLE,  PPOS_CENTER, "",0,-1},
	{PNL_TEXT,PPOS_WIDER+PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Error_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"Vital Statistics ",0,-1},
	{PNL_TEXT,PPOS_CENTER," ",0,-1},					// Type
	{PNL_TEXT,PPOS_CENTER," ",0,-1},					// Name
	{PNL_TEXT,PPOS_CENTER," ",0,-1},					// Location
	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,0},		// Makes panel go wide
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR struct InitPanelLine RawRec_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"        Record Raw Footage",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_RIGHT,"  Drive",0,30},
	{PNL_POPUP,PPOS_CENTER,"Quality",0,30},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_DIFF,PPOS_LEFT,"Approximate Time Available ",0,25},
	{PNL_DIFF,PPOS_LEFT,"Reorganized Time Available ",0,0},
	{PNL_BUTTON,PPOS_HALF2+PPOS_CENTER,"Reorganize Drive",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_DIFF,PPOS_HALF1+PPOS_CENTER,"Dropped ",-5,16},
	{PNL_DIFF,PPOS_WIDER+PPOS_CENTER,"Length ",0,0},
	{PNL_POPUP,PPOS_RIGHT,"   Source",0,PIN_H+6},
	{PNL_STEPSLIDE,PPOS_WIDER+PPOS_LEFT,"Audio Gain L",0,-1},  // 0 - 15
	{PNL_STEPSLIDE,PPOS_LEFT,"Audio Gain R",0,-1},  // 0 - 15
	{PNL_TEXT,PPOS_CENTER,NULL,0,26+8+PNL_DIV},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
//	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_LEFT,"Cut Clips",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR struct InitPanelLine ProcClip_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},			// Title + original name
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STRING,PPOS_LEFT,"Clip Name",0,30},
	{PNL_STRING,PPOS_LEFT,"Comment",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Destination",0,-1},		// 30?
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,57},
	{PNL_TEXT,PPOS_CENTER,NULL,0,32}, // This one is the space for the bar
	{PNL_BUTTON,PPOS_LEFT,"Remove",6,0},
	{PNL_BUTTON,PPOS_RIGHT,"Previous",-105,0},
	{PNL_BUTTON,PPOS_RIGHT,"Next",-5,-1},
	{PNL_FLYTIME,PPOS_LEFT,"Icon",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Include",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Perform",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR struct InitPanelLine CutClip_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},			// Title + original name
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STRING,PPOS_LEFT,"Clip Name",0,30},
	{PNL_STRING,PPOS_LEFT,"Comment",0,-1},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,57},
	{PNL_TEXT,PPOS_CENTER,NULL,0,32}, // This one is the space for the bar
	{PNL_BUTTON,PPOS_LEFT,"Remove",6,0},
	{PNL_BUTTON,PPOS_RIGHT,"Previous",-105,0},
	{PNL_BUTTON,PPOS_RIGHT,"Next",-5,-1},
	{PNL_FLYTIME,PPOS_LEFT,"Icon",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Include",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Perform",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Record Panel",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine FileInfo_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"File Information",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STRING,PPOS_CENTER,"Name",10,-1},
	{PNL_TEXT,PPOS_CENTER,"Type",0,-1},
	{PNL_TEXT,PPOS_CENTER,"COMP",0,-1},
	{PNL_TEXT,PPOS_LEFT,"Description",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},				// Clip time
	{PNL_TEXT,PPOS_CENTER,"File Size",0,-1},
	{PNL_TEXT,PPOS_CENTER,"Date",0,-1},
	{PNL_TEXT,PPOS_LEFT,"Attributes",0,-1},
	{PNL_TEXT,PPOS_LEFT,"Protection",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine DriveInfo_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"Drive Information",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_CENTER,"Name",0,-1},
	{PNL_TEXT,PPOS_CENTER,"Type",0,-1},		// Video drive/Audio drive/Non-Flyer drive
	{PNL_TEXT,PPOS_CENTER,"Size",0,-1},
	{PNL_TEXT,PPOS_CENTER,"% free",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_CENTER,"Lrg",0,-1},		// Largest
	{PNL_TEXT,PPOS_CENTER,"ReOrg",0,-1},		// Largest if reorg'd
	{PNL_BUTTON,PPOS_CENTER,"Reorganize",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_CENTER,"Continue",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Rexx_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"ARexx Macro",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_STRING,PPOS_CENTER,"Parameters:",0,-1},
	{PNL_TOGGLE,PPOS_CENTER," ",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Frame_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,72-10},

	{PNL_CHECK,PPOS_WIDER+PPOS_CENTER,"Lock",0,0},
	{PNL_EZTIME,PPOS_RIGHT,"Time",0,-1},

	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


/*** UNUSED!!! ***/
CFAR  struct InitPanelLine LumaKey_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Luminance Key Control",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_IN_TYPE,PPOS_LEFT,"Clip",0,-1},
	{PNL_EZNUM,PPOS_WIDER+PPOS_CENTER,"Level",0,-1},
	{PNL_EZTIME,PPOS_WIDER+PPOS_CENTER,"Start Time",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


/*** UNUSED!!! ***/
CFAR  struct InitPanelLine Trails_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Trails Control",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZNUM,PPOS_RIGHT,"Effect Level",0,-1},
	{PNL_EZLEN,PPOS_WIDER+PPOS_RIGHT,"Start Time",0,-1},
	{PNL_EZLEN,PPOS_RIGHT,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine CFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},

	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length",0,-1},
//	{PNL__CHECK,PPOS_WIDER+PPOS_CENTER,"Clip Length"

	{PNL_FXSPEED,PPOS_WIDER+PPOS_LEFT,"Speed",0,-1},
	{PNL_POPUP,PPOS_LEFT,"Cycles ",0,-1},
	{PNL_STEPSLIDE,PPOS_LEFT,"Effect Position",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_LEFT,"Modes ",0,-1},
	{PNL_POPUP,PPOS_LEFT," ",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Main_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Video Input",0,-1},
	{PNL_TEXT,PPOS_LEFT,"name",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

#if 0
CFAR  struct InitPanelLine XPMain_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Video Input",0,-1},
	{PNL_TEXT,PPOS_LEFT,"name",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TIME,PPOS_CENTER,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
#endif

CFAR  struct InitPanelLine Ctrl_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Control",0,-1},
	{PNL_TEXT,PPOS_LEFT,"name",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


#if 0
CFAR  struct InitPanelLine AlgoFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_FXSPEED,PPOS_LEFT,"Speed",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine XPAlgoFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_LEFT,"Speed",0,-1},
	{PNL_EZLEN,PPOS_CENTER,"Length ",0,-1},
	{PNL_POPUP,PPOS_RIGHT,"Effect Color ",0,-1},
//	{PNL_EZTIME,PPOS_CENTER,"Start Key",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
#endif

CFAR  struct InitPanelLine TransFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Fine Tune",0,72-7},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_CENTER,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},			// For fixed-only len panels
	{PNL_EZLEN,PPOS_CENTER,"Length",0,-1},			// For variable len panels
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine XPTransFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Quick Tune",0,72-7},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_CENTER,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},			// For fixed-only len panels
	{PNL_EZLEN,PPOS_CENTER,"Length",0,-1},			// For variable len panels
	{PNL_EZLEN,PPOS_CENTER,"Take Frame",0,-1},
	{PNL_EZLEN,PPOS_WIDER+PPOS_CENTER,"A src length",0,-1},
	{PNL_EZLEN,PPOS_CENTER,"B src length",0,-1},
	{PNL_POPUP,PPOS_CENTER,"Effect Color ",0,-1},
//	{PNL_EZLEN,PPOS_CENTER,"Start Key",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine OlayFX_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_CENTER,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"",0,-1},					// Wording varies for types
	{PNL_POPUP,PPOS_RIGHT,"Matte Color",0,-1},	// Matte color
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length ",-20,-1},	// Only for looping types
	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, 		// Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1},		// Start Time
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Clip_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"Video Clip",0,7},			/* Icon, name, comment */
	{PNL_BUTTON,PPOS_RIGHT,"Fine Tune",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Envelope",-130,0},
	{PNL_TEXT,PPOS_CENTER,NULL,0,72-17},
	{PNL_CHECK,PPOS_WIDER+PPOS_CENTER,"Lock",0,0},
	{PNL_EZTIME,PPOS_RIGHT,"Time",0,5},

	{PNL_PLAY,PPOS_LEFT,"",2,22},							/* Play/Stop buttons */

//	{PNL_DIFF,PPOS_LEFT,"Length",0,22},					/* Length time */
	{PNL_DIVIDE,PPOS_LEFT,"",0,8},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H-9},			/* Length time */
//	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,-1},
//	{PNL_DIVIDE,PPOS_LEFT,"Audio ",0,-1},
//	{PNL_CHECK,PPOS_LEFT,"Use Envelope",0,0},
	{PNL_TOGGLE,PPOS_RIGHT,0,0,PIN_H-6},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Process Clip",-55,0},
	{PNL_BUTTON,PPOS_CENTER,"Cut Clip",55,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE  											// end of array marker
};


CFAR  struct InitPanelLine XPClip_IPL[] = {
//	{PNL_TEXT,PPOS_LEFT,"Video Clip",0,-1},
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Quick Tune",0,0},

	{PNL_BUTTON,PPOS_RIGHT,"Envelope",-130,0},

	{PNL_TEXT,PPOS_CENTER,NULL,0,72-17},
	{PNL_CHECK,PPOS_WIDER+PPOS_CENTER,"Lock",0,0},
	{PNL_EZTIME,PPOS_RIGHT,"Time",0,5},

	{PNL_PLAY,PPOS_LEFT,"",2,22},
//	{PNL_DIFF,PPOS_LEFT,"Length",0,22},
	{PNL_DIVIDE,PPOS_CENTER," Video ",0,8},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_CENTER," Audio ",0,8},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H-15},
//	{PNL_TEXT,PPOS_LEFT,NULL,0,0},								// Pad down
//	{PNL_EZNUM,PPOS_WIDER+PPOS_CENTER,"Volume",0,-1},
	{PNL_NUMSLIDER,PPOS_CENTER,"Volume",0,54},
	{PNL_EZSLIDER,PPOS_CENTER,"Balance",0,-1},
	{PNL_TEXT,PPOS_LEFT,NULL,0,-96},								// Move back up
	{PNL_EZLEN,PPOS_HALF2+PPOS_RIGHT,"Fade In",0,0},
	{PNL_CHECK,PPOS_HALF2+PPOS_CENTER,"Auto",47,PIN_H-16},
	{PNL_EZLEN,PPOS_HALF2+PPOS_RIGHT,"Fade Out",0,0},
	{PNL_CHECK,PPOS_HALF2+PPOS_CENTER,"Auto",47,PIN_H-4},
	{PNL_POPUP,PPOS_HALF2+PPOS_CENTER,"Channels",0,-1},
//	{PNL_CHECK,PPOS_CENTER,"Use Envelope",0,25},
	{PNL_DIVIDE,PPOS_CENTER,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Process Clip",-55,0},
	{PNL_BUTTON,PPOS_CENTER,"Cut Clip",55,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE 										// end of array marker
};

CFAR  struct InitPanelLine AudClip_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Fine Tune",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Envelope",-130,0},
	{PNL_TEXT,PPOS_CENTER,NULL,0,72-17},
	{PNL_PLAY,PPOS_LEFT,"",2,-1},							/* Play/Stop buttons */
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
//	{PNL_DIFF,PPOS_LEFT,"Length ",0,0},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H-9},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_RIGHT,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Process Clip",-55,0},
	{PNL_BUTTON,PPOS_CENTER,"Cut Clip",55,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

// Backup copy of the audio panel. 
#if 0
CFAR  struct InitPanelLine AudClip_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Fine Tune",0,},
	{PNL_BUTTON,PPOS_RIGHT,"Envelope",-130,72-12},
//	{PNL_TEXT,PPOS_CENTER,NULL,0,72-17},
	{PNL_PLAY,PPOS_LEFT,"",2,-1},							/* Play/Stop buttons */
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
//	{PNL_DIFF,PPOS_LEFT,"Length ",0,0},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H-9},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_RIGHT,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Process Clip",-55,0},
	{PNL_BUTTON,PPOS_CENTER,"Cut Clip",55,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
#endif


CFAR  struct InitPanelLine XPAudClip_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,7},
	{PNL_BUTTON,PPOS_RIGHT,"Quick Tune",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Envelope",-130,0},
	{PNL_TEXT,PPOS_CENTER,NULL,0,72-17},
	{PNL_PLAY,PPOS_LEFT,"",2,-1},							/* Play/Stop buttons */
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
//	{PNL_DIFF,PPOS_LEFT,"Length ",0,0},
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},
	{PNL_DIFF,PPOS_CENTER,"Len ",0,PTIME_H},
	{PNL_TEXT,PPOS_LEFT,"",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time
	{PNL_NUMSLIDER,PPOS_CENTER,"Volume",0,54},
	{PNL_EZSLIDER,PPOS_CENTER,"Balance",0,-1},
	{PNL_TEXT,PPOS_LEFT,NULL,0,-96},								// Move back up
	{PNL_EZLEN,PPOS_HALF2+PPOS_CENTER,"Fade In",0,PIN_H-16},
	{PNL_EZLEN,PPOS_HALF2+PPOS_CENTER,"Fade Out",0,PIN_H-4},
	{PNL_POPUP,PPOS_HALF2+PPOS_CENTER,"Channels",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_CENTER,"Process Clip",-55,0},
	{PNL_BUTTON,PPOS_CENTER,"Cut Clip",55,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Key_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length ",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time
	{PNL_DIVIDE,PPOS_CENTER," Fades ",0,-1},
	{PNL_TOGGLE,PPOS_CENTER," ",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_CENTER,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},			// Fixed-only fade speeds
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

#if 0
CFAR  struct InitPanelLine XPKey_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_EZTIME,PPOS_CENTER,"Length ",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TOGGLE,PPOS_CENTER,"  Fades",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_CENTER,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},			// Fixed-only fade speeds
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
#endif

CFAR  struct InitPanelLine Crawl_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},

//	{PNL_TEXT,PPOS_LEFT,"",0,-1},
//	{PNL_TEXT,PPOS_LEFT,"",0,-1},

	{PNL_CHOICE4,PPOS_WIDER+PPOS_LEFT," Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},

	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER," Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time

//	{PNL_EZTIME,PPOS_WIDER+PPOS_LEFT,"Delay from",0,-1}, // Start Time
//	{PNL_POPUP,PPOS_CENTER,"previous",0,-1}, // Start Time
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Scroll_IPL[] = {
	{PNL_CROUTON,PPOS_LEFT,"",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
//	{PNL_TEXT,PPOS_LEFT,"",0,-1},
//	{PNL_TEXT,PPOS_LEFT,"",0,-1},

	{PNL_CHOICE5,PPOS_WIDER+PPOS_LEFT,"Speed",0,-1},
	{PNL_FXTIME,PPOS_LEFT,"Length ",0,-1},

	{PNL_POPUP,PPOS_WIDER+PPOS_CENTER,"Lock to",0,-1}, // Time Mode
	{PNL_EZTIME,PPOS_RIGHT,"Start Time",0,-1}, // Start Time

	{PNL_EZTIME,PPOS_CENTER,"Hold Duration",0,-1},
//	{PNL_EZTIME,PPOS_LEFT,"Fade Out",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR  struct InitPanelLine Quick_IPL[] = {
	{PNL_FLYTIME,PPOS_CENTER,"",0,-1},
	{PNL_FLYTIME,PPOS_CENTER,"",0,-1},
	{PNL_FLYTIME,PPOS_CENTER,"",0,-1},
	{PNL_FLYTIME,PPOS_CENTER,"",0,-1},
	LAST_LINE
};

CFAR struct InitPanelLine ReqFlyJog_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"",0,-1},				// Title
	{PNL_TEXT,PPOS_CENTER,NULL,0,64},				// Title
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_CENTER,"",0,-1},				// Name of clip
	{PNL_FLYTIME,PPOS_LEFT,"",0,-1},				// Single knob version
	{PNL_DUOSLIDE,PPOS_LEFT,"",0,5},				// Dual knob version
	{PNL_DIFF,PPOS_CENTER,"Len ",0,57},
	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,0},	// Makes panel go wide
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};


CFAR struct InitPanelLine Env_IPL[] = {
	{PNL_TEXT,PPOS_CENTER,"Audio Envelope",120,-1},				// Title
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_TEXT,PPOS_WIDER+PPOS_LEFT,"",0,-1},	// Makes panel go wide
	{PNL_TEXT,PPOS_CENTER,NULL,0,65},		//was 75


	{PNL_POPUP,PPOS_CENTER,"",0,-1}, 							// SHOULD BE MULT EXCL.
	{PNL_EZTIME,PPOS_WIDER+PPOS_LEFT,"Key Time",10,-1}, // Start Time
	{PNL_EZNUM,PPOS_WIDER+PPOS_RIGHT,"Key Volume",0,-1},

	{PNL_TEXT,PPOS_CENTER,NULL,0,10},		
	{PNL_CHECK,PPOS_CENTER,"Use Envelope",0,0},

	{PNL_TEXT,PPOS_CENTER,NULL,0,30},	// Makes panel go wide
	{PNL_DIVIDE,PPOS_LEFT,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},      
	LAST_LINE
};



/*
CFAR  struct InitPanelLine Test_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"TEXT L",0,-1},
	{PNL_DIVIDE,PPOS_LEFT,"DIVIDE L",0,-1},
	{PNL_TEXT,PPOS_CENTER,"TEXT C",0,-1},
	{PNL_DIVIDE,PPOS_CENTER,"DIVIDE C",0,-1},
	{PNL_STRING,PPOS_WIDER+PPOS_LEFT,"STRING L",0,-1},
	{PNL_STRING,PPOS_CENTER,"STRING C",0,-1},
	{PNL_POPUP,PPOS_WIDER+PPOS_RIGHT,"POPUP ",0,-1},
	{PNL_EZNUM, PPOS_CENTER, "EZNUM C",0,-1},
	{PNL_TOGGLE,PPOS_CENTER,"TOGGLE C",0,-1},
	{PNL_DUOSLIDE,PPOS_LEFT,"DuoSLide",0,-1},
	{PNL_DIFF,PPOS_WIDER+PPOS_CENTER,"",0,-1},
//	{PNL_EZTIME,PPOS_WIDER+PPOS_LEFT,"EZTIME L",0,-1},
//	{PNL_EZTIME,PPOS_CENTER,"EZTIME C",0,-1},
	{PNL_DIVIDE,PPOS_CENTER,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Test_IPL3[] = {
	{PNL_CROUTON,PPOS_CENTER,"CROUTON C",0,-1},
	{PNL_CHOICE4,PPOS_WIDER+PPOS_CENTER,"CHOICE4 C",0,-1},
	{PNL_EZSLIDER,PPOS_LEFT,"EZSLIDER",0,-1},
	{PNL_TOGGLE,PPOS_LEFT,"TOGGLE L",0,-1},
	{PNL_EZLEN,PPOS_WIDER+PPOS_CENTER, "EZLEN C",0,-1},
	{PNL_EZLEN, PPOS_LEFT, "EZLEN L",0,-1},
	{PNL_IN_TYPE,PPOS_WIDER+PPOS_CENTER,"IN_TYPE C",0,-1},
	{PNL_OUT_TYPE,PPOS_CENTER,"OUT_TYPE C",0,-1},
	{PNL_CHOICE5,PPOS_CENTER,"CHOICE5 C",0,-1},
	{PNL_NUMBER,PPOS_WIDER+PPOS_CENTER,"NUMBER C",0,-1},
	{PNL_NUMBER,PPOS_LEFT,"NUMBER L",0,-1},
	{PNL_DIVIDE,PPOS_CENTER,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};

CFAR  struct InitPanelLine Test_IPL2[] = {
	{PNL_CROUTON,PPOS_CENTER,"CROUTON L",0,-1},
	{PNL_FXSPEED,PPOS_WIDER+PPOS_LEFT,"FXSPEED",0,-1},
	{PNL_SLIDER,PPOS_LEFT,"SLIDER",0,-1},
	{PNL_TOGGLE,PPOS_LEFT,"TOGGLE L",0,-1},
	{PNL_TIME,PPOS_WIDER+PPOS_CENTER,"TIME C",0,-1},
	{PNL_TIME,PPOS_LEFT,"TIME L",0,-1},
	{PNL_DIFF,PPOS_WIDER+PPOS_LEFT,"DIFF L ",0,-1},
	{PNL_DIFF,PPOS_CENTER,"DIFF C ",0,-1},
	{PNL_VCR,PPOS_WIDER+PPOS_LEFT,"VCR",0,-1},
	{PNL_PLAY,PPOS_LEFT,"PLAY",0,-1},
	{PNL_DIVIDE,PPOS_CENTER,"",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
*/

#if TESTING_ONLY
CFAR  struct InitPanelLine XPTest_IPL[] = {
	{PNL_TEXT,PPOS_LEFT,"Control Panel Test",0,-1},
	{PNL_DIVIDE,PPOS_LEFT," Blammo! ",0,-1},
	{PNL_STRING,PPOS_WIDER+PPOS_LEFT,"Name",0,-1},
	{PNL_POPUP,PPOS_RIGHT,"Panel Type",0,-1},
	{PNL_NUMBER, PPOS_CENTER, "% Potato",0,-1},
	{PNL_PLAY,PPOS_CENTER,"Test Panel? ",0,-1},
	{PNL_DIVIDE,PPOS_CENTER,"  Bye Bye  ",0,-1},
	{PNL_BUTTON,PPOS_LEFT,"Continue",0,0},
	{PNL_BUTTON,PPOS_RIGHT,"Cancel",0,33},
	LAST_LINE
};
#endif

/* End .... Whew */
