/* $Id: panel.c,v 2.146 1996/11/21 13:34:53 Holt Exp $
* $Log: panel.c,v $
*Revision 2.146  1996/11/21  13:34:53  Holt
*fixed problem with keys not draging in time. hardcoded action in keyadjust.
*
*Revision 2.145  1996/11/18  18:40:35  Holt
*added code to validate keys after in/out points are moved.
*
*Revision 2.144  1996/07/29  10:29:31  Holt
*added part of the audioenv panel.
*
*Revision 2.143  1995/12/26  18:19:59  Holt
*changed several fixtimestr calls to get back cframe aligned times
*
*Revision 2.142  1995/10/28  02:02:12  Flick
*No longer clear PlayFG when entering FlyPanel, added misc INTUITICKS debugging
*
*Revision 2.141  1995/10/17  16:59:57  Flick
*Left/Right arrow keys not timeout and go quiet, up/down keys cleaned up lots, go quiet
*work on single sliders now, too.  "Cutting clip..." reads "Processing clips" for non-destr.
*
*Revision 2.140  1995/10/12  16:37:18  Flick
*FlyPanel/RAWKEY_LEFT&RIGHT would only Flyer jog if PL_DUAL (changed to PL_FLYER)
*
*Revision 2.139  1995/10/09  23:31:04  Flick
*Fixed quick adjust shadow math (always positive!)
*
*Revision 2.138  1995/10/09  16:37:59  Flick
*Removed unnecessary usage of popup.h
*
*Revision 2.137  1995/10/06  18:50:52  Flick
*LiveFlyer changed to DualFlyer to allow FlyPanel to shuttle on single sliders too
*
*Revision 2.136  1995/10/05  18:46:03  Flick
*Record panel now uses all new Flyer_ functions (no more ES!)
*Now warns instead of crashing when proc/cutting non-existent clip in project
*Fixed bug with skipping "cut?" requester in cutting room
*
*Revision 2.135  1995/10/05  03:48:03  Flick
*Fixed bad quick tune + shadow bug on outpoint (miscomputed min value -- would fall of the Earth)
*Quick tune shadow feature would refuse to work with audio-only and video-only clips -- fixed
*Cut/proc panels right arrow key would cause hit after clicking on new sub-clip in bar
*Removed unused Qual[] array of video qualities, //'d lots of extra debugging to reduce data size
*
*Revision 2.134  1995/10/03  18:10:46  Flick
*Quick adjust now uses TCDarkFont (removed RectFill's)
*ReOrg from drive info panel now exits panel when donw
*Made 2 versions of verif.req. on starting clip cutting (based on raw or existing clip)
*Raw clip warning skipped if disabled in prefs
*
*Revision 2.133  1995/10/02  15:47:29  Flick
*Cutting room panel: doesn't put up "destroys original" req if came from rec panel
*If user cancels this req, cleans up properly now and drops back into cutting panel.
*Added Dest Drive popup in processing panel.
*Quick tune now support shadow function, hotkeys shuffled around again, uses beveled hilite
*box now, ready to use new TCDarkFont (when fixed), added arrow keys (???)
*
*Revision 2.132  1995/09/28  10:15:07  Flick
*Now uses RawKeyCodes.h, cutting/proc panels now work correctly within subdirs, subclip name
*string was being activated too early on panel open, looks better now, quick tune panel now
*supports arrow keys and ganging points together w/ SPACE bar, fixed deadlock when releasing
*ALT while jogging.
*
*Revision 2.131  1995/09/25  13:42:57  Flick
*Added Dropped line to RawRec panel, added Quick tune panel & support fn's
*Cutting/Proc panels: fixed drive name bug, activates name string when new name built
*
*Revision 2.130  1995/09/19  12:35:19  Flick
*Changed panels to use less hard-coded buttons (i.e. Continue/Cancel), moved almost all to
*GenButtons that can have custom options (like, uh, text label!)
*
*Revision 2.129  1995/09/13  12:33:09  Flick
*Ancillary functions moved to new PanelHelp.c to reduce code bulge
*Added 3-color audio meters with clip and peak hold.  Support for Switcher fix
*on ES_Jump by adding DHD_Jump "quiet" option.
*Lots of new stuff for CutClipPanel: new calling args to be used both destr. and
*non-destructively, support "include" popup, verification requester on "continue"
*for destructive version, lots of fixes on icon slider, new logic when adding a
*new clip (fills all space, Left/Right ALT options).
*
*Revision 2.128  1995/08/18  17:01:29  Flick
*Lotsa changes to FlyPanel: left/right arrow keys would break if you touched any
*other gadgets except for duoslide stuff.  They now also stop a play if in prog.
*Duoslider knob would "miss" the first grab after playing clip
*In/Out point strings work much better -- (used to clobber wrong points, or
*could not be highlighted, or would lose tag values on exit: unless you were
*nice and hit RETURN after making changed)
*
*Revision 2.127  1995/08/16  10:57:32  Flick
*Added support for SHADOW function
*Fixed some knob trashing on "remove" in cutting panels, fixed 'S' still function
*Added duplicate name test before cutting clips (now may re-enter panel to fix)
*
*Revision 2.126  1995/08/09  17:57:22  Flick
*Reworked CutClipPanel, make it use a shared structure to make it easier to add
*features to such as: N & P hotkeys to navigate thru subclips
*Fixed bugs where knobs trashed each other for subclips
*Selected subclip is now always rendered last, so it's fully visible
*
*Revision 2.125  1995/07/27  18:11:03  Flick
*Added support for DELETE button in markclips/clip proc panels
*Fixed destr. cutting room to not reopen if partially cut/tossed original
*
*Revision 2.124  1995/07/14  16:03:41  Flick
*Fixed ReOrg on audio drives, removed spkr symbol from volname in requester
*
*Revision 2.123  1995/07/13  13:04:19  Flick
*More debugging to test DHD_CheckRecord use during play (not happening)
*
*Revision 2.122  1995/06/20  23:31:37  Flick
*Added "height" member to QualPL structure
*
*Revision 2.121  1995/06/15  12:37:17  Flick
*Icon creation will now succeed even if CutClipPanel gives bogus icon field
*
*Revision 2.120  1995/06/13  18:44:07  Flick
*Added error checking to cutting room/clip processing
*Will take you back to panel if problems occur
*
*Revision 2.119  1995/04/28  13:32:00  Flick
*Record raw clip pause button no longer hilites unless recording
*Record & Re-org buttons in record panel handle 0 Flyer drives correctly now
*
*Revision 2.118  1995/04/28  12:07:10  Flick
*Fixed long-standing record panel bug (if 1 Flyer drive)
*Cleaned up many other dangerous if/for/while instructions that had code
*  which was not protected by { }
*
*Revision 2.117  1995/04/25  15:09:29  Flick
*Reworked UpdateAudIndicator to make 2nd clip LED correct level, not be "sticky"
*Also improved response time of LED's and reduces pointer flashiness
*
*Revision 2.116  1995/04/24  16:28:03  Flick
*Fixed RenderSlide to handle field #'s above 64K (18 minutes)
*
*Revision 2.115  1995/04/19  08:19:37  pfrench
*Fixed Mungwall hit on close clip reqester via ENTER key
*
*Revision 2.114  1995/04/18  19:44:59  pfrench
*Non-working attempt at fixing enter on clip panel bug
*
*Revision 2.113  1995/03/16  14:37:16  CACHELIN4000
**** empty log message ***
*
*Revision 2.112  1995/03/10  18:37:58  CACHELIN4000
*Fix CrUD
*
*Revision 2.111  1995/03/09  18:05:18  CACHELIN4000
*Add tags to flyerstill cruds, limit crashiness of icon slider
*
*Revision 2.110  1995/03/09  10:19:01  CACHELIN4000
*Cutting roiom flyerstill support
*
*Revision 2.109  1995/03/07  16:08:17  CACHELIN4000
*Handle new DroppedFrames error, fix pause->record bug
*
*Revision 2.108  1995/03/03  11:45:55  CACHELIN4000
*Fix clip length rounding on cutting room, pause/stop/rec interaction, etc.
*
*Revision 2.107  1995/02/28  19:20:29  CACHELIN4000
*Fix logic bug in pause, gadget highlight, move clip indicator over
*
*Revision 2.106  1995/02/27  13:41:57  CACHELIN4000
*Change audio bargraph to indicators
*
*Revision 2.105  1995/02/26  14:20:52  CACHELIN4000
*Allow Stop, Rec to function while record is paused, fix FixTime() for len.s
*
*Revision 2.104  1995/02/24  11:13:07  CACHELIN4000
*Fix flags confusion on cutting room, etc.
*
*Revision 2.103  1995/02/22  10:16:51  CACHELIN4000
*Fix cutting room (i hope)!
*
*Revision 2.102  1995/02/20  12:32:25  CACHELIN4000
**** empty log message ***
*
*Revision 2.101  1995/02/19  16:57:40  CACHELIN4000
**** empty log message ***
*
*Revision 2.100  1995/02/19  01:49:58  CACHELIN4000
*Add Audio VUs, Cutting Room SMPTE trix
*
*Revision 2.99  1995/02/13  14:37:47  CACHELIN4000
**** empty log message ***
*
*Revision 2.98  1995/02/11  17:53:39  CACHELIN4000
*Add audio record level support functions, BarGraph struct
*
*Revision 2.97  1995/02/03  12:46:46  pfrench
*Removed direct serial debugging calls
*
*Revision 2.96  1995/02/01  17:53:39  CACHELIN4000
*Fix Pause, CuttingRoom Icons, Process Room
*
*Revision 2.95  1995/01/25  18:36:38  CACHELIN4000
*Add MOUSEMOVE support to MiniPanel()
*
*Revision 2.94  1995/01/24  18:06:37  CACHELIN4000
**** empty log message ***
*
*Revision 2.93  1995/01/24  16:50:57  CACHELIN4000
*Add Icon making for CuttingRoom
*
*Revision 2.92  1995/01/24  11:20:21  CACHELIN4000
*Cutting Room functions, panel support
*
*Revision 2.91  1995/01/13  12:56:59  CACHELIN4000
*Add support for PL_PARTNER to RCB functions,
*update available sizes after record, etc.
*
*Revision 2.90  1994/12/31  02:11:29  CACHELIN4000
**** empty log message ***
*
*Revision 2.89  1994/12/28  17:38:30  CACHELIN4000
*Keep Panels from opening above EditTop->TopEdge
*
*Revision 2.88  1994/12/24  12:42:26  CACHELIN4000
**** empty log message ***
*
*Revision 2.87  1994/12/23  16:12:53  CACHELIN4000
*turn off serial debug statements
*
*Revision 2.86  1994/12/23  11:38:44  CACHELIN4000
*Use PropEnd for string limits
*
*Revision 2.85  1994/12/22  20:48:27  CACHELIN4000
*Prevent video recording on audio drives
*
*Revision 2.84  1994/12/07  00:13:12  CACHELIN4000
*Audio drive name bug fixed, rec vavilable updates on drive/compression changes
*
*Revision 2.83  1994/12/05  20:05:59  CACHELIN4000
*Use global CurCompMode for retain compression settings
*
*Revision 2.82  1994/12/05  19:24:24  CACHELIN4000
*Quash verminous infestation in CutClipPanel(), add NO_CUTTINGROOM define
*I got a car today!! Ha Ha.  Paid $800 in sales tax though aieee!
*
*Revision 2.81  1994/12/04  22:57:03  CACHELIN4000
*Bring CurClipPanel into modern age, add SetHiLo()
*
*Revision 2.80  1994/12/03  18:34:56  CACHELIN4000
*Add QuickTune gadget, etc.
*
*Revision 2.79  1994/11/30  23:24:43  CACHELIN4000
* PL_SMREF)
*
*Revision 2.78  1994/11/30  11:24:23  CACHELIN4000
*Skip over Internal flyer sources 'til TBC stuff is ready
*
*Revision 2.77  1994/11/18  16:53:19  CACHELIN4000
*I don't remember what I changed...
*
*Revision 2.76  1994/11/04  16:54:02  CACHELIN4000
*PL_PLAY support
*
*Revision 2.75  94/11/04  00:29:53  CACHELIN4000
*Set InPL=AInPL, OutPL=AOutPL  on Audio only panel ==> Enforcer happy now
*
*Revision 2.74  94/11/03  23:02:42  CACHELIN4000
*Add flyer error messages to record panel, remove audio toggle handling trix
*
*Revision 2.73  94/11/02  20:21:55  CACHELIN4000
*Prevent recording of clips w/out audio or video
*
*Revision 2.72  94/10/31  17:08:37  CACHELIN4000
*Fix diff-update bug
*
*Revision 2.71  94/10/27  23:16:07  CACHELIN4000
*Set new PLine->Win in Panel() calls, change DrawPanel f'n to use PLine->Win
*
*Revision 2.70  94/10/25  18:09:51  CACHELIN4000
**** empty log message ***
*
*Revision 2.69  94/10/24  17:11:52  CACHELIN4000
*Add MiniPanel() for simplified non-flyer panel calls...
*
*Revision 2.68  94/10/24  12:20:51  CACHELIN4000
*Break non-DUAL flyer sliders... fix others
*
*Revision 2.67  94/10/20  11:56:02  CACHELIN4000
**** empty log message ***
*
*Revision 2.66  94/10/12  20:41:32  CACHELIN4000
**** empty log message ***
*
*Revision 2.65  94/10/12  17:37:36  CACHELIN4000
**** empty log message ***
*
*Revision 2.64  94/10/11  21:38:52  CACHELIN4000
*DuoSlide/PL_DUAL implementation
*
*Revision 2.63  94/10/10  17:18:20  CACHELIN4000
*Add record (SPACE) hotkey
*
*Revision 2.62  94/10/07  11:39:24  CACHELIN4000
*let EZgads go negative...
*
*Revision 2.61  94/10/06  23:04:11  CACHELIN4000
*Connect up audio shuttle real good.
*
*Revision 2.59  94/10/06  10:47:02  CACHELIN4000
*Audio control fixes...
*
*Revision 2.58  94/10/05  16:27:45  CACHELIN4000
*Fix Comment editing bug in Panel() (Param2 vs PropEnd for str max)
*
*Revision 2.57  94/10/05  01:04:36  CACHELIN4000
*Add PNL_DIFF add-on (G5) to UpdateDiff()
*
*Revision 2.56  94/10/04  17:52:55  CACHELIN4000
*Fix string/Popup bug on record panel
*
*Revision 2.55  94/10/03  18:47:44  CACHELIN4000
*Un-hilite REC before writing icon, Don't record if record button used to stop
*
*Revision 2.54  94/10/02  00:30:17  CACHELIN4000
**** empty log message ***
*
*Revision 2.53  94/10/02  00:02:42  CACHELIN4000
*fix PNL_SKIP type bug...
*
*Revision 2.52  94/10/01  01:06:10  Kell
*Now calls code to make a clip icon after record.
*
*Revision 2.51  1994/09/30  21:56:28  CACHELIN4000
**** empty log message ***
*
*Revision 2.50  94/09/30  11:29:41  CACHELIN4000
*Set Startup record source to 1 (camcorder in)
*
*Revision 2.49  94/09/29  23:47:14  CACHELIN4000
*Add NoticeWindow, WaitSprite to reorganize f'n
*
*Revision 2.48  94/09/29  16:28:18  CACHELIN4000
*
*Revision 2.44  94/09/28  14:47:29  CACHELIN4000
*Dummied out NewClip MarkClips button
*
*Revision 2.42  94/09/27  17:22:10  CACHELIN4000
*Record Panel work: Poll CheckRecord, guestimate recorded duration, use PL_LEN
*
*Revision 2.40  94/09/23  10:33:53  CACHELIN4000
*Record Panel, CutCLip Panel work, Audio controls
*
*Revision 2.39  94/09/20  23:39:48  CACHELIN4000
*PNL_SKIP support, etc.
*
*Revision 2.38  94/09/13  20:16:48  CACHELIN4000
*Fixes to CroutonString, RMB Shuttle, update strings without an <enter>
*
*Revision 2.37  94/09/12  18:52:12  CACHELIN4000
*DHD_Shuttle On Now...  other coolish fixes..
*
*Revision 2.36  94/09/12  13:03:05  CACHELIN4000
*Move all PLine member functions to PLine.c to allow compile/link to succeed
*
*Revision 2.35  94/09/10  20:10:39  CACHELIN4000
**** empty log message ***
*
*Revision 2.34  94/09/09  20:49:39  CACHELIN4000
**** empty log message ***
*
*Revision 2.32  94/09/09  13:46:38  CACHELIN4000
*Gurm
*
*Revision 2.31  94/09/06  22:26:50  CACHELIN4000
*PNL_CROUTON type enhancements
*
*Revision 2.30  94/09/05  19:06:38  CACHELIN4000
*ES_Jump support added { DHD_Jump() }
*
*Revision 2.27  94/09/02  20:17:18  CACHELIN4000
*MouseX, many fixes for DHD
*
*Revision 2.21  1994/09/01  15:06:31  CACHELIN4000
*fix hit
*
*Revision 2.20  94/08/31  23:07:21  Kell
*New debugs.  Some changes to just before the mousemove call to DHD_Jog.
*
*Revision 2.18  94/08/31  18:10:02  CACHELIN4000
*Flyer Control Work .. RCB
*
*Revision 2.17  94/08/30  17:30:31  CACHELIN4000
*Work on Flyer commands,
*Replace GadIndx hack with PLine->Flags kludge.
*
*Revision 2.16  94/08/30  10:44:37  Kell
*Changed SendSwitcherReply calls to work with new ESParams structures.
*Disabled some obsolete calls for record, shuttle etc.
*
*Revision 2.15  1994/08/30  09:45:06  CACHELIN4000
*Change ES_Messages to use ESparams struct
*
*Revision 2.14  94/08/27  16:41:14  CACHELIN4000
*reverse Continue, Cancel positions
*
*Revision 2.13  94/08/24  12:06:31  CACHELIN4000
*Add Audio Fine-tune to clip panel
*
*Revision 2.8  94/07/06  21:49:52  CACHELIN4000
*Record Panel tweaks, drop-frame fix
*
*Revision 2.6  94/06/22  10:45:00  CACHELIN4000
*Remove Control Panel data to Controls.c, left abstract panel code
*
*Revision 2.4  94/06/07  10:16:41  CACHELIN4000
*Complete rework...
*
*Revision 2.2  94/04/25  12:36:30  CACHELIN4000
*Comment out Audio Test code
*
*Revision 2.0  94/04/20  17:31:57  CACHELIN4000
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/sghooks.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>

#include <edit.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <editwindow.h>
#include <project.h>
#include <gadgets.h>
#include <prophelp.h>
#include <grazer.h>
#include <editswit.h>
#include <crouton_all.h>
#include <request.h>
#include <tags.h>
#include <panel.h>
#include <flyer.h>
#include <RawKeyCodes.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>

//#define SERDEBUG	1
#include <serialdebug.h>

#ifndef PROTO_PASS
#include <proto.h>
#else
#include "edit:proto/PanData.p"
#endif


//#define	CUT_ROOM_HELP	1

#define	AUDIO_BYTE	0xA2
#define CAF_AUDIO	CAF_AUDIOL|CAF_AUDIOR

#define RAW_REC 		RAWKEY_SPACE
#define RAW_IN 		RAWKEY_PAD_LPAREN		// num-pad '('
#define RAW_OUT 		RAWKEY_PAD_RPAREN		// num-pad ')'
#define RAW_DEL 		RAWKEY_PAD_ASTER		// num-pad '*'
#define RAW_LEN 		RAWKEY_PAD_SLASH		// num-pad '/'

extern VOID SoftSpriteOn(VOID);
extern VOID SoftSpriteOff(VOID);

extern struct Gadget StringGadg;
extern struct StringInfo StrInf;
extern struct BoolInfo BoolInf;
extern char strbuf[],strubuf[];
extern struct StringExtend TCExt;
extern int	CurGrid,CurRow,CurCol;
extern struct FastGadget *CurFG,*FirstFG,*PlayFG;
extern struct Screen *EditScreen;
extern struct Gadget Gadget1;
extern struct TextFont *DarkFont,*YellowFont,*TCFont,*TCDarkFont;
extern struct TextAttr TextAttr;
extern struct EditWindow *EditTop,*EditBottom;
extern struct TextExtent LastExtent;
extern char TempCh[],TempC2[],*DTNames[];
extern UBYTE *TempMem,*TempMem2;
extern struct TagItem nw_ti[2];
extern ULONG CRuDTypes[];
extern struct PanelLine *EasyPanelPL;
/* extern struct PanelLine *RawRecPL,*MarkClipPL; */
extern struct ESParams1 ESparams1;
extern struct ESParams2 ESparams2;
extern struct ESParams3 ESparams3;
extern struct ESParams4 ESparams4;
extern ULONG CurFlyDrive,CurFlySource,CurFlyTracks,CurCompMode;
extern UBYTE *FlyerDrives[],LClipping,RClipping;
extern struct Library *FlyerBase;
extern LONG FlyerDriveCount;
extern struct RenderCallBack *MyRCB;
extern struct EditPrefs UserPrefs;		// User preferences live here

extern __asm void MoveSoftSpriteABS( register __d0 ULONG X, register __d1 ULONG Y);

#define REC_FLAGS		SMART_REFRESH +BORDERLESS+ACTIVATE+RMBTRAP+NOCAREREFRESH+WFLG_NW_EXTENDED
#define STD_FLAGS		SIMPLE_REFRESH+BORDERLESS+ACTIVATE+RMBTRAP+NOCAREREFRESH+WFLG_NW_EXTENDED

struct ExtNewWindow ClipNW = {
	0,0,	/* window XY origin relative to TopLeft of screen */
	324,200,	/* window width and height */
	1,0,	/* detail and block pens */
	MOUSEBUTTONS+MOUSEMOVE+IDCMP_GADGETUP+IDCMP_GADGETDOWN+IDCMP_RAWKEY,	/* IDCMP flags */
	STD_FLAGS,
//	SMART_REFRESH+BORDERLESS+ACTIVATE+RMBTRAP+NOCAREREFRESH+WFLG_NW_EXTENDED,	/* other window flags */
	NULL,	/* first gadget in gadget list */
	NULL,	/* custom CHECKMARK imagery */
	NULL,	/* window title */
	NULL,	/* custom screen pointer */
	NULL,	/* custom bitmap */
	5,5,	/* minimum width and height */
	656,400,	/* maximum width and height */
	CUSTOMSCREEN,	/* destination screen type */
	&nw_ti[0]
};

struct PanelLine *CurPLine,*Start,*LastTime,*temp,*ALastTime,*GetsTicks;
struct Gadget *FirstG=0,*Down=0,*EZGad=NULL,*In=NULL,*Out=NULL,*Del=NULL,*Len=NULL,*LastString=NULL;
struct AEDKey	*GAEDNode;


LONG	ft,Adder;
ULONG	Ticks,WinFlags,GadInd,*LoTime=0,*HiTime=0,*ALoTime=0,*AHiTime=0,*SMPTime=0,smpte_base=0;
BOOL	Wide=FALSE,Playing=FALSE;


#define QUAL_NUM	6 		// number of entires in Qual array
#define DEF_QUALITY	0 	// default quality
//UBYTE	*Qual[] = {" D2 ","Beta SP"," Hi-8 ","S-VHS","VHS","Recognizable",""};
//Old struct for 4.0x
//struct PanelLine QualPL={ PNL_POPUP,PPOS_LEFT,"Video Quality",0,(LONG *)Qual,0,QUAL_NUM };
//New struct for 4.1
//struct PanelLine QualPL={ PNL_POPUP,PPOS_LEFT,"Video Quality",0,0,(LONG *)Qual,0,QUAL_NUM };
char pstr[100],*PatienceMsg[]={"Patience please...     ",pstr};
static char *DropErr[] = {"ERROR: Flyer dropped fields while recording.","Drive may be too slow for this quality mode."};
char ClipName[CLIP_PATH_MAX],ClipName2[CLIP_PATH_MAX],ClipPath[CLIP_PATH_MAX];
char	*AVparts[] = {"Video","Audio","Video+Audio",""};




ULONG __inline EZJump(ULONG t)
{
	return(t/EZ_DELAY);
}

//!!!*******************************************************************
// WARNING: This function once looked like MiniPanel below which in turn,
// once looked like an implemented design.  Let this function, with its peers,
// grow upon itself, and stand as an eternal admonition against software
// implementation with ill-defined requirements.  If you need to modify this
// crufty code, god help you. I can offer no defense, save the immortal plea
// of Adolph Eichmann  "I was just following orders".
//
// Returns FALSE if Cancel was selected
//#define MARKUP
UWORD __asm FlyPanel(REG(a0) struct EditWindow *Edit,REG(a1) struct PanelLine *PLine, REG(d0) UWORD XPMode)
{
	WORD H,ID,A,qual,X1,Y1,Lines=0;
	struct Gadget *ThisG=0;
//	struct Gadget *ContCan;
	struct Window *Window=0;
	struct RastPort *RP;
	struct PanelLine *InPL=NULL,*OutPL=NULL,*AInPL=NULL,*AOutPL=NULL,*PlayPL=NULL;
	BOOL Going = TRUE, DualFlyer = FALSE,LiveFlyer = FALSE, LoudFlyer = FALSE;
	UWORD Success = PAN_CANCEL;
	struct IntuiMessage *IntuiMsg;
	ULONG Y=0,d,*V,TilQuiet=0;
//	LONG F;

	FirstG=0; Down=0; EZGad=NULL; In=NULL; Out=NULL; Del=NULL;
	Len=NULL; LastString=NULL;
//	PlayFG=NULL;
	Wide=FALSE;
	SMPTime = &smpte_base;

	for(Start = PLine; PLine->Type && !Wide; PLine++ )
	{
		if ((PPOS_WIDER & PLine->Align) || (PPOS_HALF2 & PLine->Align))
			Wide=TRUE;
	}

	ClipNW.Flags = STD_FLAGS;			// Default window flags

	H = PNL_Y1;
	X1 = Y1 = 0;
	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine->Type != PNL_SKIP)
		{
			if (PPOS_HALF2 & PLine->Align)
				X1 = PNL_WIDTH;

			// Call the gadget's create function
//			DUMPUDECL("X=",X1," ");
//			DUMPUDECL("Y=",H,"\\");
			if(PLine->Create)		Y1=PLine->Create(X1,H,PLine,&ThisG);

			if(PPOS_WIDER & PLine->Align)
			{
				X1 = PNL_WIDTH;
				Y = Y1;
			}
			else
			{
				if (Y>0)
				{
//					DUMPUDECL("Maxing ",Y," ");
//					DUMPUDECL("and ",Y1,"\\");
					H += MAX(Y,Y1);		// Don't forget left half
				}
				else
				{
//					DUMPUDECL("Adding ",Y1,"\\");
					H += Y1;					// Was no left half
				}
				X1 = 0;
				Y = 0;
			}

			if(PLine->Flags)
			{
				if(PLine->Flags & PL_FLYER)
					LiveFlyer = TRUE;

				if(PLine->Flags&PL_IN)
				{
					if(PLine->Flags&PL_AUDIO)
					{
						AInPL=PLine;
						if(!In) In=PLine->StrGadg;
						if(PLine->Flags&PL_DUAL)
						{
							AOutPL=PLine;
							if(!Out) Out=PLine->StrGadg->NextGadget;
						}
					}
					else
					{
						InPL=PLine;
						In=PLine->StrGadg;
						if(PLine->Flags&PL_DUAL)
						{
							OutPL=PLine;
							Out=PLine->StrGadg->NextGadget;
						}
					}
				}
				else if(PLine->Flags&PL_OUT)
				{
					if(PLine->Flags&PL_AUDIO)
					{
						AOutPL=PLine;
						if(!Out) Out=PLine->StrGadg;
					}
					else
					{
						OutPL=PLine;
						Out=PLine->StrGadg;
					}
				}
				else if(PLine->Flags&PL_DEL)
					Del=PLine->StrGadg;
				else if(PLine->Flags&PL_LEN)
					Len=PLine->StrGadg;
				else if(PLine->Flags&PL_PLAY)
					PlayPL=PLine;
				if(PLine->Flags&PL_SMREF)			// Somebody wants smart refresh
					ClipNW.Flags = REC_FLAGS;
			}
			if( AInPL && AOutPL )
			{
				DualFlyer = TRUE;
				LoudFlyer = TRUE;
				if( !InPL ) InPL=AInPL;
				if( !OutPL)  OutPL=AOutPL;
			}
			else if( InPL && OutPL)
				DualFlyer = TRUE;
			Lines++;
		}
	}

	if(X1>0) H += MAX(Y,Y1);  // last gad...

//	if(Wide) X1=PNL_WIDTH;
//	if(ContCan=CreateContCancel(X1,H,&ThisG,XPMode))
//		H += (UWORD)(PNL_YADD + ContCan->Height);
//	else goto ErrExit;

	ClipNW.Width = PNL_WIDTH + (Wide ? PNL_WIDTH:0);
	ClipNW.Height = H;
	ClipNW.Screen = EditScreen;
	ClipNW.LeftEdge = EditTop->Window->LeftEdge +
		((EditTop->Window->Width - ClipNW.Width)/2);
	ClipNW.TopEdge = EditTop->Window->TopEdge; // MIN(PANEL_TOP,(EditScreen->Height - ClipNW.Height)/2) ;
	ClipNW.FirstGadget = NULL;

	SaveBorder(&EditScreen->RastPort,ClipNW.LeftEdge,ClipNW.TopEdge,
		ClipNW.LeftEdge+ClipNW.Width-1,ClipNW.TopEdge+ClipNW.Height-1);

	if (Window = OpenWindow((struct NewWindow *)&ClipNW))
	{
		SoftSpriteOff();				// Shut off for the duration -- faster, and less flash

		RP = Window->RPort;
		ClipNW.Flags = STD_FLAGS;
		WinFlags=Window->IDCMPFlags;
		SetDrMd(RP,JAM2);
		AddGList(Window,FirstG,0,-1,NULL);
		NewBorderBox(RP,0,0,Window->Width-1,Window->Height-1,BOX_CP_BORDER);
		SetFont(RP,DarkFont);
//		RefreshGList(ContCan,Window,NULL,-1);
		H = PNL_Y1;

#ifdef MARKUP
			SetAPen(RP,PAL_BLACK);
			Move(RP,PNL_X1,0);
			Draw(RP,PNL_X1,H);
			Move(RP,PNL_WIDTH,0);
			Draw(RP,PNL_WIDTH,H);
			Move(RP,PNL_WIDTH-PNL_X1,0);
			Draw(RP,PNL_WIDTH-PNL_X1,H);
#endif

		PLine = Start;
		X1 = 0;
		Y = 0;
		while (PLine->Type)
		{
			if(PLine->Type != PNL_SKIP)
			{
//				DUMPSTR(" . ");

#ifdef MARKUP
				SetAPen(RP,PAL_BLACK);
				Move(RP,0,H);
				Draw(RP,PNL_X1,H);
				Move(RP,PNL_WIDTH,H);
				Draw(RP,PNL_WIDTH-PNL_X1,H);
#endif
				PLine->Win = Window;

				if (PPOS_HALF2 & PLine->Align)
					X1 = PNL_WIDTH;

				// Call the gadget's draw function
				if(PLine->Draw)	Y1=PLine->Draw(X1,H,PLine,Window);

				if(PPOS_WIDER & PLine->Align)
				{
					X1 = PNL_WIDTH;
					Y = Y1;
				}
				else
				{
					if (Y>0)
						H += MAX(Y,Y1);		// Don't forget left half
					else
						H += Y1;					// Was no left half
					X1 = 0;
					Y = 0;
				}
			}
			PLine++;
		}
//		DUMPMSG("Lines Drawn...");

		SoftSpriteOn();

		LastTime=NULL;
		if( DualFlyer )
		{
			LastTime=InPL;
			if(OutPL==InPL)
				HiTime = OutPL->Param2;		// if DUOSLIDE
			else
				HiTime = OutPL->Param;
			LoTime = &InPL->PropStart;
			SMPTime = &InPL->PropStart;
			MyRCB->Frame = (ULONG)(*InPL->Param - *SMPTime)<<1;
			MyRCB->Max = (*HiTime - *SMPTime)<<1;
			MyRCB->Min = (*LoTime - *SMPTime)<<1;
			MyRCB->FG = CurFG;
			MyRCB->win = Window;
			MyRCB->pline = LastTime;
			if( LoudFlyer )
			{
				LastTime= AInPL;
				AHiTime = AOutPL->Param2; // !!! ASSUME DUAL
				ALoTime = &AInPL->PropStart;
			}
		}

		// handle window events
		goto GetEm;
		while (Going)
		{
			WaitPort(Window->UserPort);
GetEm:
			while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort))
			{
				switch(IntuiMsg->Class)
				{
				case IDCMP_GADGETDOWN:
//					DUMPMSG	("GADGETDOWN");
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(LastString && LastString!=ThisG)
//					if(LastString)
					{
//						DUMPSTR("LastString: ");
//						DUMPMSG(((struct StringInfo *)LastString->SpecialInfo)->Buffer);
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
//							DUMPHEXIL("LastPLine=",(LONG)PLine,"\\");
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//Y=FixTimeStr(PLine,Window,FALSE);
								Y=FixTimeStr(PLine,Window,TRUE);
								if( (PLine->Flags&PL_FLYER) && !(PLine->Flags&PL_AUDIO) )
								{
									MyRCB->Frame = (ULONG)(Y- *SMPTime)<<1;
									MyRCB->Max = (*HiTime - *SMPTime)<<1;
									MyRCB->Min = (*LoTime - *SMPTime)<<1;
//									DUMPUDECL("Jumping1 to ",(LONG)MyRCB->Frame,"\\");
									DHD_JustJump(MyRCB);
								}
								else if((PLine->Flags&PL_AUDIO) && (PLine->Flags&PL_DUAL) )
								{
									MyRCB->Frame = (ULONG)(Y - *SMPTime)<<1;
									MyRCB->Max = (*AHiTime - *SMPTime)<<1;
									MyRCB->Min = (*ALoTime - *SMPTime)<<1;
//									DUMPUDECL("Jumping2 to ",(LONG)MyRCB->Frame,"\\");
									DHD_JustJump(MyRCB);
								}
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if (*PLine->Param>PLine->PropEnd)
									*PLine->Param=PLine->PropEnd;
								if (*PLine->Param<PLine->PropStart)
									*PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else if(LastString->GadgetID==STRING_ID)
							{
//								DUMPSTR("strncpy");
//								DUMPHEXIL("( ",(LONG)PLine->Param," , ");
//								DUMPSTR(((struct StringInfo *)LastString->SpecialInfo)->Buffer);
//								DUMPUDECL(" , ",(LONG)PLine->PropEnd,")\\ ");
								strncpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer,(int)PLine->PropEnd);
							}
						}
						LastString=NULL;
					}
					if(!(PLine = (struct PanelLine *)ThisG->UserData)) break;
//					DUMPHEXIL("PLine=",(LONG)PLine,"\\");
					if(ID==STRING_ID)	LastString=ThisG;

					if( (PLine==InPL) || (PLine==OutPL) ||  (PLine==AInPL) || (PLine==AOutPL) )
					{
						LastTime=PLine;
						if(PlayPL && PlayFG)  // Must stop play to do Jog/Shuttle/Jump mode
						{
							DUMPMSG("GadgetDown: Abort Play");
//							PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
							if (PlayPL->Handle)
								PlayPL->Handle(PlayPL,0,Window);		// STOP!
//							break;
						}
					}

					if(PLine->Handle) PLine->Handle(PLine,IntuiMsg,Window);
					break;

				case IDCMP_GADGETUP:
//					DUMPMSG	("GADGETUP");

					if (Down) Down = NULL;
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;

					if(LastString && LastString!=ThisG)
					{
//						DUMPSTR("LastString: ");
//						DUMPMSG(((struct StringInfo *)LastString->SpecialInfo)->Buffer);
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
//							DUMPHEXIL("LastPLine=",(LONG)PLine,"\\");
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//Y=FixTimeStr(PLine,Window,FALSE);
								Y=FixTimeStr(PLine,Window,TRUE);
								if( (PLine->Flags&PL_FLYER) && !(PLine->Flags&PL_AUDIO) )
								{
									MyRCB->Flags = DHD_STR_UPDATE;
									MyRCB->Frame = (ULONG)(Y- *SMPTime)<<1;
									MyRCB->Max = (*HiTime - *SMPTime)<<1;
									MyRCB->Min = (*LoTime - *SMPTime)<<1;
//									DUMPUDECL("Jumping3 to ",(LONG)MyRCB->Frame,"\\");
									DHD_JustJump(MyRCB);
									MyRCB->Flags = 0;
								}
								else if(PLine->Flags&PL_AUDIO)
								{
									MyRCB->Flags = DHD_STR_UPDATE;
									MyRCB->Frame = (ULONG)(Y - *SMPTime)<<1;
									MyRCB->Max = (*AHiTime - *SMPTime)<<1;
									MyRCB->Min = (*ALoTime - *SMPTime)<<1;
//									DUMPUDECL("Jumping4 to ",(LONG)MyRCB->Frame,"\\");
									DHD_JustJump(MyRCB);
									MyRCB->Flags = 0;
								}
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if(*PLine->Param>PLine->PropEnd) *PLine->Param=PLine->PropEnd;
								if(*PLine->Param<PLine->PropStart) *PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else if(LastString->GadgetID==STRING_ID)
							{
//								DUMPSTR("strncpy");
//								DUMPHEXIL("( ",(LONG)PLine->Param," , ");
//								DUMPSTR(((struct StringInfo *)LastString->SpecialInfo)->Buffer);
//								DUMPUDECL(" , ",(LONG)PLine->PropEnd,")\\ ");
								strncpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer,(int)PLine->PropEnd);
							}
						}
						LastString=NULL;
					}

					PLine = (struct PanelLine *)ThisG->UserData;
					if(PLine && PLine->Handle)
					{
						// (STRING_ID handlers kill LastString here...)

						PLine->Handle(PLine,IntuiMsg,Window);

						DoGenButtons(PLine,Window,&Success,&Going);
					}
//					else switch (ID)
//					{
//						case ID_DARK_CONTINUE:
//							DUMPMSG	("CONTINUE");
//							Success = PAN_CONTINUE;
//						case ID_REQ_DARK_CANCEL:
//							Going = FALSE;			//Success was initialized to FALSE
//							break;
//						case ID_FINE_TUNE:
//							Going = FALSE;
//							Success = PAN_EXPERT;
//							break;
//						case ID_QUICK_TUNE:
//							Going = FALSE;
//							Success = PAN_EASY;
//							break;
//					}
					break;

				case IDCMP_INTUITICKS:
					DUMPMSG	("-tick-");

					if (TilQuiet>0)
					{
						if ((--TilQuiet)==0)
						{
							DHD_Quiet(Flds2Frms(MyRCB->Frame));
							ModifyIDCMP(Window,WinFlags);
						}
					}

					if (PLine = GetsTicks)
					{
						if (PLine->Handle)
						{
							PLine->Handle(PLine,IntuiMsg,Window);
							break;
						}
					}

					if( !EZGad || !(EZGad->Flags&GFLG_SELECTED) )
					{
						DUMPMSG	("No EZgad");
						ModifyIDCMP(Window,WinFlags);
						EZGad=NULL;
						break;
					}

					if( !(PLine=(struct PanelLine *)EZGad->UserData) )
					{
						DUMPMSG	("No UserData");
						break;
					}

//					if( DualFlyer && (PLine->Flags&PL_DUAL) )
					if( LiveFlyer && (PLine->Flags&PL_FLYER) )		// Allow on Flyer singles too
					{
						DUMPMSG("(maybe)");
						if(!EZJump(Ticks++)) break;  // skip ticks

						DUMPMSG("shuttle...");
						ModifyIDCMP(Window,WinFlags); // turn off ticks
						MyRCB->pline = PLine;
						if(PLine->Flags & PL_IN)
							MyRCB->Frame = (ULONG)(*PLine->Param - *SMPTime)<<1;
						else
							MyRCB->Frame = (ULONG)(*(PLine->Param2) - *SMPTime)<<1;

						// If shadowed, don't touch min/max, they have been done in SetHiLo()!
						if (!(PLine->Flags & PL_SHADOW))
						{
							if( (PLine->Flags&PL_FLYER) && !(PLine->Flags&PL_AUDIO) )
							{
								MyRCB->Max = (*HiTime - *SMPTime)<<1;
								MyRCB->Min = (*LoTime - *SMPTime)<<1;
							}
							else if(PLine->Flags&PL_AUDIO)
							{
								MyRCB->Max = (*AHiTime - *SMPTime)<<1;
								MyRCB->Min = (*ALoTime - *SMPTime)<<1;
							}
						}
						if(Adder>0)
							MyRCB->Flags = 0;
						else
							MyRCB->Flags = DHD_PLAY_REV;
						DHD_Shuttle(MyRCB);
						EZGad=NULL;
						UpdateAllDiff(RP,Start,Window);
					}
					else
					{
						// Handle ticks to EZ gadgets
						TickEZLenPL((struct PanelLine *)EZGad->UserData,Window,EZJump(Ticks++));

////					if( (F=*(PLine->Param)) || (Adder>0))
//						if( ((F=*(PLine->Param))>=PLine->PropStart) || (Adder>0))  // negative #s
//							F += Adder*EZJump(Ticks++);
//						else break;
//						if(Adder<0)
//							*(PLine->Param) = (F>=PLine->PropStart ? F:PLine->PropStart);
//						else
//							*(PLine->Param) = (F<=PLine->PropEnd ? F:PLine->PropEnd);
//						UpdatePanProp(PLine,Window);
//						UpdatePanStr(PLine,Window);
//						UpdateAllDiff(RP,Start,Window);
					}
					break;

				case IDCMP_MOUSEMOVE:
					if(Down)
					{
						PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,Window);
					}
					break;

				case IDCMP_MOUSEBUTTONS:
//					DUMPMSG	("MOUSEBUTTON");

					if(Down)
					{
						PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,Window);
					}

					if(!DualFlyer) break;
					A = IntuiMsg->Code;

					DUMPHEXIL("LastTime=",(LONG)LastTime,"\\");

#if FUNKY_RMB_SHUTTLE
					if( LastTime && (A==IECODE_RBUTTON))
					{
						if( LastTime->Flags&PL_FLYER )
						{
							MyRCB->Frame = (ULONG)(*LastTime->Param - *SMPTime)<<1;
							MyRCB->FG = CurFG;
							MyRCB->Max = (*HiTime - *SMPTime)<<1;
							MyRCB->Min = (*LoTime - *SMPTime)<<1;
							MyRCB->win = Window;
							MyRCB->pline = LastTime;
							if(IntuiMsg->MouseX>372) MyRCB->Flags = 0;
							else  MyRCB->Flags = DHD_PLAY_REV;
						}
						DHD_Shuttle(MyRCB);
					}
#endif

					if (Down) Down = NULL;

#if 0
					// Quiet audio on click nowhere
					if (LastTime && (A==IECODE_LBUTTON))
					{
						if (LastTime->Flags & PL_IN)
							DHD_Quiet(*LastTime->Param - *SMPTime);
						else
							DHD_Quiet(*LastTime->Param2 - *SMPTime);
					}
#endif
					break;


				case IDCMP_RAWKEY:
					A = IntuiMsg->Code;
					if(A<0x80)
					{
						qual = IntuiMsg->Qualifier;
						DUMPHEXIB("Key Code: ",A,"\\");
						switch(A)
						{
							case	RAWKEY_SPACE:
							case	RAWKEY_TAB:
								if ((PlayPL) && (PlayPL->Handle))
								{
									if(PlayFG)
									{
										PlayPL->Handle(PlayPL,0,Window);		// Stop!
//										PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
									}
									else
									{
										PlayPL->Handle(PlayPL,(struct IntuiMessage *)1,Window);	// Start!
//										PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) CurFG);
									}
								}
								break;
							case	RAW_IN:
								if(InPL)
								{
									LastTime=InPL;
									if(OutPL==InPL) HiTime = (OutPL->Param2);
									else HiTime = OutPL->Param;
									LoTime = &InPL->PropStart;
								}
								else if(AInPL)
								{
									LastTime=AInPL;
									if(OutPL==InPL) HiTime = (AOutPL->Param2);
									else AHiTime = AOutPL->Param;
									ALoTime = &AInPL->PropStart;
								}
								if(In)	ActivateGadget(In,Window,NULL);
								break;
							case	RAW_OUT:
								if(OutPL)
								{
									LastTime=OutPL;
									LoTime = InPL->Param;
									HiTime = &OutPL->PropEnd;
								}
								else if(AOutPL)
								{
									LastTime=AOutPL;
									ALoTime = AInPL->Param;
									AHiTime = &AOutPL->PropEnd;
								}
								if(Out)	ActivateGadget(Out,Window,NULL);
								break;
							case	RAW_LEN:
								if(Len)	ActivateGadget(Len,Window,NULL);
								break;
							case	RAW_DEL:
								if(Del)	ActivateGadget(Del,Window,NULL);
								break;
							case	RAWKEY_LEFT:
								DUMPHEXIL("LastTime=",(LONG)LastTime,"\\");
								if(LastTime==NULL) break;

								if(PlayPL && PlayFG)  // Must stop play to do Jog/Shuttle/Jump mode
								{
//									DUMPMSG("Abort Play");
									if (PlayPL->Handle)
										PlayPL->Handle(PlayPL,0,Window);		// STOP!
//									PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
								}

								if(qual & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
									d = 30;
								else if(qual & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
									d = (LastTime->PropEnd - LastTime->PropStart)/10+1;
								else
									d=(LastTime->Flags&PL_CFRAME) ? 2:1;

								if(LastTime->Flags & PL_IN)
									V=LastTime->Param;
								else
									V=LastTime->Param2;

								Y = *V;
//								*V = (Y>=LastTime->PropStart+d ? Y-d:LastTime->PropStart);

								if(LastTime->Flags&PL_AUDIO)
									*V = (Y >= *ALoTime+d) ? Y-d:*ALoTime;
								else
									*V = (Y >= *LoTime+d) ? Y-d:*LoTime;

								DUMPHEXIL("(flags=",(LONG)LastTime->Flags,")\\");
								if(LastTime->Flags&PL_FLYER)
								{
									MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
									DUMPHEXIL("Frm=",(LONG)MyRCB->Frame," ");
									DUMPHEXIL("(Max=",(LONG)MyRCB->Max," ");
									DUMPHEXIL("Min=",(LONG)MyRCB->Min,")\\");
									MyRCB->pline = LastTime;
									DHD_Jump(MyRCB,FALSE);

									WinFlags=Window->IDCMPFlags;
									ModifyIDCMP(Window,WinFlags|IDCMP_INTUITICKS);
									TilQuiet = 5;
								}
								else {
									UpdatePanProp(LastTime,Window);
									UpdatePanStr(LastTime,Window);
								}
								UpdateAllDiff(RP,Start,Window);
								break;
							case RAWKEY_RIGHT:
								if(LastTime==NULL) break;

								if(PlayPL && PlayFG)  // Must stop play to do Jog/Shuttle/Jump mode
								{
//									DUMPMSG("Abort Play");
									if (PlayPL->Handle)
										PlayPL->Handle(PlayPL,0,Window);		// STOP!
//									PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
								}

								if(qual & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
									d = 30;
								else if(qual & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
									d = (LastTime->PropEnd - LastTime->PropStart)/10+1;
								else
									d=(LastTime->Flags&PL_CFRAME) ? 2:1;
								if(LastTime->Flags & PL_IN) V=LastTime->Param;
								else V=LastTime->Param2;
								Y = *V;
								if(LastTime->Flags&PL_AUDIO)
									*V = (Y<=*AHiTime-d ? Y+d:*AHiTime);
								else
									*V = (Y<=*HiTime-d ? Y+d:*HiTime);
								if(LastTime->Flags&PL_FLYER)
								{
									MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
									MyRCB->pline = LastTime;
									DHD_Jump(MyRCB,FALSE);

									WinFlags=Window->IDCMPFlags;
									ModifyIDCMP(Window,WinFlags|IDCMP_INTUITICKS);
									TilQuiet = 5;
								}
								else {
									UpdatePanProp(LastTime,Window);
									UpdatePanStr(LastTime,Window);
								}
								UpdateAllDiff(RP,Start,Window);
								break;
							case RAWKEY_UP:
								if(LastTime==NULL) break;

								if(PlayPL && PlayFG)  // Must stop play to do Jog/Shuttle/Jump mode
								{
//									DUMPMSG("Abort Play");
									if (PlayPL->Handle)
										PlayPL->Handle(PlayPL,0,Window);		// STOP!
//									PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
								}

								if(LastTime->Flags & PL_IN)
									V=LastTime->Param;
								else
									V=LastTime->Param2;

								if(qual & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
								{
									if(LastTime->Flags&PL_AUDIO)
										*V = *AHiTime;
									else
										*V = *HiTime;

									if(LiveFlyer)
									{
										MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
										MyRCB->pline = LastTime;
										DHD_Jump(MyRCB,TRUE);
									}
									else {
										UpdatePanProp(LastTime,Window);
										UpdatePanStr(LastTime,Window);
									}
									UpdateAllDiff(RP,Start,Window);
								}
#if 0
								else if(qual & IEQUALIFIER_CONTROL )
								{
									if(LastTime->Flags&PL_AUDIO)
										*V = *AHiTime;
									else
										*V = *HiTime;

									if(LiveFlyer)
									{
										MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
										MyRCB->pline = LastTime;
										MyRCB->Flags = DHD_PLAY_REV;
										DHD_Jog(MyRCB);
									}
									else {
										UpdatePanProp(LastTime,Window);
										UpdatePanStr(LastTime,Window);
									}
									UpdateAllDiff(RP,Start,Window);
								}
#endif
								break;
							case RAWKEY_DOWN:
								if(LastTime==NULL) break;

								if(PlayPL && PlayFG)  // Must stop play to do Jog/Shuttle/Jump mode
								{
//									DUMPMSG("Abort Play");
									if (PlayPL->Handle)
										PlayPL->Handle(PlayPL,0,Window);		// STOP!
//									PlayPL->UserFun(PlayPL,IntuiMsg,(APTR) 0);
								}

								if(LastTime->Flags & PL_IN)
									V=LastTime->Param;
								else
									V=LastTime->Param2;

								if(qual & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
								{
									if(LastTime->Flags&PL_AUDIO)
										*V = *ALoTime;
									else
										*V = *LoTime;

									if(LiveFlyer)
									{
										MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
										MyRCB->pline = LastTime;
										DHD_Jump(MyRCB,TRUE);
									}
									else {
										UpdatePanProp(LastTime,Window);
										UpdatePanStr(LastTime,Window);
									}
									UpdateAllDiff(RP,Start,Window);
								}
#if 0
								else if(qual & IEQUALIFIER_CONTROL )
								{
									if(LastTime->Flags&PL_AUDIO)
										*V = *ALoTime;
									else
										*V = *LoTime;

									if(LiveFlyer)
									{
										MyRCB->Frame = (ULONG)(*V - *SMPTime)<<1;
										MyRCB->pline = LastTime;
										MyRCB->Flags = 0;
										DHD_Jog(MyRCB);
									}
									else {
										UpdatePanProp(LastTime,Window);
										UpdatePanStr(LastTime,Window);
									}
									UpdateAllDiff(RP,Start,Window);
								}
#endif
								break;
						}
					}
					if ((A == RAWKEY_PAD_ENTER)||(A == RAWKEY_RETURN))
					{
						Going = FALSE;
						Success=TRUE;
					}
					else if(A == RAWKEY_HELP)
					{
						if(XPMode==TUNE_FINE)
						{
							Success = PAN_EXPERT;
							Going = FALSE;
						}
						else if(XPMode==TUNE_QUICK)
						{
							Success = PAN_EASY;
							Going = FALSE;
						}

//						else
//							Success = PAN_CONTINUE;
//						if(XPMode) Success = PAN_EXPERT;
//						else Success=TRUE;
					}
					else if((A == RAWKEY_ESC)) Going = FALSE;
					break;
				}
				ReplyMsg((struct Message *)IntuiMsg);
			}
		}

		CloseWindow(Window);
		WaitBlit();

// update modified parameters
		PLine = Start;
		while (PLine->Type)
		{
			switch(PLine->Type) {
			case PNL_IN_TYPE:
			case PNL_OUT_TYPE:
				if (PLine->G1->Flags & GFLG_SELECTED) *(PLine->Param) = 1;
				else *(PLine->Param) = 0;
				break;
			}
			PLine++;
		}
	}

ErrExit:
	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine && PLine->Destroy && (PLine->Type!=PNL_SKIP) )
			PLine->Destroy(PLine);
	}
//	if (ContCan) FreeGadgets(ContCan);
	return(Success);
}

char RecMsg[] = "Record Clip";
WORD AudMode = 0;

#define aud1_ID		ID_BOOL+714
#define aud2_ID		ID_BOOL+715
#define aud3_ID		ID_BOOL+716
#define ST_ID			ID_BOOL+717
#define MX_ID			ID_BOOL+718
#define INSTR_ID		ID_BOOL+719
#define OUTSTR_ID		ID_BOOL+720
#define IN_ID			ID_BOOL+721
#define OUT_ID			ID_BOOL+722
#define CD_ID			ID_BOOL+723
#define AE_ID			ID_BOOL+724
#define JUMP_SIZE		30

#define EV_GAD			0X2000
#define EV_GAD01		EV_GAD+1
#define EV_GAD02		EV_GAD+2
#define EV_GAD03		EV_GAD+3
#define EV_GAD04		EV_GAD+4
#define EV_GAD05		EV_GAD+5
#define EV_GAD06		EV_GAD+6
#define EV_GAD07		EV_GAD+7
		




#define AUDIO_LEVEL_UPDATE_TIME	 0		// Every tick
UWORD __asm NewClipPanel(REG(a0) struct EditWindow *Edit )
{
	WORD H = PNL_Y1,ID,A,X1=0,Y1=0,Lines=0;
	struct Gadget *ThisG=0,*Record=NULL,*Pause=NULL,*ExtraGads,*gadptr;
//	struct Gadget *ContCan;
	struct Window *Window=0;
	struct RastPort *RP;
	BOOL Going = TRUE, Recording=FALSE,RecordedAlready=FALSE,Paused=FALSE,AudioOnly=FALSE;
	UWORD Success = PAN_CANCEL,audlev,clipping;
	struct PanelLine *PLine=EasyPanelPL,*LenPL=NULL,*DropPL=NULL,
										*FlyPL=NULL,*AudPL=NULL;
	struct IntuiMessage *IntuiMsg;
	LONG Y=0,F=0,RecStartM=0,RecStartS=0,PauseS=0,PauseM=0,TPauseS=0,TPauseM=0,AudUpdate=0;
	char *FlyDrive,*tempdrive;
	int err;
//	struct AudIndicator *AudBarR=NULL,*AudBarL=NULL;
	struct SegBarGraph *AudBarR=NULL,*AudBarL=NULL;

	DHD_InitRecord(0,0xC0DED00D);
	DHD_SetupRecord(CurFlySource,CurCompMode);

	FirstG=0; Down=0; EZGad=NULL; In=NULL; Out=NULL; Del=NULL; Len=NULL; LastString=NULL;
	Wide=TRUE;
//	t=(char *)&audlev;
//	DUMPHEXIL("New Clip Panel @",(LONG)PLine,"\\");
	for( Start = PLine; PLine->Type; PLine++ )
	{
		if(PLine->Type != PNL_SKIP)
		{
//			DUMPHEXIL("Pline->Create @",(LONG)PLine->Create,"\\");
			if (PPOS_HALF2 & PLine->Align)
				X1 = PNL_WIDTH;

			// Call the gadget's create function
			if(PLine->Create)		Y1=PLine->Create(X1,H,PLine,&ThisG);
			if(PPOS_WIDER & PLine->Align)
			{
				X1 = PNL_WIDTH;
				Y = Y1;
			}
			else
			{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
				X1 = Y = 0;
			}
			if(PLine->Flags)
			{
				if(PLine->Flags&PL_AVAIL)
					F= H - PIN_H +4 ;   // for aligning Reorganize button, or 0 for short panel
				else if(PLine->Flags&PL_LEN)
					LenPL=PLine;
				else if(PLine->Flags&PL_FLYER)
					FlyPL=PLine;
				else if(PLine->Flags&PL_AUDIO)
					AudPL=PLine;
			}

			if (PLine->PLID == PLID_DROPIND)
				DropPL=PLine;

			Lines++;
		}
	}
	if(X1>0) H += MAX(Y,Y1);  // last gad...
	if(Wide) X1=PNL_WIDTH;
	ClipNW.Width = PNL_WIDTH + (Wide ? PNL_WIDTH:0);
	ClipNW.Height = H;	//+PNL_YADD+24;
	ClipNW.Screen = EditScreen;
	ClipNW.LeftEdge = EditTop->Window->LeftEdge +
		((EditTop->Window->Width - ClipNW.Width)/2);
	ClipNW.TopEdge = EditTop->Window->TopEdge; // MIN(PANEL_TOP,(EditScreen->Height - ClipNW.Height)/2) ;
	ClipNW.FirstGadget = NULL;
	ClipNW.Flags = REC_FLAGS;
	if( !(ExtraGads=CreateNewClipGads((struct NewWindow *)&ClipNW,F,&ThisG)) )
		goto rErrExit;
	for (gadptr=ExtraGads; gadptr; gadptr=gadptr->NextGadget)
	{
		if (gadptr->GadgetID == ID_VCR_REC)
			Record = gadptr;
		if (gadptr->GadgetID == ID_VCR_PAUSE)
			Pause = gadptr;
	}

	SaveBorder(&EditScreen->RastPort,ClipNW.LeftEdge,ClipNW.TopEdge,
		ClipNW.LeftEdge+ClipNW.Width-1,ClipNW.TopEdge+ClipNW.Height-1);
	if (Window = OpenWindow((struct NewWindow *)&ClipNW))
	{
		SoftSpriteOff();				// Shut off for the duration -- faster, and less flash

		RP = Window->RPort;
		WinFlags=Window->IDCMPFlags;
		SetDrMd(RP,JAM2);
		AddGList(Window,FirstG,0,-1,NULL);
		NewBorderBox(RP,0,0,Window->Width-1,Window->Height-1,BOX_CP_BORDER);
		SetFont(RP,DarkFont);
		for(PLine = Start; PLine->Type; PLine++)
			PLine->Win=Window;
		DrawPanel(Start);
		NewBorderBox(RP,Record->LeftEdge-Record->Width-6,Record->TopEdge-4,
				Record->LeftEdge+(Record->Width<<1)+3,Record->TopEdge+Record->Height+3,BOX_REV);
		RefreshGList(ExtraGads,Window,NULL,-1);

		SoftSpriteOn();

		if (F
//		&& (AudBarL = InitAudIndicator(20,Record->TopEdge-18,16,8,1,&LClipping,Window))
//		&& (AudBarR = InitAudIndicator(20+(Window->Width>>1),Record->TopEdge-18,16,8,1,&RClipping,Window)) )
		&& (AudBarL = InitBarGraph(8,Record->TopEdge-66,207,8,255,Window))
		&& (AudBarR = InitBarGraph(8+(Window->Width>>1),Record->TopEdge-66,207,8,255,Window)) )
		{
			clipping	= GetRecSense();			// Get clipping info
			audlev	= GetAudioMeters();		// Get level meters
			UpdateBarGraph(AudBarL,audlev>>8,	((clipping>>8) >1) );
			UpdateBarGraph(AudBarR,audlev&0xFF,	((clipping & 0xFF) >1) );
//			UpdateAudIndicator(AudBarL,t[0]);
//			UpdateAudIndicator(AudBarR,t[1]);
			ModifyIDCMP(Window,WinFlags|IDCMP_INTUITICKS);
			WinFlags |= IDCMP_INTUITICKS;
			AudUpdate=AUDIO_LEVEL_UPDATE_TIME;
//			DUMPMSG("AudBars OK!!!");
		}
		else if(F)
		{
//			DUMPMSG("AudBars FAILED!!!");
			goto wErrExit;
		}

		if(FlyPL)
		{
			FlyDrive = ((char **)FlyPL->Param)[FlyPL->PropStart];
			if(*FlyDrive==AUDIO_BYTE)
				FlyDrive+=2; // Skip speaker symbol char and space
			strcpy(ClipName,FlyDrive);
			strcat(ClipName,TEMP_CLIP_NAME);
//			DUMPSTR("Set Name: "); DUMPMSG(ClipName);
		}

		// handle window events
		goto GetEm;
		while (Going) {
				WaitPort(Window->UserPort);
			GetEm:
			while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort)) {
				switch(IntuiMsg->Class) {
				case IDCMP_GADGETDOWN:
					DUMPSTR("GADGETDOWN..... ");
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(Paused && ( (ID!=ID_VCR_PAUSE) && (ID!=ID_REQ_STOP) && (ID!=ID_VCR_REC)) )
						break;

					if(PLine = (struct PanelLine *)ThisG->UserData)
					{
						if(PLine->Handle) PLine->Handle(PLine,IntuiMsg,Window);
						if( (PLine==FlyPL) || (PLine->Type==PNL_POPUP) )
						{
							UpdateAllDiff(RP,Start,Window);
							DUMPMSG	("pline");
						}
					}
					else switch(ID) // handle VCR Rec/Play button
					{
						case ID_VCR_REC:
							DUMPMSG	("ID_VCR_REC");
							break;
						case ID_VCR_PAUSE:
							DUMPMSG("Pause Down");
							break;
						case ID_REQ_STOP:
							DUMPMSG	("ID_REQ_STOP");
							if(Recording)
							{
								Record->Flags &= ~GFLG_SELECTED;
								RefreshGList(Record,Window,NULL,1);
								Pause->Flags &= ~GFLG_SELECTED;
								RefreshGList(Pause,Window,NULL,1);
								ModifyIDCMP(Window,WinFlags);

								Flyer_AbortRecord();		// Could take a bit to wrap up
								Paused=FALSE;
								Recording=FALSE;
//								DHD_MakeClipIcon(ClipName);
								if(Y = (IntuiMsg->Seconds - RecStartS - TPauseS)*30)
									Y += (3*IntuiMsg->Micros)/100000;  // should add (1000000-RecStartM)
								else
									Y += (3*(IntuiMsg->Micros - RecStartM - TPauseS))/100000;
								*LenPL->Param = (Y+1)&0xFFFFFFFE; // even up
								CTRL_SetDrive(FlyPL,IntuiMsg,NULL);
								UpdateAllDiff(RP,Start,Window);
							}
							break;
					}
					break;

				case IDCMP_GADGETUP:
					DUMPMSG	("GADGETUP");
					if (Down) Down = NULL;
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(Paused && !((ID==ID_VCR_PAUSE) || (ID==ID_VCR_REC) ) )
						break;
					PLine = (struct PanelLine *)ThisG->UserData;
					if(Recording && !Paused && (ID!=ID_VCR_PAUSE))
					{
						Recording = FALSE;
						Record->Flags &= ~GFLG_SELECTED;
						RefreshGList(Record,Window,NULL,1);

						Flyer_AbortRecord();		// Could take a bit to wrap up

//						DHD_MakeClipIcon(ClipName);
						if(Y = (IntuiMsg->Seconds - RecStartS- TPauseS)*30)
							Y += (3*IntuiMsg->Micros)/100000;
						else // I'm not sure the - TPauseM part here is necessary or proper
							Y += (3*(IntuiMsg->Micros - RecStartM- TPauseM))/100000;
						*LenPL->Param = (Y+1)&0xFFFFFFFE; // even up
						UpdateDiff(RP,LenPL,Window);
						if(ID==ID_VCR_REC) break;
					}

					if((PLine) && (PLine->Handle) )
					{
						PLine->Handle(PLine,IntuiMsg,Window);


						if (PLine->Flags & PL_GENBUTT)
						{
							switch ((ULONG)PLine->Param)
							{
							case GB_CONTINUE:
								// This intercept standard handler, special needs here
								if (RecordedAlready && !AudioOnly)
									DHD_MakeClipIcon(ClipName);
								Success = PAN_CONTINUE;
								Going = FALSE;
								break;
							case GB_CANCEL:
								// This intercept standard handler, special needs here
								Going = FALSE;
								CrDeleteFile(ClipName);
								break;
							case GB_REORG:			// Reorganize?
								// This intercept standard handler, special needs here

								DUMPMSG	("Re-Organize");

								if(FlyerDriveCount>0)		// Don't reorg if no drives
								{
									tempdrive = ((char **)FlyPL->Param)[FlyPL->PropStart];
									if (MaybeDoReorg(Window,tempdrive))
									{
										CTRL_SetDrive(FlyPL,IntuiMsg,NULL);
										UpdateAllDiff(RP,Start,Window);
									}
								}
								break;
							default:
								DoGenButtons(PLine,Window,&Success,&Going);
								break;
							}
						}
					}
					else switch (ID)
					{
						case ID_VCR_REC:

							if(FlyerDriveCount==0) {	// Don't record if no drives
								Record->Flags &= ~GFLG_SELECTED;
								RefreshGList(Record,Window,NULL,1);
							}
							else {
								if(FlyPL)
								{
									FlyDrive = ((char **)FlyPL->Param)[FlyPL->PropStart];
									if(*FlyDrive==AUDIO_BYTE)
									{
										FlyDrive+=2; // Skip speaker symbol char and space
										AudioOnly = TRUE;
									}
									else AudioOnly = FALSE;

									strcpy(ClipName,FlyDrive);
									strcat(ClipName,TEMP_CLIP_NAME);
									DUMPSTR("Set Name: "); DUMPMSG(ClipName);
								}
								WinFlags=Window->IDCMPFlags;
								Recording=TRUE;
								ModifyIDCMP(Window,WinFlags|IDCMP_INTUITICKS);
								if(Paused)  // Pause off
								{
									Paused=FALSE;
									Flyer_Pause(FALSE);
									Record->Flags |= GFLG_SELECTED;
									RefreshGList(Record,Window,NULL,1);
									Pause->Flags &= ~GFLG_SELECTED;
									RefreshGList(Pause,Window,NULL,1);
									TPauseS += IntuiMsg->Seconds - PauseS; // Add this pause duration
									if(IntuiMsg->Seconds == PauseS)
										TPauseM += IntuiMsg->Micros  - PauseM; // to total paused time
								}
								else
								{
									Paused=FALSE;
									*LenPL->Param = 0;
									TPauseS=0; TPauseM=0;
									PauseS=0; PauseM=0;
									RecStartS=IntuiMsg->Seconds;
									RecStartM=IntuiMsg->Micros;
									ClearFlyerStatus();
									Flyer_Record(ClipName,0);
									RecordedAlready=TRUE;
								}
							}
							break;
						case ID_REQ_STOP:
							break;
						case ID_VCR_PAUSE:
							if (!Recording)	// Just un-render if not recording
							{
								ThisG->Flags &= ~GFLG_SELECTED;
								RefreshGList(ThisG,Window,NULL,1);
							}
							else if (Paused)  // Pause off
							{
								Paused=FALSE;
								Flyer_Pause(FALSE);
								Record->Flags |= GFLG_SELECTED;
								RefreshGList(Record,Window,NULL,1);
								ThisG->Flags &= ~GFLG_SELECTED;
								RefreshGList(ThisG,Window,NULL,1);
								TPauseS += IntuiMsg->Seconds - PauseS; // Add this pause duration
								if(IntuiMsg->Seconds == PauseS)
									TPauseM += IntuiMsg->Micros  - PauseM; // to total paused time
							}
							else // Start Pause
							{
								Paused=TRUE;
								Flyer_Pause(TRUE);
								Record->Flags &= ~GFLG_SELECTED;
								RefreshGList(Record,Window,NULL,1);
								Pause->Flags |= GFLG_SELECTED;
								RefreshGList(Pause,Window,NULL,1);
								PauseS = IntuiMsg->Seconds; // reset current pause time
								PauseM = IntuiMsg->Micros;
							}
							DUMPMSG("Pause Up");
							break;
//						case ID_DARK_CONTINUE:  // called with NO_CUTTING_ROOM def'd
//							if( RecordedAlready && !AudioOnly ) DHD_MakeClipIcon(ClipName);
//							Success = PAN_CONTINUE;
//							Going = FALSE;
//							break;
//						case ID_REQ_DARK_CANCEL:
//							Going = FALSE;
//							CrDeleteFile(ClipName);
//							break;
//						case ID_MARK_PANEL: // called without NO_CUTTING_ROOM def'd
//							Going = FALSE;			//Success was initialized to FALSE
//							Success = PAN_EXPERT;
//							break;
//						case ID_REORG:
//							DUMPMSG	("Re-Organize");
//							if(FlyerDriveCount>0)		// Don't reorg if no drives
//							{
//								tempdrive = ((char **)FlyPL->Param)[FlyPL->PropStart];
//								if (MaybeDoReorg(Window,tempdrive))
//								{
//									CTRL_SetDrive(FlyPL,IntuiMsg,NULL);
//									UpdateAllDiff(RP,Start,Window);
//								}
//------
//								if(*tempdrive==AUDIO_BYTE)
//									tempdrive+=2; // Skip speaker symbol char and space
//
//								sprintf(pstr,"If I reorganize %s, it may take a while... ",tempdrive);
//								if(BoolRequest(Window,pstr))
//								{
//									sprintf(pstr,"Reorganizing Flyer drive %s",tempdrive);
//									OpenNoticeWindow(Window,PatienceMsg,2,FALSE);
//									DisplayWaitSprite();
//									DHD_Reorganize(tempdrive);
//									DisplayNormalSprite();
//									CloseNoticeWindow();
//									CTRL_SetDrive(FlyPL,IntuiMsg,NULL);
//									UpdateAllDiff(RP,Start,Window);
//								}
//							}
							break;
					}
					break;
				case IDCMP_MOUSEMOVE:
				case IDCMP_MOUSEBUTTONS:
					if(Down)
					{
						PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,Window);
					}
					break;

				case IDCMP_INTUITICKS:
					if(Recording && !Paused)
					{
						if((RecStartS==0)&&(RecStartM==0))
						{
							RecStartS=IntuiMsg->Seconds;
							RecStartM=IntuiMsg->Micros;
						}
						if(Y = (IntuiMsg->Seconds - RecStartS- TPauseS)*30)
							Y += (3*IntuiMsg->Micros)/100000;
						else
							Y += (3*(IntuiMsg->Micros - RecStartM - TPauseM))/100000;
						*LenPL->Param = (Y+1)&0xFFFFFFFE; // even up
						UpdateDiff(RP,LenPL,Window);

						// If Flyer dropped fields, update the drop count display
						if (DropPL)
						{
							if (CheckFlyerStatus(NULL, (ULONG *)DropPL->Param)==FERR_DROPPEDFLDS)
							{
								UpdateDiff(RP,DropPL,Window);
							}
						}

//						if(FlyPL->PropEnd>1)		// Why test for >1 Flyer drive?!?!?
//						{
							err = Flyer_CheckRecord();
//							DUMPSDECL	("Check: ",(LONG)err,"\\");
							if(err!=FERR_BUSY)
							{
								switch(err)
								{
									case FERR_EXISTS:
										if(BoolRequest(Window,"Temporary clip already recorded, re-record it?"))
										{
											CrDeleteFile(ClipName);
											*LenPL->Param = 0;
											RecStartS= 0; // IntuiMsg->Seconds;
											RecStartM=0; // IntuiMsg->Micros;
											TPauseS=0; TPauseM=0;
											PauseS=0; PauseM=0;
											ClearFlyerStatus();
											Flyer_Record(ClipName,0);
											CTRL_SetDrive(FlyPL,IntuiMsg,NULL);
										}
										else {
											Recording=FALSE;
											ModifyIDCMP(Window,WinFlags);
											Record->Flags &= ~GFLG_SELECTED;
											RefreshGList(Record,Window,NULL,1);
										}
										break;
									case FERR_EXHAUSTED:
										sprintf(pstr,"Recording stopped, Flyer drive %s full.",((char **)FlyPL->Param)[FlyPL->PropStart]);
										Recording=FALSE;
										ModifyIDCMP(Window,WinFlags);
										Record->Flags &= ~GFLG_SELECTED;
										RefreshGList(Record,Window,NULL,1);
										ContinueRequest(Window,pstr);
										break;
									case FERR_DROPPEDFLDS:
//										ContinueRequest(Window,
//											"Gosh, d-d-do you think we c-c-ould try that one again?");
										DUMPMSG	("FERR_DROPPEDFLDS");
										Recording=FALSE;
										ModifyIDCMP(Window,WinFlags);
										Record->Flags &= ~GFLG_SELECTED;
										RefreshGList(Record,Window,NULL,1);
										SimpleRequest(Window,DropErr,2,REQ_CENTER | REQ_H_CENTER,NULL);
										break;
									case FERR_OKAY:
										DUMPMSG	("FERR_OKAY");
										Recording=FALSE;
										ModifyIDCMP(Window,WinFlags);
										Record->Flags &= ~GFLG_SELECTED;
										RefreshGList(Record,Window,NULL,1);
//										DHD_MakeClipIcon(ClipName);
										break;
									default:
										DUMPSDECL	("Default: Flyer_CheckRecord=",(LONG)err,"\\");
										Recording=FALSE;
										ModifyIDCMP(Window,WinFlags);
										Record->Flags &= ~GFLG_SELECTED;
										RefreshGList(Record,Window,NULL,1);
										sprintf(pstr,"Recording stopped: Internal Flyer Error # %d.",err);
										ContinueRequest(Window,pstr);
										break;
								}
							}
//						}
					}
					else if(!Paused) ModifyIDCMP(Window,WinFlags);
					if(AudUpdate) AudUpdate--;
					else if(AudBarL && AudBarR)
					{
						AudUpdate=AUDIO_LEVEL_UPDATE_TIME;
//						if(FlyerBase) audlev=GetRecSense();
						if (FlyerBase)
						{
							clipping	= GetRecSense();			// Get clipping info
							audlev	= GetAudioMeters();		// Get level meters
						}
						else
						{
							audlev=((IntuiMsg->Micros>>3)&0x0707);
							clipping = 0;
						}

						UpdateBarGraph(AudBarL,audlev>>8,	((clipping>>8) >1) );
						UpdateBarGraph(AudBarR,audlev&0xFF,	((clipping & 0xFF) >1) );
//						UpdateAudIndicator(AudBarL,t[0]);
//						UpdateAudIndicator(AudBarR,t[1]);
					}
					break;
				case IDCMP_RAWKEY:
					DUMPMSG	("IDCMP_RAWKEY");
					A = IntuiMsg->Code;
					if(A>0x80) break;
					if(Paused && A!=RAWKEY_SPACE)
						break;
					if(Recording && !Paused)
					{
						Recording = FALSE;
						Record->Flags &= ~GFLG_SELECTED;
						RefreshGList(Record,Window,NULL,1);

						Flyer_AbortRecord();		// Could take a bit to wrap up

//						DHD_MakeClipIcon(ClipName);
						ModifyIDCMP(Window,WinFlags);
						if(Y = (IntuiMsg->Seconds - RecStartS - TPauseS)*30)
							Y += (3*IntuiMsg->Micros)/100000;
						else
							Y += (3*(IntuiMsg->Micros - RecStartM - TPauseM))/100000;
						*LenPL->Param = (Y+1)&0xFFFFFFFE; // even up
						UpdateDiff(RP,LenPL,Window);
						if(A==RAWKEY_SPACE) break;
					}
					switch(A)
					{
						case RAWKEY_PAD_ENTER:
						case RAWKEY_RETURN:
							if(RecordedAlready) DHD_MakeClipIcon(ClipName);
							Going = FALSE;
							Success=TRUE;
							break;
						case RAWKEY_HELP:
							break;
						case RAWKEY_ESC:
							CrDeleteFile(ClipName);
							Going = FALSE;
							break;
						case RAWKEY_SPACE:
							if(Paused)  // Pause off
							{
								Paused=FALSE;
								Record->Flags |= GFLG_SELECTED;
								RefreshGList(Record,Window,NULL,1);
								TPauseS += IntuiMsg->Seconds - PauseS; // Add this pause duration
								if(IntuiMsg->Seconds == PauseS)
									TPauseM += IntuiMsg->Micros  - PauseM; // to total paused time
								Flyer_Pause(Paused);
								break;
							}

							if(FlyPL)
							{
								FlyDrive = ((char **)FlyPL->Param)[FlyPL->PropStart];
								if(*FlyDrive==AUDIO_BYTE)
								{
									FlyDrive+=2; // Skip speaker symbol char and space
									AudioOnly = TRUE;
								}
								else AudioOnly = FALSE;
								strcpy(ClipName,FlyDrive);
								strcat(ClipName,TEMP_CLIP_NAME);
								DUMPSTR("Set Name: "); DUMPMSG(ClipName);
							}
							WinFlags=Window->IDCMPFlags;
							Recording=TRUE;
							ModifyIDCMP(Window,WinFlags|IDCMP_INTUITICKS);
							*LenPL->Param = 0;
							RecStartS=IntuiMsg->Seconds;
							RecStartM=IntuiMsg->Micros;
							ClearFlyerStatus();
							Flyer_Record(ClipName,0);
							Record->Flags |= GFLG_SELECTED;
							RefreshGList(Record,Window,NULL,1);
							RecordedAlready=TRUE;
							break;
					}
					break;
				case IDCMP_REFRESHWINDOW: // shouldn't ever come in...
//					DUMPMSG("IDCMP_REFRESHWINDOW");
					break;
				} // message switch
				ReplyMsg((struct Message *)IntuiMsg);
			}
		}
wErrExit:
		CloseWindow(Window);
		WaitBlit();
	}
rErrExit:
	ClipNW.Flags = STD_FLAGS;
	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine && PLine->Destroy && (PLine->Type != PNL_SKIP))
			PLine->Destroy(PLine);
	}
	DHD_InitPlay(0,0xC0DED00D);
	if (ExtraGads) FreeGadgets(ExtraGads);
//	if(AudBarL) FreeAudIndicator(AudBarL);
//	if(AudBarR) FreeAudIndicator(AudBarR);
	if(AudBarL) FreeBarGraph(AudBarL);
	if(AudBarR) FreeBarGraph(AudBarR);

	DUMPSTR	(" OK so far .....   ");
	return(Success);
}



UWORD __asm CutClipPanel(
		REG(a0) struct EditWindow *Edit,
		REG(a1) struct FastGadget *FG,
		REG(a2) struct PanelLine *PLine,
		REG(d0) BOOL destructive,
		REG(d1) char *SrcName)
{
#ifdef CUT_ROOM_HELP
// Help screen data
static char *HelpMsg[] = {
		"   Keyboard Shortcuts",
		" -- Keypad --",
		"   (   Enter In  point",
		"   )   Enter Out point",
		"   /   Enter Comment",
		"   *   Enter Name",
		" -- Arrows --",
		"         left/right  Fine adjust current point",
		"   ALT   left/right  Coarse adjust current point",
		"   SHIFT left/right  Adjust by 1 second",
		"   SHIFT down        Move current point to minimum",
		"   SHIFT up          Move current point to maximum",
		" -- Other --",
		"   +   Select next clip",
		"   -   Select previous clip",
		"   s   Make current clip a still",
		"   x   Remove current clip"
	};
#endif

	struct Gadget CDisp = {
		NULL,0,0,20,20,
		GFLG_GADGHNONE,
		RELVERIFY,
		BOOLGADGET,
		NULL,NULL,NULL,NULL,NULL,CD_ID,NULL
	};

	struct CutClipData	ccd;				// Structure passable to sub-routines

	WORD H = PNL_Y1,ID,A,qf,X1=0,Y1=0,Lines=0;
	struct NewClip	*tcl=NULL,*ncl;
	struct ClipInfo	*ci;
	struct Gadget *ThisG=NULL,*Clips,*Comm;
//	struct Gadget *ContCan,*LastGad=NULL,*RecGadget=NULL;
	BOOL Going,ListOpen=FALSE,FromRawClip;
	UWORD Success;
//	struct PanelLine *PLine = MarkClipPL;
	struct PanelLine *partsPL=NULL,*destPL=NULL;
	struct IntuiMessage *IntuiMsg;
	struct StringInfo *si;
	ULONG Y=0,t,d,*V,ClipFlags,TilQuiet=0;
//	ULONG *Strip;
	char *FlyDrive,DrvName[31];
	ULONG	error;
	char *MPtr[3];
	int	i,ok,stripbase;

//---
	ccd.cl=NULL;
	ccd.ClipDisp=NULL;
	ccd.Window=NULL;
	ccd.Frame = NULL;		// May not be an icon slider!
	ccd.FramePL=NULL;

	strcpy(ClipName2,"NewClip.");		// Default name prefix

	// Lookup name of FastGadget, unless one is provided
	if (SrcName==NULL)
	{
		FromRawClip = FALSE;			// Cutting up an existing clip

		SrcName = ((struct ExtFastGadget *)FG)->FileName;

		DUMPMSG("Object to work with is called...");
		DUMPMSG(SrcName);

		for(FlyDrive=DrvName,Y=0; Y<=30; Y++)
		{
			if ((*FlyDrive++ = SrcName[Y]) == ':')		// Copy byte, stop if ':' hit
				break;
		}
		*FlyDrive = 0;		// Null terminate
		FlyDrive = DrvName;

		// Derive the source clip's volume:path (this will be applied to all new files made)
		strcpy(ClipPath,SrcName);
		*FilePart(ClipPath)=0;			// Trim off the file part (may leave nothing if no path)
	}
	else
	{
		FromRawClip = TRUE;			// Just cutting up the raw clip

		// Cutting raw clip, so get name of current drive
		FlyDrive = FlyerDrives[CurFlyDrive];
		if(*FlyDrive==AUDIO_BYTE)
			FlyDrive+=2; // Skip speaker symbol char and space

		// Prepend just the volume: name before all files made here
		strcpy(ClipPath,FlyDrive);
	}

	FirstG=0; Down=0; EZGad=NULL; In=NULL; Out=NULL;
	Wide=TRUE;

	for (Start=PLine; PLine->Type; PLine++ )
	{
		if(PLine->Type != PNL_SKIP)
		{
			if (PPOS_HALF2 & PLine->Align)
				X1 = PNL_WIDTH;

			// Call the gadget's create function
			if(PLine->Create)		Y1=PLine->Create(X1,H,PLine,&ThisG);

			if(PPOS_WIDER & PLine->Align)
			{
				X1 = PNL_WIDTH;
				Y = Y1;
			}
			else
			{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
				X1 = 0;
				Y = 0;
			}

			if(PLine->Flags)
			{
				if(PLine->Flags&PL_DUAL)
				{
					ccd.TimePL = PLine;
					In=ccd.TimePL->StrGadg;
					Out=ccd.TimePL->StrGadg->NextGadget;
				}
				else if(PLine->Flags&PL_DEL)
				{
					ccd.String=PLine->StrGadg;
					ccd.StrPL = PLine;
				}
				else if(PLine->Flags&PL_LEN)
					ccd.LenPL=PLine;
				else if(PLine->Flags&PL_PLAY)
					partsPL = PLine;
//					Strip=(ULONG *)&PLine->Param;
				else if(PLine->Flags&PL_AUDIO)
				{
					ccd.FramePL=PLine;
					ccd.Frame=ccd.FramePL->StrGadg;
				}
				else if(PLine->Flags&PL_AVAIL)
				{
					ccd.CommPL=PLine;
					Comm=PLine->StrGadg;
				}
			}

			if (PLine->PLID == PLID_DESTPOPUP)
				destPL=PLine;

			Lines++;
		}
	}

	ccd.Tmax = ccd.TimePL->PropEnd;
	ccd.Tmin = ccd.TimePL->PropStart;
	if(X1>0) H += MAX(Y,Y1);  // last gad...
	if(Wide) X1=PNL_WIDTH;
	ClipNW.Width = PNL_WIDTH + (Wide ? PNL_WIDTH:0);

	ClipNW.Height = H;
	ClipNW.Screen = EditScreen;
	ClipNW.LeftEdge = EditTop->Window->LeftEdge +
		((EditTop->Window->Width - ClipNW.Width)/2);
	ClipNW.TopEdge = EditTop->Window->TopEdge; // MIN(PANEL_TOP,(EditScreen->Height - ClipNW.Height)/2) ;
	ClipNW.FirstGadget = NULL;

	// Tack clip bar gadget onto end of list
	Clips=&CDisp;
	ThisG->NextGadget = Clips;


ReOpen:
	Going = TRUE;
	Success = PAN_CANCEL;
	ccd.clipnumdigits = 2;	// Start with .01
	ccd.clipnum = 0;

	strncpy(ClipName,SrcName,CLIP_PATH_MAX);		// Make copy of source clip name

	ci=DHD_ClipInfo(ClipName);
	if (ci)
	{
//		if(ci->Flags&CIF_HASVIDEO)
//			*Strip |= 1;
//		else
//			*Strip &= ~1;
//		if(ci->Flags&CIF_HASAUDIO)
//			*Strip |= 2;
//		else
//			*Strip &= ~2;
		if (ci->Flags&CIF_HASVIDEO)
		{
			if (ci->Flags&CIF_HASAUDIO)
			{
				// Audio/Video clip
				stripbase = 0;
				partsPL->PropStart = 2;
				partsPL->PropEnd = 3;
			}
			else
			{
				// Video only
				stripbase = 0;
				partsPL->PropStart = 0;
				partsPL->PropEnd = 1;
			}
		}
		else
		{
			if (ci->Flags&CIF_HASAUDIO)
			{
				// Audio only
				stripbase = 1;
				partsPL->PropStart = 0;
				partsPL->PropEnd = 1;
			}
			else
			{
				Success = PAN_CANCEL;
				goto rErrExit;					// Not a Flyer clip, just abort
			}
		}
		partsPL->Param = (long *)&AVparts[stripbase];
	}
	else
	{
		// Aargh!  Trying to operate on a clip that no longer exists!!
		sprintf(pstr,"Error - clip \"%ls\" no longer exists",ClipName);
		ContinueRequest(EditTop->Window,pstr);

		Success = PAN_CANCEL;
		goto rErrExit;
	}

	if (!destructive)
	{
//		DUMPSTR("Non-Destructive cutting on clip: ");
//		DUMPMSG(ClipName);

		DHD_StartClipList(ClipName,CUTCLIP_PRESERVE);
		ListOpen = TRUE;

//		for(Y=0; Y<=20 && ClipName[Y]!=':'; Y++)
//			FlyD[Y] = ClipName[Y];
//		FlyD[Y] = ClipName[Y++];
//		FlyD[Y] = 0;
//		FlyDrive = FlyD;
	}
	else
	{
//		DUMPSTR("Destructive cutting on clip: ");
//		DUMPMSG(ClipName);

		DHD_StartClipList(ClipName,CUTCLIP_DESTROY);
		ListOpen = TRUE;
	}

	SaveBorder(&EditScreen->RastPort,ClipNW.LeftEdge,ClipNW.TopEdge,
		ClipNW.LeftEdge+ClipNW.Width-1,ClipNW.TopEdge+ClipNW.Height-1);
	if (ccd.Window = OpenWindow((struct NewWindow *)&ClipNW))
	{
		SoftSpriteOff();				// Shut off for the duration -- faster, and less flash

		ccd.RP = ccd.Window->RPort;
		SetDrMd(ccd.RP,JAM2);
		if(!ccd.ClipDisp)
		{
			if(!(ccd.ClipDisp=InitClipDisplay(16,
				ccd.TimePL->PropGadg->TopEdge+ccd.TimePL->PropGadg->Height+20,
				ccd.Window->Width-32,24,ccd.Tmin,ccd.Tmax,ccd.Window)))
			{
				SoftSpriteOn();
				goto rErrExit;
			}
			sprintf(ClipName,"%s%0*d",ClipName2,ccd.clipnumdigits,++ccd.clipnum);
			if(ccd.cl=AddClip(ccd.ClipDisp,ccd.Tmin,ccd.Tmax,CLIP_ACTIVE,ClipName))
			{
				ccd.StrPL->Param = (LONG *) ccd.cl->Name;
				strncpy(((struct StringInfo *)ccd.String->SpecialInfo)->Buffer,ccd.cl->Name,CLIP_NAME_MAX-1);

				ccd.CommPL->Param = (LONG *) ccd.cl->Comment;
			}
			ccd.TimePL->Param = &ccd.cl->in;
			ccd.TimePL->Param2 = &ccd.cl->out;
			ccd.LenPL->Param = ccd.TimePL->Param2;
			ccd.LenPL->Param2 = ccd.TimePL->Param;
			if (ccd.FramePL)
			{
				ccd.FramePL->Param = &ccd.cl->icon;
				ccd.FramePL->PropEnd = ccd.cl->out;
				ccd.FramePL->PropStart = ccd.cl->in;
	//			ccd.FramePL->G2 =(struct Gadget *) (ccd.cl->in-ccd.Tmin);
				AHiTime = &ccd.FramePL->PropEnd;
				ALoTime = &ccd.FramePL->PropStart;
			}
		}
		else ccd.ClipDisp->RP=ccd.Window->RPort;

		if(ccd.cl) ccd.StrPL->Param = (LONG *) ccd.cl->Name;
		Clips->LeftEdge = ccd.ClipDisp->X;
		Clips->TopEdge = ccd.ClipDisp->Y;
		Clips->Width = ccd.ClipDisp->W;
		Clips->Height = ccd.ClipDisp->H;

		AddGList(ccd.Window,FirstG,0,-1,NULL);

		// Setup outline for panel window
		NewBorderBox(ccd.RP,0,0,ccd.Window->Width-1,ccd.Window->Height-1,BOX_CP_BORDER);

		SetFont(ccd.RP,DarkFont);
//		RefreshGList(ContCan,ccd.Window,NULL,-1);
		DrawClipDisplay(ccd.ClipDisp);

		X1 = 0;
		Y = 0;
		H = PNL_Y1;
		for (PLine=Start;PLine->Type; PLine++)
		{
			if(PLine->Type != PNL_SKIP)
			{
				if (PPOS_HALF2 & PLine->Align)
					X1 = PNL_WIDTH;

				// Call the gadget's draw function
				PLine->Win = ccd.Window;

				if(PLine->Draw)	Y1=PLine->Draw(X1,H,PLine,ccd.Window);

				if(PPOS_WIDER & PLine->Align)
				{
					X1 = PNL_WIDTH;
					Y = Y1;
				}
				else
				{
					if (Y>0)
						H += MAX(Y,Y1);		// Don't forget left half
					else
						H += Y1;					// Was no left half
					X1 = 0;
					Y = 0;
				}
			}
		}

		// Activate name string gadget
		si = (struct StringInfo *) ccd.String->SpecialInfo;
		si->BufferPos = strlen(si->Buffer);		// Move cursor past end
		ActivateGadget(ccd.String,ccd.Window,NULL);

		SoftSpriteOn();

		HiTime = (ccd.TimePL->Param2);
		LoTime = &ccd.TimePL->PropStart;
		MyRCB->Frame = (ULONG)(*ccd.TimePL->Param - ccd.Tmin)<<1;
		MyRCB->Max = (*HiTime - ccd.Tmin)<<1;
		MyRCB->Min = (*LoTime - ccd.Tmin)<<1;
		MyRCB->FG = FG;
		MyRCB->win = ccd.Window;
		MyRCB->pline = ccd.TimePL;

		// handle window events
		goto GetEm;
		while (Going)
		{
				WaitPort(ccd.Window->UserPort);
			GetEm:
			while (IntuiMsg = (struct IntuiMessage *)GetMsg(ccd.Window->UserPort)) {
				switch(IntuiMsg->Class)
				{
				case IDCMP_GADGETDOWN:
//					DUMPMSG	("GADGETDOWN");
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(PLine = (struct PanelLine *)ThisG->UserData)
					{
						if(PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,ccd.Window);

						// If possibly changed in/out points, refresh clip display/icon slider
						if ((PLine==ccd.TimePL) && (ID == ID_LR_KNOB))
						{
							DUMPMSG("Post/Jog refresh");
							DrawClipDisplay(ccd.ClipDisp);
							LegalizeIconSlide(&ccd);		// Clip icon pos/move knob
						}
					}
					break;

				case IDCMP_GADGETUP:
					DUMPMSG	("GADGETUP");
					if (Down) Down = NULL;
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					PLine = (struct PanelLine *)ThisG->UserData;
					if((PLine) && (PLine->Handle) )
					{
						DUMPMSG	("HANDLE");
						PLine->Handle(PLine,IntuiMsg,ccd.Window);

						// If possibly changed in/out points, refresh clip display/icon slider
						if( PLine==ccd.TimePL )
						{
							DrawClipDisplay(ccd.ClipDisp);
							LegalizeIconSlide(&ccd);		// Clip icon pos/move knob
						}

						if(PLine==ccd.StrPL)					// Entered name string manually?
						{
							char	*ptr,c;
							BOOL	numonend=FALSE;

							ptr = ((struct StringInfo *)ccd.String->SpecialInfo)->Buffer;
							for (i=strlen(ptr)-1 ; i>0 ; i--)
							{
								c = ptr[i];
								if ((c<'0') || (c>'9'))
								{
									// Copy new prefix (even if no number on end)
									strncpy(ClipName2,ptr,i+1);		// Copy just the prefix

									if (numonend)		// Have specific number/fmt to use?
									{
										ClipName2[i+1] = 0;					// Terminate
										stcd_l(&ptr[i+1],(LONG *)&ccd.clipnum);	// Get new number
										ccd.clipnumdigits = strlen(&ptr[i+1]);		// Get # digits
									}
									else
									{
										ClipName2[i+1] = '.';				// Add '.' for them
										ClipName2[i+2] = 0;					// Terminate
										ccd.clipnum = 0;				// Start with .01
										ccd.clipnumdigits = 2;
									}
									break;
								}
								else numonend = TRUE;					// Yes, we can store this
							}
							ActivateGadget(Comm,ccd.Window,NULL);
						}

						DUMPHEXIL("Flags=",(LONG)PLine->Flags,"\\");
						if (PLine->Flags & PL_GENBUTT)
						{
							switch ((ULONG)PLine->Param)
							{
							case GB_REMOVE:		// Remove
								DUMPMSG	("DEL!");
								RemoveActiveClip(&ccd);		// Remove definition
								break;
							case GB_PREV:			// Prev
								PrevActiveClip(&ccd);		// Previous def
								break;
							case GB_NEXT:			// Next
								NextActiveClip(&ccd);		// Next def
								break;
							case GB_RECPANEL:		// To record panel
								Playing=FALSE;
								Going = FALSE;
								Success = PAN_RECORD;
//								DHD_Abort(0);
								break;
							case GB_CONTINUE:
							case GB_CANCEL:
								Playing=FALSE;
//								DHD_Abort(0);
								// (fall thru to std handler)
							default:
								DoGenButtons(PLine,ccd.Window,&Success,&Going);	// Other genbutt's
								break;
							}
						}
					}
					else switch (ID)
					{
//						case ID_DARK_CONTINUE:
//							DUMPMSG	("CONTINUE");
//							Success = PAN_CONTINUE;
//						case ID_REQ_DARK_CANCEL:
//							Playing=FALSE;
//							Going = FALSE;			//Success was initialized to FALSE
////							DHD_Abort(0);
//							break;
//						case ID_REC_PANEL:
//							Playing=FALSE;
//							Going = FALSE;			//Success was initialized to FALSE
//							Success = PAN_EASY;
////							DHD_Abort(0);
//							break;
						case CD_ID:
							if(ccd.cl)
							{
								BOOL	newnameup = FALSE;

								// Okay, clicked in the bar somewhere -- determine where
								t=ccd.Tmin + ((IntuiMsg->MouseX - ccd.ClipDisp->X)*0xFFFF)/ccd.ClipDisp->Scale;
								t&=~1;
								DUMPUDECW("MouseX= ",(WORD)IntuiMsg->MouseX,"  ");
								if( !(tcl=GetClip(ccd.ClipDisp,t)) )
								{
									DUMPUDECL("No Clip Found at ",(LONG)t,"\\");
									sprintf(ClipName,"%s%0*d",ClipName2,ccd.clipnumdigits,++ccd.clipnum);

									// Just add a piece, just so it's sorted into list
									tcl=AddClip(ccd.ClipDisp,t,t,CLIP_ACTIVE,ClipName);
									if (tcl)
									{
										newnameup = TRUE;

										// Left ALT means pointing at in-point
										if (!(IntuiMsg->Qualifier & IEQUALIFIER_LALT))
										{
											// Move inpoint to end of prev (or minimum if none)
											if( (ncl=(struct NewClip *)tcl->Node.mln_Pred) && ncl->Node.mln_Pred)
												tcl->in = ncl->out+FRAME_QUANT;
											else
												tcl->in = ccd.ClipDisp->MinVal;
										}

										// Right ALT means pointing at out-point
										if (!(IntuiMsg->Qualifier & IEQUALIFIER_RALT))
										{
											// Move outpoint to begin of prev (or maximum if none)
											if( (ncl=(struct NewClip *)tcl->Node.mln_Succ) && ncl->Node.mln_Succ)
												tcl->out = ncl->in-FRAME_QUANT;
											else
												tcl->out = ccd.ClipDisp->MaxVal;
										}
									}

//									tcl=AddClip(ccd.ClipDisp,in,out,CLIP_ACTIVE,ClipName);

//									if( (ncl=(struct NewClip *)tcl->Node.mln_Succ) && ncl->Node.mln_Succ )
//										tcl->out = ncl->in-FRAME_QUANT;
//									else
//										tcl->out=ccd.ClipDisp->MaxVal;
								}
								else DUMPUDECL("Hit clip at ",(LONG)t,"\\");

								if(tcl)
								{
									// Do everything to highlight new guy
									ChangeActiveClip(&ccd,tcl);

									if (newnameup)
									{
										// Activate name string gadget
										si = (struct StringInfo *) ccd.String->SpecialInfo;
										si->BufferPos = strlen(si->Buffer);		// Move cursor past end
										ActivateGadget(ccd.String,ccd.Window,NULL);
									}
								}
							}
							break;
					}
					break;

				case IDCMP_MOUSEMOVE:
				case IDCMP_MOUSEBUTTONS:
					if(Down)
					{
						PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,ccd.Window);
					}
					break;

				case IDCMP_INTUITICKS:
					if (TilQuiet>0)
					{
						if ((--TilQuiet)==0)
						{
							DHD_Quiet(Flds2Frms(MyRCB->Frame));
							ModifyIDCMP(ccd.Window,WinFlags);
						}
					}

					if( !EZGad || !(EZGad->Flags&GFLG_SELECTED) )
					{
						ModifyIDCMP(ccd.Window,WinFlags);
						EZGad=NULL;
						break;
					}
					if(!EZJump(Ticks++)) break;  // skip ticks
					ModifyIDCMP(ccd.Window,WinFlags); // turn off ticks
					if(MyRCB->pline->Flags&PL_IN)
						MyRCB->Frame = (ULONG)(*(MyRCB->pline->Param) - ccd.Tmin)<<1;
					else
						MyRCB->Frame = (ULONG)(*(MyRCB->pline->Param2) - ccd.Tmin)<<1;
					DUMPUDECL("Hi Time:",MyRCB->Max,"     " );
					DUMPUDECL("Lo Time:",MyRCB->Min,"    \\" );
					if(Adder>0) MyRCB->Flags = 0;
					else  MyRCB->Flags = DHD_PLAY_REV;
					DHD_Shuttle(MyRCB);
					EZGad=NULL;
					DrawClipDisplay(ccd.ClipDisp);
					LegalizeIconSlide(&ccd);			// Clip icon position, update slider
					UpdateAllDiff(ccd.RP,Start,ccd.Window);
					break;

				case IDCMP_RAWKEY:
					A = IntuiMsg->Code;
					if(A<0x80)
					{
						qf = IntuiMsg->Qualifier;
						DUMPHEXIB("Key Code: ",A,"\\");
						switch(A)
						{
							case	RAW_IN:
								if(!In)	break;
								ActivateGadget(In,ccd.Window,NULL);
								ccd.TimePL->Flags &= ~PL_OUT;
								ccd.TimePL->Flags |= PL_IN;
								break;
							case	RAW_OUT:
								if(!Out)	break;
								ActivateGadget(Out,ccd.Window,NULL);
								ccd.TimePL->Flags &= ~PL_IN;
								ccd.TimePL->Flags |= PL_OUT;
								break;
							case	RAW_DEL:
								if(!ccd.String) break;
								ActivateGadget(ccd.String,ccd.Window,NULL);
								break;
							case	RAW_LEN:
								if(!Comm) break;
								ActivateGadget(Comm,ccd.Window,NULL);
								break;
							case	RAWKEY_X:
								RemoveActiveClip(&ccd);			// Do all necessary
								break;
							case	RAWKEY_LEFT:
								if(qf & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
									d = 30;
								else if(qf & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
									d = (ccd.TimePL->PropEnd - ccd.TimePL->PropStart)/10+1;
								else
									d=(ccd.TimePL->Flags&PL_CFRAME) ? 2:1;

								if (ccd.TimePL->Flags & PL_IN)
									V=ccd.TimePL->Param;
								else
									V=ccd.TimePL->Param2;

								Y = *V;
								*V = (Y>=(*LoTime+d)) ? (Y-d) : (*LoTime);
								MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
								DHD_Jump(MyRCB,FALSE);

								WinFlags=ccd.Window->IDCMPFlags;
								ModifyIDCMP(ccd.Window,WinFlags|IDCMP_INTUITICKS);
								TilQuiet = 5;

								if (ccd.FramePL)
								{
									ccd.FramePL->PropEnd = ccd.cl->out;
									ccd.FramePL->PropStart = ccd.cl->in;
									if(ccd.cl->in==ccd.cl->out)
									{
										ccd.FramePL->PropEnd += 2;
										ccd.cl->icon=ccd.cl->in;
									}
								}

								UpdateAllDiff(ccd.RP,Start,ccd.Window);
								break;
							case RAWKEY_RIGHT:
								if(qf & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
									d = 30;
								else if(qf & (IEQUALIFIER_LALT | IEQUALIFIER_RALT) )
									d = (ccd.TimePL->PropEnd - ccd.TimePL->PropStart)/10+1;
								else
									d=(ccd.TimePL->Flags&PL_CFRAME) ? 2:1;

								if (ccd.TimePL->Flags & PL_IN)
									V=ccd.TimePL->Param;
								else
									V=ccd.TimePL->Param2;
								Y = *V;
								*V = (Y<=(*HiTime-d)) ? (Y+d) : (*HiTime);
								MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
								DHD_Jump(MyRCB,FALSE);

								WinFlags=ccd.Window->IDCMPFlags;
								ModifyIDCMP(ccd.Window,WinFlags|IDCMP_INTUITICKS);
								TilQuiet = 5;

								if (ccd.FramePL)
								{
									ccd.FramePL->PropEnd = ccd.cl->out;
									ccd.FramePL->PropStart = ccd.cl->in;
									if(ccd.cl->in==ccd.cl->out)
									{
										ccd.FramePL->PropEnd += 2;
										ccd.cl->icon=ccd.cl->in;
									}
								}
								UpdateAllDiff(ccd.RP,Start,ccd.Window);
								break;
							case RAWKEY_UP:
								if (ccd.TimePL->Flags & PL_IN)
									V=ccd.TimePL->Param;
								else
									V=ccd.TimePL->Param2;

								if(qf & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
								{
									*V = *HiTime;
									MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
									MyRCB->pline = ccd.TimePL;
									DHD_Jump(MyRCB,TRUE);
									UpdateAllDiff(ccd.RP,Start,ccd.Window);
								}
#if 0
								else if(qf & IEQUALIFIER_CONTROL )
								{
									*V = *HiTime;
									MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
									MyRCB->pline = ccd.TimePL;
									MyRCB->Flags = DHD_PLAY_REV;
									DHD_Jog(MyRCB);
									UpdateAllDiff(ccd.RP,Start,ccd.Window);
								}
#endif
								if (ccd.FramePL)
								{
									if(ccd.cl->in==ccd.cl->out)
									{
										ccd.FramePL->PropEnd += 2;
										ccd.cl->icon=ccd.cl->in;
									}
								}
								break;
							case RAWKEY_DOWN:
								if (ccd.TimePL->Flags & PL_IN)
									V=ccd.TimePL->Param;
								else
									V=ccd.TimePL->Param2;
								if(qf & (IEQUALIFIER_LSHIFT | IEQUALIFIER_RSHIFT) )
								{
									*V = *LoTime;
									MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
									MyRCB->pline = ccd.TimePL;
									DHD_Jump(MyRCB,TRUE);
									UpdateAllDiff(ccd.RP,Start,ccd.Window);
								}
#if 0
								else if(qf & IEQUALIFIER_CONTROL )
								{
									*V = *LoTime;
									MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
									MyRCB->pline = ccd.TimePL;
									MyRCB->Flags = 0;
									DHD_Jog(MyRCB);
									UpdateAllDiff(ccd.RP,Start,ccd.Window);
								}
#endif
								if (ccd.FramePL)
								{
									if(ccd.cl->in==ccd.cl->out)
									{
										ccd.FramePL->PropEnd += 2;
										ccd.cl->icon=ccd.cl->in;
									}
								}
								break;
							case RAWKEY_S:			// make still
								// First, grab "out" point
								ccd.TimePL->Flags &= ~PL_IN;
								ccd.TimePL->Flags |= PL_OUT;
								SetHiLo(ccd.TimePL);

								V=ccd.TimePL->Param2;		// Adjust out point
								*V = *LoTime;			// Go as low as possible
								MyRCB->Frame = (ULONG)(*V - ccd.Tmin)<<1;
								MyRCB->pline = ccd.TimePL;
								MyRCB->Flags = 0;
								DHD_Jump(MyRCB,TRUE);
								UpdateAllDiff(ccd.RP,Start,ccd.Window);

								if (ccd.FramePL)
								{
									if(ccd.cl->in==ccd.cl->out)
									{
										ccd.FramePL->PropEnd += 2;
										ccd.cl->icon=ccd.cl->in;
									}
								}
								DrawClipDisplay(ccd.ClipDisp);
								LegalizeIconSlide(&ccd);			// Clip icon position, update slider
								break;
							case RAWKEY_N:			// next clip
							case RAWKEY_PLUS:		// ditto
							case RAWKEY_PAD_PLUS:	// ditto
								NextActiveClip(&ccd);
								break;
							case RAWKEY_P:				// prev clip
							case RAWKEY_MINUS:		// ditto
							case RAWKEY_PAD_MINUS:	// ditto
								PrevActiveClip(&ccd);
								break;
#ifdef CUT_ROOM_HELP
							case RAWKEY_HELP:
								//*** CTRL+HELP ---> Put up "Help" requester
								SimpleRequest(ccd.Window,HelpMsg,17,REQ_H_CENTER,NULL);
								break;
#endif
						}
					}
					else if( (A==(RAW_KEYUP|RAWKEY_LEFT))
							|| (A==(RAW_KEYUP|RAWKEY_RIGHT))
							||	(A==(RAW_KEYUP|RAWKEY_DOWN))
							|| (A==(RAW_KEYUP|RAWKEY_UP)) )	// key-up
					{
						DrawClipDisplay(ccd.ClipDisp);
						LegalizeIconSlide(&ccd);			// Clip icon position, update slider
					}
					if ((A == RAWKEY_PAD_ENTER)||(A == RAWKEY_RETURN))
					{
						Going = FALSE;
						Playing=FALSE;
						Success = PAN_CONTINUE;
					}
					else if((A == RAWKEY_ESC)) Going = FALSE;
					break;
				}
				ReplyMsg((struct Message *)IntuiMsg);
			}
		}
		CloseWindow(ccd.Window);
		WaitBlit();
	}
rErrExit:

	partsPL->PropStart += stripbase+1;

//	DUMPUDECL("(Include code would have been ",partsPL->PropStart,")\\");

 if((Success == PAN_CONTINUE) && (ccd.ClipDisp))		// Do it?
 {
	// Compute destination volume/path
	if (destPL)
	{
		if (destPL->PropStart != FlyerDriveCount)		// "Same as Source"?
		{
			FlyDrive = FlyerDrives[destPL->PropStart];	// Find volume string picked
			if(*FlyDrive==AUDIO_BYTE)
				FlyDrive+=2;					// Skip speaker symbol char and space

			// Prepend just the selected volume name before all files made here
			strcpy(ClipPath,FlyDrive);
		}
	}

//	DUMPSTR("Processing to path:");
//	DUMPMSG(ClipPath);

	if (FromRawClip)
	{
		if (WFF_WARN_CUTTING & UserPrefs.WarnFlags)		// Req only if enabled
			MPtr[0] = "Are you sure you want to begin cutting?";
		else
			MPtr[0] = NULL;
	}
	else
		MPtr[0] = "This will destroy the original clip!";

	if ((!destructive) || (MPtr[0] == NULL) || (BoolRequest(EditTop->Window,MPtr[0])))
	{
		// If any name exists or are used multiple times, reopen and fix!
		ok = ClipDisplayNameCheck(ccd.ClipDisp,ClipPath,EditTop->Window);
		if (ok<0)
			goto ReOpen;

//		if (ok && (*Strip))
		if (ok)
		{
			ClipFlags=0;
//			if((*Strip&1))
			if (partsPL->PropStart & 1)
				ClipFlags |= CAF_VIDEO;
//			if((*Strip&2))
			if (partsPL->PropStart & 2)
				ClipFlags |= CAF_AUDIO;

			error = CutClipDownload(ccd.ClipDisp,ClipPath,ClipFlags);
			if (error == FERR_OKAY)
			{
				if (destructive)
					sprintf(pstr,"              Cutting clips on drive %s",FlyDrive);
				else
					sprintf(pstr,"              Processing clips on drive %s",FlyDrive);
				OpenNoticeWindow(EditTop->Window,PatienceMsg,2,FALSE);

				// Close the cut list -- this lets the Flyer make all the clips
				error = DHD_EndClipList(1);
				ListOpen = FALSE;

				DUMPMSG("List is closed");

				// If includes video, make an icon for each sub-clip
				if(ClipFlags&CAF_VIDEO)
				{
					DUMPMSG("Making icons");
					ClipDisplayIcons(ccd.ClipDisp,ClipPath);
				}

				CloseNoticeWindow();

				// Check for Flyer refusing to cut clip because all pieces won't fit
				if (error == FERR_FULL)
				{
					if (destructive)			// Destructive version
					{
						MPtr[0] = "All the new clips will not fit in original clip's space";
						MPtr[1] = "Re-adjust in/out points to reduce overlap";
						SimpleRequest(EditTop->Window,MPtr,2,REQ_CENTER|REQ_H_CENTER,NULL);
						goto ReOpen;
					}
					else						// (Non-destructive)
					{
						MPtr[0] = "One or more clips would not fit on drive, and were";
						MPtr[1] = "therefore skipped.  Processing panel will re-open";
						MPtr[2] = "showing only those that were skipped";
						SimpleRequest(EditTop->Window,MPtr,3,REQ_CENTER|REQ_H_CENTER,NULL);

						//	Check what clips succeeded, remove them from list
						RemoveClipsDone(ccd.ClipDisp,ClipPath,EditTop->Window);

						goto ReOpen;
					}
				}
				else if (error != FERR_OKAY)			// Failed somehow?
				{
					MPtr[0] = "Failed to cut all clips";
					sprintf(pstr,"Internal error %ld",error);
					MPtr[1] = pstr;
					SimpleRequest(EditTop->Window,MPtr,2,REQ_CENTER|REQ_H_CENTER,NULL);
					if (!destructive)
						goto ReOpen;			// Let'em try again
					else
						error = FERR_OKAY;	// Must not retry, as original is likely gone!!!
				}
			}
			else
			{
				DHD_EndClipList(0);		// Abort list
				ListOpen = FALSE;
			}

			if (error != FERR_OKAY)
				goto ReOpen;
		}

		// If destructive clip cutting was performed, destroy original
		if(destructive)
		{
//			strncpy(ClipName,FlyDrive,CLIP_PATH_MAX);				// OBSOLETE!!
//			strncat(ClipName,TEMP_CLIP_NAME,CLIP_PATH_MAX);
			CrDeleteFile(SrcName);
		}
	}
	else
	{
		// Do this if user panics at the "destroy original clip" req
		DHD_EndClipList(0);		// Abort list
		ListOpen = FALSE;
		goto ReOpen;
	}
 }

	if (ccd.ClipDisp)
		FreeClipDisplay(ccd.ClipDisp);

	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine && PLine->Destroy && (PLine->Type != PNL_SKIP))
			PLine->Destroy(PLine);
	}

	// If we failed to finish download to Flyer, close it
	if (ListOpen)
		DHD_EndClipList(0);

	return(Success);
}




UWORD __asm MiniPanel(REG(a0) struct EditWindow *Edit,REG(a1) struct PanelLine *PLine, REG(d0) UWORD XPMode)
{
	WORD H = PNL_Y1,ID,A,B,X1=0,Y1=0,Lines=0;
	struct Gadget *ThisG=0;
//	struct Gadget *ContCan;
	struct Window *Window=0;
	struct RastPort *RP;
	BOOL Going = TRUE;
	UWORD Success = PAN_CANCEL;
	struct IntuiMessage *IntuiMsg;
	struct StringInfo *si;
	ULONG Y=0;
//	LONG F;

	FirstG=0; Down=0; EZGad=NULL; In=NULL; Out=NULL; Del=NULL; Len=NULL; LastString=NULL;
	Wide=FALSE;
	for(Start = PLine; PLine->Type && !Wide; PLine++ )
	{
		if ((PPOS_WIDER & PLine->Align) || (PPOS_HALF2 & PLine->Align))
			Wide=TRUE;
	}

	ClipNW.Flags = STD_FLAGS;		// Default window flags

	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine->Type != PNL_SKIP)
		{
			if (PPOS_HALF2 & PLine->Align)
				X1 = PNL_WIDTH;

			// Call the gadget's create function
			if(PLine->Create)		Y1=PLine->Create(X1,H,PLine,&ThisG);

			if(PPOS_WIDER & PLine->Align)
			{
				X1 = PNL_WIDTH;
				Y = Y1;
			}
			else
			{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
				X1 = 0;
				Y = 0;
			}
			if(PLine->Flags)
			{
				if(PLine->Flags&PL_IN)
					In=PLine->StrGadg;
				else if(PLine->Flags&PL_OUT)
					Out=PLine->StrGadg;
				else if(PLine->Flags&PL_DEL)
					Del=PLine->StrGadg;
				else if(PLine->Flags&PL_LEN)
					Len=PLine->StrGadg;
				if(PLine->Flags&PL_SMREF)		// Somebody wants smart refresh
					ClipNW.Flags = REC_FLAGS;
			}
			Lines++;
		}
	}

	if(X1>0) H += MAX(Y,Y1);  // last gad...
	if(Wide) X1=PNL_WIDTH;


//	if(ContCan=CreateContCancel(X1,H,&ThisG,XPMode))
//		H += (UWORD)(PNL_YADD + ContCan->Height);
//	else goto ErrExit;


	ClipNW.Width = PNL_WIDTH + (Wide ? PNL_WIDTH:0);
	ClipNW.Height = H;
	ClipNW.Screen = EditScreen;
	ClipNW.LeftEdge = EditTop->Window->LeftEdge +
		((EditTop->Window->Width - ClipNW.Width)/2);
	ClipNW.TopEdge = EditTop->Window->TopEdge; // MIN(PANEL_TOP,(EditScreen->Height - ClipNW.Height)/2) ;
	ClipNW.FirstGadget = NULL;
	SaveBorder(&EditScreen->RastPort,ClipNW.LeftEdge,ClipNW.TopEdge,
		ClipNW.LeftEdge+ClipNW.Width-1,ClipNW.TopEdge+ClipNW.Height-1);
	if (Window = OpenWindow((struct NewWindow *)&ClipNW))
	{
		SoftSpriteOff();				// Shut off for the duration -- faster, and less flash

		RP = Window->RPort;
		ClipNW.Flags = STD_FLAGS;
		SetDrMd(RP,JAM2);
		AddGList(Window,FirstG,0,-1,NULL);
		NewBorderBox(RP,0,0,Window->Width-1,Window->Height-1,BOX_CP_BORDER);
		SetFont(RP,DarkFont);
//		RefreshGList(ContCan,Window,NULL,-1);
		H = PNL_Y1;

		PLine = Start;
		X1 = 0;
		Y = 0;
		while (PLine->Type)
		{
			if(PLine->Type != PNL_SKIP)
			{
				PLine->Win = Window;

				if (PPOS_HALF2 & PLine->Align)
					X1 = PNL_WIDTH;

				// Call the gadget's draw function
				if(PLine->Draw) Y1=PLine->Draw(X1,H,PLine,Window);

				if(PLine->Flags & PL_ACTIVATE)
				{
					si = (struct StringInfo *) PLine->StrGadg->SpecialInfo;
					si->BufferPos = strlen(si->Buffer);		// Move cursor past end
					ActivateGadget(PLine->StrGadg,Window,NULL);
				}

				if(PPOS_WIDER & PLine->Align)
				{
					X1 = PNL_WIDTH;
					Y = Y1;
				}
				else
				{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
					X1 = 0;
					Y = 0;
				}
			}
			PLine++;
		}

		SoftSpriteOn();

		// handle window events
		goto GetEm;
		while (Going)
		{
				WaitPort(Window->UserPort);
			GetEm:
			while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort)) {
				switch(IntuiMsg->Class) {
				case IDCMP_GADGETDOWN:
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(LastString)
					{
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//Y=FixTimeStr(PLine,Window,FALSE);
								Y=FixTimeStr(PLine,Window,TRUE);
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if(*PLine->Param>PLine->PropEnd) *PLine->Param=PLine->PropEnd;
								if(*PLine->Param<PLine->PropStart) *PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else
								strcpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer);
						}
						LastString=NULL;
					}
					if(!(PLine = (struct PanelLine *)ThisG->UserData)) break;
					if(ID==STRING_ID)	LastString=ThisG;
					if(PLine->Handle) PLine->Handle(PLine,IntuiMsg,Window);
					break;

				case IDCMP_GADGETUP:
//					DUMPMSG	("GADGETUP");

					if (Down)
					{
						Down = NULL;
						ModifyIDCMP(Window,WinFlags);
					}
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;

					if(LastString && LastString!=ThisG)
					{
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//FixTimeStr(PLine,Window,FALSE);
								FixTimeStr(PLine,Window,TRUE);
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if(*PLine->Param>PLine->PropEnd) *PLine->Param=PLine->PropEnd;
								if(*PLine->Param<PLine->PropStart) *PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else
								strncpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer,(int)PLine->PropEnd);
						}
						LastString=NULL;
					}

					PLine = (struct PanelLine *)ThisG->UserData;

					if(PLine && PLine->Handle)
					{
						PLine->Handle(PLine,IntuiMsg,Window);

						DoGenButtons(PLine,Window,&Success,&Going);

						if (PLine->Flags & PL_GENBUTT)
						{
							switch ((ULONG)PLine->Param)
							{
							case GB_REORG:		// Reorg drive
								Going = FALSE;				// Exit panel
								Success = PAN_EASY;		// Re-open panel again
								break;
							}
						}

					}
//					else switch (ID)
//					{
//						case ID_DARK_CONTINUE:
//							DUMPMSG	("CONTINUE");
//							Success = PAN_CONTINUE;
//						case ID_REQ_DARK_CANCEL:
//							Going = FALSE;			//Success was initialized to FALSE
//							break;
//						case ID_FINE_TUNE:
//							Going = FALSE;
//							Success = PAN_EXPERT;
//							break;
//						case ID_QUICK_TUNE:
//							Going = FALSE;
//							Success = PAN_EASY;
//							break;
//					}
					break;

				case IDCMP_MOUSEMOVE:
				case IDCMP_MOUSEBUTTONS:
					if(Down)
					{
						PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,Window);
					}
					break;

				case IDCMP_INTUITICKS:
					if( !EZGad || !(EZGad->Flags&GFLG_SELECTED) )
					{
						ModifyIDCMP(Window,WinFlags);
						EZGad=NULL;
						break;
					}

					// Handle ticks to EZ gadgets
					TickEZLenPL((struct PanelLine *)EZGad->UserData,Window,EZJump(Ticks++));

//					if(EZJump(Ticks++))  // skip ticks
//					{
//						if( !(PLine=(struct PanelLine *)EZGad->UserData) ) break;
//
//						if( ((F=*PLine->Param) >= PLine->PropStart) || (Adder>0))  // negative #s
//							F += Adder*EZJump(Ticks);
//						else break;
//						if(Adder<0)
//							*(PLine->Param) = (F>=PLine->PropStart ? F:PLine->PropStart);
//						else
//							*(PLine->Param) = (F<=PLine->PropEnd ? F:PLine->PropEnd);
//						UpdatePanProp(PLine,Window);
//						UpdatePanStr(PLine,Window);
//						UpdateAllDiff(RP,Start,Window);
//					}
					break;

				case IDCMP_RAWKEY:
					A = IntuiMsg->Code;
					if(A<0x80)
					{
						B = IntuiMsg->Qualifier;
						DUMPHEXIB("Key Code: ",A,"\\");
						switch(A)
						{
							case	RAW_IN:
								if(In)	ActivateGadget(In,Window,NULL);
								break;
							case	RAW_OUT:
								if(Out)	ActivateGadget(Out,Window,NULL);
								break;
							case	RAW_LEN:
								if(Len)	ActivateGadget(Len,Window,NULL);
								break;
							case	RAW_DEL:
								if(Del)	ActivateGadget(Del,Window,NULL);
								break;
							case	RAWKEY_PAD_ENTER:
							case	RAWKEY_RETURN:
								Going = FALSE;
								Success=TRUE;
								break;
							case	RAWKEY_HELP:
								if(XPMode==TUNE_FINE)
								{
									Success = PAN_EXPERT;
									Going = FALSE;
								}
								else if(XPMode==TUNE_QUICK)
								{
									Success = PAN_EASY;
									Going = FALSE;
								}
//								else
//									Success = PAN_CONTINUE;
								break;
//							case	RAWKEY_F9:  // Inert on panels without Quick/fine tune button
//								if(XPMode==TUNE_FINE) Success = PAN_EXPERT;
//								else if(XPMode==TUNE_QUICK) Success = PAN_EASY;
//								else break;
//								Going = FALSE;
//								break;
							case	RAWKEY_ESC:
								Going = FALSE;
								break;
						}
					}
					break;
				}
				ReplyMsg((struct Message *)IntuiMsg);
			}
		}

		CloseWindow(Window);
		WaitBlit();

// update modified parameters
		PLine = Start;
		while (PLine->Type)
		{
			switch(PLine->Type) {
			case PNL_IN_TYPE:
			case PNL_OUT_TYPE:
				if (PLine->G1->Flags & GFLG_SELECTED) *(PLine->Param) = 1;
				else *(PLine->Param) = 0;
				break;
			}
			PLine++;
		}
	}
//ErrExit:
	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine && PLine->Destroy && (PLine->Type!=PNL_SKIP) )
			PLine->Destroy(PLine);
	}
//	if (ContCan) FreeGadgets(ContCan);

	return(Success);
}


/*********************************************
*
* Allocate and init Envelope Type Gadget
*
*********************************************/
struct AudEnvDisp *NewEnvGad(	struct RastPort *RP,
									 	struct RastPort *DBRP,
									 	UWORD X,
									 	UWORD Y,
										UWORD W,
										UWORD H,
										ULONG GADID)
{
	struct AudEnvDisp *aev;

	// allocate the Envelope structure

	if (aev = AllocMem(sizeof(struct AudEnvDisp),MEMF_PUBLIC|MEMF_CLEAR))
	{

		// init the Envelope structure
		aev->X=X;
		aev->Y=Y;
		aev->W=W;
		aev->H=H;
		aev->InPoint=0;
		aev->OutPoint=0;
		aev->MinVal=0;
		aev->MaxVal=0;
		aev->HScale=0;
		aev->VScale=0;
		aev->KeyCount=0;
		aev->RP=RP;
		aev->DRP=DBRP;
		aev->DBM=DBRP->BitMap;
		aev->SELECTED_KEY=NULL;

		NewList(&aev->AEDKeys);
	
		// init the Envelope Gadget structure
		aev->EnvDispGadget.NextGadget=NULL;
		aev->EnvDispGadget.LeftEdge=X-2;
		aev->EnvDispGadget.TopEdge=Y-2;
		aev->EnvDispGadget.Width=W+6;
		aev->EnvDispGadget.Height=H+5;
		aev->EnvDispGadget.Flags=GFLG_GADGHNONE;
		aev->EnvDispGadget.Activation=RELVERIFY|GACT_IMMEDIATE; //|GACT_FOLLOWMOUSE;
		aev->EnvDispGadget.GadgetType=BOOLGADGET;
		aev->EnvDispGadget.GadgetRender=NULL;
		aev->EnvDispGadget.GadgetText=NULL;
		aev->EnvDispGadget.MutualExclude=NULL;
		aev->EnvDispGadget.SpecialInfo=NULL;
		aev->EnvDispGadget.GadgetID=GADID;
		aev->EnvDispGadget.UserData=NULL;
		return(aev);
	}
	else
		return(NULL);

}


/*************************************************************
*
* ValidEnvTag - Fix audio Env Tag due to in/out point changs.
*
*************************************************************/
void	ValidEnvTag(struct AudioEnv *AEtag,LONG InPoint, LONG OutPoint,UWORD Mode)
{

struct VE_Key	{
	struct MinNode	MN;
	ULONG	Time;
	UWORD	Flags;
	UWORD	VOL1;
	UWORD	VOL2;
	WORD	PAN1;
	WORD	PAN2;
	};

	struct MinList AE_VList;
	struct VE_Key	*NewAE_VNode,*AE_VNode,*OldAE_VNode;
	ULONG FInPoint,FOutPoint,curr_time;
	
	UWORD	 i;

	FInPoint	= InPoint*2;
	FOutPoint = OutPoint*2;

	DUMPUDECL("\\FInPoint  ",FInPoint,"\\");
	DUMPUDECL("FOutPoint ",FOutPoint,"\\");


	if(AEtag->Keysused==0)
	{
		AEtag->AEKeys[0].GoTime=FInPoint;
		AEtag->AEKeys[0].NumOfFlds=0;
		AEtag->AEKeys[0].Flags=0x666;
 		AEtag->AEKeys[0].VOL1=65535/2;  
 		AEtag->AEKeys[0].VOL2=65535/2;  
 		AEtag->AEKeys[0].PAN1=-32768;  
 		AEtag->AEKeys[0].PAN2=32767;

		AEtag->AEKeys[0].GoTime=FInPoint+4;
		AEtag->AEKeys[0].NumOfFlds=FOutPoint-FInPoint-4;
		AEtag->AEKeys[0].Flags=0x666;
 		AEtag->AEKeys[0].VOL1=65535/2;  
 		AEtag->AEKeys[0].VOL2=65535/2;  
 		AEtag->AEKeys[0].PAN1=-32768;  
 		AEtag->AEKeys[0].PAN2=32767;
	}
	else
	{
		NewList(&AE_VList);
		for(i=0;i<AEtag->Keysused;i++)
		{
			if(NewAE_VNode=AllocMem(sizeof(struct VE_Key),MEMF_PUBLIC|MEMF_CLEAR))
			{
				AddTail(&AE_VList,NewAE_VNode);
				NewAE_VNode->Time = AEtag->AEKeys[i].GoTime+AEtag->AEKeys[i].NumOfFlds;
				NewAE_VNode->Flags = AEtag->AEKeys[i].Flags;
				NewAE_VNode->VOL1 = AEtag->AEKeys[i].VOL1;
				NewAE_VNode->VOL2 = AEtag->AEKeys[i].VOL2;
				NewAE_VNode->PAN1 = AEtag->AEKeys[i].PAN1;
				NewAE_VNode->PAN2	= AEtag->AEKeys[i].PAN2;
			}
		}

		// Scan list remove nodes outside In/Out points.
		AE_VNode=AE_VList.mlh_Head; 
		do 
		{
			if((AE_VNode->Time<FInPoint)||(AE_VNode->Time>FOutPoint))
			{
				OldAE_VNode=AE_VNode;
				AE_VNode=AE_VNode->mln_Succ;
				Remove(OldAE_VNode);
				DUMPUDECL("Node gotime ",OldAE_VNode->Time,"\\");
				DUMPUDECL("Freeing node ",OldAE_VNode,"\\");
				FreeMem(OldAE_VNode,sizeof(struct VE_Key));
			}
			else
			{
				AE_VNode=AE_VNode->mln_Succ;
			}
		} while(AE_VNode->mln_Succ);	

		// count keys in list
		i=0;
		for(AE_VNode=AE_VList.mlh_Head;AE_VNode->mln_Succ;AE_VNode=AE_VNode->mln_Succ)
		{
			i++;
		}

		if(i==0)
		{
			NewAE_VNode=AllocMem(sizeof(struct VE_Key),MEMF_PUBLIC|MEMF_CLEAR);
			AddTail(&AE_VList,NewAE_VNode);

			NewAE_VNode->Time=FInPoint;
			NewAE_VNode->Flags = 0x666;
			NewAE_VNode->VOL1 = 65535/2;
			NewAE_VNode->VOL2 = 65535/2;
			NewAE_VNode->PAN1 = -32768;
			NewAE_VNode->PAN2	= 32767;
 
			NewAE_VNode=AllocMem(sizeof(struct VE_Key),MEMF_PUBLIC|MEMF_CLEAR);
			AddTail(&AE_VList,NewAE_VNode);

			NewAE_VNode->Time=FOutPoint;
			NewAE_VNode->Flags = 0x666;
			NewAE_VNode->VOL1 = 65535/2;
			NewAE_VNode->VOL2 = 65535/2;
			NewAE_VNode->PAN1 = -32768;
			NewAE_VNode->PAN2	= 32767;
		}
	
		if(i==1) 
		{
			OldAE_VNode=AE_VList.mlh_Head;
			NewAE_VNode=AllocMem(sizeof(struct VE_Key),MEMF_PUBLIC|MEMF_CLEAR);
			AddTail(&AE_VList,NewAE_VNode);
			NewAE_VNode->Flags = OldAE_VNode->Flags;
			NewAE_VNode->VOL1 = OldAE_VNode->VOL1;
			NewAE_VNode->VOL2 = OldAE_VNode->VOL2;
			NewAE_VNode->PAN1 = OldAE_VNode->PAN1;
			NewAE_VNode->PAN2	= OldAE_VNode->PAN2;

			OldAE_VNode->Time=FInPoint;
			NewAE_VNode->Time=FOutPoint;
		}	
	
		if(i>1)
		{
			AE_VNode=AE_VList.mlh_Head;
			AE_VNode->Time=FInPoint;

			AE_VNode=AE_VList.mlh_TailPred;
			AE_VNode->Time=FOutPoint;
		}			

		curr_time=FInPoint;
		i=0;
		for(AE_VNode=AE_VList.mlh_Head;AE_VNode->mln_Succ;AE_VNode=AE_VNode->mln_Succ)
		{
			DUMPHEXIL("Copying Node to table ",AE_VNode,"\\");
			AEtag->AEKeys[i].GoTime = curr_time;
			AEtag->AEKeys[i].NumOfFlds = AE_VNode->Time-curr_time;
			AEtag->AEKeys[i].Flags = AE_VNode->Flags;	
			AEtag->AEKeys[i].VOL1 = AE_VNode->VOL1;
			AEtag->AEKeys[i].VOL2 = AE_VNode->VOL2;
			AEtag->AEKeys[i].PAN1 = AE_VNode->PAN1;
			AEtag->AEKeys[i].PAN2 = AE_VNode->PAN2;
			curr_time=AE_VNode->Time;
			if(curr_time==FInPoint)
				curr_time += 4;
			i++;
		}
		AEtag->Keysused = i;

		while(AE_VNode=RemHead(&AE_VList)) 
		{ 
			DUMPHEXIL("Final Freeing node ",AE_VNode,"\\");
			FreeMem(AE_VNode,sizeof(struct VE_Key));	
		}
	}
}




/*************************************************************
*
* TagtoKL - Make Key list from AudEnv16 struct.
*
*************************************************************/
void	TagtoKL(struct AudEnvDisp *aev,struct AudioEnv *AEtag)
{
	struct AEDKey *NewAEDNode;
	UWORD	 i;


	if(AEtag->Keysused==0)
	{
		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = aev->InPoint;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 65535/2;
			NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;
		}

		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = aev->OutPoint;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 65535/2;
			NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;
		}
	}
	else
	{
		

		DUMPUDECL("\\aev->InPoint        = ",aev->InPoint,"\\");
		DUMPUDECL("aev->OutPoint           = ",aev->OutPoint,"\\");
		DUMPUDECL("AEtag->AEKeys[0].GoTime = ",AEtag->AEKeys[0].GoTime,"\\ \\");

		for(i=0;i<AEtag->Keysused;i++)
		{
			if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
			{
				AddTail(&aev->AEDKeys,NewAEDNode);
				NewAEDNode->Time = ((AEtag->AEKeys[i].GoTime+AEtag->AEKeys[i].NumOfFlds)/2);
				NewAEDNode->Scaled_Time = 0;
				NewAEDNode->Value = 0xffff-AEtag->AEKeys[i].VOL1;
				NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
				NewAEDNode->Act = AEDKey_act;
				NewAEDNode->Att = Deleteable;					
			}
		}	
		NewAEDNode=aev->AEDKeys.mlh_TailPred;
		NewAEDNode->Att = TimeLocked;					
		
		NewAEDNode=aev->AEDKeys.mlh_Head;
		NewAEDNode->Att = TimeLocked;					
	}
}



/*************************************************************
*
* KLtoTag - Make AudEnv16-Tag from a key list.
*
*************************************************************/
void	KLtoTag(struct AudEnvDisp *aev,struct AudioEnv *AEtag)
{
	struct AEDKey *AEDNode;
	struct MinList *AEDHead;
	ULONG	 curr_time;
	int i=-1;
	struct AEKey *CurrKey;


	AEDHead = &aev->AEDKeys;	

	curr_time=aev->InPoint;
	DUMPUDECL("CurrTime",curr_time,"\\");
	

	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		i++;
		CurrKey=&AEtag->AEKeys[i];

		CurrKey->Flags=0x0666;
		CurrKey->GoTime=curr_time*2;
		CurrKey->NumOfFlds=(AEDNode->Time-curr_time)*2;
		DUMPUDECL("Durr of ramp",CurrKey->NumOfFlds,"\\");
		
		CurrKey->VOL1=0xffff-AEDNode->Value;
		CurrKey->VOL2=0xffff-AEDNode->Value;
		CurrKey->PAN1=-32768;
		CurrKey->PAN2=32767;
		
		curr_time=AEDNode->Time;
		if(curr_time==aev->InPoint)
			curr_time += 2;

	}
	AEtag->Keysused = i+1;
	AEtag->Flags 	=	0;
}




/*************************************************
*
*
*	SetTimeBounds -- Sets Panel Line PropStart/End
*
*
*************************************************/
void	SetTimeBounds(struct AudEnvDisp *aev,
						  struct PanelLine *PTime)
{
	
	struct AEDKey *prev,*next;



	if(aev->SELECTED_KEY)
	{	
		if(aev->SELECTED_KEY->Att&0x01)
		{
			DUMPMSG	("Got key its timelocked");
			PTime->PropStart=aev->SELECTED_KEY->Time;
			PTime->PropEnd=aev->SELECTED_KEY->Time;
		}	
		else
		{
			next=aev->SELECTED_KEY->mln_Succ;
			prev=aev->SELECTED_KEY->mln_Pred;

			DUMPMSG	("Got key, not timelocked");
			PTime->PropStart=prev->Time+4;
			PTime->PropEnd=next->Time-4;
		}
	}
}



/*************************************************
*
*
* AdjKeyValStr -- 
*
*
*************************************************/
void	AdjKeyValStr(struct AudEnvDisp *aev,
						 struct AEDKey *SelNode,
						 struct PanelLine *PNum,
						 struct Window *Window)
{

	*PNum->Param=(100-(SelNode->Value/655));
	UpdatePanStr(PNum,Window);
	DUMPMSG	("In adjkeyval after updatestring");

}


/*************************************************
*
*
* AdjKeyTimeStr -- 
*
*
*************************************************/
void	AdjKeyTimeStr(struct AudEnvDisp *aev,
						  struct AEDKey *SelNode,
						  struct PanelLine *PTime,
						  struct Window *Window)
{
	*PTime->Param=SelNode->Time;
	UpdatePanStr(PTime,Window);
	DUMPMSG	("In adjkeyTime after updatestring");

}




/**************************************************
*
* SelectEnvKey -- Select the envlope key closest to
*						where user clicked, or none(NULL)
*
**************************************************/
struct AudEnvDisp  *SelectEnvKey(struct AudEnvDisp *aev,
											UWORD	X, UWORD Y, 
											struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;
	UWORD Selabs_off=1000,abs_off=1000;	
	

	X -= aev->X; 
	Y -= aev->Y;	

	//DUMPHEXIW("In SelectEnvKey\\X= ",(UWORD)X,"\\");
	//DUMPHEXIW("Y= ",(UWORD)Y,"\\");

	AEDHead=&aev->AEDKeys;
	
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		abs_off=(abs((AEDNode->Scaled_Time-aev->MinVal)-X)+abs(AEDNode->Scaled_Val-Y));
		//DUMPHEXIW("abs_off= ",(UWORD)abs_off,"\\");
		if(abs_off<=12)
		{	
			if(SelNode)
			{
				if(abs_off<Selabs_off)
				{	
					SelNode=AEDNode;
					Selabs_off=abs_off;
				}
			}
			else
			{	
				SelNode=AEDNode;
				Selabs_off=abs_off;
			}
		}
	}

	if(SelNode)
	{
		for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
		{
			if(AEDNode->Act!=AEDKey_Inact)
				AEDNode->Act=AEDKey_act;
		}		
		SelNode->Act=AEDKey_sel;
		RedrawAudioevn(aev);

	}
	aev->SELECTED_KEY=SelNode;
	SetTimeBounds(aev,PTime);
	return(SelNode);
}




/**************************************************************
*
* SelectNextEnvKey -- Select the Next key to the one selected
*
**************************************************************/
struct AudEnvDisp  *SelectNextEnvKey(struct AudEnvDisp *aev,
												 struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;

	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		if(AEDNode->Act==AEDKey_sel)
		{
			AEDNode->Act=AEDKey_act;
			SelNode = AEDNode->mln_Succ;
			SelNode->Act=AEDKey_sel;

		}
	}		
	RedrawAudioevn(aev);
	aev->SELECTED_KEY=SelNode;
	//SetPTimeLimits(aev,PTime);
	SetTimeBounds(aev,PTime);
	return(SelNode);
}	




/**************************************************************
*
* SelectPrevEnvKey -- Select the prev key to the one selected
*
**************************************************************/
struct AudEnvDisp  *SelectPrevEnvKey(struct AudEnvDisp *aev,
												 struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;

	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{

		if(AEDNode->Act==AEDKey_sel)
		{
			AEDNode->Act=AEDKey_act;
			SelNode = AEDNode->mln_Pred;
			SelNode->Act=AEDKey_sel;

		}

	}		
	RedrawAudioevn(aev);
	aev->SELECTED_KEY=SelNode;
	//SetPTimeLimits(aev,PTime);
	SetTimeBounds(aev,PTime);
	return(SelNode);
}



/******************************************************
*
*	DeleteEnvKey --
*
*
******************************************************/
void	DeleteEnvKey(struct AudEnvDisp *aev,
						 struct AEDKey *AEDNode,
 						 struct Window *Window,
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)

{
	struct AEDKey *BNode;

	if(AEDNode -> Att & 0x02)
	{
		BNode = SelectPrevEnvKey(aev,PTime);
		Remove(AEDNode);
		FreeMem(AEDNode,sizeof(struct AEDKey));	
		RedrawAudioevn(aev);
		AdjKeyTimeStr(aev,BNode,PTime,Window);
		AdjKeyValStr(aev,BNode,PNum,Window);
	}
}


/******************************************************
*
* Timematch - See if any nodes fall on this time code.
*
*
******************************************************/
BOOL	Timematch(struct AudEnvDisp *aev,ULONG TIME)
{
	struct MinList *AEDHead;
	struct AEDKey  *AEDNode;
	BOOL	Match=FALSE;


	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		if(AEDNode->Time==TIME)
			Match=TRUE;
	}		
	return(Match);
}





/******************************************************
*
* CreateEnvKey	-- 
*				  		
*
******************************************************/
void	CreateEnvKey(struct AudEnvDisp *aev,
						 struct Window *Window,
				 		 struct IntuiMessage *IntuiMsg,
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)

{
	struct MinList *AEDHead;
	struct AEDKey  *NewAEDNode, *AEDNode, *SN_Hi, *SN_Low;
	UWORD  MX,MY;
	ULONG	 NewTime;

	MX=IntuiMsg->MouseX-aev->X;

	if(IntuiMsg->MouseY<aev->Y)
		MY=0;
	else 
	{
		if(IntuiMsg->MouseY>(aev->Y+aev->H-10))
			MY=50;
		else 
			MY=IntuiMsg->MouseY-aev->Y+2;
	}	
	NewTime=((((MX+aev->MinVal)*aev->HScale)/256)/4)*4;
	
	AEDHead = &aev->AEDKeys;
	AEDNode = AEDHead->mlh_TailPred;
	

	if((MX<(aev->X+aev->W))&
		(NewTime<AEDNode->Time)&
		(!Timematch(aev,NewTime)))
	{	
		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			NewAEDNode->Time = NewTime;
			NewAEDNode->Scaled_Time = MX+aev->MinVal;
			NewAEDNode->Value = MY*1310;
			NewAEDNode->Scaled_Val = MY;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = Deleteable;
		}

		SN_Hi = AEDHead->mlh_Head;

		SN_Low = SN_Hi;
		SN_Hi = SN_Hi->mln_Succ;

		while(NewAEDNode->Time>SN_Hi->Time)
		{
			SN_Low = SN_Hi;
			SN_Hi = SN_Hi->mln_Succ;
		}
	
		Insert(AEDHead,NewAEDNode,SN_Low);
	
		if(aev->SELECTED_KEY)
		{
			aev->SELECTED_KEY->Act = AEDKey_act;
		}
		NewAEDNode->Act=AEDKey_sel;
		aev->SELECTED_KEY=NewAEDNode;

		//SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime);

		RedrawAudioevn(aev);
		AdjKeyTimeStr(aev,NewAEDNode,PTime,Window);
		AdjKeyValStr(aev,NewAEDNode,PNum,Window);
		SetTimeBounds(aev,PTime);

	}
}



#define	XAcc	16*32
#define	YAcc	16*32
/******************************************************
*
* AdjKeyValue 	--	Make changes on key values based on 
*				  		mouse input.
*
******************************************************/
void	AdjKeyValue(struct AudEnvDisp *aev,
				 struct AEDKey *SelNode,
				 struct IntuiMessage *IntuiMsg)
{
	LONG	SCRATCH;


	SCRATCH = SelNode->Value;
	SCRATCH += (IntuiMsg->MouseY*YAcc);
	if(SCRATCH<0)
		SCRATCH=0;
	if(SCRATCH>65535) 
		SCRATCH=65535;
		
	SelNode->Value = (UWORD)SCRATCH;
	
	SelNode->Scaled_Val = SelNode->Value/1307;
	
	DUMPHEXIW("SelNode->Value ",(UWORD)SelNode->Value,"\\");
}


/**************************************************
*
* AdjKeyTime -- Make changes on key values based on 
*				 	 mouse input.
*
**************************************************/
void	AdjKeyTime(struct AudEnvDisp *aev,
				 struct AEDKey *SelNode,
				 struct IntuiMessage *IntuiMsg)
{
	LONG	SCRATCH;
	LONG	mmy;
	ULONG	HI_BOUND,LO_BOUND,CURTIME;
	struct AEDKey *prev,*next;

	next=SelNode->mln_Succ;
	prev=SelNode->mln_Pred;
	
	HI_BOUND=next->Time;
	LO_BOUND=prev->Time;

	mmy=IntuiMsg->MouseX;

	SCRATCH = SelNode->Time;

	SCRATCH += mmy*4;
	
	CURTIME=(((ULONG)SCRATCH)/4)*4;

	if(CURTIME<=LO_BOUND)
		CURTIME=LO_BOUND+4;

	if(CURTIME>=HI_BOUND)
		CURTIME=HI_BOUND-4;
	
	SelNode->Time = (ULONG)CURTIME;
	
	SelNode->Scaled_Time = (SelNode->Time*256)/aev->HScale;
	
	DUMPHEXIL("SelNode->Time ",(ULONG)SelNode->Time,"\\");

}



/**************************************************
*
* HandleKeyDrag --  Handle Envelope Key Draging
*
*
**************************************************/
void HandleKeyDrag(struct AudEnvDisp *aev,
						 struct Window *Window,
						 struct IntuiMessage *IntuiMsg,
						 struct AEDKey *SelNode,
						 UBYTE  RButton, 
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)
{
	BOOL mouseup=FALSE;
	UWORD	MX,MY;
	UBYTE KeyAtt;

	MX=IntuiMsg->MouseX;
	MY=IntuiMsg->MouseY;

	ReplyMsg((struct Message *)IntuiMsg);		//Orignal GadgetDown/RButton msg.
	SoftSpriteOff();
	ReportMouse(1,Window);
	ModifyIDCMP(Window,WinFlags|IDCMP_DELTAMOVE);
	KeyAtt=SelNode->Att;


	if(SelNode)
	{	
		AdjKeyTimeStr(aev,SelNode,PTime,Window);
		AdjKeyValStr(aev,SelNode,PNum,Window);
	}
	while(!mouseup)
	{
		WaitPort(Window->UserPort);
		while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort)) 
		{
			//DUMPHEXIL("Got IntuiMsg Class: ",IntuiMsg->Class," \\");

			switch(IntuiMsg->Class)
			{
			case IDCMP_GADGETUP:
				mouseup=TRUE;
				break;

			case IDCMP_MOUSEMOVE:
				if(SelNode)
				{
					if(RButton)
					{
						if(!(KeyAtt & 0x01))  //TimeLocked
						{
							AdjKeyTime(aev,SelNode,IntuiMsg);
							RedrawAudioevn(aev);
							AdjKeyTimeStr(aev,SelNode,PTime,Window);
						}
					}
					else
					{
						//DUMPHEXIW("MouseX= ",IntuiMsg->MouseX,"\\");
						//DUMPHEXIW("MouseY= ",IntuiMsg->MouseY,"\\");
						AdjKeyValue(aev,SelNode,IntuiMsg);	
						RedrawAudioevn(aev);
						AdjKeyValStr(aev,SelNode,PNum,Window);
					}
				}
				break;

			case IDCMP_MOUSEBUTTONS:
				if(IntuiMsg->Code==MENUUP)
					mouseup=TRUE;
				else
					if(IntuiMsg->Code==SELECTUP)
						mouseup=TRUE;
				break;

			}
			ReplyMsg((struct Message *)IntuiMsg);
			if(mouseup) break;		
		}
	}
	ReportMouse(0,Window);
	ModifyIDCMP(Window,WinFlags);
	ESparams2.Data1 = MX+Window->LeftEdge;
	ESparams2.Data2 = MY+Window->TopEdge;
	SendSwitcherReply(ES_MoveSprite,&ESparams2);
	SoftSpriteOn();
}




/**************************************************
*
* HandleEnvGad --  Handle Envelope Type Gadget
*
* 
* STATUS={KEY_DRAG,KEY_CREATE,KEY_DELETE}
*
*
*
**************************************************/
void HandleEnvGad(struct AudEnvDisp *aev,
						struct Window *Window,
						struct IntuiMessage *IntuiMsg,
						UBYTE	STATUS, 
						struct PanelLine *PTime,
						struct PanelLine *PNum)

{
	if(IntuiMsg->Code==MENUDOWN)
	{
		if(STATUS==KEY_DRAG)
				HandleKeyDrag(aev,Window,IntuiMsg,
								  SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),
								  1,PTime,PNum);		
	}
	else
	{
		switch(STATUS)
		{
			case	KEY_DRAG:
				HandleKeyDrag(aev,Window,IntuiMsg,
								  SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),		
								  0,PTime,PNum);		

			case	KEY_CREATE:
				CreateEnvKey(aev,Window,IntuiMsg,PTime,PNum);
				break;
	
				break;
			case	KEY_DELETE:
				DeleteEnvKey(aev,
								 SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),
								 Window,PTime,PNum);
				break;
		}
	
	}
}



/***********************************************************
*
* ScaleEnvelope
*
*	Scaling_Factor=width of super-envelope
***********************************************************/
void ScaleEnvelope(struct AudEnvDisp *aev,ULONG Scaling_Factor)
{
	struct AEDKey *AEDNode,*AEDNode2;
	struct MinList *AEDHead;
	ULONG	 Total_Time;

	aev->SuperEnvWidth=Scaling_Factor;
	AEDHead = &aev->AEDKeys;	
	AEDNode = AEDHead->mlh_Head;
	AEDNode2 = AEDHead->mlh_TailPred;

	Total_Time = AEDNode2->Time-AEDNode->Time;
	aev->HScale = (Total_Time*256)/Scaling_Factor;
	
	aev->MinVal = (AEDNode->Time*256)/aev->HScale;
	aev->MaxVal = (AEDNode2->Time*256)/aev->HScale;

	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		AEDNode->Scaled_Time = (AEDNode->Time*256)/aev->HScale;
	}

}	


/*************************************************************************
*
*	SetKeyInPLTime
*
*************************************************************************/
void	SetKeyInPLTime(struct AudEnvDisp *aev,
						   struct PanelLine *PLine)
{
	struct AEDKey *SelNode;
	ULONG	Temp;

	SelNode=aev->SELECTED_KEY;
	if(SelNode)
	{
		Temp= *PLine->Param;
		if(Temp>PLine->PropEnd)
		{
			*PLine->Param=PLine->PropEnd-4;
			Temp= *PLine->Param;
			AdjKeyTimeStr(aev,aev->SELECTED_KEY,PLine,aev->PWindow);
		}
		else	
		{
			if(Temp<PLine->PropStart)
			{
				*PLine->Param=PLine->PropStart+4;
				Temp= *PLine->Param;
				AdjKeyTimeStr(aev,aev->SELECTED_KEY,PLine,aev->PWindow);
			}
		}

		DUMPHEXIL("Time PLine->Param=",(ULONG)*PLine->Param,"\\");

		SelNode->Time=Temp;
		SelNode->Scaled_Time=(SelNode->Time*256)/aev->HScale;
	}
}


/*************************************************************************
*
*	SetKeyInPLValue
*
*************************************************************************/
void	SetKeyInPLValue(struct AudEnvDisp *aev,
							 struct PanelLine *PLine)
{
struct AEDKey *SelNode;

	UWORD Temp; 

	SelNode=aev->SELECTED_KEY;
	if(SelNode)
	{
		Temp = *PLine->Param;
		DUMPHEXIW("Value PLine->Param=",(UWORD)Temp,"\\");
		SelNode->Value = (100-Temp)*655;
		SelNode->Scaled_Val = SelNode->Value/1307;
	}
}


/**************************************************************************
*
*
*
*
**************************************************************************/
ULONG	__asm	*EnvPLGadUserFun(REG(a0) struct PanelLine *PLine,
									  REG(a1) struct IntuiMessage *IntuiMsg,
									  REG(a2) struct AudEnvDisp *Obj) 
{
	DUMPMSG	("EnvPLGadUserFun");

	if(PLine->Type==PNL_EZNUM)
	{
		SetKeyInPLValue(Obj,PLine);
	}	
	else
		if(PLine->Type==PNL_EZTIME)
			{
			SetKeyInPLTime(Obj,PLine);
			}
	DUMPHEXIL("EnvPLGadUserFun aev=",(ULONG)Obj,"\\");
	if(Obj)
		RedrawAudioevn(Obj);
	return(0);
}




#define AREASIZE 100
//***********************************************************************
// 
//	Audio Envelope panel experiment. 
//
//***********************************************************************
UWORD	AudEnvPanel(struct EditWindow *Edit,
						struct PanelLine *PLine,
						LONG Time_In,LONG Time_Out,
						LONG FadeIn,LONG FadeOut,
						struct AudioEnv *AETagTable)
{
	WORD H = PNL_Y1,ID,A,B,X1=0,Y1=0,KeyMoveY,Lines=0;
	struct Gadget *ThisG=0;
	struct Gadget *Envelope;
	struct Window *Window=0;
	struct AudEnvDisp *aev;
	struct RastPort *RP;
	struct AEDKey *NewAEDNode, *AEDNode, *TestKey;
	struct MinList *AEDHead;
	struct PanelLine	*EnvAction, *CurrPL, *KeepPL, *EnvTime, *EnvValue, *UseEnvCheck;
	struct EnvPLPtr *AudEnvPan;


	BOOL Going = TRUE;
	UWORD Success = PAN_CANCEL;
	struct IntuiMessage *IntuiMsg;
	struct StringInfo *si;
	ULONG Y=0;
	UWORD Mx,My;
	struct RastPort DMRP={0};				//The double buffer rastport for audioenv.	
	struct BitMap *DMBM;

	KeepPL=PLine;


	FirstG=0; Down=0; EZGad=NULL; In=NULL; Out=NULL; Del=NULL; Len=NULL; LastString=NULL;
	Wide=FALSE;

	for(Start = PLine; PLine->Type && !Wide; PLine++ )
	{
		if ((PPOS_WIDER & PLine->Align) || (PPOS_HALF2 & PLine->Align))
			Wide=TRUE;

	}

	ClipNW.Flags = STD_FLAGS;		// Default window flags

	for( PLine=Start; PLine->Type; PLine++ )
	{
		DUMPHEXIL("Panel Line  ",(ULONG)PLine,"\\");

		if(PLine->Type != PNL_SKIP)
		{
			if (PPOS_HALF2 & PLine->Align)
				X1 = PNL_WIDTH;

			// Call the gadget's create function

			if(PLine->Create)
			{
				DUMPMSG("BEFORE PLINE CREATE");
				Y1=PLine->Create(X1,H,PLine,&ThisG);
				DUMPMSG("AFTER PLINE CREATE");
			}
			if(PPOS_WIDER & PLine->Align)
			{
				X1 = PNL_WIDTH;
				Y = Y1;
			}
			else
			{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
				X1 = 0;
				Y = 0;
			}
			if(PLine->Flags)
			{
				if(PLine->Flags&PL_IN)
					In=PLine->StrGadg;
				else if(PLine->Flags&PL_OUT)
					Out=PLine->StrGadg;
				else if(PLine->Flags&PL_DEL)
					Del=PLine->StrGadg;
				else if(PLine->Flags&PL_LEN)
					Len=PLine->StrGadg;
				if(PLine->Flags&PL_SMREF)		// Somebody wants smart refresh
					ClipNW.Flags = REC_FLAGS;
			}
			Lines++;
		}
	}

	DUMPMSG	("DONE WITH HARD PART?");

	if(X1>0) H += MAX(Y,Y1);  // last gad...
	if(Wide) X1=PNL_WIDTH;


	ClipNW.Width = PNL_WIDTH + (Wide ? PNL_WIDTH:0);
	ClipNW.Height = H;
	ClipNW.Screen = EditScreen;
	ClipNW.LeftEdge = EditTop->Window->LeftEdge +
		((EditTop->Window->Width - ClipNW.Width)/2);
	ClipNW.TopEdge = EditTop->Window->TopEdge; // MIN(PANEL_TOP,(EditScreen->Height - ClipNW.Height)/2) ;
	ClipNW.FirstGadget = NULL;

	DUMPHEXIL("ClipNW.Flags     ",(ULONG)ClipNW.Flags,"\\");
	DUMPHEXIW("ClipNW.LeftEdge  ",(WORD)ClipNW.LeftEdge,"\\");
	DUMPHEXIW("ClipNW.TopEdge   ",(WORD)ClipNW.TopEdge,"\\");
	DUMPHEXIW("ClipNW.Width     ",(WORD)ClipNW.Width,"\\");
	DUMPHEXIW("ClipNW.Height    ",(WORD)ClipNW.Height,"\\");
	DUMPHEXIW("ClipNW.Type      ",(UWORD)ClipNW.Type,"\\");
	DUMPHEXIL("ClipNW.Screen    ",(LONG)ClipNW.Screen,"\\");

	SaveBorder(&EditScreen->RastPort,ClipNW.LeftEdge,ClipNW.TopEdge,
		ClipNW.LeftEdge+ClipNW.Width-1,ClipNW.TopEdge+ClipNW.Height-1);
	
	DUMPMSG	("Before open window");

	if (Window = OpenWindow((struct NewWindow *)&ClipNW))
	{
		DUMPMSG	("AFTER OPEN WINDOW");

		SoftSpriteOff();				// Shut off for the duration -- faster, and less flash

		RP = Window->RPort;

		//Initalize and setup the double buffer for envelope displays.
		DMRP.Mask = RP->Mask;
		DMRP.TmpRas = RP->TmpRas;
		DMRP.AreaInfo = RP->AreaInfo;
		DMRP.AreaPtrn = RP->AreaPtrn;
		InitRastPort(&DMRP);
		DMRP.BitMap=AllocBitMap(484+20,50+20,RP->BitMap->Depth,BMF_DISPLAYABLE,NULL);;

		// Go and get aev struct allocated and initilized
		aev = NewEnvGad(RP,&DMRP,25-4,50-4,484+6,50+8,EV_GAD01);
		aev->PWindow = Window;
		DUMPHEXIL("Just allocated aev=",(LONG)aev,"\\");

		ThisG->NextGadget = &aev->EnvDispGadget;
		
		ClipNW.Flags = STD_FLAGS;
		SetDrMd(RP,JAM2);
		AddGList(Window,FirstG,0,-1,NULL);
		NewBorderBox(RP,0,0,Window->Width-1,Window->Height-1,BOX_CP_BORDER);
		SetFont(RP,DarkFont);
		H = PNL_Y1;

		//NewList(&aev.AEDKeys);
		//DUMPHEXIL("&aev->AEDKeys=",(LONG)&aev->AEDKeys,"\\");

		//Find the popup panel line.
		for( PLine=KeepPL; PLine->Type; PLine++ )
		{
			DUMPHEXIB("",PLine->Type,"\\");
			if(PLine->Type==0x0D)
				EnvAction=PLine;					//Keep the POPUP panelline pointer
			
			if(PLine->Type==PNL_EZTIME)
				EnvTime=PLine;						//Keep the panelline pointer
			
			if(PLine->Type==PNL_EZNUM)
				EnvValue=PLine;					//Keep the panelline pointer

			if(PLine->PLID==PLID_USEAUDENV)
				UseEnvCheck=PLine;

		}

		aev->InPoint=Time_In;
		aev->OutPoint=Time_Out;
		aev->FadeIn=FadeIn;
		aev->FadeOut=FadeOut;
		aev->AETagTable=AETagTable;

		TagtoKL(aev,AETagTable);
/*
		// Build Test list. 		
		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = 4204;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 32400;
			NewAEDNode->Scaled_Val = 32400/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;

		}


		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = 4804;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 35*1307;
			NewAEDNode->Scaled_Val = 35;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = Deleteable;

		}


		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = 6604;
			NewAEDNode->Scaled_Time = (6604<<8)/1583;
			NewAEDNode->Value = 60000;
			NewAEDNode->Scaled_Val = 60000/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = Deleteable;
		}


		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = 7204;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 32000;
			NewAEDNode->Scaled_Val = 32000/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;
		}
		*/

		ScaleEnvelope(aev,485);

		//aev->MinVal=(aev->InPoint*256)/aev->HScale;
		//aev->MaxVal=(aev->OutPoint*256)/aev->HScale;

		//
		NewBorderBox(aev->RP,aev->X-4,aev->Y-4,aev->X+aev->W-1,aev->Y+aev->H-3,BOX_REV);	//box for aud env test.
		RedrawAudioevn(aev);


		//setup string gadgets.

		EnvTime->UserFun = EnvPLGadUserFun;
		EnvTime->UserObj = aev;

		EnvValue->UserFun = EnvPLGadUserFun;
		EnvValue->UserObj = aev;



		DUMPMSG	("AFTER BOARDER BOX");

		PLine = Start;
		X1 = 0;
		Y = 0;
		while (PLine->Type)
		{
			if(PLine->Type != PNL_SKIP)
			{
				PLine->Win = Window;

				if (PPOS_HALF2 & PLine->Align)
					X1 = PNL_WIDTH;

				// Call the gadget's draw function
				if(PLine->Draw) Y1=PLine->Draw(X1,H,PLine,Window);

				if(PLine->Flags & PL_ACTIVATE)
				{
					si = (struct StringInfo *) PLine->StrGadg->SpecialInfo;
					si->BufferPos = strlen(si->Buffer);		// Move cursor past end
					ActivateGadget(PLine->StrGadg,Window,NULL);
				}

				if(PPOS_WIDER & PLine->Align)
				{
					X1 = PNL_WIDTH;
					Y = Y1;
				}
				else
				{
				if (Y>0)
					H += MAX(Y,Y1);		// Don't forget left half
				else
					H += Y1;					// Was no left half
					X1 = 0;
					Y = 0;
				}
			}
			PLine++;
		}

		SoftSpriteOn();

		DUMPMSG	("ENTERING EVENT HANDLER");


		// handle window events
		goto GetEm;
		while (Going)
		{
			WaitPort(Window->UserPort);
			GetEm:
			while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort)) 
			{
				//DUMPHEXIL("IntuiMsg: ",IntuiMsg->Class," \\");
				switch(IntuiMsg->Class) 
				{

				case IDCMP_GADGETDOWN:
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;
					if(ID&EV_GAD)
					{
						//DUMPMSG	("EV_GADDOWN");
						HandleEnvGad(aev,Window,IntuiMsg,
										 EnvAction->PropStart+1,EnvTime,EnvValue); 
						IntuiMsg=NULL;	//HandleEnvGad replys to IntuiMsg.
					}
					else
					if(LastString)
					{
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//Y=FixTimeStr(PLine,Window,FALSE);
								Y=FixTimeStr(PLine,Window,TRUE);
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if(*PLine->Param>PLine->PropEnd) *PLine->Param=PLine->PropEnd;
								if(*PLine->Param<PLine->PropStart) *PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else
								strcpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer);
						}
						LastString=NULL;
					}
					if(!(PLine = (struct PanelLine *)ThisG->UserData)) break;
					if(ID==STRING_ID)	LastString=ThisG;
					if(PLine->Handle) PLine->Handle(PLine,IntuiMsg,Window);
					break;


				case IDCMP_GADGETUP:
//					DUMPMSG	("GADGETUP");

					if (Down)
					{
						Down = NULL;
						ModifyIDCMP(Window,WinFlags);
					}
					ThisG = (struct Gadget *)IntuiMsg->IAddress;
					ID = ThisG->GadgetID;

					if(LastString && LastString!=ThisG)
					{
						if(PLine = (struct PanelLine *)LastString->UserData)
						{
							if( (((struct StringInfo *)(LastString->SpecialInfo))->Extension==&TCExt) )
							{
								//FixTimeStr(PLine,Window,FALSE);
								FixTimeStr(PLine,Window,TRUE);
							}
							else if(LastString->Activation & GACT_LONGINT)
							{
								stcd_l(((struct StringInfo *)LastString->SpecialInfo)->Buffer,(LONG *)PLine->Param);
								if(*PLine->Param>PLine->PropEnd) *PLine->Param=PLine->PropEnd;
								if(*PLine->Param<PLine->PropStart) *PLine->Param=PLine->PropStart;
								UpdatePanStr(PLine,Window);
							}
							else
								strncpy((char *)PLine->Param,((struct StringInfo *)LastString->SpecialInfo)->Buffer,(int)PLine->PropEnd);
						}
						LastString=NULL;
					}

					PLine = (struct PanelLine *)ThisG->UserData;

					if(PLine && PLine->Handle)
					{
						DUMPHEXIL("PLine->Handle ",(ULONG)PLine->Handle,"\\");
						PLine->Handle(PLine,IntuiMsg,Window);

						DoGenButtons(PLine,Window,&Success,&Going);

						if (PLine->Flags & PL_GENBUTT)
						{
							switch ((ULONG)PLine->Param)
							{
							case GB_REORG:		// Reorg drive
								Going = FALSE;				// Exit panel
								Success = PAN_EASY;		// Re-open panel again
								break;
							}
						}

					}
					break;

				case IDCMP_MOUSEMOVE:
//						DUMPSTR("&");
										
						//KeyMoveY=IntuiMsg->MouseY-aev->Y;
						//if (KeyMoveY>49) KeyMoveY=49;
						//if (KeyMoveY<1) KeyMoveY=1;
						//TestKey->Scaled_Val=KeyMoveY;

						//DUMPHEXIW("KeyMoveY: ",KeyMoveY," ");
						//DUMPHEXIW("Mouse X: ",IntuiMsg->MouseX," ");
						//DUMPHEXIW("Mouse Y: ",IntuiMsg->MouseY,"\\");


				case IDCMP_MOUSEBUTTONS:
					if(Down)
					{
                  PLine = (struct PanelLine *)Down->UserData;
						if(PLine && PLine->Handle)
							PLine->Handle(PLine,IntuiMsg,Window);
					}
               else
						// handle right button here.
						// need to determine if mouse moves are needed.
						if(IntuiMsg->Code==MENUDOWN)		//also watch for MENUUP!
						{
							//See if it's one of those envlope gadgets
							Mx = IntuiMsg->MouseX; 
							My = IntuiMsg->MouseY;
							if ((Mx>aev->X)&(Mx<(aev->X+aev->W))&
								(My>aev->Y)&(My<(aev->Y+aev->H)))
							{
								DUMPSTR("got press in env gad.");
								HandleEnvGad(aev,Window,IntuiMsg,1,EnvTime,EnvValue);
								IntuiMsg=NULL;  //HandleEnvGad replys to IntuiMsg.

							}
						};

					DUMPSTR("*");
					break;

				case IDCMP_INTUITICKS:
					if( !EZGad || !(EZGad->Flags&GFLG_SELECTED) )
					{
						ModifyIDCMP(Window,WinFlags);
						EZGad=NULL;
						break;
					}

					// Handle ticks to EZ gadgets
					TickEZLenPL((struct PanelLine *)EZGad->UserData,Window,EZJump(Ticks++));
					break;

				case IDCMP_RAWKEY:
					A = IntuiMsg->Code;
					if(A<0x80)
					{
						B = IntuiMsg->Qualifier;
						DUMPHEXIB("Key Code: ",A,"\\");
						switch(A)
						{
							case	RAW_IN:
								if(In)	ActivateGadget(In,Window,NULL);
								break;
							case	RAW_OUT:
								if(Out)	ActivateGadget(Out,Window,NULL);
								break;
							case	RAW_LEN:
								if(Len)	ActivateGadget(Len,Window,NULL);
								break;
							case	RAW_DEL:
								if(Del)	ActivateGadget(Del,Window,NULL);
								break;
							case	RAWKEY_PAD_ENTER:
							case	RAWKEY_RETURN:
								Going = FALSE;
								Success=TRUE;
								break;
							case	RAWKEY_HELP:
								break;
							case	RAWKEY_ESC:
								Going = FALSE;
								break;
						}
					}
					break;
				}
				if(IntuiMsg) 	
					ReplyMsg((struct Message *)IntuiMsg);
			}
		}
		// end of event loop

		CloseWindow(Window);
		WaitBlit();

		// update modified parameters
		PLine = Start;
		while (PLine->Type)
		{
			switch(PLine->Type) {
			case PNL_IN_TYPE:
			case PNL_OUT_TYPE:
				if (PLine->G1->Flags & GFLG_SELECTED) *(PLine->Param) = 1;
				else *(PLine->Param) = 0;
				break;
			}
			PLine++;
		}
	}
	DUMPMSG	("After OW cond.");


	for( PLine=Start; PLine->Type; PLine++ )
	{
		if(PLine && PLine->Destroy && (PLine->Type!=PNL_SKIP) )
			PLine->Destroy(PLine);
	}

	// Free the double buffer bitmap
	FreeBitMap(DMRP.BitMap);


	if(Success==PAN_CONTINUE)
	{
		KLtoTag(aev,AETagTable);
		if(*UseEnvCheck->Param)
			AETagTable->Flags=1;		//Use tagtable
	}

	//free display list.
	AEDHead=&aev->AEDKeys;

	while(AEDNode=RemHead(AEDHead)) 
	{ 
		DUMPHEXIL("Freeing AEDNode: ",(LONG)AEDNode,"\\");
		FreeMem(AEDNode,sizeof(struct AEDKey));	
	}

	// Free the Envelope structures
	FreeMem(aev,sizeof(struct AudEnvDisp));

	return(Success);
}



/**********************************/
/*** Quick-Tune panel & support ***/
/**********************************/

static void TimeHilite(struct RastPort *rp, int which, BOOL state);

#define	QWINH		16						/* Quick window height */
#define	QXBASE	0
#define	QAPART	145
#define	TCLEN		88
#define	QLBL		35
#define	QZwidth	(TCLEN+16)


struct ExtNewWindow quick_nw = {
	32 + GRID_LEFT,28,	/* window XY origin relative to TopLeft of screen */
	640,QWINH,				/* window width and height */
	1,0,						/* detail and block pens */

	/* IDCMP flags */
	IDCMP_RAWKEY | IDCMP_REFRESHWINDOW | IDCMP_MOUSEBUTTONS | IDCMP_GADGETDOWN | IDCMP_GADGETUP,
	/* other window flags */
	/* WFLG_BACKDROP | */
	WFLG_SIMPLE_REFRESH | WFLG_BORDERLESS | WFLG_RMBTRAP | WFLG_NW_EXTENDED,

	NULL,	/* first gadget in gadget list */
	NULL,	/* custom CHECKMARK imagery */
	NULL,	/* window title */
	NULL,	/* custom screen pointer */
	NULL,	/* custom bitmap */
	5,5,	/* minimum width and height */
	656,400,	/* maximum width and height */
	CUSTOMSCREEN,	/* destination screen type */
	&nw_ti[0]
};


UWORD QuickPanel(
	struct EditWindow *Edit,
	struct PanelLine *Panel,
	struct FastGadget *FG,
	LONG smpte)
{
	struct Window *win;
	struct RastPort *rp;
	struct PanelLine *pl,*PLs[4];
	struct EditWindow *edwin;
	BOOL Going=TRUE,IDchange,audpts=FALSE;
	WORD	newID,curID,lastID=0;
	UWORD	success=0;
	char	*labels[] = {"  In","Out","  In","Out"};
	int	i;
	ULONG	waitsigs,topsig,botsig,signals;
	LONG	adder;
	UBYTE	itemcount=0;

	struct IntuiMessage *IntuiMsg;
	ULONG	IMclass;
	UWORD	IMcode,IMqual;

	quick_nw.Screen = EditScreen;

	if (win = OpenWindow((struct NewWindow *)&quick_nw))
	{
		rp = win->RPort;

		SetDrMd(rp,JAM2);
		SetFont(rp,TCFont);
		rp->Mask = 0x07;

		SetRast(rp,1);			// Clear entire window

		PLs[0] = PLs[1] = PLs[2] = PLs[3] = NULL;

		for(pl=Panel; pl->Type; pl++)
		{
			if(pl->Type != PNL_SKIP)
			{
				itemcount++;

				pl->Win = win;

				if (PL_IN & pl->Flags)
				{
					if (PL_AUDIO & pl->Flags)
						PLs[2] = pl;
					else
						PLs[0] = pl;
				}
				else if (PL_OUT & pl->Flags)
				{
					if (PL_AUDIO & pl->Flags)
						PLs[3] = pl;
					else
						PLs[1] = pl;
				}
			}
		}

		curID = -1;					// None highlighted yet

		SetFont(rp,TCDarkFont);

		for (i=0; i<4; i++)
		{
			if (PLs[i])
				DispQuickTime(win,i,*(PLs[i]->Param),labels[i],FALSE);
		}

		// Setup RCB structure to just show time in quick window
		MyRCB->RenderFn = &QuickRenderFunc;						// Use my special renderer
		MyRCB->FG = FG;
		MyRCB->win = win;
		MyRCB->Flags = 0;

		topsig = botsig = 0;
		if (EditTop && EditTop->Window)
			topsig = (1<<EditTop->Window->UserPort->mp_SigBit);
		if (EditBottom && EditBottom->Window)
			botsig = (1<<EditBottom->Window->UserPort->mp_SigBit);

		waitsigs = topsig | botsig;

		// handle window events
		goto GetEm;
		while (Going)
		{
			DUMPMSG	("Wait...");
			signals = Wait(waitsigs);
GetEm:
			for (i=0; i<=1; i++)
			{
				if (i==0)
				{
					if (signals & topsig)
						edwin = EditTop;
					else
						continue;
				}
				else
				{
					if (signals & botsig)
						edwin = EditBottom;
					else
						continue;
				}

				// Steal messages meant for top/bottom windows
				while (IntuiMsg = (struct IntuiMessage *)GetMsg(edwin->Window->UserPort))
				{
					DUMPMSG	("(msg)");
					IMclass = IntuiMsg->Class;
					IMcode  = IntuiMsg->Code;
					IMqual  = IntuiMsg->Qualifier;
					ReplyMsg((struct Message *)IntuiMsg);		// Best to reply quickly

					IDchange = FALSE;
					adder = 0;

					switch(IMclass)
					{
					case IDCMP_GADGETUP:
						DUMPMSG	("GADGETUP");
						newID = -1;							// Change to "none"
						IDchange = TRUE;
						break;
					case IDCMP_GADGETDOWN:
						DUMPMSG	("GADGETDOWN");
						newID = 0;							// Must be left button over some gadget
						IDchange = TRUE;
						break;
					case IDCMP_MOUSEBUTTONS:
						DUMPMSG	("MOUSEBUTTON");

						if (IMcode==SELECTDOWN)
							newID = 0;						// Select "in" point
						else if (IMcode==MENUDOWN)
							newID = 1;						// Select "out" point
						else
							newID = -1;						// "none"

						IDchange = TRUE;
						break;
					case IDCMP_RAWKEY:
						DUMPHEXIB("Key Code: ",IMcode,"\\");
						switch (IMcode)
						{
							case RAW_KEYUP+RAWKEY_CTRL:		// Ctrl up
								Going = FALSE;
								success = PAN_CONTINUE;
								break;
							case RAWKEY_LEFT:
								adder = -4;
								newID = lastID;
								IDchange = TRUE;
								break;
							case RAWKEY_RIGHT:
								adder = 4;
								newID = lastID;
								IDchange = TRUE;
								break;
							case RAWKEY_SPACE:
								audpts = !audpts;		// Change to/from audio in/out points
								break;

//							case RAWKEY_ESC:
//								Going = FALSE;
//								success = PAN_CANCEL;
//								break;
						}
						break;
					}


					if (IDchange)
					{
						if (newID>=0)
						{
							// Wants audio in/out points?
//							if (IMqual & (IEQUALIFIER_LSHIFT|IEQUALIFIER_RSHIFT))
							if (audpts)
								newID |= 2;

							if (PLs[newID] == NULL)
								newID ^= 2;					// Use other pair if this pair is disabled

							lastID = newID;				// Remember this for arrow keys
						}

						if (newID != curID)				// Changing current point?
						{
							// Remove highlight, if any
							if (curID != -1)
							{
								TimeHilite(rp,curID,FALSE);
								DispQuickTime(win,curID,*(PLs[curID]->Param),labels[curID],FALSE);
							}

							// Add new highlight, if any
							if (newID != -1)
							{
								TimeHilite(rp,newID,TRUE);
								DispQuickTime(win,newID,*(PLs[newID]->Param),labels[newID],TRUE);
							}
							curID = newID;
						}

						// Begin jogging if button pressed...
						if (curID != -1)
						{
							MyRCB->pline = pl = PLs[curID];

							if ((itemcount == 4) && (IMqual & IEQUALIFIER_LALT))
								pl->Flags |= PL_PARTNER;
							else
								pl->Flags &= ~((ULONG)PL_PARTNER);

							if (IMqual & IEQUALIFIER_LSHIFT)
							{
								pl->Flags |= PL_SHADOW;

								// Always make positive shadow values!
								if (curID & 1)		// For out point, shadow = this - other
								{
									pl->ShadowOffset = *pl->Param
									- *((struct PanelLine *)(pl->Param2))->Param;
								}
								else					// For in point, shadow = other - this
								{
									pl->ShadowOffset = *((struct PanelLine *)(pl->Param2))->Param
									- *pl->Param;		// Difference
								}

								DUMPSDECL("Shadow=",(LONG)pl->ShadowOffset,"\\");
							}
							else
								pl->Flags &= ~((ULONG)PL_SHADOW);

							MyRCB->Frame = Frms2Flds((ULONG)(*pl->Param - smpte));
							if (curID & 1)										// Out points
							{
								if (pl->Flags & PL_SHADOW)
								{
									MyRCB->Min = PLs[curID-1]->PropStart+pl->ShadowOffset;	// Min w/shadow
									DUMPSDECL("Min=",(LONG)MyRCB->Min,"\\");
								}
								else
									MyRCB->Min = *PLs[curID-1]->Param;		// Min= in point
								MyRCB->Max = pl->PropEnd;						// Max= clip max
							}
							else
							{
								MyRCB->Min = pl->PropStart;		// Min= clip min
								if (pl->Flags & PL_SHADOW)
								{
									MyRCB->Max = PLs[curID+1]->PropEnd-pl->ShadowOffset;		// Max w/shadow
									DUMPSDECL("Max=",(LONG)MyRCB->Max,"\\");
								}
								else
									MyRCB->Max = *PLs[curID+1]->Param;		// Max= out point
							}
							MyRCB->Min = Frms2Flds(MyRCB->Min - smpte);
							MyRCB->Max = Frms2Flds(MyRCB->Max - smpte);

							if (adder)
							{
								MyRCB->Frame += adder;
								DUMPUDECL("Frm ",(LONG)MyRCB->Frame," ");
								DUMPUDECL("Min ",(LONG)MyRCB->Min," ");
								DUMPUDECL("Max ",(LONG)MyRCB->Max,"\\");
								if((MyRCB->Frame <= MyRCB->Max)
								&& (MyRCB->Frame >= MyRCB->Min))
								{
									DHD_Jump(MyRCB,FALSE);			// Jump, stay noisy
//									MyRCB->Frame = Frms2Flds((ULONG)(*(PLs[curID]->Param) - smpte));
								}
							}
							else
							{
								DUMPMSG("Beginning test jog...");
								DHD_Jog(MyRCB);
								DUMPMSG("Done, let's leave");
							}
						}

						DUMPHEXIW("Qualifiers=",(LONG)IMqual,"\\");
						if (!(IMqual & IEQUALIFIER_CONTROL))
						{
							Going = FALSE;
							success = PAN_CONTINUE;
							DUMPMSG("Must have missed!!!");
						}
					}
				}
			}
		}

		MyRCB->RenderFn = &RenderFunc;			// Restore normal RCB renderer

		CloseWindow(win);
//		WaitBlit();
	}

	return(success);
}

void DispQuickTime(struct Window *win, int which, ULONG acctime, char *label, BOOL state)
{
	LONG					x,xend;
	static char	time[12]="00:00:00:00";

	DUMPUDECL("DAT ",(LONG)acctime," )\\");

	x = QXBASE + (which * QAPART) + 10;
	xend = x + QLBL + TCLEN;

	LongToTime((ULONG *)&acctime,time);	// Was provided to me in frames

	DUMPMSG(time);

	if (time)
	{
		if (win)
		{
			struct RastPort		*rp = win->RPort;

			SetAPen(rp,PAL_DGRAY);

			if (label)
			{
				SetFont(rp,DarkFont);
				Move(rp,x,rp->Font->tf_Baseline + 4 );
				SafeColorText(rp,label,strlen(label));
			}

			if (state)
				SetFont(rp,TCFont);
			else
				SetFont(rp,TCDarkFont);

			Move(rp,x+QLBL,rp->Font->tf_Baseline + 4 );
			SafeColorText(rp,time,11);

//			if (rp->cp_x <= xend)			// Clear out rest of ProgTime field
//			{
//				if (state)
//					SetAPen(rp,PAL_DYELLOW);
//				else
//					SetAPen(rp,PAL_DGRAY);
//				RectFill(rp,rp->cp_x,3,xend,13 /* QWINH */);
//			}
		}
	}
}

static void TimeHilite(struct RastPort *rp, int which, BOOL state)
{
	WORD	left,top,w,h;

	left = QXBASE+QLBL+3+which*QAPART;
	top = 0;
	w = QZwidth;
	h = QWINH;

	if (state)
		NewBorderBox(rp,left,top,left+w,top+h,BOX_REV_BORDER);
	else
	{
		SetAPen(rp,PAL_DGRAY);
		RectFill(rp,left,top,left+w,top+h);
	}
}


