/* $PanFunctions.c$  Flyer controls and other control panel real-time interactions
* $Id: panfunctions.c,v 2.32 1996/11/18 18:41:37 Holt Exp $
* $Log: panfunctions.c,v $
*Revision 2.32  1996/11/18  18:41:37  Holt
*added more envelope support code.
*
*Revision 2.31  1996/07/19  14:52:58  Holt
*finished up cfx and changed selectors so they don't change video
*source when audio only recording is enabled.
*
*Revision 2.30  1996/06/25  17:07:40  Holt
*made some changes to impament audio envelopes
*
*Revision 2.29  1996/01/15  15:12:15  Holt
*fixed audio pantel and tag problems
*
*Revision 2.28  1995/10/24  17:26:37  Flick
*DHD_InitRecord's ES_SELECTDEFAULT was killing keys before recording (not good)
*
*Revision 2.27  1995/10/19  02:12:17  Flick
*Fixed volume error when changing channels popup to stereo (now calls SetDiff...()
*Fixed volume error when balance is to left, changing volume would disturb balance setting
*
*Revision 2.26  1995/10/17  09:47:51  Flick
*Fixed CTRL_SetBalance on left-only audio
*
*Revision 2.25  1995/10/09  16:39:41  Flick
*Removed unnecessary usage of popup.h
*
*Revision 2.24  1995/10/06  18:38:28  Flick
*Fixed ARexx RecordClip() function to just start recording and return (properly)
*
*Revision 2.23  1995/10/05  18:44:27  Flick
*Moved DHD_Record function into Flyer.c & overhauled to not use ES
*Slight rename of other Flyer functions, grabbing global audio volumes
*
*Revision 2.22  1995/10/02  15:36:20  Flick
*Fixed bug with saving tags when locking all 4 knobs A/V in/out together.  Worked okay if
*dragging one of the video knobs, but if dragging an audio knob, wouldn't save video points
*Formalized handling of FlyerDrive names
*
*Revision 2.21  1995/09/28  10:56:35  Flick
*Fixed enforcer hit on ganged quick tune adj, makes SetRCBtags more robust
*
*Revision 2.20  1995/09/25  13:04:25  Flick
*Code cosmetics only
*
*Revision 2.19  1995/09/19  12:24:26  Flick
*Added names of new tags to debugging table
*Changes references to TweakPL et.al. to EasyPanelPL's
*
*Revision 2.18  1995/09/13  13:02:05  Flick
*CTRL_SetVol and _SetBal now work "live" while clip is playing from panel
*DHD_Jump now has "quiet" option, fixed A->V partner tags bug
*
*Revision 2.17  1995/08/18  17:05:39  Flick
*Added maintenance for project running time after jog/shuttling in panels
*New DHD_JustJump.  Delay hack to prevent STOP/BEGINFINDFIELD from happening fast.
*
*Revision 2.16  1995/08/16  10:54:55  Flick
*Added support for SHADOW function
*
*Revision 2.15  1995/08/09  17:59:37  Flick
*Added HQ5 button handler + PL_SHADOW hack for quick tune panel
*
*Revision 2.14  1995/07/14  16:02:58  Flick
*Fixed crash in SortFlyerDrives if just audio drive(s) present
*
*Revision 2.13  1995/04/28  13:33:21  Flick
*Fixed enforcer hit in SortFlyerDrives when no Flyer drives mounted
*
*Revision 2.12  1995/04/27  14:29:22  Flick
*Added string for new tag "HoldFields"
*
*Revision 2.11  1995/04/20  11:31:54  Flick
*Improved Blocks2Frames to handle big drives
*Improved conversion times for Fast modes
*
*Revision 2.10  1995/03/17  11:51:34  CACHELIN4000
*Add delay() in RecordAppend
*
*Revision 2.9  1995/03/16  16:20:28  CACHELIN4000
*Add RecordAppend function...
*
*Revision 2.8  1995/03/09  18:05:01  CACHELIN4000
**** empty log message ***
*
*Revision 2.7  1995/03/07  16:11:23  CACHELIN4000
*New FASTDRIVE compression mode support, compression mode indirection
*
*Revision 2.6  1995/03/03  11:43:24  CACHELIN4000
*Fix up audio-only compression/source selection interactions
*
*Revision 2.5  1995/02/28  19:19:26  CACHELIN4000
*SetPrefs on panel continue, set recsource to 0 if in AUDIOONLY mode in DHD_Record()
*
*Revision 2.4  1995/02/27  13:43:12  CACHELIN4000
*add Clipping vars to setrecgain
*
*Revision 2.3  1995/02/27  09:33:37  CACHELIN4000
**** empty log message ***
*
*Revision 2.2  1995/02/24  11:12:06  CACHELIN4000
*Add CTRL_Tag function, fix other stuff i think
*
*Revision 2.1  1995/02/22  10:13:15  CACHELIN4000
**** empty log message ***
*
*Revision 2.0  1995/02/19  16:41:32  CACHELIN4000
*FirstCheckIn
*
*
* Copyright (c)1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/sghooks.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <editwindow.h>
#include <project.h>
#include <gadgets.h>
#include <prophelp.h>
#include <grazer.h>
#include <editswit.h>
#include <crouton_all.h>
#include <request.h>
#include <tags.h>
#include <panel.h>
#include <flyer.h>
#include <flyerlib.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>

#ifndef PROTO_PASS
#include <proto.h>
#else
#include <pandata.p>
#endif

#define SERDEBUG	1
#include <serialdebug.h>

#define CFAR __far
#define CSTATIC

/*** Prototypes ***/
static void SetDiffStereoVol(struct AudioSet *aud, UWORD scale);

extern struct PanelLine *CurPLine,*Start,*LastTime,*temp;
extern struct Gadget *FirstG,*Down,*EZGad,*In,*Out,*Del,*Len;
extern LONG	InOrOut,ft,Adder,FlyerDriveCount;
extern ULONG	Ticks,WinFlags,GadInd;
extern struct FastGadget *CurFG,*SKellFG;
extern char TempCh[],TempC2[],*DTNames[];
extern UBYTE *TempMem;
extern ULONG CRuDTypes[];
extern struct MsgPort *SwitPort;
extern struct EditWindow *EditTop,*EditBottom;
extern struct Library *FlyerBase;
extern struct ESParams1 ESparams1;
extern struct ESParams2 ESparams2;
extern struct ESParams3 ESparams3;
extern struct ESParams4 ESparams4;
extern struct ESParams5 ESparams5;
extern struct	AudioSet	CurAudioSet;
extern struct FlyAudCtrl AudCtrl;
extern struct FastGadget *PlayFG;
extern ULONG CurFlyDrive,CurFlySource,CurFlyTracks,CurCompMode;
extern CFAR struct Hack	*Hacks[],*BakHacks[],*Hack;
extern struct SystemPrefs Config;
extern struct TBCctrl		TBC_dat,TBC_bak;
extern UBYTE	*FlyerDrives[],SrcInd[],TBC_KeyMode[],TBC_Input[],QualMode[];
extern struct PanelLine *EasyPanelPL;
extern UBYTE global_LeftGain,global_RightGain;

#define SWITCHER_MODE	( (!EditBottom) && (!EditTop || (EditTop->Height!=TOP_LARGE)) )
#define EDITOR_MODE		(!SWITCHER_MODE)

UBYTE LClipping=0,RClipping=0;
static char *FaceMess[]={"Removing interface from Preview Monitor,",
		"Press HELP to restore."};

CFAR struct TagHelp TagNames[] = {
	{	"!!NULL TAG!!",0},
	{	"Version",0},
	{	"Revision",0},
	{	"AAeffect",0},
	{	"NonAAeffect",0},
	{	"KillInterfaceNonAA",0},
	{	"KillInterfaceAA",0},
	{	"ButtonELHlogic",0},
	{	"CustomButtonELHlogic",1}, // Table
	{	"NumberOfAnims",0},
	{	"RequestFileName",0},
	{	"AnimFiles",1},  // Table
	{	"Frames",0},
	{	"FieldSync",0},
	{	"VariableSpeeds",0},
	{	"ForcePlayForward",0},
	{	"ForcePlayReverse",0},
	{	"LoopAnims",0},
	{	"AnimControl",1},  // Table
	{	"AudioFastSamples",0},
	{	"AudioMediumSamples",0},
	{	"AudioSlowSamples",0},
	{	"AudioFiles",1}, // Table
	{	"AudioControl",1},  // Table
	{	"PauseTimes",1},  // Table
	{	"LatchColors",1},  // Table
	{	"TransparentColors",1},  // Table
	{	"PaletteColors",1},  // Table
	{	"Equations",1}, // Table
	{	"Encoder",0},
	{	"VerticalScroll",0},
	{	"ReverseTime",0},
	{	"ReverseButtLog",0},
	{	"ReverseCustomButtLog",1}, // Table
	{	"KeyMode",0},
	{	"MatteColor",0},
	{	"CustomMatteColor",0},
	{	"BorderColor",0},
	{	"CustomBorderColor",0},
	{	"LineNumbers",1},     // Table
	{	"LineNumberPlane",0},
	{	"ForceFreeze4",0},
	{	"ForceFreeze8",0},
	{	"ForceLive",0},
	{	"ForceLumKeyOn",0},
	{	"ForceLumKeyOff",0},
	{	"ForceLumKeyOnBlack",0},
	{	"ForceLumKeyOnWhite",0},
	{	"BadDefaultFX",0},
	{	"LoadPictures",1}, // Table
	{	"FadeInDuration",0},
	{	"FadeOutDuration",0},
	{	"DigitalFX",0},
	{	"TimeMode",0},
	{	"LUT",0},
	{	"DigitalPairs",0},
	{	"LatchAM",0},
	{	"LatchBM",0},
	{	"LatchIS",0},
	{	"HonorPreviewOverLay",0},
	{	"ForceDefaultMatte",0},
	{	"TurnAudioFilterOff",0},
	{	"AudioStartField",0},
	{	"NumAudioFields",0},
	{	"ISandClipPause",0},
	{	"Interlaced",0},
	{	"FirstFieldNTSCII",0},
	{	"BounceILBM",0},
	{	"LatchRanges",1}, // Table
	{	"LatchList",1}, // Table
	{	"TransparentRanges",1},  // Table
	{	"TransparentList",1}, // Table
	{	"Color0Transparent",0},
	{	"AbortIfSlow",0},
	{	"NumSkipFieldsAtEnd",0},
	{	"TBarDoesAuto",0},
	{	"DoNotStompSprite",0},
	{	"AbortLoopAtEnd",0},
	{	"NonAAremap",0},
	{	"100PercentWhiteMatte",0},
	{	"UseEffectColor",0},
	{	"LoopCount",0},
	{	"CroutonType",0},
	{	"TimeLine",0},
	{	"IndexID",0},
	{	"FCountMode",0},
	{	"VariableFCount",0},
	{	"SlowFCount",0},
	{	"MedFCount",0},
	{	"FastFCount",0},
	{	"VariableFCount68000",0},
	{	"SlowFCount68000",0},
	{	"MedFCount68000",0},
	{	"FastFCount68000",0},
	{	"NumFields",0},
	{	"StartTime",0},
	{	"DescriptorList",1}, // Table
	{	"AboutList",1},  // Table
	{	"CommentList",1},  // Table
	{	"AlgoFXtype",0},
	{	"AlgoFXborder",0},
	{	"NumFramesSlow",0},
	{	"NumFramesMedium",0},
	{	"NumFramesFast",0},
	{	"NumFramesVariable",0},
	{	"Page",1}, // Table
	{	"Speed",0},
	{	"Delay",0},
	{	"Duration",0},
	{	"AudioAttack",0},
	{	"AudioDecay",0},
	{	"RecFields",0},
	{	"AudioOn",0},
	{	"AudioStart",0},
	{	"AudioDuration",0},
	{	"ClipStartField",0},
	{	"FadeInVideo",0},
	{	"MaxDuration",0},
	{	"VideoSource",0},
	{	"LoadedSlices",0},
	{	"OriginalLocation",1}, // Table
	{	"AudioVolume1",0},
	{	"AudioVolume2",0},
	{	"AudioPan1",0},
	{	"AudioPan2",0},
	{	"PanelMode",0},
	{	"ColorMode",0},
	{	"CycleMode",0},
	{	"DataMode",0},
	{	"AdjustedVideoStart",0},
	{	"AdjustedVideoDuration",0},
	{	"Asynchronous",0},
	{	"CommandLine",1},  // Table
	{	"SMPTEtime",1},  // Table
	{	"TBarPosition",0},
	{	"HoldFields",0},
	{	"TakeOffset",0},
	{	"ASourceLen",0},
	{	"BSourceLen",0},
	{	"AudioFadeFlags",0},
	{	"AudEnv16",0},
	{	"AudEnv32",0},
	{	"AudEnv64",0},
	{	"AudEnv128",0},
	{"",0}   // IMPORTANT to null terminate!
};

// Convert free 512 byte (.5k)  blocks in FlyerVolInfo
ULONG BlocksToFrames(ULONG blox, ULONG mode)
{ // 3M/s worst case = 3*1024*2blocks/sec ==> N blocks =N/6144sec.s =30*N/6144 frames

	switch(mode)
	{
		// Marty simplified fractions as much as possible to prevent LONG overflow
		// on really big drives.  To be ready for 18 Gig drives, we should never
		// multiply by a factor > 60

		case STD_COMP_MODE:
//			return((30*blox)/6144);
			return((5*blox)/1024);		// 3.1 MB/sec
			break;
		case FASTSTD_COMP_MODE:
//			return((7*30*blox)/(10*6144));	// COMP_MODE * 7/10
			return((7*blox)/(2048));			// 4.49 MB/sec
			break;
		case AUDIO_COMP_MODE:
		// 44.1khz*2byte samples*2stereo channels*(1000/1024)=172.266kb/s=344.53blox/s
		// 344.53 blox/sec==> t(secs)=blox/344.53==> frames=30*blox/344.53
//			return((30*blox)/345);
			return((2*blox)/23);					// 172 KB/sec
			break;
		case FASTEXTD_COMP_MODE:
//			return((7*42*blox)/(10*6144)); // 7/10 for fast 42 is arbitrary num from 30/.707
//			return((5*blox)/1024);			// 3.1 MB/sec (not exactly 7/10, but close)
		//NEW HQ-6 MODE.	
			return((6*blox)/(2048));			// 6.1 MB/sec (not exactly 7/10, but close)
			break;
		case EXTD_COMP_MODE:
		default:
//			return((42*blox)/6144);		// 42 is arbitrary num from 30/.707
			return((7*blox)/1024);		// 2.2 MB/sec
			break;
	}
}

//|~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~|//
// The following 'CTRL_' functions are called as PanelLine.UserFun functions
// within the PanelLine's Handle() function.

// TBC Control function
ULONG __asm CTRL_TBCSet(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	int type=(int)Obj;
	ULONG flags;

	if(!pl->PropGadg)
		flags=(ULONG)pl->Param;
	switch(type)
	{
		case TBC_CPHZ:
			TBC_dat.Phase =*(pl->Param);
			DUMPSDECL("Phase: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_HPHZ:
			TBC_dat.HorAdj =*(pl->Param);
			DUMPSDECL("Horiz: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_BRT:
			TBC_dat.Bright = (BYTE) *(pl->Param);
			DUMPSDECL("Bright: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_HUE:
			TBC_dat.Hue = (BYTE) *(pl->Param);
			DUMPSDECL("Hue: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_CON:
			TBC_dat.Contrast = (UBYTE) *(pl->Param);
			DUMPSDECL("Cont: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_SAT:
			TBC_dat.Sat = (UBYTE)*(pl->Param);
			DUMPSDECL("Sat: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_FAD:
			TBC_dat.Fader = (BYTE) *(pl->Param);
			DUMPSDECL("Fade: ",(LONG)*pl->Param,"\\");
			break;
		case TBC_INP:
			TBC_dat.InputSel = TBC_Input[pl->PropStart];
			break;
		case TBC_KEYM:
			TBC_dat.KeyerFlags &=~(TBCKF_MODE0|TBCKF_MODE1);
			TBC_dat.KeyerFlags |= TBC_KeyMode[pl->PropStart];
			break;

		case TBC_KEY:
//			TBC_dat.KeyerFlags=0;
			if(flags&1)
				TBC_dat.KeyerFlags |=TBCKF_FADEROUT;
			else
				TBC_dat.KeyerFlags &=~TBCKF_FADEROUT;
			if(flags&1<<1)
				TBC_dat.KeyerFlags |=TBCKF_KEYONB;
			else
				TBC_dat.KeyerFlags &=~TBCKF_KEYONB;
			break;
		case TBC_ENC:
			TBC_dat.Flags=0;
			if(flags&1)
				TBC_dat.Flags |= TBCGF_BYPASS;
			if(flags&1<<3)
				TBC_dat.Flags |= TBCGF_FREEZE;
			TBC_dat.EncFlags=0;
			if(flags&1<<1)
				TBC_dat.EncFlags |=TBCEF_BARS;
			if(flags&1<<2)
				TBC_dat.EncFlags |=TBCEF_KILLCOLOR;
			break;
		case TBC_DEC:
			TBC_dat.DecFlags=0;
			if(flags&1<<1)
				TBC_dat.DecFlags |=TBCDF_AGC;
			if(flags&1<<2)
				TBC_dat.DecFlags |=TBCDF_CHROMAAGC;
			if(flags&1)
				TBC_dat.DecFlags |=TBCDF_MONOCHROME;
			break;
		case TBC_TRM:
			TBC_dat.Term=0;
			if(flags&1<<4)
				TBC_dat.Term |= TBCTF_FADERB;
			if(flags&1<<3)
				TBC_dat.Term |= TBCTF_FADERA;
			if(flags&1<<2)
				TBC_dat.Term |= TBCTF_OUT;
			if(flags&1<<1)
				TBC_dat.Term |= TBCTF_GENIN;
			if(flags&1)
				TBC_dat.Term |= TBCTF_COMPIN;
			break;
		default:
			return(0);
	}
	ESparams2.Data1 =(LONG) HACK_TBCW;
	ESparams2.Data2 =(LONG) &TBC_dat;
	SendSwitcherReply(ES_Hack,&ESparams2);
	return(0);
}

// Hack rectest popup f'n
ULONG __asm CTRL_RecTest(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) struct Hack *hak)
{

	if(Hack!=Hacks[pl->PropStart])
	{
		Hack=Hacks[pl->PropStart];
		EasyPanelPL[3].Param = &(Hack->hk_Position);		// These were TweakPL's
		EasyPanelPL[3].UserObj=(APTR)Hack;
		UpdatePanStr(&(EasyPanelPL[3]),pl->Win);

		EasyPanelPL[4].Param = &(Hack->hk_Clock);
		EasyPanelPL[4].UserObj=(APTR)Hack;
		UpdatePanStr(&(EasyPanelPL[4]),pl->Win);

		EasyPanelPL[5].Param = &(Hack->hk_Coarse);
		EasyPanelPL[5].UserObj=(APTR)Hack;
		UpdatePanStr(&(EasyPanelPL[5]),pl->Win);

		EasyPanelPL[6].Param = &(Hack->hk_Fine);
		EasyPanelPL[6].UserObj=(APTR)Hack;
		UpdatePanStr(&(EasyPanelPL[6]),pl->Win);

//		EasyPanelPL[7].Param = &(Hack->hk_Pedestal);
//		EasyPanelPL[7].UserObj=(APTR)Hack;
//		UpdatePanStr(&(EasyPanelPL[7]),pl->Win);

//		EasyPanelPL[8].Param=(long *)Hack->hk_Shift;
//		EasyPanelPL[8].UserObj=(APTR)Hack;
	}

	ESparams2.Data1 =(LONG) HACK_TWEAK;
	ESparams2.Data2 =(LONG) Hack;  // Hack ptr
	SendSwitcherReply(ES_Hack,&ESparams2);
	return(0);
}

ULONG	__asm CTRL_Hack(
	REG(a0) struct PanelLine *pl, 
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) struct Hack *hack)
{
	ULONG Flags=hack->hk_Flags;
	DUMPMSG("CTRL_Hack()");
	hack->hk_Flags &= ~HKF_TESTREC;
	ESparams2.Data1 =(LONG) HACK_TWEAK;
	ESparams2.Data2 =(LONG) hack;  // Hack ptr
	SendSwitcherReply(ES_Hack,&ESparams2);

	hack->hk_Flags = Flags;
	return(0);
}

// Set any TAG, Obj=TagMess
ULONG __asm CTRL_SetTag(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct TagMess *tm=Obj;
	if(tm->tm_vSize<=4)
		return((ULONG)PutValue(tm->tm_FG,tm->tm_Tag,*tm->tm_Val));
	else
		return((ULONG)PutTable(tm->tm_FG,tm->tm_Tag,(UBYTE *)tm->tm_Val,(tm->tm_vSize)&~1 ));
}

// Source popup f'n  object is Drive PLine for available time update
ULONG __asm CTRL_SetSource(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct FlyerVolInfo *FVI=NULL;
	LONG	T;

	CurFlySource=pl->PropStart;

	ESparams1.Data1 = SrcInd[CurFlySource];
//	if(CurCompMode==AUDIO_COMP_MODE)				//test removing these for seeing 
//		ESparams1.Data1 = 0;							//video while recording aud.

	DUMPUDECL("SetSource( ",ESparams1.Data1,",");
	SendSwitcherReply(ES_RecordSource,&ESparams1);
	if(Obj)
	{
		if(FlyerDriveCount && (FVI=GetFlyerInfo(FlyerDrives[CurFlyDrive])))
		{
			T=BlocksToFrames(FVI->Largest,CurCompMode);
			((struct PanelLine *)Obj)->G4 = (struct Gadget *)T;
			T=BlocksToFrames(FVI->Optimized,CurCompMode);
			((struct PanelLine *)Obj)->G5 = (struct Gadget *)T;
			if(((struct PanelLine *)Obj)->G4>((struct PanelLine *)Obj)->G5)
				((struct PanelLine *)Obj)->G5=((struct PanelLine *)Obj)->G4; // Don't let optimized be smaller!!!
		}
	}
	return(0);
}

// Drive popup f'n  object is ignored
ULONG __asm CTRL_SetDrive(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct FlyerVolInfo *vi;
	char *name;
	DUMPSTR("SetDrive( ");
	name=( ((char **)pl->Param)[pl->PropStart] );

	if( *name==AUDIO_BYTE )
	{
		name +=2 ; // Skip speaker symbol char and space
		CurCompMode=AUDIO_COMP_MODE;
		if( (pl->Flags&PL_PARTNER) && pl->Partners )
			(pl->Partners)->PropStart = AUDIO_COMP_MODE;
		//ESparams1.Data1 = 0;								//removed to see video
		ESparams1.Data1 = SrcInd[CurFlySource];

		SendSwitcherReply(ES_RecordSource,&ESparams1);
	}
	ESparams2.Data1=(LONG)name;
	DUMPSTR((char *)ESparams2.Data1);
	DUMPMSG(" ) \\");
	ESparams2.Data2=(LONG)NULL;
	CurFlyDrive=pl->PropStart;
	if(vi=(struct FlyerVolInfo *)SendSwitcherReply(ES_FlyerDriveInfo,&ESparams2))
	{
		DUMPHEXIL(" vi = ",(LONG)vi,"\\");
		DUMPUDECL("vi->Largest =  ",(LONG)vi->Largest,"\\");
		DUMPUDECL("vi->Optimized =  ",(LONG)vi->Optimized,"\\");
		pl->G4 = (struct Gadget *) BlocksToFrames(vi->Largest,CurCompMode);
		pl->G5 = (struct Gadget *) BlocksToFrames(vi->Optimized,CurCompMode);
		if(pl->G4>pl->G5) pl->G5=pl->G4; // Don't let optimized be smaller!!!
	}
	return(0);
}

// Compression popup f'n  object is Drive PLine for available time update
ULONG __asm CTRL_SetCompression(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct FlyerVolInfo *FVI=NULL;
	LONG	T;
	DUMPUDECL("SetCompression( ",pl->PropStart," ) \\");
	ESparams1.Data1 =(LONG) QualMode[pl->PropStart];
	T=CurCompMode;
	CurCompMode = pl->PropStart;

	DUMPHEXIL(" Compmode = ",(LONG)ESparams1.Data1,"\\");
	if(CurCompMode!=AUDIO_COMP_MODE)
	{
		SendSwitcherReply(ES_CompressionMode,&ESparams1);
		if(T==AUDIO_COMP_MODE) // Was audio only
		{
			ESparams1.Data1 = SrcInd[CurFlySource];
			DUMPUDECL("SetSource( ",ESparams1.Data1,",");
			SendSwitcherReply(ES_RecordSource,&ESparams1);
		}
	}
	else {
		ESparams1.Data1 = SrcInd[CurFlySource];
		//ESparams1.Data1 = 0;								//removed to see video
		DUMPUDECL("SetSource( ",ESparams1.Data1,",");
		SendSwitcherReply(ES_RecordSource,&ESparams1);
	}
	if(Obj)
	{
		if(FlyerDriveCount && (FVI=GetFlyerInfo(FlyerDrives[CurFlyDrive])))
		{
			if( (FlyerDrives[CurFlyDrive][0]==AUDIO_BYTE) && (CurCompMode!=AUDIO_COMP_MODE) )
			{
				CurCompMode=AUDIO_COMP_MODE;
				pl->PropStart=AUDIO_COMP_MODE;
				ESparams1.Data1 = SrcInd[CurFlySource];
				//ESparams1.Data1 = 0;		//removed to see video
				DUMPUDECL("SetSource( ",ESparams1.Data1,",");
				SendSwitcherReply(ES_RecordSource,&ESparams1);
			}
			T=BlocksToFrames(FVI->Largest,CurCompMode);
			((struct PanelLine *)Obj)->G4 = (struct Gadget *)T;
			T=BlocksToFrames(FVI->Optimized,CurCompMode);
			((struct PanelLine *)Obj)->G5 = (struct Gadget *)T;
			if(((struct PanelLine *)Obj)->G4>((struct PanelLine *)Obj)->G5)
				((struct PanelLine *)Obj)->G5=((struct PanelLine *)Obj)->G4; // Don't let optimized be smaller!!!
		}
	}
	return(0);
}

// 2 or 3 monitor mode setting
ULONG __asm CTRL_SetFace(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	DUMPUDECL("SetFace( ",(LONG)*pl->Param," ) \\");
	if(*pl->Param)
		Config.Flags1 |= (1<<spB_PrvwOLay);
	else
	{
		Config.Flags1 &= ~(1<<spB_PrvwOLay);
		DUMPSTR(FaceMess[0]);
		DUMPMSG(FaceMess[1]);
		SimpleRequest(pl->Win,FaceMess,2,REQ_CENTER | REQ_H_CENTER,NULL);
	}
	ESparams1.Data1=(LONG)&Config;
	SendSwitcherReply(ES_SetPrefs,&ESparams1);
	return(0);
}

// Source Termination setting
ULONG __asm CTRL_SetTermination(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	DUMPUDECL("SetTermination( ",(LONG)pl->Param," ) \\");
	Config.Termination = (LONG)pl->Param;
	ESparams1.Data1=(LONG)&Config;
	SendSwitcherReply(ES_SetPrefs,&ESparams1);
	return(0);
}

// Flyer Output Setting
ULONG __asm CTRL_SetFlyOut(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	if((LONG)pl->Param&1)
		Config.Flags1 |= (1<<spB_FlyerVID3);
	else Config.Flags1 &= ~(1<<spB_FlyerVID3);
	if((LONG)pl->Param&2)
		Config.Flags1 |= (1<<spB_FlyerVID4);
	else Config.Flags1 &= ~(1<<spB_FlyerVID4);
	ESparams1.Data1=(LONG)&Config;
	SendSwitcherReply(ES_SetPrefs,&ESparams1);
	return(Config.Flags1);
}

// Set GPI setting
ULONG __asm CTRL_SetGPI(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	DUMPUDECL("SetGPI( ",pl->PropStart," ) \\");
	Config.GPI = pl->PropStart;
	ESparams1.Data1=(LONG)&Config;
	SendSwitcherReply(ES_SetPrefs,&ESparams1);
	return(Config.GPI);
}

// HQ5 enable/disable
ULONG __asm CTRL_SetHQ5(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	static char *WarnMess[]={
		"Warning -- Clips previously recorded in HQ5",
		"will not play properly if HQ5 is not enabled."
	};

	DUMPUDECL("SetHQ5( ",(ULONG)pl->Param," ) \\");
	if(pl->Param == 0)				// Shut off HQ5?
	{
		SimpleRequest(pl->Win,WarnMess,2,REQ_CENTER | REQ_H_CENTER,NULL);
	}
	return(0);
}



// Audio env create/delete/drag
//ULONG __asm CTRL_SetHQ5(
//	REG(a0) struct PanelLine *pl,
//	REG(a1) struct IntuiMessage *IntuiMsg,
//	REG(a2) APTR Obj)
//{
//}
//	return(0);
//}


UWORD __asm GetRecSense()
{
	UWORD	s;

//	DUMPSTR("GetRecSense: ");
	ESparams2.Data1 =(LONG) &AudCtrl;
	ESparams2.Data2 =(LONG) 1;
	SendSwitcherReply(ES_AudioControl,&ESparams2);
	s=(AudCtrl.LeftSense<<8);
	s|=AudCtrl.RightSense;
//	DUMPHEXIW(" = ",s,"\\");

	return(s);
}

UWORD __asm GetRecGain()
{
	UWORD	s;
	UBYTE *c;
	c=(UBYTE *)&s;
	DUMPSTR("RecGain");
	ESparams2.Data1 =(LONG) &AudCtrl;
	ESparams2.Data2 =(LONG) 1;
	SendSwitcherReply(ES_AudioControl,&ESparams2);
	s=(AudCtrl.LeftGain<<8);
	s|=AudCtrl.RightGain;
	DUMPUDECB(" L: ",c[0],"   ");
	DUMPUDECB(" R: ",c[1],"\\");
	return(s);
}

// Record gain control function, object is *FlyAudCtrl
ULONG __asm CTRL_SetRecGain(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct FlyAudCtrl	*aud=Obj;
	ULONG	Y=*pl->Param;
	DUMPUDECL("SetRecGain: ",Y,"\\");
	if(!aud) return(0);
	if(pl->Flags&PL_IN)
	{
		LClipping=0;
		global_LeftGain = aud->LeftGain =  Y&0x0F;
	}
	else
	{
		RClipping=0;
		global_RightGain = aud->RightGain = Y&0x0F;
	}
	ESparams2.Data1 =(LONG) aud;
	ESparams2.Data2 =(LONG) 2;
	SendSwitcherReply(ES_AudioControl,&ESparams2);
	return((ULONG)aud->LeftGain);
}


// For Diagnostic purposes only
ULONG __asm CTRL_DumpPLine(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
#ifdef SERDEBUG
	DUMPMSG("PanelLine = { ");
	if((ULONG)pl->Param>0xFFFF)
	{
		DUMPHEXIL("	*Param: ",(LONG)*pl->Param,"  ");
		DUMPHEXIL(" @",(LONG)pl->Param,"\\");
	}
	else DUMPUDECL("	Param: ",(LONG)pl->Param,"\\ ");
	if((ULONG)pl->Param2>0xFFFF)
	{
		DUMPHEXIL("	*Param2: ",(LONG)*pl->Param2,"  ");
		DUMPHEXIL(" @",(LONG)pl->Param2,"\\");
	}
	else DUMPUDECL("	Param2: ",(LONG)pl->Param2,"\\ ");
	DUMPUDECL("	PropStart ",(LONG)pl->PropStart,"	");
	DUMPUDECL("	PropEnd ",(LONG)pl->PropEnd," \\");
	DUMPHEXIL("	Flags ",(LONG)pl->Flags," \\");
	DUMPHEXIL("	Obj: ",(LONG)Obj," };\\");
#endif
	return(0);
}

// Return overall volume (0-100), from v1,v2,balance,etc.
ULONG	GetVolume(struct AudioSet	*aud)
{
	ULONG	V=0;

#ifdef SERDEBUG
	DUMPHEXIL("AudioSet @ ",(LONG)aud,"  = { \\");
	DUMPUDECL("Volume: ",aud->Volume,"	");
	DUMPUDECL("V1: ",aud->V1,"	");
	DUMPUDECL("V2: ",aud->V2,"\\");
	DUMPHEXIW("Balance: ",aud->Balance,"	");
	DUMPHEXIW("P1: ",aud->Pan1,"	");
	DUMPHEXIW("P2: ",aud->Pan2,"\\");
	DUMPHEXIW("Mode: ",aud->Mode,"	} \\");
#endif
	if(!aud) return(0);
	switch(aud->Mode)
	{
		case  AMODE_LEFT:
			if(aud->V1) V=((aud->V1+1)*100)/MAXPOT;
			break;
		case  AMODE_RIGHT:
			if(aud->V2) V=((aud->V2+1)*100)/MAXPOT;
			break;
		case  AMODE_STEREO:
		default:
			if(V=MAX(aud->V1,aud->V2)) V=((V+1)*100)/MAXPOT;
			break;
	}
	return(aud->Volume=V);
}

// Volume control function, object is *AudioSet
ULONG __asm CTRL_SetVolume(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct AudioSet	*aud=Obj;
	LONG	*paramptr;

	DUMPMSG("CTRL_SetVolume");
	if(!aud) return(0);
	switch(aud->Mode)
	{
		case  AMODE_LEFT:
			aud->V1 = (MAXPOT*aud->Volume/pl->PropEnd)&0x0000FFFF;
			if (aud->V1==0)
				aud->V1=((MAXPOT>>1)/105); 
			PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
			break;
		case  AMODE_RIGHT:
			aud->V2 = (MAXPOT*aud->Volume/pl->PropEnd)&0x0000FFFF;
			if (aud->V2==0)
				aud->V2=((MAXPOT>>1)/110); 
			PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
			break;
		case  AMODE_STEREO:
		default:
			SetDiffStereoVol(aud,pl->PropEnd);
			//if (aud->V1==0)
			//	aud->V1=((MAXPOT>>1)/100); 
			//if (aud->V2==0)
			//	aud->V2=((MAXPOT>>1)/100); 

			break;
	}

	if (PlayFG)
	{
		DUMPMSG("Live");
		ESparams1.Data1 =(LONG) aud->FG;
		SendSwitcherReply(ES_ChangeAudio,&ESparams1);
	}
	else
	{
		DUMPMSG("non-live");

		if (LastTime)
		{
			if(LastTime->Flags & PL_IN)
				paramptr=LastTime->Param;
			else
				paramptr=LastTime->Param2;

			if (IntuiMsg->Class != IDCMP_GADGETDOWN)		// MouseMove's or GadgetUp's
			{

				ESparams2.Data1=(LONG)CurFG;
				ESparams2.Data2=(LONG)Frms2Flds(*paramptr);
				DUMPHEXIW("Scrub ",(LONG)Frms2Flds(*paramptr),"\\");
//				DUMPMSG("Scrub");
				SendSwitcherReply(ES_Jump,&ESparams2);		// No rendering, just try jog in place
			}

			if (IntuiMsg->Class == IDCMP_GADGETUP)
				DHD_Quiet(*paramptr);		// Quiet audio
		}
	}
	return(aud->Volume);
}


/*
 * SetDiffStereoVol - Cook balance/Volume into differential volumes for L/R channels
 *							 (Some controls are still doing this themselves, should use this!)
 */
static void SetDiffStereoVol(struct AudioSet *aud, UWORD scale)
{
	UWORD R,L;
	ULONG	Y;

	DUMPMSG("SetDiffStereoVol");
	R = aud->Balance;
	L=MAXPOT-R;
	if(R>MAXPOT>>1)  // Scale balance to 100% volume (0xFFFF)
	{
		Y=L*MAXPOT;
		L=Y/R;
		R=MAXPOT;
		aud->V1= ((L*(aud->Volume))/scale)&0x0000FFFF;
		aud->V2= ((R*(aud->Volume))/scale)&0x0000FFFF;
	}
	else if(R<MAXPOT>>1)
	{
		Y=R*MAXPOT;
		R=Y/L;
		L=MAXPOT;
		aud->V1= ((L*(aud->Volume))/scale)&0x0000FFFF;
		aud->V2= ((R*(aud->Volume))/scale)&0x0000FFFF;
	}
	else // R==MAXPOT>>1
		aud->V2 = aud->V1 = (MAXPOT*aud->Volume/scale)&0x0000FFFF;

	PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
	PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
}

// Return Balance (0-0xFFFF), from v1,v2,balance,etc.
ULONG	GetBalance(struct AudioSet	*aud)
{
	ULONG	V;
	UWORD R,L;

	DUMPMSG("GetBalance");
	if(!aud) return(0);
	switch(aud->Mode)
	{
		case  AMODE_LEFT: // just return aud->Balance !?? WRONG010396DEH
			//aud->Balance=aud->Pan1;
			aud->Balance=aud->Pan1+32767;
			DUMPHEXIW("GB Balance: ",aud->Balance,"\\");
			DUMPHEXIW("GB Pan1: ",aud->Pan1,"\\");
			break;
		case  AMODE_RIGHT:
			//aud->Balance=aud->Pan2;
			aud->Balance=aud->Pan2+32767;
			DUMPHEXIW("GB Balance: ",aud->Balance,"\\");
			DUMPHEXIW("GB Pan2: ",aud->Pan2,"\\");
			break;
		case  AMODE_STEREO:
		default:
			if(!(V=MAX(aud->V1,aud->V2))) return(MAXPOT>>1);
			if(aud->V1<aud->V2)
			{
				V=aud->V1*MAXPOT/aud->V2; // Scale up to full Volume
				L=V/2;
				R=MAXPOT-L;
			}
			else 	if(aud->V1>aud->V2) {
				V=aud->V2*MAXPOT/aud->V1; // Scale up to full Volume
				R=V/2;
				L=MAXPOT-R;
			}  // V1==V2
				else R = L = MAXPOT>>1;
			R &= 0x0000FFFF;
			aud->Balance=R;
			break;
	}
	return(aud->Balance);
}

// Fake balance Volume control function, object is AudioSet
ULONG __asm CTRL_SetBalance(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct AudioSet	*aud=Obj;
	LONG	*paramptr;
	ULONG	V,V1,V2;
	UWORD R,L;

	DUMPMSG("CTRL_SetBalance");
	aud->Balance = R = ((struct PropInfo *)pl->PropGadg->SpecialInfo)->HorizPot;
	if (R == 0xFFFF)
		aud->Balance = R = 0xFFFE;
	switch(aud->Mode)
	{
		case  AMODE_LEFT:
			if(aud->Balance==MAXPOT)
				aud->Pan1=(MAXPOT>>1); // want 0x7FFF, not 0x8000
			else
				aud->Pan1 = aud->Balance - (MAXPOT>>1);
			PutValue((struct FastGadget *)aud->FG,TAG(AudioPan1),aud->Pan1);
			break;
		case  AMODE_RIGHT:
			if(aud->Balance==MAXPOT)
				aud->Pan2=(MAXPOT>>1); // want 0x7FFF not 0x8000
			else
				aud->Pan2 = aud->Balance - (MAXPOT>>1);
			PutValue((struct FastGadget *)aud->FG,TAG(AudioPan2),aud->Pan2);
			break;
		case  AMODE_STEREO:
		default:
			V=aud->Volume*MAXPOT/100;
			DUMPHEXIW("Aud Balance: ",aud->Balance,"\\");
			DUMPHEXIW("R: ",R,"\\");
			if(R<MAXPOT>>1)
			{
				V2=2*R;
				aud->V2=(V2*V/MAXPOT)&0x0000FFFF;
				aud->V1=V&0x0000FFFF;
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
			}
			else 
				if(R>MAXPOT>>1)
				{
					DUMPMSG("TOTALPANIC");
					L=(MAXPOT-R); 
					V1=2*L;
					aud->V2=V&0x0000FFFF;
					aud->V1=(V1*V/MAXPOT)&0x0000FFFF;
					DUMPHEXIW("P1: ",aud->Pan1,"\\");
					DUMPHEXIW("P2: ",aud->Pan2,"\\");


					PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
					PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
				}
				else
				{
					aud->V1 = aud->V2 = V;
					PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
					PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
				}
			break;
	}

	if (PlayFG)
	{
		DUMPMSG("Live");
		ESparams1.Data1 =(LONG) aud->FG;
		SendSwitcherReply(ES_ChangeAudio,&ESparams1);
	}
	else
	{
		if (LastTime)
		{
			if(LastTime->Flags & PL_IN)
				paramptr=LastTime->Param;
			else
				paramptr=LastTime->Param2;

			if (IntuiMsg->Class != IDCMP_GADGETDOWN)		// MouseMove's or GadgetUp's
			{
				ESparams2.Data1=(LONG)CurFG;
				ESparams2.Data2=(LONG)Frms2Flds(*paramptr);
				DUMPHEXIW("Scrub ",(LONG)Frms2Flds(*paramptr),"\\");
//				DUMPMSG("Scrub");
				SendSwitcherReply(ES_Jump,&ESparams2);		// No rendering, just try jog in place
			}

			if (IntuiMsg->Class == IDCMP_GADGETUP)
				DHD_Quiet(*paramptr);		// Quiet audio
		}
	}
	
	return((ULONG)R);
}

// Set stereo output source popup function, object is AudioSet,
ULONG __asm CTRL_SetPan(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct AudioSet	*aud=Obj;
	DUMPMSG("CTRL_SetPan");
	if(aud->Mode!=pl->PropStart) // mode actually changed
	{
		switch(aud->Mode=pl->PropStart)
		{
			case   AMODE_LEFT:
				DUMPMSG("Left");
				DUMPHEXIW("Balance: ",aud->Balance,"\\");

				if(aud->Balance==MAXPOT)
					aud->Pan1=(MAXPOT>>1); // want 0x7FFF, not 0x8000
				else
					aud->Pan1 = aud->Balance - (MAXPOT>>1);
				DUMPHEXIW("Pan1: ",aud->Pan1,"\\");
				aud->Pan2 =	0;
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan1),aud->Pan1);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan2),aud->Pan2);
				aud->V1 = (MAXPOT*aud->Volume/100)&0x0000FFFF;
				aud->V2 = 0;
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
				SET_LEFT(aud->AudioOn);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioOn),aud->AudioOn);
				break;
			case  AMODE_RIGHT:
				DUMPMSG("Right");
				DUMPHEXIW("Balance: ",aud->Balance,"\\");
				//aud->Pan2 = aud->Balance  - (MAXPOT>>1); //seem to make bad vals.

				if(aud->Balance==MAXPOT)
					aud->Pan2=(MAXPOT>>1); // want 0x7FFF not 0x8000
				else
					aud->Pan2 = aud->Balance - (MAXPOT>>1);
				aud->Pan1 =	0;
				DUMPHEXIW("Pan2: ",aud->Pan2,"\\");
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan1),aud->Pan1);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan2),aud->Pan2);
				aud->V1 = 0;
				aud->V2 = (MAXPOT*aud->Volume/100)&0x0000FFFF;
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume2),aud->V2);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioVolume1),aud->V1);
				SET_RIGHT(aud->AudioOn);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioOn),aud->AudioOn);
				break;
			case  AMODE_NOAUDIO:
				DUMPMSG("None");
				SET_NOAUDIO(aud->AudioOn);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioOn),aud->AudioOn);
				break;
			case  AMODE_STEREO:
			default:
				DUMPMSG("Stereo");
				aud->Pan1 = PAN_LEFT;
				aud->Pan2 = PAN_RIGHT;
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan1),aud->Pan1);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioPan2),aud->Pan2);
//				CTRL_SetVolume(pl,IntuiMsg,Obj); // recalc V1,V2 based on Volume,Balance
				SetDiffStereoVol(aud,100);			// Recalc V1,V2 CORRECTLY!
				SET_STEREO(aud->AudioOn);
				PutValue((struct FastGadget *)aud->FG,TAG(AudioOn),aud->AudioOn);
				//ESparams1.Data1 =(LONG) aud->FG;
				//SendSwitcherReply(ES_ChangeAudio,&ESparams1);
				break;
		}
	}
	ESparams1.Data1 =(LONG) aud->FG;
	SendSwitcherReply(ES_ChangeAudio,&ESparams1);
	return(aud->Mode);
}

// Fake balance Volume control function, object is AudioSet
ULONG __asm CTRL_SetAudio(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	struct AudioSet	*aud=Obj;

	DUMPMSG("CTRL_SetAudio");
	if(pl->Param)
		aud->AudioOn |= AUD_ENABLE;
	else
		aud->AudioOn &= ~AUD_ENABLE;
	PutValue((struct FastGadget *)aud->FG,TAG(AudioOn),aud->AudioOn);
	ESparams1.Data1 =(LONG) aud->FG;
	SendSwitcherReply(ES_ChangeAudio,&ESparams1);
	return(aud->AudioOn);
}


//  Play or abort current FG clip
ULONG __asm CTRL_Play(
	REG(a0) struct PanelLine *pl,
	REG(a1) struct IntuiMessage *IntuiMsg,
	REG(a2) APTR Obj)
{
	if(Obj && !PlayFG)
	{
//		PlayFG=NULL;

		ClearFlyerStatus();		// Clear "done" flag and any errors

		DUMPMSG("Play");
		if(SKellFG!=Obj)
		{
			ESparams1.Data1 =(LONG) Obj;
			SendSwitcherReply(ES_PanelClose,&ESparams1);
			if(EDITOR_MODE || SendSwitcherReply(ES_Select,&ESparams1))
			{
				SKellFG=(struct FastGadget *)Obj;
				PlayFG = SKellFG;
				SendSwitcherReply(ES_Auto,&ESparams1);
			}
			else
			{
				DUMPSTR("SELECT FAILED!!! on FG");
				DUMPMSG( ((struct ExtFastGadget *)Obj)->FileName );
				SKellFG=NULL;
			}
		}
		else if(ESparams1.Data1 =(LONG) Obj)
		{
			PlayFG = SKellFG;
			SendSwitcherReply(ES_PanelClose,&ESparams1);
			SendSwitcherReply(ES_Auto,&ESparams1);
		}
	}
	else
	{
		DUMPMSG("Stop");
		SendSwitcherReply(ES_Stop,NULL);
		if(ESparams1.Data1 =(LONG) PlayFG)
			SendSwitcherReply(ES_PanelOpen,&ESparams1);
		PlayFG=NULL;

		// Why does Flyer lock if we take this out (stops/beginfindfield happens too quickly)
		DUMPSTR("Wait...");
		Delay(20);
		DUMPMSG("okay");
	}
	return((ULONG)Obj);
}

//|~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~~*~~|//



void AddFlyerDrive(char *devname)
{
	if(!FlyerBase) return;
	DUMPUDECL("FlyerDrive[",FlyerDriveCount,"] = ");
	DUMPMSG(devname);
	if((*devname) && (FlyerDriveCount<21))
		strncpy(FlyerDrives[FlyerDriveCount++],devname,FLY_VOL_MAX-1);
	FlyerDrives[FlyerDriveCount][0]=0;
}

struct FlyerVolInfo *GetFlyerInfo(char *devname)
{
	struct FlyerVolInfo *vi=NULL;
	if(*devname)
	{
		DUMPSTR("FlyerDriveInfo( ");
		if( *devname==AUDIO_BYTE ) devname +=2 ; // Skip speaker symbol char and space
		ESparams2.Data1=(LONG)devname;
		DUMPSTR((char *)ESparams2.Data1);
		ESparams2.Data2=NULL;
		if(vi=(struct FlyerVolInfo *)SendSwitcherReply(ES_FlyerDriveInfo,&ESparams2))
		{
			DUMPHEXIL(" ) = ",(LONG)vi,"\\");
			DUMPUDECL("FlyerVolumeInfo->Largest 	=  ",(LONG)vi->Largest,"\\");
			DUMPUDECL("FlyerVolumeInfo->Optimized 	=  ",(LONG)vi->Optimized,"\\");
			DUMPUDECB("FlyerVolumeInfo->Flags 	= ",vi->Flags,"\\");
			return(vi);
		}
	}
	return(NULL);
}

int CheckFlyerDrives()
{
	struct FlyerVolInfo *FVI=NULL;
	int	i;

	if(!FlyerBase) return(0);
	for(i=0;i<FlyerDriveCount && *(FlyerDrives[i]); i++)
	{
		DUMPUDECL("Checking Flyer Drive #",(LONG)i," Name: ");
		DUMPMSG(FlyerDrives[i]);
		if(FVI=GetFlyerInfo(FlyerDrives[i]))
		{
			if( IS_AUDIO_DRIVE(FVI) )
			{
				DUMPUDECL("Audio Flag set on # ",(LONG)i,"\\");
				TempCh[0]=AUDIO_BYTE; // Add little speaker symbol character
				TempCh[1]=' ';
				strncpy(&(TempCh[2]),FlyerDrives[i],FLY_VOL_MAX-2);
				strncpy(FlyerDrives[i],TempCh,FLY_VOL_MAX-2);
				TempCh[0]=0;
			}
		}
	}
	return(i);
}

void SortFlyerDrives()
{
//	QuickSortArray(FlyerDrives, FlyerDriveCount,CompareFlyerDrives,SwapFlyerDrives);
// for some unknown reason, this call takes forever... literally
// So this hack version, which depends on the drives already marked with AUDIO_BYTE
	int	i,b=FlyerDriveCount-1;
	UBYTE *temp;

	if (FlyerDriveCount == 0)		// Don't try to sort an empty list
		return;

	if(!FlyerBase)
	{
		FlyerDriveCount=0;
		return;
	}

	while ((b>0) && (*(FlyerDrives[b])==AUDIO_BYTE))
		b--; // b is index of last non-audio drive

	for(i=0; i<b; i++)
	{
		if( (*(FlyerDrives[i])==AUDIO_BYTE) )
		{
			temp=FlyerDrives[i];
			FlyerDrives[i]=FlyerDrives[b];
			FlyerDrives[b--]=temp;
		}
	}
	return;

}

ULONG CheckTag(struct FastGadget *FG,ULONG TagID)
{
#ifdef SERDEBUG
	ULONG	c=0;
	if(FG) {
		ESparams2.Data1=(LONG)FG;
		ESparams2.Data2=TagID;
		c=SendSwitcherReply(ES_TagSize,&ESparams2);
	}
	DUMPHEXIL("ES_TagSize( ",(LONG)FG,", ");
	DUMPSTR(TagNames[TagID&~0x80000000].th_Name);
	DUMPSDECL(" 		) = ",c,"\\");
	return(c);
#else
	if(FG){
		ESparams2.Data1=(LONG)FG;
		ESparams2.Data2=TagID;
	 	return((ULONG)SendSwitcherReply(ES_TagSize,&ESparams2));
	}
	else return(0);
#endif
}

LONG GetValue(struct FastGadget *FG,ULONG TagID)
{
#ifdef SERDEBUG
	LONG	c=0;
	if(FG) {
		ESparams2.Data1=(LONG)FG;
		ESparams2.Data2=TagID;
		c=SendSwitcherReply(ES_GetValue,&ESparams2);
	}
	DUMPHEXIL("ES_GetValue( ",(LONG)FG,", ");
	DUMPSTR(TagNames[TagID&~0x80000000].th_Name);
	DUMPSDECL(" 		) = ",c,"\\");
	return(c);
#else
	if(FG){
		ESparams2.Data1=(LONG)FG;
		ESparams2.Data2=TagID;
	 	return(SendSwitcherReply(ES_GetValue,&ESparams2));
	}
	else return(0);
#endif
}

LONG GetTable(struct FastGadget *FG,ULONG TagID, UBYTE *Table, ULONG Size)
{
	LONG	c=0,d=666;
	if(FG) {
		ESparams2.Data1=(LONG)FG;
		ESparams2.Data2=TagID;
		c=SendSwitcherReply(ES_TagSize,&ESparams2);
		DUMPSDECL("Table TAG Size= ",c,"\\");
		DUMPSDECL("Table Input Size= ",Size,"\\");
		if( (ESparams4.Data2=(LONG)Table) && (ESparams4.Data3=MIN(Size,c)) )
		{
			DUMPMSG(Table);
			ESparams4.Data1=(LONG)FG;
			ESparams4.Data4=TagID&~0x80000000;
			d=SendSwitcherReply(ES_GetTable,&ESparams4);
			DUMPMSG(Table);
		}
	}
	DUMPHEXIL("ES_GetTable( ",(LONG)FG,",");
	DUMPSTR(TagNames[TagID].th_Name);
	DUMPSDECL(")= ",d,"\\");
	if(Table) DUMPMSG(Table);
	return(c);
}

LONG PutValue(struct FastGadget *FG,ULONG TagID,LONG Value)
{
#ifdef SERDEBUG
	if(FG) {
		ESparams3.Data1=(LONG)FG;
		ESparams3.Data2=TagID;
		ESparams3.Data3=Value;
		SendSwitcherReply(ES_PutValue,&ESparams3);
	}
	DUMPHEXIL("PutValue( ",(LONG)FG,", ");
	DUMPSTR(TagNames[TagID&~0x80000000].th_Name);
	DUMPSDECL(" 		,",Value," ) \\");
	return(0);
#else
	if(FG) {
		ESparams3.Data1=(LONG)FG;
		ESparams3.Data2=TagID;
		ESparams3.Data3=Value;
		return(SendSwitcherReply(ES_PutValue,&ESparams3));
	}
	else return(0);
#endif
}

LONG PutTable(struct FastGadget *FG,ULONG TagID,UBYTE *Table, ULONG Size)
{
	LONG	c=0;
	if(FG) {
		ESparams4.Data1=(LONG)FG;
		ESparams4.Data2=(LONG)Table;
		ESparams4.Data3=Size;
		ESparams4.Data4=TagID&~0x80000000;
		c=SendSwitcherReply(ES_PutTable,&ESparams4);
	}
#ifdef SERDEBUG
	DUMPHEXIL("PutTable( ",(LONG)FG,", ");
	DUMPSTR(TagNames[TagID&~0x80000000].th_Name);
	DUMPSTR(" , ");
	DUMPSTR(Table);
	DUMPUDECL(" ) = ",c,"\\");
#endif
	return(c);
}


/*
// channels: bit 0 = L exist, 2=L enable, Bit 1 = R exist, 3=R enable,
// just like AudioOn tag value
void SwitchFlyerAudio(struct FastGadget *FG,LONG Channels)
{
	DUMPMSG("SwitcherFlyerAudio");
	PutValue(FG,TAG(AudioOn),Channels);
	switch((Channels>>2)&3)
	{
		case 0:  // all disabled, why change vol??
			break;
		case 1:
			PutValue(FG,TAG(AudioPan1),0);
			break;
		case 2:
			PutValue(FG,TAG(AudioPan2),0);
			break;
		case 3:
			PutValue(FG,TAG(AudioPan1),-1);
			PutValue(FG,TAG(AudioPan2),1);
			break;
	}
	ESparams1.Data1 =(LONG) aud->FG;
	SendSwitcherReply(ES_ChangeAudio,&ESparams1);
}

// channels: bit 0 = L exist, 2=L enable, Bit 1 = R exist, 3=R enable,
// just like AudioOn tag value
void SetFlyerAudio(struct FastGadget *FG,UWORD Vol1,UWORD Vol2,LONG Channels)
{
	DUMPMSG("SetFlyerAudio");
	PutValue(FG,TAG(AudioOn),Channels);
	switch((Channels>>2)&3)
	{
		case 0:  // all disabled, why change vol??
			break;
		case 1:
			PutValue(FG,TAG(AudioVolume1),Vol1);
			PutValue(FG,TAG(AudioPan1),0);
			break;
		case 2:
			PutValue(FG,TAG(AudioVolume2),Vol2);
			PutValue(FG,TAG(AudioPan2),0);
			break;
		case 3:
			PutValue(FG,TAG(AudioVolume1),Vol1);
			PutValue(FG,TAG(AudioVolume2),Vol2);
			PutValue(FG,TAG(AudioPan1),-1);
			PutValue(FG,TAG(AudioPan2),1);
			break;
	}
	ESparams1.Data1 =(LONG) aud->FG;
	SendSwitcherReply(ES_ChangeAudio,&ESparams1);
}
*/


void __inline SetInPoint(struct FastGadget *FG, ULONG InField, ULONG OutField)
{
	PutValue(FG,TAG(ClipStartField),InField);
	PutValue(FG,TAG(Duration),(OutField+4-InField));
}

void __inline SetOutPoint(struct FastGadget *FG, ULONG InField, ULONG OutField)
{
	PutValue(FG,TAG(Duration),(OutField+4-InField));
}

void __inline SetAudioInPoint(struct FastGadget *FG, ULONG InField, ULONG OutField)
{
	PutValue(FG,TAG(AudioStart),InField);
	PutValue(FG,TAG(AudioDuration),(OutField+4-InField));
}

void __inline SetAudioOutPoint(struct FastGadget *FG, ULONG InField, ULONG OutField)
{
	PutValue(FG,TAG(AudioDuration),(OutField+4-InField));
}

// Return MaxBlocks
ULONG	DHD_InitRecord(ULONG Unit,ULONG Flags)
{
	DUMPUDECL("DHD_InitRecord( ",Unit,",");
	DUMPHEXIL(" ",Flags," ); \\ ");

#if 0
// Removed this code, as it was removing the current key before you could record it!
	if(ESparams1.Data1=(LONG)CurFG)
	{
		SendSwitcherReply(ES_SelectDefault,NULL);
//		SendSwitcherReply(ES_FreeCrouton,&ESparams1); // if freshly recorded clip
		CurFG=NULL;
	}
#endif

	SendSwitcherReply(ES_InitRecord,NULL);
	DUMPMSG("InitRecord() Done");
	return((ULONG)1);
}

// Src is raw CurFlySource= popup array entry Actual flyer value SrcInd[CurFlySource];
void DHD_SetupRecord(LONG Src, LONG Comp)
{
	DUMPUDECL("DHD_SetupRecord( ",Src,",");
	DUMPUDECL(" ",Comp,") \\");

	ESparams1.Data1 = SrcInd[Src];
	if(Comp==AUDIO_COMP_MODE)
		ESparams1.Data1 = 0;
	SendSwitcherReply(ES_RecordSource,&ESparams1);

	ESparams1.Data1 =(LONG) QualMode[Comp];
	SendSwitcherReply(ES_CompressionMode,&ESparams1);

	ESparams2.Data1 =(LONG) &AudCtrl;
	ESparams2.Data2 =(LONG) 2;
	SendSwitcherReply(ES_AudioControl,&ESparams2);
	return;
}

// Return MaxBlocks
ULONG	DHD_InitPlay(char *name,ULONG Flags)
{
	DUMPSTR("DHD_InitPlay( ");
	DUMPHEXIL(" ",Flags," ); \\ ");
	SendSwitcherReply(ES_InitPlay,NULL);
	return((ULONG)1);
}


void	__inline Main2Blank()
{
	DUMPMSG("Main2Blank");
	SendSwitcherReply(ES_Main2Blank,NULL);
	return;
}


ULONG	DHD_MakeClipIcon(char *name)
{
	struct	ClipInfo * ci;
	ULONG	x=FALSE;	//assume error

	DUMPSTR("DHD_MakeClipIcon( ");
	DUMPSTR(name);
	DUMPSTR(" )");

	DisplayWaitSprite();

	if( (ci=DHD_ClipInfo(name)) && (ci->Flags&CIF_HASVIDEO) ) {
		ESparams4.Data1=(LONG)name;
		ESparams4.Data2=(LONG)0;				// currently no CrUD
		ESparams4.Data3=(LONG)0;
		ESparams4.Data4=(LONG)(ci->Fields/2);	// center field
		x=(ULONG)SendSwitcherReply(ES_MakeClipIcon,&ESparams4);
		ESparams1.Data1=(LONG)name;
		SendSwitcherReply(ES_AppendIcon,&ESparams1);
	}

	DisplayNormalSprite();
	return(x);
}

void	SetRCBFlags(struct RenderCallBack	*rcb)
{
	if(rcb->pline->Flags&PL_AUDIO)
	{
		rcb->Flags &= ~DHD_VIDEOSLIDER;
		rcb->Flags |=	DHD_AUDIOSLIDER;
	}
	else
	{
		rcb->Flags &=	~DHD_AUDIOSLIDER;
		rcb->Flags |=	DHD_VIDEOSLIDER;
	}

	if(rcb->pline->Flags&PL_IN)
	{
		rcb->Flags &=~DHD_OUTPOINT;
		rcb->Flags |=DHD_INPOINT  ;
	}
	else
	{
		rcb->Flags &=~DHD_INPOINT;
		rcb->Flags |=DHD_OUTPOINT;
	}
}

void	SetRCBTags(struct RenderCallBack	*rcb)
{
	struct PanelLine *PartPL;
	ULONG infield,outfield;

	if (!(rcb->pline->Flags & PL_SHADOW))
	{
		if(rcb->pline->Flags&PL_AUDIO)
		{
			if(rcb->pline->Flags&PL_IN)
				SetAudioInPoint(rcb->FG,rcb->Frame,rcb->Max);
			else if(rcb->pline->Flags&PL_OUT)
				SetAudioOutPoint(rcb->FG,rcb->Min,rcb->Frame);
		}
		else
		{
			if(rcb->pline->Flags&PL_IN)
				SetInPoint(rcb->FG,rcb->Frame,rcb->Max);
			else if(rcb->pline->Flags&PL_OUT)
				SetOutPoint(rcb->FG,rcb->Min,rcb->Frame);
		}


		if( (rcb->pline->Flags&PL_PARTNER) && (PartPL=rcb->pline->Partners) )
		{
			if (rcb->pline->Flags & PL_DUAL)
			{
				infield = (*PartPL->Param-PartPL->PropStart)<<1;
				outfield = (*PartPL->Param2-PartPL->PropStart)<<1;
			}
			else
			{
				infield = rcb->Min;
				outfield = rcb->Max;
			}

			if(PartPL->Flags&PL_AUDIO)		// Audio ganged to video knob
			{
				if(PartPL->Flags&PL_IN)
					SetAudioInPoint(rcb->FG,rcb->Frame,outfield);
//					SetAudioInPoint(rcb->FG,rcb->Frame,rcb->Max);
				else if(PartPL->Flags&PL_OUT)
					SetAudioOutPoint(rcb->FG,infield,rcb->Frame);
//					SetAudioOutPoint(rcb->FG,rcb->Min,rcb->Frame);
			}
			else   // Video ganged with audio knob
			{
				if(PartPL->Flags&PL_IN)
					SetInPoint(rcb->FG,rcb->Frame,outfield);
//					SetInPoint(rcb->FG,rcb->Frame,rcb->Max);
				else if(PartPL->Flags&PL_OUT)
					SetOutPoint(rcb->FG,infield,rcb->Frame);
//					SetOutPoint(rcb->FG,rcb->Min,rcb->Frame);
			}
		}
	}
	else
	{
		//*** Set tags for shadowed duoslide in/out points ***//
		if(rcb->pline->Flags&PL_IN)
		{
			infield = rcb->Frame;
			outfield = infield + Frms2Flds(rcb->pline->ShadowOffset);
		}
		else
		{
			outfield = rcb->Frame;
			infield = outfield - Frms2Flds(rcb->pline->ShadowOffset);
		}

		if(rcb->pline->Flags&PL_AUDIO)
		{
			SetAudioInPoint(rcb->FG,infield,outfield);

			// Set video in/out too?
			if ((rcb->pline->Flags&PL_PARTNER) && (rcb->pline->Partners))
				SetInPoint(rcb->FG,infield,outfield);
		}
		else
		{
			SetInPoint(rcb->FG,infield,outfield);

			// Set audio in/out too?
			if ((rcb->pline->Flags&PL_PARTNER) && (rcb->pline->Partners))
				SetAudioInPoint(rcb->FG,infield,outfield);
		}
	}


	// This is for hidden audio sliders which always must follow video in quick tune!!!
	if(rcb->pline->Flags&PL_PHANTOM)
	{
		if(rcb->pline->Flags&PL_IN)
			SetAudioInPoint(rcb->FG,rcb->Frame,rcb->Max);
		else if(rcb->pline->Flags&PL_OUT)
			SetAudioOutPoint(rcb->FG,rcb->Min,rcb->Frame);
	}

}

void	DHD_Shuttle(struct RenderCallBack	*rcb)
{
	DUMPMSG("DHD_Shuttle()");
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");
	ESparams1.Data1=(LONG)rcb;
	SetRCBFlags(rcb);
	SendSwitcherReply(ES_Shuttle,&ESparams1);
	rcb->Frame += 1;
	rcb->Frame &= ~0x00000003;
	SetRCBTags(rcb);
	DUMPMSG("Shuttle Back");
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");

	CalcRunningTime();		// Re-calculate sequence total time & put up in access window
}

void	DHD_Jog(struct RenderCallBack	*rcb)
{
//	DUMPMSG("DHD_Jog()");
	DUMPUDECL("DHD_Jog() -- frame starts at ",rcb->Frame,"\\");
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");
	SetRCBFlags(rcb);
	rcb->Flags |= DHD_MOUSE_UPDATE;
	ESparams1.Data1=(LONG)rcb;
	SendSwitcherReply(ES_Jog,&ESparams1);
	DUMPUDECL("JUMP BACK!  frame: ",rcb->Frame,"  ");
	rcb->Frame += 1;
	rcb->Frame &= ~0x00000003;
	rcb->RenderFn(rcb);
	DUMPUDECL("new frame: ",rcb->Frame,"\\");
	SetRCBTags(rcb);
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");

	CalcRunningTime();		// Re-calculate sequence total time & put up in access window
}

void	DHD_Jump(struct RenderCallBack *rcb, BOOL quiet)
{
	DUMPUDECL("DHD_Jump() min: ",rcb->Min,"   ");
	DUMPUDECL("frame: ",rcb->Frame,"  ");
	DUMPUDECL("max: ",rcb->Max,"  \\ ");
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");
	if(rcb->Frame>rcb->Max) rcb->Frame = rcb->Max;
	if(rcb->Frame<rcb->Min) rcb->Frame = rcb->Min;
	rcb->Frame &= ~0x00000003;
	SetRCBFlags(rcb);
	rcb->Flags &= ~DHD_MOUSE_UPDATE;

	ESparams2.Data1=(LONG)rcb->FG;
	ESparams2.Data2=(LONG)rcb->Frame;
	SendSwitcherReply(ES_Jump,&ESparams2);

	rcb->RenderFn(rcb);
	SetRCBTags(rcb);			// Update tags to match new in/out point location
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");

	CalcRunningTime();		// Re-calculate sequence total time & put up in access window

	if (quiet)
		DHD_Quiet(Flds2Frms(rcb->Frame));
}

// All the effects of DHD_Jump (rendering & tags), but Flyer does nothing
void	DHD_JustJump(struct RenderCallBack	*rcb)
{
	DUMPUDECL("DHD_JustJump() min: ",rcb->Min,"   ");
	DUMPUDECL("frame: ",rcb->Frame,"  ");
	DUMPUDECL("max: ",rcb->Max,"  \\ ");
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");
	if(rcb->Frame>rcb->Max) rcb->Frame = rcb->Max;
	if(rcb->Frame<rcb->Min) rcb->Frame = rcb->Min;
	rcb->Frame &= ~0x00000003;
	SetRCBFlags(rcb);
	rcb->Flags &= ~DHD_MOUSE_UPDATE;

	rcb->RenderFn(rcb);
	SetRCBTags(rcb);			// Update tags to match new in/out point location
	DUMPHEXIL("PL->Flags ",rcb->pline->Flags,"\\");

	CalcRunningTime();		// Re-calculate sequence total time & put up in access window
}


ULONG RecordClip(char *ClipName, ULONG RecFields, int FlySource, int CompMode)
{
	ULONG	res=FERR_CMDFAILED;

	CurCompMode = CompMode;
	CurFlySource = FlySource;

	DisplayWaitSprite();
	DHD_InitRecord(0,0xC0DED00D);

	DHD_SetupRecord(CurFlySource,CompMode);

	res = Flyer_Record(ClipName,RecFields);
	if (res == FERR_OKAY)
	{
//DONT DO ANY OF THIS, AS WE SHOULD JUST START THE RECORDING
//WILL NOT RETURN AN ERROR HERE IF FILE ALREADY EXISTS OR SOME SUCH THING
//THESE ERRORS WONT SURFACE UNTIL Flyer_CheckRecord() IS CALLED
//		do {				// Wait for error or complete
//			Delay(50);
//			res = Flyer_CheckRecord();
//		} while (res==FERR_BUSY);
//
//		switch(res)
//		{
//			case FERR_OKAY:
//				DHD_MakeClipIcon(ClipName);
//				break;
//			case FERR_EXISTS:
//			case FERR_EXHAUSTED:
//			default:
//				// Just return error code
//				break;
//		}
	}
	else
	{
		// Drastic failure -- not a normal problem like exists or no volume
		DHD_InitPlay("",0xC0DED00D);
		DisplayNormalSprite();
	}

	return(res);
}

ULONG RecordAppend(char *ClipName, ULONG RecFields, int FlySource, int CompMode)
{
	CurCompMode = CompMode;
	CurFlySource = FlySource;
	DHD_InitRecord(0,0xC0DED00D);
	DHD_SetupRecord(CurFlySource,CompMode);
	if(CurCompMode==AUDIO_COMP_MODE)
	{
		ESparams1.Data1 = 0;
		SendSwitcherReply(ES_RecordSource,&ESparams1);
	}
	ESparams2.Data1=(LONG)ClipName;
	ESparams2.Data2=(LONG)RecFields;
	Delay(5);
	SendSwitcherReply(ES_RecordAppend,&ESparams2);
	DHD_InitPlay("",0xC0DED00D);
	return(1);
}


/* End .... Whew */