/*********************************************************************\
*
* SetFlooby - Sets misc Flyer variables
*
* $Id: setflooby.c,v 1.1 1995/05/23 13:16:20 Flick Exp $
*
* $Log: setflooby.c,v $
*Revision 1.1  1995/05/23  13:16:20  Flick
*Added 0 as a valid item (for debugging)
*
*Revision 1.0  1995/05/05  15:52:50  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	04/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);
void GetLongArg(char *arg,long *var,long lo,long hi,char *label);


struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit,chan,item,value2,value3;
	ULONG	res;
	long	value;

	if ((argc<5)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board> <chan> <item> <value> [value2] [value3]\n",argv[0]);
		printf("\nItems...\n");
		printf("  0) Debug help\n");
		printf("  1) Record Sync Value\n");
		printf("  2) Play Phase (edge,course,fine)\n");
		printf("  3) Rec Phase (edge,course,fine)\n");
		printf("  4) Auto-calibrate PLL controller\n");
		printf("  5) Play Horiz Offset\n");
		printf("  6) Rec Horiz Offset\n");
		printf("  7) ClockFreq (0=DMA,1=Audio,2=Mcoder,3=Pcoder)  value=decimal Hz\n");
		printf("  8) ClockGen (0=DMA/Audio,1=M/Pcoder)\n");
		printf("  A) Exchange w/Genlock uP\n");
		printf("  B) Bar graph type (0-9)\n");
		printf("  C) Set SN,toler bits\n");
		printf("  E) Set LED's\n");
		printf(" 10) Calibrate skew baselines\n");
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	GetArg(argv[2],&chan,0,3,"Channel");
	GetArg(argv[3],&item,0,69,"Item");
	GetLongArg(argv[4],&value,0x80000000,0x7FFFFFFF,"Value");

	if (argc>=6)
		GetArg(argv[5],&value2,0,255,"Value 2");
	else
		value2 = 0;

	if (argc>=7)
		GetArg(argv[6],&value3,0,255,"Value 3");
	else
		value3 = 0;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	switch (item) {
	case 2:
		if (chan==0) {
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_EDGE,value,0);
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_COURSE,value2,0);
			res = FlyerWriteCalib(0,CALIB_DACA_PHASE_FINE,value3,0);
		}
		else {
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_EDGE,value,0);
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_COURSE,value2,0);
			res = FlyerWriteCalib(0,CALIB_DACB_PHASE_FINE,value3,0);
		}
		break;
	case 3:
		res = FlyerWriteCalib(0,CALIB_ADC_PHASE_EDGE,value,0);
		res = FlyerWriteCalib(0,CALIB_ADC_PHASE_COURSE,value2,0);
		res = FlyerWriteCalib(0,CALIB_ADC_PHASE_FINE,value3,0);
		break;
	case 5:
		if (chan==0)
			res = FlyerWriteCalib(0,CALIB_HPLAYOFFSETA,value,0);
		else
			res = FlyerWriteCalib(0,CALIB_HPLAYOFFSETB,value,0);
		break;
	case 6:
		res = FlyerWriteCalib(0,CALIB_HRECOFFSETA,value,0);
		break;
	case 7:
		stcd_l(argv[4],&value);
		res = SetFlooby(unit,chan,item,value);
		break;
	default:
		res = SetFlooby(unit,chan,item,value);
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

void GetLongArg(char *arg,long *var,long lo,long hi,char *label)
{
	stch_l(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
