***********************************************************************
*
* TestLib - Test: calling flyer.library from assembly
*
* $Id: testlib.asm,v 1.1 1995/05/08 10:02:17 Flick Exp $
*
* $Log: testlib.asm,v $
*Revision 1.1  1995/05/08  10:02:17  Flick
*Removed assembler.i include
*
*Revision 1.0  1995/05/05  15:53:33  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/22/94		Marty	created
***********************************************************************

	include "exec/types.i"
	include "exec/nodes.i"
	include "exec/lists.i"
	include "exec/libraries.i"
	include "dos/dos.i"

	include "asmsupp.i"
	include "macros.i"
	include "Flyer.i"
	include "Flyerlib.i"
	include "FlyerPrivate.i"
	include "serialdebug.i"

Start	movem.l	d0-d7/a0-a6,-(sp)
	move.l	(_AbsExecBase).w,a6
	lea.l	FlyerName(pc),a1
	CLEAR	d0
	XSYS	OpenLibrary		;Open flyer.library
	tst.l	d0			;Succeeded?
	beq	.flyfail
	move.l	d0,a6

	bsr	LoadRegStuff
	bsr	TestDebug
	DUMPREG <After DebugMode>

;	bsr	LoadRegStuff
;	bsr	TestScsiInit
;	DUMPREG <After SCSIinit>

;	bsr	LoadRegStuff
;	bsr	TestToasterMux
;	DUMPREG <After ToasterMux>

;	bsr	LoadRegStuff
;	bsr	TestInputSel
;	DUMPREG <After InputSelect>

;	bsr	LoadRegStuff
;	bsr	TestTermination
;	DUMPREG <After FlyerTerm>

;	bsr	LoadRegStuff
;	bsr	TestPlayMode
;	DUMPREG <After PlayMode>

;	bsr	LoadRegStuff
;	bsr	TestStartHeadList
;	DUMPREG <After StartHeadList>

;	bsr	LoadRegStuff
;	bsr	TestEndHeadList
;	DUMPREG <After EndHeadList>

;	bsr	LoadRegStuff
;	bsr	TestRecMode
;	DUMPREG <After RecMode>

	move.l	a6,a1
	move.l	(_AbsExecBase).w,a6
	XSYS	CloseLibrary		;Close flyer.library
.flyfail
	movem.l	(sp)+,d0-d7/a0-a6
	rts



;----------------------------------------------
TestDebug
	move.l	#$ABADABBA,d0		;Unit
	move.l	#$80006,d1	;Flags
	XSYS	DebugMode
	rts

TestScsiInit
	lea.l	FlyVol(pc),a0
	clr.l	fv_Path(a0)
	clr.b	fv_Board(a0)
	clr.b	fv_SCSIdrive(a0)
	XSYS	SCSIinit
	rts

TestToasterMux
	CLEAR	d0		;board
	moveq.l	#1,d1		;Input 3
	moveq.l	#1,d2		;Input 4
	CLEAR	d3		;Preview
	XSYS	ToasterMux
	rts

TestInputSel
	CLEAR	d0		;board
	moveq.l	#FI_Toaster1,d1	;Input 1
	moveq.l	#FS_Toaster1,d2	;Input 1 sync
	XSYS	FlyerInputSel
	rts

TestTermination
	CLEAR	d0		;board
	moveq.l	#6,d1		;Term 3&4 only
	XSYS	FlyerTermination
	rts

TestPlayMode
	CLEAR	d0		;board
	XSYS	PlayMode
	rts

TestRecMode
	CLEAR	d0		;board
	XSYS	RecordMode
	rts

TestStartHeadList
	CLEAR	d0		;board
	XSYS	StartHeadList
	rts

TestEndHeadList
	CLEAR	d0		;board
	moveq.l	#1,d1		;Do it!
	XSYS	EndHeadList
	rts

*********************************************************************

LoadRegStuff
	move.l	#$88888888,d0
	move.l	#$11111111,d1
	move.l	#$22222222,d2
	move.l	#$33333333,d3
	move.l	#$44444444,d4
	move.l	#$55555555,d5
	move.l	#$66666666,d6
	move.l	#$77777777,d7

	move.l	#$88888888,a0
	move.l	#$11111111,a1
	move.l	#$22222222,a2
	move.l	#$33333333,a3
	move.l	#$44444444,a4
	move.l	#$55555555,a5
	rts


	RDUMP

FlyVol		dc.b	FV_sizeof

FlyerName	dc.b	'flyer.library',0
