/*********************************************************************\
*
* FlyerFS.h - FlyerFileSystem include file
*
* $Id: flyerfs.h,v 1.1 1995/08/11 12:45:51 Flick Exp $
*
* $Log: flyerfs.h,v $
*Revision 1.1  1995/08/11  12:45:51  Flick
*Reworked FileSys quite a bit
*
*Revision 1.0  1995/05/05  15:45:09  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty		Created
\*********************************************************************/


#define	ID_DISK_BUSY			(0x42555359L)	// 'BUSY'
#define	ID_FLYER_DISK			(0x464C5900L)	// 'FLY\0'
//#define	PATHMAXSIZE				128
#define	VOLNAMEMAXSIZE			31
#define	FILENAMEMAXSIZE		31

#define	FLYER_MIN_VER			0			// Minimum library version

#define	FLYER_TYPE_FILE		1
#define	FLYER_TYPE_DIR			2

#define	FLYER_MODE_INPUT		1
#define	FLYER_MODE_OUTPUT		2
#define	FLYER_MODE_UPDATE		3

#define	FLYER_POS_BEGIN		0
#define	FLYER_POS_CURRENT		1
#define	FLYER_POS_END			2

#define	FLYER_ACC_SHARED		SHARED_LOCK
#define	FLYER_ACC_EXCLUSIVE	EXCLUSIVE_LOCK

enum { FLYST_OKAY, FLYST_WAIT, FLYST_NONE };


struct	timepkt {
	APTR	Link;
	APTR	Port;
	LONG	Action;
};

// This forces Flyer.lib pragmas to find Base in my FS structure
#define	FlyerBase	FS->FlyBase

struct FSbase {
	APTR		SpookedPad;
	struct	Library		*FlyBase;
	struct	Process		*myProcess;
	struct	MsgPort		*myMsgPort;
	struct	DosPacket	*DosPkt;
	ULONG		ID;
	BPTR		myVolume;
	int		OSversion;
	int		TimerErr;
	struct	timerequest	IntervalTimer,ClockTime;
	struct	MsgPort		ClockReplyPort;
	struct	BufNode		**FastHash;
	UBYTE		*FragBuffer;
	struct	BufNode		*IdleBuffers;
	int		IEerr;
	struct	MsgPort		*IEReply;
	struct	IOStdReq		*IEIO;
	struct	timepkt		TimerPkt;
	BPTR		MasterLockList;
	struct	FlyerVolInfo	FSinfo;
	struct	FlyerVolume		FlyVol;
	struct	ClipAction		ClipAct;

/* Stuff to handle logical blocks sizes other than 512 */
	UBYTE		LogBlkShift;

	UBYTE		FlyerDrive;		// Currently, used just for debugging

	LONG		DOSerror;
	ULONG		SoftErrCnt;
	UBYTE		Inhibited;
	UBYTE		DiskLoaded;
	UBYTE		FlyerState;			// State of Flyer/software
	struct	IntuitionBase	*IntuitionBase;

//	char		cname[PATHMAXSIZE+10];	// Misc buffers for paths
//	char		cname2[PATHMAXSIZE+10];	// Misc buffers for paths

/* Removed */

//	struct	FileOpen		*myFileOpen;

/*** Intuition stuff ***/
	struct IntuiText ReadWriteText;
	struct IntuiText DupeVolText,DupeVol2Text;

#if 0
---- UNUSED --------- UNUSED ----------- UNUSED -----------------


	struct	WorkbenchBase	*WorkbenchBase;
#endif
};


struct LongLock {
	BPTR		ll_Link;				// bcpl pointer to next lock
	LONG		ll_Key;				// disk block number
	LONG		ll_Access;			// exclusive or shared
	struct MsgPort *ll_Task;	// handler task's port
	BPTR		ll_Volume;			// bptr to DLT_VOLUME DosList entry
	ULONG		ll_Grip;				// Flyer private structure
};


struct	FileOpen {
	ULONG	FileID;				// Flyer File id
	BPTR	Volume;				// Volume that contains file
	BPTR	Lock;					// Lock on file
	UBYTE	wrote;				// Flag: wrote to file, needs date set
	UBYTE	pad;
};


typedef void (*PktFunc)(struct FSbase *);

// (ULONG) vs. DOS' (LONG)
#define MAKEBADDR(x)	(((ULONG)(x)) >> 2)
