#include "dos/dos.h"

/****** Library Operations ******/
ULONG	AbortCmd(ULONG id);
ULONG	CheckCmd(ULONG id);
ULONG	WaitAction(struct ClipAction *action);
ULONG	CheckAction(struct ClipAction *action);
ULONG	AbortAction(struct ClipAction *action);
char	*Error2String(UBYTE error);

/****** Setup ******/
ULONG	InitFlyers(BPTR lock);
ULONG	Firmware(UBYTE board,ULONG length,APTR data,ULONG offset);
ULONG	RunModule(UBYTE board,ULONG length,APTR data,ULONG *ID,
	UWORD argc,ULONG *argv);
ULONG	PgmFPGA(UBYTE board,UBYTE chipnum,ULONG length,APTR data,
	UBYTE revision);
ULONG	SBusWrite(UBYTE board,UBYTE addr,UBYTE data);
ULONG	SBusRead(UBYTE board,UBYTE addr,UBYTE *data);
ULONG	FIRinit(UBYTE board,UWORD reg0,UWORD reg1);
ULONG	FIRcustom(UBYTE board,UBYTE prepost,UWORD scale,UWORD *coefdata);
ULONG	FIRmapRAM(UBYTE board,UBYTE bank,UBYTE scale,UBYTE shape);
ULONG	DSPboot(UBYTE board,ULONG length,APTR dataptr);
ULONG	GetFieldClock(ULONG *clockptr);
ULONG	FlyerQuit(int unit);
ULONG	PlayMode(UBYTE board);
ULONG	RecordMode(UBYTE board);

/****** Video Operations ******/
ULONG	FlyerPlay(struct ClipAction *clip);
ULONG	FlyerRecord(struct ClipAction *clip);
ULONG	ChangeAudio(struct ClipAction *clip);
ULONG	StartHeadList(UBYTE board);
ULONG	EndHeadList(UBYTE board,UBYTE flag);
ULONG	MakeClipHead(struct ClipAction *clip);
ULONG	VoidClipHead(struct ClipAction *clip);
ULONG	VoidCardHeads(UBYTE board);
ULONG	VoidAllHeads(void);
ULONG	AudioParams(void);
ULONG	BeginFindField(struct ClipAction *clip);
ULONG	DoFindField(struct ClipAction *clip);
ULONG	EndFindField(struct ClipAction *clip);
ULONG	FindFieldAudio(struct ClipAction *clip);
ULONG	GetSMPTE(UBYTE board,struct SMPTEinfo *info);

/****** Mode and Misc Operations ******/
ULONG	VideoParams(UBYTE board,UBYTE vidchan,UBYTE mintol,UBYTE maxtol,
	UBYTE rndfreq,UWORD vidlen,UBYTE FIRset,UBYTE special);
ULONG	StillMode(UBYTE board,UBYTE vidchan,UBYTE mode);
ULONG	SetPlayMode(UBYTE board);
ULONG	SetRecMode(UBYTE board);
ULONG	SetNoMode(UBYTE board);
ULONG	ToasterMux(UBYTE board,UBYTE input3,UBYTE input4,UBYTE preview);
ULONG	FlyerInputSel(UBYTE board,UBYTE video,UBYTE sync);
ULONG	FlyerTermination(UBYTE board,UBYTE flags);
ULONG	SetFlooby(UBYTE board,UBYTE chan,UBYTE item,ULONG value);
void	Defaults(struct ClipAction *clip);

/****** Direct Field Access ******/
ULONG	OpenReadField(struct ClipAction *action,ULONG field,UBYTE mode);
ULONG	OpenWriteField(struct ClipAction *action,ULONG field,UBYTE mode,struct VidCompInfo *);
ULONG	CloseField(struct ClipAction *action);
ULONG	FlyerReadLine(struct ClipAction *action,UBYTE *buffer);
ULONG	FlyerWriteLine(struct ClipAction *action,UBYTE *buffer);
ULONG	SetFillColor(struct ClipAction *action);
ULONG	SkipLines(struct ClipAction *action,UWORD lines);

/****** SCSI Operations ******/
ULONG	SCSIreset(UBYTE board);
ULONG	SCSIinit(struct FlyerVolume *volume);
ULONG	FindDrives(struct FlyerVolume *volume,APTR buffer);
ULONG	CopyData(struct FlyerVolume *src,struct FlyerVolume *dest,
	ULONG srcaddr,ULONG blocks,ULONG destaddr);
ULONG	ReqSense(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer);
ULONG	Inquiry(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer);
ULONG	ModeSelect(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer,UBYTE PFbyte);
ULONG	ModeSense(struct FlyerVolume *volume,UBYTE bufsize,UBYTE page,APTR buffer);
ULONG	ReadSize(struct FlyerVolume *volume,ULONG *countptr,ULONG *lenptr);
ULONG	Read10(struct ClipAction *action,WORD blocks,ULONG lba,ULONG buffer);
ULONG	Write10(struct ClipAction *action,WORD blocks,ULONG buffer,ULONG lba);
ULONG	SCSIseek(struct FlyerVolume *volume,ULONG lba);
ULONG	FlyerSCSIdirect(UBYTE board,UBYTE unit,struct SCSICmd *scsiinfo,
	UBYTE structlen);

/****** FileSystem Interface ******/
ULONG	FlyerDriveCheck(struct FlyerVolume *vol);
ULONG	FlyerDriveInfo(struct FlyerVolume *vol,struct FlyerVolInfo *volume);
ULONG	FlyerLocate(struct ClipAction *clip);
ULONG	FlyerFileInfo(struct FlyerVolume *volume,struct ClipInfo *clipinfo);
ULONG	FlyerFreeGrip(struct FlyerVolume *volume,ULONG grip);
ULONG	FlyerCopyGrip(struct FlyerVolume *volume,ULONG grip,ULONG *newgrip);
ULONG	FlyerCmpGrips(struct FlyerVolume *volume,ULONG grip1,ULONG grip2);
ULONG	FlyerParent(struct FlyerVolume *volume,ULONG grip,ULONG *newgrip,ULONG *blockptr);
ULONG	FlyerExamine(struct FlyerVolume *volume,ULONG grip,struct ClipInfo *clipinfo);
ULONG	FlyerDirList(struct FlyerVolume *volume,ULONG grip,struct ClipInfo *clipinfo,
	UBYTE firstflag,UBYTE fsonlyflag);
ULONG	FlyerFileOpen(struct ClipAction *clip);
ULONG	FlyerFileClose(struct FlyerVolume *volume,ULONG fileid);
ULONG	FlyerFileSeek(struct FlyerVolume *volume,ULONG fileid,LONG pos_ext, LONG pos,UBYTE mode,
	struct DLONG	*newpos,struct DLONG *oldpos);
ULONG	FlyerFileRead(struct FlyerVolume *volume,ULONG fileid,ULONG size,UBYTE *buffer,
	ULONG *actual);
ULONG	FlyerFileWrite(struct FlyerVolume *volume,ULONG fileid,ULONG size,UBYTE *buffer,
	ULONG *actual);
ULONG	FlyerCreateDir(struct ClipAction *clip);
ULONG	FlyerDelete(struct ClipAction *clip);
ULONG	FlyerRename(struct ClipAction *old,ULONG newgrip,char *newname);
ULONG	FlyerRenameDisk(struct FlyerVolume *volume,char *newname);
ULONG	FlyerFormat(struct FlyerVolume *volume,char *name,struct DateStamp *date,
	ULONG blocks,UBYTE flags);
ULONG	FlyerDeFrag(struct FlyerVolume *volume);
ULONG	FlyerSetBits(struct FlyerVolume *volume,ULONG grip,ULONG bits);
ULONG	FlyerSetDate(struct FlyerVolume *volume,ULONG grip,
	ULONG days,ULONG mins,ULONG ticks);
ULONG	FlyerSetComment(struct FlyerVolume *volume,ULONG grip,char *comment);
ULONG	FlyerWriteProt(struct FlyerVolume *volume,UBYTE value,UBYTE setflag,
	UBYTE *checkval);
ULONG	FlyerChangeMode(struct FlyerVolume *volume,ULONG grip,UBYTE access);
ULONG	MakeFlyerFile(struct FlyerVolume *volume,ULONG size,ULONG *startptr);
ULONG	GetClipInfo(struct FlyerVolume *volume,struct ClipInfo *clipinfo);
ULONG	FlyerCopyClip(struct FlyerVolume *srcvolume,struct FlyerVolume *destvolume);

/****** Flyer Testing ******/
ULONG	CPUwrite(UBYTE board,ULONG addr,UWORD data);
ULONG	CPUread(UBYTE board,ULONG addr,UWORD *data);
ULONG	CPUDMA(UBYTE board,ULONG cpuptr,ULONG dmaptr,UWORD length,UBYTE readflag);
ULONG	DebugMode(int unit,ULONG flags);
ULONG	ReadTest(struct FlyerVolume *volume,ULONG blocks,ULONG repeat,ULONG lba,
	UBYTE dblflag);
ULONG	WriteTest(struct FlyerVolume *volume,ULONG blocks,ULONG repeat,ULONG lba,
	UBYTE dblflag);

/****** Misc stuff ******/
ULONG	SetFlyerTime(struct DateStamp *datestamp);
ULONG	FlyerStripAudio(struct FlyerVolume *srcvolume,struct FlyerVolume *destvolume);
ULONG	FlyerWriteCalib(UBYTE board,UWORD item,WORD value,UBYTE saveflag);
ULONG	FlyerReadCalib(UBYTE board,UWORD item,WORD *valueptr);
ULONG	WriteEEreg(UBYTE board,UBYTE addr,UWORD data);
ULONG	ReadEEreg(UBYTE board,UBYTE addr,UWORD *dataptr);
ULONG	ResetFlyer(UBYTE board,ULONG flags);
ULONG	SetClockGen(UBYTE board,UBYTE clock,ULONG speed);
ULONG	TeachFPGA(UBYTE chipnum,ULONG length,APTR data);
ULONG	FlyerRunning(UBYTE board);
ULONG	FlyerLoadVideo(UBYTE board,APTR data,ULONG size);
ULONG	SetSerDevice(UBYTE board,UBYTE port,UBYTE type,UBYTE device);
ULONG	FlyerSelfTest(UBYTE board,UBYTE test,ULONG arg1,ULONG arg2,ULONG *result);
ULONG	VideoCompressModes(UBYTE board,UBYTE bestmode,UBYTE worstmode,
	UBYTE strategy);
ULONG	FIRquery(UBYTE board,UBYTE coefset,UBYTE prepost,UWORD *scale,UWORD *coefdata);
ULONG	GetClrSeqError(UBYTE board,UBYTE flag,UBYTE *doneptr,ULONG *userIDptr,ULONG *moreinfoptr);
APTR	LockFlyVolList(void);
ULONG	UnLockFlyVolList(APTR list);

/****** New for 4.0 ******/
ULONG	TBCcontrol(UBYTE board,struct TBCctrl *ptr,UBYTE oper);
ULONG	PauseAction(struct ClipAction *action,UBYTE pauseflag);
ULONG	StartClipCutList(struct ClipAction *clip,UBYTE flags);
ULONG	AddClipCut(struct ClipAction *subclip);
ULONG	EndClipCutList(UBYTE doit);
ULONG	EasyOpenWriteField(struct ClipAction *action,ULONG field,UBYTE mode,
	UBYTE quality);
ULONG	FlyerAudioCtrl(UBYTE board,struct FlyAudCtrl *ptr,UBYTE oper);
ULONG	AppendFields(struct ClipAction *action);

/****** New for 4.05 ******/
ULONG	NewSequence(UBYTE board);
ULONG	AddSeqClip(struct ClipAction *clip);
ULONG	EndSequence(UBYTE board,UBYTE doit);
ULONG	PlaySequence(UBYTE board,ULONG basetime);
ULONG	FlyerOptions(UBYTE board,UBYTE setflag,ULONG *options);
ULONG	LocateField(struct ClipAction *clip);
ULONG	CacheTest(UBYTE board);

/****** New for 4.1 ******/
ULONG	FlyerCopyClipNew(struct ClipAction *srcaction,struct FlyerVolume *destvolume);
ULONG	EndSequenceNew(struct ClipAction *action,UBYTE doit);
ULONG	FlyerDeFragNew(struct ClipAction *action);
ULONG	GetFrameHeader(struct ClipAction *action,APTR buffer);
ULONG	PutFrameHeader(struct ClipAction *action,APTR buffer);
/****** New for 4.1 ******/
ULONG	AddAudEKey(struct AudioEKey *AEK);
ULONG	AddAudEnv(struct AudioEnv TheAudioEnv);
ULONG	InitFlyerForce(BPTR lock, ULONG id);
ULONG	FlyerFileExtend(struct FlyerVolume *volume,ULONG fileid,ULONG size);
/*------ Library Operations --------------------------------------------*/
#pragma libcall FlyerBase AbortCmd 1e 001
#pragma libcall FlyerBase CheckCmd 24 001
#pragma libcall FlyerBase WaitAction 2a 801
#pragma libcall FlyerBase CheckAction 30 801
#pragma libcall FlyerBase AbortAction 36 801
#pragma libcall FlyerBase Error2String 3c 001
/*------ Setup -------------------------------------------------------*/
#pragma libcall FlyerBase InitFlyers 42 001
#pragma libcall FlyerBase Firmware 48 281004
#pragma libcall FlyerBase RunModule 4e A2981006
#pragma libcall FlyerBase PgmFPGA 54 3821005
#pragma libcall FlyerBase SBusWrite 5a 21003
#pragma libcall FlyerBase SBusRead 60 81003
#pragma libcall FlyerBase FIRinit 66 21003
#pragma libcall FlyerBase FIRcustom 6c 821004
#pragma libcall FlyerBase FIRmapRAM 72 321004
#pragma libcall FlyerBase DSPboot 78 81003
#pragma libcall FlyerBase GetFieldClock 7e 801
#pragma libcall FlyerBase FlyerQuit 84 001
#pragma libcall FlyerBase PlayMode 8a 001
#pragma libcall FlyerBase RecordMode 90 001
/*------ Video/Audio Operations --------------------------------------------*/
#pragma libcall FlyerBase FlyerPlay 96 801
#pragma libcall FlyerBase FlyerRecord 9c 801
#pragma libcall FlyerBase ChangeAudio a2 801
#pragma libcall FlyerBase StartHeadList a8 001
#pragma libcall FlyerBase EndHeadList ae 1002
#pragma libcall FlyerBase MakeClipHead b4 801
#pragma libcall FlyerBase VoidClipHead ba 801
#pragma libcall FlyerBase VoidCardHeads c0 001
#pragma libcall FlyerBase VoidAllHeads c6 0
#pragma libcall FlyerBase AudioParams cc 0
#pragma libcall FlyerBase BeginFindField d2 801
#pragma libcall FlyerBase DoFindField d8 801
#pragma libcall FlyerBase EndFindField de 801
#pragma libcall FlyerBase FindFieldAudio e4 801
#pragma libcall FlyerBase GetSMPTE ea 8002
/*------ Mode and Misc Operations -----------------------------------------*/
#pragma libcall FlyerBase VideoParams f0 7654321008
#pragma libcall FlyerBase StillMode f6 21003
#pragma libcall FlyerBase SetPlayMode fc 001
#pragma libcall FlyerBase SetRecMode 102 001
#pragma libcall FlyerBase SetNoMode 108 001
#pragma libcall FlyerBase ToasterMux 10e 321004
#pragma libcall FlyerBase FlyerInputSel 114 21003
#pragma libcall FlyerBase FlyerTermination 11a 1002
#pragma libcall FlyerBase SetFlooby 120 321004
#pragma libcall FlyerBase Defaults 126 801
/*------------ Direct Field Access -----------**/
#pragma libcall FlyerBase OpenReadField 12c 10803
#pragma libcall FlyerBase OpenWriteField 132 910804
#pragma libcall FlyerBase CloseField 138 801
#pragma libcall FlyerBase FlyerReadLine 13e 9802
#pragma libcall FlyerBase FlyerWriteLine 144 9802
#pragma libcall FlyerBase SetFillColor 14a 801
#pragma libcall FlyerBase SkipLines 150 0802
/*------ SCSI Operations ---------------------------------------------*/
#pragma libcall FlyerBase SCSIreset 156 001
#pragma libcall FlyerBase SCSIinit 15c 801
#pragma libcall FlyerBase FindDrives 162 9802
#pragma libcall FlyerBase CopyData 168 2109805
#pragma libcall FlyerBase ReqSense 16e 90803
#pragma libcall FlyerBase Inquiry 174 90803
#pragma libcall FlyerBase ModeSelect 17a 190804
#pragma libcall FlyerBase ModeSense 180 910804
#pragma libcall FlyerBase ReadSize 186 A9803
#pragma libcall FlyerBase Read10 18c 210804
#pragma libcall FlyerBase Write10 192 210804
#pragma libcall FlyerBase SCSIseek 198 0802
#pragma libcall FlyerBase FlyerSCSIdirect 19e 281004
/*------ FileSystem Interface ----------------------------------------*/
#pragma libcall FlyerBase FlyerDriveCheck 1a4 801
#pragma libcall FlyerBase FlyerDriveInfo 1aa 9802
#pragma libcall FlyerBase FlyerLocate 1b0 801
#pragma libcall FlyerBase FlyerFileInfo 1b6 9802
#pragma libcall FlyerBase FlyerFreeGrip 1bc 0802
#pragma libcall FlyerBase FlyerCopyGrip 1c2 90803
#pragma libcall FlyerBase FlyerCmpGrips 1c8 10803
#pragma libcall FlyerBase FlyerParent 1ce A90804
#pragma libcall FlyerBase FlyerExamine 1d4 90803
#pragma libcall FlyerBase FlyerDirList 1da 2190805
#pragma libcall FlyerBase FlyerFileOpen 1e0 801
#pragma libcall FlyerBase FlyerFileClose 1e6 0802
#pragma libcall FlyerBase FlyerFileSeek 1ec A93210807
#pragma libcall FlyerBase FlyerFileRead 1f2 A910805
#pragma libcall FlyerBase FlyerFileWrite 1f8 A910805
#pragma libcall FlyerBase FlyerCreateDir 1fe 801
#pragma libcall FlyerBase FlyerDelete 204 801
#pragma libcall FlyerBase FlyerRename 20a 90803
#pragma libcall FlyerBase FlyerRenameDisk 210 9802
#pragma libcall FlyerBase FlyerFormat 216 10A9805
#pragma libcall FlyerBase FlyerDeFrag 21c 801
#pragma libcall FlyerBase FlyerSetBits 222 10803
#pragma libcall FlyerBase FlyerSetDate 228 3210805
#pragma libcall FlyerBase FlyerSetComment 22e 90803
#pragma libcall FlyerBase FlyerWriteProt 234 910804
#pragma libcall FlyerBase FlyerChangeMode 23a 10803
#pragma libcall FlyerBase MakeFlyerFile 240 90803
#pragma libcall FlyerBase GetClipInfo 246 9802
#pragma libcall FlyerBase FlyerCopyClip 24c 9802
/*------ Flyer Testing -------------------------------------------------*/
#pragma libcall FlyerBase CPUwrite 252 18003
#pragma libcall FlyerBase CPUread 258 98003
#pragma libcall FlyerBase CPUDMA 25e 2198005
#pragma libcall FlyerBase DebugMode 264 1002
#pragma libcall FlyerBase ReadTest 26a 3210805
#pragma libcall FlyerBase WriteTest 270 3210805
/*------------ Misc stuff ----------------*/
#pragma libcall FlyerBase SetFlyerTime 276 801
#pragma libcall FlyerBase FlyerStripAudio 27c 9802
#pragma libcall FlyerBase FlyerWriteCalib 282 321004
#pragma libcall FlyerBase FlyerReadCalib 288 81003
#pragma libcall FlyerBase WriteEEreg 28e 21003
#pragma libcall FlyerBase ReadEEreg 294 81003
#pragma libcall FlyerBase ResetFlyer 29a 1002
#pragma libcall FlyerBase SetClockGen 2a0 21003
#pragma libcall FlyerBase TeachFPGA 2a6 81003
#pragma libcall FlyerBase FlyerRunning 2ac 001
#pragma libcall FlyerBase FlyerLoadVideo 2b2 18003
#pragma libcall FlyerBase SetSerDevice 2b8 321004
#pragma libcall FlyerBase FlyerSelfTest 2be 8321005
#pragma libcall FlyerBase VideoCompressModes 2c4 321004
#pragma libcall FlyerBase FIRquery 2ca 9821005
#pragma libcall FlyerBase GetClrSeqError 2d0 A981005
#pragma libcall FlyerBase LockFlyVolList 2d6 0
#pragma libcall FlyerBase UnLockFlyVolList 2dc 801
/*------------ New for 4.0 ----------------*/
#pragma libcall FlyerBase TBCcontrol 2e2 18003
#pragma libcall FlyerBase PauseAction 2e8 0802
#pragma libcall FlyerBase StartClipCutList 2ee 0802
#pragma libcall FlyerBase AddClipCut 2f4 801
#pragma libcall FlyerBase EndClipCutList 2fa 001
#pragma libcall FlyerBase EasyOpenWriteField 300 210804
#pragma libcall FlyerBase FlyerAudioCtrl 306 18003
#pragma libcall FlyerBase AppendFields 30c 801
/*------------ New for 4.05 ----------------*/
#pragma libcall FlyerBase NewSequence 312 001
#pragma libcall FlyerBase AddSeqClip 318 801
#pragma libcall FlyerBase EndSequence 31e 1002
#pragma libcall FlyerBase PlaySequence 324 1002
#pragma libcall FlyerBase FlyerOptions 32a 81003
#pragma libcall FlyerBase LocateField 330 801
#pragma libcall FlyerBase CacheTest 336 001
/*------------ New for 4.1 ----------------*/
#pragma libcall FlyerBase FlyerCopyClipNew 33c 9802
#pragma libcall FlyerBase EndSequenceNew 342 0802
#pragma libcall FlyerBase FlyerDeFragNew 348 801
#pragma libcall FlyerBase GetFrameHeader 34e 9802
#pragma libcall FlyerBase PutFrameHeader 354 9802
/*------------ New for 4.2 ----------------*/
#pragma libcall FlyerBase AddAudEKey 35a 801
#pragma libcall FlyerBase AddAudEnv 360 8002
#pragma libcall FlyerBase InitFlyerForce 366 5002
#pragma libcall FlyerBase FlyerFileExtend 36c 10803
#pragma libcall FlyerBase FlyerFileHSRead 372 9210805
#pragma libcall FlyerBase FlyerFileHSWrite 378 9210805
#pragma libcall FlyerBase FlyerNewFileRead 37e A910805
#pragma libcall FlyerBase FlyerNewFileWrite 384 A910805
