*********************************************************************
*
* FlyerPrivate.i - Flyer include file (private information)
*
* $Id: flyerprivate.i,v 1.15 1997/05/14 11:41:02 Holt Exp $
*
* $Log: flyerprivate.i,v $
*Revision 1.15  1997/05/14  11:41:02  Holt
*no real changes.
*
*Revision 1.14  1997/04/18  16:53:10  Holt
**** empty log message ***
*
*Revision 1.13  1997/03/26  16:42:32  Holt
**** empty log message ***
*
*Revision 1.12  1996/12/19  18:12:44  Holt
**** empty log message ***
*
*Revision 1.11  1996/12/19  18:07:05  Holt
*added FileExtend funtion that extends a file without writing data to it.
*
*Revision 1.10  1996/11/13  19:06:40  Hayes
*added FlyerDatChunk structure
*
*Revision 1.9  96/11/12  15:33:05  Holt
**** empty log message ***
*
*Revision 1.8  1996/08/13  15:31:30  Holt
*added support for HQ6 mode.
*
*Revision 1.7  1996/06/25  17:20:32  Holt
*made many changes to support audio envelopes
*/.
*
*Revision 1.6  1996/04/29  10:39:37  Holt
**** empty log message ***
*
*Revision 1.5  1995/08/25  15:28:15  Flick
*Added new VTASC private fields for CPU type, user modes, and '020 support
*
*Revision 1.4  1995/08/11  12:53:04  Flick
*Expanded SharedCtrl structure, added size limit "reserves" in it & Guru struct
*
*Revision 1.3  1995/08/04  10:52:45  Flick
*Ready to support NEWMEMALLOC code (for alloc/dealloc'ing SRAM)
*Added FLB_CACHED for systems that need anti-cache code
*
*Revision 1.2  1995/06/19  17:56:41  Flick
*Moved VTASC SRAM down just below program (ouch!)
*
*Revision 1.1  1995/05/08  15:48:58  Flick
*Reduced SRAM top, reduced #cmds to 8
*
*Revision 1.0  1995/05/05  15:45:31  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty		Created
*********************************************************************

	IFND	INC_FLYERPRIV_I
INC_FLYERPRIV_I	SET	1

**
**	Include file for flyer.library and other priveliged users
**
**	(c) Copyright 1994 NewTek, Inc.
**	    All Rights Reserved
**

*** General Flyer constants ***

FLYER_PRI	EQU	0
MAX_FLYER_CARDS	EQU	4
MAX_FLYER_CMDS	EQU	8
FLYER_CMD_LEN	EQU	32
MAX_POOL_FRAGS	EQU	(MAX_FLYER_CMDS+4)
LOGBLK_SIZE	EQU	512

*** Board Auto-Config ID Numbers ***

NEWTEK_ID	EQU	2191
FLYER_ID	EQU	0


*** Flyer SRAM offset addresses ***

FLYERGURU	EQU	$00400		;Flyer trap meditation numbers
SHAREDCTRL	EQU	$00480		;Disk change counters, etc.
CMDBASE		EQU	$00500
SHAREDTOP	EQU	$0F000		;Leave room for Flyer's stuff
PROGAREA	EQU	$18000
SRAMSIZE	EQU	$40000

VTASCDRAM	EQU	$1FFE		;DRAM blocks reserved for VTASC
VTASCSRAM	EQU	$BE		;SRAM blocks reserved for VTASC
VTASCSRAMADDR	EQU	$17C00		;Offset address of SRAM blocks for VTASC

*** Data Sizes for Video Quality Modes ***
VIDSIZE_0	EQU	$7A ;$70+A	;"IBM" standard drives -- 3.75 MB/sec
VIDSIZE_1	EQU	$9C ;$92+A	;Improved drives -- 5 MB/sec
VIDSIZE_2	EQU	$BC ;$B2+A	;Improved drives -- 5 MB/sec

*** Flyer trap meditation structure ***

    STRUCTURE FlyerGuru,0
	UWORD	fg_Dead		;=$DEAD if hung
	UBYTE	fg_Trap		;68000 trap number
	UBYTE	fg_Version	;EPROM version
	ULONG	fg_PC		;PC near exception
	UWORD	fg_SR		;SR register
	ULONG	fg_SSP		;SSP register
	STRUCT	fg_Regs,15*4	;Registers
	STRUCT  fg_reserved,54	;Don't exceed this!
	LABEL	FG_Sizeof


*** Amiga/Flyer shared control structure ***

    STRUCTURE SharedCtrl,0
	UBYTE	sc_SeqError	;Sequencing error code
	UBYTE	sc_Done		;Finished (1=TRUE)
	ULONG	sc_UserID	;ID of sequence event that failed
	ULONG	sc_MoreInfo	;i.e. dropped fields/fields late
	STRUCT  sc_reserved,118	;Don't exceed this!
	LABEL	SC_Sizeof


*** Opcode Status Bits ***

STATMASK	EQU	$C000
STAT_BLANK	EQU	$0000
STAT_NEW	EQU	$4000
STAT_INPROG	EQU	$8000
STAT_DONE	EQU	$C000


*** A structure to define each free chunk of SRAM memory ***

    STRUCTURE FreeChunk,0
	ULONG	fc_Start	;Pointer to start of this SRAM chunk
	ULONG	fc_Size		;Length of this SRAM chunk
	LABEL	FC_Sizeof


*** Control structure for each SRAM command slot for each card ***

    STRUCTURE FlyerCmd,0	;Usually in a4
	UBYTE	cmd_RetTime	;Return time (synchronicity)
	UBYTE	cmd_Majic	;For authenticity check
	ULONG	cmd_Dataptr1	;Ptr to data allocated from SRAM for command
	ULONG	cmd_Datalen1	;Length of SRAM data allocated for command
	ULONG	cmd_Dataptr2	;Ptr to data allocated from SRAM for command
	ULONG	cmd_Datalen2	;Length of SRAM data allocated for command
	APTR	cmd_FollowUp	;Vector to routine to call when command done
	ULONG	cmd_CopySrc	;SRAM (src) ptr for follow-up copy
	ULONG	cmd_CopyDest	;User (dest) ptr for follow-up copy
	ULONG	cmd_CopySize	;Size of follow-up copy
	ULONG	cmd_CopyExtra	;Extra ptr for follow-up use
	APTR	cmd_SRAMptr	;Ptr to this command's SRAM buffer
	APTR	cmd_Unit	;Link to dest. card's unit structure
	APTR	cmd_Action	;Ptr to Action structure for this command
	LABEL	FlyerCmd_Sizeof

MAJIC_ID	equ	$12
RT_ATTACHED	equ	99	;Special - attached to other command, do sync

*** Control structure for each Flyer card ***

    STRUCTURE FlyerUnit,0		;Usually in a5
	ULONG	unit_SRAMbase		;Pointer to shared SRAM for card
	STRUCT	unit_Cmds,FlyerCmd_Sizeof*MAX_FLYER_CMDS   ;For each cmd
	STRUCT	unit_FreeList,FC_Sizeof*MAX_POOL_FRAGS	   ;SRAM memory list
;	STRUCT	unit_MemHdr,MH_SIZE			   ;SRAM memory pool
	UBYTE	unit_Mode		;Current mode: REC/PLAY/NONE/UNKNOWN
	UBYTE	unit_PrivFlags
	LABEL	FlyerUnit_Sizeof

*** Flyer Unit Flags

	BITDEF	FU,RUNNING,0		;Flyer code running
	BITDEF	FU,SETUP,1		;Flyer fully setup


*** The Flyer library base structure ***

    STRUCTURE FlyerLib,LIB_SIZE		;a6
	ULONG	fl_SysLib		;AbsExecBase
	ULONG	fl_DosBase		;Dos.library base
	ULONG	fl_SegList		;SegList of my library code
	UBYTE	fl_PrivFlags		;Library flags
	UBYTE	fl_pad
	STRUCT	fl_Units,FlyerUnit_Sizeof*MAX_FLYER_CARDS	;For each card
	STRUCT	fl_Volumes,MLH_SIZE	;Mounted Flyer volumes
	APTR	fl_Mencode		;M-Encoder definition data
	ULONG	fl_Mencodelen
	APTR	fl_Pencode		;P-Encoder definition data
	ULONG	fl_Pencodelen
	APTR	fl_Mdecode		;M-Decoder definition data
	ULONG	fl_Mdecodelen
	APTR	fl_Pdecode		;P-Decoder definition data
	ULONG	fl_Pdecodelen
;	ULONG	fl_Test			;For testing only
	APTR	fl_BinaryBuffer		;For loading .bin files
	ULONG	fl_BinaryLength
	UWORD	fl_RefNumber		;CutRoom reference number counter
	APTR	fl_RenameList		;CutRoom rename list
	STRUCT	fl_PrivVolume,FV_sizeof	;My private FlyerVolume structure
	STRUCT	fl_PrivAction,CA_sizeof	;My private ClipAction structure
	STRUCT	fl_PrivCompInfo,VCI_sizeof	;My private VidCompInfo structure
	STRUCT	fl_PrivClipInfo,CI_sizeof	;My private ClipInfo structure
	LABEL   FlyerLib_Sizeof

*** Flyer (Private) Library Flags

	BITDEF	FL,DELEXP,0		;Delayed expunge requested (not supported)
	BITDEF	FL,CACHED,1		;Flyer SRAM is being cached by CPU


*** Constants for Flyer's current mode ***

CURMODE_UNKNOWN		EQU	$00
CURMODE_NONE		EQU	$01
CURMODE_PLAY		EQU	$02
CURMODE_REC		EQU	$03


*** Legal "SetFlooby" values ***

FLOOBY_RECSYNC		EQU	1
FLOOBY_PLAYPHASEA	EQU	2
FLOOBY_PLAYPHASEB	EQU	3
FLOOBY_RECPHASE		EQU	4
FLOOBY_PLAYHORIZOFF	EQU	5
FLOOBY_RECHORIZOFF	EQU	6
FLOOBY_BARGRAPH		EQU	7
FLOOBY_CLOCKGEN		EQU	8
FLOOBY_STILLMODE	EQU	9
FLOOBY_LEDS		EQU	14

*** Legal "FlyerTest" values ***
TEST_NONE		EQU	0

*** SCSI commands ***

SCMD_READ		EQU	2
SCMD_WRITE		EQU	3
SCMD_SEEK		EQU	4
SCMD_TUR		EQU	5
SCMD_REQSENSE		EQU	6
SCMD_INQUIRY		EQU	7
SCMD_MODESENSE		EQU	8
SCMD_MODESEL		EQU	9
SCMD_READCAPAC		EQU	10
SCMD_FORMAT		EQU	11


*************** VTASC stuff *****************

VT_MAJIC	EQU	$1BADBABE

MAXTOLER	EQU	7

*** For bit buffering routines ***
BITBUFBLKS	EQU	2
BITBUFSIZE	EQU	BITBUFBLKS*512

NTSC_BLANK	EQU	60	;NTSC level for blanking
NTSC_BLACK	EQU	71	;NTSC level for black

BORDERVALUE	EQU	$82

PIXELSPERLINE	EQU	760	;Samples per active video line (NTSC+8)

LINEBUFFERSIZE	EQU	PIXELSPERLINE+2	;Extra for sub-nyquist

ALGO_OLDD2	EQU	0	;Old D2 mode is now private

*** Control structure for VTASC operations

    STRUCTURE VTASCinfo,0	;
	ULONG	vt_FlyerBase	;Must have for Flyer calls
	ULONG	vt_valid	;Must = VT_MAJIC to be valid handle
	UBYTE	vt_comp		;Compression/decompression flag
	UBYTE	vt_SNflag	;SubNyquist flag
	UBYTE	vt_pcoder	;0=old D2, 1=new SN/D2
	UBYTE	vt_drive	;SCSI drive for compressed I/O
	ULONG	vt_lba		;Block address on SCSI drive
	ULONG	vt_lbastop	;Block limit address on SCSI drive
	ULONG	vt_DRAMblk	;For (de)compressing to/from DRAM
	UBYTE	vt_field	;Field number (0..3)
	UBYTE	vt_preverr	;Prev uncorrected error
	UWORD	vt_fscale	;Filter scale factor (x 256)
	UWORD	vt_tolmag	;Error tolerence magnitude
	UBYTE	vt_tolbits	;Error tolerence in bits
	UBYTE	vt_RndDither	;PRN dither in bits
	UBYTE	vt_RndFreq	;PRN dither frequency
	UBYTE	vt_RndSeed	;PRN seed for field
	UBYTE	vt_RndNum	;Pseudo-random number
	UBYTE	vt_rndcntr	;Random dither frequency counter
	ULONG	vt_RndData	;Pseudo-random number generator bits
	UWORD	vt_msize	;Current mcoder bit size
	UWORD	vt_y		;'y' line counter
	STRUCT	vt_Coefs,8*2	;Coefficients to use
	UBYTE	vt_FillY	;
	UBYTE	vt_FillI	;Fill color YIQ -- default=black
	UBYTE	vt_FillQ	;
	UBYTE	vt_C4		;
	UBYTE	vt_C5		;
	UBYTE	vt_C6		;
	UBYTE	vt_NextBit	;VTASC bit counter
	UBYTE	vt_BitBucket	;Holds 8 bits
	UWORD	vt_BitBufAmt	;Amount of data in BitBuffer
	APTR	vt_BitBufPtr	;Pointer into buffer below
	UBYTE	vt_Error	;Error code
	UBYTE	vt_ModeFlags	;From opener's "modes" argument
	UBYTE	vt_pad7
	UBYTE	vt_BitBuffPre	;Overflow backwards from bitbuffer ('020)
	STRUCT	vt_BitBuffer,BITBUFSIZE		;Holds VTASC compressed bits
	UBYTE	vt_BitBuffPost	;Overflow backwards from bitbuffer ('020)
	UBYTE	vt_pad8
	ULONG	vt_RefNum	;Flyer open field reference number (write only)
	UBYTE	vt_topline	;Index to top video line
	UBYTE	vt_extraline	;Index to middle/bottom video line
	STRUCT	vt_Lines,PIXELSPERLINE*2	;2 lines of video data
	STRUCT	vt_SpareLine,PIXELSPERLINE	;A line for my private use
	ULONG	vt_SRAMbase	;Base of Flyer's SRAM
	UWORD	vt_CPU		;CPU present in Amiga
	LABEL	VTASCinfo_Sizeof

*************** My private fields ***********************

vci_DataStart	EQU	vci_Private1
vci_DataEnd	EQU	vci_Private2

    STRUCTURE FlyerChipHeader,0
	ULONG	fch_FlyerID
	UBYTE	fch_chipnum
	UBYTE	fch_defnum
	UBYTE	fch_chiprev
	UBYTE	fch_boardrev
	ULONG	fch_id			;Date code, etc.
	ULONG	fch_speed		;Speed at which to run chip (Hz)
	ULONG	fch_length		;Amount of binary data in chip def
	LABEL	FlyerChipHdr_Sizeof

	STRUCTURE FlyerDatChunk,0
		ULONG fdc_ChipID		;Chip type the bin is for
		ULONG fdc_length		;length of the bin file
		UBYTE fdc_data			;binary data for the chip
	LABEL FlyerDatChunk_Sizeof

FIRSET_CUSTOM	EQU	0
FIRSET_25	EQU	1
FIRSET_33	EQU	2
FIRSET_50	EQU	3
FIRSET_100	EQU	4



************ FILEGRIP **************
	STRUCTURE F_GRIP,0
	APTR		g_GRIP 							* Forward link
	ULONG		g_header						* FS Header of file/dir
	ULONG		g_parent						* FS Header of parent
	ULONG		g_DL_dir						* Location of directory currently scanning
	ULONG		g_DL_blk						* DirList header block found
	WORD		g_DL_hash					* Hash ptr for dir listing
	ULONG		g_DL_link					* Hash chain link from previous
	UBYTE		g_DL_done					* Flag used for dir listing
	UBYTE		g_drv							* SCSI channel/unit
	UBYTE		g_type						* Object type
* File operation stuff 
	UBYTE		g_opened						* File open?
	ULONG		g_startblk			 		* Start blk of file's data
	ULONG		g_curpos				 		* Position within the file : lo 32 bits
	ULONG		g_curpos_ext		 		* Position within the file : hi 32 bits
	ULONG		g_filelen			 		* Precise length of file : lo 32 bits
	ULONG		g_filelen_ext		 		* Precise length of file : hi 32 bits
	ULONG		g_physlen			 		* Physical length of file (blks * 512) : lo 32 bits
	ULONG		g_physlen_ext		 		* Physical length of file (blks * 512) : hi 32 bits
	ULONG		g_protbits			 		* Protect bits when opened
	ULONG		g_magic				 		* Is this an authentic structure?
	LABEL		F_GRIP_sizeof


GRIPMAGIC	equ	$47524950			* "GRIP"


*************** Cutting Room Stuff ***********************

    STRUCTURE RenameNode,0
	APTR	frn_Next		;Link to next (or 0)
	ULONG	frn_Length		;Length of this structure
	UWORD	frn_RefNum		;Temp clip reference number
	UBYTE	frn_Drive		;SCSI drive number
	UBYTE	frn_pad
	LABEL	frn_Name		;Name starts here
	LABEL	FlyNameNode_Sizeof	;Length varies

******************** Some handy macros ******************

SETC	MACRO
	ori	#$01,ccr
	ENDM

CLRC	MACRO
	andi	#$FE,ccr
	ENDM

******************* Debugging control *****************
SERDEBUG	equ	0

	IFNE	SERDEBUG
*DEBUGINIT	equ	1
*DEBUGSRAM	equ	1
*DEBUGCLIP	equ	1
*DEBUGCMD	equ	1
*DEBUGVERBOSE	equ	1
*DEBUGGEN	equ	1
*DEBUGGEN2	equ	1
*DEBUGASYNC	equ	1
*DEBUGVTASC	equ	1
*DEBUGVTLOTS	equ	1
*DEBUGVTSETUP	equ	1
*DEBUGVTTEST	equ	1
*DEBUGVOL	equ	1
*DEBUGSKELL	equ	1
*DEBUGCLIPCUT	equ	1
*DEBUGAPPEND	equ	1
*DEBUGCACHE	equ	1

	ENDC

	ENDC	; INC_FLYERPRIV_I
