*********************************************************************
*
* flyerscsi.device include file
*
* $Id: flyscsi.i,v 1.1 1995/09/06 12:55:04 Flick Exp $
*
* $Log: flyscsi.i,v $
*Revision 1.1  1995/09/06  12:55:04  Flick
*Added FLYERUP flag
*
*Revision 1.0  1995/05/05  15:45:47  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	09/02/94		Marty		Created
*********************************************************************

MYPROCSTACKSIZE	EQU	$900		;Stack size
MYPRI		EQU	0
TASKPRI		EQU	0		;Priority of unit task
NUM_DRIVES	EQU	24		;Number of drives supported

**** Device command definitions ****

   DEVINIT  0
   DEVCMD   FLY_INVALID
   DEVCMD   FLY_RESET
   DEVCMD   FLY_READ
   DEVCMD   FLY_WRITE		;Not Applicable
   DEVCMD   FLY_UPDATE
   DEVCMD   FLY_CLEAR
   DEVCMD   FLY_STOP
   DEVCMD   FLY_START
   DEVCMD   FLY_FLUSH
   DEVCMD   FLY_MOTOR
   DEVCMD   FLY_SEEK
   DEVCMD   FLY_FORMAT		;Not applicable
   DEVCMD   FLY_REMOVE
   DEVCMD   FLY_NIL1
   DEVCMD   FLY_NIL2
   DEVCMD   FLY_NIL3
   DEVCMD   FLY_NIL4
   DEVCMD   FLY_NIL5
   DEVCMD   FLY_NIL6
   DEVCMD   FLY_NIL7
   DEVCMD   FLY_NIL8
   DEVCMD   FLY_NIL9
   DEVCMD   FLY_NIL10
   DEVCMD   FLY_NIL11
   DEVCMD   FLY_NIL12
   DEVCMD   FLY_NIL13
   DEVCMD   FLY_NIL14
   DEVCMD   FLY_NIL15
   DEVCMD   FLY_DIRECT
   DEVCMD   FLYDEV_END

FIRSTSIGBIT	EQU	31		;First one to allocate
QUEUESIGBIT	EQU	31		;IO added to queue
QUEUESIGFLAG	EQU	$80000000
LASTSIGBIT	EQU	31		;Last one to allocate


;----- The flyscsi.device structure
 STRUCTURE FlyScsiDev,LIB_SIZE
   UBYTE	fly_Flags		;Device-wide flags
   UBYTE	fly_pad1
   ULONG	fly_ExecBase		;AbsExecBase (in a convenient place)
   ULONG	fly_SegList		;SegmentList of my device (given to me to hold)
   STRUCT	fly_Units,NUM_DRIVES*4	;Pointers to structures for each active unit
   LABEL	FlyScsiDev_Sizeof

;----- fly_Flags definitions
   BITDEF	FLY,DELEXP,0		;Delayed expunge pending

;----- The inidividual unit structure
 STRUCTURE FlyScsiUnit,MP_SIZE
;Low-level device stuff
   UBYTE   fsu_UnitFlags		;Low-level unit flags
   UBYTE   fsu_UnitNum			;My unit number
   UWORD   fsu_OpenCnt			;Number of openers
   UWORD   fsu_DebugFlags		;For debugging 'C' routines
   ULONG   fsu_Device			;Ptr to FlyBase
   ULONG   fsu_ExecBase			;AbsExecBase (in a convenient place)
   STRUCT  fsu_Task,TC_SIZE		;My Queuer Task Control Block (TCB)
   ULONG   fsu_Stack			;Pointer to my allocated stack

;Task control
   STRUCT  fsu_Q,MP_SIZE		;Regular Queue Port
   ULONG   fsu_iobDoing			;Latest iob done from queue task (non-ST type)

;Flyer library interface
   ULONG   fsu_FlyerBase		;flyer.library base

;SCSI stuff
   STRUCT  fsu_SenseData,20		;Buffer for ReqSense
   UBYTE   fsu_RawStatus		;Raw drive status
   LABEL   FlyUnit_Sizeof

;----- cdu_UnitFlags definitions
   BITDEF	FSU,UNITSTOPPED,3	;Unit stopped
   BITDEF	FSU,FLYERUP,4		;Flyer has come up, no need to watch and wait
   BITDEF	FSU,SUICIDE,5		;Tell task to dealloc & remove itself
   BITDEF	FSU,ACTIVE,6		;Unused
   BITDEF	FSU,INTASK,7		;Unused

;----- cdu_DebugFlags definitions
   BITDEF	DB,INTERFACE,0
   BITDEF	DB,CMD,1
   BITDEF	DB,TASK,3
   BITDEF	DB,SCSI,4
   BITDEF	DB,INTERNAL,5


;----- This table defines how each command should be treated
CB_IMMEDIATE	EQU	0
CB_REGQUEUE	EQU	1

CF_IMMEDIATE	EQU	$0001
CF_REGQUEUE	EQU	$0002
