*********************************************************************
*
* Opcodes.i - Flyer command opcodes
*
* $Id: opcodes.i,v 1.9 1997/02/05 14:15:26 Holt Exp $
*
* $Log: opcodes.i,v $
*Revision 1.9  1997/02/05  14:15:26  Holt
*added FlierFileFSRead/Write
*
*Revision 1.8  1997/01/31  18:07:29  Hayes
*changed opcodes for op_FILESEEK
*
*Revision 1.6  1996/12/19  18:07:19  Holt
*added FileExtend funtion that extends a file without writing data to it.
*
*Revision 1.5  1996/06/17  18:31:27  Holt
*added new AddAudEKey funct.
*
*Revision 1.4  1995/08/04  10:52:14  Flick
*Added CACHETEST opcode
*
*Revision 1.3  1995/07/19  11:40:27  Flick
*Added op_LOCATEFLD functions
*
*Revision 1.2  1995/06/27  13:11:15  Flick
*Added GETSETOPT for Flyer options
*
*Revision 1.1  1995/05/11  13:01:45  Flick
*Added 4.1 sequencing opcodes
*
*Revision 1.0  1995/05/05  15:44:52  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty		Created
*********************************************************************

*****************************************
***  Flyer processor opcodes/formats  ***
*****************************************

BASECMD		MACRO	;value
CMD_VALUE	SET	\1
		ENDM

DEFCMD		MACRO	;name
\1		equ	CMD_VALUE
CMD_VALUE	SET	CMD_VALUE+1
		ENDM

	BASECMD	$0000
	DEFCMD	op_NULL		;
	DEFCMD	op_FIRMWARE	;cmd.w,-,err,ptr.l,length.l,(actual)
	DEFCMD	op_CALLMOD	;cmd.w,-,err,argc,-.w,arg1,arg2,arg3,arg4,arg5,arg6
	DEFCMD	op_PGMFPGA	;cmd.w,-,err,ptr.l,bytes.l,chipnum,dual,rev
	DEFCMD	op_SBUSW	;cmd.w,-,err,addr,data
	DEFCMD	op_SBUSR	;cmd.w,-,err,addr,(data)
	DEFCMD	op_CPUW		;cmd.w,-,err,addr.l,data.w
	DEFCMD	op_CPUR		;cmd.w,-,err,addr.l,(data.w)
	DEFCMD	op_GETCLOCK	;cmd.w,cont,err,(fieldclock.l)
	DEFCMD	op_FIRINIT	;cmd.w,-,err,reg0data.w,reg1data.w
	DEFCMD	op_FIRXCHG	;cmd.w,-,err,setnum,rdflag,prepost,-,data.w[8],scale.w
	DEFCMD	op_FIRMAPRAM	;cmd.w,-,err,bank.b,scale.b
	DEFCMD	op_DSPBOOT	;cmd.w,-,err,srcptr.l,bytes.l
	DEFCMD	op_CPUDMA	;cmd.w,-,err,cpuptr.l,dmaptr.l,blkcnt.w,readflg.b
	DEFCMD	op_VIDPARAM	;cmd.w,-,err,vchan,mintol,maxtol,freq,vidlen.w,vmaxlen.w,firset,special
	DEFCMD	op_PLAYMODE	;cmd.w,-,err
	DEFCMD	op_RECMODE	;cmd.w,-,err
	DEFCMD	op_NOMODE	;cmd.w,-,err
	DEFCMD	op_TOASTMUX	;cmd.w,-,err,input3,input4,preview
	DEFCMD	op_INPUTSEL	;cmd.w,-,err,source,sync
	DEFCMD	op_TERMINATE	;cmd.w,-,err,flags
	DEFCMD	op_SRCHARGS	;cmd.w,-,err,clipactptr,flag
	DEFCMD	op_DOSEARCH	;cmd.w,cont,err,clipactptr
	DEFCMD	op_FLYPLAY	;cmd.w,cont,err,clipactptr
	DEFCMD	op_FLYRECORD	;cmd.w,cont,err,clipactptr
	DEFCMD	op_CHGAUDIO	;cmd.w,cont,err,clipactptr
	DEFCMD	op_GETSMPTE	;cmd.w,-,err,SMPTEinfoptr
	DEFCMD	op_NEWHEADLIST	;cmd.w,-,err
	DEFCMD	op_ENDHEADLIST	;cmd.w,-,err,flag
	DEFCMD	op_MAKEHEAD	;cmd.w,cont,err,actptr
	DEFCMD	op_VOIDHEAD	;cmd.w,cont,err,actptr
	DEFCMD	op_VOIDALL	;cmd.w,cont,err
	DEFCMD	op_AUDEKEY	;cmd,
	DEFCMD	op_SCSIRST	;cmd.w,-,err
	DEFCMD	op_SCSIINIT	;cmd.w,-,err,,drive
	DEFCMD	op_FINDDRV	;cmd.w,-,err,,drive,drivebits,-,Ver0..Ver7,AL0..AL7
	DEFCMD	op_COPYDATA	;cmd.w,-,err,,drive,,drive,addr.l,blocks.l,dest.l,verf
	DEFCMD	op_SCSICALL	;cmd.w,-,err,,drive,cmd,-,ptr.l,len.w,extra.l
	DEFCMD	op_READSIZE	;cmd.w,-,err,,drive,(length.l),(blklen.l)
	DEFCMD	op_READ10	;cmd.w,-,err,,drive,lba.l,len.w,addr.l
	DEFCMD	op_WRITE10	;cmd.w,-,err,,drive,addr.l,len.w,lba.l
	DEFCMD	op_DRIVEINFO	;cmd.w,-,err,,drive,volinfoptr.l
	DEFCMD	op_LOCATE	;cmd.w,-,err,clipactptr
	DEFCMD	op_FREEGRIP	;cmd.w,-,err,,drive,grip.l
	DEFCMD	op_COPYGRIP	;cmd.w,-,err,,drive,grip.l,(newgrip)
	DEFCMD	op_CMPGRIPS	;* -cmd.w,-,err,,drive,grip1.l,grip2.l
	DEFCMD	op_PARENT	;cmd.w,-,err,,drive,grip.l,(newgrip)
	DEFCMD	op_EXAMINE	;-cmd.w,-,err,,drive,grip.l,ClipInfoPtr.l
	DEFCMD	op_DIRLIST	;cmd.w,-,err,,drive,grip.l,ClipInfoPtr.l,firstflag.b,fsonly.b
	DEFCMD	op_FILEINFO	;cmd.w,-,err,volptr.l,ClipInfoPtr.l
	DEFCMD	op_FILEOPEN	;cmd.w,-,err,clipactptr
	DEFCMD	op_FILECLOSE	;cmd.w,-,err,,drive,id.l
	DEFCMD	op_FILESEEK	;cmd.w,-,err,,drive,mode,-,id.l,position.l,(oldpos)
	DEFCMD	op_FILEREAD	;cmd.w,-,err,,drive,id.l,length.l,buffer.l,(actual.l)
	DEFCMD	op_FILEWRITE	;cmd.w,-,err,,drive,id.l,length.l,buffer.l,(actual.l)
	DEFCMD	op_CREATEDIR	;cmd.w,-,err,clipactptr
	DEFCMD	op_DELETE	;cmd.w,-,err,clipactptr
	DEFCMD	op_RENAME	;cmd.w,-,err,oldclipact,newgrip,newname
	DEFCMD	op_RENAMEDISK	;cmd.w,-,err,,drive,newname
	DEFCMD	op_FORMAT	;cmd.w,-,err,flags,drive,volumename.l,days,mins,ticks,blocks
	DEFCMD	op_DEFRAG	;cmd.w,-,err,,drive
	DEFCMD	op_SETBITS	;cmd.w,-,err,,drive,grip.l,bits.l
	DEFCMD	op_SETDATE	;cmd.w,-,err,,drive,grip.l,days.l,mins.l,ticks.l
	DEFCMD	op_SETCOMMENT	;cmd.w,-,err,,drive,grip.l,comment.l
	DEFCMD	op_WRITEPROT	;?cmd.w,-,err,,drive,value.b,setflag.b
	DEFCMD	op_CHANGEMODE 	;* ?cmd.w,-,err,,drive,grip.l,access.b
	DEFCMD	op_MAKEFILE	;cmd.w,-,err,volptr.l,size,(start)
	DEFCMD	op_COPYCLIP	;cmd.w,-,err,srcvolptr.l,dstvolptr.l,verf
	DEFCMD	op_DEBUGFLAGS	;cmd.w,-,err,flags.w
	DEFCMD	op_FLOOBY	;cmd.w,-,err,chan,item,value.l
	DEFCMD	op_READTEST	;cmd.w,-,err,,drive,lba.l,len.l,rpt.l,dblbufflag
	DEFCMD	op_WRITETEST	;cmd.w,-,err,,drive,lba.l,len.l,rpt.l,dblbufflag
	DEFCMD	op_QUIT		;cmd.w,-,-
;--------sort these
	DEFCMD	op_SCSIDIRECT	;cmd.w,cont,err,drive,-,directinfo
	DEFCMD	op_OPENREADFLD	;cmd.w,cont,err,actptr,field
	DEFCMD	op_OPENWRITEFLD	;cmd.w,cont,err,actptr,compinfoptr,field,mode.b,-,
				; refnum.l
	DEFCMD	op_CLOSEFIELD	;cmd.w,cont,err,refnum,wrote.b,-,dataptr
	DEFCMD	op_READLINE	;cmd.w,cont,err,fhandle,bufptr
	DEFCMD	op_WRITELINE	;cmd.w,cont,err,fhandle,bufptr
	DEFCMD	op_SETFILLCOLOR	;cmd.w,cont,err,fhandle,Y,I,Q
	DEFCMD	op_SKIPLINES	;cmd.w,cont,err,fhandle,lines.w
	DEFCMD	op_GETCOMPINFO	;cmd.w,cont,err,drive,field,lba,structptr
	DEFCMD	op_SETCLOCK	;cmd.w,cont,err,days,mins,ticks
	DEFCMD	op_STRIPAUDIO	;cmd.w,cont,err,srcvolptr,destvolptr
	DEFCMD	op_WRITECALIB	;cmd.w,cont,err,item.w,value.w,save.b
	DEFCMD	op_READCALIB	;cmd.w,cont,err,item.w,(value.w)
	DEFCMD	op_EEWRITE	;cmd.w,cont,err,addr.b,-,data.w
	DEFCMD	op_EEREAD	;cmd.w,cont,err,addr,b,-,(data.w)
	DEFCMD	op_RESETFLYER	;cmd.w,cont,err,flags.l
	DEFCMD	op_SETCLOCKGEN	;cmd.w,cont,err,clock,-,speed
	DEFCMD	op_LOADVID	;cmd.w,cont,err,addr,size
	DEFCMD	op_SERDEVICE	;cmd.w,cont,err,port,type,device
	DEFCMD	op_SELFTEST	;cmd.w,cont,err,test,-,arg1.l,arg2.l,(result)
	DEFCMD	op_TBC		;cmd.w,cont,err,structptr.l,opmodes.b
	DEFCMD	op_NEWCUTLIST	;cmd.w,cont,err,clipactptr,flags.b
	DEFCMD	op_ADDSUBCLIP	;cmd.w,cont,err,drive,flags,ref.w,startfld,flds
	DEFCMD	op_MAKESUBCLIPS	;cmd.w,cont,err,doit.b
	DEFCMD	op_CODECCTRL	;cmd.w,cont,err,structptr,l,opmodes.b
	DEFCMD	op_NEWSEQ	;cmd.w,cont,err
	DEFCMD	op_ADDSEQCLIP	;cmd.w,cont,err,clipactptr
	DEFCMD	op_ENDSEQ	;cmd.w,cont,err,doit.b
	DEFCMD	op_PLAYSEQ	;cmd.w,cont,err,basetime
	DEFCMD	op_GETSETOPT	;cmd.w,cont,err,flags.l,setflag.b
	DEFCMD	op_LOCATEFLD	;cmd.w,cont,err,clipactptr
	DEFCMD	op_CACHETEST	;cmd.w,cont,err,value
	DEFCMD	op_FILEEXTEND	;cmd.w,-,err,,drive,id.l,length.l)
	DEFCMD	op_FILEHSREAD	;cmd.w,-,err,,drive,id.l,startblk.l,blockcount.l,buffer.l)
	DEFCMD	op_FILEHSWRITE	;cmd.w,-,err,,drive,id.l,startblk.l,blockcount.l,buffer.l)
	
