.MODULE Synthesizer;
 
{
        Lattice Filter LPC synthesizer
 
        Calling Parameters
                I1 --> Coefficient Buffer       L0=0
                I2 --> Output Buffer            L2=0
 
        Return Values
                Output Buffer Filled
 
        Altered Registers
                I0,I1,I2,I4,M0,M1,M4,M5,M6,M7,AX0,AY0,AX1,AY1,AR,AF,
                MX0,MY0,MY1,MR,L1,L4,SE

        Computation Time
                16,000 cycles (approximately)

}

.INCLUDE                <lpcconst.h>;
 
.VAR/DM                 white_noise[length];
.VAR/DM/RAM             pitch_driver[length];
.VAR/PM/RAM/CIRC        delay[p];
.EXTERNAL               p_latt;
.INIT                   delay: <zero.dat>;
.INIT                   white_noise: <random.dat>;
.ENTRY                  l_p_synthesis;
 
l_p_synthesis:  CALL set_driving;
                CALL synthesis;
                RTS;
 
set_driving:    M0=1;
                AX0=I1;
                AY0=p;
                AR=AX0+AY0;
                I0=AR;
                AX0=DM(I0,M0);
                I0=^white_noise;                {Point to random data buffer}
                MX0=AX0, AR=PASS AX0;
                IF EQ RTS;                      {If pitch = 0, return}
                I0=^pitch_driver;               {Compute pitch period}
                MY0=samplefreq;
                MR=MX0*MY0 (SS);
                CNTR=length;
                AY1=0;
                AY0=MR1, AF=AY1+1;
                AX1=impulse;
                DO fill_buffer UNTIL CE;        {Fill buffer with impulses at}
                        AX0=AY1, AF=AF-1;       {the pitch period}
                        IF NE JUMP fill_buffer;
                        AX0=AX1, AF=AY0+1;
fill_buffer:            DM(I0,M0)=AX0;
                I0=^pitch_driver;
                RTS;

synthesis:      CNTR=length;I4=^delay;          {Set parameters for lattice}
                L1=p;L4=p;M1=-1;M4=1;           {filter routine}
                M5=-1;M6=3;M7=-2;AR=H#1000;
                AX0=p-1;SE=3;
                CAll p_latt;
                L1=0;L4=0;
                RTS;
.ENDMOD;
