.MODULE		A_Law_Compression;

{
		This routine determines the 8-bit (right-justified)
		a-Law value from the 16-bit (right-justified) linear 
		input.

		Calling Parameters
	AR = 16-bit (right-justified) linear input

		Return Values
	AR = 8-bit log (a-Law) output

		Altered Registers
	AR, AF, AX0, AY0,
	SR, SE

		Computation Time
	21 Cycles

}

.ENTRY	compress;

compress:	AR=ABS AR;			{Take absolute value}
		AY0=1;
		IF NEG AR=AR+AY0;
		SR=ASHIFT AR BY -1 (HI);
		AR=PASS SR1;
		AY0=4095;			{Maximum PCM value}
		AF=AR-AY0;			{Cap input}
		IF GT AR=PASS AY0;		{If in excess}
		AY0=31;				{Check ofor zero segment}
		AF=AR-AY0;
		IF GT JUMP upper_seg;
		SR=LSHIFT AR BY -1 (LO);
		AR=H#4000;
		IF NEG AR=PASS 0;
		SR=SR OR LSHIFT AR BY -7 (LO);
		AY0=H#55;
		AR=SR0 XOR AY0;
		RTS;

upper_seg:	SE=EXP AR (HI);			{Find exponent adjustmet}
		AX0=SE, SR=NORM AR (HI);	{Normalize input}
		AY0=H#4000;
		AR=SR1 XOR AY0;			{Remove first significant bit}
		SR=LSHIFT AR BY -10 (LO);	{Shift position bits}
		AR=PASS AY0;
		IF NEG AR=PASS 0;		{Create sign bit}
		SR=SR OR LSHIFT AR BY -7 (LO);	{Position sign bit}
		AY0=10;
		AR=AX0+AY0;			{Compute segment}
		IF LT AR=PASS 0;
		SR=SR OR LSHIFT AR BY 4 (LO);	{Position segment bits}
		AY0=H#55;
		AR=SR0 XOR AY0;			{Invert bits}
		RTS;

.ENDMOD;
