.MODULE		A_Law_Expansion;
{
	This routine determines the 16-bit (right-justified) linear
	value from an 8-bit log (a-law) input


		Calling Parameters
	AR = 8-bit log (a-law) value

		Return Values
	AR = 16-bit linear output

		Altered Registers
	AR, AF, AX0, AY0,
	SR, SE

		Cycle Count
	16 Cycles

}

.ENTRY	expand;

expand:		AY0=H#0055;
		AR=AR XOR AY0;
		SR1=H#0008;			{Always set sign bit}
		SR0=H#0800;			{Set LSB of interval}
		SR=SR OR LSHIFT AR BY 12 (LO);	{Isolate segment, interval}
		AY0=32;				
		AX0=AR, AF=PASS AY0;		
		AY0=9;				{Segment bias}
		AR=SR1-AY0;			{Determine shift value}
		IF LT AF=PASS 0;		{No extra MSB bit}
		IF EQ AR=PASS 0;		{No less then zero bits}
		SR=LSHIFT SR0 BY -11 (LO);	{Isolate Interval}
		SE=AR, AR=SR0 OR AF;		{Add bit if necessary}
		SR=LSHIFT AR (LO);		{Position output}
		AY0=H#FF80;			
		SR=ASHIFT SR0 BY 1 (HI);
		AR=SR1, AF=AX0+AY0;		{Is sign bit set?}
		IF LT AR=-SR1;			{Yes, so invert word}
		RTS;

.ENDMOD;

