.MODULE		Mu_Law_Expansion;

{	
	This routine determines the 14-bit linear PCM value (right-justified)
	from the 8-bit (right-justified) log (mu-Law) value.

		Calling Paramters
	AR = 8-bit mu-Law value

		Return Values
	AR = 16-bit linear value (right-justified)

		Altered Registers
	AR, AF, AX0, AY0,
	SR, SE

		Computation Time
	17 cycles

}


.ENTRY		u_expand;

u_expand:	AY0=H#FF;			{Mask unwanted bits}
		AF=AR AND AY0, AX0=AY0;
		AF=AX0 XOR AF;			{Invert bits}
		AX0=H#70;
		AR=AX0 AND AF;			{Isolate segment bits}
		SR=LSHIFT AR BY -4 (LO);	{Shift to LSBs}
		SE=SR0, AR=AR XOR AF;		{Remove segment bits}
		AY0=H#FF80;
		AF=AR+AY0;
		IF LT JUMP posval;		{Detemine sign}
		AR=PASS AF;
		AR=AR+AF;			{Shift left by 1 bit}
		AY0=33;
		AR=AR+AY0;			{Add segment offset}
		SR=ASHIFT AR (LO);		{Position bits}
		AR=AY0-SR0;			{Remove segment offset}
		RTS;

posval:		AF=PASS AR;
		AR=AR+AF;			{Shift left by 1}
		AY0=33;	
		AR=AR+AY0;			{Add segment offset}
		SR=ASHIFT AR (LO);
		AR=SR0-AY0;			{Remove segment offset}
		RTS;

.ENDMOD;
