.MODULE csg_sub;

{
        Single-Precision Complex SG Update Subroutine

        Calling Parameters
                I0 --> Oldest data value in real delay line          L0 = N
                I1 --> Oldest data value in imaginary delay line     L1 = N
                I4 --> Beginning of real coefficient table           L4 = N
                I5 --> Beginning of imag coefficient table           L5 = N
                MX0 = real part of Beta * Error
                MX1 = imag part of Beta * Error
                M0,M5 = 1
                M1 = -1
                M4=0
                CNTR = Filter length (N)

        Return Values
                Coefficients updated
                I0 --> Oldest data value in real delay line
                I1 --> Oldest data value in imag delay line
                I4 --> Beginning of real coefficient table
                I5 --> Beginning of imag coefficient table

        Altered Registers
                MY0,MY1,MR,SR,AY0,AY1,AR

        Computation Time
                6*N + 10 cycles

        All coefficients and data values are assumed to be in 1.15 format.
}

.ENTRY  csg;

csg:    MY0=DM(I0,M0);                              {Get Xr}
        MR=MX0*MY0(SS), MY1=DM(I1,M0);              {Er*Xr, get Xi}
        DO adaptc UNTIL CE;
                MR=MR-MX1*MY1(RND), AY0=PM(I4,M4);  {Ei*Xi, get Hr}
                AR=AY0-MR1, AY1=PM(I5,M4);          {Hr-Er*Xr+Ei*Xi, get Hi}
                PM(I4,M5)=AR, MR=MX0*MY1(SS);       {Store Hr, Er*Xi}
                MR=MR+MX1*MY0(RND), MY0=DM(I0,M0);  {Ei*Xr, get Xr}
                AR=AY1-MR1, MY1=DM(I1,M0);          {Hi-Er*Xi-Ei*Xr, get Xi}
adaptc:         PM(I5,M5)=AR, MR=MX0*MY0(SS);       {Store Hi, Er*Xr}
        MODIFY (I0,M1);
        MODIFY (I1,M0);
        RTS;
.ENDMOD;
