.mODULE dist_sub;

{
        Euclidean Distance Subroutine

        Calling Parameters
                I1 --> Start of constellation (C) table
                AX0 contains Xr
                AX1 contains Xi
                L1 = length of constellation table
                M0 = 1
                M1 = -1
                CNTR = length of constellation table

        Return Values
                SI contains the decision index j
                AF contains the minimum distance (squared)
                I1 --> Beginning of constellation table

        Altered Registers
                AY0,AY1,AF,AR,MX0,MY0,MY1,MR,SI

        Computation Time
                10*N + 5 (maximum)
}

.ENTRY  dist;

dist:   AY0=32767;      {Initialize minimum distance to largest possible value}
        AF=PASS AY0, AY0=DM(I1,M0);        {Get Cr}
        DO ptloop UNTIL CE;
                AR=AX0-AY0, AY1=DM(I1,M0); {Xr-Cr, Get Ci}
                MY0=AR, AR=AX1-AY1;        {Copy Xr-Cr, Xi-Ci}
                MY1=AR;                    {Copy Xi-Ci}
                MR=AR*MY1 (SS), MX0=MY0;   {(Xi-Ci)^2, Copy Xr-Cr}
                MR=MR+MX0*MY0 (RND);       {(Xr-Cr)^2}
                AR=MR1-AF;                 {Compare with previous minimum}
                IF GE JUMP ptloop;
                AF=PASS MR1;               {New minimum if MR1<AF}
                SI=CNTR;                   {Record the constellation index}
ptloop:         AY0=DM(I1,M0);
        MODIFY(I1,M1);                     {Point back to beginning of table}
        RTS;
.ENDMOD;
