{	*** Adjust the CODEC channel gain on ADSP-2100 Evaluation Board ***

Directions:
(1) assemble and link ADJUST.DSP, UEXPAND.DSP, UCOMPRESS.DSP, EVALSHIP.SYS
(2) set jumpers on eval. board to factory setting (i.e. codec enabled)
(3) download and run executable on evaluation board
(4) connect "SCOPE VERT" BNC to vertical input of an oscilloscope
(5) connect a DTMF signal generator (or microphone) to "AUDIO IN" jack
(6) the scope should show the waveform which the codec "hears" interlaced
    between alternating values of h#0000 and h#FFFF (i.e. full-scale rails)
(7) "normalize" the gain and null the offset in the codec input amplifier
	(a) normalizing the gain:  adjust R34 so the largest amplitude of
	    the input waveform just touches both h#0000 and h#FFFF markers 
	    on the oscilloscope display without clipping
	(b) null the offset:  adjust R37 so as to remove any dc offset in 
	    the displayed waveform (i.e. a sine wave is centered around the
	    imaginary line exactly between the h#0000 and the h#FFFF lines)

}
.module/ram/abs=0	adjust_codec;
.port			codec;
.port			cntl_port;
.port			dac;
.external		u_expand;
.external		u_compress;
{-------------------------}
.macro wait ( %0 );
.local looper;
	cntr=%0;
	do looper until ce;
looper:	nop;
.endmacro;
{-------------------------}
	rti; rti; rti; jump sample;

start:		si=0;
                dm(cntl_port)=si;
		ay1=h#8000;
		icntl=b#01111;
		imask= b#1000;
wait_int:	jump wait_int;

sample:		ay0=dm(codec);		{ read codec sample }
		call u_expand;		{ convert u-law to 1.13 }
		ax1=sr0;		
		ar=ax1 xor ay1;		{ two's compl. to inverse binary }
		si=h#0000;	dm(dac)=si;	wait(100);
		si=h#FFFF;	dm(dac)=si;	wait(100);
		dm(dac)=ar;		{ send sample to dac }
		ar=ar xor ay1;		{ inverse binary to two's compl. }
		call u_compress;
		dm(codec)=ar;
		rti;

.endmod;
