.module/ram	U_COMPRESS_SUB;
.entry		U_COMPRESS;
{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$									$
$		Linear to u-law Compression Subroutine			$
$									$
$		Calling parameters:					$
$		AR = Input linear 16-bit value				$
$									$
$		Returns with:						$
$		AR = 8-bit u-law value (with all bits inverted)		$
$									$
$		Destroys:						$
$		AX0,AY0,AR,SE,SR					$
$									$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
}
U_COMPRESS:	AR=ABS AR;
		AY0=132;
		AR=AR+AY0;
		SE=EXP AR (HI);
		SR=NORM AR (LO);

		AY0=H#4000;
		AR=SR0 XOR AY0;		{ clear MNSB = 1 }
		SR=LSHIFT AR BY -10 (LO);	{ mantissa bits }

		AR=PASS AY0;
		IF POS AR=PASS 0;
		SR=SR OR LSHIFT AR BY -7 (LO);	{ sign bit }

		AX0=SE;
		AY0=7;
		AR=AX0+AY0;
		IF LT AR=PASS 0;
		SR=SR OR LSHIFT AR BY 4 (LO);	{ exponent bits }

		AY0=H#FF;
		AR=SR0 XOR AY0;		{ invert all bits }

		RTS;
.endmod;
