.module/ram	U_EXPAND_SUB;
.entry		U_EXPAND;
{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$									$
$		u-law to Linear Expansion Subroutine			$
$									$
$		Calling parameters:					$
$		AY0 = Input u-law value from codec			$
$		      (with all bits inverted)				$
$									$
$		Returns with:						$
$		SR0 = Linear Q15 value (2 LSBs zeroed)			$
$									$
$		Destroys:						$
$		AX0,AY0,AF,AR,SE,SR1,SR0				$
$									$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
}
U_EXPAND:	AX0=H#FF;
		AF=AX0 AND AY0;		{ zero MSBs of u-law value }
		AF=AX0 XOR AF;		{ invert all bits of u-law value }
		AX0=H#70;
		AR=AX0 AND AF;		{ isolate exponent bits }

		SR=LSHIFT AR BY -4 (LO);{ shift exponent to SR0 LSBs }

		SE=SR0, AR=AR XOR AF;	{ clear exponent bits }
		AY0=H#FF80;
		AF=AR+AY0;

		IF LT JUMP POSVAL;
NEGVAL:		AR=PASS AF;
		AR=AR+AF;		{ shift left one bit }
		AY0=33;
		AR=AR+AY0;

		SR=ASHIFT AR (LO);
		AR=AY0-SR0;
		SR=ASHIFT AR BY 2 (LO);	{ make Q13 number Q15 }

		RTS;

POSVAL:		AF=PASS AR;
		AR=AR+AF;		{ shift left one bit }
		AY0=33;
		AR=AR+AY0;

		SR=ASHIFT AR (LO);
		AR=SR0-AY0;
		SR=ASHIFT AR BY 2 (LO);	{ make Q13 number Q15 }

		RTS;
.endmod;
