
.MODULE Double_Precision_Multiply;

{
        Double-Precision Multiplication
                Z = X * Y

        Calling Parameters
                I0 --> Address of Z Buffer           L0 = 0
                M0 = 1 
                MX0 = LSW of X
                MX1 = MSW of X
                MY0 = LSW of Y
                MY1 = MSW of Y

        Return Values
                Z Buffer Filled

        Altered Registers
                MR, I0

        Computation Time
                13 cycles

}

.ENTRY  dpm;

dpm:    MR=MX0*MY0(UU);                              {Compute LSW}
        DM(I0,M0)=MR0;                               {Save LSW}
        MR0=MR1;                                     {Shift right 16 bits}
        MR1=MR2;
        MR=MR+MX1*MY0(SU);                           {Compute inner product}
        MR=MR+MX0*MY1(US);
        DM(I0,M0)=MR0;                               {Shift right 16 bits}
        MR0=MR1;
        MR1=MR2;
        MR=MR+MX1*MY1(SS);                           {Compute MSW}
        DM(I0,M0)=MR0;
        DM(I0,M0)=MR1;                               {Store MSW}
        RTS;

.ENDMOD;

