.MODULE Integer_TPM;

{
        Integer Triple-Precision Multiplication
                Z = X * Y

        Calling Parameters
                I0 --> X Buffer                            L0 = 3
                I1 --> Y Buffer                            L1 = 3
                I2 --> Storage for Z                       L2 = 0
                M0 = 1
                SE = -1

        Return Values
                Z Buffer Filled

        Altered Registers
                MX0,MX1,MY0,MY1,MR,I0,I1,I2,SR

        Computation Time
                28 cycles

}

.ENTRY  itpm;

itpm:   MY0=DM(I0,M0);                                     {Fetch LSWs}
        MX0=DM(I1,M0);
        MY1=DM(I0,M0), MR=MX0*MY0(UU);                     {Compute LSW}
        MX1=DM(I1,M0);
        MR0=MR1, SR=LSHIFT MR0(LO);                        {Shift LSW}
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);
        DM(I2,M0)=SR0, MR=MR+MX0*MY1(UU);                  {Store LSW}
        MR=MR+MX1*MY0(UU);
        MR0=MR1, SR=LSHIFT MR0(LO);
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);
        DM(I2,M0)=SR0, MR=MR+MX1*MY1(UU);
        MY1=DM(I0,M0);
        MR=MR+MX0*MY1(US), MX0=DM(I1,M0);
        MY0=DM(I0,M0), MR=MR+MX0*MY0(SU);                  {Skip 1st word}
        MR0=MR1, SR=LSHIFT MR0(LO);
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);
        DM(I2,M0)=SR0;
        MY0=DM(I0,M0), MR=MR+MX1*MY1(US);
        MR=MR+MX0*MY0(SU);
        MR0=MR1, SR=LSHIFT MR0(LO);
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);
        DM(I2,M0)=SR0, MR=MR+MX0*MY1(SS);
        SR=LSHIFT MR0(LO);                                 {Shift MSW}
        SR=SR OR LSHIFT MR1(HI);
        SR=SR OR LSHIFT MR2 BY 15(HI);
        DM(I2,M0)=SR0;
        DM(I2,M0)=SR1;                                     {Save MSW}
        RTS;

.ENDMOD;

