.MODULE Triple_Precision_Multiply;

{
        Triple-Precision Multiplication
                Z = X * Y

        Calling Parameters
                I0 --> X Buffer                           L0 = 3
                I1 --> Y Buffer                           L1 = 3
                I2 --> Z Buffer                           L2 = 0
                M0 = 1

        Return Values
                Z Buffer Filled

        Altered Registers
                MX1,MX0,MY1,MY0,MR,I0,I1,I2

        Computation Time
                26 cycles

}

.ENTRY  tpm;

tpm:    MY0=DM(I0,M0);
        MX0=DM(I1,M0);
        MX1=DM(I1,M0), MR=MX0*MY0(UU);                    {Compute LSW}
        DM(I2,M0)=MR0;                                    {Save LSW}
        MR0=MR1;                                          {Shift right 16 bits}
        MR1=MR2;
        MY1=DM(I0,M0), MR=MR+MX1*MY0(UU);
        MR=MR+MX0*MY1(UU);
        DM(I2,M0)=MR0;
        MR0=MR1;                                          {Shift right 16 bits}
        MR1=MR2;
        MY1=DM(I0,M0), MR=MR+MX1*MY1(UU);
        MX0=DM(I1,M0), MR=MR+MX0*MY1(US);
        MY0=DM(I0,M0), MR=MR+MX0*MY0(SU);                 {Skip 1st word, LSW}
        DM(I2,M0)=MR0;
        MR0=MR1;                                          {Shift right 16 bits}
        MR1=MR2;
        MY0=DM(I0,M0), MR=MR+MX1*MY1(US);
        MR=MR+MX0*MY0(SU);
        DM(I2,M0)=MR0;
        MR0=MR1;
        MR1=MR2;
        MR=MR+MX0*MY1(SS);
        DM(I2,M0)=MR0;
        DM(I2,M0)=MR1;                                    {Save MSW}
        RTS;

.ENDMOD;



