
.MODULE cvt_2word_float_to_fixed;

{
        Convert two-word floating-point to 1.15 fixed-point
 
        Calling Parameters
                AX0 = exponent                  [16.0 signed twos complement]
                AY0 = exponent bias             [16.0 signed twos complement]
                SI = mantissa                   [1.15 signed twos complement]
 
        Return Values
                SR1 = fixed-point number        [1.15 signed twos complement]
 
        Altered Registers
                AR,SE,SR

        Computation Time
                4 cycles

}
 
.ENTRY  fixone;
 
fixone: AR=AX0-AY0;                            {Compute unbiased exponent}
        SE=AR;
        SR=ASHIFT SI (HI);                     {Shift fractional part}
        RTS;
 
.ENDMOD;

