.MODULE single_fixed_to_floating;

{
        Convert 1.15 fixed-point to two-word floating-point

        Calling Parameters
                AR = fixed point number            [1.15 signed twos complement]
                AX0 = exponent bias (0=unbiased)   [16.0 signed twos complement]
 
        Return Values
                AR = biased exponent               [16.0 signed twos complement]
                SR1 = mantissa                     [1.15 signed twos complement]
 
        Altered Registers
                SE,SR,AY0,AR

        Computation Time
                5 cycles

}
 
.ENTRY  fltone;
 
fltone: SE=EXP AR (HI);     {Determine exponent}
        SR=NORM AR (HI);    {Remove redundant sign bits}
        AY0=SE;
        AR=AX0+AY0;         {Add bias}
        RTS;
 
.ENDMOD;

