.MODULE floating_point_add;

{
        Floating-Point Addition
                z = x + y

        Calling Parameters
                AX0 = Exponent of x
                AX1 = Fraction of x
                AY0 = Exponent of y
                AY1 = Fraction of y

        Return Values
                AR = Exponent of z
                SR1 = Fraction of z

        Altered Registers
                AX0,AY1,AY0,AF,AR,SI,SE,SR 
                
        Computation Time
                11 cycles

}

.ENTRY  fpa;

fpa:    AF=AX0-AY0;                               {Is Ex > Ey?}
        IF GT JUMP shifty;                        {Yes, shift y}
        SI=AX1, AR=PASS AF;                       {No, shift x}
        SE=AR;
        SR=ASHIFT SI (HI);
        JUMP add;
shifty: SI=AY1, AR=-AF;
        SE=AR;
        SR=ASHIFT SI (HI), AY1=AX1;
        AY0=AX0;
add:    AR=SR1+AY1;                              {Add fractional parts}
        SE=EXP AR (HIX);
        AX0=SE, SR=NORM AR (HI);                 {Normalize}
        AR= AX0+AY0;                             {Compute exponent}
        RTS;

.ENDMOD;

