.MODULE floating_point_divide;

{
        Floating-Point Divide
                z = x / y

        Calling Parameters
                AX0 = Exponent of x
                AX1 = Fraction of x 
                AY0 = Exponent of y
                AY1 = Fraction of y
                MX0 = Excess Code

        Return Values
                AR = Exponent of z
                SR1 = Fraction of z

        Altered Registers
                AF,AR,MR,SE,SI,SR,AX1,AX0,AY0

        Computation Time
                33 cycles (maximum)

}

.ENTRY  fpd;

fpd:    SR0=AY1, AR=ABS AX1;
        SR1=AR, AF=ABS SR0;
        SI=AX1, AR=SR1-AF;                                  {Is Fx > Fy?}
        IF LT JUMP divide;                                  {Yes, go divide}
        SR=ASHIFT SI BY -1 (LO);                            {No, shift Fx right}
        AF=PASS AX0;
        AR=AF+1, AX1=SR0;                                   {Increase exponent}
        AX0=AR;
divide: AX0=MX0, AF=AX0-AY0;
        MR=0;
        AR=AX0+AF, AY0=MR1;
        AF=PASS AX1, AX1=AY1;                               {Add bias}
        DIVS AF, AX1;                                       {Divide fractions}
        DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1;
	DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1;
	DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1; DIVQ AX1;
	MR0=AY0, AF=PASS AR;
        SI=AY0, SE=EXP MR0 (HI);
        AX0=SE, SR=NORM SI (HI);                            {Normalize}
        AR=AX0+AF;                                          {Compute exponent}
        RTS;

.ENDMOD;

