.MODULE floating_point_multiply;

{
        Floating-Point Multiply
                Z = X * Y

        Calling Parameters
                AX0 = Exponent of X
                AX1 = Fraction of X
                AY0 = Exponent of Y
                AY1 = Fraction of Y
                MX0 = Excess Code

        Return Values
                AR = Exponent of Z
                SR1 = Fraction of Z

        Altered Registers
                AF,AR,AX0,MY1,MX1,MR,SE,SR

        Computation Time
                9 cycles

}

.ENTRY  fpm;

fpm:    AF=AX0+AY0, MX1=AX1;                         {Add exponents}
        MY1=AY1;
        AX0=MX0, MR=MX1*MY1 (RND);                   {Multiply fractions}
        IF MV SAT MR;                                {Check for overflow}
        SE=EXP MR1 (HI);
        AF=AF-AX0, AX0=SE;                           {Subtract bias}
        AR=AX0+AF;                                   {Compute exponent}
        SR=NORM MR1 (HI);                            {Normalize}
        RTS;

.ENDMOD;


