.MODULE floating_point_multiply_accumulate;

{
        Floating-Point Multiply/Accumulate
                    n   
                z =sum ( x(i) * y(i) )
                   i=1

        Calling Parameters
                I0 --> x Buffer                             L0 = 0
                I1 --> y Buffer                             L1 = 0
                M0 = 1
                CNTR = Length of Buffer - 1
                MX0 = Excess Code

        Return Values
                AR = Exponent of z
                SR1 = Fraction of z

        Altered Registers
                AF,AR,AX0,AX1,AY0,AY1,MX1,MY1,SE,MR,SR
        
        Computation Time
                13*(n-1)+16

}

.ENTRY  fpmacc;

fpmacc: AX0=DM(I0,M0);                               {Get 1st Ex}
        AY0=DM(I1,M0);                               {Get 1st Ey}
        AF=AX0+AY0, MX1=DM(I0,M0);                   {Add exp., get 1st Fx}
        AR=PASS AF, MY1=DM(I1,M0);                   {Get 1st Fy}
        AX1=AR, MR=MX1*MY1(RND);                     {Multiply fractions}
        IF MV SAT MR;                                {Check for overflow}
        SE=EXP MR1(HI); 
        AY1=SE, SR=NORM MR1(HI);                     {Normalize}
        AR=AX1+AY1, AX0=DM(I0,M0);
        AX1=AR;
        AY0=DM(I1,M0);
        DO macc UNTIL CE;
                AF=AX0+AY0, MX1=DM(I0,M0);           {Compute product exp.}
                AR=AX1-AF, MY1=DM(I1,M0);            {Sum exp. > product exp.?}
                IF GT JUMP shiftp;                   {Yes, shift product}
                SE=AR, MR=MX1*MY1(RND);              {No, shift sum}
                IF MV SAT MR;
                AY1=MR1, AR=PASS AF;
                AX1=AR, SR=ASHIFT SR1(HI);
                JUMP add;
shiftp:         AF=PASS AR;
                AR=-AF;
                SE=AR, MR=MX1*MY1(RND);
                IF MV SAT MR;
                AY1=SR1, SR=ASHIFT MR1(HI);
add:            AR=SR1+AY1, AX0=DM(I0,M0);           {Accumulate}
                SE=EXP AR(HIX);
                AY1=SE, SR=NORM AR(HI);              {Normalize}
                AR= AX1+AY1, AY0=DM(I1,M0);
macc:           AX1=AR;
        SR0=MX0;                                     {Get bias}
        AF=PASS SR0;
        AR=AX1-AF;                                   {Subtract bias}
        RTS;

.ENDMOD;

