.MODULE Square_root;

{
        Square Root
                y = sqrt(x)

        Calling Parameters
                MR1 = MSW of x 
                MR0 = LSW of x
                M3 = 1
                L3 = 0

        Return Values
                SR1 = y in 8.8 UNSIGNED format

        Altered Registers
                AX0,AY0,AY1,AR,MY0,MY1,MX0,MF,MR,SE,SR,I3

        Computation Time
                75 cycles (maximum)
}

.CONST  base=H#0D49, sqrt2=H#5A82;

.VAR/DM sqrt_coeff[5];

.INIT   sqrt_coeff : H#5D1D, H#A9ED, H#46D6, H#DDAA, H#072D;

.ENTRY  sqrt;

sqrt:   I3=^sqrt_coeff;                       {Pointer to coeff. buffer}
        SE=EXP MR1 (HI);                      {Check for redundant bits}
        SE=EXP MR0 (LO);
        AX0=SE, SR=NORM MR1 (HI);             {Remove redundant bits}
        SR=SR OR NORM MR0 (LO);
        MY0=SR1, AR=PASS SR1;
        IF EQ RTS;
        MR=0;
        MR1=base;                             {Load constant value}
        MF=AR*MY0 (RND), MX0=DM(I3,M3);       {MF = x**2}
        MR=MR+MX0*MY0 (SS), MX0=DM(I3,M3);    {MR = base + C1*x}
        CNTR=4;
        DO approx UNTIL CE;
                MR=MR+MX0*MF (SS), MX0=DM(I3,M3);
approx:         MF=AR*MF (RND);
        AY0=15;
        MY0=MR1, AR=AX0+AY0;                 {SE + 15 = 0?}
        IF NE JUMP scale;                    {No, compute sqrt(s)}
        SR=ASHIFT MR1 BY -6 (HI);
        RTS;
scale:  MR=0;
        MR1=sqrt2;                           {Load 1/sqrt(2)}
        MY1=MR1, AR=ABS AR;
        AY0=AR;
        AR=AY0-1;
        IF EQ JUMP pwr_ok;
        CNTR=AR;                             {Compute (1/sqrt(2))^(SE+15)}
        DO compute UNTIL CE;
compute:  MR=MR1*MY1 (RND);
pwr_ok: IF NEG JUMP frac;
        AY1=H#0080;                          {Load a 1 in 9.23 format}
        AY0=0;                               {Compute reciprocal of MR}
        DIVS AY1, MR1;
        DIVQ MR1; DIVQ MR1; DIVQ MR1;
        DIVQ MR1; DIVQ MR1; DIVQ MR1;
        DIVQ MR1; DIVQ MR1; DIVQ MR1;
        DIVQ MR1; DIVQ MR1; DIVQ MR1;
        DIVQ MR1; DIVQ MR1; DIVQ MR1;
        MX0=AY0;
        MR=0;
        MR0=H#2000;
        MR=MR+MX0*MY0 (US);
        SR=ASHIFT MR1 BY 2 (HI);
        SR=SR OR LSHIFT MR0 BY 2 (LO);
        RTS;
frac:   MR=MR1*MY0 (RND);
        SR=ASHIFT MR1 BY -6 (HI);
        RTS;
.ENDMOD; 
