.MODULE urand_sub;

{
        Linear Congruence Uniform Random Number Generator
 
        Calling Parameters
                I0 --> Output buffer    L0 = 0
                M0 = 1
                SR1 = MSW of seed value
                SR0 = LSW of seed value
                CNTR = desired number of random numbers
 
        Return Values
                Desired number of random numbers in output buffer
                SR1 = MSW of updated seed value
                SR0 = LSW of updated seed value
 
        Altered Registers
                MY0,MY1,MR,SI,SR

        Computation Time
                10*N + 4 cycles
}

.ENTRY  urand;

urand:  MY1=25;                                 {Upper half of a}
        MY0=26125;                              {Lower half of a}
        DO randloop UNTIL CE;
                DM(I0,M0)=SR1, MR=SR0*MY1(UU);  {a(hi)*x(lo)}
                MR=MR+SR1*MY0(UU);              {a(hi)*x(lo) + a(lo)*x(hi)}
                SI=MR1;
                MR1=MR0;
                MR2=SI;
                MR0=H#FFFE;                     {c=32767, left-shifted by 1}
                MR=MR+SR0*MY0(UU);              {(above) + a(lo)*x(lo) + c}
                SR=ASHIFT MR2 BY 15 (HI);
                SR=SR OR LSHIFT MR1 BY -1 (HI); {right-shift by 1}
randloop:       SR=SR OR LSHIFT MR0 BY -1 (LO);
        RTS;
.ENDMOD;
