.MODULE    dif_fft;

.CONST     N=1024, N_div_2=512, log2N=10;

.EXTERNAL  inplacedata, twid_real, twid_imag;
.EXTERNAL  groups,bflys_per_group,node_space;
.EXTERNAL  bfp_adjust;

.ENTRY     fft_start;

fft_start:
   I4=^twid_real;  {I4 ->   C  OF W(0)}
   L4=N_div_2;
   I5=^twid_imag;  {I5 -> (-S) OF W(0)}
   L5=N_div_2;
   M0=-1;
   M1=1;
   CNTR=log2N;     {Initialize stage counter}
   L0=0;
   L1=0;
   L2=0;
   DO stage_loop UNTIL CE; 
      I0=^inplacedata;                {I0 -> x0}
      I1=^inplacedata;
      AY0=DM(node_space);     
      M2=AY0;
      MODIFY(I1,M2);                  {I1 -> x1}
      I2=I1;
      AX0=2;
      AR=AY0-AX0;
      M3=AR;                          {M3=node_space-2}
      CNTR=DM(groups);                {Initialize group counter}
      SB=-2;  
      M5=CNTR;                        {Init. twiddle factor modifier}
      DO group_loop UNTIL CE; 
         CNTR=DM(bflys_per_group);    {Init. butterfly counter}
         AX0=DM(I0,M1);               {AX0=x0}
         AY0=DM(I1,M1);               {AY0=x1}
         AY1=DM(I1,M1);               {AY1=y1}
         DO bfly_loop UNTIL CE;
            AR=AX0+AY0, AX1=DM(I0,M0), MY0=PM(I4,M5);
                                       {AR=x0+x1,AX1=y0,MY0=C}
            SB=EXPADJ AR;              {Check for bit growth}
            DM(I0,M1)=AR, AR=AX1+AY1;  {x0=x0+x1,AR=y0+y1}
            SB=EXPADJ AR;              {Check for bit growth}
            DM(I0,M1)=AR, AR=AX0-AY0;  {y0=y0+y1,AR=x0-x1}
            MX0=AR, AR=AX1-AY1;        {MX0=x0-x1,AR=y0-y1}
            MR=MX0*MY0 (SS), AX0=DM(I0,M1), MY1=PM(I5,M5);
                                       {MR=(x0-x1)C,AX0=next x0,MY1=(-S)}
            MR=MR-AR*MY1 (RND), AY0=DM(I1,M1);
                                       {MR=(x0-x1)C-(y0-y1)(-S),AY0=next x1}
            SB=EXPADJ MR1;             {Check for bit growth}
            DM(I2,M1)=MR1, MR=AR*MY0 (SS);
                                       {x1=(x0-x1)C-(y0-y1)(-S),MR=(y0-y1)C}
            MR=MR+MX0*MY1 (RND), AY1=DM(I1,M1);
                                       {MR=(y0-y1)C+(x0-x1)(-S),AY1=next y1}
bfly_loop:  DM(I2,M1)=MR1,SB=EXPADJ MR1;
                                       {y1=(y0-y1)C+(x0-x1)(-S),check bit growth}
         MODIFY(I2,M2);  {I2->x1 of first butterfly in next group}
         MODIFY(I1,M3);  {I1->x1 of first butterfly in next group}
         MODIFY(I0,M3);
group_loop: MODIFY(I0,M1);  {I0->x0 of first butterfly in next group}
      CALL bfp_adjust;        {Adjust block data for bit growth}
      SI=DM(groups);  
      SR=LSHIFT SI BY 1 (LO); 
      DM(groups)=SR0;         {groups=groups*2}
      SI=DM(node_space);      
      SR=LSHIFT SI BY -1 (LO);        
      DM(node_space)=SR0;     {node_space=node_space/2}
      SR=LSHIFT SR0 BY -1 (LO);        
stage_loop: DM(bflys_per_group)=SR0; {bflys_per_group=bflys_per_group/2}
   RTS;
.ENDMOD;
