.MODULE dif_unscramble;

{       Calling Parameters
                Real and imaginary scrambled output data in inplacedata

        Return Values
                Sequentially ordered real output data in real_results
                Sequentially ordered imag. output data in imaginary_results

        Altered Registers
                I0,I1,I4,M1,M4, AY1,CNTR

        Altered Memory
                real_results, imaginary_results
}

.CONST  N=1024,mod_value=H#0010;        {Initialize constants}
.CONST  N_x_2 = 2048;

.EXTERNAL       inplacedata;

.ENTRY  unscramble;     {Declare entry point into module}

unscramble:     I4=^inplacedata;        {I4-->real part of 1st data point}
                M4=2;                   {Modify by 2 to fetch only real data}
                L0=0;
                L4=0;
                I1=h#4;                   {I1=1st real output addr, bit-reversed}
                                        { 14 bit reversal of 4 = h#800}
                M1=mod_value;           {Modifier for 10-bit reversal}
                CNTR=N;                 {N=number of real data points}
                ENA BIT_REV;            {Enable bit-reverse}

        DO bit_rev_real UNTIL CE;
                AY1=DM(I4,M4);          {Read real data}
bit_rev_real:   DM(I1,M1)=AY1;          {Place in sequential order}
                I4=^inplacedata+1;      {I4-->imag. part of 1st data point}
                I1=h#0C;                {I1=1st imag. output addr, bit-reversed}
                CNTR=N;                 {N=number of imaginary data points}
        DO bit_rev_imag UNTIL CE;
                AY1=DM(I4,M4);          {Read imag. data}
bit_rev_imag:   DM(I1,M1)=AY1;          {Place in sequential order}
                DIS BIT_REV;            {Disable bit-reverse}
        RTS;
.ENDMOD;
