.MODULE dit_scramble;

{       Calling Parameters
                Sequentially ordered input data in inputreal

        Return Values
                Scrambled input data in inplacereal

        Altered Registers
                I0,I4,M0,M4,AY1

        Altered Memory
                inplacereal
}

.CONST  	N=1024, mod_value=H#0010;        {Initialize constants}
{to calculate correct mod_value, divide 16384 by N}

.CONST		scrambletop=H#0000;
{here, ^inplacereal=h#0000 which is the same as its bit-reversed address}

.EXTERNAL       inputreal, inplacereal;
{warning: ^inplacereal must = H#0000 in this case!}

.ENTRY  	scramble;


scramble:       I4=^inputreal;		{I4-->sequentially ordered data}
        	I0=scrambletop;		{I0-->scrambled data}
       	 	M4=1;
        	M0=mod_value;   	{M0=modifier for reversing N bits}
        	L4=0;
        	L0=0;
        	CNTR = N;
        	ENA BIT_REV;    	{Enable bit-reversed outputs on DAG1}
        	DO brev UNTIL CE;
                  AY1=DM(I4,M4);	{Read sequentially ordered data}
brev:             DM(I0,M0)=AY1;	{Write data in bit-reversed location}
        	DIS BIT_REV;    	{Disable bit-reverse}
        	RTS;    		{Return to calling program}
.ENDMOD;
