.MODULE/ROM     dif_radix_4_bfp_adjust;

{       Calling Parameters
                Radix-4 DIF FFT stage results in inplace

        Return Values
                inplace adjusted for bit growth

        Altered Registers
                I0,I1,AX0,AY0,AR,SE,SI,SR

        Altered Memory
                inplace, blk_exponent 
}

.EXTERNAL       inplace, blk_exponent;      

.ENTRY  	bfp_adjust;
                        
bfp_adjust:M1=1;
        AY0=-3;
        AX0=SB;
        AR=AX0-AY0;
        IF EQ RTS;             		{If SB=-3, no bit growth, return}
        AY0=-2;
        SE=-1;
        I0=^inplace;        	{I0=read pointer}
        I1=^inplace;        	{I1=write pointer}
        AR=AX0-AY0,SI=DM(I0,M1);	{Check SB, get 1st sample}
        IF EQ JUMP strt_shift;  	{If SB=-2, shift block right 1 bit}
        AY0=-1;
        SE=-2;
        AR=AX0-AY0;     
        IF EQ JUMP strt_shift;  	{If SB=-1, shift block right 2 bits}
        SE=-3;
strt_shift:CNTR=N_x_2-1;
	AY0=SE;
        DO shift_loop UNTIL CE; 
           SR=ASHIFT SI(LO),SI=DM(I0,M1);  	{SR=shifted data, SI=next data}
shift_loop:DM(I1,M1)=SR0;            		{Unshifted data=shifted data}
        SR=ASHIFT SI(LO);       		{Shift last data word}
        AX0=DM(blk_exponent);   		{Update block exponent and}
        DM(I1,M1)=SR0,AR=AX0-AY0;       	{store last shifted sample}
        DM(blk_exponent)=AR;
        SE=0;
        RTS;
.ENDMOD;

