.MODULE/BOOT=0		drev_1024.dsp;
.CONST			N=1024;
.CONST			Nx2=2048;
.CONST			log2N=10;
.CONST			chkrbd_e=h#2AAA; {even bit mask}
.CONST			chkrbd_o=h#1555; {odd bit mask}
.CONST			base_adr=h#0004; {results base, h#0800=2K bit reved} 
.CONST 			evenshift=14 - log2N - 2;
.CONST			oddshift=14 - log2N;
.VAR/ABS=2048		drev_out[Nx2];	 {output at 2K}
.GLOBAL			drev_out;
.EXTERNAL		inplace;
.ENTRY			drev;

{ this routine unscrambles radix-4 dif fft results out of place       }
{ a seven instruction core loop unscrambles a complex pair in 7 cycles }
{ an additional 20 cycles for setup are required giving total processing}
{ time for 1024 points is 7188 cycles or 0.57504ms @ 80ns     }

drev:	ENA bit_rev;
	M1=h#2000;		{this is a modify by one in b_rev mode}
	M3=base_adr;		{this is the b_rev base adr of output buffer}
	I0=base_adr;		{initialized because for first write is wraped}
	L0=0;
	I4=^inplace;		{I4 points to scrambled fft results}
	M4=1;
	L4=0;
	AX0=chkrbd_e;		{used to isolate even index bits}
	AX1=chkrbd_o;		{used to isolate odd index bits}
	AY0=-1;			{initialize index for wraped code}
	SE=evenshift;		{core loop even shift is not immediate}
	AF=PASS AY0;		{store index count in AF}
	CNTR=N;			{process N complex pairs}
	DO digit UNTIL CE;
	   AF=AF+1,DM(I0,M1)=MX0;	{inc index,store b_rev real val}
	   AR=AX0 AND AF,DM(I0,M1)=MX1; {isolate even bits, store b_rev imag}
	   SR=LSHIFT AR(HI),MX0=DM(I4,M4);{shift for b_rev index, get next real}
	   AR=AX1 AND AF,MX1=DM(I4,M4); {isolate odd bits,get imag val}
	   SR=SR OR LSHIFT AR BY oddshift (HI);{OR for b_rev index}
	   I0=SR1;			{store b_rev index}
digit:	   MODIFY(I0,M3);		{compute b_rev adr}
	DM(I0,M1)=MX0;			{store last b_rev real val}
	DM(I0,M1)=MX1;			{store last b_rev imag val}
	DIS bit_rev;
	RTS;
.ENDMOD;
