{
                TWO DIMENSIONAL FFT
                Row Block Floating Point Module

        Description:
                This module does the final adjusting of the row
                block floating point exponents, to normalize the 
                entire array.  Each row has an associated BFP exponent.
                This module finds the greatest magnitude exponent, 
                then shifts each row by the difference of the individual
                BFP exponent and the greatest magnitude exponent.
}
.module         all_row_bfp;
.var/dm         largest_re;
.const          N=64;
.external       row_exponents, rrowbase, irowbase, realdata, tempdata;
.entry          row_final_adj;

{find the greatest of the row exponents}

row_final_adj:  i0 = ^row_exponents;
                m0 = 0;
                m1 = 1;
                ax1 = 0;
                af = pass ax1;

                ay0 = dm(i0,m1);        {find max of 1st two values}
                ax0 = dm(i0,m1);
                ar = ax0 - ay0;         {see which is greater}

                if ge af = pass ax0;    {af gets greatest of 1st two}
                if lt af = pass ay0;
                ax0 = dm(i0,m1);

                cntr = N-2;             {buffer size less first two values}
                do findmax until ce;    {find greatest in the buffer}
                  ar = ax0 - af;
                  if ge af = pass ax0;
findmax:          ax0 = dm(i0,m1);
                ar = pass af;           {put the largest row exponent}
                dm(largest_re) = ar;    {in memory}


{  shift each row by the difference between the greatest and the individual
   row exponent.  this puts all of the row fft outputs in the same range}
                
                i1=^tempdata;          {address of post scrambled real data}
                i2=^realdata;          {address of post scrambled imag data}
                i0 = ^row_exponents;

                ay0 = dm(largest_re);
                cntr = N;
                ax0=dm(i0,m1);         {get indiv. row BFP}

                do row UNTIL ce;
                 ar = ay0 - ax0;        {diff between greatest and row BFP}
                 se = ar;
                 af = pass 0;           {clear AC bit}
                 cntr = N;
                   do row_shift UNTIL ce;  {shift the row}
                     si = dm(i1,m0);    {get next value leave pointer}
                     sr = ashift si (hi);
                     dm(i1,m1) = sr1;   {put shifted value back, inc pointer}
                     si = dm(i2,m0);    {do same for imag values}
                     sr = ashift si (hi);
row_shift:           dm(i2,m1) = sr1;   
row:             ax0=dm(i0,m1);         {get indiv. row BFP}

                rts;

.endmod;

