.MODULE col_dif_unscramble;
{       Calling Parameters
                Real and imaginary scrambled output data in inplacedata

        Return Values
                Sequentially ordered real output data in real_results
                Sequentially ordered imag. output data in imaginary_results

        Altered Registers
                I0,I1,I4,M1,M4, AY1,CNTR

        Altered Memory
                real_results, imaginary_results
}

.VAR/DM rownum;
.CONST  N=64, mod_value=4;        {Initialize constants}

.CONST  N_x_2 = 128, N_DIV_2 = 32;

.EXTERNAL      current_rcol, current_icol;
.ENTRY  col_unscr_start;     {Declare entry point into module}

col_unscr_start:
                I4=dm(current_icol);    {I4-->real part of 1st data point}
                M4=64;                  {Modify by 64 to fetch next col val}
                M5 = 1;
                L0=0;
                L4=0;
                si = dm(i6,m5);
                i1 = si;
                M1=mod_value;           {Modifier for FFT size}
                CNTR=N;                 {N=number of real data points}
                ENA BIT_REV;            {Enable bit-reverse}

        DO bit_rev_real UNTIL CE;
                AY1=DM(I4,M4);          {Read real data}
bit_rev_real:   DM(I1,M1)=AY1;          {Place in sequential order}
                ay0 = dm(current_icol); {increment pointer to current}
                ar = ay0 + 1;           {imaginary column data}
                dm(current_icol) = ar;

                cntr = N;
                I4 = dm(current_rcol);
                si  = dm(i7,m5);
                i1 =si;

        DO bit_rev_imag UNTIL CE;
                AY1=DM(I4,M4);          {Read imag data}        
bit_rev_imag:   DM(I1,M1)=AY1;          {Place in sequential order}
                ay0 = dm(current_rcol); {increment pointer to current}
                ar = ay0 + 1;           {real column data}
                dm(current_rcol) = ar;
                DIS BIT_REV;            {Disable bit-reverse}
        RTS;
.ENDMOD;

