.MODULE         Two_Dimensional_Convolution;

{                3    3                
        G(x,y) =sum  sum [H(i,j) * F(x+i, y+j)]
                i=1  j=1

        Calling Parameters
                I0 --> F(x,y), MxN Input Matrix              L0 = 0
                I1 --> G(x,y), (M-2)x(N-2) Output Matrix     L1 = 0
                I4 --> H(i,j), 3x3 Coefficient Matrix        L4 = 9
                CNTR = M-2          M3 = 2
                M0 = 1              M4 = 1
                M1 = N-2            M2 = -(2*N + 1)

        Return Values
                G(x,y) Filled

        Altered Registers
                MX0,MY0,MR,I0,I1,I4

        Computation Time
                ((10*(N-2) + 3) * (M-2)) + 3 + 10 cycles
}

.ENTRY  conv;

conv: MX0=DM(I0,M0), MY0=PM(I4,M4);   {Get first data and coeff}
      DO in_row UNTIL CE;             {Loop M-2 times}
        CNTR=M1;
        DO in_col UNTIL CE;           {Loop N-2 times}
          MR=MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M1), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M1), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (SS), MX0=DM(I0,M2), MY0=PM(I4,M4);
          MR=MR+MX0*MY0 (RND), MX0=DM(I0,M0), MY0=PM(I4,M4);
in_col:   DM(I1,M0)=MR1;              {Save convolution value}
        MODIFY(I0,M0);
in_row: MX0=DM(I0,M0);                {Point to next input row}
      RTS;
.ENDMOD;
