.MODULE Histogram_subroutine;

.CONST  N=2048;          {number of elements in array}

{ 
        Calculates histogram of input data

        Calling Parameters
                Set each location in the histogram result buffer 
                to zero before calling this routine.
                I0 --> Input buffer in data memory          L0 = 0
                I4 --> Histogram results in program memory  L4 = 0
                M0 = 0
                M1 = 1
                M5 = 0
        
        Return Values
                Histogram buffer filled with results

        Altered Registers
                AX0,AX1,AY0,AF,AR,I0,I4,M4

        Computation Time
                7 + (4 * (Input buffer length - 2) + 2) + 12 cycles
}

.ENTRY  histo;

histo:  AX1=DM(I0,M1);                  {Get 1st data value}
        M4=AX1;
        MODIFY(I4,M4);                  {Point to its counter}
        AX0=DM(I0,M0);                  {Get 2nd data value}
        AF=PASS AX1;                    {Pass to y operand}
        CNTR=N-2;
        DO histo_loop UNTIL CE;
            AR=AX0-AF, AX1=DM(I0,M1), AY0=PM(I4,M5);
                                        {calc index, reread data, locate cntr}
            M4=AR;                      {transfer index to modify register}
            AR=AY0+1, AX0=DM(I0,M0);
histo_loop: PM(I4,M4)=AR, AF=PASS AX1;
        AR=AX0-AF, AY0=PM(I4,M5);       {calc index, locate cntr}
        M4=AR;                          {transfer index to modify register}
        AR=AY0+1;                       {increment cntr}
        PM(I4,M5)=AR;                   {save updated cntr, point to next}
        AY0=PM(I4,M5);                  {locate cntr}
        AR=AY0+1;                       {increment cntr}
        PM(I4,M5)=AR;                   {store updated cntr}
        RTS;
.ENDMOD;
