.module/boot=0  Bootable_Sin_Approximation;
{
        Sine Approximation
                Y = boot_sin(x)

        Calling Parameters
                AX0 = x in scaled 1.15 format 
                M7 = 1
                L7 = 0

        Return Values
                AR = y in 1.15 format

        Altered Registers
                AY0,AF,AR,MY1,MX1,MF,MR,SR,I3

        Computation Time
                25 cycles

}
.ENTRY  boot_sin;

.VAR/PM sin_coeff[5];
.INIT   sin_coeff: H#324000, H#005300, H#AACC00, H#08B700, H#1CCE00;

boot_sin:
        I7=^sin_coeff;                      {Pointer to coeff. buffer}
        AY0=H#4000;
        AR=AX0, AF=AX0 AND AY0;             {Check 2nd or 4th quad.}
        IF NE AR=-AX0;                      {If yes, negate input}
        AY0=H#7FFF;
        AR=AR AND AY0;                      {Remove sign bit}
        MY1=AR;
        MF=AR*MY1 (RND), MX1=PM(I7,M7);     {MF = x2}
        MR=MX1*MY1 (SS), MX1=PM(I7,M7);     {MR = C1x}
        CNTR=3;
        { DO approx UNTIL CE; }
top_approx:     MR=MR+MX1*MF (SS);
approx:         MF=AR*MF (RND), MX1=PM(I7,M7);
                if not ce jump top_approx;
        MR=MR+MX1*MF (SS);
        SR=ASHIFT MR1 BY 3 (HI);
        SR=SR OR LSHIFT MR0 BY 3 (LO);      {Convert to 1.15 format}
        AR=PASS SR1;
        IF LT AR=PASS AY0;                  {Saturate if needed}
        AF=PASS AX0;
        IF LT AR=-AR;                       {Negate output if needed}
        RTS;
.ENDMOD;

