{   Set Up SPORTS and TIMER on EZ-LAB board after RESET
    (used for ADSP-2101 EZ-LAB demonstrations)

    Analog Devices, Inc.
    DSP Division
    P.O.Box 9106
    Norwood, MA 02062
    
    31-Jan-1990, revised 3-Apr-1990, 8-Nov-1990
    Christoph Cavigioli (DSP Applications)

    Usage:              call init2101;
    Input:              none
    Output:             DM(0x3fef) - DM(0x3fff) initialized
    Altered Registers:  AX0
    Benchmark:          35 cycles
}
.module/boot=0/boot=1/boot=2/boot=3
       /boot=4/boot=5/boot=6/boot=7     Set_Up_2101_Cntl_Regs;
.const  SPORT1_Autobuf=         0x3fef;
.const  SPORT1_RFSDIV=          0x3ff0;
.const  SPORT1_SCLKDIV=         0x3ff1;
.const  SPORT1_Control_Reg=     0x3ff2;
.const  SPORT0_Autobuf=         0x3ff3;
.const  SPORT0_RFSDIV=          0x3ff4;
.const  SPORT0_SCLKDIV=         0x3ff5;
.const  SPORT0_Control_Reg=     0x3ff6;
.const  SPORT0_TX_Channels0=    0x3ff7;
.const  SPORT0_TX_Channels1=    0x3ff8;
.const  SPORT0_RX_Channels0=    0x3ff9;
.const  SPORT0_RX_Channels1=    0x3ffa;
.const  TSCALE=                 0x3ffb;
.const  TCOUNT=                 0x3ffc;
.const  TPERIOD=                0x3ffd;
.const  DM_Wait_Reg=            0x3ffe;
.const  System_Control_Reg=     0x3fff;
.entry init2101;
init2101:
{================== S E R I A L   P O R T   #1   S T U F F ==================}
    ax0=0;      dm(SPORT1_Autobuf)=ax0;     { autobuffering disabled }
    ax0=0;      dm(SPORT1_RFSDIV)=ax0;      { RFSDIV not used }
    ax0=0;      dm(SPORT1_SCLKDIV)=ax0;     { SCLKDIV not used }
    ax0=0;      dm(SPORT1_Control_Reg)=ax0; { control reg functions disabled }

{================== S E R I A L   P O R T   #0   S T U F F ==================}
    ax0=0;      dm(SPORT0_Autobuf)=ax0;     { autobuffering disabled }
    ax0=255;    dm(SPORT0_RFSDIV)=ax0;      { RFSDIV=255 for 8 kHz interrupts
                                              from 2.048 MHz SCLK }
    ax0=2;      dm(SPORT0_SCLKDIV)=ax0;     { SCLKDIV=2 makes 2.048 MHz SCLK
                                              with 12.288 MHz xtal on EZ-LAB }
    ax0=0x6b27; dm(SPORT0_Control_Reg)=ax0; { multichannel disabled,
                                              internally generated SCLK,
                                              RFS required, TFS required,
                                              normal frame sync width,
                                              internal RFS, internal TFS, 
                                              serial data is u_law, 8-bit PCM }
    ax0=0;      dm(SPORT0_TX_Channels0)=ax0;    { TX on TDM channels 15-00 }
    ax0=0;      dm(SPORT0_TX_Channels1)=ax0;    { TX on TDM channels 31-16 }
    ax0=0;      dm(SPORT0_RX_Channels0)=ax0;    { RX on TDM channels 15-00 }
    ax0=0;      dm(SPORT0_RX_Channels1)=ax0;    { RX on TDM channels 31-16 }

{================ T I M E R   S T U F F ==================}
    ax0=0;      dm(TSCALE)=ax0;             { timer not being used }
    ax0=0;      dm(TCOUNT)=ax0;
    ax0=0;      dm(TPERIOD)=ax0;

{============== S Y S T E M   A N D   M E M O R Y   S T U F F ==============}
    ax0=0;      dm(DM_Wait_Reg)=ax0;        { no DM wait states }
    ax0=0x1018; dm(System_Control_Reg)=ax0; { SPORT0 enabled, SPORT1 disabled, 
                                              use FI,FO,IRQ0,IRQ1,SCLK instead
                                              BOOT_PAGE=0, BMWAIT=3, PMWAIT=0 }
    rts;
.endmod;
