{   Pick a 16-bit Random Number

    Linear Congruence Method to generate Uniform Random Numbers

    Input:
        32-bit seed value stored in DM(seed_msw), DM(seed_lsw)

    Output:
        32-bit seed updated
        16-bit random number in SR1

    Registers Altered
        MY1,MY0,MR2,MR1,MR0,SR1,SR0

    Benchmark:
        17 cycles
}
.module/boot=0/boot=1/boot=2/boot=3
       /boot=4/boot=5/boot=6/boot=7     Get_Next_Random_Number;

.external   seed_msw, seed_lsw;
.entry      newrnd;

newrnd: sr1=dm(seed_msw);
        sr0=dm(seed_lsw);
        my1=25;                         { Upper half of a }
        my0=26125;                      { Lower half of a }
        mr=sr0*my1(uu);                 { a(hi) X x(lo) }
        mr=mr+sr1*my0(uu);              { a(hi) X x(lo) + a(lo) X x(hi) }
        si=mr1;
        mr1=mr0;
        mr2=si;
        mr0=h#FFFE;                     { c=32767, left-shifted by 1 }
        mr=mr+sr0*my0(uu);              { (above) + a(lo) X x(lo) + c }
        sr=ashift mr2 by 15 (hi);
        sr=sr or lshift mr1 by -1 (hi); { right-shift by 1 }
        sr=sr or lshift mr0 by -1 (lo);
        dm(seed_msw)=sr1;               { random 16-bit value in sr1 }
        dm(seed_lsw)=sr0;
        rts;

.endmod;
