
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

struct ClipInfo	Buffer;
struct SMPTEinfo SmpteInfo;

main(int argc,char **argv)
{
ULONG	res,meg10,sec10;

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <drive:name>\n",argv[0]);
   return(20);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];

Buffer.len = sizeof(struct ClipInfo);
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   printf("Error %ld - %ls\n",res,Error2String(res));
else 
   {
   printf("Name: %ls\n",Buffer.Name);
   if (Buffer.Type == FLYER_TYPE_FILE) 
      {
      meg10 = (Buffer.Length / 100000) + (Buffer.LengthExt * 42950);
      printf("Size: $%lx blocks (%ld.%ld MB)\n",(Buffer.Length/512) + (Buffer.LengthExt * 8388608),
			meg10/10,meg10%10);
      printf("Start: $%lx\n",Buffer.Start);
      sec10 = Buffer.Fields / 6;
      printf("Fields: %ld (%ld.%ld seconds)\n",Buffer.Fields,
		sec10/10,sec10%10);
      printf("Index blk: %lx\n",Buffer.IndexBlk);
      printf("Clip contains: ");
      if (Buffer.Flags & CIF_HASVIDEO)
	 {
	 printf("video ");
	 if (Buffer.VideoGrade == VG_HQ5)
	    printf("(HQ5) ");
	 }
      if (Buffer.Flags & CIF_HASAUDIO)
	 printf("audio -- %ld channel(s)",Buffer.NumAudChans);
      printf("\n");

/*			printf("Length is now %ld\n",Buffer.len); */

      /* See if field had SMPTE info */
      res = GetSMPTE(FlyVol.Board,&SmpteInfo);
      if ((res==FERR_OKAY)&&(SmpteInfo.SMPTEvalid)) 
         {
	 printf("SMPTE start time: %02ld:%02ld:%02ld:%02ld %ls\n",
		SmpteInfo.SMPTEhours,SmpteInfo.SMPTEminutes,
		SmpteInfo.SMPTEseconds,SmpteInfo.SMPTEframes,
		(SmpteInfo.SMPTEflags & SIF_DropFrame)?"(DF)":" ");
	 }
      else 
         {
	 printf("No SMPTE start time\n");
	 }
      }
   else
      printf("Is a sub-directory\n");
   }

CloseLibrary(FlyerBase);

return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
