
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

struct ClipInfo	Buffer;
struct SMPTEinfo SmpteInfo;

ULONG value;

FILE *bill;

int main(int argc,char **argv)
{
ULONG	res;

printf("ReadTC version 1.00 \n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <drive:name>\n",argv[0]);
   return(-1);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(-1);
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];

value = -1;

Buffer.len = sizeof(struct ClipInfo);

res = GetClipInfo(&FlyVol,&Buffer);

if (res)
   value = -1;
else 
   {
   if (Buffer.Type == FLYER_TYPE_FILE) 
      {
      /* See if field had SMPTE info */
      res = GetSMPTE(FlyVol.Board,&SmpteInfo);
      if ((res==FERR_OKAY)&&(SmpteInfo.SMPTEvalid)) 
         {
         value = SmpteInfo.SMPTEhours * 108000 + 
                 SmpteInfo.SMPTEminutes * 1800 +
                 SmpteInfo.SMPTEseconds * 30 + SmpteInfo.SMPTEframes;
   
	 }
      else 
         {
         value = 0; 
	 }
      }
   }

bill = fopen("env:oz-rtc.txt","w");

fprintf(bill,"%ld\n",value);

fclose(bill);

CloseLibrary(FlyerBase);

return(0);
}
