

#include <exec/types.h>
#include <string.h>
#include <stdio.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *FlyerBase;
struct FrameHeader	HdrBuff;

/* Prototypes */
ULONG SetTimeCode(char *pathname, ULONG field, ULONG timecode);
UBYTE Binary2BCD(UBYTE bin);

main(int argc,char **argv)
{
char	*ptr;
ULONG	err,timecode;
int	hh,mm,ss,ff;


printf("Timecode version 1.00 \n");
printf("Copyright Prowave 1996\n");

if (argc!=3)
   {
   printf("Not Enough Parameters \n");
   printf("%s pathname ColorFrameCount \n",argv[0]); 
   return(20);
   }

stcd_i(argv[2],&timecode);

timecode = timecode * 2;

printf("This is timecode %s %ld \n",argv[2],timecode);

if (FlyerBase = OpenLibrary(FLYERLIBNAME,0))
   {
   err = SetTimeCode(argv[1],0,timecode);	// Set timecode for first field of clip
   CloseLibrary(FlyerBase);
   }
else
   printf("Open flyer.library failed\n");

return(0);
}


ULONG SetTimeCode(char *pathname, ULONG field, ULONG timecode)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;
int	i;
struct Field			*fld;
UBYTE	*buf,hours,minutes,seconds,frames;

actptr = &Action;
volptr = &FlyVol;

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->VidStartField = field;			// Get header for this field

res = GetFrameHeader(actptr,&HdrBuff);		// Get it!
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   return(res);
   }

fld = &HdrBuff.fields[field % 4];		// Pick out which of the 4 fields we wanted
buf = &fld->SerData[0];

hours = timecode / (60*60*30);
minutes = (timecode / (60*30)) % 60;
seconds = (timecode / 30) % 60;
frames = timecode % 30;

buf[0] = 0xF2;				// Use this code to signify drop-frame timecode
//	buf[0] = 0xF0;				// Use this code to signify non-drop timecode
buf[1] = Binary2BCD(frames);
buf[2] = Binary2BCD(seconds);
buf[3] = Binary2BCD(minutes);
buf[4] = Binary2BCD(hours);

fld->SerialDataLen = 5;				// Amount of data we placed in buffer
fld->SerType = SERDEVTYPE_SMPTE;	// This is SMPTE info
fld->SerMake = SERDEV_HORITA;		//	Horita format

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->VidStartField = field;			// Put header for this field

res = PutFrameHeader(actptr,&HdrBuff);		// Put it back!
if (res)
   printf("Error %ld - %ls\n",res,Error2String(res));

return(res);
}

UBYTE Binary2BCD(UBYTE bin)
{
UBYTE	lo,hi;

hi = bin/10;
lo = bin%10;

return((UBYTE)((hi<<4)+lo));
}
