
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

void GetArg(char *arg,LONG *var,LONG lo,LONG hi,char *label);

struct Library *FlyerBase;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: FlyerCut 1.5";

int main(int argc, char *argv[])
{
struct FlyerVolume FlyVol,*volptr, FlyVol2, *volptr2;
struct ClipAction	 Action,*actptr;
ULONG	res;
LONG StFrame;
LONG frames, ClipType, CutType;

printf("FlyerCut 1.5\n");
printf("Copyright Bill Evans 1998\n");

if (argc!=7)
   {
   printf("Not enough parameters \n");
   printf("%s Inputfile StartFrame FrameCount Outputfile ClipType CutType\n",argv[0]);
   printf("ClipType - 0 = Audio/Video \n");
   printf("           1 = Audio Only  \n");
   printf("           2 = Video Only  \n");
   printf("CutType  - 0 = Nondestructive\n");
   printf("           1 = Destructive \n");
   exit(0);
   }

GetArg(argv[2],&StFrame,0,20000000,"Starting Frame");
GetArg(argv[3],&frames,0,20000000,"Frames");
GetArg(argv[5],&ClipType,0,2,"ClipType");
GetArg(argv[6],&CutType,0,1,"CutType");

FlyerBase = OpenLibrary(FLYERLIBNAME,0); 
   
actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = argv[1];		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

printf("Let's start the List \n");

res = StartClipCutList(actptr,CutType);		// Ready for destructive reprocessing

printf("We have started the List \n");

if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr2 = &FlyVol2;
volptr2->Board = 0;
volptr2->Path = argv[4];					// Make new clip the same name
volptr2->Flags = 0;							// None
actptr->Volume = volptr2;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = StFrame * 2;					// Reprocess all of clip
actptr->AudFieldCount = frames * 2;
actptr->VidStartField = StFrame * 2;					// Reprocess all of clip
actptr->VidFieldCount = frames * 2;

if (ClipType == 0)
   actptr->Flags = CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;
if (ClipType == 1)
   actptr->Flags = CAF_AUDIOL | CAF_AUDIOR;
if (ClipType == 2)
   actptr->Flags = CAF_VIDEO;

printf("ready to addclipcut \n");

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

printf("Lets make the new clip \n");

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

CloseLibrary(FlyerBase);

return(FERR_OKAY);
}

void GetArg(char *arg,LONG *var,LONG lo,LONG hi,char *label)
{
stcd_l(arg,var);
if ((*var < lo)||(*var > hi)) 
   {
   printf("Error: %ls is out of range\n",label);
   exit(20);
   }
}
