/* BW.rexx */
/* By Bill Evans    */

numeric digits 12

call remlib('PROJECT_REXX_PORT')
call remlib('ToasterARexx.port')

call addlib('PROJECT_REXX_PORT',0)
call addlib('ToasterARexx.port',0)

call set_view(2)

call REQ_ERROR("BW Proc V1.00     ---   Process flyer clip(s).")

ncmd=0
thisisdone=0
do until thisisdone=1

  cmdback=chooseclip()

  if (ncmd=0 & cmdback="CANCEL") then call quit

  if cmdback~="CANCEL" then do
     ncmd=ncmd+1
     cmd.ncmd=cmdback
     icon.ncmd=iconname
     end

  call req_error("So far you have "||ncmd||" clips ready to process.")
  if req_tell("Black & White Proc V1.00","'Continue' to choose another clip.","'Cancel' to start processing.")=0 then thisisdone=1

end

call req_error("Note: While clips are being processed you can abort by using Control-C.")
  if req_tell("Still want to continue?","Hit 'Continue' to process clips.","Hit 'Cancel' abort FlyerProc.")=0 then call quit()

call req_error("")

Switcher(TOWB)

do count=1 to ncmd
  address command cmd.count
  icontime=1
  if ncmd=1 then do
     Switcher(TOSW)
     icontime=REQ_FLYERJOG("Choose frame for icon.",icon.ncmd,1)
     if icontime="CANCEL" then icontime=1
     icontime=icontime*2
     end
  call makeicon(icon.count,icontime)
end

Switcher(TOSW)

call req_error("All done.")

call remlib('PROJECT_REXX_PORT')
call remlib('ToasterARexx.port')

exit



quit: PROCEDURE
   call req_error("Canceled.")
   call remlib('ToasterARexx.port')
   call remlib('PROJECT_REXX_PORT')
   exit

isclip:
parse arg clipname
if open('CLIP',clipname,'R') then do
   padding=readch('CLIP',12)
   call close ('CLIP')
   if substr(padding,1,4)='CLIP' then return 1
   end
call close ('CLIP')
return 0

chooseclip:

  /* The following stuff is just to get a filename with a path */

  call startfilereq("Source Clip?","","")

  exit=1
  do while exit=1
    file=queryfilereq()
    if file=0 then return CANCEL
  if file~="" then exit=0
  address command "c:wait 1"
  end

  if lastpos('/',file,length(file)-1)~=0 then do
     filenam=right(file,(length(file)-lastpos('/',file,length(file)-1)))
     path=left(file,(lastpos('/',file,length(file))-1))
     end
  else do
     filenam=right(file,(length(file)-lastpos(':',file,length(file)-1)))
     path=left(file,(lastpos(':',file,length(file))))
     end

  address command "c:cd "path

  call pragma("D",path)
  path=pragma("D","RAM:")

  if right(path,1)=":" then Source=path||filenam
  else Source=path||"/"||filenam

  if isclip(source)=0 then do
     call req_tell("Error!","            That isn't a clip!")
     return CANCEL
     end

  if fields=-2 then do
    call req_tell("Error!","I can't find that file.")
    return CANCEL
    end

  /* end of that requestor */

  /* Do that all over again for the destination */

  call startfilereq("Save Clip Where?","FB0:","OutClip."||ncmd+1)

  exit=1
  do while exit=1
    file=queryfilereq()
    if file=0 then return CANCEL
    if file~="" then exit=0
    address command "c:wait 1"
  end

  if exists(file) then
     if req_tell("Ok to overwrite this file?")=0 then return CANCEL

  if lastpos('/',file,length(file)-1)~=0 then do
     filenam=right(file,(length(file)-lastpos('/',file,length(file)-1)))
     path=left(file,(lastpos('/',file,length(file))-1))
     end
  else do
     filenam=right(file,(length(file)-lastpos(':',file,length(file)-1)))
     path=left(file,(lastpos(':',file,length(file))))
     end

  address command "c:cd "path

  call pragma("D",path)
  path=pragma("D","RAM:")

  if right(path,1)=":" then dest=path||filenam
  else dest=path||"/"||filenam

  /* End of all that stuff */

  times=REQ_FLYERJOG("Choose in and out points.",source,2)

  if times="CANCEL" then return CANCEL

  starttime=(word(times,1)*2)
  endtime=(word(times,2)*2)
  
  endtime = endtime-starttime
   
  cmd="flyerutils:bw "||'"'||source||'"'||'"'||dest||'"'||" "starttime" "endtime" "
  iconname=dest

return cmd




