
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

struct FlyerVolume	FlyVol, FlyVol2;
struct ClipAction	Action, Action2;
struct ClipInfo		Cinfo;

UBYTE Buffer[SAMPLESPERLINE],AltBuf[SAMPLESPERLINE];

__far UBYTE Buffer2[240][752];

main(int argc,char **argv)
{
int	board=0,i,j,k,l,pattern,line,modes,fieldnum;
ULONG	err;
UBYTE	*buff,qualmode;
int start, length;
UBYTE temp;

if (argc < 5)
   {
   printf("Correct format: %s infile outfile startfield fieldcount \n",argv[0]);
   exit(1);
   }

modes = FWF_NEW;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = board;
FlyVol.Path = argv[1];
FlyVol.Flags = 0;			// We'll specify volume in name, not drive number

Action.Volume = &FlyVol;		// Link structures together
Action.ReturnTime = RT_STOPPED;

FlyVol2.Board = board;
FlyVol2.Path = argv[2];
FlyVol2.Flags = 0;			// We'll specify volume in name, not drive number

fieldnum = 0;

Action2.Volume = &FlyVol2;
Action2.ReturnTime = RT_STOPPED;
qualmode = 0;		// Best mode

start = atoi(argv[3]);

length = atoi(argv[4]);

length += start;

for (j=start;j<length;j++)
   {
   printf("Field: %d \n",j);

   err = OpenReadField(&Action,j,0);			// Open field in clip for reading
   if (err)
      {
      printf("\nOpen Error %ld - %ls\n",err,Error2String(err));
      printf("Didn't open field %ld\n",j);
      }

   for (line=0;line<239;line++)
      {
      Action.ReturnTime = RT_STOPPED;
      err = FlyerReadLine(&Action,Buffer2[line]);			// Read D2 data into my buffer
//      for (k=0;k<188;k++)
//         {
//         temp = (Buffer2[line][k*4] + Buffer2[line][k*4+2])/2;
//         Buffer2[line][k*4] = temp;
//         Buffer2[line][k*4+1] = temp;
//         Buffer2[line][k*4+2] = temp;
//         Buffer2[line][k*4+3] = temp;
//         Buffer2[line][k*4] = temp;
//         Buffer2[line][k*4+1] = temp;
//         Buffer2[line][k*4+2] = temp;
//         Buffer2[line][k*4+3] = temp;
//         }
      }

   err = CloseField(&Action);									// Close field, done now
   if (err)
      printf("\nClose Error 1 %ld - %ls\n",err,Error2String(err));

   for (l=0;l<4;l++)
      {
      err = EasyOpenWriteField(&Action2,0,modes | FWF_APPEND,qualmode);
      if (err)
         printf("\nOpen Error %ld - %ls\n",err,Error2String(err));

      for (i=0;i<239;i++)
         {
         Action2.ReturnTime = RT_STOPPED;
         buff = Buffer2[i];

         err = FlyerWriteLine(&Action2,buff);
         if (err)
	    {
	    printf("\nError %ld on line %ld - %ls\n",err,line,Error2String(err));
	    break;
	    }
         }

      Action2.ReturnTime = RT_STOPPED;
      err = CloseField(&Action2);
      if (err)
         printf("\nClose Error 2 %ld - %ls\n",err,Error2String(err));
       
      modes = 0;
      }
   }
CloseLibrary(FlyerBase);
return(0);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi))
	{
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
