/*********************************************************************\
*
* DumpProject - Dump and document a 4.0 Toaster/Flyer project file
*
* Copyright (c) 1995 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/95		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Tags.h"

/*** Prototypes ***/
void EndIt(void);
void DumpProject(UBYTE *ptr, char *name);
UBYTE *DumpTagList(UBYTE *ptr);
ULONG ReadFile(char *name, UBYTE **bufferptr);

FILE *infile, *outfile;

/*** Globals ***/
UBYTE	*ProjBuffer;

main(int argc,char **argv)
{
if (argc!=3)
   {
   printf("Usage: %ls <DumpFile> <ProjFile> \n",argv[0]);
   exit(100);
   }

infile = fopen(argv[1],"r");

outfile = fopen(argv[2],"w");

DumpProject(ProjBuffer,argv[1]);

fclose(outfile);
}

struct ProjHeader	
   {
   ULONG	ID1,ID2;
   ULONG	Version;
   ULONG	pad[4];
   ULONG	SysTagsSize;
   };

struct ProjEntry 
   {
   ULONG	Length;
   ULONG	ObjType;
   ULONG	ObjVersion;
   ULONG	future[4];
   UWORD	NameLength;
   char	Name[0];
   };

void DumpProject(UBYTE *ptr, char *name)
{
ptr = DumpTagList(ptr);

fprintf(outfile,">>>>>>>>>> End <<<<<<<<<<\n");
}

char *TagNames[] = 
   {
   "???",
   "Version",
   "Revision",
   "AAeffect",
   "NonAAeffect",
   "KillInterfaceNonAA",
   "KillInterfaceAA",
   "ButtonELHlogic",
   "CustomButtonELHlogic",
   "NumberOfAnims",
   "RequestFileName",
   "AnimFiles",
   "Frames",
   "FieldSync",
   "VariableSpeeds",
   "ForcePlayForward",
   "ForcePlayReverse",
   "LoopAnims",
   "AnimControl",
   "AudioFastSamples",
   "AudioMediumSamples",
   "AudioSlowSamples",
   "AudioFiles",
   "AudioControl",
   "PauseTimes",
   "LatchColors",
   "TransparentColors",
   "PaletteColors", 
   "Equations",
   "Encoder",
   "VerticalScroll",
   "ReverseTime",
   "ReverseButtLog",
   "ReverseCustomButtLog",
   "KeyMode",
   "MatteColor",
   "CustomMatteColor ",
   "BorderColor",
"CustomBorderColor",
"LineNumbers",
"LineNumberPlane",
"ForceFreeze4",
"ForceFreeze8",
"ForceLive",
"ForceLumKeyOn",
"ForceLumKeyOff",
"ForceLumKeyOnBlack",
"ForceLumKeyOnWhite",
"BadDefaultFX",
"LoadPictures",
"FadeInDuration",
"FadeOutDuration",
"DigitalFX",
"TimeMode",	
"LUT",
"DigitalPairs",
"LatchAM",
"LatchBM",
"LatchIS",
"HonorPreviewOverLay",
"ForceDefaultMatte",
"TurnAudioFilterOff",
"AudioStartField",
"NumAudioFields",
"ISandClipPause",
"Interlaced",
"FirstFieldNTSCII",
"BounceILBM",
"LatchRanges",
"LatchList",
"TransparentRanges",
"TransparentList",
"Color0Transparent",
"AbortIfSlow",
"NumSkipFieldsAtEnd",
"TBarDoesAuto",
"DoNotStompSprite",
"AbortLoopAtEnd",
"NonAAremap",
"100PercentWhiteMatte",
"UseEffectColor",
"LoopCount",	
"CroutonType",
"TimeLine",
"IndexID",
"FCountMode",
"VariableFCount",
"SlowFCount",
"MedFCount",
"FastFCount",
"VariableFCount68000",
"SlowFCount68000",
"MedFCount68000",
"FastFCount68000",
"NumFields",
"StartTime",
"DescriptorList",
"AboutList",
"CommentList",
"AlgoFXtype",
"AlgoFXborder",
"NumFramesSlow",
"NumFramesMedium",
"NumFramesFast",
"NumFramesVariable",
"Page",
"Speed",
"Delay",
"Duration",
"AudioAttack",
"AudioDecay",
"RecFields",
"AudioOn",
"AudioStart",
"AudioDuration",
"ClipStartField",
"FadeInVideo",
"MaxDuration",
"VideoSource",
"LoadedSlices",
"OriginalLocation",
"AudioVolume1",
"AudioVolume2",
"AudioPan1",
"AudioPan2",
"PanelMode",
"ColorMode",
"CycleMode",
"DataMode",
"AdjustedVideoStart",
"AdjustedVideoDuration",
"Asynchronous",
"CommandLine",
"SMPTEtime",
"TBarPosition",
"HoldFields",
"TakeOffset",
"ASourceLen",
"BSourceLen",
"AudioFadeFlags",
};

#define	TAGTABLEENTRIES	(sizeof(TagNames)/sizeof(char *))

UBYTE *DumpTagList(UBYTE *ptr)
{
int	i,j,k,l,m,n;
char    mystring[256];

fgets(mystring,256,infile);
while (!feof(infile))
   {
   k = 0;
   l = 0;
   m = 0;
   n = 0;

   for (i=0;i<50;i++)
      {
      if (mystring[i] == '=')
         n = i-4;
      }

   printf("This is %x %s\n",n,mystring);

   for (i=0;i<140;i++)
      {
      if (TagNames[i][0] == mystring[3])
         {
         for (j=1;j<n;j++)
            {
            if (TagNames[i][j] == mystring[3+j])
               k++;
            }
         } 

      if (k == n-1)
         printf("This is i %x L %x M %x %s ",i,l,m,TagNames[i]); 
      k = 0;
      l = 0;
      m = 0;
      }
   printf("%x %s \n",n,mystring);
   fgets(mystring,256,infile);
   n = 0;
   }
}
