/*********************************************************************\
*
* DumpProject - Dump and document a 4.0 Toaster/Flyer project file
*
* Copyright (c) 1995 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/95		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Tags.h"

/*** Prototypes ***/
void EndIt(void);
void DumpProject(UBYTE *ptr, char *name);
void DumpTagList(void);
ULONG ReadFile(char *name, UBYTE **bufferptr);

FILE *infile, *outfile;

/*** Globals ***/
UBYTE	*ProjBuffer;

unsigned char mycool[4];

unsigned legion[100];

unsigned clipname[100];

ULONG mylong;

unsigned char firsttext[48] = {0x50,0x72,0x6F,0x6A,0x65,0x63,0x74,0x00,
                       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,
                       0x84,0x00,0x00,0x77,0x00,0x00,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x96};

unsigned char cliptext[26] = {0x43,0x4c,0x49,0x50,0x00,0x00,0x00,0x00,
                              0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                              0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                              0x00,0x14};              

unsigned char algotext[26] = {0x41,0x4c,0x47,0x4F,0x00,0x00,0x00,0x00,
                              0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                              0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                              0x00,0x22};              
     
main(int argc,char **argv)
{
if (argc!=3)
   {
   printf("Usage: %ls <DumpFile> <ProjFile> \n",argv[0]);
   exit(100);
   }

infile = fopen(argv[1],"r");

outfile = fopen(argv[2],"wb");

DumpProject(ProjBuffer,argv[1]);

fclose(outfile);
}

struct ProjHeader	
   {
   ULONG	ID1,ID2;
   ULONG	Version;
   ULONG	pad[4];
   ULONG	SysTagsSize;
   };

unsigned totally = 0;

struct ProjEntry 
   {
   ULONG	Length;
   ULONG	ObjType;
   ULONG	ObjVersion;
   ULONG	future[4];
   UWORD	NameLength;
   char	Name[0];
   };

void DumpProject(UBYTE *ptr, char *name)
{
DumpTagList();
}

char *TagNames[] = 
   {
   "???",
   "Version",
   "Revision",
   "AAeffect",
   "NonAAeffect",
   "KillInterfaceNonAA",
   "KillInterfaceAA",
   "ButtonELHlogic",
   "CustomButtonELHlogic",
   "NumberOfAnims",
   "RequestFileName",
   "AnimFiles",
   "Frames",
   "FieldSync",
   "VariableSpeeds",
   "ForcePlayForward",
   "ForcePlayReverse",
   "LoopAnims",
   "AnimControl",
   "AudioFastSamples",
   "AudioMediumSamples",
   "AudioSlowSamples",
   "AudioFiles",
   "AudioControl",
   "PauseTimes",
   "LatchColors",
   "TransparentColors",
   "PaletteColors", 
   "Equations",
   "Encoder",
   "VerticalScroll",
   "ReverseTime",
   "ReverseButtLog",
   "ReverseCustomButtLog",
   "KeyMode",
   "MatteColor",
   "CustomMatteColor ",
   "BorderColor",
"CustomBorderColor",
"LineNumbers",
"LineNumberPlane",
"ForceFreeze4",
"ForceFreeze8",
"ForceLive",
"ForceLumKeyOn",
"ForceLumKeyOff",
"ForceLumKeyOnBlack",
"ForceLumKeyOnWhite",
"BadDefaultFX",
"LoadPictures",
"FadeInDuration",
"FadeOutDuration",
"DigitalFX",
"TimeMode",	
"LUT",
"DigitalPairs",
"LatchAM",
"LatchBM",
"LatchIS",
"HonorPreviewOverLay",
"ForceDefaultMatte",
"TurnAudioFilterOff",
"AudioStartField",
"NumAudioFields",
"ISandClipPause",
"Interlaced",
"FirstFieldNTSCII",
"BounceILBM",
"LatchRanges",
"LatchList",
"TransparentRanges",
"TransparentList",
"Color0Transparent",
"AbortIfSlow",
"NumSkipFieldsAtEnd",
"TBarDoesAuto",
"DoNotStompSprite",
"AbortLoopAtEnd",
"NonAAremap",
"100PercentWhiteMatte",
"UseEffectColor",
"LoopCount",	
"CroutonType",
"TimeLine",
"IndexID",
"FCountMode",
"VariableFCount",
"SlowFCount",
"MedFCount",
"FastFCount",
"VariableFCount68000",
"SlowFCount68000",
"MedFCount68000",
"FastFCount68000",
"NumFields",
"StartTime",
"DescriptorList",
"AboutList",
"CommentList",
"AlgoFXtype",
"AlgoFXborder",
"NumFramesSlow",
"NumFramesMedium",
"NumFramesFast",
"NumFramesVariable",
"Page",
"Speed",
"Delay",
"Duration",
"AudioAttack",
"AudioDecay",
"RecFields",
"AudioOn",
"AudioStart",
"AudioDuration",
"ClipStartField",
"FadeInVideo",
"MaxDuration",
"VideoSource",
"LoadedSlices",
"OriginalLocation",
"AudioVolume1",
"AudioVolume2",
"AudioPan1",
"AudioPan2",
"PanelMode",
"ColorMode",
"CycleMode",
"DataMode",
"AdjustedVideoStart",
"AdjustedVideoDuration",
"Asynchronous",
"CommandLine",
"SMPTEtime",
"TBarPosition",
"HoldFields",
"TakeOffset",
"ASourceLen",
"BSourceLen",
"AudioFadeFlags",
};

#define	TAGTABLEENTRIES	(sizeof(TagNames)/sizeof(char *))

void DumpTagList(void)
{
int	i,j,k,m,n,r;
char    mystring[256];
char    chartest[10];
int     header = 0;
long    l;
int     clipfound = 0;

fgets(mystring,256,infile);

while (!feof(infile))
   {
   k = 0;
   l = 0;
   m = 0;
   n = 0;

   for (i=0;i<50;i++)
      {
      if (mystring[i] == '=')
         {
         n = i-4;
         i = 50;
         }
      }

   if (n != 0)
      {
      /* Lets get the number */
      for (i=0;i<10;i++)
          chartest[i] = 0;

      for (i=n+6;i<n+16;i++)
         chartest[i-(n+6)] = mystring[i];

      l = atoi(chartest);
      /* Now get the Name */
      for (i=0;i<140;i++)
         {
         m = strlen(TagNames[i]);
         if (m == n)
            {
            if (TagNames[i][0] == mystring[3])
               {
               for (j=1;j<n;j++)
                  {
                  if (TagNames[i][j] == mystring[3+j])
                     k++;
                  }
               } 
            }

         if (k == n-1)
            {
            printf("This is i %ld L %ld %s ",i,l,TagNames[i]); 
            if (clipfound == 1)
               {
               mycool[0] = 0x85;
               mycool[1] = 0x00;
               mycool[2] = (char)(i >> 8);
               mycool[3] = (char)(i&0x00FF);
               fprintf(outfile,"%c%c%c%c",mycool[0],mycool[1],mycool[2],mycool[3]);
               if (i == 0x78)
                  {
                  r = 22;
                  while (mystring[r] != 0x0A)
                     {
                     fprintf(outfile,"%c",mystring[r]);
                     r++; 
                     }
                  fprintf(outfile,"%c%c",0,0);
                  legion[totally-1] += r-16;
                  }
               else
                  {
                  legion[totally-1] += 8;
                  mycool[0] = 0x00;
                  mycool[1] = 0x00;
                  mycool[2] = (char)(l >> 8);
                  mycool[3] = (char)(l&0x00FF);
                  fprintf(outfile,"%c%c%c%c",mycool[0],mycool[1],mycool[2],mycool[3]);
                  }
               }
            }
         k = 0;
         }
      }
   else
      {
      printf(" No Equals ");
      if (header == 0)
         {
         for (i=0;i<47;i++)
            fprintf(outfile,"%c",firsttext[i]);
         header = 1;
         }
      if (mystring[1] == 'C')
         {
         for (i=0;i<26;i++)
            fprintf(outfile,"%c",cliptext[i]);
         i = 7;
         while (mystring[i] != 0x0A)
            {
            fprintf(outfile,"%c",mystring[i]);
            i++; 
            }
         fprintf(outfile,"%c%c",0,0);
         clipname[totally] = i-5;
         totally++;
         legion[totally-1] = i-5+26;
         clipfound = 1;
         }
      if (mystring[1] == 'A')
         {
         for (i=0;i<25;i++)
            fprintf(outfile,"%c",algotext[i]);
         i = 7;
         while (mystring[i] != 0x0A)
            {
            fprintf(outfile,"%c",mystring[i]);
            i++; 
            }
         fprintf(outfile,"%c%c",0,0);

         clipname[totally] = i-5;
         totally++;
         legion[totally-1] = i-5+26;
         }

      if (mystring[1] == 'S')
         {
         fprintf("%c%c",mystring[7],mystring[8]);
         }
      }

   printf(" %s",mystring);
   fgets(mystring,256,infile);
   }

for (i=0;i<totally;i++)
   printf("%d %x %x \n",i,legion[i],clipname[i]);

}
