;Flyer-Toaster ES Message Programming Example
;by Daniel Wolf 7/4/95
;for MACRO68 Assembler
;1995 by NewTek     


;****************  Preliminaries

;*** Intuition Equates - needed for includes

CUSTOMSCREEN 	EQU $F
ACTIVATE	EQU $1000
DISKINSERTED 	EQU $8000
DISKREMOVED 	EQU $10000
MOUSEBUTTONS 	EQU $8
INTUITICKS 	EQU $400000
NOCAREREFRESH 	EQU $20000
RAWKEY 		EQU $400
GADGETDOWN 	EQU $20
GADGETUP 	EQU $40
RMBTRAP 	EQU $10000
SMART_REFRESH 	EQU $0
BORDERLESS 	EQU $800
BACKDROP 	EQU $100
BOOLGADGET 	EQU $1
GADGHNONE 	EQU $3
GADGIMMEDIATE 	EQU $2


;*** Amiga Includes

 INCLUDE "EXEC.I"		;types.i, ports.i, nodes.i, etc. in one
 INCLUDE "GADGET.I"		;Amiga Gadget basis for FastGadgets

;*** Toaster Includes

 INCLUDE "ELH.I"		;needed for INSTINCT.I
 INCLUDE "VTHAND.I"		;needed for INSTINCT.I
 INCLUDE "EDITSWIT.I"		;Editor-Switcher Message Definitions
 INCLUDE "INSTINCT.I"		;reference to TB_ARexxPort

;*** Private Structure for Local Variables

SOFFSET SET 0
 LONG _STACK
 LONG _DOSBASE
 LONG _TOASTBASE
 LONG COMMAND
 LONG STDOUT
 LONG PUBPORT
 LONG FG				;the FastGadget of the Crouton
SOFFSET SET 0

;*** Amiga Exec and DOS Lib Offsets

LVO.CLOSELIBRARY 	EQU $FFFFFE62
LVO.FINDTASK 		EQU $FFFFFEDA
LVO.OPENLIBRARY 	EQU $FFFFFDD8
LVO.WAITPORT 		EQU $FFFFFE80
LVO.REMOVE		EQU $FFFFFF04
LVO.ADDPORT		EQU $FFFFFE9E
LVO.PUTMSG		EQU $FFFFFE92
LVO.FREESIGNAL 		EQU $FFFFFEB0
LVO.ALLOCSIGNAL 	EQU $FFFFFEB6

LVO.OUTPUT 		EQU $FFFFFFC4
LVO.WRITE 		EQU $FFFFFFD0

;*** Some Useful Macros

SYSLIB MACRO
 move.l $4,a6
 jsr LVO.\1(a6)
 ENDM

DOSLIB MACRO
 move.l _DOSBASE(a5),a6
 jsr LVO.\1(a6)
 ENDM

JUST MACRO
 jsr LVO.\1(a6)
 ENDM

DOSPRINT MACRO   			;*filehandle (d1),*buff (d2), [len (d3)]
 movem.l d0-d3/a0-a6,-(SP)
 move.l \1,d1
 move.l \2,d2
 move.l d2,a0				;put length of null-terminated 
CALC\@					;string into d3 for DOS WRITE command
 tst.b (a0)+
 bne.s CALC\@
 move.l a0,d3
 sub.l d2,d3
 subq.l #1,d3
 DOSLIB WRITE
 movem.l (SP)+,d0-d3/a0-a6
 ENDM

;****************  Program Code

     section code 

_START:					;Amiga Startup Stuff
 lea VARIABLES,a5
 move.l SP,_STACK(a5)          		;save stack pointer
 move.l $4,a6
 move.l a0,COMMAND(a5)         		;save ptr to the clip name!
 cmpi.l #4,d0				;command at least 4 characters long!
 bmi _STARTERROR
 clr.b -1(a0,d0.W)			;null-terminate the command line

 lea _DOSNAME,a1
 moveq #34,d0
 JUST OPENLIBRARY
 move.l d0,_DOSBASE(a5)        		;check for successful open
 beq _STARTERROR

 lea _TOASTNAME,a1
 moveq #0,d0
 JUST OPENLIBRARY
 move.l d0,_TOASTBASE(a5)
 beq _STARTERROR

 DOSLIB OUTPUT
 move.l d0,STDOUT(a5)         		;set CLI window as OUTPUT file handle

NOWDOMAIN
 DOSPRINT STDOUT(a5),#TITLE		;print out program title
 DOSPRINT STDOUT(a5),COMMAND(a5)	;print out clip name from command line
 DOSPRINT STDOUT(a5),#TWOLINE		;do 2 linefeeds and carriage returns

 jsr CROUTONIT				;do the Flyer routines

_ERROR
 move.l d0,-(SP)			;clean up and exit to AmigaDos
 move.l $4,a6
 move.l _TOASTBASE(a5),d0
 beq.s 5$
 move.l d0,a1
 JUST CLOSELIBRARY
5$
 move.l _DOSBASE(a5),d0
 beq.s 9$
 move.l d0,a1
 JUST CLOSELIBRARY
9$
 move.l (SP)+,d0
 move.l _STACK(a5),SP      		;restore stack pointer
 rts                   			;exit back to where we came from!

_STARTERROR
 moveq #$ffffffff,d0
 bra _ERROR


CROUTONIT
 bsr SETUPPORT
 tst.l d0
 beq ERROR				;didnt get our ESMSG port!

 lea MESSAGE,a1				;load the crouton
 move.w #ES_LoadCrouton,ES_Type(a1)
 move.l COMMAND(a5),ES_Data1(a1)
 move.l #1,ES_Data2(a1)
 bsr SENDIT
 move.l ES_Reply(a1),FG(a5)
 beq.s DONE

 move.w #ES_Select,ES_Type(a1)
 move.l FG(a5),ES_Data1(a1)
 bsr SENDIT

 move.w #ES_Auto,ES_Type(a1)		;auto/execute the crouton
 move.l FG(a5),ES_Data1(a1)
 bsr SENDIT

 move.w #ES_FreeCrouton,ES_Type(a1)
 move.w FG(a5),ES_Data1(a1)
 bsr SENDIT

DONE
 tst.l PUBPORT(a5)			;did we make a port?
 beq.s 1$
 move.l PUBPORT(a5),a1
 SYSLIB REMOVE				; if so - remove it from list
 move.l PUBPORT(a5),a0
 moveq #0,d0
 move.b MP_SIGBIT(a0),d0		; and free the ports SIGBIT
 JUST FREESIGNAL
1$
 moveq #0,d0				;all is well
ERROR
 rts

SENDIT
 move.w #EditCookie,ES_Cookie(a1)	;abracadabra
 move.l PUBPORT(a5),MN_REPLYPORT(a1)	;reply to me!
 move.b #NT_MESSAGE,LN_TYPE(a1)
 move.w #128,MN_LENGTH(a1)
 move.l _TOASTBASE(a5),a2
 move.l TB_ARexxPort(a2),a0		;port in a0
 SYSLIB PUTMSG
0$
 move.l PUBPORT(a5),a0
 JUST WAITPORT
 cmpi.l #MESSAGE,d0			;is it our message coming back?
 bne.s 0$				;stupid wait loop
 move.l d0,a1
 cmpi.b #NT_REPLYMSG,LN_TYPE(a1)	;is this a reply to our message?
 bne.s 0$
 rts

SETUPPORT	 			
 move #-1,d0                       	;don't care which sigbit this port gets
 SYSLIB ALLOCSIGNAL	           	;get a sigbit
 move.b d0,d7                      	;stash sigbit
 cmpi.b #-1,d0			   	;if error -
 beq ERR_PORT1 			   	; branch out from here

 lea PORTMEM,a4
 suba.l a1,a1
 JUST FINDTASK                   	;find the task control block and
 move.l d0,MP_SIGTASK(a4)          	;tell port where the tcb is
 move.l #PORTNAME,LN_NAME(a4)           ; and its name
 move.b #0,LN_PRI(a4)			; and its priority
 move.b #NT_MSGPORT,LN_TYPE(a4)  	; and its type
 move.b #PA_SIGNAL,MP_FLAGS(a4)    	; and its flags
 move.b d7,MP_SIGBIT(a4)           	; and which sigbit it got
PUBLICPORT			   	;anything but PUBLIC would be DUMB
 move.l a4,a1                      	;tell ADDPORT where the port is
 JUST ADDPORT                      	;and ADD it
 move.l a4,PUBPORT(a5)        		;and tell this program where it is
 move.l a4,d0				;and return its address
 rts				
ERR_PORT1			   	;if error, set d0 = 0
 moveq #0,d0				;signal allocation failed	
 rts

;****************  Data Section

         section data

 CNOP 0,4
_TOASTNAME: DC.B 'ToasterBase',0

_DOSNAME: DC.B 'dos.library',0

PORTNAME: dc.b 'ESTEST',0

TITLE:    DC.B 13,10,' ESTest by D. Wolf 1995 by NewTek'
TWOLINE:  DC.B 10,13,10,13,0,0,0,0
 
 CNOP 0,4

VARIABLES: DS.l 20		;private (STACK, COMMAND, CMDLEN, etc.)

 CNOP 0,4

MESSAGE:   DS.l 64			;mem for our message

 CNOP 0,4
  
PORTMEM:   DS.l 20			;mem for our message port

 END
