
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction  Action;

FILE *bill;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: PlayClip 0.87";

main(int argc,char **argv)
{
int   vidchan;
ULONG res,theclock;
UWORD Volume;
char buff5[256];
char *tokenpt;
int Volume1, Volume2, Pan1, Pan2;
int vframe,vcount,aframe,acount;
int AudioOn,VideoOn;
int Attack, Decay;
int matte = 0;
int Mode = 0;
int delta = 0;

char filename[100];

if ((argc!=2)||(argv[1][0]=='?'))
   {
   printf("Playclip version 0.87 \n");
   printf("Copyright Prowave 1997\n");
   printf("Usage: %ls <filename>\n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename,tokenpt,99);
tokenpt = strtok(NULL,",");
matte = atoi(tokenpt);
tokenpt = strtok(NULL,",");
time = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
vidchan = atoi(tokenpt)-3;
tokenpt = strtok(NULL,",");
Mode = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
vframe = atoi(tokenpt);
tokenpt = strtok(NULL,",");
vcount = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
aframe = atoi(tokenpt);
tokenpt = strtok(NULL,",");
acount = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
AudioOn = atoi(tokenpt);
tokenpt = strtok(NULL,",");
VideoOn = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
Volume1 = atoi(tokenpt);
tokenpt = strtok(NULL,",");
Volume2 = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
Pan1 = atoi(tokenpt);
tokenpt = strtok(NULL,",");
Pan2 = atoi(tokenpt);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
Attack = atoi(tokenpt);
tokenpt = strtok(NULL,",");
Decay = atoi(tokenpt);

fclose(bill);

printf("File: %s \n",filename);
printf("Video Channel %d \n",vidchan);

printf("Video %d %d \n",vframe,vcount);

printf("Audio %d %d \n",aframe,acount);

printf("Flags %d %d \n",AudioOn,VideoOn);

printf("Vol %d %d \n",Volume1,Volume2);

printf("Pan %d %d \n",Pan1, Pan2);

if ((vidchan > 1) || (vidchan < 0))
   vidchan = 0; 

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

ToasterMux(0,1,1,0);

FlyVol.Path = filename;

FlyVol.Board = 0;

if (Mode != 0)
   {
   if (Mode < 5)
      {
      delta = Mode - 1;
      printf("This is Field and delta %d \n",delta);
      StillMode(0,vidchan,MODE_FIELD);
      }
   else
      {
      delta = (Mode - 5) * 2; 
      StillMode(0,vidchan,MODE_PAIR);
      }
   }     
else
   StillMode(0,vidchan,MODE_FRAME);

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STARTED;

Action.Channel = vidchan;

Action.Flags = CAF_VIDEO;

if (matte == 1)
   Action.Flags |= CAF_USEMATTE; 

if (AudioOn == 15)
   Action.Flags |= CAF_AUDIOL | CAF_AUDIOR; 
if (AudioOn == 11)
   Action.Flags |= CAF_AUDIOR;
if (AudioOn == 7) 
   Action.Flags |= CAF_AUDIOL; 
 
Volume = 0xFFFF;

Action.VidStartField = vframe * 2;

Action.VidFieldCount = vcount * 2 + delta;

Action.VidFieldCount = vcount * 2; 

/* Action.TotalAudStart = */ 
Action.AudStartField = aframe * 2;
/* Action.TotalAudLength = */ 
Action.AudFieldCount = acount * 4;

Action.VolSust1 = Volume1;
Action.VolSust2 = Volume2;
Action.AudioPan1 = Pan1;
Action.AudioPan2 = Pan2;
Action.VolAttack = Attack;
Action.VolDecay = Decay;

/* Additional Action Stuff */


res = FlyerPlay(&Action);
if (res==FERR_OKAY) 
   {
   res = GetFieldClock(&theclock);
   }  

CloseLibrary(FlyerBase);
return(0);
}
