/*********************************************************************\
*
* FSinfo - Show Flyer drive's FileSystem info
*
* $Id: FSinfo.c,v 1.0 1995/05/05 15:50:34 Flick Exp $
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* All information contained herein is property of
* NewTek, Inc. and is subject to change without
* notice.
*
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>

#include "flyerlib.h"
#include "flyer.h"

#define	ID_FLYROOT	0x524f4f54

struct Library		*FlyerBase;
struct FlyerVolume	FlyVol;
struct FlyerVolInfo	Buffer;

main(int argc,char **argv)
{
int	unit,drive;
ULONG	err,meg10;

if ((argc!=2)||(argv[1][0]=='?'))
   {
   printf("Usage: %ls <volume>\n",argv[0]);
   return(20);
   }

FlyVol.Board = 0;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
   {
   printf("Open flyer.library failed\n");
   return;
   }

// FlyVol.SCSIdrive = drive;

FlyVol.Path = argv[1];


Buffer.len = sizeof(struct FlyerVolInfo);		// IMPORTANT!
err = FlyerDriveInfo(&FlyVol,&Buffer);
if (err)
   printf("Error %ld - %ls\n",err,Error2String(err));
else
   {
   if (Buffer.Ident == ID_FLYROOT)
      {
      printf("%lx\n",Buffer.Largest);
      }
   else
      printf("Unformatted\n");
   }

CloseLibrary(FlyerBase);
return(0);
}

