
#include "arexx.h"
#include "arexxsyslib.h"

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction  Action;

BPTR  handle;

#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
   };

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

struct Library *DosBase;

void PlayVideo(UWORD, char *,UWORD); 

void AppendVid(char *, int);

void CheckBar(int);

char pathname[3][100];

float FL_TBAR, FL_DELTA;

struct envtype
   {
   UWORD Frame;
   UWORD Count;
   } Env[256];

FILE *input_file;

ARexxContext rob1;

float TVAL[101] = {  0.0,  5.0, 10.0, 15.0, 20.0, 26.0, 31.0, 36.0, 41.0, 46.0,
                  51.0, 56.0, 61.0, 66.0, 72.0, 77.0, 82.0, 87.0, 92.0, 97.0,
                 102.0,107.0,112.0,118.0,123.0,128.0,133.0,138.0,143.0,148.0,
                 153.0,158.0,164.0,169.0,174.0,179.0,184.0,189.0,194.0,199.0,
                 204.0,210.0,215.0,220.0,225.0,230.0,235.0,240.0,245.0,250.0,
                 256.0,261.0,266.0,271.0,276.0,281.0,286.0,291.0,296.0,301.0,
                 307.0,312.0,317.0,322.0,327.0,332.0,337.0,342.0,347.0,353.0,
                 358.0,363.0,368.0,373.0,378.0,383.0,388.0,393.0,399.0,404.0,
                 409.0,414.0,419.0,424.0,429.0,434.0,439.0,445.0,450.0,455.0,
                 460.0,465.0,470.0,475.0,480.0,485.0,491.0,496.0,501.0,506.0,510.0};

void CGBUS(UWORD, UWORD, UWORD);

ARexxContext rob1;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: RenderFX 2.02 ";

main(int argc,char **argv)
{
struct Library *RexxSysLib = NULL;

UWORD i, Frame1, Frame2;
UWORD Length1,Length2;
UWORD StartFrame1,StartFrame2;
UWORD Novid1, Novid2;
UWORD Type1, Type2;
UWORD looplength, pathcount;
char temp[20];
char outpath[50];
char buff5[256];
char *tokenpt;
UWORD VidQual;
int err;
int TBARVAL, delta;

char number[100];

struct RexxMsg *bill;

LONG result;

UWORD key;

UBYTE QualModes[] = {
   0x00,    // Standard
   0x03,    // Extended
   0x00,    // Audio-only (yuck!)
   0x10};   // HQ5
ULONG res;
UWORD Matte;
UWORD SWIT = 0;
UWORD STYPE, SBUS, SKEY, SLEVEL, SFADE; 
char KEYWORD[100];
UWORD Legend;
UWORD RFX_Type = 0;

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("RenderFX 2.02 \n");
   printf("Copyright Prowave 1997 \n");
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

input_file = fopen(argv[1],"r");
if (input_file == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,49);

tokenpt = strtok(NULL,",");
VidQual = atoi(tokenpt);
tokenpt = strtok(NULL,",");
Matte = atoi(tokenpt);

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(pathname[0],tokenpt,49);
tokenpt = strtok(NULL,",");
Type1 = atoi(tokenpt);
tokenpt = strtok(NULL,",");
StartFrame1 = atoi(tokenpt)/2;
tokenpt = strtok(NULL,",");
Length1 = atoi(tokenpt)/2;

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(pathname[1],tokenpt,49);
tokenpt = strtok(NULL,",");
Type2 = atoi(tokenpt);
tokenpt = strtok(NULL,",");
StartFrame2 = atoi(tokenpt)/2;
tokenpt = strtok(NULL,",");
Length2 = atoi(tokenpt)/2;

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(pathname[2],tokenpt,49);

err = fscanf(input_file,"%s ",temp);
looplength = atoi(temp)/2;

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
pathcount = atoi(tokenpt);
tokenpt = strtok(NULL,",");
RFX_Type = atoi(tokenpt);

for (i=0;i<pathcount;i++)
   {
   fgets(buff5,255,input_file);
   tokenpt = strtok(buff5,",");
   Env[i].Frame = atoi(tokenpt);
   if (RFX_Type == 0)
      Env[i].Frame = Env[i].Frame/2;
   tokenpt = strtok(NULL,",");
   Env[i].Count = atoi(tokenpt);
   }

Legend = StartFrame2;

if (RFX_Type == 1)
   {
   looplength = looplength/2;
   StartFrame1 = StartFrame1/2;   
   Length1 = Length1/2; 
   StartFrame2 = StartFrame2/2;   
   Length2 = Length2/2; 
   }

Frame1 = StartFrame1;
Frame2 = StartFrame2;

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(KEYWORD,tokenpt,49);
if (KEYWORD[0] == 'S')
   {
   SWIT = 1; 
   tokenpt = strtok(NULL,",");
   STYPE = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   SBUS = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   SKEY = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   SLEVEL = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   SFADE = atoi(tokenpt);
   } 

RexxSysLib = OpenLibrary("rexxsyslib.library",0);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

rob1 = ARexxInit("PROWAVE",NULL,FALSE);
if (!rob1)
   printf("We are confused \n");

bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TOSW");
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

key = 0;

if (RFX_Type == 0)
   {
   FL_DELTA = TVAL[Env[1].Count] - TVAL[Env[0].Count];
   FL_DELTA = FL_DELTA/((float)(Env[1].Frame-Env[0].Frame)*4.0);
   FL_TBAR = TVAL[Env[key].Count];
   TBARVAL = (int)TVAL[Env[0].Count];
   }
else
   {
   FL_DELTA = Env[1].Count - Env[0].Count;
   FL_DELTA = FL_DELTA/((float)(Env[1].Frame-Env[0].Frame));
   FL_TBAR = Env[key].Count;
   TBARVAL = (int)Env[0].Count;
   }

res = FlyerInputSel(0,FI_ToasterMain,FS_ToasterMain);
Delay(1);
if (res)
   {
   CloseLibrary(FlyerBase);
   exit(20);
   }  

if (VidQual >= 0)
   {
   res = VideoCompressModes(0,QualModes[VidQual],4,0);
   Delay(10);         // Allow a few fields of mode-settling
   }   

if (Type1 >  2)
   {
   StartFrame1 = 0;
   Length1 = 0;
   }

if (Type2 >  2)
   {
   StartFrame2 = 0;
   Length2 = 0;
   }

if (Type1 == 2)
   {
   Length1 = 1;
   PlayVideo(0,pathname[0],Frame1);
   Delay(3);
   bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
   if (!bill)
      printf("It didn't work\n");
   else
      result = get_reply(rob1);
   Delay(1);
   bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB3");
   if (!bill)
      printf("It didn't work\n");
   else
      result = get_reply( rob1);
   Delay(1);
   }

if (Type2 == 2)
   {
   Length2 = 1;
   PlayVideo(1,pathname[1],Frame2);
   Delay(3);
   bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV2");
   if (!bill)
      printf("It didn't work\n");
   else
      result = get_reply( rob1);
   Delay(1);
   bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB4");
   if (!bill)
      printf("It didn't work\n");
   else
      result = get_reply( rob1);
   Delay(1);
   }

if ((SWIT == 1) && (STYPE == 0))
   {
   CGBUS(SBUS,SKEY,SLEVEL); 
   }

delta = 0;

if (RFX_Type == 0)
   {
   for (i=0;i<looplength;i++)
      {
      Novid1 = 0;
      Novid2 = 0;
      if (StartFrame1 + Length1 > Frame1)
         PlayVideo(0,pathname[0],Frame1);
      else
         Novid1 = 1;
      if (StartFrame2 + Length2 > Frame2)
         PlayVideo(1,pathname[1],Frame2);
      else
         Novid2 = 1;

      sprintf(number,"RenderFX: %s Frames %d and %d of %d",pathname[2],i*2+1,i*2+2,looplength*2);
      bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,number); 
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply(rob1);

      if (Env[key+1].Frame == i)
         {
         key++;
         FL_DELTA = TVAL[Env[key+1].Count] - TVAL[Env[key].Count];
         FL_DELTA = FL_DELTA/((float)(Env[key+1].Frame-Env[key].Frame)*4.0);
         delta = (int)FL_DELTA;
         FL_TBAR = TVAL[Env[key].Count];
         TBARVAL = (int)FL_TBAR;
         }

      input_file = fopen("ENV:OZ-PanicStop","r");
      if (input_file != NULL)
         { 
         bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"RenderFX: Aborted by Hotkey");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         goto ending;
         }

      Delay(3);

      if (((!((TBARVAL > 509) && (delta == 0))) && (Novid1 == 0)) || ((SWIT==1)&&(Type1<2)))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply(rob1);

         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB3");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((!((TBARVAL < 1) && (delta ==0))) && (Novid2 == 0))
         {
        
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV2");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);

         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB4");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV2");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      if (Type2 == 4)
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PBKG");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         }

      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      if (Type1 == 4)
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MBKG");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         }

      if ((Type2 == 5)&&((delta != 0)||(TBARVAL != 0))) 
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         sprintf(number,"%d",Legend);
         bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number);
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"DOEN");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(5);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      res = RecordMode(0);
      Delay(1);
      if (res) 
         {
         printf("\nError %ld - %ls\n",res,Error2String(res));
         }   

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      if (FL_DELTA != 0)
         AppendVid(outpath,1); 
      else
         {
         AppendVid(outpath,4);
         goto veryquick;
         }

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;

      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;

      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
   
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
   
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      veryquick:
      res = PlayMode(0); 
      if (res) 
         printf("This is superwidget \n");

      Delay(5);   
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);
   
      Frame1++;
      Frame2++;
      }
   }
else
   {  /* Wizard */
   for (i=0;i<looplength;i++)
      {
      Novid1 = 0;
      Novid2 = 0;

      if (StartFrame1 + Length1 > Frame1)
         {
         PlayVideo(0,pathname[0],Frame1);
         }
      else
         Novid1 = 1;

      if (StartFrame2 + Length2 > Frame2)
         PlayVideo(1,pathname[1],Frame2);
      else
         Novid2 = 1;

      sprintf(number,"RenderFX: %s Frames %d and %d of %d",pathname[2],i*2+1,i*2+2,looplength*2);
      bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,number); 
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply(rob1);

      if (Env[key+1].Frame == i*4)
         {
         key++;
         FL_DELTA = Env[key+1].Count - Env[key].Count;
         FL_DELTA = FL_DELTA/((float)(Env[key+1].Frame-Env[key].Frame));
         delta = (int)FL_DELTA;
         FL_TBAR = Env[key].Count;
         TBARVAL = (int)FL_TBAR;
         }

      input_file = fopen("ENV:OZ-PanicStop","r");
      if (input_file != NULL)
         { 
         bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"RenderFX: Aborted by Hotkey");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         goto ending;
         }

      Delay(3);

      if ((Novid1 == 0) || ((SWIT==1)&&(Type1<2)))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply(rob1);

         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB3");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if (Novid2 == 0)
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV2");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);

         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"GRB4");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV2");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      if (Type2 == 4)
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PBKG");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         }

      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      if (Type1 == 4)
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MBKG");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         }

      if ((Type2 == 5)&&((delta != 0)||(TBARVAL != 0))) 
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         sprintf(number,"%d",Legend);
         bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number);
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"DOEN");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(5);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      res = RecordMode(0);
      Delay(1);
      if (res) 
         {
         printf("\nError %ld - %ls\n",res,Error2String(res));
         }   

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      if (Env[key+1].Frame == i*4+1)
         {
         key++;
         FL_DELTA = Env[key+1].Count - Env[key].Count;
         FL_DELTA = FL_DELTA/((float)(Env[key+1].Frame-Env[key].Frame));
         delta = (int)FL_DELTA;
         FL_TBAR = Env[key].Count;
         TBARVAL = (int)FL_TBAR;
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;

      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      if (Env[key+1].Frame == i*4+2)
         {
         key++;
         FL_DELTA = Env[key+1].Count - Env[key].Count;
         FL_DELTA = FL_DELTA/((float)(Env[key+1].Frame-Env[key].Frame));
         delta = (int)FL_DELTA;
         FL_TBAR = Env[key].Count;
         TBARVAL = (int)FL_TBAR;
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
   
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      if ((Matte > 0) && (FL_DELTA < 0.0))
         {
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
         if (!bill)
            printf("It didn't work\n");
         else
            result = get_reply( rob1);
         Delay(1);
         }

      if ((SWIT == 1) && (STYPE == 1))
         {
         CGBUS(SBUS,SKEY,SLEVEL); 
         }

      if (Env[key+1].Frame == i*4+3)
         {
         key++;
         FL_DELTA = Env[key+1].Count - Env[key].Count;
         FL_DELTA = FL_DELTA/((float)(Env[key+1].Frame-Env[key].Frame));
         delta = (int)FL_DELTA;
         FL_TBAR = Env[key].Count;
         TBARVAL = (int)FL_TBAR;
         }

      FL_TBAR = FL_TBAR + FL_DELTA;
      TBARVAL = (int)FL_TBAR;
   
      if (TBARVAL > 510)
         TBARVAL = 510;
      if (TBARVAL < 0)
         TBARVAL = 0;
      sprintf(number,"%d",TBARVAL);
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);

      Delay(1);
      AppendVid(outpath,1); 

      veryquick2:
      res = PlayMode(0); 
      if (res) 
         printf("This is superwidget \n");

      Delay(5);   
      bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
      if (!bill)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);
   
      Frame1++;
      Frame2++;
      }
   }

bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"RenderFX: Complete");
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

ending:

bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONSINPROJECT",RXFF_RESULT,0);
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

ARexxFree(rob1);

if (RexxSysLib)
   CloseLibrary(RexxSysLib);

CloseLibrary(FlyerBase);
}

void CGBUS(UWORD SBUS, UWORD SKEY, UWORD SLEVEL)
{

char number[10];

struct RexxMsg *bill;

LONG result;

switch (SBUS)
   {
   case(1):
      sprintf(number,"O001");
      break;
   case(2):
      sprintf(number,"O002");
      break;
   case(3):
      sprintf(number,"O003");
      break;
   case(4):
      sprintf(number,"O004");
      break;
   case(5):
      sprintf(number,"ODV1");
      break;
   case(6):
      sprintf(number,"ODV2");
      break;
   case(7):
      sprintf(number,"OBKG");
      break;
   }

bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,number);
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

switch (SKEY)
   {
   case(0):
      sprintf(number,"KOFF");
      break;
   case(1):
      sprintf(number,"KBLK");
      break;
   case(2):
      sprintf(number,"KWHT");
      break;
   }


bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,number);
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

sprintf(number,"%d",SLEVEL);
bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"CLIP",number);
if (!bill)
   printf("It didn't work\n");
else
   result = get_reply( rob1);

}

void PlayVideo(UWORD vidchan, char *pathname,UWORD cframe) 
{
ULONG res;
UWORD Volume;

ToasterMux(0,1,1,0);

FlyVol.Path = pathname;
FlyVol.Board = 0;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STOPPED;

Action.Channel = vidchan;
Action.Flags = CAF_VIDEO;

Volume = 0xFFFF;

Action.VidStartField = cframe * 4;
Action.VidFieldCount = 4;
Action.TotalAudStart = Action.AudStartField = cframe * 4;
Action.TotalAudLength = Action.AudFieldCount = 4;

Action.VolSust1 = 0;
Action.VolSust2 = 0;
Action.AudioPan1 = 0;
Action.AudioPan2 = 0;

res = FlyerPlay(&Action);
if (res) 
   {
   printf("This is superwidget \n");
   printf("\nError %ld - %ls\n",res,Error2String(res));
   }  
}

void AppendVid(char *outpath, int count)
{

ULONG res;
int fields;

fields = count;

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.SCSIdrive = 0;
FlyVol.Path = outpath;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STOPPED;

Action.Channel = 0;

/* These flags are currently ignored */
Action.Flags = CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

Action.VidFieldCount = Action.AudFieldCount = fields;

Action.VolSust1 = 0xFFFF;     // Unimportant
Action.VolSust2 = 0xFFFF;     // "
Action.VidStartField = 0;     // "

res = AppendFields(&Action);
if (res) 
   {
   printf("This is superwidget \n");
   printf("\nError %ld - %ls\n",res,Error2String(res));
   }
}

LONG get_reply(ARexxContext  context)
{
   struct RexxMsg   *reply;
   unsigned long    i;
   LONG             temp_code;

   /* poll for reply */
   i=0;
      while ( ((reply = GetARexxMsg(context)) == NULL) && (++i < 1000) )
      {
      Delay(1);
      }
 

   if (i == 1000)
   {
      printf("timeout\n");
      /* did not get a response in a long time, just return */
      return(0);
   }
   else
   {
            if (IsARexxReply( reply) )
            { 
         temp_code = reply->rm_Result1;

         FreeARexxMsg(context, reply);
      }
      /* otherwise, don't care */
   }
   return( temp_code);
}

ARexxContext ARexxInit(char *name, char *extension, BOOL multiple)
{
struct Library *RexxSysBase;
struct MsgPort *port;
ARexxContext  context;
unsigned count;
char  *ptr;

context = AllocMem(sizeof(struct ARexxContext), MEMF_PUBLIC | MEMF_CLEAR);

if (!context)
   return(NULL);

RexxSysBase = OpenLibrary((UBYTE *) "rexxsyslib.library",0L);

if (RexxSysBase)
   {
   context->rexx_base = RexxSysBase;
   if (!extension)
      extension = "rexx";
   StrNUpper(context->extension, extension, MAX_EXTENSION);
   ptr = StrNUpper(context->port_name, name, MAX_PORT_NAME);

   Forbid();
   if (multiple)
      {
      *ptr++='.';
      for (count = 1; count < 100; ++count)
         {
         UiToStr(count, ptr);
         port = FindPort((UBYTE *) context->port_name);
         if (!port) break;
         }
      }
   else
      {
      port = FindPort((UBYTE *) context->port_name);
      }

   if (!port)
      context->arexx_port = CreatePort ((UBYTE *) context->port_name,0);
   Permit();
   }

if (!context->rexx_base || !context->arexx_port)
   {
   ARexxFree(context);
   context = NULL;
   }

return(context);
}

void ARexxFree (ARexxContext context)
{
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context)
   return;

if (context->rexx_base)
   {
   RexxSysBase = context->rexx_base;
   context->port_name[0] = NULLCHAR;
   while (context->outstanding > 0 && context->arexx_port != NULL)
      {
      WaitPort(context->arexx_port);
      while ((msg = GetARexxMsg(context) ) != NULL)
         {
         if (!FreeARexxMsg(context, msg))
            ReplyARexxMsg(context, msg, 100, NULL, 0);
         }
      }
   if (context->arexx_port)
      {
      Forbid();
      while ((msg = GetARexxMsg(context)) != NULL)
         ReplyARexxMsg(context, msg, 100, NULL, 0);
      DeletePort(context->arexx_port);
      Permit();
      }
   CloseLibrary(RexxSysBase);
   }

FreeMem(context, sizeof(struct ARexxContext));

}

char *ArexxName(ARexxContext context)
{
if (context)
   return(context->port_name);
else
   return(NULL);
}

ULONG ARexxSignal(ARexxContext context)
{
if (context)
   return(1UL << context->arexx_port->mp_SigBit);
else
   return(0);
}

struct Library *ARexxBase(ARexxContext context)
{
if (context)
   return(context->rexx_base);
else
   return(NULL);
}

BOOL IsARexxReply( struct RexxMsg *msg)
{
if (msg)
   return( (BOOL)(msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG ));
else
   return(FALSE);
}

struct RexxMsg *GetARexxMsg(ARexxContext context)
{
struct RexxMsg *msg;

if (!context)
   return(NULL);

msg = (struct RexxMsg *) GetMsg(context->arexx_port);

if (!msg)
   return(NULL);

if (IsARexxReply(msg))
   --context->outstanding;

return(msg);
}

BOOL FreeARexxMsg(ARexxContext context, struct RexxMsg *msg)
{
struct Library *RexxSysBase;

if (!context || !msg)
   return(FALSE);

if (!IsARexxReply(msg))
   return(FALSE);

RexxSysBase = context->rexx_base;

ClearRexxMsg(msg, 16);

if (msg->rm_Result1 == 0 && msg->rm_Result2 != NULL)
   DeleteArgstring((char *) msg->rm_Result2);

DeleteRexxMsg(msg);

return(TRUE);

}

struct RexxMsg *SendARexxMsg(ARexxContext context, char *port_name,
              char *command, ULONG flags)
{
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context || !command)
   return(NULL);

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
              context->port_name);

if (!msg)
   return(NULL);

flags &= ( RXFF_NOIO | RXFF_RESULT | RXFF_STRING | RXFF_TOKEN );

msg->rm_Action = RXCOMM | flags;

msg->rm_Args[0] = (STRPTR) CreateArgstring(command, strlen(command));

msg->rm_Result1 = 0;

msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port = FindPort((UBYTE *) port_name )) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   DeleteArgstring((char *) msg->rm_Args[0]);
   DeleteRexxMsg(msg);
   msg = NULL;
   }

Permit();
return(msg);

}


struct RexxMsg *CallARexxFunc (ARexxContext context, char *port_name,
       char *function, ULONG flags, int num_args, ...)
{
va_list        argptr;
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;
BOOL   quit;
int   i;
char *arg;

if (!context || !function || num_args < 0)
   return(NULL);

if (num_args > 15)
   num_args = 15;

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
            context->port_name);

if (!msg)
   return(NULL);

flags &= (RXFF_NOIO | RXFF_RESULT | RXFF_STRING);

msg->rm_Action = RXFUNC | flags;

msg->rm_Action |= ( num_args & RXARGMASK);

msg->rm_Args[0] = (STRPTR) CreateArgstring(function, strlen(function));

msg->rm_Result1 = 0;
msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

va_start (argptr, num_args);

for (i=1, quit=FALSE; i<= num_args && !quit; ++i)
   {
   arg = (char *) va_arg(argptr, char *);

   if (!arg)
      arg = "";

   msg->rm_Args[i] = (STRPTR) CreateArgstring(arg, strlen(arg));

   if (!msg->rm_Args[i])
      quit = TRUE;

   }

va_end(argptr);

if (quit)
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port=FindPort((UBYTE *) port_name)) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   msg = NULL;
   }


Permit();

return(msg);

}


BOOL  ReplyARexxMsg( ARexxContext context,  struct RexxMsg  *msg,
                     LONG return_code,  char *result_string,
                     LONG error_code)
{

   struct Library  *RexxSysBase;

   if ( !context || !msg )
      return( FALSE );

   if ( IsARexxReply (msg) )
      return( FALSE );

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Set the results */

   msg->rm_Result1 = return_code;
   msg->rm_Result2 = (LONG) NULL;

   /* if no error and result was requested, set the result string */

   if ( result_string != NULL && return_code == RC_OK
        && (msg->rm_Action & RXFF_RESULT) != 0 )
      {
       msg->rm_Result2 = (LONG) CreateArgstring( result_string,
                                 strlen( result_string) );
      }
   else if  (return_code != RC_OK)
      {
         msg->rm_Result2 = error_code;
      }

   ReplyMsg( (struct Message *)msg );

   return(TRUE);
}

BOOL AddFuncHost (ARexxContext context,  LONG priority)
{

   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if( !context )
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Get a new message packet */

   msg = CreateRexxMsg( context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);


   msg->rm_Action = RXADDFH | RXFF_NONRET;
   msg->rm_Args[0] = (STRPTR) context->port_name;
   msg->rm_Args[1] = (STRPTR) priority;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX" ) ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg( msg );
      msg = NULL;
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}


BOOL RemFuncHost( ARexxContext context)
{
   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if (!context)
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* get a new message packet */

   msg = CreateRexxMsg (context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);

   /* tell the resident process to remove the port name to the Library
    * List... we don't expect a reply
    */

   msg->rm_Action   = RXREMLIB | RXFF_NONRET;
   msg->rm_Args[0]  = (STRPTR)  context->port_name;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX") ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg (msg);
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}

BOOL  SetARexxLastError( ARexxContext context, struct RexxMsg *msg,
                        char *error)
{

      return(FALSE);

}




static char *StrNUpper( char *dest,  char *src,  unsigned int len)
{

   for( ; *src != NULLCHAR && len-- > 0; ++src)
   {
      if (islower (*src))
         *dest++ = toupper( *src );
      else
         *dest++ = *src;
   }

   *dest = NULLCHAR;

   return(dest);
}



static char *UiToStr( unsigned num, char *buf)
{
   num %= 100;

   buf[0] = (num / 10) + '0';
   buf[1] = (num % 10) + '0';
   buf[2] = NULLCHAR;

   return(buf);
}



