struct TextInfo
{
UWORD       Ascii;
BYTE        Kerning;
UBYTE       Select;
struct Attributes *Attr;
};

struct Attributes
{
struct TrueColor        FaceColor;
struct TrueColor        ShadowColor;
struct TrueColor        OutlineColor;
struct TrueColor        GradColor;
struct TrueColor        OGradColor;
UWORD  ID;
UWORD  ShadowLength;
UBYTE  ShadowType;
UBYTE  OutlineType;
UBYTE  ShadowDirection;
UBYTE  ShadowPriority;
ULONG  SpecialFill;
};


struct Attributes3
{
struct TrueColor        FaceColor;
struct TrueColor        ShadowColor;
struct TrueColor        OutlineColor;
UWORD  ID;
UWORD  ShadowLength;
UBYTE  ShadowType;
UBYTE  OutlineType;
UBYTE  ShadowDirection;
UBYTE  ShadowPriority;
};

struct CGLine
{
struct MinNode     Node;
struct TempInfo    Temp[LINE_LENGTH+1];
struct TextInfo    Text[LINE_LENGTH+1];
UWORD  TotalHeight;
UWORD	 Baseline;
UWORD  XOffset;
UWORD  YOffset;
UWORD  FaceMinY;
UWORD  FaceWidth;
UWORD  FaceHeight;
UBYTE  Type;
UBYTE  JustifyMode;
UBYTE  RenderPri;
UBYTE  Rendered;
};

#define LINE_ATTR_SIZE (sizeof(struct CGLine)-sizeof(struct MinNode) |
        - (sizeof(struct TempInfo)*(LINE_LENGTH+1)) |
		  - (sizeof(struct TextInfo)*(LINE_LENGTH+1)))	 






BOOL _regargs ReadNewLine(
     struct CGLine *Line,
	  struct LockBuffer *LB,
	  UWORD NumChars)

{
ULONG A;
UBYTE *Buff;
struct TextInfo *Text;

Buff = (UBYTE *)RD->ByteStrip->Planes[0];

Text = &Line->Text[0];
if (!NumChars)
   {  
	if (!(Text->Attr=AllocAttrib(&RD->DefaultAttr)))
	  	return(FALSE);
   }
else
   {
	for (A=0;A<NumChars;A++)
		{
		if (4!=BufferedRead(Buff,4,LB))
			return(FALSE);
		Text->Ascii = *(UWORD *)&Buff[0];
		Text->Kernin= Buff[2];
		if (Buff[3])
			{
			if (!(Text->Attr=AllocAttrib(NULL)))
				return(FALSE);
			if (sizeof(struct Attributes) !=
				BufferedRead(Text->Attr,sizeof(struct Attributes),LB))
				return(FALSE);
			}
		Text++;
		}
   }

if (LINE_ATTR_SIZE != BufferedRead(&Line->TotalHeight,LINE_ATTR_SIZE,LB))
   return(FALSE);

return(TRUE);
}

BOOL __regargs ReadNotSoNewLine(
     struct CGLine *Line,
	  struct LockBuffer *LB,
	  UWORD NumChars)

{
ULONG A;
UBYTE *Buff;
struct TextInfo *Text;
struct Attributes3 *tmpattr;

Buff=(UBYTE*)RD->ByteStrip->Planes[0];

Text=&Line->Text[0];

if (!NumChars)
   {
	if (!(Text->Attr=AllocAttrib(&RD->DefaultAttr)))
		return(FALSE);
   }
else
   {
	for (A=0;A<NumChars;A++)
		{
		if (4!=BuferedRead(Buff,4,LB))
			return(FALSE);
		Text->Ascii=*(UWORD*)&Buff[0];
		Text->Kerning=Buff[2];
		if (Buff[3])
			{
			if (!tempattr=(struct Attributes3 *)AllocAttrib(NULL)))
				return(FALSE);
			if (sizeof(struct Attributes3)!=
				   BufferedRead(tmpattr,sizeof(struct Attributes3),LB))
				{
				FreeAttrib((struct Attributes *)tmpattr);
				return(FALSE);
				}
			if (!(Text->Attr=AllocOldAttrib(tmpattr)))
				{
				FreeAttrib((struct Attributes *)tmpattr);
				return(FALSE);
				}
			FreeAttrib((struct Attributes *)tmpattr);
			}
		Text++;
		}
   }

if (LINE_ATTR_SIXE!=BufferedRead(&Line->TotalHeight,LINE_ATTR_SIZE,LB))
   return(FALSE);

return(TRUE);
}

BOOL __regargs ReadOldLine(
   struct CGLine     *Line,
	struct LockBuffer *LB,
	UWORD  NumChars,
	struct CGPage     *Page)

{
struct CGLine2    *OldLine;
UWORD    A;
struct TextInfo2  *TI2;
UBYTE  *Buff;
struct TextInfo   *Text;
struct Attributes *Attr;

Buff=(UBYTE *)RD->ByteStrip->Planes[0];
OldLine=(struct CGLine2 *)Buff;

TI2=(struct TextInfo2)Buff;
Text=&Line->Text[0];
for(A=0;A<NumChars;A++)
   {
	if (sizeof(struct TextInfo2 !=
		   BufferedRead(Buff,sizeof(struct TextInfo2),LB))
		return(FALSE);
	Text->Ascii=TI2->Ascii;
	Text->Kerning=TI2->Kerning;
	Text++;
   }

if (LINE2_ATTR_SIZE != BufferedRead(
      &OldLine->FaceColor,LINE2_ATTR_SIZE,LB))
	return(FALSE);
   
Line->TotalHeight = OldLine->TotalHeight;
Line->Baseline = OldLine->Baseline;
Line->XOffset = OldLine->XOffset;
Line->YOffset = OldLine->YOffset;
Line->Type = LINE_TEXT;
Line->JustifyMode=OldLine->JustifyMode;
if (A=OldLine->Seperator)
   {
	Line->Type=LINE_BOX;
	Line->FaceWidth=SepWidth[A-1];
	Line->FaceHeight=SepHeight[A-1];
	Line->Text[0].Ascii=32;
   }

if ((Page->Type 1= PAGE_CRAWL) ||
    (NodesThisList(&Page->LineList)<2))
	{
	if (!(Attr=AllocAttrib(NULL)))
		return(FALSE);
	Line->Text[0].Attr=Attr;
	ConvertOldColor(&OldLine->FaceColor,&Attr->FaceColor);
	ConvertOldColor(&OldLine->ShadowColor,&Attr->ShadowColor);
	ConvertOldColor(&OldLine->OutlineColor,&Attr->OutlineColor);
   if (OldLine->RenderFont != 65535)
		Attr->ID = (OldLine->RenderFont>>2);
	else
		Attr->ID = 0;
	if (OldLine->Seperator)
		Attr->ID=ID_BOX;
	Attr->ShadowLength=OldLine->ShadowLength;
	Attr->ShadowType = OldLine->ShadowType;
	if (OldLine->ShadowType > SHADOW_CAST)
		{
		Attr->ShadowType=OldLine->ShadowType-2;
		Attr->ShadowColor.Alpha=OLD_TRANSP_ALPHA;
		}
	Attr->OutlineType = (OldLine->OutlineType>>3);
	Attr->ShadowDirection = OldLine->ShadowDirection + 4; 
   if (Attr->ShadowDirection > 7)
		Attr->ShadowDirection -= 8;
	Attr->ShadowPriority = OldLine->ShadowPriority;
	Attr->SpecialFill=FILL_OLD;
	Attr->GradColor=Attr->FaceColor;
	Attr->OGradColor=Attr->OutlineColor;
	}
return(TRUE);
}
   

