
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

#define	MONOAUDFLDSIZE		3
#define	NUMAUDCHANS			2
#define	SAMPLESPERFIELD	735	// Audio samples per video field

struct Library *FlyerBase;

UBYTE BlkBuff[512];

UWORD	AudioBuff[8][256*MONOAUDFLDSIZE];

UWORD BillStereo;

UWORD Rate;

UWORD size;

/* Prototypes */
ULONG WriteTestClip(char *, ULONG, FILE *);

ULONG Reprocess(char *, ULONG);

/* Function Prototypes */
int IFFencode(FILE *);

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: StealAudio 1.00";

int getdata(char *ptr, int nbytes, FILE *IN);
void error(char *msg, int code);
/* here for linear interp.  might be useful for other things */
gcd(a, b) 
long a, b;
{
if (b == 0)
   return a;
else
   return gcd(b, a % b);
}

lcm(a, b) 
long a, b;
{
return (a * b) / gcd(a, b);
}

void main(int argc, char **argv)
{
FILE *Infile, *tempfile;
BPTR Outfile;
UWORD temp;
UWORD notthere;
ULONG temp2, temp3;
ULONG err, frames;
char filename[2][80];
char buff5[256];
char *tokenpt;

tempfile = fopen(argv[1],"r");
if (tempfile == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

fgets(buff5,255,tempfile);
tokenpt = strtok(buff5,",");
strncpy(filename[0],tokenpt,99);

fgets(buff5,255,tempfile);
tokenpt = strtok(buff5,",");
strncpy(filename[1],tokenpt,99);

Infile = fopen (filename[0], "rb");
if (!Infile)
   {
   puts ("Input File open failed.");
   exit(5);
   }

Outfile = Open(filename[1], MODE_NEWFILE);
if (!Outfile)
   {
   puts("Output File open failed.");
   exit(5);
   }

getdata((char *)&temp,2,Infile);
notthere = 0;

while (notthere == 0)
   {
   while (temp != 0x464F)
      getdata((char *)&temp,2,Infile);
   getdata((char *)&temp,2,Infile);
   getdata((char *)&temp2,4,Infile);
   getdata((char *)&temp3,4,Infile);
   if (temp3 == 0x38535658)
      {
      notthere = 1;
      }
   }

if (notthere == 1)
   {
   if (FlyerBase = OpenLibrary(FLYERLIBNAME,0)) 
      {
      frames = IFFencode(Infile);
      err = WriteTestClip(filename[1],frames,Infile);
      if (err == 0) 
         {
         err = Reprocess(filename[1],frames);		// Let Flyer process into full clip
         }
      CloseLibrary(FlyerBase);
      }
   }

fclose (Infile);

/* Close (Outfile); */

exit (0);
}

int getdata(char *ptr, int nbytes, FILE *IN)
{
int count;

for (count = 0; count < nbytes; count++) 
   {
   *(ptr+count) = getc(IN);
   if (ferror(IN))
      error("error reading from file",0);
   }

return(0);
}

void error(char *msg, int code)
{
printf("\nError code %4i \n",code);
printf("%s",msg);
exit(code);
}

/*******************************************************/

int IFFencode(FILE *IN)
{
long inlength;             /* Length of input file (in bytes) */
UWORD temp;
long dLen;
ULONG test;

printf("We have reached IFFencode\n");
getdata((char *)&test,4,IN);
while (test != 0x56484452)
   getdata((char *)&test,4,IN);

printf("We have found VHDR\n");

getdata((char *)&test,4,IN);

getdata((char *)&dLen,4,IN);

getdata((char *)&test,4,IN);
getdata((char *)&test,4,IN);

getdata((char *)&Rate,2,IN);

printf("let's set BillStereo value\n");

BillStereo = 1;

getdata((char *)&temp,2,IN);
while (temp != 0x424F) 
   getdata((char *)&temp,2,IN);

getdata((char *)&temp,2,IN);
while (temp != 0x4459)
   getdata((char *)&temp,2,IN);

printf("We found the Body\n");

temp = Rate/15;

inlength = (dLen/temp);
if (dLen%temp != 0)
   inlength++;

size = 1;

printf("dLen(words): %ld\n",dLen);
printf("Number of Frames: %d\n",inlength); 
printf("Rate %d\n",Rate);
printf("Channels %d\n",BillStereo);
return(inlength);
}

ULONG WriteTestClip(char *pathname, ULONG frames, FILE *IN)
{
int	i,j,k;
ULONG	frm;
BPTR	handle;
struct ClipHeader		*ch;
struct FrameHeader	*fh;
struct Field			*fld;
UWORD temp, temp2;

ULONG Istep,Ostep,Ipos,Opos,lcmnum;

handle = Open(pathname,MODE_NEWFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

lcmnum = lcm(44100,Rate); 

Istep = lcmnum/Rate;

Ostep = lcmnum/44100;

Opos = Ipos = 0;

for (frm=0 ; frm<frames ; frm++) 
   {
   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;
   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (i=0;i<4;i++) 
      {
      fld = &fh->fields[i];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   /* Write all audio data for this color frame */
   for (i=0 ; i<NUMAUDCHANS; i++) 
      {
      for (j=0 ; j<4 ; j++) 
         {
         if (i == 0)
            {           
            for (k=0 ; k<SAMPLESPERFIELD ; k++)
               {
               if ((Ipos + Istep) <= Opos)
                  { 
                  getdata((char *)&temp,size,IN);
                  if (BillStereo == 2)
                     getdata((char*)&temp2,size,IN);
                  Ipos += Istep;          
                  }
               AudioBuff[j][k] = temp;   
               if (BillStereo == 1)
                  AudioBuff[j+4][k] = AudioBuff[j][k];
               else
                  AudioBuff[j+4][k] = temp2;
               Opos += Ostep;
               if (Opos == Ipos)
                  Opos = Ipos = 0;
               }
            }
	 }
      }
   if (Write(handle,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   }

Close(handle);

return(0);		// Okay
}

// Reprocess -- Let Flyer re-process our clip to build all the reserved
//					structures needed.  These are quite technical (as well as
//					being private), so we'll let it do the work for us.  We
//					just provide a clip that has the minimal stuff needed.
//					This, obviously, requires that the clip was written to
//					a Flyer drive.  If not, you should copy the "skeletal"
//					clip file to a Flyer drive first, then do this function.
ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!
if (NUMAUDCHANS == 2)
   actptr->Flags |= CAF_AUDIOL | CAF_AUDIOR;
else
   actptr->Flags |= CAF_AUDIOL;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}

