*********************************************************************
* rect.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: rect.i,v 2.2 93/12/02 20:48:32 Kell Exp $
*
* $Log:	rect.i,v $
*Revision 2.2  93/12/02  20:48:32  Kell
*Now has structures for dynamic Fader/LumKey/TBarTime/BMposition.
*New structures for new types of motion for 4.0
*
*Revision 2.1  93/11/06  08:45:51  Kell
*Fixed double defined label (structure name)
*
*Revision 2.0  92/05/18  21:23:54  Hartford
**** empty log message ***
*
*********************************************************************
	IFND	RECT_I
RECT_I	SET	1

* if >0 do ELH
* if 3 = first
* if 5 = last

FIELDDURING	EQU	0	;transformed to DOELH or NOELH via ProcessDuring()
FIELDNOELH	EQU	0	;during stage, no elh
FIELDDOELH	EQU	1	;during stage, do elh
FIELDFIRST	EQU	3	;1st of stage, do elh
FIELDLAST	EQU	5	;may do take, do elh
FIELDREDO	EQU	7	;redraw as LAST, with elh, but logic of FIRST

DIGOFFSET	SET 	-3	;relation of source to dest quad position
QUAFBYTE	SET	$ff	;transparent digital quad 

**********************************************************
	STRUCTURE	ScaleData,0

;I don't see much use in border that has a non-constant thickness, but
;maybe this could be used in advanced drop shadows someday.
	  WORD  SD_borderUpper	;thickness of border, in destin. resolution
	  WORD  SD_borderLower	;thickness of border, in destin. resolution
	  WORD  SD_position	;position of srcaxis with respect to destaxis, 
				;in destination resolution

;source cropping and scaling axis placement.
;Source cropping on Y sources is a bit weird because of the EVENODD
;rule. So you may need to "undercut" to avoid Y scaling from falling off edge.
	  WORD	SD_srcMin	;minimum address to ever use from source
	  WORD	SD_srcMax	;maximum address to ever use from source
	  WORD	SD_srcAxis	;axis to scale from

;NOTE!!!!! At the current time, maybe srcAxis has to lie between srcMin and
;srcMax inclusive ?????
;It crashed when I tried Min/Max/Axis = SXAXIS/SXMAX/SXMIN

;Y scaling will require two srcAxis, an even and an odd one.  So this
;SD_srcAxis will be one of them, and SD_srcAxis+1 will be the other!

;destination cropping, defines useful underscan area
	  WORD	SD_destMin	;minimum address to ever use in destination
	  WORD	SD_destMax	;maximum address to ever use in destination
	  WORD	SD_destAxis	;display coordinate origin.

	  WORD  SD_effectSize	;width or height of effect, in dest resolution
;effectSize is place here because it has to be after srcMax & srcMin have
;been defined. Because srcSize may effect effectSize.

;the effect&bordercolors are ignored for DVE Input Effects, i.e. Trails.
;but backgroundColor is looked at when horizontal scaling.
;if vertical scaling, give least of two source lines.
	  WORD  SD_effectColor	   ;>0 color of effect, -1=skip effect, 0=doit
	  WORD  SD_borderColor	   ;color of border, -1=skip border
	  WORD  SD_backgroundColor ;color of background, -1=skip bg
;currently overscancolor is not utilized
          WORD  SD_overscanColor   ;color of overscan area, -1=skip os	

;the Scale routine will determine the remaining elements in this structure.
	  WORD  SD_rectMin	;minimum/maximum destination addresses that
	  WORD	SD_rectMax	;have an effect element, on or off screen.

	  WORD  SD_effectMin    ;min/max on screen destination address that
	  WORD  SD_effectMax	;has a scaled effect.  Is not altered by borders.
				;=-1 if no scaled effect on screen.
				;Useful for pixelizing all but borders.
		
	  WORD  SD_totalMin     ;min/max on screen destination address that
	  WORD  SD_totalMax	;has an effect or borders.  May be altered by
				;border routine. =-1 if nothing on screen.

;parameters to scale from destInit and go upward
	  WORD  SD_destInit	;address of initial destination address
	  LONG  SD_srcInit	;binary real, source initial value
	  LONG  SD_srcInc	;binary real, source incremental value
	  WORD  SD_countUp	;# of points to plot, destInc = 1

;parameters to scale from destInit and go downward
;use neg.l srcInc for downward source incremental value
	  WORD  SD_countDown	;# of points to plot, destInc = -1

	LABEL SD_SIZEOF		   ;size of this structure

***********************************************************************
BYTE_SIZEOF	SET 1
WORD_SIZEOF	SET 2
LONG_SIZEOF	SET 4

* values to use so min/max motion parameters are ignored
MINABSREAL	SET 0		;use this if you have no min limit
MAXABSREAL	SET $7fffffff	;use this if you have no max limit

* All of the variables in the Accelerate/Harmonic structures are
* binary Reals.  
* So that cropping of the source does not cause scaling in the final
* effectSize, changes in crop may tweek sp, by adding
* (srcSizeNew-srcSizeOld) to sp.

	STRUCTURE Linear,0	; mind <= sp*t+id <= maxd 
	  LONG	LM_initDistance
	  LONG	LM_speed
	  LONG	LM_minDistance	;value >= 0
	  LONG	LM_maxDistance  ;value >= 0
	LABEL	LM_SIZEOF	;size of this structure

*-----------------------------------------
* So that cropping of the source does not cause scaling in the final
* effectSize, changes in crop may tweek iv, by adding
* (srcSizeNew-srcSizeOld) to iv.

* (minsp <= ac*t+iv <= maxsp)*t + id
	STRUCTURE Accelerate,0
	  STRUCT AC_accel,LM_SIZEOF
				;LONG	AC_initVelocity
				;LONG	AC_acceleration
	  			;LONG	AC_minSpeed	;min abs(Velocity)
	  			;LONG	AC_maxSpeed	;max abs(velocity)
	  LONG	AC_initDistance	
	LABEL AC_SIZEOF	;size of this structure

*-----------------------------------------	
* So that cropping of the source does not cause scaling in the final
* effectSize, changes in crop may tweek ia, by adding
* (srcSizeNew-srcSizeOld) to ia.

*  (minam <= da*t+ia <= maxam) * SIN[(minfr <= df*t+if <= maxfr)*t + ip] + os
	STRUCTURE	Harmonic,0
	  STRUCT HM_frequency,LM_SIZEOF
	  			;LONG	HM_initFreq
				;LONG	HM_deltaFreq
	  			;LONG	HM_minFreq	;min abs(Frequency)
	  			;LONG	HM_maxFreq	;max abs(Frequency)
	  LONG	HM_initPhase

	  STRUCT HM_amplitude,LM_SIZEOF
				;LONG	HM_initAmp
				;LONG	HM_deltaAmp
				;LONG	HM_minAmp	;min abs(Amplitude)
				;LONG	HM_maxAmp	;max abs(Amplitude)
	  LONG  HM_initOffset 
	LABEL HM_SIZEOF		   ;size of this structure

*-----------------------------------------
	STRUCTURE DelayedLinear,0	; mind <= sp*t+id <= maxd 
	  LONG	DLM_initDistance
	  LONG	DLM_speed
	  LONG	DLM_minDistance	;value >= 0
	  LONG	DLM_maxDistance  ;value >= 0
	  WORD	DLM_timeStart	;value >= 0
	  WORD  DLM_timeEnd	;value >0, else = $10000
	LABEL	DLM_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaLinearData,0
	  LONG	DLD_Delta
	LABEL	DLD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaAccelData,0
	  LONG	DAD_Delta
	LABEL	DAD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaDeaccelData,0
	  LONG	DDD_Delta
	LABEL	DDD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaSCurveData,0
	  LONG	DSD_Delta
	LABEL	DSD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaBigAccelData,0
	  LONG	DBAD_Delta
	LABEL	DBAD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaBigDeaccelData,0
	  LONG	DBDD_Delta
	LABEL	DBDD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaRandomData,0
	  LONG	DRD_Delta
	LABEL	DRD_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaConstantData,0
	  LONG	DCND_Delta
	LABEL	DCND_SIZEOF	;size of this structure

*-----------------------------------------
	STRUCTURE DeltaCyclicData,0
	 LONG	DCD_initAmp
	 LONG	DCD_deltaAmp
	 LONG	DCD_initPhase
	 LONG	DCD_deltaPhase
	 LONG	DCD_deltaFreq
	LABEL	DCD_SIZEOF	;size of this structure

*-----------------------------------------
* If TV_function is <0 then ignore.  If TV_function = NULL then end of table
* All TV_functions will be called with;
* a0->data (ie Accelerate/Harmonic structures),
* a1->results (ie ScaleData structure field), d0=Time
	STRUCTURE	TimeVariablesStruct,0
	  APTR	TV_function	;->a motion/size function
	  APTR	TV_data		;->data used by the function, NULL if none
	  APTR	TV_results	;->place to put results
	LABEL  TV_SIZEOF	;size of this structure

*-----------------------------------------
*
* The pixelize routines are ment to pixelize the buffX or buffY buffers.
 
	STRUCTURE	PixelizeData,0
;destination cropping, defines useful underscan area
	  WORD	PD_destMin	;minimum address to ever use in destination
	  WORD	PD_destMax	;maximum address to ever use in destination
	  WORD	PD_destAxis	;display coordinate origin.

	  WORD  PD_blockSize	;width or height of effect, in dest resolution
	LABEL	PD_SIZEOF

***************************************************
	STRUCTURE	Wipe1Data,0

	  WORD  W1D_position	;position of srcaxis with respect to destaxis, 
				;in destination resolution
	  WORD	W1D_srcAxis	;axis to wipe from, =center of wiped rectangle
				;based on a 10000 unit wide rectangle
				;0=use left edge of rect, 9999 use right, 5000 use center
;destination cropping, defines useful underscan area
	  WORD	W1D_destMin	;minimum address to ever use in destination
	  WORD	W1D_destMax	;maximum address to ever use in destination
	  WORD	W1D_destAxis	;display coordinate origin.

	  WORD  W1D_effectSize	;width or height of effect, in dest resolution

	  WORD  W1D_effectColor	;1=> set effect, clear BG
          WORD  W1D_overscanColor  	;color of overscan area, -1=skip os	

;the wipe routine will determine the remaining elements in this structure.
	  WORD  W1D_rectMin	;minimum/maximum destination addresses that
	  WORD	W1D_rectMax	;have an effect element, on or off screen.

	  WORD  W1D_effectMin    ;min/max on screen destination address that
	  WORD  W1D_effectMax	;has a scaled effect.
				;=-1 if no scaled effect on screen.
	LABEL W1D_SIZEOF		   ;size of this structure

***************************************************
	STRUCTURE	EffectsLUT,0
		APTR	ELUT_variables
		APTR	ELUT_equations
	LABEL	ELUT_SIZEOF

***************************************************
* Toaster Register Time Variables, dynamic w/o matt
	STRUCTURE	ToasterELH1,0		
		WORD	TELH1_CD		;control da
		WORD	TELH1_LKA	;lumkey A
		WORD	TELH1_LKB	;lumkey B
	LABEL	TELH1_SIZEOF

* Toaster Register Time Variables, non-dynamic w/o matt
* Other static bits could go in here, but remember to change NUMTV_TELH2
	STRUCTURE	ToasterELH2,0		
		WORD	TELH2_AM
		WORD	TELH2_BM
		WORD	TELH2_IS
		WORD	TELH2_PV
		WORD	TELH2_LK
		WORD	TELH2_CDS
	LABEL	TELH2_SIZEOF

* Toaster Register Time Variables, matt & (autocal?)
	STRUCTURE	ToasterELH3,0		
		WORD	TELH3_MA		;matt reg A
		WORD	TELH3_MB		;matt reg B
		WORD	TELH3_MP		;matt phase
	LABEL	TELH3_SIZEOF

***************************************************
* used by 4.0 ANIM/ILBM Effects
	STRUCTURE	FaderData,0
		UWORD	FDRD_CD		;0-255
	LABEL	FDRD_SIZEOF	

*-------------------
	STRUCTURE	LumKeyData,0
		UWORD	LKAD_LKA	;0-255
	LABEL	LKAD_SIZEOF	

*-------------------
	STRUCTURE	TBarTimeData,0
		UWORD	TBTD_Time	;0-$ffff
	LABEL	TBTD_SIZEOF	

*-------------------
	STRUCTURE	BMpositionData,0
		WORD	BMPD_Xaxis	;source, lines up with Destination X axis when deltaX = 0
		WORD	BMPD_Yaxis	;source, lines up with Destination Y axis when deltaY = 0
		WORD	BMPD_deltaX
		WORD	BMPD_deltaY
	LABEL	BMPD_SIZEOF	

***************************************************
* This structure is always at the start of all crouton DVE data
	STRUCTURE	DVEEffects,0
		APTR	DVEE_TimeVars
;;		APTR	DVEE_EntrySetUp  ;entry toaster register config.
;;		APTR	DVEE_ExitSetUp	 ;toaster register config on exit
		LONG	DVEE_Modes1
		WORD	DVEE_NumHor
	LABEL	DVEE_SIZEOF	

* DVEE_Modes1

DEB_SHOWFACE	SET	0	;leave interface up while doing effect
DEB_DRAGTBAR	SET	1	;show tbar dragging
DEB_REVERSE	SET	2	;reverse the direction of the effect
DEB_MIDFLOP  	SET	3	;when TBar is halfway down, switch sources and reverse
DEB_DOELH1	SET	4	;frames do SendELH2Toaster (w/o MATT/dynamic)
DEB_DOELH2	SET	5	;frames do SendELH2Toaster (w/o MATT/non-dynamic)
DEB_DOELH3	SET	6	;frames do SendELH2Toaster (MATT & autocal)
DEB_GEOONINPUT	SET	7	;set if effects on writing, else on playback
DEB_STAMPWAIT	SET	8	;used with Writing effects, to hold TBar 8 fields
DEB_TILEX	SET	9	;duplicate geometry to fill buffer
DEB_TILEY	SET	10
DEB_MOSAICX	SET	11	;mosaic will be applied after DVE is calculated
DEB_MOSAICY	SET	12

*-----------
DEF_SHOWFACE	SET	(1<<DEB_SHOWFACE)
DEF_DRAGTBAR	SET	(1<<DEB_DRAGTBAR)
DEF_REVERSE	SET	(1<<DEB_REVERSE)
DEF_MIDFLOP  	SET	(1<<DEB_MIDFLOP)
DEF_DOELH1	SET	(1<<DEB_DOELH1)		; w/o MATT, dynamic
DEF_DOELH2	SET	(1<<DEB_DOELH2)		; w/o MATT, non-dynamic
DEF_DOELH3	SET	(1<<DEB_DOELH3)		; MATT & AutoCal
DEF_GEOONINPUT	SET	(1<<DEB_GEOONINPUT)
DEF_STAMPWAIT	SET	(1<<DEB_STAMPWAIT)
DEF_TILEX	SET	(1<<DEB_TILEX)	
DEF_TILEY	SET	(1<<DEB_TILEY)	
DEF_MOSAICX	SET	(1<<DEB_MOSAICX)
DEF_MOSAICY	SET	(1<<DEB_MOSAICY)
***************************************************
* This structure is always at the start of all crouton Wipe data
	STRUCTURE	WipeEffects,0
		APTR	WPE_TimeVars
;;		APTR	WPE_EntrySetUp  ;entry toaster register config.
;;		APTR	WPE_ExitSetUp	 ;toaster register config on exit
		LONG	WPE_Modes1
		WORD	WPE_NumHor
	LABEL	WPE_SIZEOF	

* WPE_Modes1
WEB_SHOWFACE	SET	0	;leave interface up while doing effect
WEB_DRAGTBAR	SET	1	;show tbar dragging
WEB_REVERSE	SET	2	;reverse the direction of the effect
WEB_MIDFLOP	SET	3	;when TBar is halfway down, switch sources and reverse
WEB_DOELH1	SET	4	;frames do SendELH2Toaster (w/o MATT/dynamic)
WEB_DOELH2	SET	5	;frames do SendELH2Toaster (w/ MATT/non-dynamic)
WEB_DOELH3	SET	6	;frames do SendELH2Toaster (MATT & autocal)
WEB_CROSS	SET	7	;to cross wipe

*-----------
WEF_SHOWFACE	SET	(1<<WEB_SHOWFACE)
WEF_DRAGTBAR	SET	(1<<WEB_DRAGTBAR)
WEF_REVERSE	SET	(1<<WEB_REVERSE)
WEF_MIDFLOP	SET	(1<<WEB_MIDFLOP)
WEF_DOELH1	SET	(1<<WEB_DOELH1)		; w/o MATT, dynamic
WEF_DOELH2	SET	(1<<WEB_DOELH2)		; w/o MATT, non-dynamic
WEF_DOELH3	SET	(1<<WEB_DOELH3)		; MATT & AutoCal
WEF_CROSS	SET	(1<<WEB_CROSS)

***************************************************
* This structure is always at the start of all crouton Switcher data
	STRUCTURE	SwitcherEffects,0
		APTR	SWE_TimeVars
;;		APTR	SWE_EntrySetUp  ;entry toaster register config.
;;		APTR	SWE_ExitSetUp	 ;toaster register config on exit
		LONG	SWE_Modes1
	LABEL	SWE_SIZEOF	

* SWE_Modes1
SEB_SHOWFACE	SET	0	;leave interface up while doing effect
SEB_DRAGTBAR	SET	1	;show tbar dragging
SEB_REVERSE	SET	2	;reverse the direction of the effect
SEB_MIDFLOP	SET	3	;when TBar is halfway down, switch sources and reverse
SEB_DOELH1	SET	4	;frames do SendELH2Toaster (w/o MATT/dynamic)
SEB_DOELH2	SET	5	;frames do SendELH2Toaster (w/ MATT/non-dynamic)
SEB_DOELH3	SET	6	;frames do SendELH2Toaster (MATT & autocal)

*-----------
SEF_SHOWFACE	SET	(1<<SEB_SHOWFACE)
SEF_DRAGTBAR	SET	(1<<SEB_DRAGTBAR)
SEF_REVERSE	SET	(1<<SEB_REVERSE)
SEF_MIDFLOP	SET	(1<<SEB_MIDFLOP)
SEF_DOELH1	SET	(1<<SEB_DOELH1)		; w/o MATT, dynamic
SEF_DOELH2	SET	(1<<SEB_DOELH2)		; w/o MATT, non-dynamic
SEF_DOELH3	SET	(1<<SEB_DOELH3)		; MATT & AutoCal

***************************************************
	ENDC	;RECT_I

