/**************************************************************************
**
**                               error message lib
**
**
**
**
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rfx_common.h"
#include "err_lib.h"


/*- global variables -*/
char    err_msg_buf[1025];
int     err_msg_buf_size = 1024;
int     err_display_level  = DEBUG_MSG;
int     logfile_open       = FALSE;

FILE    *logfile = stdout;







/****************************************************************************
**
**  int init_errlog(int display_level, char *logfilename)
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/
int init_errlog(int display_level, char *logfilename)
{

    err_display_level = display_level;

    /* open file or set to STDOUT */
    if (logfilename != NULL)
    {
        if ( (logfile = fopen(logfilename, "w")) == NULL)
        {
            logfile = stdout;
            return(ERROR);
        }
    }

    logfile_open = TRUE;
    return(OK);

}



/****************************************************************************
**
**  void close_errlog(void)
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/
void close_errlog(void)
{

    /* if we have an open error log file, close it and reset the */
    /* default output to stdout */

    if (logfile_open == TRUE)
    {
        fclose(logfile);
    }
    logfile = stdout;


    return;

}






/****************************************************************************
**
** void  log_message( int level, char *message)
**
** DESC:
**  logs a message to if it at or above a threshold level
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/
void  log_message( int level, char *message)
{

    if (level >= err_display_level)
    {
        if (strlen(message) >= err_msg_buf_size)
        {
            message[err_msg_buf_size] = '\0';
        }

            sprintf(err_msg_buf,"L%d: %s", level, message);

        fprintf(logfile,"%s\n", err_msg_buf);
    }

    return;
}








/*--- Spare Template ---*/


/****************************************************************************
**
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/



