/****************************************************************************
**                            Render FX interface functions
**
**
**
**
**
****************************************************************************/


/*-- System Include files --*/


#include "arexx.h"
#include "arexxsyslib.h"

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

#include "flyerlib.h"
#include "flyer.h"


struct Library *FlyerBase = NULL;
struct Library *RexxSysLib = NULL;
struct FlyerVolume FlyVol;
struct ClipAction  Action;

BPTR  handle;

#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
   };


struct RexxMsg *bill;

LONG result;

UWORD key;

ULONG res;


/*-- external interface variable --*/
double view_percent = 0.0;

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

void PlayVideo(UWORD, char *,UWORD);

ARexxContext rob1 = NULL;



/*-- User Include Files --*/

#include "rfx_common.h"
#include "interface.h"



/* initialize the toaster (open the libraries) */
/* return an error if it doesn't succeed, but this will not be a fatal error */

int init_flyer(void)
{


    /* Initialization */
    if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
    {
        printf("Open flyer.library failed\n");
        return(ERROR);
    }

    ToasterMux(0,1,1,0);

    return(OK);
}


/* initialize AREXX functions */

int flyer_arexx_init(void)
{


    if( (RexxSysLib = OpenLibrary("rexxsyslib.library",0)) == NULL)
    {
        printf("Error opening rexxsyslib.library\n");
        return(ERROR);
    }

    if ( (rob1 = ARexxInit("RFX1",NULL,FALSE)) == NULL)
    {
        printf("Error initializing AREXX Port\n");
        return(ERROR);
    }

    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"M003");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }



    return(OK);
}



int show_transition(    char *aclipname,  unsigned long int afield, int atype,
                        char *bclipname,  unsigned long int bfield, int btype,
                        double tbar_percent)
{

    char number[100], halfnumber[100];
    int     tbar_level;


    /* play the video and perform the transition */

    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TOSW");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }

    key = 0;

    res = FlyerInputSel(0,FI_ToasterMain,FS_ToasterMain);
    Delay(1);
    if (res)
    {
        CloseLibrary(FlyerBase);
        exit(20);
    }

    if (btype < 3)
       {
       if (btype == 1)
          show_field(1,bclipname,(UWORD)bfield);
       else
          show_field(1,bclipname,0);
       bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"P004");
       if (!bill)
          {
          printf("It didn't work\n");
          }
       else
          {
          result = get_reply( rob1);
          }
       }
    else
       {
       bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV2");
       if (!bill)
          {
          printf("It didn't work\n");
          }
       else
          {
          result = get_reply( rob1);
          }

       if (btype == 5)
          {
          bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"PDV1");
          if (!bill)
             printf("It didn't work\n");
          else
             result = get_reply( rob1);
          Delay(5);
          bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
          if (!bill)
             printf("It didn't work\n");
          else
             result = get_reply( rob1);
          Delay(5);
          sprintf(number,"%d",bfield);
          bill = CallARexxFunc(rob1,"PROJECT_REXX_PORT","CROUTONPICK",0,1,number);
          if (!bill)
             printf("It didn't work\n");
          else
             result = get_reply( rob1);
          Delay(5);
          bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"DOEN");
          if (!bill)
             printf("It didn't work\n");
          else
             result = get_reply( rob1);
          Delay(5);
          bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
          if (!bill)
             printf("It didn't work\n");
          else
             result = get_reply( rob1);
          Delay(5);
          }
         
      }

    if (atype < 3)
       {
       if (atype == 1) 
          show_field(0,aclipname,(UWORD)afield);
       else
          show_field(0,aclipname,0);
       bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"M003");
       if (!bill)
          {
          printf("It didn't work\n");
          }
       else
          {
          result = get_reply( rob1);
          }
       }
    else
       {
       bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"MDV1");
       if (!bill)
          {
          printf("It didn't work\n");
          }
       else
          {
          result = get_reply( rob1);
          }
       }





    /* save a copy of the percent value to be compared with the */
    /* the final value */

    view_percent = tbar_percent;

    tbar_level = (int)(tbar_percent * 5.11);  /* 511 / 100.0 */
    
    if (tbar_level == 0)
    {
        tbar_level = 1;
    }
    sprintf(number,"%d",tbar_level);
    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,2,"TBAR",number);
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }

    return(OK);
}


/* function to snap the flyer screen to the background */

void restore_rfx_screen(void)
{
int status, level;
FILE      *datafile;

    status = system("rx prowave:green.rexx");

    if ( (datafile = fopen("env:green.txt","r")) == NULL)
    {
        /* couldn't open the file, save a negative percent */
        /* as an error flag */
        view_percent = -1.0;
    }
    else
    {
        fscanf(datafile,"%d",&level);
        /* more bullshit, if the level is 0, it may have either been */
        /*  moved to 0 or 511 (in which case it is "finished" and resets */
        /*  to 0, the best damn thing we can do is guess that if the  */
        /*  original percent level was over 50, they went to 100% */

        if (view_percent > 50.0)
        {
            if (level == 0)
            {
                level = 511;
            }
        }
        else if (view_percent == 0.0)
        {
            if (level == 1)
            {
                level = 0;
            }
        }
        view_percent = (double)level / 5.11;
        fclose(datafile);
    }

    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TAKE");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }

    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"M003");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }


    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TOWB");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }

    return;
}


void restore_switcher(void)
{

    bill = CallARexxFunc(rob1,"ToasterARexx.port","Switcher",0,1,"TOSW");
    if (!bill)
    {
        printf("It didn't work\n");
    }
    else
    {
        result = get_reply( rob1);
    }

    return;
}


/* shut down the ARexx connection */

void flyer_arexx_shutdown(void)
{

    ARexxFree(rob1);

    if (RexxSysLib)
    {
        CloseLibrary(RexxSysLib);
    }

    return;
}




/* shutdown the flyer, it it has been started */

void close_flyer(void)
{
    if( FlyerBase != NULL )
    {
        /* Close Library */
        CloseLibrary(FlyerBase);
        FlyerBase = NULL;
    }
}

/* show a field of a clip */
/* The arguement is the first field to be shown */

int show_field(UWORD vidchan, char *clipname, unsigned long int field)
{
	int res;
    UWORD Volume;

    if (FlyerBase != NULL)
    {

        FlyVol.Path = clipname;
        FlyVol.Board = 0;

        Action.Volume = &FlyVol;
        Action.ReturnTime = RT_STOPPED;

        Action.Channel = vidchan;
        Action.Flags = CAF_VIDEO;

        Volume = 0xFFFF;

        Action.VidStartField = field;
        Action.VidFieldCount = 4;
        Action.TotalAudStart = Action.AudStartField = field;
        Action.TotalAudLength = Action.AudFieldCount = 4;

        Action.VolSust1 = 0;
        Action.VolSust2 = 0;
        Action.AudioPan1 = 0;
        Action.AudioPan2 = 0;

        res = FlyerPlay(&Action);
        if (res)
        {
            printf("\nError %ld - %ls\n",res,Error2String(res));
            return(ERROR);
        }
   }

   return(OK);
}

LONG get_reply(ARexxContext  context)
{
   struct RexxMsg   *reply;
   unsigned long    i;
   LONG             temp_code;

   /* poll for reply */
   i=0;
      while ( ((reply = GetARexxMsg(context)) == NULL) && (++i < 1000) )
      {
      Delay(1);
      }

   if (i == 1000)
   {
      printf("timeout\n");
      /* did not get a response in a long time, just return */
      return(0);
   }
   else
   {
      if (IsARexxReply( reply) )
      {
//printf("Got a valid reply %d\n", reply->rm_Result1);
         temp_code = reply->rm_Result1;
         FreeARexxMsg(context, reply);
      }
      else
      {
printf("Not a reply\n");
      /* otherwise, don't care */
      }
   }
   return( temp_code);
}

ARexxContext ARexxInit(char *name, char *extension, BOOL multiple)
{
struct Library *RexxSysBase;
struct MsgPort *port;
ARexxContext  context;
unsigned count;
char  *ptr;

context = AllocMem(sizeof(struct ARexxContext), MEMF_PUBLIC | MEMF_CLEAR);

if (!context)
   return(NULL);

RexxSysBase = OpenLibrary((UBYTE *) "rexxsyslib.library",0L);

if (RexxSysBase)
   {
   context->rexx_base = RexxSysBase;
   if (!extension)
      extension = "rexx";
   StrNUpper(context->extension, extension, MAX_EXTENSION);
   ptr = StrNUpper(context->port_name, name, MAX_PORT_NAME);
#ifdef RVI
   strcpy(context->error_name, context->port_name);
   strcat(context->error_name, ".LASTERROR");
#endif

   Forbid();
   if (multiple)
      {
      *ptr++='.';
      for (count = 1; count < 100; ++count)
         {
         UiToStr(count, ptr);
         port = FindPort((UBYTE *) context->port_name);
         if (!port) break;
         }
      }
   else
      {
      port = FindPort((UBYTE *) context->port_name);
      }

   if (!port)
      context->arexx_port = CreatePort ((UBYTE *) context->port_name,0);
   Permit();
   }

if (!context->rexx_base || !context->arexx_port)
   {
   ARexxFree(context);
   context = NULL;
   }

return(context);
}

void ARexxFree (ARexxContext context)
{
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context)
   return;

if (context->rexx_base)
   {
   RexxSysBase = context->rexx_base;
   context->port_name[0] = NULLCHAR;
   while (context->outstanding > 0 && context->arexx_port != NULL)
      {
      WaitPort(context->arexx_port);
      while ((msg = GetARexxMsg(context) ) != NULL)
         {
         if (!FreeARexxMsg(context, msg))
            ReplyARexxMsg(context, msg, 100, NULL, 0);
         }
      }
   if (context->arexx_port)
      {
      Forbid();
      while ((msg = GetARexxMsg(context)) != NULL)
         ReplyARexxMsg(context, msg, 100, NULL, 0);
      DeletePort(context->arexx_port);
      Permit();
      }
   CloseLibrary(RexxSysBase);
   }

FreeMem(context, sizeof(struct ARexxContext));

}

char *ArexxName(ARexxContext context)
{
if (context)
   return(context->port_name);
else
   return(NULL);
}

ULONG ARexxSignal(ARexxContext context)
{
if (context)
   return(1UL << context->arexx_port->mp_SigBit);
else
   return(0);
}

struct Library *ARexxBase(ARexxContext context)
{
if (context)
   return(context->rexx_base);
else
   return(NULL);
}

BOOL IsARexxReply( struct RexxMsg *msg)
{
if (msg)
   return( (BOOL)(msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG ));
else
   return(FALSE);
}

struct RexxMsg *GetARexxMsg(ARexxContext context)
{
struct RexxMsg *msg;

if (!context)
   return(NULL);

msg = (struct RexxMsg *) GetMsg(context->arexx_port);

if (!msg)
   return(NULL);

if (IsARexxReply(msg))
   --context->outstanding;

return(msg);
}

BOOL FreeARexxMsg(ARexxContext context, struct RexxMsg *msg)
{
struct Library *RexxSysBase;

if (!context || !msg)
   return(FALSE);

if (!IsARexxReply(msg))
   return(FALSE);

RexxSysBase = context->rexx_base;

ClearRexxMsg(msg, 16);

if (msg->rm_Result1 == 0 && msg->rm_Result2 != NULL)
   DeleteArgstring((char *) msg->rm_Result2);

DeleteRexxMsg(msg);

return(TRUE);

}

struct RexxMsg *SendARexxMsg(ARexxContext context, char *port_name,
              char *command, ULONG flags)
{
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context || !command)
   return(NULL);

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
              context->port_name);

if (!msg)
   return(NULL);

flags &= ( RXFF_NOIO | RXFF_RESULT | RXFF_STRING | RXFF_TOKEN );

msg->rm_Action = RXCOMM | flags;

msg->rm_Args[0] = (STRPTR) CreateArgstring(command, strlen(command));

msg->rm_Result1 = 0;

msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port = FindPort((UBYTE *) port_name )) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   DeleteArgstring((char *) msg->rm_Args[0]);
   DeleteRexxMsg(msg);
   msg = NULL;
   }

Permit();
return(msg);

}


struct RexxMsg *CallARexxFunc (ARexxContext context, char *port_name,
       char *function, ULONG flags, int num_args, ...)
{
va_list        argptr;
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;
BOOL   quit;
int   i;
char *arg;

if (!context || !function || num_args < 0)
   return(NULL);

if (num_args > 15)
   num_args = 15;

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
            context->port_name);

if (!msg)
   return(NULL);

flags &= (RXFF_NOIO | RXFF_RESULT | RXFF_STRING);

msg->rm_Action = RXFUNC | flags;

msg->rm_Action |= ( num_args & RXARGMASK);

msg->rm_Args[0] = (STRPTR) CreateArgstring(function, strlen(function));

msg->rm_Result1 = 0;
msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

va_start (argptr, num_args);

for (i=1, quit=FALSE; i<= num_args && !quit; ++i)
   {
   arg = (char *) va_arg(argptr, char *);

   if (!arg)
      arg = "";

   msg->rm_Args[i] = (STRPTR) CreateArgstring(arg, strlen(arg));

   if (!msg->rm_Args[i])
      quit = TRUE;

   }

va_end(argptr);

if (quit)
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port=FindPort((UBYTE *) port_name)) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   msg = NULL;
   }


Permit();

return(msg);

}


BOOL  ReplyARexxMsg( ARexxContext context,  struct RexxMsg  *msg,
                     LONG return_code,  char *result_string,
                     LONG error_code)
{

   struct Library  *RexxSysBase;

   if ( !context || !msg )
      return( FALSE );

   if ( IsARexxReply (msg) )
      return( FALSE );

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Set the results */

   msg->rm_Result1 = return_code;
   msg->rm_Result2 = (LONG) NULL;

   /* if no error and result was requested, set the result string */

   if ( result_string != NULL && return_code == RC_OK
        && (msg->rm_Action & RXFF_RESULT) != 0 )
      {
       msg->rm_Result2 = (LONG) CreateArgstring( result_string,
                                 strlen( result_string) );
      }
   else if  (return_code != RC_OK)
      {
         msg->rm_Result2 = error_code;
      }

   ReplyMsg( (struct Message *)msg );

   return(TRUE);
}

BOOL AddFuncHost (ARexxContext context,  LONG priority)
{

   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if( !context )
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Get a new message packet */

   msg = CreateRexxMsg( context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);


   msg->rm_Action = RXADDFH | RXFF_NONRET;
   msg->rm_Args[0] = (STRPTR) context->port_name;
   msg->rm_Args[1] = (STRPTR) priority;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX" ) ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg( msg );
      msg = NULL;
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}


BOOL RemFuncHost( ARexxContext context)
{
   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if (!context)
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* get a new message packet */

   msg = CreateRexxMsg (context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);

   /* tell the resident process to remove the port name to the Library
    * List... we don't expect a reply
    */

   msg->rm_Action   = RXREMLIB | RXFF_NONRET;
   msg->rm_Args[0]  = (STRPTR)  context->port_name;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX") ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg (msg);
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}




BOOL  SetARexxLastError( ARexxContext context, struct RexxMsg *msg,
                        char *error)
{

   #ifndef RVI
      return(FALSE);
   #else
      if (!context || !msg || !error)
         return(FALSE);

      if (!CheckRexxMsg (msg) )
         return(FALSE);

      return( SetRexxVar( msg, context->error_name,
                           error, strlen(error) ) == 0 )
   #endif
}




static char *StrNUpper( char *dest,  char *src,  unsigned int len)
{

   for( ; *src != NULLCHAR && len-- > 0; ++src)
   {
      if (islower (*src))
         *dest++ = toupper( *src );
      else
         *dest++ = *src;
   }

   *dest = NULLCHAR;

   return(dest);
}



static char *UiToStr( unsigned num, char *buf)
{
   num %= 100;

   buf[0] = (num / 10) + '0';
   buf[1] = (num % 10) + '0';
   buf[2] = NULLCHAR;

   return(buf);
}





/****************************************************************************
**
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/



