/****************************************************************************
**                            Render FX shell
**
**
**
**
**
****************************************************************************/


/*-- System Include files --*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>

#include <graphics/displayinfo.h>
#include <libraries/dos.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>



/*-- User Include Files --*/

#include "rfx_common.h"
#include "pw_util_lib.h"
#include "rfx_init.h"
#include "err_lib.h"
#include "graph_lib.h"
#include "rfx_gadget_ids.h"




/***************************************************************************/


int main(int argc, char *argv[])
{
    int        status;
    char       reply[50];

    struct graph_struct *graph;

    /* the rest are leftovers from first waveeditor draft */

    BOOL       quitflag;
    ULONG      signalmask, winsignal, signals;
    struct     IntuiMessage *message = NULL;
    ULONG      class;
    UWORD      code;
    UWORD      qualifier;
    WORD       mousex, mousey;
    struct     Gadget  *gad;

    /*- the A clip -*/
    char                    afilename[257];
    int                     afilenamesize = 256;
    unsigned long int       acliplen;
    unsigned long int       bclipstart;

    /*- the B clip -*/
    char                    bfilename[257];
    int                     bfilenamesize = 257;
    unsigned long int       bcliplen;
    unsigned long int       bclipstart;

    int         i,j;
    int         lower_index, higher_index;
    long int    lower_delta, higher_delta;

    long int   tf1, tf2;

    long int mid_frame, new_startframe, new_endframe;


    unsigned long int  delay_counter;


    /* open libraries and setup resources */

    status = init_rfx();

    if (status != OK)
    {
        printf("Error from init_rfx status is %d\n", status);
    }




    /* draw a test graph */

//    graph = init_graph( 50, 100, 200, 200, 35, 100, 200);

//    redraw_graph(rf_win->RPort ,graph);

//    insert_graph_point(graph, 20, 100);

//    redraw_graph(rf_win->RPort, graph);

//    insert_graph_point(graph, 1,25);
//    redraw_graph(rf_win->RPort, graph);

//    delete_graph_point(graph, 1);
//    redraw_graph(rf_win->RPort, graph);

//    delete_graph_point(graph,2);
//    redraw_graph(rf_win->RPort, graph);


//    insert_graph_point(graph, 20, 100);
//    redraw_graph(rf_win->RPort, graph);

//    move_graph_point( rf_win->RPort, graph, 3, 25, 75);



//    find_graph_points( graph, 25, &lower_index, &lower_delta, &higher_index,
//                        &higher_delta);

//    printf("lower_index = %d  lower_delta = %ld\n", lower_index, lower_delta);
//    printf("higher_index = %d  higher_delta = %ld\n", higher_index, higher_delta);



    /* Set up the signalswe want to hear about ... */
    winsignal = 1L << rf_win->UserPort->mp_SigBit;   /* window IDCMP */
    signalmask = winsignal;


    quitflag = FALSE;


    while( !quitflag )
    {
        signals = Wait(signalmask);

        /* An Event occured - now act on the signal(s) we received */
        /* We were only waiting for one signal (winsignal) in out */
        /* signalmask, so we actually knw we recieved winsignal. */

        if( signals & winsignal)
        {
            while( message = (struct IntuiMessage *)GetMsg(rf_win->UserPort))
            {
                class = message->Class;  /* get all the data needed from  msg*/
                code = message->Code;
                qualifier = message->Qualifier;
                mousex = message->MouseX;
                mousey = message->MouseY;


                /* gadget address is ONLY valid for gadget messages */
               if( (class==IDCMP_GADGETUP) || (class == IDCMP_GADGETDOWN) )
                {
                    gad = (struct Gadget *)(message->IAddress);
                }

                /* when we're through with the message, reply */
                ReplyMsg( (struct Message *)message);


                /* see what events occured */

                switch(class)
                {

                case IDCMP_GADGETUP:
                    /* caused by GACT_RELVERIFY */
                    printf("recieved an IDCMP_GADGETUP, gadget number %d\n",
                            gad->GadgetID);


                    if (gad->GadgetID == _CANCEL_ID)
                    {
                        quitflag = TRUE;
                    }


                    break;

                case IDCMP_GADGETDOWN:
                    /* caused by GACT_IMMEDIATE */
                    printf("receive an IDCMP_GADGETDOW, gadget number %d\n",
                            gad->GadgetID);


                    break;


                case IDCMP_RAWKEY:

//                    printf("rawkey\n");

                    break;

                case IDCMP_MOUSEBUTTONS:
                    //printf("MouseButton\n");

                    /* note, these messages are only enabled when there is */
                    /* something loaded, so there WILL be data to operate on */

                    /* SELECTDOWN States */
                    if (code == SELECTDOWN)
                    {


                    }

                    else if (code == SELECTUP)
                    {

                    }



                    break;

                case IDCMP_MOUSEMOVE:

                    break;

               default:
                    printf("recieved unknown IDCMP code %d\n", class);
                    break;
                }
            }
        }

    }

    /* Clean Up and exit */


    shutdown_rfx();

//    if (graph != NULL)
//    {
//        free_graph(graph);
//    }


    return(0);

}






/****************************************************************************
**
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/



