/****************************************************************************
**                      PW Error Message Library Header
**
**  Header file for error_lib.  Contains defines and function
** prototypes
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef PW_ERROR_LIB_H

#define PW_ERROR_LIB_H


/*- message levels -*/
#define DEBUG_MSG       (0)
#define INFO_MSG        (1)
#define WARNING_MSG     (2)
#define ERROR_MSG       (3)


/*- variables -*/
extern int         err_display_level;


/*-- function prototypes --*/

void log_message(int level, char *message);
int init_errlog(int display_level, char *logfilename);
void close_errlog(void);



#endif /* PW_ERROR_LIB_H */







