/****************************************************************************
**
**                              mem_lib
**
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef MEM_LIB_H

#define MEM_LIB_H


struct mem_block {
    int                  num_used;
    void                 **values;
    struct mem_block     *next;
};


struct mem_list {
    int                  status;
    int                  total_elements;
    int                  num_used;
    int                  num_blocks;
    int                  num_ptrs_per_block;
    struct mem_block     *block_head;
    struct mem_block     *block_tail;
};

/*- global memory list head (must be allocated in the code) -*/
extern struct mem_list   *mem_head;



/*-- function prototypes --*/
struct mem_list  *initialize_mem_list( int num_ptrs_per_block);
int  remove_mem_list( struct mem_list *head);
int  insert_mem_list_ptr( struct mem_list *head, void *pointer);
int  free_mem_list_ptr( struct mem_list *head, void *pointer, int free_flag);







#endif /* MEM_LIB_H */







