/****************************************************************************
**                      PW Utility Library Header
**
**  Header file for pw_util_lib.c.  Contains defines and function
** prototypes
**
** Revisions: (see changelog of .c file for details)
**
** 23 Mar 97
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef PW_UTIL_LIB_H

#define PW_UTIL_LIB_H



#define RAISED           (0)
#define LOWERED          (1)


#define CLIP_FORWARD     (0)
#define CLIP_BACKWARD    (1)


/*- requestor types for bb_filereq typeflag arguement--*/
#define  FILE_OPEN       (1)
#define  FILE_SAVE       (2)
#define  DRAWER_SELECT   (3)



/*-- function prototypes --*/

struct Border  *create_win_border( int width,  int height, int thinkness,
                                   int orient_flag, int lightpen,
                                   int darkpen, int frameflag, int framepen);

void free_win_border (struct Border *head);

int  shift_border( struct Border *head, WORD leftshift, WORD topshift);

int  in_hitbox(WORD x, WORD y, struct hitbox_struct hbox);

int center_text( struct RastPort *rport, int width, int height,
                   char *text, WORD *xoffset, WORD *yoffset);

char *clip_text( struct RastPort *rport, int max_text_width, int clipdir,
                 char *text, int *out_strlen, int *text_width_out);



#endif /* PW_UTIL_LIB_H */







