/****************************************************************************
**
**                         pw_init.h
**
** header file for functions in pw_init.c
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef PW_INIT_H

#define PW_INIT_H


/*-- Global Defines --*/
#define A_TCODEX         (68)
#define A_TCODEY         (142)

#define B_TCODEX         (466)
#define B_TCODEY         (142)


#define LEN_STR_WIDTH       (6)
#define FRAME_STR_WIDTH     (6)
#define PERCENT_STR_WIDTH   (4)

/*-- External variables --*/

/*- input envent variables --*/
extern struct IOStdReq      *InputIO;
extern struct MsgPort       *InputMP;

/*- Graph Mode Gadgets -*/

extern struct Gadget    _create_gad;
extern struct Gadget    _delete_gad;
extern struct Gadget    _drag_gad;

extern struct Gadget    _percent_str_gad;
extern struct Gadget    _frame_str_gad;
extern struct Gadget    _len_str_gad;

//extern struct Gadget    _a_left_gad;
//extern struct Gadget    _a_right_gad;

//extern struct Gadget    _b_left_gad;
//extern struct Gadget    _b_right_gad;

//extern struct Gadget    _len_left_gad;
//extern struct Gadget    _len_right_gad;

//extern struct Gadget    _frame_left_gad;
//extern struct Gadget    _frame_right_gad;







/*-- Function declarations --*/

int init_rfx(void);
int shutdown_rfx(void);








#endif /* PW_INIT_H */







