/****************************************************************************
**                         pw_common.h
**
**  Universal common constants and global variables
**
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef RFX_COMMON_H

#define RFX_COMMON_H

#include <exec/types.h>

/*-- Status Codes --*/

#define OK           (0)
#define ERROR        (1)
#define FILE_ERROR   (2)

#define UNINITIALIZED   (0)
#define INITIALIZED     (1)


/*-- Global Defines --*/

/* pens for different colors */

#define PW_SHINEPEN     (3)
#define PW_SHADOWPEN    (4)
#define PW_BACKPEN      (1)
#define PW_BLACKPEN     (0)

#define BLACKPEN        (0)
#define MDGREY1PEN      (1)
#define LTGREY1PEN      (2)
#define LTGREY2PEN      (3)
#define DKGREY1PEN      (4)
#define DKGREY2PEN      (5)
#define DKYELLOWPEN     (6)
#define LTYELLOWPEN     (7)
#define LTBLUE1PEN      (8)
#define LTPURPLE1PEN    (9)
#define DKGREEN1PEN     (10)




/*-- Global Structures --*/

/*-- hitbox structure --*/

struct hitbox_struct {
    WORD      left;
    WORD      top;
    WORD      right;
    WORD      bottom;
    };


/*-- Global Variables:  Library Base Pointers --*/

//extern struct Library *IntuitionBase;



/*-- Global Variables:  Intuition Variables --*/
extern struct Screen       *screen;
extern struct Window       *rf_win;
extern struct TextFont     *topaz11;

/*-- Universal Global Variables --*/

#define VERSION_STRING  "Version 1.0"

#endif /* BB_COMMON_H */







