/****************************************************************************
**
**                              timecode_lib.h
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef TIMECODE_LIB_H

#define TIMECODE_LIB_H


/*-- data struct --*/

struct timecode {
    int             hh;            // hours
    int             mm;            // minutes
    int             ss;            // seconds
    int             ff;            // frames
    int             negflag;       // flag set if negative
};



/*- function prototypes -*/
void frame2tcode( long int frame, struct timecode *tcode);
void tcode2frame( struct timecode tcode, long int *frame);
void draw_timecode( struct RastPort *rport, struct timecode tcode,
                    int parenflag);





#endif /* TIMECODE_LIB_H */







