


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <exec/types.h>
#include <exec/memory.h>

#include <libraries/dos.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>

unsigned long int get_filesize( char *filename);

int main(int argc, char *argv[])
{
    unsigned long int     size;

    if (argc < 2)
    {
        printf("filesize <file name>\n");
        exit(1);
    }

    size = get_filesize(argv[1]);
 
    printf("%s is %ld bytes\n", argv[1], size);

    return(0);
}



unsigned long int get_filesize(char *filename)
{

    BOOL                    status;
    BPTR                    lock = NULL;
    struct  FileInfoBlock   fileinfo;
    unsigned long int       file_size = 0;


    /* attempt to lock the file */

    lock = Lock(filename, ACCESS_READ);

    if (lock == 0)
    {
        printf("unable to lock %s\n", filename);
        return(0);
    }

    status = Examine(lock, &fileinfo);

    if (status)
    {
        file_size = fileinfo.fib_Size;
    }

    if (lock != 0)
    {
        UnLock(lock);
    }

    return(file_size);

}

