#ifndef TAGS_H
#define TAGS_H
/********************************************************************
* $Tags.h$  - Crouton tags, see switcher/inc/tags.i
* $Id: Tags.h,v 2.32 1995/08/09 17:47:56 Flick Exp $
*
* Copyright (c)1993 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
********************************************************************/


#define	TAGCTRL_LONG		(1<<31)
#define	TAGCTRL_UNSAVED	(1<<26)



// Tag values have top bit on (|0x80000000), tables don't

#define TAG_Version							0x01|0x80000000
#define TAG_Revision							0x02|0x80000000
#define TAG_AAeffect							0x03|0x80000000
#define TAG_NonAAeffect						0x04|0x80000000
#define TAG_KillInterfaceNonAA			0x05|0x80000000
#define TAG_KillInterfaceAA				0x06|0x80000000
#define TAG_ButtonELHlogic					0x07|0x80000000
#define TAG_CustomButtonELHlogic			0x08
#define TAG_NumberOfAnims					0x09|0x80000000
#define TAG_RequestFileName				0x0a|0x80000000        
#define TAG_AnimFiles						0x0b
#define TAG_Frames							0x0c|0x80000000
#define TAG_FieldSync						0x0d|0x80000000
#define TAG_VariableSpeeds					0x0e|0x80000000
#define TAG_ForcePlayForward				0x0f|0x80000000
#define TAG_ForcePlayReverse				0x10|0x80000000
#define TAG_LoopAnims						0x11|0x80000000
#define TAG_AnimControl						0x12
#define TAG_AudioFastSamples				0x13|0x80000000
#define TAG_AudioMediumSamples			0x14|0x80000000
#define TAG_AudioSlowSamples				0x15|0x80000000
#define TAG_AudioFiles						0x16
#define TAG_AudioControl					0x17
#define TAG_PauseTimes						0x18
#define TAG_LatchColors						0x19
#define TAG_TransparentColors				0x1a
#define TAG_PaletteColors					0x1b
#define TAG_Equations						0x1c
#define TAG_Encoder							0x1d|0x80000000
#define TAG_VerticalScroll					0x1e|0x80000000
#define TAG_ReverseTime						0x1f|0x80000000
#define TAG_ReverseButtLog					0x20|0x80000000
#define TAG_ReverseCustomButtLog			0x21
#define TAG_KeyMode							0x22|0x80000000
#define TAG_MatteColor						0x23|0x80000000
#define TAG_CustomMatteColor 				0x24|0x80000000
#define TAG_BorderColor						0x25|0x80000000
#define TAG_CustomBorderColor				0x26|0x80000000
#define TAG_LineNumbers						0x27
#define TAG_LineNumberPlane				0x28|0x80000000
#define TAG_ForceFreeze4					0x29|0x80000000
#define TAG_ForceFreeze8					0x2a|0x80000000
#define TAG_ForceLive						0x2b|0x80000000
#define TAG_ForceLumKeyOn					0x2c|0x80000000
#define TAG_ForceLumKeyOff					0x2d|0x80000000
#define TAG_ForceLumKeyOnBlack			0x2e|0x80000000
#define TAG_ForceLumKeyOnWhite			0x2f|0x80000000
#define TAG_BadDefaultFX					0x30|0x80000000
#define TAG_LoadPictures					0x31
#define TAG_FadeInDuration					0x32|0x80000000
#define TAG_FadeOutDuration				0x33|0x80000000
#define TAG_DigitalFX						0x34|0x80000000
#define TAG_TimeMode							0x35|0x80000000
#define TAG_LUT								0x36|0x80000000
#define TAG_DigitalPairs					0x37|0x80000000
#define TAG_LatchAM							0x38|0x80000000
#define TAG_LatchBM							0x39|0x80000000
#define TAG_LatchIS							0x3a|0x80000000
#define TAG_HonorPreviewOverLay			0x3b|0x80000000
#define TAG_ForceDefaultMatte				0x3c|0x80000000
#define TAG_TurnAudioFilterOff			0x3d|0x80000000
#define TAG_AudioStartField				0x3e|0x80000000
#define TAG_NumAudioFields					0x3f|0x80000000
#define TAG_ISandClipPause					0x40|0x80000000
#define TAG_Interlaced						0x41|0x80000000
#define TAG_FirstFieldNTSCII				0x42|0x80000000
#define TAG_BounceILBM						0x43|0x80000000
#define TAG_LatchRanges						0x44
#define TAG_LatchList						0x45
#define TAG_TransparentRanges				0x46
#define TAG_TransparentList				0x47
#define TAG_Color0Transparent				0x48|0x80000000
#define TAG_AbortIfSlow						0x49|0x80000000
#define TAG_NumSkipFieldsAtEnd			0x4a|0x80000000
#define TAG_TBarDoesAuto					0x4b|0x80000000
#define TAG_DoNotStompSprite				0x4c|0x80000000
#define TAG_AbortLoopAtEnd					0x4d|0x80000000
#define TAG_NonAAremap						0x4e|0x80000000
#define TAG_100PercentWhiteMatte			0x4f|0x80000000
#define TAG_UseEffectColor					0x50|0x80000000
#define TAG_LoopCount						0x51|0x80000000
#define TAG_CroutonType						0x52|0x80000000
#define TAG_TimeLine							0x53|0x80000000
#define TAG_IndexID							0x54|0x80000000
#define TAG_FCountMode						0x55|0x80000000
#define TAG_VariableFCount					0x56|0x80000000   // Write-Only, in Fields
#define TAG_SlowFCount						0x57|0x80000000
#define TAG_MedFCount						0x58|0x80000000
#define TAG_FastFCount						0x59|0x80000000
#define TAG_VariableFCount68000			0x5a|0x80000000   // Many of these require the high bit set too..
#define TAG_SlowFCount68000				0x5b|0x80000000   // i.e. GetValue(FG,0x80000000|TAG_NumFramesSlow)
#define TAG_MedFCount68000					0x5c|0x80000000
#define TAG_FastFCount68000				0x5d|0x80000000
#define TAG_NumFields						0x5e|0x80000000
#define TAG_StartTime						0x5f|0x80000000
#define TAG_DescriptorList					0x60
#define TAG_AboutList						0x61
#define TAG_CommentList						0x62
#define TAG_AlgoFXtype						0x63|0x80000000
#define TAG_AlgoFXborder					0x64|0x80000000
#define TAG_NumFramesSlow					0x65|0x80000000   // Read-Only, in Frames
#define TAG_NumFramesMedium				0x66|0x80000000
#define TAG_NumFramesFast					0x67|0x80000000
#define TAG_NumFramesVariable				0x68|0x80000000
#define TAG_Page								0x69
#define TAG_Speed								0x6a|0x80000000
#define TAG_Delay								0x6b|0x80000000
#define TAG_Duration							0x6c|0x80000000	// Fields
#define TAG_AudioAttack						0x6d|0x80000000
#define TAG_AudioDecay						0x6e|0x80000000
#define TAG_RecFields						0x6f|0x80000000
#define TAG_AudioOn							0x70|0x80000000 // bit0,1 tel if audio is present in ch1,2  bits 2,3 are enable for ch1,2
#define TAG_AudioStart						0x71|0x80000000
#define TAG_AudioDuration					0x72|0x80000000
#define TAG_ClipStartField					0x73|0x80000000
#define TAG_FadeInVideo						0x74|0x80000000
#define TAG_MaxDuration						0x75|0x80000000
#define TAG_VideoSource						0x76|0x80000000
#define TAG_LoadedSlices					0x77|0x80000000
#define TAG_OriginalLocation				0x78
#define TAG_AudioVolume1					0x79|0x80000000
#define TAG_AudioVolume2					0x7a|0x80000000
#define TAG_AudioPan1						0x7b|0x80000000
#define TAG_AudioPan2						0x7c|0x80000000
#define TAG_PanelMode						0x7d|0x80000000
#define TAG_ColorMode						0x7e|0x80000000
#define TAG_CycleMode						0x7f|0x80000000
#define TAG_DataMode							0x80|0x80000000
//The following 2 items are only used for Sequencing
#define TAG_AdjustedVideoStart			0x81|0x80000000	//includes FX overlap at start or end of clip
#define TAG_AdjustedVideoDuration		0x82|0x80000000	//includes FX overlap at start or end of clip

#define TAG_Asynchronous					0x83|0x80000000	//Used with AREXX scripts and sequencing.
																//=FALSE if AREXX doesn't return until
																//the AREXX script is finished.
																//Defaults to FALSE = synchronous.
#define TAG_CommandLine						0x84				//Text string containing a command
																		//with optional parameters.
#define TAG_SMPTEtime						0x85				//SMPTEinfo structure
#define TAG_TBarPosition					0x86|0x80000000
#define TAG_HoldFields						0x87|0x80000000
#define TAG_TakeOffset						0x88|0x80000000	// FRAC32-FX take pos
#define TAG_ASourceLen						0x89|0x80000000	// FRAC32-FX A vid src length
#define TAG_BSourceLen						0x8a|0x80000000	// FRAC32-FX B vid src length (or 0)
#define TAG_AudioFadeFlags					0x8b|0x80000000	// For audio ramping w/FX

#endif
