/*********************************************************************\
*
* AppendFields - Test: append video fields
*
* $Id: AppendFields.c,v 1.1 1995/10/16 17:19:33 Flick Exp $
*
* $Log: AppendFields.c,v $
*Revision 1.1  1995/10/16  17:19:33  Flick
*Added optional compression mode argument
*
*Revision 1.0  1995/05/05  15:53:03  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	03/15/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);


struct Library *FlyerBase;

struct FlyerVolume	FlyVol;
struct ClipAction		Action;

UBYTE	QualModes[] = {
	0x00,		// Standard
	0x03,		// Extended
	0x00,		// Audio-only (yuck!)
	0x10		// HQ5
};

main(int argc,char **argv)
{
	int	fields,mode;
	ULONG	res;

	if ((argc<3)||(argc>4)||(argv[1][0]=='?')) {
		printf("Usage: %ls <volume:clipname> <fields> [<mode>]\n",argv[0]);
		return(20);
	}

	GetArg(argv[2],&fields,0,0xFFFF,"Field count");
	if (argc==4)
		GetArg(argv[3],&mode,0,3,"Compression mode");
	else
		mode = -1;


	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.Board = 0;
	FlyVol.Flags = 0;
	FlyVol.SCSIdrive = 0;
	FlyVol.Path = argv[1];

	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;

	Action.Channel = 0;

	/* These flags are currently ignored */
	Action.Flags = CAF_VIDEO;
//	if (vidflag)
//		Action.Flags |= CAF_VIDEO;
//	if (audchans==2)
//		Action.Flags |= (CAF_AUDIOL | CAF_AUDIOR);
//	else if (audchans==1)
//		Action.Flags |= CAF_AUDIOL;

	Action.VidFieldCount = Action.AudFieldCount = fields;

	Action.VolSust1 = 0xFFFF;		// Unimportant
	Action.VolSust2 = 0xFFFF;		// "
	Action.VidStartField = 0;		// "

	if (mode >= 0)
	{
		res = VideoCompressModes(0,QualModes[mode],4,0);
		Delay(5);			// Allow a few fields of mode-settling
	}

	res = AppendFields(&Action);
	if (res) {
		printf("\nError %ld - %ls\n",res,Error2String(res));
	}

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stcd_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
