/*********************************************************************\
*
* CopyClip - Copy Flyer clip using high-speed copying
*
* $Id: CopyClip.c,v 1.0 1995/05/05 15:48:25 Flick Exp $
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* All information contained herein is property of
* NewTek, Inc. and is subject to change without
* notice.
*
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;
struct FlyerVolume SrcVol,DestVol;

main(int argc,char **argv)
{
	int	unit;
	ULONG	err;

	if ((argc!=4)||(argv[1][0]=='?'))
	{
		printf("Usage: %ls <board> <vol:name> <destvol:>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");
	SrcVol.Board = unit;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
	{
		printf("Open flyer.library failed\n");
		exit(10);
	}

	SrcVol.Flags = 0;
	SrcVol.Path = argv[2];		// Complete volume:pathname

	DestVol.Flags = 0;
	DestVol.Path = argv[3];		// Complete volume:pathname

	err = FlyerCopyClip(&SrcVol,&DestVol);					// Do it!
	if (err)
		printf("Error %ld - %ls\n",err,Error2String(err));
	else
		printf("Created file\n");

	CloseLibrary(FlyerBase);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi))
	{
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
