/*********************************************************************\
*
* Volumes - Dump mounted Flyer volume names
*
* $Id: Volumes.c,v 1.0 1995/05/05 15:53:57 Flick Exp $
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* All information contained herein is property of
* NewTek, Inc. and is subject to change without
* notice.
*
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

void Cleanup(int code);

struct Library		*FlyerBase;


main(int argc,char **argv)
{
	struct FlyerVolNode	*vptr;
	struct MinList			*vollist;

	if (argc!=1)
	{
		printf("Usage: %ls\n",argv[0]);
		Cleanup(10);
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
	{
		printf("Open flyer.library failed\n");
		Cleanup(10);
	}

	printf("Flyer volumes in list...\n");

	vollist = (struct MinList *)LockFlyVolList();
	if (vollist==0)
	{
		printf("Couldn't lock Flyer volume list\n");
	}
	else
	{
		vptr = (struct FlyerVolNode *)vollist->mlh_Head;

		while (vptr->Node.ln_Succ)
		{
			printf("\"%ls\"  brd=%ld, drive=%ld, flags=%ld\n",vptr->Name,vptr->Board,
				vptr->SCSIdrive,vptr->Flags);
/*			printf("(at address %lx)\n",vptr); */

			vptr = (struct FlyerVolNode *)vptr->Node.ln_Succ;
		}
		UnLockFlyVolList(vollist);
	}

	Cleanup(0);

	return(0);
}


void Cleanup(int code)
{
	if (FlyerBase)
		CloseLibrary(FlyerBase);

	if (code)
		exit(code);
}
