	IFND	INC_FLYER_I
INC_FLYER_I	SET	1

**
**	Include file for use by Apps calling flyer.library
**
**	(c) Copyright 1994 NewTek, Inc.
**	    All Rights Reserved
**

;	IFND	DOS_DOS_I
;	INCLUDE	"dos/dos.i"
;	ENDC


FLYERLIBNAME:	MACRO
		DC.B	'flyer.library',0
		DS.W	0
		ENDM


*******************************************
*** Public Return Codes for Flyer Calls ***
*******************************************

*** General Flyer Errors ***
FERR_OKAY		EQU $00	;All went well
FERR_CMDFAILED		EQU $01	;Command failed for some reason
FERR_BUSY		EQU $02	;Still in progress
FERR_ABORTED		EQU $03	;User abort
FERR_BADPARAM		EQU $04	;Bad command parameter
FERR_BADCOMMAND		EQU $05	;Command not defined/supported
FERR_BADVIDHDR		EQU $06	;Ran out of video - no header detected
FERR_WRONGMODE		EQU $07	;Wrong play/rec mode for action
FERR_OLDDATA		EQU $08	;Incompatible data
FERR_NOAUDIOCHAN	EQU $09	;No free audio channel(s)
FERR_CHANINUSE		EQU $0A	;Video/SCSI channel not available
FERR_BADFLDHAND		EQU $0B	;Bad or missing field handle

*** Flyer Internal Errors ***
FERR_NOTASKS		EQU $10	;No SCSI tasks available for use
FERR_LISTCORRUPT	EQU $11	;Internal list corrupt
FERR_NOTINRANGE		EQU $12	;Internal list error
FERR_EEFAILURE		EQU $13	;EEPROM failure
FERR_NOFINDERS		EQU $14	;No FrameFinders available for use
FERR_BADMODULE		EQU $1F	;Incompatible module provided

*** FileSystem Errors ***
FERR_OBJNOTFOUND	EQU $20	;Could not find file/dir
FERR_FULL		EQU $21	;Drive full
FERR_DIRFULL		EQU $22	;Directory full
FERR_EXHAUSTED		EQU $23	;Directory list exhausted
FERR_FSFAIL		EQU $24	;FileSystem failure
FERR_WRONGTYPE		EQU $25	;Wrong type of object
FERR_UNFORMATTED	EQU $26	;Drive not high-level formatted
FERR_EXCLUDED		EQU $27	;Exclusive lock prevented action
FERR_OUTOFRANGE		EQU $28	;Seek beyond bounds
FERR_CANTEXTEND		EQU $29	;End of file, and cannot extend file
FERR_PROTECTED		EQU $2A	;Drive write-protected
FERR_DIFFERENT		EQU $2B	;Grips are different objects
FERR_EXISTS		EQU $2C	;File already exists
FERR_NOMEM		EQU $2D	;Out of storage
FERR_DELPROT		EQU $2E	;Delete-protected file
FERR_READPROT		EQU $2F	;Read-protected file
FERR_WRITEPROT		EQU $30	;Write-protected file
FERR_INUSE		EQU $31	;Disk/object in use
FERR_DIRNOTEMPTY	EQU $32	;Directory was not empty

*** SCSI Errors ***
FERR_SELTIMEOUT		EQU $40	;SCSI Time-out -- no drive
FERR_BADSTATUS		EQU $41	;Bad status after executing command

*** Amiga Library Errors ***
FERR_NOCARD		EQU $70	;Flyer card specified does not exist
FERR_LIBFAIL		EQU $71	;Library failed to pass command to Flyer
FERR_ASYNCFAIL		EQU $72	;An asynchronous command failed
FERR_VOLNOTFOUND	EQU $73	;Volume name not found
FERR_NOFREECMD		EQU $74	;Library<->Flyer RAM clogged
FERR_BADID		EQU $75	;Illegal async ID

FERR_LIMIT		EQU $7F


**********************************************
***  Mode - for use with StillMode command ***
**********************************************

MODE_FIELD	EQU	1
MODE_PAIR	EQU	2
MODE_FRAME	EQU	4


*********************************************************
***  Field Mode - for use with OpenWriteField command ***
*********************************************************

FIELD_REPLACE	EQU	1
FIELD_APPEND	EQU	2

ds_SIZEOF	EQU	12

*********************************************
***  Used with the FlyerDriveInfo command ***
*********************************************

*** Structure returned from FlyerDriveInfo call ***

    STRUCTURE FlyerVolInfo,0
	UWORD	fvi_len		;Length of this structure
	ULONG	fvi_Ident	;'ROOT' for good volumes
	UBYTE	fvi_Version	;Version of FileSystem that wrote drive
	UBYTE	fvi_LTitle	;Length for L-String
	STRUCT	fvi_Title,80	;String (null-terminated)
	ULONG	fvi_Blocks	;Total user blocks
	ULONG	fvi_BlksFree	;User blocks free
	UBYTE	fvi_Flags	;FVIF_xxx - see below
	UBYTE	fvi_DiskOkay	;FileSys in good shape?
	UWORD	fvi_BlkSize	;Block size
	STRUCT	fvi_DiskDate,ds_SIZEOF
	ULONG	fvi_FragBlks	;Fragmented blocks
	ULONG	fvi_Largest	;Largest free chunk (in blocks)
	ULONG	fvi_Optimized	;Largest free chunk if optimized (in blocks)
	STRUCT	fvi_reserved,4*4
	LABEL	FVI_sizeof

*** FlyerVolInfo Flags ***
	BITDEF	FVI,VIDEOREADY,0	;Drive can handle video
	BITDEF	FVI,AUDIOREADY,1	;Drive can handle audio
	BITDEF	FVI,WRITEPROT,2		;Drive is not writable

*** Structure returned from GetClipInfo call ***

    STRUCTURE ClipInfo,0
	UWORD	ci_len		;Length of this structure
	STRUCT	ci_Name,80
	STRUCT	ci_Comment,80
	UBYTE	ci_Flags	;CIF_xxxx -- see below
	UBYTE	ci_Type		;Unused -- FLYER_TYPE_xxx
	STRUCT	ci_Date,ds_SIZEOF
	ULONG	ci_Bits		;User defined
	ULONG	ci_Fields	;Length in fields
	ULONG	ci_Start	;Start block on drive
	ULONG	ci_Length	;Byte length
	ULONG	ci_IndexBlk	;Location of clip's index
	UBYTE	ci_NumAudChans	;Number of audio channels contained
	STRUCT	ci_reserved,31
	LABEL	CI_sizeof

*** Flyer object types ***
FLYER_TYPE_FILE		EQU	1
FLYER_TYPE_DIR		EQU	2
FLYER_TYPE_ROOT		EQU	3

*** ClipInfo Flags ***
	BITDEF	CI,HASVIDEO,0	;Clip contains video
	BITDEF	CI,HASAUDIO,1	;Clip contains audio


*** Structure returned from GetSMPTE call ***

    STRUCTURE SMPTEinfo,0
	UBYTE	si_SMPTEvalid		;SMPTE info valid?
	UBYTE	si_SMPTEhours		;Hours
	UBYTE	si_SMPTEminutes		;Minutes
	UBYTE	si_SMPTEseconds		;Seconds
	UBYTE	si_SMPTEframes		;Frames (1/30th)
	UBYTE	si_SMPTEuser1		;BW1 and 2
	UBYTE	si_SMPTEuser2		;BW3 and 4
	UBYTE	si_SMPTEuser3		;BW5 and 6
	UBYTE	si_SMPTEuser4		;BW7 and 8
	UBYTE	si_SMPTEflags		;See SIx_xxxx below
	LABEL	SI_sizeof

*** SMPTE Flags ***
	BITDEF	SI,DROPFRAME,0	;Position is in drop-frame format
	BITDEF	SI,COLORFRAME,1	;Color Frame identification applied
	BITDEF	SI,REVERSE,2	;Time code is reverse-direction


*** Structure used with OpenWriteField call ***

    STRUCTURE VidCompInfo,0
	UBYTE	vci_Algo	;Algorithm type
	UBYTE	vci_Tolerance	;Error tolerance
	UBYTE	vci_FIRcomp	;FIR compensation level
	UBYTE	vci_RndFreq	;Noise frequency
	UBYTE	vci_RndSeed	;Noise seed
	UBYTE	vci_Flags	;VCIx_xxx Flags
	ULONG	vci_Private1	;Internal use only
	STRUCT	vci_reserved,8
	LABEL	VCI_sizeof

ALGO_OLDD2	EQU	0	;Old D2
ALGO_D2		EQU	1	;D2
ALGO_SN		EQU	2	;sub-nyquist

*** VidCompInfo Flags ***
	BITDEF	VCI,AUTOMODE,0	;Optimize compression on the fly

SAMPLESPERLINE	EQU	752	;Samples per active video line
LINESPERFIELD	EQU	240	;Lines per active video field


    STRUCTURE FlyerVolume,0
	APTR	fv_Path		;Pointer to Volume:clipname string
	UBYTE	fv_Board	;Board number (0...n)
	UBYTE	fv_SCSIdrive	;SCSI unit on channel
	UBYTE	fv_Flags	;See below
	UBYTE	fv_pad
	STRUCT	fv_reserved,4*4
	LABEL	FV_sizeof


	BITDEF	FV,USENUMS,0	;Ignore volume in string, use numbers


    STRUCTURE ClipAction,0
	APTR	ca_Volume	;Ptr to FlyerVolume structure
	ULONG	ca_ID		;For asynchronous operation
	UBYTE	ca_ReturnTime	;When this call should return
	UBYTE	ca_Channel	;Video channel to use: 0, 1, or FF for choice
	UBYTE	ca_Flags	;CAF_xxxxx -- see below
	UBYTE	ca_PermissFlags	;CAPF_xxxxx -- see below
	ULONG	ca_VidStartField
	ULONG	ca_AudStartField
	ULONG	ca_VidFieldCount
	ULONG	ca_AudFieldCount
	ULONG	ca_GoClock
	UWORD	ca_MatteY	;For use with CAF_USEMATTE
	BYTE	ca_MatteI
	BYTE	ca_MatteQ
	;Following audio stuff not yet supported
	UWORD	ca_VolAttack	;Attack time/ramp time
	UWORD	ca_VolSust1	;Channel 1 sustain volume
	UWORD	ca_VolSust2	;Channel 2 sustain volume
	UWORD	ca_VolDecay	;Decay time
	WORD	ca_AudioPan1	;Channel 1 pan (-left, 0 ctr, +right)
	WORD	ca_AudioPan2	;Channel 2 pan (-left, 0 ctr, +right)
	ULONG	ca_TotalAudStart	;Combined audio start field
	ULONG	ca_TotalAudLength	;Combined audio field count
	STRUCT	ca_reserved0,4*4
	;These block values provide a "raw" access to clip points
	ULONG	ca_StartBlk
	ULONG	ca_EndBlk
	STRUCT	ca_reserved1,4*4
	;These things used by the FileSystem
	ULONG	ca_Grip
	ULONG	ca_FileID
	UBYTE	ca_Access
	UBYTE	ca_pad2
	ULONG	ca_FldHandle	;Handle to open field for direct R/W
	STRUCT	ca_reserved2,4*4
	;Special return values -- Valid only when command complete
	ULONG	ca_LastFieldDone
	LABEL	CA_sizeof

*** ReturnTime values ***
RT_FREE		equ	0	;Return immediately, never follow-up
RT_IMMED	equ	1	;Return immediately
RT_STARTED	equ	2	;Return when actually started
RT_STOPPED	equ	3	;Return when action stops

*** ClipAction flags ***
	BITDEF	CA,VIDEO,0		;Include clip video
	BITDEF	CA,AUDIOL,1		;Include left audio channel
	BITDEF	CA,AUDIOR,2		;Include right audio channel
	BITDEF	CA,USEMATTE,3		;Display matte color when clip done
	BITDEF	CA,NOPREROLL,4		;Skip pre-roll
	BITDEF	CA,APPEND,5		;For single-frame appending

*** ClipAction permission flags ***
	BITDEF	CAP,STEALOURVIDEO,0	;Can steal requested video channel
	BITDEF	CAP,KILLOTHERVIDEO,1	;Can kill other video channel(s)
	BITDEF	CAP,ERRIFBUSY,2		;Return error rather than wait for it
	BITDEF	CAP,AUTOMUTE,3		;Automatically mute audio when looping

*** FlyerInputSel values (video source) ***
FI_Camcorder	equ	0	;Needs TBC
FI_SVHS		equ	1	;Needs TBC
FI_Toaster1	equ	2
FI_Toaster2	equ	3
FI_ToasterMain	equ	4
FI_ToasterPV	equ	5

*** FlyerInputSel values (sync source) ***
FS_ToasterMain	equ	0
FS_Toaster1	equ	1

*** Flyer Calibration values ***
CALIB_DACA_PHASE_EDGE	equ 0
CALIB_DACA_PHASE_COURSE	equ 1
CALIB_DACA_PHASE_FINE	equ 2
CALIB_DACB_PHASE_EDGE	equ 3
CALIB_DACB_PHASE_COURSE	equ 4
CALIB_DACB_PHASE_FINE	equ 5
CALIB_ADC_PHASE_EDGE	equ 6
CALIB_ADC_PHASE_COURSE	equ 7
CALIB_ADC_PHASE_FINE	equ 8
CALIB_HPLAYOFFSETA	equ 9
CALIB_HPLAYOFFSETB	equ 10
CALIB_HRECOFFSETA	equ 11
CALIB_HRECOFFSETB	equ 12
CALIB_PEDESTALA		equ 13
CALIB_PEDESTALB		equ 14

	ENDC	; INC_FLYER_I
