#ifndef NEWTEK_BITMAP_H
#define NEWTEK_BITMAP_H
/*
 * $Id: bitmap.h 5.2 1995/08/02 16:58:44 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/bitmap.h $
 *
 * $Log: bitmap.h $
 * Revision 5.2  1995/08/02 16:58:44  pfrench
 * Changed directories of bitmap.h
 * Revision 5.1  1995/06/01 22:40:14  pfrench
 * Added IFF ILBM parsing structures and defines
 * Revision 5.0  1995/03/22 21:40:12  pfrench
 * Initial revision
 */

#ifdef AMIGA
	#define iff_long(x)		x
	#define iff_word(x)		x
	#define CONV_LONG(x)
	#define CONV_WORD(x)
#else
	#include <windows.h>

	/* BitMap Struct */

	struct BitMap
	{
	    UWORD   BytesPerRow;
	    UWORD   Rows;
	    UBYTE   Flags;
	    UBYTE   Depth;
	    UWORD   pad;
	    UWORD	*Planes[8];
	};

	/* SmallBitMap, for Allocating you own plane pointers (in case Depth != 8 */

	struct SmallBitMap
	{
	    UWORD   BytesPerRow;
	    UWORD   Rows;
	    UBYTE   Flags;
	    UBYTE   Depth;
	    UWORD   pad;
	    UWORD	*Planes[0];
	};

/* **************************************************************************** */
/* **************************************************************************** */

	typedef struct BitMapHeader
	{
		UWORD w,h;
		WORD  x,y;
		UBYTE nPlanes;
		UBYTE masking;
		UBYTE compression;
		UBYTE pad1;
		UWORD transparentColor;
		UBYTE xAspect,yAspect;
		WORD  pageWidth,pageHeight;
	} BitMapHeader;

/*  Masking techniques  */
#define	mskNone					0
#define	mskHasMask				1
#define	mskHasTransparentColor	2
#define	mskLasso				3

/* We plan to define this value, to mean that the BMHD.transparentColor
 * variable contains a count of alpha channel planes which are stored
 * in the BODY AFTER the image planes.  As always, the count of
 * masking/alpha planes is not included in BMHD.nPlanes.
 */
#define	mskHasAlpha				4

/*  Compression techniques  */
#define	cmpNone			0
#define	cmpByteRun1		1

/* CAMG Modes (in CAMG chunk of ILBMs) */
#define GENLOCK_VIDEO	0x0002
#define LACE			0x0004
#define DOUBLESCAN		0x0008
#define SUPERHIRES		0x0020
#define PFBA			0x0040
#define EXTRA_HALFBRITE 0x0080
#define GENLOCK_AUDIO	0x0100
#define DUALPF			0x0400
#define HAM				0x0800
#define EXTENDED_MODE	0x1000
#define VP_HIDE			0x2000
#define SPRITES			0x4000
#define HIRES			0x8000

/* Parameter packet sent to ILBM loader routine */
struct LoadILBMParams
{
	APTR			 lip_mempool;

	struct BitMap	*lip_bm;

	BitMapHeader	 lip_bmhd;
	ULONG			 lip_camg;
	UBYTE			*lip_colors;
	ULONG			 lip_colors_size;	/* size of allocation */
};

#endif

#endif /* NEWTEK_BITMAP_H */
