/*
 * $Id: flyclip_protos.h 5.0 1995/09/21 19:30:54 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/flyclip_protos.h $
 *
 * $Log: flyclip_protos.h $
 * Revision 5.0  1995/09/21 19:30:54  pfrench
 * Initial revision
 */

#ifdef __cplusplus
extern "C" {	/* Assume C declarations for C++ */
#endif			/* __cplusplus */

/* From flyclip.c */
struct FlyClipInfo *fc_Open(
	char			*filename,
	ULONG			 mode );

long fc_Close(
	struct FlyClipInfo *fc );

long fc_SetQuality(
	struct FlyClipInfo	*fc,
	unsigned long		 max_write_blocks,	/* For write only */
	unsigned long		 flags );			/* Undocumented, must be NULL */

long fc_ReadVideoField(
	struct FlyClipInfo	*fc,
	long				 field_num,
	unsigned char		*field_buf );

long fc_WriteVideoField(
	struct FlyClipInfo	*fc,
	long				 field_num,
	unsigned char		*field_buf );

unsigned long fc_GetNumFields(
	struct FlyClipInfo *fc );

/* From vtasc.c */

/* WARNING WARNING WARNING */

/* "field_buf" MUST BE PADDED BY EIGHT BYTES OF USABLE MEMORY BEFORE
 * AND EIGHT BYTES TRAILING THE END IF YOU INTEND TO USE VTASC ON THE DATA.
 *
 * Note that those eight bytes will always be preserved, they just
 * must not generate an MMU hit when accessed by VTASC functions.
 *
 * If the object was allocated by "ob_AllocObj" then you are OK for
 * the leading eight bytes.  Just allocate an extra eight bytes for
 * "comp_buf" only.
 *
 * If your ByteMap or Frame was allocated with bym_Create() or
 * fr_Create(), this has already been done for you.  I predict most
 * problems will arise with people using the composite_convert functions
 * and then running the FIR on the D2 buffer they've allocated.
 */

void VTASC_FIRScanLineInPlace(
	unsigned char	*scanline,
	signed long		*accum_line,
	signed short	*coefs,
	unsigned short	 width,
	unsigned char	 scalebits );

void VTASC_FIRField(
	unsigned char	*fld,
	unsigned short	 width,
	unsigned short	 height,
	signed long		*accum_line,
	signed short	*coefs,
	unsigned char	 scalebits );

signed short *VTASC_GetPresetFIRCoefs(
	long			 coef_num,
	long			 inverse,
	long			*pscale_bits );

#ifdef __cplusplus
}			/* End of extern "C" { */
#endif		/* __cplusplus */
