/*
 * $Id: nt_tools_protos.h 5.5 1995/09/21 19:34:22 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/nt_tools_protos.h $
 *
 * $Log: nt_tools_protos.h $
 * Revision 5.5  1995/09/21 19:34:22  pfrench
 * Changed swap function parameters
 * Revision 5.4  1995/08/03 00:03:46  pfrench
 * Removed void declaration for bm_Delete()
 * Revision 5.3  1995/08/02 19:43:58  pfrench
 * Added protos for rgb2comp.c
 * Revision 5.2  1995/07/12 19:36:26  pfrench
 * Surrounded protos with extern c;s
 * Revision 5.1  1995/07/11 20:25:52  pfrench
 * forgot fld_ToDIB function
 * Revision 5.0  1995/07/11 19:37:06  pfrench
 * Initial revision
 */

#ifdef __cplusplus
extern "C" {	/* Assume C declarations for C++ */
#endif			/* __cplusplus */

/* From bitmap.c */
struct BitMap *bm_Create(
	APTR mempool,
	ULONG width, 
	ULONG height, 
	ULONG depth, 
	ULONG flags );

void bm_Delete(
	struct BitMap *bm);

/* From bm_cvt.c */
struct ByteMap *bym_LoadILBM( APTR fh );

struct ByteMap *bym_Create(
	APTR mempool,
	unsigned long width,
	unsigned long hieght,
	unsigned long byte_planes );

void bym_Delete(
	struct ByteMap *bym );

void bym_BitMap2ByteMap(
	struct BitMap	*bm,
	struct ByteMap	*bym );

void PlanarToChunky( 
	UWORD ** planes, 
	ULONG plane_offset, 
	UWORD num_planes, 
	UBYTE *pixels, 
	LONG num_pixels );

void PlanarToChunky_rev( 
	UWORD ** planes, 
	ULONG plane_offset, 
	UWORD num_planes, 
	UBYTE *pixels, 
	LONG num_pixels );

/* From comp_convert.c */
struct comp_convert	*cc_Create(
	void *mempool,
	long width );

void cc_Delete( struct comp_convert *cc );

void cc_split_comp_iq(
	struct comp_convert	*cc );

void cc_split_comp_iq_odd(
	struct comp_convert	*cc );

void cc_filter_iq(
	struct comp_convert	*cc );

void cc_extract_y(
	struct comp_convert	*cc );

void cc_extract_y_odd(
	struct comp_convert	*cc );

void cc_split_iq(
	struct comp_convert	*cc );

void cc_decode_yiq(
	struct comp_convert	*cc );

void cc_full_decode(
	struct comp_convert	*cc,
	unsigned char		*alt_line,
	unsigned char		 odd_line );

/* from rgb2comp.c */
void cc_full_encode(
	struct comp_convert	*cc,
	unsigned char		*alt_scanline,
	long				 odd_scanline );

void cc_y_filter(
	struct comp_convert	*cc );

void cc_i_filter(
	struct comp_convert	*cc );

void cc_q_filter(
	struct comp_convert	*cc );

void cc_merge_yiq(
	struct comp_convert	*cc,
	unsigned char		*alt_scanline,
	long				 odd_scanline );

void cc_rgb2yiq(
	struct comp_convert	*cc );

/* From croutonload.c */
struct BitMap *LoadIconBitMap( APTR fh, APTR mempool );

ULONG ob_SeekUp2IconsBitMap( APTR fh );

ULONG ob_Seek2IconsBitMap( APTR fh );

ULONG ob_IsGoodIconBM( APTR fh );

ULONG ob_SeekUp2Form( APTR fh, ULONG form_id );

ULONG ob_SeekPrevForm( APTR fh );

ULONG ob_Seek2Form( APTR fh, ULONG form_id );

ULONG ob_SeekNextForm( APTR fh );

/* From framstor.c */
struct Frame *fr_Create(
	APTR mempool,
	long width,
	long height,
	long num_fields );

void fr_Delete(
	struct Frame	*fr );

struct Frame *fr_LoadFrameStore( APTR fh );

APTR fr_ToDIB( struct Frame *fr );

APTR fld_ToDIB(
	struct Frame *fr, 
	long odd );

long fr_BitMap2Frame(
	struct BitMap	*bm,
	struct Frame	*fr );

void BitMap2Field(
	struct BitMap	*bm,				/* Source BitMap */
	short			 src_plane,			/* Beginning Plane */
	short			 src_row,			/* Row To Read */
	unsigned char	*comp_data,			/* Composite Data Buffer */
	long			 comp_rows,			/* Number of rows to read */
	long			 comp_width );		/* Width of composite buffer */

/* From ilbm_io.c */
LONG lip_load(
	struct LoadILBMParams *lip, 
	APTR fh );

/* From swap.c */
ULONG swap_long( ULONG x );
void swap_longa( ULONG *x );
UWORD swap_word( UWORD x );
void swap_worda( UWORD *x );

#ifdef __cplusplus
}			/* End of extern "C" { */
#endif		/* __cplusplus */
