#ifndef PROOF_CLASSES_H
#define PROOF_CLASSES_H TRUE
/*
 * $Id: classes.h 5.1 1995/07/10 22:37:00 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/classes.h $
 *
 * $Log: classes.h $
 * Revision 5.1  1995/07/10 22:37:00  pfrench
 * Moved proof includes to new directory.
 * Revision 5.0  1995/03/22 21:55:02  pfrench
 * Initial revision
*Revision 5.2  1994/12/16  14:40:09  pfrench
*rootclass object now contains an allocator object ptr.
*
*Revision 5.1  1994/11/28  14:11:38  pfrench
*Added more conditionals if intuition structures
*have already been defined
*
*Revision 5.0  1994/10/12  18:56:14  pfrench
*FirstCheckIn
*
 */

#ifndef PROOF_LIB_H
#include <proof/proof_lib.h>
#endif

#ifndef PROOF_CLASSUSR_H
#include <proof/classusr.h>
#endif

#ifndef PROOF_HOOKS_H
#include <proof/hooks.h>
#endif

#ifndef	INTUITION_CLASSES_H

	struct Class
	{
		struct Hook		cl_Dispatch;
		ULONG			cl_Reserved;	/* must be 0 */
		struct Class	*cl_Super;
		ClassID			cl_ID;

		UWORD			cl_InstOffset;
		UWORD			cl_InstSize;

		ULONG			cl_UserData;

		ULONG			cl_SubClassCount;

		ULONG			cl_ObjectCount;
		ULONG			cl_Flags;

		/* fields added to support "proxy" class, etc. */
		UWORD			cl_NegInstOffset;
		UWORD			cl_NegInstSize;

	};

	#define INST_DATA(cl,o)		((VOID *)(((UBYTE *)(o))+(cl)->cl_InstOffset))
	#define NEGINST_DATA(cl,o)	((VOID *)(((UBYTE *)(o))-(cl)->cl_NegInstOffset))

	#define SIZEOF_INSTANCE(cl)	((cl)->cl_InstOffset + (cl)->cl_InstSize + (cl)->cl_NegInstOffset )

	/* All objects have a class pointer as the first four bytes before */
	/* the actual object pointer */
	struct _Object
	{
		APTR				 o_allocator_ob;
		struct Class	*o_Class;
	};

	#define _OBJ( o )			((struct _Object *)(o))
	#define BASEOBJECT( _obj )	((Object *)(_OBJ(_obj)+1))
	#define _OBJECT( o )		(_OBJ(o) - 1)
	#define OCLASS( o )			((_OBJECT(o))->o_Class)

#endif /* INTUITION_CLASSES_H */

#endif /* PROOF_CLASSES_H */
