#ifndef PROOF_STREAM_H
#define PROOF_STREAM_H TRUE
/*
 * $Id: stream.h 5.3 1995/07/10 22:37:12 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/stream.h $
 *
 * $Log: stream.h $
 * Revision 5.3  1995/07/10 22:37:12  pfrench
 * Moved proof includes to new directory.
 * Revision 5.2  1995/03/23 04:39:30  pfrench
 * Added general purpose macro for buffered file open.
 * Revision 5.1  1995/03/23 03:31:12  pfrench
 * Moved object method bases to classusr.h
 * Revision 5.0  1995/03/22 21:57:14  pfrench
 * Initial revision
*Revision 5.13  1995/02/09  15:56:53  pfrench
*Added couple options
*
*Revision 5.12  1995/02/09  15:53:12  pfrench
*Added scsi load/unload commands
*
*Revision 5.11  1995/01/27  11:32:28  pfrench
*Added a few new scsi methods and attributes
*
*Revision 5.10  1995/01/26  11:16:50  pfrench
*Added Text stream class
*
*Revision 5.9  1995/01/25  20:14:10  pfrench
*made inquiry buf point to character
*
*Revision 5.8  1995/01/25  20:12:18  pfrench
*Added inquiry to scsistream
*
*Revision 5.7  1995/01/25  15:27:40  pfrench
*Added consolebuffer class
*
*Revision 5.6  1995/01/25  15:11:07  pfrench
*Added console stream and device stream
*
*Revision 5.5  1995/01/17  19:21:42  pfrench
*Added stream sprintf method to resolve conflicts regarding
*whether we put the null characters in there or not
*
*Revision 5.4  1995/01/17  17:32:25  pfrench
*Added couple more methods to the scsistream
*
*Revision 5.3  1995/01/13  20:04:08  pfrench
*Added scsi-stream handler class
*
*Revision 5.2  1994/11/30  12:11:44  pfrench
*Added streambuffer class, It IS NOT SAFE TO USE YET
*
*Revision 5.1  1994/11/28  13:57:54  pfrench
*Added openmode attribute to filestreamclass
*
*Revision 5.0  1994/11/16  19:42:45  pfrench
*FirstCheckIn
*
 */

#ifndef PROOF_CLASSUSR_H
#include <proof/classusr.h>
#endif

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			STREAMCLASS		(METACLASS ONLY)
 *	SuperClass:		ROOTCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/***********************************************
 *	Stream Methods
 */
enum
{
	STREAMM_Dummy = STREAMCLASS_BASE,

	STREAMM_Init,				/* Prepare a stream for session */

	STREAMM_Cleanup,			/* Terminate stream session */

	STREAMM_Read,				/* Similar to Read(fh,buf,len) */

	STREAMM_Write,				/* Similar to Write(fh,buf,len) */

	STREAMM_Seek,				/* Similar to Seek(fh,offset,mode) */

	/* Inherited methods of stream class. For a subclass to inherit
	 *	these abilities, all it has to do is override the
	 *	STREAMM_Read, STREAMM_Write, and STREAMM_Seek methods.
	 */

	STREAMM_Getc,				/* Get a character from a stream */
	STREAMM_UnGetc,			/* Un-get a character */
	STREAMM_Putc,				/* Put a character */

	STREAMM_Gets,				/* Get a line from a stream */
	STREAMM_Puts,				/* Write a line to a stream */

	STREAMM_Printf,			/* Do a printf to a stream */
	STREAMM_SPrintf,			/* Do a printf to a stream (including nulls) */

	STREAMM_InitIFF,			/* Initialize an IFF handle */
};

/* Quick definitions for stream functions */

#define ob_Read(ob,buf,len)	ob_DoMethod((ob),STREAMM_Read,(buf),(len))
#define ob_Write(ob,buf,len)	ob_DoMethod((ob),STREAMM_Write,(buf),(len))
#define ob_Seek(ob,pos,mode)	ob_DoMethod((ob),STREAMM_Seek,(pos),(mode))
#define ob_Getc(ob)				ob_DoMethod((ob),STREAMM_Getc)
#define ob_UnGetc(ob)			ob_DoMethod((ob),STREAMM_UnGetc)
#define ob_Putc(ob,ch)			ob_DoMethod((ob),STREAMM_Putc,(ch))
#define ob_Gets(ob,buf,len)	ob_DoMethod((ob),STREAMM_Gets,(buf),(len))
#define ob_Puts(ob,str)			ob_DoMethod((ob),STREAMM_Puts,(str))
#define ob_InitIFF(ob,iff)		ob_DoMethod((ob),STREAMM_InitIFF,(iff))

/*
 *	STREAMM_Read
 *	STREAMM_Write
 *	STREAMM_Gets
 */
struct opStreamRead
{	ULONG				MethodID;
	APTR				stmrw_buf;
	LONG				stmrw_len;
};

/*
 *	STREAMM_Seek
 */
struct opStreamSeek
{	ULONG				MethodID;
	LONG				stmseek_pos;
	LONG				stmseek_mode;
};

/*
 *	STREAMM_UnGetc
 *	STREAMM_Putc
 */
struct opStreamPutc
{	ULONG				MethodID;
	LONG				stmputc_ch;
};

/*
 *	STREAMM_Puts
 */
struct opStreamPuts
{	ULONG				MethodID;
	char				*stmputs_str;
};

/*
 *	STREAMM_Printf
 *	STREAMM_SPrintf
 */
struct opStreamPrintf
{	ULONG				 MethodID;
	char				*stmprintf_fmt;
	APTR				 stmprintf_argv;
};

/*
 *	STREAMM_InitIFF
 */
struct opStreamInitIFF
{	ULONG					 MethodID;
	struct IFFHandle	*stmiff_iff;
};

/***********************************************
 *	Stream Attributes
 */
enum
{
	STREAMA_Dummy = ((LONG)TAG_USER | STREAMCLASS_BASE),

	STREAMA_IFFBits,					/* Bits that IFF handles can use */
};

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			FILESTREAMCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *		Stream subclass that uses AmigaDos filehandles for I/O
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/***********************************************
 *	FileStream Methods
 */
enum
{
	FSTMM_Dummy = FILESTREAMCLASS_BASE,
};

/***********************************************
 *	FileStream Attributes
 */
enum
{
	FSTMA_Dummy = ((LONG)TAG_USER | FILESTREAMCLASS_BASE),

	FSTMA_FileName,				/* (I)	Name of file to open */

	FSTMA_OpenMode,				/* (I)	Mode to open file in */

	FSTMA_FH,					/* (I)	Use existing filehandle */

};

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			MEMSTREAMCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *		Stream subclass that uses a memory buffer for I/O
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/***********************************************
 *	MemStream Methods
 */
enum
{
	MEMSTMM_Dummy = MEMSTREAMCLASS_BASE,
};

/***********************************************
 *	MemStream Attributes
 */
enum
{
	MEMSTMA_Dummy = ((LONG)TAG_USER | MEMSTREAMCLASS_BASE),

	MEMSTMA_Buf,					/* (I)	address of beginning of buffer memory */

	MEMSTMA_Len,					/* (I)	length of buffer (in memory) */
};

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			STREAMBUFFERCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *		General purpose stream buffer, can buffer any stream
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/***********************************************
 *	StreamBuffer Methods
 */
enum
{
	STMBUFM_Dummy = (STREAMBUFFERCLASS_BASE),
};

/***********************************************
 *	StreamBuffer Attributes
 */
enum
{
	STMBUFA_Dummy = ((LONG)TAG_USER | STREAMBUFFERCLASS_BASE),

	STMBUFA_Stm,			/* (I)	Target stream to buffer */

	STMBUFA_StmClassName,	/* (I)	Create/Connect to stream of classname */

	STMBUFA_Buf,			/* (I)	Buffer to use */

	STMBUFA_BufSize,		/* (I)	Size of buffer (if buf not provided, create) */

};

#define ob_BufferedOpen(filename,mode,bufsiz)	\
	ob_NewObject(NULL,STREAMBUFFERCLASS,		\
		STMBUFA_StmClassName, FILESTREAMCLASS,	\
		STMBUFA_BufSize,	(bufsiz),			\
		FSTMA_FileName, 	(filename),			\
		FSTMA_OpenMode,		(mode),				\
		TAG_DONE)
		

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			DEVICESTREAMCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *		DEVSTMA_Device,		(I) Device Name
 *
 *		DEVSTMA_Unit,			(I) Device Unit
 *
 *		DEVSTMA_Flags,			(I) Device Flags
 *
 *		DEVSTMA_OpenData,		(I) Data in IORequest on OpenDevice
 *
 *		DEVSTMA_OpenLength,	(I) Length of Data in IORequest on OpenDevice
 *
 *		DEVSTMA_IOReqest,		(G) IORequest structure (for rolling your own)
 *
 *****************************************************************************
 *
 */

/**********************************************************/

/* Methods for device stream class objects
 */
enum
{	DEVSTMM_Dummy = DEVICESTREAMCLASS_BASE,
};

/* Method structs for my class objects
 */

/* Attributes for my class objects
 */
enum
{	DEVSTMA_Dummy = ((LONG)TAG_USER | DEVICESTREAMCLASS_BASE),

	DEVSTMA_Device,		/* (I) Device Name */

	DEVSTMA_Unit,			/* (I) Device Unit */

	DEVSTMA_Flags,			/* (I) Device Flags */

	DEVSTMA_OpenData,		/* (I) Data in IORequest on Open */

	DEVSTMA_OpenLength,	/* (I) Length of Data in IORequest on Open */

	DEVSTMA_IOReqest,		/* (G) IORequest structure */
};

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			SCSISTMCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *	New Methods:
 *
 *		SCSISTMM_Rewind,			- Rewind the tape
 *
 *		SCSISTMM_Prevent,			- Prevent removal of the tape
 *
 *		SCSISTMM_Allow,			- Allow removal of the tape
 *
 *		SCSISTMM_Erase,			- Format the tape
 *
 *		SCSISTMM_Locate,			- Seek to block number
 *
 *		SCSISTMM_WriteFileMark,	- Write Filemark on tape
 *
 *	Changed Methods
 *
 *	Attributes:
 *
 *		SCSISTM_Device,			- currently always "flyerscsi.device"
 *
 *		SCSISTM_Unit,				- (channel * 8) + unit
 *
 *****************************************************************************
 *
 */

/**********************************************************/

/* Methods for scsi stream class objects
 */
enum
{	SCSISTMM_Dummy = SCSISTMCLASS_BASE,

	SCSISTMM_TestReady,			/* Is stream ready (tape inserted) */

	SCSISTMM_Rewind,			/* Rewind the tape */

	SCSISTMM_Erase,				/* Format the tape */

	SCSISTMM_Prevent,			/* Prevent removal of the tape */

	SCSISTMM_Allow,				/* Allow removal of the tape */

	SCSISTMM_Locate,			/* Seek to block number */

	SCSISTMM_WriteFileMarks,	/* Write N Filemarks on tape */

	SCSISTMM_Space,				/* Seek to filemark/blocks/etc on tape */

	SCSISTMM_Inquiry,			/* Perform Inquiry to a buffer */

	SCSISTMM_RequestSense,		/* Perform RequestSense to a buffer */

	SCSISTMM_ModeSense,			/* Perform Mode Sense */

	SCSISTMM_ModeSelect,		/* Perform Mode Select */

	SCSISTMM_Load,				/* Load the tape */

	SCSISTMM_UnLoad,			/* Unload the tape */

	SCSISTMM_DoCommand,			/* Perform scsi command */
};

/* Attributes for scsi stream objects
 */
enum
{	SCSISTMA_Dummy = ((LONG)TAG_USER | SCSISTMCLASS_BASE),

	SCSISTMA_Device,			/* (I) default to "flyerscsi.device" */

	SCSISTMA_Unit,				/* (I) (channel * 8) + unit */

	SCSISTMA_MaxTransfer,		/* (I) largest block size can transfer at once */

	SCSISTMA_SenseData,			/*	(G) Sense Data ptr (20 bytes) */

	SCSISTMA_SCSICmd,			/*	(G) (struct SCSICmd *) */

	SCSISTMA_TotalKbytes,		/*	(SG) Total Kilobytes transferred */
};

/*
 * SCSISTMM_Rewind
 * SCSISTMM_Erase
 * SCSISTMM_Prevent
 * SCSISTMM_Allow
 */
struct opSCSICommand
{	ULONG				MethodID;
	ULONG				cmd_immediate;		/* return immediately or 0 == wait */
};

/*
 *	SCSISTMM_Locate
 */
struct opSCSILocate
{	ULONG				MethodID;
	ULONG				sl_block;			/* Logical block address */
};

/*
 *	SCSISTMM_WriteFileMarks
 */
struct opSCSIFileMark
{	ULONG				MethodID;
	ULONG				fm_num_marks;
};

/*
 *	SCSISTMM_Space
 */
struct opSCSISpace
{	ULONG				MethodID;
	LONG				sp_code;				/* code field of space command */
	LONG				sp_count;			/* count field of space command */
};

#define SCSI_SPACE_Blocks			0L
#define SCSI_SPACE_Filemarks		1L
#define SCSI_SPACE_SeqFilemarks	2L
#define SCSI_SPACE_EOD				3L

/*
 *	SCSISTMM_Inquiry
 *	SCSISTMM_RequestSense
 */
struct opSCSIInquiry
{	ULONG				MethodID;
	char				*si_buf;				/* where to store inquiry data */
	LONG				 si_siz;				/* the size of the buffer */
};

/*
 *	SCSISTMM_ModeSense
 */
struct opSCSIModeSense
{	ULONG				MethodID;
	char				*sms_buf;			/* where to store mode sense data */
	LONG				 sms_siz;			/* the size of the buffer */
	LONG				 sms_page;			/* Page to sense */
	LONG				 sms_pc;				/* Page control data */
	LONG				 sms_dbd;			/* Disable Block Descriptors */
};

#define SCSI_MS_PC_CURRENT			0
#define SCSI_MS_PC_CHANGEABLE		1
#define SCSI_MS_PC_DEFAULT			2
#define SCSI_MS_PC_SAVED			3

/*
 *	SCSISTMM_ModeSelect
 */
struct opSCSIModeSelect
{	ULONG				MethodID;
	char				*sel_buf;			/* mode select data to write */
	LONG				 sel_siz;			/* the size of the buffer */
	LONG				 sel_pf;				/* Page Format bit */
	LONG				 sel_sp;				/* Save Pages bit */
};

/*
 *	SCSISTMM_Load
 *	SCSISTMM_UnLoad
 */
struct opSCSILoad
{	ULONG				MethodID;
	LONG				sl_reten;			/* Retension the tape */
	LONG				sl_eot;				/* Position self at end of tape */
};

/*
 *	SCSISTMM_DoCommand
 */
struct opSCSIDoCommand
{	ULONG				 MethodID;
	struct SCSICmd	*sc_scsi;			/* Command to perform */
};

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			CONSOLESTREAMCLASS
 *	SuperClass:		DEVICESTREAMCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *		This is an Amiga Console stream handler
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			CONSOLEBUFFERCLASS
 *	SuperClass:		STREAMBUFFERCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *		STREAMM_Printf		- Will force a STREAMM_Cleanup after printf/sprintf
 *		STREAMM_SPrintf
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/* *************************************************************************** */
/* *************************************************************************** */

/*****************************************************************************
 *	Class:			TEXTSTREAMCLASS
 *	SuperClass:		STREAMCLASS
 *	Description:
 *
 *			This object contains a List of Nodes that stores the lines of
 *		a stream in individual Nodes as you write them out.  For all practical
 *		purposes, you can only use this object as a (struct List).  The
 *		Individual Nodes in the list can be Remove()d and ob_Dispose()d
 *
 *		Currently, this object only listens to ob_Write()s.  It is not
 *		possible to ob_Seek() or ob_Read() on this object.
 *
 *	New Methods:
 *
 *		TXTSTMM_Erase,		- Erase All Lines of text
 *
 *		TXTSTMM_Dump,		- Write contents to a stream
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/**********************************************************/

/* Methods for text stream class objects
 */
enum
{	TXTSTMM_Dummy = TEXTSTREAMCLASS_BASE,

	TXTSTMM_Erase,		/* Erase All Lines of text */

	TXTSTMM_Dump,		/* Write contents to a stream */
};

/*
 *	TXTSTMM_Dump
 */
struct opTXTDump
{	ULONG		MethodID;
	APTR		td_stm;
};

/* Method structs for text stream class objects
 */

/* Attributes for text stream class objects
 */
enum
{	TXTSTMA_Dummy = ((LONG)TAG_USER + TEXTSTREAMCLASS_BASE),

};

/* *************************************************************************** */
/* *************************************************************************** */

#endif /* PROOF_STREAM_H */
