#ifndef PROOF_CLASS_BASES_H
#define PROOF_CLASS_BASES_H
/*
 * $Id: class_bases.h 5.5 1995/10/11 01:34:08 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/class_bases.h $
 *
 * $Log: class_bases.h $
 * Revision 5.5  1995/10/11 01:34:08  pfrench
 * Added FlyerFileStream class
 * Revision 5.4  1995/07/10 22:36:54  pfrench
 * Moved proof includes to new directory.
 * Revision 5.3  1995/04/05 00:10:18  pfrench
 * Added switcherwindowclass
 * Revision 5.2  1995/04/03 22:38:32  pfrench
 * Added shared mempool class
 * Revision 5.1  1995/03/29 02:50:40  pfrench
 * Re-ordered bases
 * Revision 5.0  1995/03/23 04:49:30  pfrench
 * Initial revision
 *
 */

#ifndef INTUITION_CLASSUSR_H
	#define ROOTCLASS			"rootclass"
	#define ROOTCLASS_BASE		0x100L
#endif

/* classes are objects, too */
#define CLASSCLASS				"classclass"
#define CLASSCLASS_BASE			0x1100L

#define MEMORYCLASS				"memoryclass"
#define MEMORYCLASS_BASE		0x0L

#define ALLOCATORCLASS			"allocatorclass"
#define ALLOCATORCLASS_BASE		0x200L

#define MEMPOOLCLASS			"mempoolclass"
#define MEMPOOLCLASS_BASE		0xC00L

#define SHAREDMEMPOOLCLASS		"sharedmempoolclass"
#define SHAREDMEMPOOLCLASS_BASE	0x0L

#define PROXYCLASS				"proxyclass"
#define PROXYCLASS_BASE			0x400L

#define PROXYNODECLASS			"proxynodeclass"
#define PROXYNODECLASS_BASE		0x0L

#define PROXYHASHCLASS			"proxyhashclass"
#define PROXYHASHCLASS_BASE		0x0L

#define HASHTABLECLASS			"hashtableclass"
#define HASHTABLECLASS_BASE		0x300L

#define KEYTABLECLASS			"keytableclass"
#define KEYTABLECLASS_BASE		0xB00L

#define GRIDCLASS				"gridclass"
#define GRIDCLASS_BASE			0x500L

#define LISTCLASS				"listclass"
#define LISTCLASS_BASE			0xF00L

/* -------------------------------------------------------- */

#define STREAMCLASS				"streamclass"
#define STREAMCLASS_BASE		0x700L

#define FILESTREAMCLASS			"filestreamclass"
#define FILESTREAMCLASS_BASE	0x800L

#define MEMSTREAMCLASS			"memstreamclass"
#define MEMSTREAMCLASS_BASE		0x900L

#define STREAMBUFFERCLASS		"streambufferclass"
#define STREAMBUFFERCLASS_BASE	0xA00L

#define DEVICESTREAMCLASS		"devicestreamclass"
#define DEVICESTREAMCLASS_BASE	0xE00L

#define SCSISTMCLASS			"scsistmclass"
#define SCSISTMCLASS_BASE		0xD00L

#define CONSOLESTREAMCLASS		"consolestreamclass"
#define CONSOLESTREAMCLASS_BASE	0x0L

#define CONSOLEBUFFERCLASS		"consolebufferclass"
#define CONSOLEBUFFERCLASS_BASE	0x0L

#define TEXTSTREAMCLASS			"textstreamclass"
#define TEXTSTREAMCLASS_BASE	0x1000L

#define FLYERFILESTREAMCLASS	"flyerfilestreamclass"
#define FLYERFILESTREAMCLASS_BASE	0x0L

/* -------------------------------------------------------- */

#define WINNODECLASS			"winnodeclass"
#define WINNODECLASS_BASE		0x2000L

#define WINCLASS				"winclass"
#define WINCLASS_BASE			0x2100L

#define APPWINCLASS				"appwinclass"		/* Not implemented yet */
#define APPWINCLASS_BASE		0x2200L

#define CHILDWINCLASS			"childwinclass"		/* Not implemented yet */
#define CHILDWINCLASS_BASE		0x2300L

#define BUTTONCLASS				"buttonclass"
#define BUTTONCLASS_BASE		0x2400L

#define SCROLLERCLASS			"scrollerclass"
#define SCROLLERCLASS_BASE		0x2500L

/* -------------------------------------------------------- */

#define EDITWINDOWCLASS			"editwindowclass"
#define EDITWINDOWCLASS_BASE	0x3000L

#define CROUTONGRIDCLASS		"croutongridclass"
#define CROUTONGRIDCLASS_BASE	0x3100L

#define CROUTONCLASS			"croutonclass"
#define CROUTONCLASS_BASE		0x3200L

#define RESOURCECLASS			"resourceclass"
#define RESOURCECLASS_BASE		0x3300L

#define PROJECTCLASS			"projectclass"
#define PROJECTCLASS_BASE		0x3400L

#define DIBCLASS				"dibclass"
#define DIBCLASS_BASE			0x3500L

#define SWITCHERWINDOWCLASS		"switcherwindowclass"
#define SWITCHERWINDOWCLASS_BASE 0x3600L

/* -------------------------------------------------------- */

#endif /* PROOF_CLASS_BASES_H */
