/*
 * $Id: proof_protos.h 5.6 1995/10/10 17:25:54 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/proof_protos.h $
 *
 * $Log: proof_protos.h $
 * Revision 5.6  1995/10/10 17:25:54  pfrench
 * Added msgport function, sprintf, and forbid/permit
 * Revision 5.5  1995/10/10 06:02:36  pfrench
 * Added EnqueueFIFO
 * Revision 5.4  1995/08/09 21:22:24  pfrench
 * Changed many variable tag item list functions to use longs instead
 * of ULONGs, prevented tons ov compiler warnings
 * Revision 5.3  1995/08/02 16:58:18  pfrench
 * Added Todd's RawDoFmt
 * Revision 5.2  1995/07/10 22:37:08  pfrench
 * Moved proof includes to new directory.
 * Revision 5.1  1995/03/23 03:30:22  pfrench
 * Added a few extra functions to proof_exec.c
 * Revision 5.0  1995/03/22 21:56:48  pfrench
 * Initial revision
*Revision 5.1  1995/01/17  19:28:58  pfrench
*Added sprintf
*
*Revision 5.0  1994/12/19  20:59:38  pfrench
*FirstCheckIn
*
 *
 */

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif /* __cplusplus */

#ifdef ULONG_NOT_A_PROBLEM
	/* protos for proof_stubs.lib */
	/* --------------------------------------------------------------------- */
	ULONG	h_CallHook( struct Hook *h, APTR object, ULONG command, ... );

	APTR	ob_NewObject( struct Class *cl, UBYTE *classID, ULONG tag1, ... );
	ULONG	ob_DoMethod( APTR object, LONG command, ... );
	ULONG	ob_DoSuperMethod( struct Class *cl, APTR object, ULONG command, ... );
	ULONG	ob_CoerceMethod( struct Class *cl, APTR object, ULONG command, ... );

	/* ULONG ob_Dispose( APTR object ); */

	ULONG	ob_SetAttrs( APTR object, ULONG tag, ... );
	ULONG	ob_GetAttrs( APTR object, ULONG tag, ... );
	ULONG	ob_SetSuperAttrs( struct Class *cl, APTR object, ULONG tag, ... );
	ULONG	ob_GetSuperAttrs( struct Class *cl, APTR object, ULONG tag, ... );

	LONG	ob_Printf( APTR ob, STRPTR fmt, ... );
	LONG	ob_SPrintf( APTR ob, STRPTR fmt, ... );
#else
	/* protos for proof_stubs.lib */
	/* --------------------------------------------------------------------- */
	ULONG	h_CallHook( struct Hook *h, APTR object, long command, ... );

	APTR	ob_NewObject( struct Class *cl, UBYTE *classID, long tag1, ... );
	ULONG	ob_DoMethod( APTR object, long command, ... );
	ULONG	ob_DoSuperMethod( struct Class *cl, APTR object, long command, ... );
	ULONG	ob_CoerceMethod( struct Class *cl, APTR object, long command, ... );

	/* ULONG ob_Dispose( APTR object ); */

	ULONG	ob_SetAttrs( APTR object, long tag, ... );
	ULONG	ob_GetAttrs( APTR object, long tag, ... );
	ULONG	ob_SetSuperAttrs( struct Class *cl, APTR object, long tag, ... );
	ULONG	ob_GetSuperAttrs( struct Class *cl, APTR object, long tag, ... );

	LONG	ob_Printf( APTR ob, STRPTR fmt, ... );
	LONG	ob_SPrintf( APTR ob, STRPTR fmt, ... );
#endif

/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */
/* protos for proof_library function calls */
/* --------------------------------------------------------------------- */
/* --------------------------------------------------------------------- */

/* proof_os.c */
/* --------------------------------------------------------------------- */
void proof_Forbid( void );
void proof_Permit( void );
struct MessagePort *proof_FindPort( char *name );
void proof_AddPort( struct MessagePort *mp );

/* General purpose sprintf that uses RawDoFmt */
void *proof_sprintf( char *dest, char *fmt, long data1, ... );

/* classes.c */
/* --------------------------------------------------------------------- */
struct Class * cl_MakeClass( UBYTE *classID, UBYTE *superclassID,
	struct Class *superclass, UWORD inst_size, ULONG flags );

struct Class * cl_MakeClassN( UBYTE *classID, UBYTE *superclassID,
	struct Class *superclass, UWORD inst_size, UWORD neg_inst_size, ULONG flags );

ULONG cl_FreeClass( struct Class *cl );

/* proofbase.c */
/* --------------------------------------------------------------------- */
struct ClassBase *pb_GetClassBase( void );
ULONG pb_AddClass( struct Class *cl );
struct Class *pb_FindClass( char *classID );
APTR pb_SetAllocatorObject( APTR newob );

/* objectlib.c */
/* --------------------------------------------------------------------- */
ULONG h_CallHookPkt( struct Hook *h, APTR object, APTR msg );
APTR	ob_NewObjectA( struct Class *cl, UBYTE *classID, struct TagItem *ti );
ULONG	ob_DoMethodA( APTR object, APTR msg );
ULONG	ob_DoSuperMethodA( struct Class *cl, APTR object, APTR msg );
ULONG	ob_CoerceMethodA( struct Class *cl, APTR object, APTR msg );

/* tags.c */
/* --------------------------------------------------------------------- */
struct TagItem *ti_NextTagItem( struct TagItem **pti );
ULONG ti_GetTagData( long tag_id, long defaultVal, struct TagItem *ti );

	/* the following tag functions are still un-implemented */

struct TagItem *ti_AllocateTagItems(ULONG numTags);
void ti_ApplyTagChanges(struct TagItem *list_ti, struct TagItem *change_ti );
struct TagItem *ti_CloneTagItems(struct TagItem *orig_ti);
void ti_FilterTagChanges(struct TagItem *list_ti, struct TagItem *change_ti, ULONG apply );
ULONG ti_FilterTagItems(struct TagItem *list_ti,Tag *filter_ti,ULONG logic );
struct TagItem *ti_FindTagItem( long tag_id, struct TagItem *ti );
void ti_FreeTagItems( struct TagItem *ti );
void ti_MapTags( struct TagItem *list_ti, struct TagItem *map_ti, ULONG mapType );
ULONG ti_PackBoolTags(ULONG initialFlags, struct TagItem *list_ti,struct TagItem *boolmap_ti );
ULONG ti_PackStructureTags( APTR pack, ULONG *packtable, struct TagItem *ti );
void ti_RefreshTagItemClones( struct TagItem *clone_ti, struct TagItem *orig_ti );
ULONG ti_TagInArray( long tag_id, long *ti );
ULONG ti_UnpackStructureTags( APTR pack, ULONG *packtable, struct TagItem *ti );


/* Protoypes from msgport.c */
struct MessagePort *mp_Create(
	STRPTR	mp_name,
	signed char mp_pri );

struct MessagePort *mp_CreateEx(
	STRPTR	mp_name,
	signed char mp_pri,
	long	mp_siz );

LONG mp_Delete( 
	struct MessagePort *mp );

void mp_PutMsg(
	struct MessagePort *mp, 
	struct Message *mn );

struct Message *mp_GetMsg( 
	struct MessagePort *mp );

void mn_ReplyMessage(
	struct Message *mn );

struct Message *mn_Create(
	APTR mempool,
	LONG msg_len );

LONG msg_DoIO( 
	struct MessagePort	*mp,		/* Message Port to send to */
	struct Message		*msg );		/* Message to wait for */

/* --------------------------------------------------------------------- */

#ifndef AMIGA
/*------ memory copy --------------------------------------------------------*/
void CopyMem( APTR source, APTR dest, unsigned long size );
/*------ lists --------------------------------------------------------*/
void Insert( struct List *list, struct Node *node, struct Node *pred );
void AddHead( struct List *list, struct Node *node );
void AddTail( struct List *list, struct Node *node );
void Remove( struct Node *node );
struct Node *RemHead( struct List *list );
struct Node *RemTail( struct List *list );
void NewList( struct List *list );
void Enqueue( struct List *list, struct Node *node );
struct Node *FindName( struct List *list, char *name );
struct Node *FindNode( struct List *list, long pos );
long NodePos( struct List *list, struct Node *node );
long ListLen( struct List *list );
void *RawDoFmt(
	char *FmtStr,
	void *DataStream,
	void ASM (*PutChProc)( REG(d0) char, REG(a3) void * ),
	void *PutChData );
#endif

void EnqueueFIFO( struct List *list, struct Node *node );

#ifdef __cplusplus
}                       /* End of extern "C" { */
#endif       /* __cplusplus */
