/*
 * $Id: proof_win.h 5.3 1995/07/10 22:37:10 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/proof_win.h $
 *
 * $Log: proof_win.h $
 * Revision 5.3  1995/07/10 22:37:10  pfrench
 * Moved proof includes to new directory.
 * Revision 5.2  1995/03/30 03:05:22  pfrench
 * Added new DIB support tags for imagery
 * Revision 5.1  1995/03/29 02:41:22  pfrench
 * Added support for button bitmaps
 * Revision 5.0  1995/03/22 21:57:00  pfrench
 * Initial revision
 */


#ifndef PROOF_CLASSUSR_H
#include <proof/classusr.h>
#endif

#include <windows.h>

/* Class Name passed to Windows Create function */
#define PROOF_WNDCLASS_NAME "proofwndclass"

/* GLOBAL RE-ENTRANT callback function which creates an object message
 * WINM_DoWindowProc, and calls the object with it.
 * NOTE: The Object's GW_USERDATA MUST be set to the object pointer, "ob".
 */
LRESULT CALLBACK ob_WndProc(
	HWND hWnd, UINT message,
	WPARAM wParam, LPARAM lParam );

/*****************************************************************************
 *	Class:			WINDCLASS
 *	SuperClass:		ROOTCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/* SPECIAL HACKER NOTE:
 * If you MUST make windows calls directly, use this macro below.
 * I will make sure that the window class has this pointer in this
 * location relative to the object.
 * Note also that windows can be stored in a MinList (if you must)
 */

struct WinNode
{	struct Node			 wn_node;		/* little connecting tissue */
	UWORD				 wn_usr_flags;	/* User Flags Long align */
	HWND				 wn_hwnd;		/* (HWND) for user32.dll calls */
	struct MinList		 wn_children;	/* children of this window */
	struct EditAppData	*wn_app;		/* Pointer back to appdata */
	struct WinNode		*wn_parent;		/* Not an HWND!! */
	ULONG				 x,y,w,h;		/* Position of window (relative) */
	WNDPROC				 old_WndProc;	/* WindProc stolen from Windows */
	HANDLE				 wn_hinst;		/* Instance of App that created the button */
};

#define ob_WinNode(ob)	((struct WinNode *)(ob))

#define ob_HWND(ob)				(ob_WinNode(ob)->wn_hwnd)
#define ob_ChildList(ob)		((struct List *)&ob_WinNode(ob)->wn_children)

#define hwnd_GetObject(hwnd)	(struct WinNode *)GetWindowLong((hwnd),GWL_USERDATA)

/**********************************************************/

/* Methods for hwnd class objects
 */
enum
{	WINM_Dummy = WINCLASS_BASE,

	WINM_DoWindowProc,

	WINM_Show,

	WINM_Update,
};

/* Windows API Function Substitutions Go Here */
/* ******************************************************************** */

#define ob_ShowWindow(ob,nCmdShow)	ob_DoMethod((ob),WINM_Show,(nCmdShow))
#define ob_UpdateWindow(ob)			ob_DoMethod((ob),WINM_Update)

/* ******************************************************************** */


/* Method structs for my class objects
 */

/*
 *	WINM_DoWindowProc
 */
struct opDoWindowProc
{	ULONG				 MethodID;
	HWND				 dwp_hwnd;
	UINT				 dwp_message;
	WPARAM				 dwp_wParam;
	LPARAM				 dwp_lParam;
};

/*
 *	WINM_Show
 */
struct opShowWindow
{	ULONG				 MethodID;
	ULONG				 sw_nCmdShow;
};

/* Attributes for my class objects
 */
enum
{	WINA_Dummy = ((LONG)TAG_USER + WINCLASS_BASE),

	WINA_ExStyle,		/* (I) Extended Style flags */

	WINA_Style,			/* (I) Style Flags */

	WINA_ClassName,		/* (IG) (char *) ClassName of window */

	WINA_Caption,		/* (I) (char *) Name of window */

	WINA_x,				/* (ISG) Coordinates of window */
	WINA_y,
	WINA_w,
	WINA_h,

	WINA_Parent,		/* (ISG) (APTR) Parent Window (MUST be winclass subclass) */

	WINA_Menu,			/* (ISG) (HMENU) Handle of menu or child window ID */

	WINA_AppInst,		/* (I) Handle of application instance */

	WINA_Param,			/* (I) Parameters during creation */

	WINA_AppData,		/* (I) struct EditAppData * */

	/* Things after creation */

	/* These two used during OM_SET of the window's coordinates */
	WINA_MainWin,		/* (I) Are we the main window? */

	WINA_MoveMode,		/* (S) Used to modify movement mode when changing position */

	WINA_InsertAfter,	/* (S) Window to insert self after if moving */

	/* NOTE: the default procedure will send a WINM_DOWINDOWPROC, so it
	 * is STRONGLY urged that you don't override this function, as it will
	 * pretty much disable any procedure inheritance.
	 */
	WINA_WndProc,		/* (ISG) Window Procedure to execute */
};

/* Special Hack for CreateWIndow() */
#define	WINA_ID WINA_Menu	/* (ISG) (HMENU) Handle of menu or child window ID */


/*****************************************************************************
 *	Class:			WINNODECLASS
 *	SuperClass:		ROOTCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/*****************************************************************************
 *	Class:			BUTTONCLASS
 *	SuperClass:		WINNODECLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

enum
{	BUTTONA_Dummy = ((LONG)TAG_USER + BUTTONCLASS_BASE),

	BUTTONA_NormalImageRes,		/* (IS) Normal Image for button */

	BUTTONA_HighlightImageRes,	/* (IS) Highlight Image for button */

	BUTTONA_NormalImage,		/* (ISG) Normal Image for button */

	BUTTONA_HighlightImage,		/* (ISG) Highlight Image for button */

	BUTTONA_NormalDIB,			/* (ISG) Normal DIB for button */

	BUTTONA_HighlightDIB,		/* (ISG) Highlight DIB for button */

};
