Major NT_TOOLS.DLL FUNCTIONS

Pat Brouillette

/* -------------------------------------------------------------------------- */
/* DIB Object */
/* -------------------------------------------------------------------------- */

	/* Methods for DIB class objects
	 */
	enum
	{	DIBM_Dummy = DIBCLASS_BASE,

		DIBM_RENDER,				/* Render DIB to hdc */

		DIBM_LOAD,					/* fh = ".bmp" file */
		DIBM_LOAD_BM_CROUTON,		/* fh = "ilbm" file */
	};

	/* Method structs for dib class objects
	 */

	/*
	 * DIBM_RENDER
	 */
	struct opDIBRender
	{	ULONG		MethodID;

		ULONG		dibr_dest_hdc;

		LONG		dibr_dest_x;
		LONG		dibr_dest_y;

		LONG		dibr_w;
		LONG		dibr_h;

		LONG		dibr_src_x;
		LONG		dibr_src_y;
	};

	#define ob_DIBRender(ob,hdc,dx,dy,w,h,sx,sy) \
		ob_DoMethod((ob),DIBM_RENDER,(hdc),(dx),(dy),(w),(h),(sx),(sy))

	/*
	 * DIBM_LOAD
	 * DIBM_LOAD_BM_CROUTON
	 */
	struct opDIBLoad
	{	ULONG		MethodID;
		APTR		dibl_fh;		/* stream to load from */
	};


	/* Attributes for DIB class objects
	 */
	enum
	{	DIBA_Dummy = ((LONG)TAG_USER + DIBCLASS_BASE),

		DIBA_w,						/* (IG) Width in pixels */
						
		DIBA_h,						/* (IG) Height in pixels */

		DIBA_bpp,					/* (IG) bits per pixel */

		DIBA_numcolors,				/* (IG) colors actually used */

		DIBA_pixelbuf,				/* (G) pixel buffer */

		DIBA_UseBitMapInfo,			/* (IS) Use this BitMapInfo for rendering (for shared palettes) */
	};

/* -------------------------------------------------------------------------- */
/* Framestore Reading */
/* -------------------------------------------------------------------------- */
	#ifndef NEWTEK_FRAME_H
	#define NEWTEK_FRAME_H
	
	/* These values subject to change!!! */
	#define TOASTER_D2_WIDTH		752
	#define TOASTER_D2_HEIGHT		240

	struct Frame
	{
		short			 fr_field_width;	/* Width of field, in pixels */
		short			 fr_field_height;	/* Height of field, in pixels */

		unsigned char	 fr_fields;			/* Number of Byte-Planes */
		unsigned char	 fr_pad[3];			/* Misc Flags, make sure they are cleared */

		unsigned char	*fr_d2_fld_1;		/* Field 1 Composite Data */

		unsigned char	*fr_d2_fld_2;		/* Field 2 Composite Data */

		unsigned char	*fr_d2_fld_3;		/* Field 3 Composite Data */

		unsigned char	*fr_d2_fld_4;		/* Field 4 Composite Data */
	};

	#endif /* NEWTEK_FRAME_H */

	struct Frame *fr_Create(
		APTR mempool,
		long width,
		long height,
		long num_fields );

	void fr_Delete(
		struct Frame	*fr );

	struct Frame *fr_LoadFrameStore( APTR fh );

	APTR fr_ToDIB( struct Frame *fr );		/* Do perfect-color decode of four fields */

	APTR fld_ToDIB(							/* Do decode of single field "fr_d2_fld_1" */
		struct Frame *fr, 
		long odd );

	long fr_BitMap2Frame(					/* Convert Framestore BitMap to Frame */
		struct BitMap	*bm,
		struct Frame	*fr );

	void BitMap2Field(
		struct BitMap	*bm,				/* Source BitMap */
		short			 src_plane,			/* Beginning Plane */
		short			 src_row,			/* Row To Read */
		unsigned char	*comp_data,			/* Composite Data Buffer */
		long			 comp_rows,			/* Number of rows to read */
		long			 comp_width );		/* Width of composite buffer */

/* -------------------------------------------------------------------------- */
/* Single Scan-line D2-RGB Conversion */
/* -------------------------------------------------------------------------- */
	#ifndef NEWTEK_COMP_CONVERT_H
	#define NEWTEK_COMP_CONVERT_H

	typedef signed short	iq_val;
	typedef unsigned short	y_val;

	struct comp_convert
	{
		long			 width;

		/* Composite Buffer, one byte per pixel */
		unsigned char	*comp_buf;

		/* YIQ Buffers, one word per pixel */
		y_val			*y_buf;		/* Unsigned */

		iq_val			*iq_buf;	/* Alternating IQ buffer */

		iq_val			*i_buf;
		iq_val			*q_buf;

		/* RGB Buffers, one byte per pixel */
		unsigned char	*r_buf;
		unsigned char	*g_buf;
		unsigned char	*b_buf;
	};

	#endif /* NEWTEK_COMP_CONVERT_H */

	struct comp_convert	*cc_Create(
		void *mempool,
		long width );

	/* Note: cc_Create() Will allocate all buffers in the structure
	 * except "comp_buf," which the user is expected to supply.
	 */

	void cc_Delete( struct comp_convert *cc );

	void cc_full_decode(
		struct comp_convert	*cc,
		unsigned char		*alt_line,
		unsigned char		 odd_line );

	/* Note: For perfect color decode, the user can supply the corresponding
	 * scan line in "alt_line".  (e.g. "cc->comp_buf" points at scanline 42 in
	 * field 1, "alt_line" must point to scanline 42 in field 3)
	 */

	void cc_full_encode(
		struct comp_convert	*cc,
		unsigned char		*alt_line,
		long				 odd_line );

	/* Note: For perfect color encode, the user can supply the corresponding
	 * scan line in "alt_line".  (e.g. "cc->comp_buf" points at scanline 42 in
	 * field 1, "alt_line" must point to scanline 42 in field 3)
	 */

/* -------------------------------------------------------------------------- */
/* ILBM File Read */
/* -------------------------------------------------------------------------- */

	/* Parameter packet sent to ILBM loader routine */
	struct LoadILBMParams
	{
		APTR			 lip_mempool;		/* User MUST supply this */

		struct BitMap	*lip_bm;			/* User MUST bm_Delete() this */

		BitMapHeader	 lip_bmhd;
		ULONG			 lip_camg;
		UBYTE			*lip_colors;		/* User MUST ob_Dispose() this */
		ULONG			 lip_colors_size;	/* size of allocation */
	};

	LONG lip_load( struct LoadILBMParams *lip, APTR fh );

/* -------------------------------------------------------------------------- */
/* BitMap/ByteMap Creation, Destruction */
/* -------------------------------------------------------------------------- */

	#ifndef NEWTEK_BITMAP_H
	#define NEWTEK_BITMAP_H
		/* BitMap Struct */

		struct BitMap
		{
		    UWORD   BytesPerRow;
		    UWORD   Rows;
		    UBYTE   Flags;
		    UBYTE   Depth;
		    UWORD   pad;
		    UWORD	*Planes[8];
		};

	#endif /* NEWTEK_BITMAP_H */

	struct BitMap *bm_Create(
		APTR mempool,
		ULONG w, 
		ULONG h, 
		ULONG d, 
		ULONG flags );

	void bm_Delete(
		struct BitMap *bm );

	#ifndef NEWTEK_BYTEMAP_H
	#define NEWTEK_BYTEMAP_H

	struct ByteMap
	{
		unsigned short	 bym_width;		/* Width of bym, in pixels */
		unsigned short	 bym_height;	/* Height of bym, in pixels */

		unsigned char	 bym_depth;		/* Number of Byte-Planes */
		unsigned char	 bym_pad[3];	/* Misc Flags, make sure they are cleared */

		unsigned char	*bym_plane[1];	/* Mimimum of one byte plane depth */
	};

	#endif /* NEWTEK_BYTEMAP_H */

	struct ByteMap *bym_Create(
		APTR mempool,
		unsigned long width,
		unsigned long hieght,
		unsigned long byte_planes );

	void bym_Delete(
		struct ByteMap *bym );

/* -------------------------------------------------------------------------- */
/* BitMap/ByteMap Conversion */
/* -------------------------------------------------------------------------- */
	struct ByteMap *bym_LoadILBM( APTR fh );

	void bym_BitMap2ByteMap(
		struct BitMap	*bm,
		struct ByteMap	*bym );

/* -------------------------------------------------------------------------- */
/* Planar To Chunky Conversion */
/* -------------------------------------------------------------------------- */
	void PlanarToChunky( 
		UWORD ** planes, 
		ULONG plane_offset, 
		WORD num_planes, 
		UBYTE *pixels, 
		LONG num_pixels );

	void PlanarToChunky_rev( 
		UWORD ** planes, 
		ULONG plane_offset, 
		WORD num_planes, 
		UBYTE *pixels, 
		LONG num_pixels );

/* -------------------------------------------------------------------------- */
/* IFF (CRUD) File Parsing */
/* -------------------------------------------------------------------------- */
	struct BitMap *LoadIconBitMap( APTR fh, APTR mempool );

	ULONG ob_SeekUp2IconsBitMap( APTR fh );

	ULONG ob_Seek2IconsBitMap( APTR fh );

	ULONG ob_IsGoodIconBM( APTR fh );

	ULONG ob_SeekUp2Form( APTR fh, ULONG form_id );

	ULONG ob_SeekPrevForm( APTR fh );

	ULONG ob_Seek2Form( APTR fh, ULONG form_id );

	ULONG ob_SeekNextForm( APTR fh );

	ULONG swap_long( ULONG x );

	void swap_longa( ULONG *x );

	UWORD swap_word( UWORD x );

	void swap_worda( UWORD *x );


/* -------------------------------------------------------------------------- */
/* Example Code: Load A Framestore and convert to a 24-bit DIB */
/* -------------------------------------------------------------------------- */
#ifndef PROOF_LIB_H
#include <proof/proof_lib.h>
#endif

#ifndef PROOF_CLASSBASE_H
#include <proof/classbase.h>
#endif

#ifndef PROOF_STREAM_H
#include <proof/stream.h>
#endif

#ifndef NEWTEK_DIB_H
#include <newtek/dib.h>
#endif

#ifndef NEWTEK_FRAME_H
#include <newtek/frame.h>
#endif

#include <newtek/nt_tools_protos.h>

APTR fr_LoadFramestoreDIB( char *frame_filename )
{
	APTR		dib = NULL;
	APTR		fh;

	if ( fh = ob_BufferedOpen(frame_filename,MODE_OLDFILE,1024*4) )
	{
		struct Frame		*fr;

		if ( fr = fr_LoadFrameStore(fh) )
		{
			if ( dib = fr_ToDIB(fr) )
			{
			}

			fr_Delete(fr);
		}

		ob_Dispose(fh);
	}

	return(dib);
}

/* -------------------------------------------------------------------------- */
/* Example Code: Load a 24-bit ILBM, convert to DIB */
/* -------------------------------------------------------------------------- */
#ifndef PROOF_LIB_H
#include <proof/proof_lib.h>
#endif

#ifndef PROOF_CLASSBASE_H
#include <proof/classbase.h>
#endif

#ifndef PROOF_STREAM_H
#include <proof/stream.h>
#endif

#ifndef NEWTEK_BITMAP_H
#include <newtek/bitmap.h>
#endif

#ifndef NEWTEK_DIB_H
#include <newtek/dib.h>
#endif

#include <newtek/nt_tools_protos.h>

extern struct ClassBase	*ClassBase;

__inline static void _scatter3(
	unsigned char	*dest,
	unsigned char	*src,
	unsigned long	 len )
{
	while ( len-- )
	{
		*dest = *src++;
		dest += 3;
	}
}

APTR LoadILBM24( char *bm_filename )
{
	APTR		dib = NULL;
	APTR		fh;

	/* Open PROOF buffered file stream with 2k buffer */
	if ( fh = ob_BufferedOpen(bm_filename,MODE_OLDFILE,1024*2) )
	{
		struct LoadILBMParams	lip;

		/* Clear Parameter block */
		memset(&lip,0,sizeof(lip));

		if ( lip_load(&lip,fh) )
		{
			struct BitMap	*bm;

			/* Won't be needing the colormap, so discard it now */
			if ( lip.lip_colors )
				ob_Dispose(lip.lip_colors);

			/* Did the loader read in a bitmap */
			if ( bm = lip.lip_bm )
			{
				/* Only convert 24 bit bitmaps */
				if ( lip.lip_bmhd.nPlanes == 24 )
				{
					/* Create a DIB we can blit to the screen */
					if ( dib = ob_NewObject(NULL,DIBCLASS,
							DIBA_w,			lip.lip_bmhd.w,
							DIBA_h,			-lip.lip_bmhd.h,	/* NEG HT == Top Down DIB */
							DIBA_bpp,		24,
							DIBA_numcolors,	2,	/* To Save Memory */
							TAG_DONE) )
					{
						unsigned char	*chunkybuf;
						unsigned char	*dib_pix_buf;

						/* Get the DIBs pixel buffer */
						ob_GetAttrs(dib,
							DIBA_pixelbuf,		&dib_pix_buf,
							TAG_DONE);

						/* Allocate buffer using proof.dll's global allocator object,
						 * "ClassBase->cb_allocator_ob".
						 */
						if ( chunkybuf = ob_AllocObj(ClassBase->cb_allocator_ob,
								lip.lip_bmhd.w,MEMF_ANY) )
						{
							unsigned short	row;
							unsigned long	plane_offset = 0;

							for ( row = 0; row < lip.lip_bmhd.h; row++ )
							{
								/* 24-bit DIBs data is in B,G,R format */

								/* Red Pixels */
								memset(chunkybuf,0,lip.lip_bmhd.w);

								PlanarToChunky(
									&bm->Planes[0],
									plane_offset,8,
									chunkybuf,lip.lip_bmhd.w);

								_scatter3(&dib_pix_buf[2],chunkybuf,lip.lip_bmhd.w);

								/* Green Pixels */
								memset(chunkybuf,0,lip.lip_bmhd.w);

								PlanarToChunky(
									&bm->Planes[8],
									plane_offset,8,
									chunkybuf,lip.lip_bmhd.w);

								_scatter3(&dib_pix_buf[1],chunkybuf,lip.lip_bmhd.w);

								/* Blue Pixels */
								memset(chunkybuf,0,lip.lip_bmhd.w);

								PlanarToChunky(
									&bm->Planes[16],
									plane_offset,8,
									chunkybuf,lip.lip_bmhd.w);

								_scatter3(&dib_pix_buf[0],chunkybuf,lip.lip_bmhd.w);

								plane_offset += bm->BytesPerRow;
								dib_pix_buf += (lip.lip_bmhd.w*3);
							}

							ob_Dispose(chunkybuf);
						}
						else
						{
							ob_Dispose(dib);
							dib = NULL;
						}
					}
				}

				bm_Delete(lip.lip_bm);
			}
		}

		/* Close the file */
		ob_Dispose(fh);
	}

	return(dib);
}
