
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

int Make_AV(char *, char *);

struct Library *FlyerBase;
struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[4][100];
ULONG count[2];

FILE *bill;

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE2;
UWORD  i,temp;
char buff5[256];
char *tokenpt;

printf("FlyerAddAudio Version 0.97\n");
printf("Copyright Prowave 1996\n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

printf("Time to take out tokens \n");

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[3],tokenpt,99);

printf("3  %s \n",filename[3]);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[1],tokenpt,99);
tokenpt = strtok(NULL,",");
count[0] = atoi(tokenpt)/2;

printf("1 %s %d \n",filename[1],count[0]);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[2],tokenpt,99);
tokenpt = strtok(NULL,",");
count[1] = atoi(tokenpt)/2;

printf("2 %s %d \n",filename[2],count[1]);

fclose(bill);

for (i=1;i<4;i++)
   printf("%d %s \n",i,filename[i]);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = filename[1];

Buffer.len = sizeof(struct ClipInfo);
Buffer2.len = sizeof(struct ClipInfo);
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

/* Bill's Attempt at the Impossible */

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = filename[3];

if (Buffer.Flags & CIF_HASAUDIO)
   {
   printf("we have audio \n");
   if (strcmp(filename[1],filename[3]))
      { 
      res = MakeFlyerFile(&FlyVol2,Buffer.Length/512,&OUTFILE2);
      if (res)
         {
         printf("Lets try it now \n"); 
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }
      res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,Buffer.Length/512,OUTFILE2);
      if (res)
         {
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }
      }
   else
      OUTFILE2 = Buffer.Start;
   }
else /* Call Audio 2 */
   { 
   Make_AV(filename[1],filename[3]);
   printf("We have made the file \n");
   res = GetClipInfo(&FlyVol2,&Buffer);
   OUTFILE2 = Buffer.Start;
   }

printf("We have made the file \n");

act.Volume = &FlyVol2;

FlyVol3.Board = 0;
FlyVol3.Flags = 0;
FlyVol3.Path = filename[2];

printf("This is the path %s \n",filename[2]); 

res = GetClipInfo(&FlyVol3,&Buffer2);

printf("Get the Clip Info \n");

if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

printf("CLIP OK \n");

printf("This is count %ld %ld \n",count[0],count[1]);

if (count[0] != count[1])
   {
   if (count[0] < count[1])
      {
      count[1] = count[1] - count[0];
      count[0] = 0;
      }
   else
      {
      count[0] = count[0] - count[1];
      }
   }
else
   {
   count[0] = 0;
   count[1] = 0;
   }

printf("This is count %ld %ld \n",count[0],count[1]);

printf("Buffer %ld Buffer2 %ld \n",Buffer.Fields/4,Buffer2.Fields/4);
printf("count[0] %ld count[1] %ld \n",count[0],count[1]); 

temp = count[0]+Buffer2.Fields/4-count[1];

for (i=count[0];i<temp;i++)
   {
   act.Volume = &FlyVol2;

   act.VidStartField = i*4;

   res = GetFrameHeader(&act,&FrameBuffer);

   if (res)
      {
      printf("Failure on frame %d\n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   OUTFILE2 = act.StartBlk+1;

   act.VidStartField = (i-count[0])*4;

   act.Volume = &FlyVol3;

   res = GetFrameHeader(&act,&FrameBuffer2);

   if (res)
      {
      printf("Failure on frame %d\n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
    
   res = CopyData(&FlyVol3,&FlyVol2,act.StartBlk+1,24,OUTFILE2);

   if (res)
      {
      printf("Copy Failure on frame %d\n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   }

CloseLibrary(FlyerBase);

return(0);
}

int Make_AV(char *inpath, char *outpath)
{
ULONG	res, frames;
ULONG  OUTFILE2, OUTFILE3, OUTFILE4;
UWORD  i, j;
ULONG Total = 0, WIDGET = 0;
BPTR handle;
char myfile[50];

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

WIDGET = Buffer.Fields/4;
Total = Buffer.Length/512 - 44 + 24*WIDGET;

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = outpath;

strcpy(myfile,inpath); 
strcat(myfile,".Prowave");
FlyVol3.Path = myfile;
FlyVol3.Board = 0;
FlyVol3.Flags = 0;

res = MakeFlyerFile(&FlyVol3,WIDGET+24,&OUTFILE3);
if (res)
   {
   printf("Error making Prowave file \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

res = MakeFlyerFile(&FlyVol2,Total,&OUTFILE2);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

handle = Open(myfile,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   }

for (i=0;i<256;i++)
   testbuff[i] = 0;

for (i=0;i<24;i++)
   Write(handle,&testbuff,512);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;

res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

for (j=0;j<Buffer.Fields/4;j++)
   {
   act.VidStartField = j*4;

   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);

   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   FrameBuffer.FrameNumber = WIDGET+j;
   FrameBuffer.AudioChans = 2;
   FrameBuffer.Length += 24;
   FrameBuffer.AudVer = 2;
   FrameBuffer.AudioLength = 3; 
   
   if (j != 0)
      FrameBuffer.PrevFrame -= 24;
   
   FrameBuffer.NextFrame += 24;

   for (i=0;i<4;i++)
      FrameBuffer.fields[i].VidStart += 24;

   if (Write(handle,&FrameBuffer,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   if (res)
      {
      Printf("New FrameHeader Put Error on i = %d \n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   }

Close(handle);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;

res = GetClipInfo(&FlyVol,&Buffer);

res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,1,OUTFILE2);

OUTFILE2++;

OUTFILE4 = OUTFILE3;
OUTFILE3+=24;

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);
if (res)
   {
   printf("Error on whatsit \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

OUTFILE2++;

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE4,24,OUTFILE2);
if (res)
   {
   printf("Error on whatsit \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

OUTFILE2+=24;

OUTFILE3++;

Buffer.Start += 2;

for (j=0;j<Buffer.Fields/4;j++)
   {
   act.VidStartField = j*4;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);

   if (res)
      {
      Printf("Error on j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,FrameBuffer.Length-1,OUTFILE2);

   if (res)
      {
      Printf("Error on Data Write j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   OUTFILE2 = OUTFILE2 + FrameBuffer.Length - 1;

   res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);

   if (res)
      {
      Printf("Copy Error on j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   
   OUTFILE2++;

   res = CopyData(&FlyVol3,&FlyVol2,OUTFILE4,24,OUTFILE2);
   if (res)
      {
      printf("Error on whatsit \n");
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   Buffer.Start += FrameBuffer.Length;
   OUTFILE2 += 24;
   OUTFILE3++;
   }

frames = WIDGET;

WriteClipStart(frames, Total ,outpath);

Reprocess(outpath,frames);

printf("We have deleted the file \n");

return(0);
}

ULONG WriteClipStart(ULONG frames, ULONG Length,char *pathname)
{
BPTR	handle;
struct ClipHeader *ch;
UBYTE BlkBuff[512];

handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

/* Read the Ignore Stuff */
Read(handle,BlkBuff,512);

Close(handle);

ch->Fields = frames * 4;
ch->DataEnd = Length;
ch->Tail = 0;
ch->Length = Length-1;
ch->AudioChans = 2;
ch->AudVer = 2;
ch->AudioLength = 3;
				// No index table!
handle = Open(pathname,MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

Close(handle);

return(0);		// Okay
}

ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;
actptr->VidStartField = 0;					// Reprocess all of clip
actptr->VidFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!

actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}
