 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

struct Library *FlyerBase;

struct Join
   {
   char    Name[50];
   ULONG   StartFrame;
   ULONG   FrameCount;
   } join[50];

FILE *bill;

main(int argc,char **argv)
{
ULONG	res, err;
ULONG  OUTFILE2, OUTFILE3;  
UWORD  i, j;
ULONG Total = 0, WIDGET = 0, back;
BPTR handle;
ULONG frames;
char myfile[50];

struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer;

struct FlyerVolume *volptr;

struct ClipAction Action,*actptr;

UWORD pathcount;
UWORD *pathpt;
char temp[20];
char outpath[50];
char buff5[256];
char *tokenpt;

pathpt = &pathcount;

printf("Join Version 0.97\n");
printf("Copyright Prowave 1996\n");

if ((argc != 2) || (argv[1][0] == '?'))
   {
   printf("Incorrect arguements \n");
   printf("%s filename \n",argv[0]);
   exit(20);
   }

pathcount = 0;

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }


fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,49);

err = fscanf(bill,"%s ",temp);
pathcount = atoi(temp);

for (i=0;i<pathcount;i++)
   {
   fgets(buff5,255,bill);
   tokenpt = strtok(buff5,",");
   strncpy(join[i].Name,tokenpt,99);
   tokenpt = strtok(NULL,",");
   join[i].StartFrame = atoi(tokenpt)/2;
   tokenpt = strtok(NULL,",");
   join[i].FrameCount = atoi(tokenpt)/2;
   printf("This is the read %s %ld %ld \n",join[i].Name,join[i].StartFrame,join[i].FrameCount);
   }

fclose(bill);

printf("%s \n",outpath);
printf("%d \n",pathcount);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

Buffer.len = sizeof(struct ClipInfo);
Buffer2.len = sizeof(struct ClipInfo);

printf("We are at Level 1 \n");

for (i=0;i<pathcount;i++)
   {
   FlyVol.Board = 0;
   FlyVol.Flags = 0;
   FlyVol.Path = join[i].Name;
   res = GetClipInfo(&FlyVol,&Buffer);
   if (res)
      {
      printf("Counting Widgets %d \n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   for (j=join[i].StartFrame;j<(join[i].StartFrame + join[i].FrameCount);j++)
      {
      act.VidStartField = j*4;

      act.Volume = &FlyVol;

      res = GetFrameHeader(&act,&FrameBuffer);

      if (res)
         {
         Printf("Super Widget Error on i = %d \n",i);
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }
      Total = Total + FrameBuffer.Length;
      WIDGET++;
      }
   }

Total = Total + 1;

printf("This is total %ld \n",Total);

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = outpath;

strcpy(myfile,join[0].Name); 
strcat(myfile,".Prowave");
FlyVol3.Path = myfile;
FlyVol3.Board = 0;
FlyVol3.Flags = 0;

res = MakeFlyerFile(&FlyVol3,WIDGET,&OUTFILE3);

if (res)
   {
   printf("Error making Prowave file \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

res = MakeFlyerFile(&FlyVol2,Total,&OUTFILE2);

if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

handle = Open(myfile,MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   }

WIDGET = 0;

back = 0;

printf("We are at Level 2 \n");

for (i=0;i<pathcount;i++)
   {
   FlyVol.Board = 0;
   FlyVol.Flags = 0;
   FlyVol.Path = join[i].Name;

   res = GetClipInfo(&FlyVol,&Buffer);
   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   for (j=join[i].StartFrame;j<(join[i].StartFrame + join[i].FrameCount);j++)
      {
      act.VidStartField = j*4;

      act.Volume = &FlyVol;

      res = GetFrameHeader(&act,&FrameBuffer);

      if (res)
         {
         Printf("Super Widget Error on i = %d \n",i);
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }

      if (j==join[i].StartFrame)
         FrameBuffer.PrevFrame = -back;

      FrameBuffer.FrameNumber = WIDGET+j;

      if (Write(handle,&FrameBuffer,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
         printf("Frame header write error\n");

      WIDGET++;
      back = FrameBuffer.Length;
      }
   }

Close(handle);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = join[0].Name;

res = GetClipInfo(&FlyVol,&Buffer);

res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,1,OUTFILE2);

OUTFILE2++;

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);

if (res)
   {
   printf("Error on whatsit \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

OUTFILE2++;

OUTFILE3++;

printf("We are at Level 3 \n");

for (i=0;i<pathcount;i++)
   {
   FlyVol.Board = 0;
   FlyVol.Flags = 0;
   FlyVol.Path = join[i].Name;

   res = GetClipInfo(&FlyVol,&Buffer);

   Buffer.Start += 2;

   for (j=join[i].StartFrame;j<(join[i].StartFrame + join[i].FrameCount);j++)
      {
      act.VidStartField = j*4;
      act.Volume = &FlyVol;

      res = GetFrameHeader(&act,&FrameBuffer);

      if (res)
         {
         Printf("Error on j = %d \n",j);
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }

      res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+1,FrameBuffer.Length-1,OUTFILE2);

      if (res)
         {
         Printf("Error on Data Write j = %d \n",j);
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }

      OUTFILE2 = OUTFILE2 + FrameBuffer.Length - 1;

      res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);
 
      if (res)
         {
         Printf("Copy Error on j = %d \n",j);
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }
      OUTFILE2++;
      OUTFILE3++;
      }
   }

frames = WIDGET;

printf("We are at Level 4 \n");

WriteClipStart(frames, Total ,outpath);

Reprocess(outpath,frames);

CloseLibrary(FlyerBase);

return(0);
}

ULONG WriteClipStart(ULONG frames, ULONG Length,char *pathname)
{
BPTR	handle;
struct ClipHeader *ch;
UWORD i;
UBYTE BlkBuff[512];

handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

printf(" Frames   %ld \n",frames);
printf(" Length   %ld \n",Length);
printf(" pathname %s \n",pathname);

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

/* Read the Ignore Stuff */
Read(handle,BlkBuff,512);

i = Close(handle);
printf("this is close 1 %d \n",i);

ch->Fields = frames * 4;
ch->DataEnd = Length;
ch->Tail = 0;
ch->Length = Length-1;

for (i=4;i<34;i++)
   {
   printf("%x ",BlkBuff[i]);
   }
printf("\n");
					// No index table!
handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

i = Close(handle);
printf("this is close 2 %d \n",i);

return(0);		// Okay
}

ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;
actptr->VidStartField = 0;					// Reprocess all of clip
actptr->VidFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!

actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}

