
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

FILE *bill;

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

int main(int argc, char *argv[])
{
struct FlyerVolume FlyVol,*volptr, FlyVol2, *volptr2;
struct ClipAction	 Action,*actptr;
ULONG	res, err;
int StFrame, frames, ClipType;
UWORD i;
UWORD pathcount;
char temp[20];
char outpath[40];
char paths[40];
char buff5[256];
char *tokenpt;

printf("FlyerStripAudio 1.00\n");
printf("Copyright Prowave 1996\n");

if ((argc!=2) || (argv[1][0] == '?'))
   {
   printf("Not enough parameters \n");
   printf("%s Inputfile \n",argv[0]);
   exit(20);
   }

bill = fopen(argv[1],"r");

if (bill == NULL)
   {
   printf("No Such File \n");
   return(20);
   }

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,99);

err = fscanf(bill,"%s ",temp);
pathcount = atoi(temp);

FlyerBase = OpenLibrary(FLYERLIBNAME,0); 
   
actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = outpath;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

printf("Let's start the List \n");

res = StartClipCutList(actptr,0);		// Ready for destructive reprocessing

printf("We have started the List \n");

if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

for (i=0;i<pathcount;i++)
   {
   fgets(buff5,255,bill);
   tokenpt = strtok(buff5,",");
   strncpy(paths,tokenpt,99);
   tokenpt = strtok(NULL,",");
   StFrame = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   frames = atoi(tokenpt);   
   tokenpt = strtok(NULL,",");
   ClipType = atoi(tokenpt);   
  
   /* Now define one clip to make from original */

   volptr2 = &FlyVol2;
   volptr2->Board = 0;
   volptr2->Path = paths;					// Make new clip the same name
   volptr2->Flags = 0;							// None
   actptr->Volume = volptr2;					// Link together
   actptr->ReturnTime = RT_STOPPED;			// Don't return until done
   actptr->AudStartField = StFrame * 2;					// Reprocess all of clip
   actptr->AudFieldCount = frames * 2; 
   actptr->VidStartField = StFrame * 2;					// Reprocess all of clip
   actptr->VidFieldCount = frames * 2;

   if (ClipType == 0)
      actptr->Flags = CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;
   if (ClipType == 1)
      actptr->Flags = CAF_AUDIOL | CAF_AUDIOR;
   if (ClipType == 2)
      actptr->Flags = CAF_VIDEO;

   printf("ready to addclipcut \n");

   res = AddClipCut(actptr);					// Define the new clip
   if (res) 
      {
      printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
      res = EndClipCutList(0);				// Let Flyer clean up
      return(res);
      }

   }

printf("Lets make the new clip \n");

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

CloseLibrary(FlyerBase);

return(FERR_OKAY);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
stcd_i(arg,var);
if ((*var < lo)||(*var > hi)) 
   {
   printf("Error: %ls is out of range\n",label);
   exit(20);
   }
}
