
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Reprocess(char *, ULONG, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *, ULONG);

int Make_Video_Clip(char *, char *,ULONG,ULONG);

struct Library *FlyerBase;
struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[4][100];
ULONG count[2];

FILE *bill;

main(int argc,char **argv)
{
ULONG	res, err;
ULONG  OUTFILE2;
UWORD  i;
char buff5[256];
char *tokenpt;

printf("Still2Clip Version 0.96\n");
printf("Copyright Prowave 1996\n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

printf("Time to take out tokens \n");

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[2],tokenpt,99);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[1],tokenpt,99);
tokenpt = strtok(NULL,",");
count[0] = atoi(tokenpt)/2;
tokenpt = strtok(NULL,",");
count[1] = atoi(tokenpt);

printf("1 %s %d %d \n",filename[1],count[0],count[1]);

printf("2 %s \n",filename[2]);

fclose(bill);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = filename[1];

Buffer.len = sizeof(struct ClipInfo);

Buffer2.len = sizeof(struct ClipInfo);

res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = filename[2];

Make_Video_Clip(filename[1],filename[2],count[0],count[1]);

CloseLibrary(FlyerBase);

return(0);
}

int Make_Video_Clip(char *inpath, char *outpath,ULONG length,ULONG type)
{
ULONG	res, frames;
ULONG  OUTFILE2, OUTFILE3, OUTFILE4;
UWORD  i, j;
ULONG Total = 0, WIDGET = 0;
BPTR handle;
char myfile[100];
struct FlyerVolume *volptr;
struct ClipAction Action,*actptr;

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

printf("This is type %ld \n",type);

Total = (Buffer.Length/512 - 45)*length + 24*length*type;
printf("This is Total %ld \n",Total);
printf("This is Buffer %ld \n",Buffer.Length/512);
FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = outpath;

strcpy(myfile,inpath); 
strcat(myfile,".P");
FlyVol3.Path = myfile;
FlyVol3.Board = 0;
FlyVol3.Flags = 0;

printf("This is myfile %s\n",myfile);

res = MakeFlyerFile(&FlyVol3,length+24,&OUTFILE3);
if (res)
   {
   printf("Error making Prowave file \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

res = MakeFlyerFile(&FlyVol2,Total,&OUTFILE2);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

handle = Open(myfile,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   }

for (i=0;i<256;i++)
   testbuff[i] = 0;

for (i=0;i<24;i++)
   Write(handle,&testbuff,512);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;

res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

for (j=0;j<length;j++)
   {
   act.VidStartField = 0;

   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);

   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   FrameBuffer.FrameNumber = WIDGET+j;
   if (type == 1)
      {
      FrameBuffer.AudioChans = 2;
      FrameBuffer.Length += 24;
      FrameBuffer.AudVer = 2;
      FrameBuffer.AudioLength = 3; 
   
      if (j != 0)
         FrameBuffer.PrevFrame -= 24;
   
      FrameBuffer.NextFrame += 24;
     
      for (i=0;i<4;i++)
         FrameBuffer.fields[i].VidStart += 24;
      }

   if (Write(handle,&FrameBuffer,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   if (res)
      {
      Printf("New FrameHeader Put Error on i = %d \n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   }

Close(handle);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;

res = GetClipInfo(&FlyVol,&Buffer);

res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,1,OUTFILE2);

OUTFILE2++;

OUTFILE4 = OUTFILE3;

OUTFILE3+=24;

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);
if (res)
   {
   printf("Error on whatsit \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

OUTFILE2++;

if (type == 1)
   {
   res = CopyData(&FlyVol3,&FlyVol2,OUTFILE4,24,OUTFILE2);
   if (res)
      {
      printf("Error on whatsit \n");
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   OUTFILE2+=24;
   }

OUTFILE3++;

Buffer.Start += 2;

for (j=0;j<length;j++)
   {
   act.VidStartField = 0;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);

   if (res)
      {
      Printf("Error on j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,FrameBuffer.Length-1,OUTFILE2);

   if (res)
      {
      Printf("Error on Data Write j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   OUTFILE2 = OUTFILE2 + FrameBuffer.Length - 1;

   res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);

   if (res)
      {
      Printf("Copy Error on j = %d \n",j);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   
   OUTFILE2++;
   if (type == 1)
      {
      res = CopyData(&FlyVol3,&FlyVol2,OUTFILE4,24,OUTFILE2);
      if (res)
         {
         printf("Error on whatsit \n");
         printf("Error %ld - %ls\n",res,Error2String(res));
         exit(20);
         }

      OUTFILE2 += 24;
      }

   OUTFILE3++;
   }

frames = length;

WriteClipStart(frames, Total ,outpath, type);

Reprocess(outpath,frames, type);

printf("We have deleted the file \n");

return(0);
}

ULONG WriteClipStart(ULONG frames, ULONG Length,char *pathname, ULONG type)
{
BPTR	handle;
struct ClipHeader *ch;
UBYTE BlkBuff[512];

handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Testing again \n");
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

/* Read the Ignore Stuff */
Read(handle,BlkBuff,512);

Close(handle);

ch->Fields = frames * 4;
ch->DataEnd = Length;
ch->Tail = 0;
ch->Length = Length-1;
if (type == 1)
   ch->AudioChans = 2;
ch->AudVer = 2;
ch->AudioLength = 3;
				// No index table!
handle = Open(pathname,MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

Close(handle);

return(0);		// Okay
}

ULONG Reprocess(char *pathname, ULONG frames, ULONG type)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
if (type == 1)
   {
   actptr->AudStartField = 0;					// Reprocess all of clip
   actptr->AudFieldCount = frames * 4;
   }
actptr->VidStartField = 0;					// Reprocess all of clip
actptr->VidFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!

actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}
