 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

struct Library *FlyerBase;

struct Join
   {
   char    Name[50];
   ULONG   StartFrame;
   ULONG   FrameCount;
   } join;

FILE *bill;

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE2, OUTFILE3;  
UWORD  j;
ULONG Total = 0, Total2 = 0, WIDGET = 0, back;
BPTR handle;
ULONG frames;
char myfile[50];

struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer, FrameBuffer2;

char outpath[50];
char buff5[256];
char *tokenpt;
ULONG MYAUD;

printf("Twist Version 0.90\n");
printf("Copyright Prowave 1996\n");

if ((argc != 2) || (argv[1][0] == '?'))
   {
   printf("Incorrect arguements \n");
   printf("%s filename \n",argv[0]);
   exit(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,49);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(join.Name,tokenpt,99);
tokenpt = strtok(NULL,",");
join.StartFrame = atoi(tokenpt)/2;
tokenpt = strtok(NULL,",");
join.FrameCount = atoi(tokenpt)/2;
printf("This is the read %s %ld %ld \n",join.Name,join.StartFrame,join.FrameCount);

fclose(bill);

printf("%s \n",outpath);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

Buffer.len = sizeof(struct ClipInfo);
Buffer2.len = sizeof(struct ClipInfo);

printf("We are at Level 1 \n");

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = join.Name;
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

/* Count Number of Blocks needed */
for (j=join.StartFrame;j<(join.StartFrame + join.FrameCount);j++)
   {
   act.VidStartField = j*4;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);
   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   Total = Total + FrameBuffer.Length;

   if ( j != join.StartFrame)
      Total2 += FrameBuffer.fields[0].VidLength + 
                 FrameBuffer.fields[1].VidLength;

   if (j != (join.StartFrame + join.FrameCount - 1)) 
      Total2 += FrameBuffer.fields[2].VidLength +
                 FrameBuffer.fields[3].VidLength; 

   if (Buffer.Flags & CIF_HASAUDIO)
      Total2 += 24;

   WIDGET++;
   }


MYAUD = 0;
if (Buffer.Flags & CIF_HASAUDIO)
   MYAUD = 24;

Total = Total + 1;
Total2 = Total2 + 1 + WIDGET;

printf("This is total %ld \n",Total);
printf("This is total2 %ld \n",Total2);

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = outpath;

strcpy(myfile,join.Name); 
strcat(myfile,".Prowave");
FlyVol3.Path = myfile;
FlyVol3.Board = 0;
FlyVol3.Flags = 0;

res = MakeFlyerFile(&FlyVol3,WIDGET,&OUTFILE3);
if (res)
   {
   printf("Error making Prowave file \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

res = MakeFlyerFile(&FlyVol2,Total2,&OUTFILE2);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

handle = Open(myfile,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   }

WIDGET = 0;
back = 0;

printf("We are at Level 2 \n");

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = join.Name;

res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

WIDGET = 0;

for (j=join.StartFrame;j<(join.StartFrame + join.FrameCount-1);j++)
   {
   act.VidStartField = j*4;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);
   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   act.VidStartField = (j+1)*4;
   act.Volume = &FlyVol;
   res = GetFrameHeader(&act,&FrameBuffer2);
   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }

   if (j==join.StartFrame)    
      FrameBuffer.PrevFrame = 0;
   else
      FrameBuffer.PrevFrame = -back;

   FrameBuffer.FrameNumber = WIDGET;

   FrameBuffer.fields[0].VidLength = FrameBuffer.fields[2].VidLength;

   FrameBuffer.fields[1].VidLength = FrameBuffer.fields[3].VidLength;

   FrameBuffer.fields[1].VidStart = FrameBuffer.fields[0].VidStart + FrameBuffer.fields[2].VidLength;   

   FrameBuffer.fields[2].VidLength = FrameBuffer2.fields[0].VidLength;

   FrameBuffer.fields[2].VidStart = FrameBuffer.fields[1].VidLength + FrameBuffer.fields[1].VidStart;

   FrameBuffer.fields[3].VidLength = FrameBuffer2.fields[1].VidLength;

   FrameBuffer.fields[3].VidStart = FrameBuffer.fields[2].VidLength + FrameBuffer.fields[2].VidStart;
    
   back = FrameBuffer.fields[0].VidLength +
          FrameBuffer.fields[1].VidLength +
          FrameBuffer.fields[2].VidLength +
          FrameBuffer.fields[3].VidLength + 1 + MYAUD;

   FrameBuffer.Length = back;

   FrameBuffer.NextFrame = back;

   if (Write(handle,&FrameBuffer,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   WIDGET++;
   }

Close(handle);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = join.Name;

res = GetClipInfo(&FlyVol,&Buffer);

res = CopyData(&FlyVol,&FlyVol2,Buffer.Start,1,OUTFILE2);

OUTFILE2++;

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);

if (res)
   {
   printf("Error on whatsit \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

OUTFILE2++;

OUTFILE3++;

printf("We are at Level 3 \n");
   
FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = join.Name;

res = GetClipInfo(&FlyVol,&Buffer);
Buffer.Start += 2;

for (j=join.StartFrame;j<(join.StartFrame + join.FrameCount);j++)
   {
   act.VidStartField = j*4;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);


   if (j != join.StartFrame)
      {
      printf("This is OUTFILE2 %ld \n",OUTFILE2);
      res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+FrameBuffer.fields[0].VidStart,FrameBuffer.fields[0].VidLength,OUTFILE2);

      OUTFILE2 = OUTFILE2 + FrameBuffer.fields[0].VidLength;
      printf("This is OUTFILE2 %ld \n",OUTFILE2);

      res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+FrameBuffer.fields[1].VidStart,FrameBuffer.fields[1].VidLength,OUTFILE2);

      OUTFILE2 = OUTFILE2 + FrameBuffer.fields[1].VidLength;
      printf("This is OUTFILE2 %ld \n",OUTFILE2);

      if (j != (join.StartFrame + join.FrameCount - 1))
         {
         res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,1,OUTFILE2);
         OUTFILE2++;
         printf("This is OUTFILE2 %ld \n",OUTFILE2);
         OUTFILE3++;
         if (MYAUD == 24)
            {
            res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+1,24,OUTFILE2);
            OUTFILE2 += 24;           
            printf("This is OUTFILE2 %ld \n",OUTFILE2);
            }
         } 
      }

   if (j != (join.StartFrame + join.FrameCount - 1))
      {
      res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+FrameBuffer.fields[2].VidStart,FrameBuffer.fields[2].VidLength,OUTFILE2);

      OUTFILE2 = OUTFILE2 + FrameBuffer.fields[2].VidLength;
      printf("This is OUTFILE2 %ld \n",OUTFILE2);

      res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+FrameBuffer.fields[3].VidStart,FrameBuffer.fields[3].VidLength,OUTFILE2);

      OUTFILE2 = OUTFILE2 + FrameBuffer.fields[3].VidLength;
      printf("This is OUTFILE2 %ld \n",OUTFILE2);
      }
   } 

frames = join.FrameCount-1; 

printf("We are at Level 4 \n");

/* WriteClipStart(frames, Total ,outpath); */

/* Reprocess(outpath,frames); */

CloseLibrary(FlyerBase);

return(0);
}

ULONG WriteClipStart(ULONG frames, ULONG Length,char *pathname)
{
BPTR	handle;
struct ClipHeader *ch;
UWORD i;
UBYTE BlkBuff[512];

handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

printf(" Frames   %ld \n",frames);
printf(" Length   %ld \n",Length);
printf(" pathname %s \n",pathname);

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

/* Read the Ignore Stuff */
Read(handle,BlkBuff,512);

i = Close(handle);
printf("this is close 1 %d \n",i);

ch->Fields = frames * 4;
ch->DataEnd = Length;
ch->Tail = 0;
ch->Length = Length-1;

for (i=4;i<34;i++)
   {
   printf("%x ",BlkBuff[i]);
   }
printf("\n");
					// No index table!
handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

i = Close(handle);
printf("this is close 2 %d \n",i);

return(0);		// Okay
}

ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;
actptr->VidStartField = 0;					// Reprocess all of clip
actptr->VidFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!

actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}

