
#include "arexx.h"
#include "arexxsyslib.h"

#ifdef RVI
#include "rvi.h"
#endif

#include <exec/types.h>
#include <string.h>
#include <stdio.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

#define	MONOAUDFLDSIZE		3
#define	NUMAUDCHANS			2
#define	SAMPLESPERFIELD	735	// Audio samples per video field


#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
#ifdef RVI
   char   error_name[MAX_ERROR_NAME + 1];
#endif
   };

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

struct Library *DosBase;

struct Library *FlyerBase;

UBYTE BlkBuff[512];

FILE *bill;

WORD AudioBuff[8][256*MONOAUDFLDSIZE];

LONG __far Buff[8][256*3];

char outpath[40];
char paths[20][40];

/* Function Prototypes */
ULONG Reprocess(char *, ULONG);
void error(char *msg, int code);
UWORD getframes(UWORD); 

UWORD size;

struct Mix
   {
   BPTR  IN;
   ULONG StartFrame;
   ULONG FrameCount;
   ULONG Time;
   UWORD AudioOn;
   UWORD Vol1;
   UWORD Vol2;
   WORD Pan1;
   WORD Pan2;
   UWORD AudioAttack;
   UWORD AudioDecay;
   /* Calculated Values */
   ULONG CurrentVol1;
   ULONG CurrentVol2;
   UWORD Loffset;
   UWORD Roffset;
   UWORD DecayStep1;
   UWORD DecayStep2;
   UWORD AttackStep1;
   UWORD AttackStep2;
   UWORD AttackFrame;
   UWORD DecayStart; 
   UWORD DecayOffset;
   } ProMix[256];

ULONG WriteTestClip(char *pathname, ULONG frames, UWORD count);

ARexxContext rob1;

FILE *bill, *input_file;

struct RexxMsg *bill2;
LONG result;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: MixAudio 1.01";

int main(int argc, char *argv[])
{
ULONG err, totalframes, framecount;
UWORD i;
UWORD pathcount;
UWORD *pathpt;
char temp[20];
char buff5[256];
char *tokenpt;
ARexxContext rob1;
struct Library *RexxSysLib = NULL;
char number[100];

pathpt = &pathcount;

printf("MixAudio Version 1.01\n");
printf("Copyright Prowave 1996\n");

if ((argc != 2) || (argv[1][0] == '?'))
   {
   printf("Incorrect arguements \n");
   printf("%s filename \n",argv[0]);
   exit(20);
   }

pathcount = 0;

printf("Let's open a file \n");

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("No Such file \n");
   return(20);
   }

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,99);

err = fscanf(bill,"%s ",temp);

pathcount = atoi(temp);

for (i=0;i<pathcount;i++)
   {
   fgets(buff5,255,bill);
   tokenpt = strtok(buff5,",");
   strncpy(paths[i],tokenpt,99);
   tokenpt = strtok(NULL,",");
   ProMix[i].StartFrame = atoi(tokenpt)/2;
   tokenpt = strtok(NULL,",");
   ProMix[i].FrameCount = atoi(tokenpt)/2;
   tokenpt = strtok(NULL,",");
   ProMix[i].Time = atoi(tokenpt)/2;
   tokenpt = strtok(NULL,",");
   ProMix[i].AudioOn = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].Vol1 = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].Vol2 = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].Pan1 = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].Pan2 = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].AudioAttack = atoi(tokenpt);
   tokenpt = strtok(NULL,",");
   ProMix[i].AudioDecay = atoi(tokenpt);

   ProMix[i].IN = Open(paths[i],MODE_OLDFILE);

   if (ProMix[i].AudioOn == 15)
      {
      ProMix[i].Loffset = 0;
      ProMix[i].Roffset = 0;
      ProMix[i].CurrentVol1 = ProMix[i].Vol1;
      ProMix[i].CurrentVol2 = ProMix[i].Vol2;
      }

   if (ProMix[i].AudioOn == 7)
      {
      ProMix[i].Loffset = 0;
      ProMix[i].Roffset = 4;
      ProMix[i].CurrentVol1 = ProMix[i].Vol1;
      ProMix[i].CurrentVol2 = ProMix[i].Vol1;
      ProMix[i].Vol2 = ProMix[i].Vol1;
      }

   if (ProMix[i].AudioOn == 11)
      {
      ProMix[i].Loffset = 4;
      ProMix[i].Roffset = 0;
      ProMix[i].CurrentVol1 = ProMix[i].Vol2;
      ProMix[i].CurrentVol2 = ProMix[i].Vol2;
      ProMix[i].Vol1 = ProMix[i].Vol2;
      }

   if (ProMix[i].AudioAttack != 0)
      {
      ProMix[i].CurrentVol1 = 0;
      ProMix[i].CurrentVol2 = 0;
      ProMix[i].AttackStep1 = ProMix[i].Vol1 / (ProMix[i].AudioAttack * 21);
      ProMix[i].AttackStep2 = ProMix[i].Vol2 / (ProMix[i].AudioAttack * 21);
      ProMix[i].AttackFrame = ProMix[i].Time + ProMix[i].AudioAttack/2;
      }     

   if (ProMix[i].AudioDecay != 0)
      {
      ProMix[i].DecayStep1 = ProMix[i].Vol1 / (ProMix[i].AudioDecay * 21);
      ProMix[i].DecayStep2 = ProMix[i].Vol2 / (ProMix[i].AudioDecay * 21);
      ProMix[i].DecayOffset = (ProMix[i].AudioDecay/2)%2;
      ProMix[i].DecayStart = ProMix[i].Time + ProMix[i].FrameCount-ProMix[i].AudioDecay/4-ProMix[i].DecayOffset;
      }     
   }

printf("%s \n",outpath);
printf("%d \n",pathcount);

totalframes = 0;

for (i=0;i<pathcount;i++)
   {
   framecount = ProMix[i].Time + ProMix[i].FrameCount;
   if (totalframes < framecount)
      totalframes = framecount;
   }

getframes(pathcount);

if ((RexxSysLib = OpenLibrary("rexxsyslib.library",0))==0)
   {
   printf("Open rexxsyslib.library failed\n");
   exit(0);
   }

rob1 = ARexxInit("PROWAVE",NULL,FALSE);
if (!rob1)
   printf("We are confused \n");

if (FlyerBase = OpenLibrary(FLYERLIBNAME,0)) 
   {
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"Checking Clip For Audio Track"); 
   if (!bill2)
      printf("It didn't work\n");
   else
      result = get_reply(rob1);

   err = WriteTestClip(outpath,totalframes,pathcount);	// Make skeletal version

   if (err == 0) 
      {
      printf("Time to Reprocess \n");
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"Making Magic Cookies"); 
      if (!bill2)
         printf("It didn't work\n");
      else
         result = get_reply(rob1);
      err = Reprocess(outpath,totalframes);		// Let Flyer process into full clip
      printf("Return from Process \n");
      for (i=0;i<pathcount;i++)
          Close(ProMix[i].IN);
      }
   CloseLibrary(FlyerBase);
   }
else 
   {
   printf("Open flyer.library failed\n");
   }

bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"MixAudio Completed"); 
if (!bill2)
   printf("It didn't work\n");
else
   result = get_reply(rob1);

ending:

ARexxFree(rob1);

if (RexxSysLib)
   CloseLibrary(RexxSysLib);

return(0);
}

/*******************************************************/

UWORD getframes(UWORD count)
{
UWORD i, j;
ULONG temp,temp2;

for (i=0;i<count;i++)
   {
   printf("\n%d %ld ",i,ProMix[i].IN);
   temp2 = (ProMix[i].StartFrame * 12800) + 1024;
   temp = Seek(ProMix[i].IN,temp2,0);
   printf("%ld %ld %ld",ProMix[i].IN,temp,temp2);
   }
printf("\n");
return(0);
}

/*******************************************************/

ULONG WriteTestClip(char *pathname, ULONG frames, UWORD count)
{
int	i,j,k;
ULONG	frm;
BPTR	handle;
struct ClipHeader	*ch;
struct FrameHeader	*fh;
struct Field		*fld;
WORD temp;
LONG temp2;

printf("This is frames %ld this is count %d\n",frames,count);


handle = Open(pathname,MODE_NEWFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

ch->ID = ID_CLIP;
ch->Length = 1+frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Version = 4;
ch->VidCmpVer = 2;
ch->AudVer = 2;
ch->Fields = frames * 4;
ch->DataStart = 1;
ch->DataEnd = frames*(1+MONOAUDFLDSIZE*NUMAUDCHANS*4);
ch->Tail = 0;					// No index table!
ch->AudioLength = MONOAUDFLDSIZE;
ch->VidFlag = FALSE;
ch->AudioChans = NUMAUDCHANS;
ch->Pedestal = 60;
memset(ch->CustCoefs,0,sizeof(WORD)*9);
memset(ch->CustInvCoefs,0,sizeof(WORD)*9);
ch->LogBlkSize = 512;
ch->FIRROM = 0;
ch->FIRRAM = 0;

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

for (frm=0 ; frm<frames; frm++) 
   {
   printf("This is frm %d ",frm);
   sprintf(number,"MixAudio: Frames %d and %d of %d",frm*2,frm*2+1,frames*2-1);
   bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,number); 
   if (!bill2)
      printf("It didn't work\n");
   else
      result = get_reply(rob1);

   /* Build and write each frame header */
   fh = (struct FrameHeader *)&BlkBuff;
   memset(fh,0,sizeof(struct FrameHeader));

   fh->ID = ID_CFRM;

   fh->Length = 1+MONOAUDFLDSIZE*NUMAUDCHANS*4;
   fh->Version = 4;
   fh->VidCmpVer = 2;
   fh->AudVer = 2;
   fh->PrevFrame = (frm == 0)?0:(- fh->Length);
   fh->NextFrame = ((frm+1) >= frames)?0:(fh->Length);
   fh->FrameNumber = frm;
   fh->AudioLength = MONOAUDFLDSIZE;
   fh->VidFlag = FALSE;
   fh->AudioChans = NUMAUDCHANS;

   for (j=0;j<4;j++) 
      {
      fld = &fh->fields[j];
      /* Leave all these blank, unless we add video to clip */
      }

   if (Write(handle,fh,sizeof(struct FrameHeader)) != sizeof(struct FrameHeader))
      printf("Frame header write error\n");

   for (j=0;j<6144;j++)
      Buff[0][j] = 0;

   for (i=0;i<count;i++)
      {
      if ((frm>= ProMix[i].Time) && (frm <= (ProMix[i].Time + ProMix[i].FrameCount-1))) 
         {
         printf("%d ",i);
         Read(ProMix[i].IN,AudioBuff,12288);
         for (j=0;j<4;j++)
            {
            for (k=0;k<735;k++)
               {
               temp = AudioBuff[j+ProMix[i].Loffset][k];
               temp2 = temp;
               /* This handles the Attack Ramp */ 
               if (ProMix[i].CurrentVol1 != ProMix[i].Vol1)
                  {
                  if (frm < ProMix[i].AttackFrame)
                     {
                     if (((k%21) == 0) || ((k==0) && !((frm == ProMix[i].Time) && (j==0))))
                        {
                        if ((ProMix[i].Vol1 - ProMix[i].CurrentVol1) > ProMix[i].AttackStep1)
                           ProMix[i].CurrentVol1 += ProMix[i].AttackStep1;
                        else
                           ProMix[i].CurrentVol1 = ProMix[i].Vol1; 
                        }                         
                     }
                  }

               /* This handles the Decay Ramp */ 
               if (frm >= ProMix[i].DecayStart)
                  {
                  if (((k%21) == 0) || (k==0))
                     {
                     if ((frm==ProMix[i].DecayStart) && (ProMix[i].DecayOffset == 1))
                        { 
                        if (j > 1)
                           { 
                           if (ProMix[i].DecayStart > ProMix[i].CurrentVol1)                                
                              ProMix[i].CurrentVol1 = 0;
                           else
                              ProMix[i].CurrentVol1 -= ProMix[i].DecayStep1; 
                           } 
                        }
                     else
                        {
                        if (ProMix[i].DecayStep1 > ProMix[i].CurrentVol1)
                           ProMix[i].CurrentVol1 = 0;
                        else
                           ProMix[i].CurrentVol1 -= ProMix[i].DecayStep1; 
                        }
                     }                         
                  }
                temp2 = temp2 * ProMix[i].CurrentVol1; 
               temp2 = temp2 / 45874;
               Buff[j][k] = Buff[j][k] + temp2;
               }
            }

         for (j=4;j<8;j++)
            {
            for (k=0;k<735;k++)
               {
               temp = AudioBuff[j-ProMix[i].Roffset][k];
               temp2 = temp; 
               /* This handles the Attack Ramp */ 
               if (ProMix[i].CurrentVol2 != ProMix[i].Vol2)
                  {
                  if (frm < ProMix[i].AttackFrame)
                     {
                     if (((k%21) == 0) || ((k==0) && !((frm == ProMix[i].Time) && (j==4))))
                        {
                        if ((ProMix[i].Vol2 - ProMix[i].CurrentVol2) > ProMix[i].AttackStep2)
                           ProMix[i].CurrentVol2 += ProMix[i].AttackStep2;
                        else
                           ProMix[i].CurrentVol2 = ProMix[i].Vol2; 
                        }                         
                     }
                  }

               /* This handles the Decay Ramp */ 
               if (frm >= ProMix[i].DecayStart)
                  {
                  if (((k%21) == 0) || (k==0))
                     {
                     if ((frm==ProMix[i].DecayStart) && (ProMix[i].DecayOffset == 1))
                        { 
                        
                        if (j > 5)
                           {   
                           if (ProMix[i].DecayStep2 > ProMix[i].CurrentVol2)
                              ProMix[i].CurrentVol2 = 0;
                           else
                              ProMix[i].CurrentVol2 -= ProMix[i].DecayStep2; 
                           }
          
                        }
                     else
                        {
                        if (ProMix[i].DecayStep2 > ProMix[i].CurrentVol2)
                           ProMix[i].CurrentVol2 = 0;
                        else
                           ProMix[i].CurrentVol2 -= ProMix[i].DecayStep2; 
                        }
                     }                         
                  }
               temp2 = temp2 * ProMix[i].CurrentVol2; 
               temp2 = temp2 / 45874;
               Buff[j][k] = Buff[j][k] + temp2;
               }
            }
         Read(ProMix[i].IN,AudioBuff,512);
         }
      }
   
   for (i=0;i<8;i++)   
      {
      for (j=0;j<735;j++)
         {
         if (Buff[i][j] < -32768)
            AudioBuff[i][j] = -32768;
         else
            {
            if (Buff[i][j] > 32767)
               {
               AudioBuff[i][j] = 32767;
               }
            else
               {
               AudioBuff[i][j] = Buff[i][j];
               }
            }
         }
      }

   /* Write all audio data for this color frame */
   if (Write(handle,AudioBuff,12288) != 12288)
      printf("Audio data write error\n");
   printf(" \n");
   }

printf("CurrentVol = %d %d  \n",ProMix[0].CurrentVol1, ProMix[0].CurrentVol2);
printf("       Vol = %d %d  \n",ProMix[0].Vol1, ProMix[0].Vol2);

printf("Let's Close the File \n");

Close(handle);

return(0);		// Okay
}

// Reprocess -- Let Flyer re-process our clip to build all the reserved
//		structures needed.  These are quite technical (as well as
//		being private), so we'll let it do the work for us.  We
//		just provide a clip that has the minimal stuff needed.
//		This, obviously, requires that the clip was written to
//		a Flyer drive.  If not, you should copy the "skeletal"
//		clip file to a Flyer drive first, then do this function.
ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!
if (NUMAUDCHANS == 2)
   actptr->Flags |= CAF_AUDIOL | CAF_AUDIOR;
else
   actptr->Flags |= CAF_AUDIOL;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(0);
}

