
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

struct FlyerVolume	FlyVol, FlyVol2;
struct ClipAction	Action, Action2;
struct ClipInfo		Cinfo;

UBYTE Buffer[SAMPLESPERLINE],AltBuf[SAMPLESPERLINE];

__far UBYTE Buffer2[240][752];

__far UBYTE Buffer1[240][752];

unsigned fieldtype[4] = {0,0,1,1};

main(int argc,char **argv)
{
int	board=0,i,j,k,l,pattern,line,modes,fieldnum;
ULONG	err;
UBYTE	*buff,qualmode;
int start, length;
UBYTE temp1, temp2;
int count = 0;
int myY, myI, myQ;
int fieldcnt;

if (argc < 6)
   {
   printf("Correct format: %s infile outfile startfield fieldcount value \n",argv[0]);
   exit(1);
   }

modes = FWF_NEW;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = board;
FlyVol.Path = argv[1];
FlyVol.Flags = 0;			// We'll specify volume in name, not drive number

Action.Volume = &FlyVol;		// Link structures together
Action.ReturnTime = RT_STOPPED;

FlyVol2.Board = board;
FlyVol2.Path = argv[2];
FlyVol2.Flags = 0;			// We'll specify volume in name, not drive number

fieldnum = 0;

Action2.Volume = &FlyVol2;
Action2.ReturnTime = RT_STOPPED;
qualmode = 0;		// Best mode

start = atoi(argv[3]);

length = atoi(argv[4]);

length += start;

for (j=start;j<length;j++)
   {
   printf("Field: %d \n",j);

   err = OpenReadField(&Action,j,0);			// Open field in clip for reading
   if (err)
      {
      printf("\nOpen Error %ld - %ls\n",err,Error2String(err));
      printf("Didn't open field %ld\n",j);
      }

   for (line=0;line<240;line++)
      {
      Action.ReturnTime = RT_STOPPED;
      err = FlyerReadLine(&Action,Buffer1[line]);			// Read D2 data into my buffer
      }

   err = CloseField(&Action);									// Close field, done now
   if (err)
      printf("\nClose Error 1 %ld - %ls\n",err,Error2String(err));

   fieldcnt = atoi(argv[5]);

   for (l=0;l<fieldcnt;l++)
      {
      err = EasyOpenWriteField(&Action2,0,modes | FWF_APPEND,qualmode);
      if (err)
         printf("\nOpen Error %ld - %ls\n",err,Error2String(err));
      for (line=0;line<240;line++)
         {
         if (line == 0)
            printf("change it \n"); 
         for (k=0;k<188;k++)
            {
            if (fieldtype[count%4] != fieldtype[j%4])
               {
               myY = Buffer1[line][k*4] + Buffer1[line][k*4+2] + Buffer1[line][k*4+1] + Buffer1[line][k*4+3];
               myY = myY/4;
               myI = ((myY-Buffer1[line][k*4]) + (Buffer1[line][k*4+2]-myY))/2;
               myQ = ((myY-Buffer1[line][k*4+1]) + (Buffer1[line][k*4+3]-myY))/2;
               Buffer2[line][k*4+0] = myY+myI;
               Buffer2[line][k*4+1] = myY+myQ;
               Buffer2[line][k*4+2] = myY-myI;
               Buffer2[line][k*4+3] = myY-myQ;
               }
            else
               {
               Buffer2[line][k*4+0] = Buffer1[line][k*4+0];
               Buffer2[line][k*4+1] = Buffer1[line][k*4+1];
               Buffer2[line][k*4+2] = Buffer1[line][k*4+2];
               Buffer2[line][k*4+3] = Buffer1[line][k*4+3];
               } 
            }
         Action2.ReturnTime = RT_STOPPED;
         buff = Buffer2[line];
         err = FlyerWriteLine(&Action2,buff);
         if (err)
            {
            printf("\nError %ld on line %ld - %ls\n",err,line,Error2String(err));
            break;
	    }
         }
      Action2.ReturnTime = RT_STOPPED;
      err = CloseField(&Action2);
      if (err)
         printf("\nClose Error 2 %ld - %ls\n",err,Error2String(err));
      count++;
      } 
   modes = 0;
   }

CloseLibrary(FlyerBase);
return(0);
}

void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi))
	{
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
