/*********************************************************************\
*
* ReadField2 - Dump video field
*
* $Id: ReadField2.c,v 1.0 1995/05/05 15:50:44 Flick Exp $
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* All information contained herein is property of
* NewTek, Inc. and is subject to change without
* notice.
*
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);


struct Library *FlyerBase;

struct FlyerVolume	FlyVol;
struct ClipAction		Action;

UBYTE Buffer[SAMPLESPERLINE];

main(int argc,char **argv)
{
	int	board=0,line,i,j=0;
	ULONG	field,res;

	if ((argc!=3)||(argv[1][0]=='?'))
	{
		printf("Usage: %ls <volume:name> <field>\n",argv[0]);
		printf("  Reads and dumps a field of D2 video data from video clip\n");
		return(20);
	}

	GetLongArg(argv[2],&field,0,0xFFFFFFFF,"Field number");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
	{
		printf("Open flyer.library failed\n");
		return;
	}

	FlyVol.Board = board;
	FlyVol.Flags = 0;
	FlyVol.Path = argv[1];			// Volume & name of clip

	Action.Volume = &FlyVol;		// Link structures together
	Action.ReturnTime = RT_STOPPED;
     
     for (j=0;j<4;j++)
        {
	res = OpenReadField(&Action,field+j,0);			// Open field in clip for reading
	if (res)
	{
		printf("\nOpen Error %ld - %ls\n",res,Error2String(res));
		printf("Didn't open field %ld\n",field);
	}
	else
	{
		printf("Found field %ld\n",field);

		for (line=21;line<=260;line++)
		{
			Action.ReturnTime = RT_STOPPED;
			res = FlyerReadLine(&Action,Buffer);			// Read D2 data into my buffer
			if (res)
			{
				printf("\nError %ld - %ls\n",res,Error2String(res));
				break;
			}

			printf("Line %ld: \n",line);
		}
		Action.ReturnTime = RT_STOPPED;
		CloseField(&Action);									// Close field, done now
	}
       }


	CloseLibrary(FlyerBase);

	return(0);
}


void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
{
	stch_l(arg,(long *)var);
	if ((*var < lo)||(*var > hi))
	{
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
