
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act, *actptr;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[4][100];
ULONG count[2];

struct sequence
   {
   char filename[256];
   ULONG VidStart;
   ULONG VidLength;
   ULONG AudStart;
   ULONG AudLength;
   } SEQ[50];

FILE *bill;

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE2;
UWORD  i,temp;
char buff5[256];
char *tokenpt;
UWORD seqcount;


printf("FlyerSeq Version 0.80\n");
printf("Copyright Prowave 1997\n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

printf("Time to take out tokens \n");

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
seqcount = atoi(tokenpt);

for (i=0;i<seqcount;i++)
   {
   fgets(buff5,255,bill);
   tokenpt = strtok(buff5,",");
   strncpy(SEQ[i].filename,tokenpt,99);
   tokenpt = strtok(NULL,",");
   SEQ[i].VidStart = atoi(tokenpt)*2;
   tokenpt = strtok(NULL,",");
   SEQ[i].VidLength = atoi(tokenpt)*2;
   tokenpt = strtok(NULL,",");
   SEQ[i].AudStart = atoi(tokenpt)*2;
   tokenpt = strtok(NULL,",");
   SEQ[i].AudLength = atoi(tokenpt)*2;
   printf("%s %d %d %d %d  \n",SEQ[i].filename,SEQ[i].VidStart,SEQ[i].VidLength,
          SEQ[i].AudStart,SEQ[i].AudLength);
   }

fclose(bill);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

res = NewSequence(0);
if (res)
   {
   printf("Error starting new sequence \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

for (i=0;i<seqcount;i++)
   {
   FlyVol.Board = 0;
   FlyVol.Flags = 0;
   FlyVol.Path = SEQ[i].filename;

   act.Volume = &FlyVol;

   act.VidStartField = SEQ[i].VidStart;
   act.VidFieldCount = SEQ[i].VidLength;
   act.AudStartField = SEQ[i].AudStart;
   act.AudFieldCount = SEQ[i].AudLength;
   act.TotalAudStart = act.AudStartField;    
   act.TotalAudLength = act.AudFieldCount;
   act.VolSust1 = 45874;
   act.VolSust2 = 45874;
   act.AudioPan1 = 0;
   act.AudioPan2 = 0;
   act.VolAttack = 0;
   act.VolDecay = 0;

   actptr = &act;

   actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;
   actptr->ReturnTime = RT_STOPPED;			// Don't return until done

   res = AddSeqClip(actptr);
   if (res)
      {
      printf("Error adding %d to sequence \n",i);
      printf("Error %ld - %ls\n",res,Error2String(res));
      exit(20);
      }
   }

res = EndSequence(0,1);
if (res)
   {
   printf("Error Ending Sequence \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

res = PlaySequence(0,0);
if (res)
   {
   printf("Error Playing Sequence \n");
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

CloseLibrary(FlyerBase);

return(0);
}

