
#include "arexx.h"
#include "arexxsyslib.h"

#ifdef RVI
#include "rvi.h"
#endif

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

#define MAX_PORT_NAME   16
#define MAX_PORT_LENGTH 24
#define MAX_ERROR_NAME  28
#define MAX_EXTENSION    8

#define NULLCHAR '\0'

struct ARexxContext
   {
   struct MsgPort *arexx_port;
   struct Library *rexx_base;
   long   outstanding;
   char   port_name[MAX_PORT_LENGTH +1];
   char   extension[MAX_EXTENSION + 1];
#ifdef RVI
   char   error_name[MAX_ERROR_NAME + 1];
#endif
   };

#define AREXXCONTEXT
typedef struct ARexxContext *ARexxContext;

#include "SimpleRexx.h"

static char *StrNUpper(char *dest, char *src, unsigned int len);

static char *UiToStr(unsigned num, char *buf);

ARexxContext ARexxInit(char *, char *, BOOL);
LONG get_reply(ARexxContext  context);

struct Library *DosBase;

struct Library *FlyerBase;
struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act, act2;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[2][100];
ULONG count[2];

ARexxContext rob1;

FILE *bill, *input_file;

struct RexxMsg *bill2;
LONG result;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: ShiftAudio 1.20";

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE2, OUTFILE3;
UWORD  i,temp;
char buff5[256];
char *tokenpt;
ARexxContext rob1;
struct Library *RexxSysLib = NULL;
char number[100];
WORD shiftcount;
UWORD y;
BPTR handle;
char myfile[100];
UWORD offset1,offset2,count1,count2;

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("ShiftAudio Version 1.20 \n");
   printf("Copyright Prowave 1997\n");
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

printf("Time to take out tokens \n");

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[0],tokenpt,99);
tokenpt = strtok(NULL,",");
shiftcount = atoi(tokenpt);

printf("0  %s %d \n",filename[0],shiftcount);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[1],tokenpt,99);

fclose(bill);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

if ((RexxSysLib = OpenLibrary("rexxsyslib.library",0))==0)
   {
   printf("Open rexxsyslib.library failed\n");
   exit(0);
   }

rob1 = ARexxInit("PROWAVE",NULL,FALSE);
if (!rob1)
   printf("We are confused \n");

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = filename[1];

Buffer.len = sizeof(struct ClipInfo);
Buffer2.len = sizeof(struct ClipInfo);
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = filename[0];

bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"Making New File"); 
if (!bill2)
   printf("It didn't work\n");
else
   result = get_reply(rob1);
res = FlyerCopyClip(&FlyVol,&FlyVol2);

if (res)
   {
   printf("Lets try it now \n"); 
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

strcpy(myfile,filename[0]); 
strcat(myfile,".Prowave");
FlyVol3.Path = myfile;
FlyVol3.Board = 0;
FlyVol3.Flags = 0;

res = MakeFlyerFile(&FlyVol3,24,&OUTFILE3);

handle = Open(myfile,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   }

for (i=0;i<256;i++)
   testbuff[i] = 0;

for (i=0;i<24;i++)
   Write(handle,&testbuff,512);

Close(handle);

res = GetClipInfo(&FlyVol2,&Buffer);
OUTFILE2 = Buffer.Start;
res = GetClipInfo(&FlyVol3,&Buffer2);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

act.Volume = &FlyVol2;
act.VidStartField = 0;
res = GetFrameHeader(&act,&FrameBuffer);

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,24,act.StartBlk+1);

act.Volume = &FlyVol2;
act.VidStartField = Buffer.Fields-3;
res = GetFrameHeader(&act,&FrameBuffer);

res = CopyData(&FlyVol3,&FlyVol2,OUTFILE3,24,act.StartBlk+1);

temp = Buffer.Fields/4;

printf("This is shiftcount %d \n",shiftcount);

if ((shiftcount == 1) || (shiftcount == -3))
   {
   offset1 = 3; 
   offset2 = 9;
   count1 = 9;
   count2 = 3; 
   }

if ((shiftcount == 2) || (shiftcount == -2))
   {            
   offset1 = 6; 
   offset2 = 6;
   count1 = 6;
   count2 = 6; 
   }

if ((shiftcount == 3) || (shiftcount == -1))
   {
   offset1 = 9;
   offset2 = 3;
   count1 = 3;
   count2 = 9;
   }

for (i=0;i<Buffer.Fields/4-1;i++)
   {
   /* print status every 30 frames */
   if ( (i%15) == 0)
      {
      y = i*2+30;
      if (y>temp*2)
         y=temp*2;
      sprintf(number,"FlyerShiftAudio: Frames %d through %d of %d",i*2+1,y,temp*2);
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,number); 
      if (!bill2)
         printf("It didn't work\n");
      else
         result = get_reply(rob1);
      }

   /* Oz Panic Stop stuff */ 
   input_file = fopen("ENV:OZ-PanicStop","r");
   if (input_file != NULL)
      { 
      bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"FlyerShiftAudio: Aborted by Hotkey");
      if (!bill2)
         printf("It didn't work\n");
      else
         result = get_reply( rob1);
      goto ending;
      }

   /* Get Source Video Pointer */
   act.Volume = &FlyVol;
   act.VidStartField = i*4;
   res = GetFrameHeader(&act,&FrameBuffer);
   if (res) 
      printf("Error Getting Header \n");


   /* Get Destination Video Pointer */
   act2.VidStartField = i*4;
   act2.Volume = &FlyVol2;
   res = GetFrameHeader(&act2,&FrameBuffer2);
   if (res) 
      printf("Error Getting Header 2\n");

   /* Copy Left  Audio */    
   res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+1,count1,act2.StartBlk+offset1+1);
   if (res) 
      printf("Error Copying Left \n");

   /* Copy Right Audio */    
   res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+13,count1,act2.StartBlk+offset1+13);
   if (res) 
      printf("Error Copying Right \n");

   /* Get Destination Video Pointer */
   act2.VidStartField = (i+1)*4;
   act2.Volume = &FlyVol2;
   res = GetFrameHeader(&act2,&FrameBuffer2);
   if (res) 
      printf("Error Getting Header 3 \n");

   /* Copy Left  Audio */    
   res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+1+count1,count2,act2.StartBlk+1);
   if (res) 
      printf("Error Copying Left 2 \n");

   /* Copy Right Audio */    
   res = CopyData(&FlyVol,&FlyVol2,act.StartBlk+13+count1,count2,act2.StartBlk+13);
   if (res) 
      printf("Error Copying Right 2 \n");

   }


bill2 = CallARexxFunc(rob1,"PROJECT_REXX_PORT","REQ_ERROR",0,1,"FlyerShiftAudio Completed"); 
if (!bill2)
   printf("It didn't work\n");
else
   result = get_reply(rob1);

ending:
ARexxFree(rob1);

if (RexxSysLib)
   CloseLibrary(RexxSysLib);

CloseLibrary(FlyerBase);

return(0);
}

LONG get_reply(ARexxContext  context)
{
   struct RexxMsg   *reply;
   unsigned long    i;
   LONG             temp_code;

   /* poll for reply */
   i=0;
      while ( ((reply = GetARexxMsg(context)) == NULL) && (++i < 1000) )
      {
         Delay(5);
      }
 

   if (i == 1000)
   {
      printf("timeout\n");
      /* did not get a response in a long time, just return */
      return(0);
   }
   else
   {
            if (IsARexxReply( reply) )
            { 
         temp_code = reply->rm_Result1;
         FreeARexxMsg(context, reply);
      }
      /* otherwise, don't care */
   }
   return( temp_code);
}

ARexxContext ARexxInit(char *name, char *extension, BOOL multiple)
{
struct Library *RexxSysBase;
struct MsgPort *port;
ARexxContext  context;
unsigned count;
char  *ptr;

context = AllocMem(sizeof(struct ARexxContext), MEMF_PUBLIC | MEMF_CLEAR);

if (!context)
   return(NULL);

RexxSysBase = OpenLibrary((UBYTE *) "rexxsyslib.library",0L);

if (RexxSysBase)
   {
   context->rexx_base = RexxSysBase;
   if (!extension)
      extension = "rexx";
   StrNUpper(context->extension, extension, MAX_EXTENSION);
   ptr = StrNUpper(context->port_name, name, MAX_PORT_NAME);
#ifdef RVI
   strcpy(context->error_name, context->port_name);
   strcat(context->error_name, ".LASTERROR");
#endif

   Forbid();
   if (multiple)
      {
      *ptr++='.';
      for (count = 1; count < 100; ++count)
         {
         UiToStr(count, ptr);
         port = FindPort((UBYTE *) context->port_name);
         if (!port) break;
         }
      }
   else
      {
      port = FindPort((UBYTE *) context->port_name);
      }

   if (!port)
      context->arexx_port = CreatePort ((UBYTE *) context->port_name,0);
   Permit();
   }

if (!context->rexx_base || !context->arexx_port)
   {
   ARexxFree(context);
   context = NULL;
   }

return(context);
}

void ARexxFree (ARexxContext context)
{
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context)
   return;

if (context->rexx_base)
   {
   RexxSysBase = context->rexx_base;
   context->port_name[0] = NULLCHAR;
   while (context->outstanding > 0 && context->arexx_port != NULL)
      {
      WaitPort(context->arexx_port);
      while ((msg = GetARexxMsg(context) ) != NULL)
         {
         if (!FreeARexxMsg(context, msg))
            ReplyARexxMsg(context, msg, 100, NULL, 0);
         }
      }
   if (context->arexx_port)
      {
      Forbid();
      while ((msg = GetARexxMsg(context)) != NULL)
         ReplyARexxMsg(context, msg, 100, NULL, 0);
      DeletePort(context->arexx_port);
      Permit();
      }
   CloseLibrary(RexxSysBase);
   }

FreeMem(context, sizeof(struct ARexxContext));

}

char *ArexxName(ARexxContext context)
{
if (context)
   return(context->port_name);
else
   return(NULL);
}

ULONG ARexxSignal(ARexxContext context)
{
if (context)
   return(1UL << context->arexx_port->mp_SigBit);
else
   return(0);
}

struct Library *ARexxBase(ARexxContext context)
{
if (context)
   return(context->rexx_base);
else
   return(NULL);
}

BOOL IsARexxReply( struct RexxMsg *msg)
{
if (msg)
   return( (BOOL)(msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG ));
else
   return(FALSE);
}

struct RexxMsg *GetARexxMsg(ARexxContext context)
{
struct RexxMsg *msg;

if (!context)
   return(NULL);

msg = (struct RexxMsg *) GetMsg(context->arexx_port);

if (!msg)
   return(NULL);

if (IsARexxReply(msg))
   --context->outstanding;

return(msg);
}

BOOL FreeARexxMsg(ARexxContext context, struct RexxMsg *msg)
{
struct Library *RexxSysBase;

if (!context || !msg)
   return(FALSE);

if (!IsARexxReply(msg))
   return(FALSE);

RexxSysBase = context->rexx_base;

ClearRexxMsg(msg, 16);

if (msg->rm_Result1 == 0 && msg->rm_Result2 != NULL)
   DeleteArgstring((char *) msg->rm_Result2);

DeleteRexxMsg(msg);

return(TRUE);

}

struct RexxMsg *SendARexxMsg(ARexxContext context, char *port_name,
              char *command, ULONG flags)
{
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;

if (!context || !command)
   return(NULL);

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
              context->port_name);

if (!msg)
   return(NULL);

flags &= ( RXFF_NOIO | RXFF_RESULT | RXFF_STRING | RXFF_TOKEN );

msg->rm_Action = RXCOMM | flags;

msg->rm_Args[0] = (STRPTR) CreateArgstring(command, strlen(command));

msg->rm_Result1 = 0;

msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port = FindPort((UBYTE *) port_name )) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   DeleteArgstring((char *) msg->rm_Args[0]);
   DeleteRexxMsg(msg);
   msg = NULL;
   }

Permit();
return(msg);

}


struct RexxMsg *CallARexxFunc (ARexxContext context, char *port_name,
       char *function, ULONG flags, int num_args, ...)
{
va_list        argptr;
struct MsgPort *port;
struct RexxMsg *msg;
struct Library *RexxSysBase;
BOOL   quit;
int   i;
char *arg;

if (!context || !function || num_args < 0)
   return(NULL);

if (num_args > 15)
   num_args = 15;

if (!port_name)
   port_name = "REXX";

RexxSysBase = context->rexx_base;

msg = CreateRexxMsg(context->arexx_port, context->extension,
            context->port_name);

if (!msg)
   return(NULL);

flags &= (RXFF_NOIO | RXFF_RESULT | RXFF_STRING);

msg->rm_Action = RXFUNC | flags;

msg->rm_Action |= ( num_args & RXARGMASK);

msg->rm_Args[0] = (STRPTR) CreateArgstring(function, strlen(function));

msg->rm_Result1 = 0;
msg->rm_Result2 = (LONG) NULL;

if (!msg->rm_Args[0])
   {
   DeleteRexxMsg(msg);
   return(NULL);
   }

va_start (argptr, num_args);

for (i=1, quit=FALSE; i<= num_args && !quit; ++i)
   {
   arg = (char *) va_arg(argptr, char *);

   if (!arg)
      arg = "";

   msg->rm_Args[i] = (STRPTR) CreateArgstring(arg, strlen(arg));

   if (!msg->rm_Args[i])
      quit = TRUE;

   }

va_end(argptr);

if (quit)
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   return(NULL);
   }

Forbid();

if ((port=FindPort((UBYTE *) port_name)) != NULL)
   {
   PutMsg(port, (struct Message *) msg);
   ++context->outstanding;
   }
else
   {
   ClearRexxMsg(msg, 16);
   DeleteRexxMsg(msg);
   msg = NULL;
   }


Permit();

return(msg);

}


BOOL  ReplyARexxMsg( ARexxContext context,  struct RexxMsg  *msg,
                     LONG return_code,  char *result_string,
                     LONG error_code)
{

   struct Library  *RexxSysBase;

   if ( !context || !msg )
      return( FALSE );

   if ( IsARexxReply (msg) )
      return( FALSE );

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Set the results */

   msg->rm_Result1 = return_code;
   msg->rm_Result2 = (LONG) NULL;

   /* if no error and result was requested, set the result string */

   if ( result_string != NULL && return_code == RC_OK
        && (msg->rm_Action & RXFF_RESULT) != 0 )
      {
       msg->rm_Result2 = (LONG) CreateArgstring( result_string,
                                 strlen( result_string) );
      }
   else if  (return_code != RC_OK)
      {
         msg->rm_Result2 = error_code;
      }

   ReplyMsg( (struct Message *)msg );

   return(TRUE);
}


BOOL AddFuncHost (ARexxContext context,  LONG priority)
{

   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if( !context )
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* Get a new message packet */

   msg = CreateRexxMsg( context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);


   msg->rm_Action = RXADDFH | RXFF_NONRET;
   msg->rm_Args[0] = (STRPTR) context->port_name;
   msg->rm_Args[1] = (STRPTR) priority;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX" ) ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg( msg );
      msg = NULL;
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}


BOOL RemFuncHost( ARexxContext context)
{
   struct RexxMsg  *msg;
   struct Library  *RexxSysBase;
   struct MsgPort  *port;

   if (!context)
      return(FALSE);

   /* setup the library pointer */

   RexxSysBase = context->rexx_base;

   /* get a new message packet */

   msg = CreateRexxMsg (context->arexx_port, context->extension,
                        context->port_name);

   if (!msg)
      return(FALSE);

   /* tell the resident process to remove the port name to the Library
    * List... we don't expect a reply
    */

   msg->rm_Action   = RXREMLIB | RXFF_NONRET;
   msg->rm_Args[0]  = (STRPTR)  context->port_name;

   /* find the port */

   Forbid();

   if( ( port = FindPort( (UBYTE *) "REXX") ) != NULL )
   {
      PutMsg( port, (struct Message *) msg);
   }
   else
   {
      ClearRexxMsg( msg, 16);
      DeleteRexxMsg (msg);
   }

   Permit();

   return( (BOOL)(msg != NULL) );
}




BOOL  SetARexxLastError( ARexxContext context, struct RexxMsg *msg,
                        char *error)
{

   #ifndef RVI
      return(FALSE);
   #else
      if (!context || !msg || !error)
         return(FALSE);

      if (!CheckRexxMsg (msg) )
         return(FALSE);

      return( SetRexxVar( msg, context->error_name,
                           error, strlen(error) ) == 0 )
   #endif
}




static char *StrNUpper( char *dest,  char *src,  unsigned int len)
{

   for( ; *src != NULLCHAR && len-- > 0; ++src)
   {
      if (islower (*src))
         *dest++ = toupper( *src );
      else
         *dest++ = *src;
   }

   *dest = NULLCHAR;

   return(dest);
}



static char *UiToStr( unsigned num, char *buf)
{
   num %= 100;

   buf[0] = (num / 10) + '0';
   buf[1] = (num % 10) + '0';
   buf[2] = NULLCHAR;

   return(buf);
}
