
#include <exec/types.h>
#include <exec/memory.h> 
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *DosBase;

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

int SLOMO(char *, char *);

struct Library *FlyerBase;
struct FlyerVolume FlyVol, FlyVol2, FlyVol3;

struct ClipInfo	Buffer, Buffer2;
struct ClipAction act;
struct FrameHeader FrameBuffer, FrameBuffer2;

WORD testbuff[256];

char filename[4][100];
ULONG count[2];

FILE *bill, *input_file;

LONG result;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: SlowMO 0.50";

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE2;
UWORD  i,temp;
char buff5[256];
char *tokenpt;
char number[100];

printf("Slo-Mo Version 0.50\n");
printf("Copyright Prowave 1997\n");

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

bill = fopen(argv[1],"r");
if (bill == NULL)
   {
   printf("%s : File not found \n",argv[1]);
   exit(20);
   }

printf("Time to take out tokens \n");

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[3],tokenpt,99);

printf("3  %s \n",filename[3]);

fgets(buff5,255,bill);
tokenpt = strtok(buff5,",");
strncpy(filename[1],tokenpt,99);

fclose(bill);

for (i=1;i<4;i++)
   printf("%d %s \n",i,filename[i]);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = filename[1];

Buffer.len = sizeof(struct ClipInfo);
Buffer2.len = sizeof(struct ClipInfo);
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   exit(20);
   }

SLOMO(filename[1],filename[3]);

printf("We have made the file \n");

CloseLibrary(FlyerBase);

return(0);
}

int SLOMO(char *inpath, char *outpath)
{
ULONG	res, frames;
ULONG  OUTFILE2, OUTFILE3, OUTFILE4;
UWORD  i, j;
ULONG Total = 0, WIDGET = 0;
BPTR handle;
char myfile[50];
LONG OldLength = 0;
UWORD VidLength = 0;

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = inpath;

WriteClipStart(frames, Total ,outpath);

printf("We have deleted the file \n");

return(0);
}

ULONG WriteClipStart(ULONG frames, ULONG Length,char *pathname)
{
BPTR	handle;
struct ClipHeader *ch;
UBYTE BlkBuff[512];

handle = Open(pathname,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

/* Build and write Clip header */
ch = (struct ClipHeader *)&BlkBuff;
memset(ch,0,sizeof(struct ClipHeader));

/* Read the Ignore Stuff */
Read(handle,BlkBuff,512);

Close(handle);

ch->Fields = frames * 4;
ch->DataEnd = Length;
ch->Tail = 0;
ch->Length = Length-1;
ch->AudioChans = 2;
ch->AudVer = 2;
ch->AudioLength = 3;
ch->Pedestal = 20;


				// No index table!
handle = Open(pathname,MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(1);
   }

if (Write(handle,ch,sizeof(struct ClipHeader)) != sizeof(struct ClipHeader))
   printf("Clip header write error\n");

Close(handle);

return(0);		// Okay
}

ULONG Reprocess(char *pathname, ULONG frames)
{
struct FlyerVolume FlyVol,*volptr;
struct ClipAction	 Action,*actptr;
ULONG	res;

actptr = &Action;
volptr = &FlyVol;

/* Let Flyer find original clip and prepare to process it */

volptr->Board = 0;
volptr->Path = pathname;		// Full path and filename (on Flyer drive)
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done

res = StartClipCutList(actptr,1);		// Ready for destructive reprocessing
if (res) 
   {
   printf("Error %ld on StartClipCutList - %ls\n",res,Error2String(res));
   return(res);
   }

/* Now define one clip to make from original */

volptr->Board = 0;
volptr->Path = pathname;					// Make new clip the same name
volptr->Flags = 0;							// None
actptr->Volume = volptr;					// Link together
actptr->ReturnTime = RT_STOPPED;			// Don't return until done
actptr->AudStartField = 0;					// Reprocess all of clip
actptr->AudFieldCount = frames * 4;
actptr->VidStartField = 0;					// Reprocess all of clip
actptr->VidFieldCount = frames * 4;

actptr->Flags = CAF_REPROCESS;		// Force Flyer to re-process this!

actptr->Flags |= CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

res = AddClipCut(actptr);					// Define the new clip
if (res) 
   {
   printf("Error %ld on AddClipCut - %ls\n",res,Error2String(res));
   res = EndClipCutList(0);				// Let Flyer clean up
   return(res);
   }

res = EndClipCutList(1);				// Do it now!!!
if (res) 
   {
   printf("Error %ld on EndClipCutList - %ls\n",res,Error2String(res));
   }

return(FERR_OKAY);
}

