/*********************************************************************\
*
* FlyerPrivate.h - Flyer include file (private information)
*
* $Id: FlyerPrivate.h,v 1.3 96/11/13 19:06:25 Hayes Exp $
*
* $Log:	FlyerPrivate.h,v $
*Revision 1.3  96/11/13  19:06:25  Hayes
*added FlyerDatChunk structure
*
*Revision 1.2  95/10/16  17:48:01  Flick
*Private SRAM locations as in FlyerPrivate.i
*
*Revision 1.1  1995/05/08  15:49:29  Flick
*Reduced SRAM top, reduced #cmds to 8
*
*Revision 1.0  1995/05/05  15:45:26  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/23/94		Marty		Created
\*********************************************************************/

#define	MAX_FLYER_CARDS	4
#define	MAX_FLYER_CMDS		8
#define	FLYER_CMD_LEN		32
#define	MAX_POOL_FRAGS		MAX_FLYER_CMDS+4

/*** Flyer SRAM offset addresses ***/

#define	FLYERGURU			0x00400		//Flyer trap meditation numbers
#define	SHAREDCTRL			0x00480		//Disk change counters, etc.
#define	CMDBASE				0x00500
#define	SHAREDTOP			0x0F000		//Leave room for Flyer's stuff
#define	PROGAREA				0x18000
#define	SRAMSIZE				0x40000

#define	VTASCDRAM			0x1FFE		//DRAM blocks reserved for VTASC
#define	VTASCSRAM			0xBE			//SRAM blocks reserved for VTASC
#define	VTASCSRAMADDR		0x17C00		//Offset address of SRAM blocks for VTASC

struct FlyerCmd {
	UBYTE	dc_RetTime;
	UBYTE	dc_Majic;
	APTR	dc_DataPtr1;
	ULONG	dc_DataLen1;
	APTR	dc_DataPtr2;
	ULONG	dc_DataLen2;
	APTR	dc_FollowUp;
	ULONG	dc_CopySrc;
	ULONG	dc_CopyDest;
	ULONG	dc_CopySize;
	ULONG	dc_CopyExtra;
	APTR	dc_SRAMptr;
	APTR	dc_Unit;
	APTR	dc_Action;
};

struct Flyerfl {
	APTR	fl_Start;
	ULONG	fl_Size;
};

struct FlyerUnit {
	APTR		fu_SRAMbase;
	struct	FlyerCmd	fu_Cmds[MAX_FLYER_CMDS];
	struct	Flyerfl	fu_FreeList[MAX_POOL_FRAGS];
/*	ULONG		fu_ChanIDs[NUMIDS]; */
	UBYTE		fu_Mode;
	UBYTE		fu_PrivFlags;
};

struct FlyerLib {
	struct Library	fl_Library;
	APTR	fl_SysLib;
	APTR	fl_DosBase;
	BPTR	fl_SegList;
	UBYTE	fl_PrivFlags;
	UBYTE	fl_pad;
	struct FlyerUnit fl_Units[MAX_FLYER_CARDS];
	struct MinList fl_Volumes;
	APTR	fl_Mencode;			/* M-Encoder definition data */
	ULONG	fl_Mencodelen;
	APTR	fl_Pencode;			/* P-Encoder definition data */
	ULONG	fl_Pencodelen;
	APTR	fl_Mdecode;			/* M-Decoder definition data */
	ULONG	fl_Mdecodelen;
	APTR	fl_Pdecode;			/* P-Decoder definition data */
	ULONG	fl_Pdecodelen;
/*	ULONG	fl_Test; */
	APTR	fl_BinaryBuffer;	/* For loading .bin files */
	ULONG	fl_BinaryLength;
	UWORD	fl_RefNumber;		/* CutRoom ref number counter */
	APTR	fl_RenameList;		/* CutRoom rename list */
	struct FlyerVolInfo	fl_PrivVolume;		/* My private FlyVol structure */
	struct ClipAction		fl_PrivAction;		/* My private ClipAction structure */
	struct VidCompInfo	fl_PrivCompInfo;	/* My private VidCompInfo struct */
	struct ClipInfo		fl_PrivClipInfo;	/* My private ClipInfo struct */
};


/* VidCompInfo private fields */
#define	DataStart	Private1
#define	DataEnd		Private2


struct FlyerChipHeader {
	ULONG	FlyerID;
	UBYTE	chipnum;
	UBYTE	defnum;
	UBYTE	chiprev;
	UBYTE	boardrev;
	ULONG	id;			/* Date code, etc */
	ULONG	speed;		/* Speed at which to run chip (Hz) */
	ULONG	length;		/* Amount of binary data in chip def */
};

struct FlyerDatChunk
{
	ULONG ChipID;		/* Chip type the bin is for */
	ULONG length;		/* length of the bin file   */
	UBYTE data;			/* binary data for the chip */
};

#define	ALGO_OLDD2		0			/* Old D2 is now private */
