#include "dos/dos.h"

/****** Library Operations ******/
ULONG	AbortCmd(ULONG id);
ULONG	CheckCmd(ULONG id);
ULONG	WaitAction(struct ClipAction *action);
ULONG	CheckAction(struct ClipAction *action);
ULONG	AbortAction(struct ClipAction *action);
char	*Error2String(UBYTE error);

/****** Setup ******/
ULONG	InitFlyers(BPTR lock);
ULONG	Firmware(UBYTE board,ULONG length,APTR data,ULONG offset);
ULONG	RunModule(UBYTE board,ULONG length,APTR data,ULONG *ID,
	UWORD argc,ULONG *argv);
ULONG	PgmFPGA(UBYTE board,UBYTE chipnum,ULONG length,APTR data,
	UBYTE revision);
ULONG	SBusWrite(UBYTE board,UBYTE addr,UBYTE data);
ULONG	SBusRead(UBYTE board,UBYTE addr,UBYTE *data);
ULONG	FIRinit(UBYTE board,UWORD reg0,UWORD reg1);
ULONG	FIRcustom(UBYTE board,UBYTE prepost,UWORD scale,UWORD *coefdata);
ULONG	FIRmapRAM(UBYTE board,UBYTE bank,UBYTE scale,UBYTE shape);
ULONG	DSPboot(UBYTE board,ULONG length,APTR dataptr);
ULONG	GetFieldClock(ULONG *clockptr);
ULONG	FlyerQuit(int unit);
ULONG	PlayMode(UBYTE board);
ULONG	RecordMode(UBYTE board);

/****** Video Operations ******/
ULONG	FlyerPlay(struct ClipAction *clip);
ULONG	FlyerRecord(struct ClipAction *clip);
ULONG	ChangeAudio(struct ClipAction *clip);
ULONG	StartHeadList(UBYTE board);
ULONG	EndHeadList(UBYTE board,UBYTE flag);
ULONG	MakeClipHead(struct ClipAction *clip);
ULONG	VoidClipHead(struct ClipAction *clip);
ULONG	VoidCardHeads(UBYTE board);
ULONG	VoidAllHeads(void);
ULONG	AudioParams(void);
ULONG	BeginFindField(struct ClipAction *clip);
ULONG	DoFindField(struct ClipAction *clip);
ULONG	EndFindField(struct ClipAction *clip);
ULONG	FindFieldAudio(struct ClipAction *clip);
ULONG	GetSMPTE(UBYTE board,struct SMPTEinfo *info);

/****** Mode and Misc Operations ******/
ULONG	VideoParams(UBYTE board,UBYTE vidchan,UBYTE mintol,UBYTE maxtol,
	UBYTE rndfreq,UWORD vidlen,UBYTE FIRset,UBYTE special);
ULONG	StillMode(UBYTE board,UBYTE vidchan,UBYTE mode);
ULONG	SetPlayMode(UBYTE board);
ULONG	SetRecMode(UBYTE board);
ULONG	SetNoMode(UBYTE board);
ULONG	ToasterMux(UBYTE board,UBYTE input3,UBYTE input4,UBYTE preview);
ULONG	FlyerInputSel(UBYTE board,UBYTE video,UBYTE sync);
ULONG	FlyerTermination(UBYTE board,UBYTE flags);
ULONG	SetFlooby(UBYTE board,UBYTE chan,UBYTE item,ULONG value);
void	Defaults(struct ClipAction *clip);

/****** Direct Field Access ******/
ULONG	OpenReadField(struct ClipAction *action,ULONG field,UBYTE mode);
ULONG	OpenWriteField(struct ClipAction *action,ULONG field,UBYTE mode,struct VidCompInfo *);
ULONG	CloseField(struct ClipAction *action);
ULONG	FlyerReadLine(struct ClipAction *action,UBYTE *buffer);
ULONG	FlyerWriteLine(struct ClipAction *action,UBYTE *buffer);
ULONG	SetFillColor(struct ClipAction *action);
ULONG	SkipLines(struct ClipAction *action,UWORD lines);

/****** SCSI Operations ******/
ULONG	SCSIreset(UBYTE board);
ULONG	SCSIinit(struct FlyerVolume *volume);
ULONG	FindDrives(struct FlyerVolume *volume,APTR buffer);
ULONG	CopyData(struct FlyerVolume *src,struct FlyerVolume *dest,
	ULONG srcaddr,ULONG blocks,ULONG destaddr);
ULONG	ReqSense(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer);
ULONG	Inquiry(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer);
ULONG	ModeSelect(struct FlyerVolume *volume,UBYTE bufsize,APTR buffer,UBYTE PFbyte);
ULONG	ModeSense(struct FlyerVolume *volume,UBYTE bufsize,UBYTE page,APTR buffer);
ULONG	ReadSize(struct FlyerVolume *volume,ULONG *countptr,ULONG *lenptr);
ULONG	Read10(struct ClipAction *action,WORD blocks,ULONG lba,ULONG buffer);
ULONG	Write10(struct ClipAction *action,WORD blocks,ULONG buffer,ULONG lba);
ULONG	SCSIseek(struct FlyerVolume *volume,ULONG lba);
ULONG	FlyerSCSIdirect(UBYTE board,UBYTE unit,struct SCSICmd *scsiinfo,
	UBYTE structlen);

/****** FileSystem Interface ******/
ULONG	FlyerDriveCheck(struct FlyerVolume *vol);
ULONG	FlyerDriveInfo(struct FlyerVolume *vol,struct FlyerVolInfo *volume);
ULONG	FlyerLocate(struct ClipAction *clip);
ULONG	FlyerFileInfo(struct FlyerVolume *volume,struct ClipInfo *clipinfo);
ULONG	FlyerFreeGrip(struct FlyerVolume *volume,ULONG grip);
ULONG	FlyerCopyGrip(struct FlyerVolume *volume,ULONG grip,ULONG *newgrip);
ULONG	FlyerCmpGrips(struct FlyerVolume *volume,ULONG grip1,ULONG grip2);
ULONG	FlyerParent(struct FlyerVolume *volume,ULONG grip,ULONG *newgrip,ULONG *blockptr);
ULONG	FlyerExamine(struct FlyerVolume *volume,ULONG grip,struct ClipInfo *clipinfo);
ULONG	FlyerDirList(struct FlyerVolume *volume,ULONG grip,struct ClipInfo *clipinfo,
	UBYTE firstflag,UBYTE fsonlyflag);
ULONG	FlyerFileOpen(struct ClipAction *clip);
ULONG	FlyerFileClose(struct FlyerVolume *volume,ULONG fileid);
ULONG	FlyerFileSeek(struct FlyerVolume *volume,ULONG fileid,LONG pos_ext, LONG pos,UBYTE mode,
	struct DLONG	*newpos,struct DLONG *oldpos);
ULONG	FlyerFileRead(struct FlyerVolume *volume,ULONG fileid,ULONG size,UBYTE *buffer,
	ULONG *actual);
ULONG	FlyerFileWrite(struct FlyerVolume *volume,ULONG fileid,ULONG size,UBYTE *buffer,
	ULONG *actual);
ULONG	FlyerCreateDir(struct ClipAction *clip);
ULONG	FlyerDelete(struct ClipAction *clip);
ULONG	FlyerRename(struct ClipAction *old,ULONG newgrip,char *newname);
ULONG	FlyerRenameDisk(struct FlyerVolume *volume,char *newname);
ULONG	FlyerFormat(struct FlyerVolume *volume,char *name,struct DateStamp *date,
	ULONG blocks,UBYTE flags);
ULONG	FlyerDeFrag(struct FlyerVolume *volume);
ULONG	FlyerSetBits(struct FlyerVolume *volume,ULONG grip,ULONG bits);
ULONG	FlyerSetDate(struct FlyerVolume *volume,ULONG grip,
	ULONG days,ULONG mins,ULONG ticks);
ULONG	FlyerSetComment(struct FlyerVolume *volume,ULONG grip,char *comment);
ULONG	FlyerWriteProt(struct FlyerVolume *volume,UBYTE value,UBYTE setflag,
	UBYTE *checkval);
ULONG	FlyerChangeMode(struct FlyerVolume *volume,ULONG grip,UBYTE access);
ULONG	MakeFlyerFile(struct FlyerVolume *volume,ULONG size,ULONG *startptr);
ULONG	GetClipInfo(struct FlyerVolume *volume,struct ClipInfo *clipinfo);
ULONG	FlyerCopyClip(struct FlyerVolume *srcvolume,struct FlyerVolume *destvolume);

/****** Flyer Testing ******/
ULONG	CPUwrite(UBYTE board,ULONG addr,UWORD data);
ULONG	CPUread(UBYTE board,ULONG addr,UWORD *data);
ULONG	CPUDMA(UBYTE board,ULONG cpuptr,ULONG dmaptr,UWORD length,UBYTE readflag);
ULONG	DebugMode(int unit,ULONG flags);
ULONG	ReadTest(struct FlyerVolume *volume,ULONG blocks,ULONG repeat,ULONG lba,
	UBYTE dblflag);
ULONG	WriteTest(struct FlyerVolume *volume,ULONG blocks,ULONG repeat,ULONG lba,
	UBYTE dblflag);

/****** Misc stuff ******/
ULONG	SetFlyerTime(struct DateStamp *datestamp);
ULONG	FlyerStripAudio(struct FlyerVolume *srcvolume,struct FlyerVolume *destvolume);
ULONG	FlyerWriteCalib(UBYTE board,UWORD item,WORD value,UBYTE saveflag);
ULONG	FlyerReadCalib(UBYTE board,UWORD item,WORD *valueptr);
ULONG	WriteEEreg(UBYTE board,UBYTE addr,UWORD data);
ULONG	ReadEEreg(UBYTE board,UBYTE addr,UWORD *dataptr);
ULONG	ResetFlyer(UBYTE board,ULONG flags);
ULONG	SetClockGen(UBYTE board,UBYTE clock,ULONG speed);
ULONG	TeachFPGA(UBYTE chipnum,ULONG length,APTR data);
ULONG	FlyerRunning(UBYTE board);
ULONG	FlyerLoadVideo(UBYTE board,APTR data,ULONG size);
ULONG	SetSerDevice(UBYTE board,UBYTE port,UBYTE type,UBYTE device);
ULONG	FlyerSelfTest(UBYTE board,UBYTE test,ULONG arg1,ULONG arg2,ULONG *result);
ULONG	VideoCompressModes(UBYTE board,UBYTE bestmode,UBYTE worstmode,
	UBYTE strategy);
ULONG	FIRquery(UBYTE board,UBYTE coefset,UBYTE prepost,UWORD *scale,UWORD *coefdata);
ULONG	GetClrSeqError(UBYTE board,UBYTE flag,UBYTE *doneptr,ULONG *userIDptr,ULONG *moreinfoptr);
APTR	LockFlyVolList(void);
ULONG	UnLockFlyVolList(APTR list);

/****** New for 4.0 ******/
ULONG	TBCcontrol(UBYTE board,struct TBCctrl *ptr,UBYTE oper);
ULONG	PauseAction(struct ClipAction *action,UBYTE pauseflag);
ULONG	StartClipCutList(struct ClipAction *clip,UBYTE flags);
ULONG	AddClipCut(struct ClipAction *subclip);
ULONG	EndClipCutList(UBYTE doit);
ULONG	EasyOpenWriteField(struct ClipAction *action,ULONG field,UBYTE mode,
	UBYTE quality);
ULONG	FlyerAudioCtrl(UBYTE board,struct FlyAudCtrl *ptr,UBYTE oper);
ULONG	AppendFields(struct ClipAction *action);

/****** New for 4.05 ******/
ULONG	NewSequence(UBYTE board);
ULONG	AddSeqClip(struct ClipAction *clip);
ULONG	EndSequence(UBYTE board,UBYTE doit);
ULONG	PlaySequence(UBYTE board,ULONG basetime);
ULONG	FlyerOptions(UBYTE board,UBYTE setflag,ULONG *options);
ULONG	LocateField(struct ClipAction *clip);
ULONG	CacheTest(UBYTE board);

/****** New for 4.1 ******/
ULONG	FlyerCopyClipNew(struct ClipAction *srcaction,struct FlyerVolume *destvolume);
ULONG	EndSequenceNew(struct ClipAction *action,UBYTE doit);
ULONG	FlyerDeFragNew(struct ClipAction *action);
ULONG	GetFrameHeader(struct ClipAction *action,APTR buffer);
ULONG	PutFrameHeader(struct ClipAction *action,APTR buffer);
/****** New for 4.1 ******/
ULONG	AddAudEKey(struct AudioEKey *AEK);
ULONG	AddAudEnv(struct AudioEnv TheAudioEnv);
ULONG	InitFlyerForce(BPTR lock, ULONG id);
ULONG	FlyerFileExtend(struct FlyerVolume *volume,ULONG fileid,ULONG size);
