
// ToDo
// When file selected, put vid/aud flags below it???
//		Then how do we set the date,

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/gadgetclass.h>
#include <intuition/intuition.h>
#include <libraries/gadtools.h>
#include <libraries/asl.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos/dos.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/gadtools.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerprivate.h"
#include "IntFSprivate.h"

//typedef BOOL (*GadHandFunc)(struct Window *, struct Gadget *, UWORD, struct Gadget **);

#define	LIVEUPDATES		1

#define DEBUG    {}

/*** Prototypes ***/
struct Gadget *MakeMyGadgets(struct Gadget **glistptr, void *vi,
					UWORD topborder, struct Gadget *gadlist[]);
int DoRecovery(char *volname);
void HandleWinEvents(struct Window *win, struct Gadget *gadlist[]);
BOOL HandleGadgetEvent(struct Window *win, struct Gadget *gad, UWORD code,
		struct Gadget *gadlist[]);
void AddFileListNode(struct List *list, char *str,
		struct Window *win, struct Gadget **gadlist, ULONG block,
		ULONG bytes_lo, ULONG bytes_hi);
void AddVolListNode(struct List *list, char *str,
		struct Window *win, struct Gadget **gadlist, UBYTE drive);
void RemoveFileListNode(struct List *list, struct FileNode *fnode,
		struct Window *win, struct Gadget **gadlist);
ULONG GetFileList(struct Window *win, struct Gadget **gadlist);
ULONG GetVolList(struct Window *win, struct Gadget **gadlist, UBYTE baddrive);
BOOL ShowFreeSpace(struct Window *win, struct Gadget **gadlist, UBYTE drive);
char *DoCopy(struct FileNode *fnode, UBYTE drive);
ULONG SCSI_Read(ULONG lba, ULONG size);
ULONG SCSI_Write(ULONG lba, ULONG size);
BYTE FindDrive(char *volname);
void BusyPtr(struct Window *win);
void __inline NormalPtr(struct Window *win);
void StatusMessage(struct Window *win, struct Gadget *gadlist[], char *msg);
void FreeList(struct List *list, int size);
void Cleanup(void);

#define	DMABLK	VTASCDRAM	// Safe to use this unless VTASC (de)compression going on
#define	SRAMBLK	VTASCSRAM	// (ditto)

#define	ID_FORM		0x464F524D		// "FORM"
#define	ID_CLIP		0x434C4950		// "CLIP"

/*** Globals ***/
struct IntuitionBase *IntuitionBase;
struct GfxBase *GfxBase;
struct Library *GadToolsBase;
struct Library *AslBase;
struct Library *FlyerBase;
struct FlyerVolume BadFlyVol;
struct ClipAction	 BadAction;
struct FlyerVolInfo	FVIbuff;
struct TextAttr Topaz80 = { "topaz.font", 8, 0, 0, };

UBYTE	*Buffer;
BYTE	DestDrive = -1;
BYTE    SrcDrive = -1;
ULONG	Length,MegFree10,FileMeg10;
struct FileNode *fileptr;
struct List *FileList=NULL, *VolList=NULL;

char	SizeMsg[20],FreeMsg[20],LargestMsg[20];

/*** Gadget ID's ***/
enum {
	GID_FILELIST,
	GID_VOLLIST1,
	GID_VOLLIST2,
	GID_COPYFILE,
	GID_SIZE,
	GID_FREE,
	GID_LARGEST,
	GID_STATUS,
	NUMGADGETS
};

struct FileNode
{
	struct Node node;
	UBYTE 		str[34];
	ULONG			bytes_hi;
	ULONG			bytes_lo;
	ULONG			block;
};

struct VolNode
{
	struct Node node;
	UBYTE str[40];
	UBYTE drive;
};


main(int argc, char **argv)
{
int	retcode=20;

//if ((argc!=2)||(argv[1][0]=='?'))
//   {
//   printf("Usage: %ls <volumename>\n",argv[0]);
//   return(retcode);
//   }

if (!(IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 37L)))
   printf("Requires Version 37 intuition library");
else
   {
   if (!(GfxBase = (struct GfxBase *)OpenLibrary("graphics.library",37L)))
	printf("Requires Version 37 graphics library");
   else
      {
      if (!(GadToolsBase = OpenLibrary("gadtools.library",37L)))
	 printf("Requires Version 37 gadtools library");
      else
	 {
	 if (!(FlyerBase = OpenLibrary("flyer.library",0)))
	    printf("Open flyer.library failed");
	 else
	    {
	    retcode = DoRecovery(argv[1]);
	    Cleanup();
	    CloseLibrary(FlyerBase);
	    }
	 CloseLibrary(GadToolsBase);
	 }		
      CloseLibrary((struct Library *)GfxBase);
      }
   CloseLibrary((struct Library *)IntuitionBase);
   }

return(retcode);
}

struct Gadget *MakeMyGadgets(struct Gadget **glistptr, void *vi,
			UWORD topborder, struct Gadget *gadlist[])
{
struct NewGadget ng;
struct Gadget *gad;

gad = CreateContext(glistptr);

ng.ng_LeftEdge = 14;
ng.ng_TopEdge = 19 + topborder;
ng.ng_Width = 250;
ng.ng_Height = 126;
ng.ng_GadgetText = "Available Files";
ng.ng_TextAttr = &Topaz80;
ng.ng_VisualInfo = vi;
ng.ng_GadgetID = GID_FILELIST;
ng.ng_Flags = PLACETEXT_ABOVE;
fileptr = NULL;
gadlist[GID_FILELIST] = gad = CreateGadget(LISTVIEW_KIND, gad, &ng,
	GTLV_ShowSelected,	NULL,
	TAG_END);	

ng.ng_LeftEdge = 300;
ng.ng_TopEdge = 19 + topborder;
ng.ng_Width = 250;
ng.ng_Height = 36;
ng.ng_GadgetText = "Source Drives";
ng.ng_TextAttr = &Topaz80;
ng.ng_VisualInfo = vi;
ng.ng_GadgetID = GID_VOLLIST1;
ng.ng_Flags = PLACETEXT_ABOVE;
gadlist[GID_VOLLIST1] = gad = CreateGadget(LISTVIEW_KIND, gad, &ng,
	GTLV_ShowSelected,	NULL,
	TAG_END);	

ng.ng_LeftEdge = 300;
ng.ng_TopEdge = 70 + topborder;
ng.ng_Width = 250;
ng.ng_Height = 36;
ng.ng_GadgetText = "Destination Drives";
ng.ng_TextAttr = &Topaz80;
ng.ng_VisualInfo = vi;
ng.ng_GadgetID = GID_VOLLIST2;
ng.ng_Flags = PLACETEXT_ABOVE;
gadlist[GID_VOLLIST2] = gad = CreateGadget(LISTVIEW_KIND, gad, &ng,
	GTLV_ShowSelected,	NULL,
	TAG_END);	

ng.ng_LeftEdge = 350;
ng.ng_TopEdge = 145 + topborder;
ng.ng_Width = 140;
ng.ng_Height = 16;
ng.ng_GadgetText = "Copy File";
ng.ng_GadgetID = GID_COPYFILE;
ng.ng_Flags = PLACETEXT_IN;
gadlist[GID_COPYFILE] = gad = CreateGadget(BUTTON_KIND, gad, &ng, 
	TAG_END);

ng.ng_LeftEdge = 73;
ng.ng_TopEdge = 148 + topborder;
ng.ng_Width = 100;
ng.ng_Height = 13;
ng.ng_GadgetText = "Size";
ng.ng_GadgetID = GID_SIZE;
ng.ng_Flags = PLACETEXT_LEFT;
gadlist[GID_SIZE] = gad = CreateGadget(TEXT_KIND, gad, &ng, 
	GTTX_Text,		"",
	GTTX_Border,	TRUE,
	TAG_END);

ng.ng_LeftEdge = 370;
ng.ng_TopEdge = 126 + topborder;
ng.ng_Width = 100;
ng.ng_Height = 13;
ng.ng_GadgetText = "Free";
ng.ng_GadgetID = GID_FREE;
ng.ng_Flags = PLACETEXT_LEFT;
gadlist[GID_FREE] = gad = CreateGadget(TEXT_KIND, gad, &ng, 
	GTTX_Text,		"",
	GTTX_Border,	TRUE,
	TAG_END);

ng.ng_LeftEdge = 370;
ng.ng_TopEdge = 110 + topborder;
ng.ng_Width = 100;
ng.ng_Height = 13;
ng.ng_GadgetText = "Largest";
ng.ng_GadgetID = GID_LARGEST;
ng.ng_Flags = PLACETEXT_LEFT;
gadlist[GID_LARGEST] = gad = CreateGadget(TEXT_KIND, gad, &ng, 
	GTTX_Text,		"",
	GTTX_Border,	TRUE,
	TAG_END);

ng.ng_LeftEdge = 73;
ng.ng_TopEdge = 165 + topborder;
ng.ng_Width = 483;
ng.ng_Height = 13;
ng.ng_GadgetText = "Status:";
ng.ng_GadgetID = GID_STATUS;
ng.ng_Flags = PLACETEXT_LEFT;
gadlist[GID_STATUS] = gad = CreateGadget(TEXT_KIND, gad, &ng, 
	GTTX_Text,		"",
	GTTX_Border,	TRUE,
	TAG_END);

return(gad);
}

int getdrivenum(char *volname)
{
int	drive,len;
BOOL	specvol=FALSE;
char	c,n;

printf("this is the volumename  %s \n",volname);

len = strlen(volname);

if (volname[len-1] == ':')
   {
   specvol = TRUE;
   volname[len-1] = 0;			//Remove ':'
   len--;
   }

if (specvol || (!isdigit(volname[0])))
   {
   drive = FindDrive(volname);		// Lookup as if volume name

   printf("This is the drive number %d \n",drive);

   // If cannot find volume name, try to interpret as a device name
   if (drive<0)
      {
      if (len>=3)
	 {
	 c = toupper(volname[1]);
	 n = volname[2];

	 if ((toupper(volname[0])=='F')
	     && ((c>='A')&&(c<='C'))
	     && ((n>='0')&&(n<='6')))
	    {
	    drive = (c-'A')*8 + (n-'0');		// Compute drive # from device name
	    }
	 }
      }

   if (drive<0)
      {
      printf("Can't find volume %ls\n",volname);
      return(20);
      }
   }
else
   stcd_i(volname,&drive);

return(drive);
}

int DoRecovery(char *volname)
{
int	drive;
UWORD					 topborder;
struct TextFont	*font;
struct Screen		*scr;
struct Window		*win;
struct Gadget		*glist, *gadlist[NUMGADGETS];
void 					*vi;

drive = getdrivenum(volname);

printf("This is the drive %d \n",drive);

BadFlyVol.Board = 0;					// Setup for accesses to drive to recover
BadFlyVol.SCSIdrive = drive;
BadAction.Volume = &BadFlyVol;
BadAction.ReturnTime = RT_STOPPED;

if (!(font = OpenFont(&Topaz80)))
   printf("Failed to Open Topaz 80");
else
   {
   if (!(scr = LockPubScreen(NULL)))
      printf("Could not lock public screen");
   else
      {
      if (vi = GetVisualInfo(scr, TAG_END))
	 {
	 topborder = scr->WBorTop + (scr->Font->ta_YSize + 1);
	 if (MakeMyGadgets(&glist, vi, topborder, gadlist))
	    {
	    if (!(win = OpenWindowTags(NULL,
	       	WA_Title, "Flyer Undelete 1.00, Icecat Software",
		WA_Gadgets,			glist,
		WA_Left,				35,
		WA_Top,				13,
		WA_Width,			570,
		WA_Height,			200,
		WA_DragBar,			TRUE,
		WA_DepthGadget,	TRUE,
		WA_Activate,		TRUE,
		WA_CloseGadget,	TRUE,
		WA_SimpleRefresh,	TRUE,
		WA_IDCMP,			IDCMP_CLOSEWINDOW |
		IDCMP_REFRESHWINDOW |
		LISTVIEWIDCMP,
		WA_PubScreen,		scr,
	   	TAG_END)))
	       printf("OpenWindow() Failed");
	    else
	       {
	       GT_RefreshWindow(win, NULL);
	       GetVolList(win, gadlist, drive);
	       StatusMessage(win, gadlist, "Scanning for files...");
	       BusyPtr(win);
	       if (GetFileList(win, gadlist) == FERR_OKAY)
	          StatusMessage(win, gadlist, " ");
	       NormalPtr(win);
	       HandleWinEvents(win, gadlist);
	       CloseWindow(win);
	       }
	    }
	 FreeGadgets(glist);
	 FreeVisualInfo(vi);
	 }
      UnlockPubScreen(NULL, scr);
      }
   CloseFont(font);
   }
return(0);
}

void HandleWinEvents(struct Window *win, struct Gadget *gadlist[])
{
struct IntuiMessage *imsg;
ULONG IMclass;
UWORD IMcode;
struct Gadget *gad;
BOOL going = TRUE;

while (going)
   {
   Wait (1<<win->UserPort->mp_SigBit);
   while ((going) && (imsg = GT_GetIMsg(win->UserPort)))
      {
      gad = (struct Gadget *)imsg->IAddress;

      IMclass = imsg->Class;
      IMcode = imsg->Code;

      GT_ReplyIMsg(imsg);

      switch(IMclass)
	 {
	 case IDCMP_GADGETDOWN:
	 case IDCMP_GADGETUP:
	 case IDCMP_MOUSEMOVE:
	    going = HandleGadgetEvent(win, gad, IMcode, gadlist);
	    break;
	 case IDCMP_CLOSEWINDOW:
	    going = FALSE;
	    break;
	 case IDCMP_REFRESHWINDOW:
	    GT_BeginRefresh(win);
	    GT_EndRefresh(win, TRUE);
	    break;
	 }
      } 
   }
}

BOOL HandleGadgetEvent(struct Window *win, struct Gadget *gad, UWORD code,
								struct Gadget *gadlist[])
{
char	*msg;
struct FileNode *fnode;
struct VolNode *vnode;
BOOL going = TRUE;
UWORD	index;

switch(gad->GadgetID)
   {
   case GID_FILELIST:
      fileptr = NULL;
      index = 0;
      for ( fnode=(struct FileNode *)FileList->lh_Head;
	    fnode->node.ln_Succ;
	    fnode=(struct FileNode *)fnode->node.ln_Succ,index++)
	 {
	 if (index == code)
	    {
	    fileptr = fnode;
	    FileMeg10 = fnode->bytes_hi*655*65 + fnode->bytes_lo/100000;
	    sprintf(SizeMsg,"%ld.%ld MB",FileMeg10/10,FileMeg10%10);
	    GT_SetGadgetAttrs(gadlist[GID_SIZE], win, NULL,GTTX_Text,SizeMsg,TAG_END);
  	    StatusMessage(win, gadlist, " ");
	    }
	 }
      break;

   case GID_VOLLIST1:
      SrcDrive = -1;  //Indicates no drive selected
      index = 0;

      for ( vnode=(struct VolNode *)VolList->lh_Head;
	    vnode->node.ln_Succ;
	    vnode=(struct VolNode *)vnode->node.ln_Succ,index++)
	 {
	 if (code == index)
	    {
            printf("Widget starts %d \n",vnode->drive);
BadFlyVol.Board = 0;					// Setup for accesses to drive to recover
BadFlyVol.SCSIdrive = vnode->drive;
BadAction.Volume = &BadFlyVol;
BadAction.ReturnTime = RT_STOPPED;
	    GetVolList(win, gadlist, vnode->drive);
	    StatusMessage(win, gadlist, "Scanning for files...");
	       BusyPtr(win);
	       if (GetFileList(win, gadlist) == FERR_OKAY)
	          StatusMessage(win, gadlist, " ");
	       NormalPtr(win);
	       HandleWinEvents(win, gadlist);
            
	    }
	 }
      break;

   case GID_VOLLIST2:
      DestDrive = -1;  //Indicates no drive selected
      index = 0;
      for ( vnode=(struct VolNode *)VolList->lh_Head;
	    vnode->node.ln_Succ;
	    vnode=(struct VolNode *)vnode->node.ln_Succ,index++)
	 {
	 if (code == index)
	    {
	    if (ShowFreeSpace(win, gadlist, vnode->drive))
	       {
	       StatusMessage(win, gadlist, " ");
	       DestDrive = vnode->drive;
	       }
	    else
	       {
	       StatusMessage(win, gadlist, "Drive not formatted");
	       DestDrive = -1;
	       }
	    }
	 }
      break;
   
   case GID_COPYFILE:
      if (fileptr)
	 {
	 if (DestDrive != -1)
	    {
	    if (FileMeg10 > MegFree10)
	       StatusMessage(win, gadlist, "Will not fit on this drive");
	    else
	       {
	       StatusMessage(win, gadlist, "Copying...");
	       BusyPtr(win);
               /*** Do the copy! ***/
	       msg = DoCopy(fileptr,DestDrive);			// Try to copy it
  	       NormalPtr(win);

	       if (msg)
		  StatusMessage(win, gadlist, msg);
	       else
		  {
		  StatusMessage(win, gadlist, "Copy complete");
		  RemoveFileListNode(FileList, fileptr, win, gadlist);
		  fileptr = NULL;
 		  GT_SetGadgetAttrs(gadlist[GID_SIZE], win, NULL,
		  	GTTX_Text,	" ",
			TAG_END);
		  }
               ShowFreeSpace(win, gadlist, DestDrive);		// Update size now
	       }
	    }
	 else
	    StatusMessage(win, gadlist, "No destination drive selected");
	 }
      else
	 StatusMessage(win, gadlist, "No file selected");
      break;
      }

return(going);
}

void AddFileListNode(struct List *list, char *str,
		struct Window *win, struct Gadget **gadlist, ULONG block,
		ULONG bytes_lo, ULONG bytes_hi)
{
struct FileNode *Fnode,*prevnode,*thisnode;

if (Fnode = AllocMem(sizeof(struct FileNode), MEMF_CLEAR))
   {
   strcpy(Fnode->str, str);
   Fnode->node.ln_Name = Fnode->str;
   Fnode->node.ln_Pri = 0;
   Fnode->node.ln_Type = 100;
   Fnode->block = block;
   Fnode->bytes_lo = bytes_lo;
   Fnode->bytes_hi = bytes_hi;

   // Determine where to add new node
   thisnode = (struct FileNode *)list->lh_Head;		// Get first node in list
   prevnode = NULL;
   while (thisnode->node.ln_Succ)
      {
      if (stricmp(str,thisnode->str) < 0)
	 break;
      prevnode = thisnode;
      thisnode = (struct FileNode *)thisnode->node.ln_Succ;
      }

#if LIVEUPDATES
		GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL, 
			GTLV_Labels,	~0,
			TAG_END);
#endif

   // Insert just after "prevnode" (or head if NULL)
   Insert(list, (struct Node *)Fnode, (struct Node *)prevnode);

#if LIVEUPDATES
		GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL,
			GTLV_Labels, 	list,
			GTLV_Selected,	~0,
			TAG_END);		
#endif

//		AddTail(list, (struct Node *)Fnode);			// List was empty
   }
}

void AddVolListNode(struct List *list, char *str,
	struct Window *win, struct Gadget **gadlist, UBYTE drive)
{
struct VolNode *Vnode;

if (Vnode = AllocMem(sizeof(struct VolNode), MEMF_CLEAR))
   {
   sprintf(Vnode->str, "(F%c%c) %ls",'A'+(drive/8),'0'+(drive&7),str);

   Vnode->node.ln_Name = Vnode->str;
   Vnode->node.ln_Pri = 0;
   Vnode->node.ln_Type = 100;
   Vnode->drive = drive;

   AddTail(list, (struct Node *)Vnode);
   }
}


void RemoveFileListNode(struct List *list, struct FileNode *fnode,
	struct Window *win, struct Gadget **gadlist)
{

GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL, 
		GTLV_Labels,	~0,
		TAG_END);

Remove((struct Node *)fnode);					// Remove from list
FreeMem(fnode, sizeof(struct FileNode));

GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL,
		GTLV_Labels,	list,
		GTLV_Selected,	~0,
		TAG_END);		
}

ULONG GetFileList(struct Window *win, struct Gadget **gadlist)
{
ULONG	lba,res=FERR_OKAY,startlba,stoplba,misses;
UBYTE	*buffer,count;
struct ROOTHDR		*root;
struct DIRHDR		*dir;
struct FILEHDR		*file;
struct FlyerLib	        *FlyLib;
struct FlyerUnit	*FlyUnit;
char scratch[64];
ULONG	blo,bhi,start;

GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL, 
		GTLV_Labels,	~0,
		TAG_END);

FlyLib = (struct FlyerLib *)FlyerBase;		// Get ptr to private Flyer base
FlyUnit = &FlyLib->fl_Units[0];				// Get ptr to unit structure for board 0

if (FlyUnit->fu_SRAMbase == NULL)
   return(FERR_NOCARD);

buffer = (UBYTE *)FlyUnit->fu_SRAMbase + (512 * SRAMBLK);

FreeList(FileList, sizeof(struct FileNode));

if (FileList = AllocMem(sizeof(struct List), MEMF_CLEAR))
   {
   NewList(FileList);

   res = SCSI_Read(0,1);		// Read ROOT info in
   if (res)
      {
      StatusMessage(win, gadlist, "No drive present");
      return(res);
      }

   root = (struct ROOTHDR *)buffer;

   if (root->id == ID_ROOT)
      {
      startlba = root->hdrsarea;			// Scan just between these points
      stoplba = root->dataarea;
      }
   else
      {
      startlba = 1;		// Start here
      stoplba = 0;		// Go forever, until we hit some data

      StatusMessage(win, gadlist, "Root is corrupt - Groping for files...");
      }

   count = 0;

   for (lba=startlba; (lba<stoplba) || (stoplba==0); lba++)
      {
      res = SCSI_Read(lba,1);		// Read header candidate in
      if (res)
	 {
	 StatusMessage(win, gadlist, "Read error");
	 break;
	 }

      file = (struct FILEHDR *)buffer;
      if (file->id == ID_FILE)
	 {

         blo = file->bytes;
	 bhi = file->bytes_hi;
	 start = file->start;
	 sprintf(scratch,"%ls",file->name);

	 res = SCSI_Read(start,1);		// Read first block of file in
	 if (res)
	    {
	    StatusMessage(win, gadlist, "Read error");
	    break;
	    }
	 if ((file->id == ID_CLIP) || (file->id == ID_FORM))
	    {
	    AddFileListNode(FileList, scratch, win, gadlist, start, blo,bhi);
	    count++;
	    }

	 misses = 0;
	 }
      else if (file->id == ID_DIR)
	 {
	 dir = (struct DIRHDR *)buffer;

	 misses = 0;
	 }
      else 
         if (file->id == 0x00000000)
	    {
	    // Do nothing -- is a blank header most likely
            if (file->name[0] != 0)
               {
               blo = file->bytes;
	       bhi = file->bytes_hi;
	       start = file->start;
	       sprintf(scratch,"%ls",file->name);
	       res = SCSI_Read(start,1);		// Read first block of file in
 	       AddFileListNode(FileList, scratch, win, gadlist, start, blo, bhi);
	       count++;
               }
	    }
	 else
	    {
	    if ((stoplba==0) && (count>0))	// Doing hard search and already found some?
	       {
	       if ((++misses) > 10)			// After 10, I'm sure we've entered data area
		  {
		  res = FERR_OKAY;
		  break;
		  }
	       }
	    }
	 }

      if (count==0)
	 {
	 sprintf(scratch, "--none--");
	 AddFileListNode(FileList, scratch, win, gadlist,0,0,0);
	 }

      GT_SetGadgetAttrs(gadlist[GID_FILELIST], win, NULL,
	   		GTLV_Labels, 	FileList,
			GTLV_Selected,	~0,
			TAG_END);		
      }
return(res);
}

ULONG GetVolList(struct Window *win, struct Gadget **gadlist, UBYTE baddrive)
{
struct FlyerVolNode	*vptr;
struct MinList			*vollist;
char scratch[64];

GT_SetGadgetAttrs(gadlist[GID_VOLLIST1], win, NULL, 
		GTLV_Labels,		~0,
		TAG_END);

GT_SetGadgetAttrs(gadlist[GID_VOLLIST2], win, NULL, 
		GTLV_Labels,		~0,
		TAG_END);

FreeList(VolList, sizeof(struct VolNode));

if (VolList = AllocMem(sizeof(struct List), MEMF_CLEAR))
   {
   NewList(VolList);

   vollist = (struct MinList *)LockFlyVolList();
   if (vollist)
      {
      vptr = (struct FlyerVolNode *)vollist->mlh_Head;

      while (vptr->Node.ln_Succ)
	 {
         sprintf(scratch,"%ls",vptr->Name);
	 AddVolListNode(VolList, scratch, win, gadlist, vptr->SCSIdrive);
	 vptr = (struct FlyerVolNode *)vptr->Node.ln_Succ;
	 }
      UnLockFlyVolList(vollist);
      }

   GT_SetGadgetAttrs(gadlist[GID_VOLLIST1], win, NULL,
			GTLV_Labels, 	VolList,
			GTLV_Selected,	~0,
			TAG_END);		

   GT_SetGadgetAttrs(gadlist[GID_VOLLIST2], win, NULL,
			GTLV_Labels, 	VolList,
			GTLV_Selected,	~0,
			TAG_END);		

   }
return(FERR_OKAY);
}

BOOL ShowFreeSpace(struct Window *win, struct Gadget **gadlist, UBYTE drive)
{
ULONG	res,meg10;
struct FlyerVolInfo	FVI;
struct FlyerVolume PrivFlyVol;

PrivFlyVol.Board = 0;
PrivFlyVol.SCSIdrive = drive;
PrivFlyVol.Flags = FVF_USENUMS;

FVI.len = sizeof(struct FlyerVolInfo);
res = FlyerDriveInfo(&PrivFlyVol,&FVI);
if (res)
   return(FALSE);

if (FVI.Ident != 0x524f4f54)
   return(FALSE);

meg10 = FVI.BlksFree / (100000 / FVI.BlkSize);
sprintf(FreeMsg,"%ld.%ld MB",meg10/10,meg10%10);

GT_SetGadgetAttrs(gadlist[GID_FREE], win, NULL,
		GTTX_Text,	FreeMsg,
		TAG_END);

MegFree10 = meg10 = FVI.Largest / (100000 / FVI.BlkSize);
sprintf(LargestMsg,"%ld.%ld MB",meg10/10,meg10%10);

GT_SetGadgetAttrs(gadlist[GID_LARGEST], win, NULL,
		GTTX_Text,	LargestMsg,
		TAG_END);

return(TRUE);
}

char *DoCopy(struct FileNode *fnode, UBYTE drive)
{
ULONG	res,start,blks,copyblks;
struct FlyerVolume DestVol;

DestVol.Board = 0;
DestVol.Flags = FVF_USENUMS;
DestVol.Path = fnode->str;
DestVol.SCSIdrive = drive;

	// Calculate number of blocks to copy
blks = (fnode->bytes_hi << (32-9)) + (fnode->bytes_lo >> 9);

if ((fnode->bytes_lo & 0x1FF)==0)		// Block-aligned length?
   copyblks = blks;
else
   {
   copyblks = blks+1;
   blks = 0;
   start = fnode->bytes_lo;		// Pass byte size
   }

res = MakeFlyerFile(&DestVol,blks,&start);			// Add file to dest drive, reserve space
if (res == FERR_EXISTS)
   return("A file of this name already exists on this drive");
else 
   if (res)
      return("Failed to add file to drive");

res = CopyData(&BadFlyVol,&DestVol,fnode->block,copyblks,start);
if (res)
   return("Copy failed");

return(NULL);
}

ULONG SCSI_Read(ULONG lba, ULONG size)
{
ULONG	 res;

res = Read10(&BadAction,size,lba,DMABLK);
if (res)
   printf("Read10 Error %ld - %ls\n",res,Error2String(res));
else
   {
   res = CPUDMA(0,SRAMBLK,DMABLK,size,0);		/* Move from DRAM to SRAM */
   if (res)
      printf("CPUDMA Error %ld - %ls\n",res,Error2String(res));
   }
return(res);
}

BYTE FindDrive(char *volname)
{
struct FlyerVolNode	*vptr;
struct MinList			*vollist;
BYTE	drive = -1;

vollist = (struct MinList *)LockFlyVolList();
if (vollist)
   {
   vptr = (struct FlyerVolNode *)vollist->mlh_Head;

   while (vptr->Node.ln_Succ)
      {
      if (stricmp(volname,vptr->Name)==0)
	 {
	 drive = (BYTE)vptr->SCSIdrive;
	 break;
	 }
			
      vptr = (struct FlyerVolNode *)vptr->Node.ln_Succ;
      }
   UnLockFlyVolList(vollist);
   }

return(drive);
}

void BusyPtr(struct Window *win)
{
static USHORT __chip WaitPointer[36] =
   {
   0x0000, 0x0000, 0x0400, 0x07C0, 0x0000, 0x07C0, 0x0100, 0x0380, 0x0000,
   0x07E0, 0x07C0, 0x1FF8, 0x1FF0, 0x3FEC, 0x3FF8, 0x7FDE, 0x3FF8, 0x7FBE,
   0x7FFC, 0xFF7F, 0x7EFC, 0xFFFF, 0x7FFC, 0xFFFF, 0x3FF8, 0x7FFE, 0x3FF8,
   0x7FFE, 0x1FF0, 0x3FFC, 0x07C0, 0x1FF8, 0x0000, 0x07E0, 0x0000, 0x0000
   };

SetPointer(win,WaitPointer,16L,16L,-6L,0L);
}

void __inline NormalPtr(struct Window *win)
{
ClearPointer(win);
}

void StatusMessage(struct Window *win, struct Gadget *gadlist[], char *msg)
{
GT_SetGadgetAttrs(gadlist[GID_STATUS], win, NULL,
		GTTX_Text,	msg,
		TAG_END);
}

void FreeList(struct List *list, int size)
{
struct Node *worknode, *nextnode;

if (list)
   {
   worknode = list->lh_Head;
   while (nextnode = worknode->ln_Succ)
      {
      FreeMem(worknode, size);
      worknode = nextnode;
      }
   FreeMem(list, sizeof(struct List));
   }
}

void Cleanup(void) 
{
if (FileList)
   FreeList(FileList,sizeof(struct FileNode));
if (VolList)
   FreeList(VolList,sizeof(struct VolNode));
}
