
/* SimpleRexx.h */

#ifndef SIMPLEREXX_H_INCLUDED
#define SIMPLEREXX_H_INCLUDED

#include <stdarg.h>

#ifndef AREXXSYSLIB_H_INCLUDED
#include "arexxsyslib.h"
#endif


/* ARexxContext is private to SimpleRexx.c... other files only need
 * to see if as a void pointer
 */

#ifndef AREXXCONTEXT

   #define AREXXCONTEXT
   typedef void *ARexxContext;

#endif

/* prototypes for the SimpleRexx functions.  See the simplrexx.c
 * files for documentation */

extern ARexxContext   ARexxInit( char *name, char *extension, BOOL mult);
extern void           ARexxFree( ARexxContext context);

extern char          *ARexxName( ARexxContext context);
extern ULONG          ARexxSignal( ARexxContext context );
extern struct Library *ARexxBase( ARexxContext context);
extern BOOL           IsARexxReply( struct RexxMsg *msg);

extern struct RexxMsg *GetARexxMsg( ARexxContext context);
extern BOOL           FreeARexxMsg( ARexxContext context,
                                    struct RexxMsg *msg );
extern BOOL           ReplyARexxMsg( ARexxContext context,
                                    struct RexxMsg *msg,
                                    LONG return_code,
                                    char *result_string,
                                    LONG error_code);
extern struct RexxMsg *SendARexxMsg( ARexxContext context, char *port,
                                    char *string, ULONG flags);
extern struct RexxMsg *CallARexxFunc( ARexxContext context, char *port,
                                     char *function, ULONG flags,
                                     int num_args, ...);
extern BOOL           AddFuncHost( ARexxContext context, LONG priority);
extern BOOL           RemFuncHost( ARexxContext context);
extern BOOL           SetARexxLastError(ARexxContext context,
                                 struct RexxMsg *msg, char *error);

#endif /* SIMPLEREXX_H_INCLUDED */
