 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

ULONG Reprocess(char *, ULONG);

ULONG WriteClipStart(ULONG frames, ULONG Length, char *);

struct Library *FlyerBase;

main(int argc,char **argv)
{
ULONG	res; 
UWORD  j;
ULONG Total = 0;

struct FlyerVolume FlyVol;

struct ClipInfo	Buffer;
struct ClipAction act;
struct FrameHeader FrameBuffer;

printf("FileCheck Version 1.00 \n");
printf("Copyright Prowave 1997\n");

if ((argc != 2) || (argv[1][0] == '?'))
   {
   printf("Incorrect arguements \n");
   printf("%s filename \n",argv[0]);
   exit(0);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   exit(0);
   }

Buffer.len = sizeof(struct ClipInfo);

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];
res = GetClipInfo(&FlyVol,&Buffer);
if (res)
   {
   printf("Error %ld - %ls\n",res,Error2String(res));
   }

for (j=0;j<Buffer.Fields/4;j++)
   {
   act.VidStartField = j*4;
   act.Volume = &FlyVol;

   res = GetFrameHeader(&act,&FrameBuffer);
   if (res)
      {
      printf("Error %ld - %ls\n",res,Error2String(res));
      }
   Total = Total + FrameBuffer.Length;

   }

Total = Total + 1;

printf("This is Added Total %ld \n",Total);

printf("This is file Total %ld \n",Buffer.Length/512);

CloseLibrary(FlyerBase);

exit(1);
}

