

/* arexxsyslib.h */

#ifndef  AREXXSYSLIB_H_INCLUDED
#define  AREXXSYSLIB_H_INCLUDED

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/lists.h>
#include <exec/ports.h>
#include <exec/memory.h>
#endif


#ifndef REXX_STORAGE_H
#include <rexx/storage.h>
#include <rexx/rxslib.h>
#include <rexx/errors.h>
#endif


extern struct Library  *RexxSysBase;

/* prototypes for public functions */

extern char                *CreateArgstring( char *str, ULONG length);
extern void                 DeleteArgstring( char *argstr );
extern ULONG                LengthArgstring( char *argstr );
extern struct RexxMsg      *CreateRexxMsg( struct MsgPort *replyport,
                                           char *extension, char *hostaddress);
extern void                 DeleteRexxMsg( struct RexxMsg *msg);
extern void                 ClearRexxMsg ( struct RexxMsg *msg, ULONG numargs);
extern long                 FillRexxMsg (struct RexxMsg *msg, ULONG numargs,
                                          ULONG mask);
extern long                 IsRexxMsg( struct RexxMsg *msg);


/* defines the pragmas */

#if defined(LATTICE)

   #pragma  libcall RexxSysBase  ClearRexxMsg 9c 0802
   #pragma  libcall RexxSysBase  CreateArgstring 7e 0802
   #pragma  libcall RexxSysBase  CreateRexxMsg 90 09803
   #pragma  libcall RexxSysBase  DeleteArgstring 84 801
   #pragma  libcall RexxSysBase  DeleteRexxMsg  96 801
   #pragma  libcall RexxSysBase  FillRexxMsg  a2 10803
   #pragma  libcall RexxSysBase  IsRexxMsg  a8  801
   #pragma  libcall RexxSysBase  LengthArgstring 8a 801

#endif