/* This is the Mixer Script */
/* 9/29/96 */
/* 2/13/96 Added Support for Updated MixAudio 1.01 */

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)


if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"
OPEN(myfile,"ram:Prowave.txt",'Write')     
mycount. = 0


/* --------- Mix entire project or highlighted clips --------- */

test='00'
MixAll=0
call req_open(,'Mix Audio --  1997 ProWave')
do while (test=='00')|(test=='11')
   test=req_buttons('Mix Audio...  pick one','00','Mix entire project','Mix highlighted clips')
   if test='CANCEL' then call quit()
end
if test=='10' then MixAll=1
call req_close()



/* ----------------------- Enter file name ----------------- */

rx startfilereq("Select audio drive below, and enter Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end

call req_close()

if (patht='') then do
   call req_tell('MixAudio cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('MixAudio cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

if exists(filename1) then do
   test=req_tell('That file already exists','  Select Continue to overwrite file')
   if test=0 then call quit()
   end



/* ---------- if not entire project then scan for highlighted clips -------- */

count = croutonsinproject()

testing = 0
cur_spot = 1
selected = 0
hiselected=0
if mixall=0 then do
   call req_open('MixAudio','Scanning for highlighted clips...')

   do while cur_spot < count+1
      row = trunc(cur_spot/8)
      col = cur_spot - (row*8)
      row = row + 1
      clipok=0
      if crnumtype(cur_spot-1)=' AUD' then clipok=1
      else if crnumtype(cur_spot-1)='CLIP' then do
         if crnumgettag(cur_spot-1,audioon)>3 then clipok=1
      end
      if croutonselected(row,col) = 1 then do
         hiselected=hiselected+1
         if clipok=1 then do
            mycount.testing = cur_spot-1
            testing = testing + 1
            selected = selected + 1
         end
      end
      SAY row||" "||col||" "||selected
     cur_spot = cur_spot + 1
   end
   call req_close()
end


   
/* ----------- check with user.... ready to proceed -------- */

if (hiselected>0)&(selected>0) then test= req_tell('MixAudio','         Ready to mix' selected' clip(s)','           into one audio clip')
else if (hiselected=0) then test= req_tell('Mix Audio','  Ready to mix all audio in project','           into one audio clip')
else do
   call req_tell('Cancelled','   Highlighted clips have no audio')
   test=0
end
if test=0 then quit()



/* -------- if entire project, then scan for clips with sound ------ */

if hiselected<1 then do
   testing = 0
   cur_spot = 0
   selected = 0
   call req_open('MixAudio','Scanning for clips...')

   do while cur_spot < count
      clipok=0
      if crnumtype(cur_spot)=' AUD' then clipok=1
      else if crnumtype(cur_spot)='CLIP' then do
         if crnumgettag(cur_spot,audioon)>3 then clipok=1
      end
      if clipok=1 then do
         mycount.testing = cur_spot
         testing = testing + 1
         selected = selected + 1
      end
      SAY row||" "||col||" "||selected
      cur_spot = cur_spot + 1
   end

   call req_close()
end


if selected<1 then do
   call req_tell('Mix Audio cancelled','      Project does not have audio')
   call quit()
end


/* --------------- start writing text file ---------------- */

WRITELN(myfile,filename1||",");
lowstart=0
firstpass=0
WRITELN(myfile,selected);


/* --------------- get minimum start time of all selections ---------- */

next = 0
do while next < selected
  if exists("ENV:OZ-PanicStop") then quit2()
  call croutonpick(mycount.next)
  if firstpass=0 then do
     firstpass=1
     lowstart=croutontime()
     end
  else if lowstart>croutontime() then lowstart=croutontime()
  next = next + 1
end

next = 0
do while next < selected
  call croutonpick(mycount.next)
  WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2||","||(croutontime()-lowstart)%2||","||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||","||croutongettag(AudioAttack)||","||croutongettag(AudioDecay));
  next = next + 1
end


CLOSE(myfile)



/* ----- if file exists, then delete NOW, just before proceeding ------ */

if exists(filename1) then address command 'delete 'filename1' QUIET'
if exists(filename1||'.i') then address command 'delete 'filename1'.i QUIET'


/* ------------- perform mix audio --------------- */

call req_open("Mixing Audio... Please Wait.", "Left-Amiga Delete to abort Operation")
address command  "prowave:mixaudio >CON: ram:prowave.txt" 

call req_close()
call set_view(4)
call set_view(2)
call req_error(' Mix Audio -- all done')
call remlib('PROJECT_REXX_PORT')
exit

/* ----- use this to cancel with Flyer screen refresh ------- */ 
quit2:
call req_close()
call set_view(4)
call set_view(2)
call req_error(' Mix Audio -- cancelled')
call remlib('PROJECT_REXX_PORT')
exit

/* ----- use this to cancel normally ------- */ 
quit:
call req_close()
call req_error(' Mix Audio -- cancelled')
call remlib('PROJECT_REXX_PORT')

